// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: dafny1\Celebrity.dfy /print:\Users\philipp\Desktop\boogie\boogie-k-induction-benchmarks\benchmarks\Celebrity.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class._default: ClassName;

const unique xxxxxxxxxfile: $token;

axiom $file_name_is(0, xxxxxxxxxfile);

const unique #tok$0^3.8: $token;

procedure CheckWellformed$$_default.Pick(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, S#0: Set BoxType) returns (t#1: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^3.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.this: $token;

const unique #tok$0^3.16: $token;

const unique #loc.S#0: $token;

const unique #tok$0^3.36: $token;

const unique #loc.t#1: $token;

implementation CheckWellformed$$_default.Pick(this: ref, S#0: Set BoxType) returns (t#1: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^3.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^3.16, cev_parameter, #loc.S#0, S#0);
    call CevVarIntro(#tok$0^3.36, cev_local, #loc.t#1, t#1);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume !Set#Equal(S#0, Set#Empty(): Set BoxType);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc t#1;
    assume S#0[t#1];
}



procedure _default.Pick(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, S#0: Set BoxType) returns (t#1: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires !Set#Equal(S#0, Set#Empty(): Set BoxType);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^3.8;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures S#0[t#1];
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



function _default.Knows($heap: HeapType, a#2: BoxType, b#3: BoxType) : bool;

// frame axiom for _default.Knows
axiom (forall $h0: HeapType, $h1: HeapType, a#2: BoxType, b#3: BoxType :: { $HeapSucc($h0, $h1), _default.Knows($h1, a#2, b#3) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: false ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> _default.Knows($h0, a#2, b#3) == _default.Knows($h1, a#2, b#3));

procedure CheckWellformed$$_default.Knows(a#2: BoxType, b#3: BoxType);
  free requires 0 == $ModuleContextHeight && 0 == $FunctionContextHeight;



implementation CheckWellformed$$_default.Knows(a#2: BoxType, b#3: BoxType)
{
    assume a#2 != b#3;
}



function _default.IsCelebrity($heap: HeapType, c#4: BoxType, people#5: Set BoxType) : bool;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (1 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, c#4: BoxType, people#5: Set BoxType :: { _default.IsCelebrity($Heap, c#4, people#5) } $IsGoodHeap($Heap) ==> _default.IsCelebrity($Heap, c#4, people#5) == (people#5[c#4] && (forall p#6: BoxType :: people#5[p#6] && p#6 != c#4 ==> _default.Knows($Heap, p#6, c#4) && !_default.Knows($Heap, c#4, p#6))));

// frame axiom for _default.IsCelebrity
axiom (forall $h0: HeapType, $h1: HeapType, c#4: BoxType, people#5: Set BoxType :: { $HeapSucc($h0, $h1), _default.IsCelebrity($h1, c#4, people#5) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: false ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> _default.IsCelebrity($h0, c#4, people#5) == _default.IsCelebrity($h1, c#4, people#5));

procedure CheckWellformed$$_default.IsCelebrity(c#4: BoxType, people#5: Set BoxType);
  free requires 0 == $ModuleContextHeight && 1 == $FunctionContextHeight;



implementation CheckWellformed$$_default.IsCelebrity(c#4: BoxType, people#5: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var p#31: BoxType;
  var a#32: BoxType;
  var b#33: BoxType;
  var a#34: BoxType;
  var b#35: BoxType;

    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    if (people#5[c#4])
    {
        if (people#5[p#31])
        {
        }

        if (people#5[p#31] && p#31 != c#4)
        {
            a#32 := p#31;
            b#33 := c#4;
            assert a#32 != b#33;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            if (_default.Knows($Heap, p#31, c#4))
            {
                a#34 := c#4;
                b#35 := p#31;
                assert a#34 != b#35;
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            }
        }
    }
}



const unique #tok$0^16.8: $token;

procedure CheckWellformed$$_default.FindCelebrity0(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, people#7: Set BoxType, c#8: BoxType) returns (r#9: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^16.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^16.31: $token;

const unique #loc.people#7: $token;

const unique #tok$0^16.58: $token;

const unique #loc.c#8: $token;

const unique #tok$0^16.78: $token;

const unique #loc.r#9: $token;

implementation CheckWellformed$$_default.FindCelebrity0(this: ref, people#7: Set BoxType, c#8: BoxType) returns (r#9: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var c#36: BoxType;
  var c#37: BoxType;
  var people#38: Set BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^16.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^16.31, cev_parameter, #loc.people#7, people#7);
    call CevVarIntro(#tok$0^16.58, cev_parameter, #loc.c#8, c#8);
    call CevVarIntro(#tok$0^16.78, cev_local, #loc.r#9, r#9);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    c#37 := c#36;
    people#38 := people#7;
    assume (exists c#10: BoxType :: _default.IsCelebrity($Heap, c#10, people#7));
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc r#9;
    assume r#9 == c#8;
}



procedure _default.FindCelebrity0(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, people#7: Set BoxType, c#8: BoxType) returns (r#9: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires (exists c#10: BoxType :: _default.IsCelebrity($Heap, c#10, people#7));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^16.8;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures r#9 == c#8;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.cc#11: $token;

const unique #tok$0^20.7: $token;

const unique #tok$0^21.5: $token;

implementation _default.FindCelebrity0(this: ref, people#7: Set BoxType, c#8: BoxType) returns (r#9: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var cc#11: BoxType where #cev_var_update(#cev_pc, cev_local, #loc.cc#11, cc#11);

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^16.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^16.31, cev_parameter, #loc.people#7, people#7);
    call CevVarIntro(#tok$0^16.58, cev_parameter, #loc.c#8, c#8);
    call CevVarIntro(#tok$0^16.78, cev_local, #loc.r#9, r#9);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- dafny1\Celebrity.dfy(20,7)
    call CevVarIntro(#tok$0^20.7, cev_local, #loc.cc#11, cc#11);
    // ----- assume statement ----- dafny1\Celebrity.dfy(20,11)
    assert {:subsumption 0} true;
    assume cc#11 == c#8;
    // ----- assignment statement ----- dafny1\Celebrity.dfy(21,5)
    assert true;
    assert true;
    r#9 := cc#11;
    assume {:captureState "dafny1\Celebrity.dfy(21,5)"} true;
    call CevUpdate(#tok$0^21.5, #loc.r#9, r#9);
}



const unique #tok$0^24.8: $token;

procedure CheckWellformed$$_default.FindCelebrity1(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, people#12: Set BoxType, c#13: BoxType) returns (r#14: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^24.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^24.31: $token;

const unique #loc.people#12: $token;

const unique #tok$0^24.58: $token;

const unique #loc.c#13: $token;

const unique #tok$0^24.78: $token;

const unique #loc.r#14: $token;

implementation CheckWellformed$$_default.FindCelebrity1(this: ref, people#12: Set BoxType, c#13: BoxType) returns (r#14: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var c#39: BoxType;
  var people#40: Set BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^24.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^24.31, cev_parameter, #loc.people#12, people#12);
    call CevVarIntro(#tok$0^24.58, cev_parameter, #loc.c#13, c#13);
    call CevVarIntro(#tok$0^24.78, cev_local, #loc.r#14, r#14);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    c#39 := c#13;
    people#40 := people#12;
    assume _default.IsCelebrity($Heap, c#13, people#12);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc r#14;
    assume r#14 == c#13;
}



procedure _default.FindCelebrity1(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, people#12: Set BoxType, c#13: BoxType) returns (r#14: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires _default.IsCelebrity($Heap, c#13, people#12);
  free requires _default.IsCelebrity($Heap, c#13, people#12) ==> people#12[c#13] && (forall p#6: BoxType :: people#12[p#6] && p#6 != c#13 ==> _default.Knows($Heap, p#6, c#13) && !_default.Knows($Heap, c#13, p#6));
  requires (_default.IsCelebrity($Heap, c#13, people#12) ==> people#12[c#13] && (forall p#6: BoxType :: people#12[p#6] && p#6 != c#13 ==> _default.Knows($Heap, p#6, c#13) && !_default.Knows($Heap, c#13, p#6))) ==> people#12[c#13];
  requires (_default.IsCelebrity($Heap, c#13, people#12) ==> people#12[c#13] && (forall p#6: BoxType :: people#12[p#6] && p#6 != c#13 ==> _default.Knows($Heap, p#6, c#13) && !_default.Knows($Heap, c#13, p#6))) ==> (forall p#6: BoxType :: people#12[p#6] && p#6 != c#13 ==> _default.Knows($Heap, p#6, c#13) && !_default.Knows($Heap, c#13, p#6));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^24.8;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures r#14 == c#13;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.Q#15: $token;

const unique #tok$0^28.7: $token;

const unique #loc.x#16: $token;

const unique #tok$0^29.8: $token;

const unique #loc.x: $token;

const unique #tok$0^29.3: $token;

const unique #tok$0^30.3: $token;

const unique #loc.y#17: $token;

const unique #tok$0^36.10: $token;

const unique #loc.y: $token;

const unique #tok$0^36.5: $token;

const unique #tok$0^37.5: $token;

const unique #tok$0^37.22: $token;

const unique #tok$0^38.9: $token;

const unique #tok$0^39.12: $token;

const unique #tok$0^40.9: $token;

const unique #tok$0^42.5: $token;

const unique #tok$0^44.5: $token;

implementation _default.FindCelebrity1(this: ref, people#12: Set BoxType, c#13: BoxType) returns (r#14: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var Q#15: Set BoxType where #cev_var_update(#cev_pc, cev_local, #loc.Q#15, Q#15);
  var x#16: BoxType where #cev_var_update(#cev_pc, cev_local, #loc.x#16, x#16);
  var S#41: Set BoxType;
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: Set BoxType;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: Set BoxType;
  var y#17: BoxType where #cev_var_update(#cev_pc, cev_local, #loc.y#17, y#17);
  var S#42: Set BoxType;
  var S#43: Set BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^24.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^24.31, cev_parameter, #loc.people#12, people#12);
    call CevVarIntro(#tok$0^24.58, cev_parameter, #loc.c#13, c#13);
    call CevVarIntro(#tok$0^24.78, cev_local, #loc.r#14, r#14);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- dafny1\Celebrity.dfy(28,7)
    assert true;
    assert true;
    Q#15 := people#12;
    assume {:captureState "dafny1\Celebrity.dfy(28,7)"} true;
    call CevVarIntro(#tok$0^28.7, cev_local, #loc.Q#15, Q#15);
    // ----- var-declaration statement ----- dafny1\Celebrity.dfy(29,8)
    call CevVarIntro(#tok$0^29.8, cev_local, #loc.x#16, x#16);
    // ----- call statement ----- dafny1\Celebrity.dfy(29,3)
    assert true;
    S#41 := Q#15;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call x#16 := _default.Pick(this, S#41);
    call CevUpdateHere(#loc.x, x#16);
    call CevStep(#tok$0^29.3);
    assume {:captureState "dafny1\Celebrity.dfy(29,3)"} true;
    // ----- while statement ----- dafny1\Celebrity.dfy(30,3)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := Q#15;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^30.3);
    while (true)
      free invariant _default.IsCelebrity($Heap, c#13, Q#15) ==> Q#15[c#13] && (forall p#6: BoxType :: Q#15[p#6] && p#6 != c#13 ==> _default.Knows($Heap, p#6, c#13) && !_default.Knows($Heap, c#13, p#6));
      invariant $w0 && (_default.IsCelebrity($Heap, c#13, Q#15) ==> Q#15[c#13] && (forall p#6: BoxType :: Q#15[p#6] && p#6 != c#13 ==> _default.Knows($Heap, p#6, c#13) && !_default.Knows($Heap, c#13, p#6))) ==> Q#15[c#13];
      invariant $w0 && (_default.IsCelebrity($Heap, c#13, Q#15) ==> Q#15[c#13] && (forall p#6: BoxType :: Q#15[p#6] && p#6 != c#13 ==> _default.Knows($Heap, p#6, c#13) && !_default.Knows($Heap, c#13, p#6))) ==> (forall p#6: BoxType :: Q#15[p#6] && p#6 != c#13 ==> _default.Knows($Heap, p#6, c#13) && !_default.Knows($Heap, c#13, p#6));
      free invariant $w0 ==> _default.IsCelebrity($Heap, c#13, Q#15);
      invariant $w0 ==> Q#15[x#16];
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant Set#Subset(Q#15, $decr0$init$0) && (Set#Equal(Q#15, $decr0$init$0) ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^30.3;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.r#14, r#14);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} true;
            assume _default.IsCelebrity($Heap, c#13, Q#15);
            assert {:subsumption 0} true;
            assume Q#15[x#16];
            assert true;
            assume false;
        }

        assert true;
        if (Set#Equal(Q#15, Set#UnionOne(Set#Empty(): Set BoxType, x#16)))
        {
            break;
        }

        call CevStepEvent(#tok$0^30.3, loop_entered);
        assume {:captureState "dafny1\Celebrity.dfy(30,3): loop entered"} true;
        $decr0$0 := Q#15;
        // ----- var-declaration statement ----- dafny1\Celebrity.dfy(36,10)
        call CevVarIntro(#tok$0^36.10, cev_local, #loc.y#17, y#17);
        // ----- call statement ----- dafny1\Celebrity.dfy(36,5)
        assert true;
        S#42 := Set#Difference(Q#15, Set#UnionOne(Set#Empty(): Set BoxType, x#16));
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        call y#17 := _default.Pick(this, S#42);
        call CevUpdateHere(#loc.y, y#17);
        call CevStep(#tok$0^36.5);
        assume {:captureState "dafny1\Celebrity.dfy(36,5)"} true;
        // ----- if statement ----- dafny1\Celebrity.dfy(37,5)
        call CevEvent(#tok$0^37.5, conditional_moment);
        assert x#16 != y#17;
        if (_default.Knows($Heap, x#16, y#17))
        {
            call CevEvent(#tok$0^37.22, took_then_branch);
            // ----- assignment statement ----- dafny1\Celebrity.dfy(38,9)
            assert true;
            assert true;
            Q#15 := Set#Difference(Q#15, Set#UnionOne(Set#Empty(): Set BoxType, x#16));
            assume {:captureState "dafny1\Celebrity.dfy(38,9)"} true;
            call CevUpdate(#tok$0^38.9, #loc.Q#15, Q#15);
        }
        else
        {
            call CevEvent(#tok$0^39.12, took_else_branch);
            // ----- assignment statement ----- dafny1\Celebrity.dfy(40,9)
            assert true;
            assert true;
            Q#15 := Set#Difference(Q#15, Set#UnionOne(Set#Empty(): Set BoxType, y#17));
            assume {:captureState "dafny1\Celebrity.dfy(40,9)"} true;
            call CevUpdate(#tok$0^40.9, #loc.Q#15, Q#15);
            // ----- assert statement ----- dafny1\Celebrity.dfy(40,22)
            assert {:subsumption 0} true;
            assert Q#15[x#16];
        }

        // ----- call statement ----- dafny1\Celebrity.dfy(42,5)
        assert true;
        S#43 := Q#15;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        call x#16 := _default.Pick(this, S#43);
        call CevUpdateHere(#loc.x, x#16);
        call CevStep(#tok$0^42.5);
        assume {:captureState "dafny1\Celebrity.dfy(42,5)"} true;
        assert Set#Subset(Q#15, $decr0$0) && !Set#Subset($decr0$0, Q#15);
    }

    call CevStepEvent(#tok$0^30.3, loop_exited);
    assume {:captureState "dafny1\Celebrity.dfy(30,3): loop exit"} true;
    // ----- assignment statement ----- dafny1\Celebrity.dfy(44,5)
    assert true;
    assert true;
    r#14 := x#16;
    assume {:captureState "dafny1\Celebrity.dfy(44,5)"} true;
    call CevUpdate(#tok$0^44.5, #loc.r#14, r#14);
}



const unique #tok$0^47.8: $token;

procedure CheckWellformed$$_default.FindCelebrity2(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, people#18: Set BoxType, c#19: BoxType) returns (r#20: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^47.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^47.31: $token;

const unique #loc.people#18: $token;

const unique #tok$0^47.58: $token;

const unique #loc.c#19: $token;

const unique #tok$0^47.78: $token;

const unique #loc.r#20: $token;

implementation CheckWellformed$$_default.FindCelebrity2(this: ref, people#18: Set BoxType, c#19: BoxType) returns (r#20: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var c#44: BoxType;
  var people#45: Set BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^47.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^47.31, cev_parameter, #loc.people#18, people#18);
    call CevVarIntro(#tok$0^47.58, cev_parameter, #loc.c#19, c#19);
    call CevVarIntro(#tok$0^47.78, cev_local, #loc.r#20, r#20);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    c#44 := c#19;
    people#45 := people#18;
    assume _default.IsCelebrity($Heap, c#19, people#18);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc r#20;
    assume r#20 == c#19;
}



procedure _default.FindCelebrity2(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, people#18: Set BoxType, c#19: BoxType) returns (r#20: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires _default.IsCelebrity($Heap, c#19, people#18);
  free requires _default.IsCelebrity($Heap, c#19, people#18) ==> people#18[c#19] && (forall p#6: BoxType :: people#18[p#6] && p#6 != c#19 ==> _default.Knows($Heap, p#6, c#19) && !_default.Knows($Heap, c#19, p#6));
  requires (_default.IsCelebrity($Heap, c#19, people#18) ==> people#18[c#19] && (forall p#6: BoxType :: people#18[p#6] && p#6 != c#19 ==> _default.Knows($Heap, p#6, c#19) && !_default.Knows($Heap, c#19, p#6))) ==> people#18[c#19];
  requires (_default.IsCelebrity($Heap, c#19, people#18) ==> people#18[c#19] && (forall p#6: BoxType :: people#18[p#6] && p#6 != c#19 ==> _default.Knows($Heap, p#6, c#19) && !_default.Knows($Heap, c#19, p#6))) ==> (forall p#6: BoxType :: people#18[p#6] && p#6 != c#19 ==> _default.Knows($Heap, p#6, c#19) && !_default.Knows($Heap, c#19, p#6));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^47.8;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures r#20 == c#19;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.b#21: $token;

const unique #tok$0^51.8: $token;

const unique #loc.b: $token;

const unique #tok$0^51.3: $token;

const unique #loc.R#22: $token;

const unique #tok$0^52.7: $token;

const unique #tok$0^53.3: $token;

const unique #loc.x#23: $token;

const unique #tok$0^61.10: $token;

const unique #tok$0^61.5: $token;

const unique #tok$0^62.5: $token;

const unique #tok$0^62.22: $token;

const unique #tok$0^63.9: $token;

const unique #tok$0^64.12: $token;

const unique #tok$0^65.9: $token;

const unique #tok$0^66.9: $token;

const unique #tok$0^69.5: $token;

implementation _default.FindCelebrity2(this: ref, people#18: Set BoxType, c#19: BoxType) returns (r#20: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b#21: BoxType where #cev_var_update(#cev_pc, cev_local, #loc.b#21, b#21);
  var S#46: Set BoxType;
  var R#22: Set BoxType where #cev_var_update(#cev_pc, cev_local, #loc.R#22, R#22);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: Set BoxType;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: Set BoxType;
  var x#23: BoxType where #cev_var_update(#cev_pc, cev_local, #loc.x#23, x#23);
  var S#47: Set BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^47.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^47.31, cev_parameter, #loc.people#18, people#18);
    call CevVarIntro(#tok$0^47.58, cev_parameter, #loc.c#19, c#19);
    call CevVarIntro(#tok$0^47.78, cev_local, #loc.r#20, r#20);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- dafny1\Celebrity.dfy(51,8)
    call CevVarIntro(#tok$0^51.8, cev_local, #loc.b#21, b#21);
    // ----- call statement ----- dafny1\Celebrity.dfy(51,3)
    assert true;
    S#46 := people#18;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call b#21 := _default.Pick(this, S#46);
    call CevUpdateHere(#loc.b, b#21);
    call CevStep(#tok$0^51.3);
    assume {:captureState "dafny1\Celebrity.dfy(51,3)"} true;
    // ----- var-declaration statement ----- dafny1\Celebrity.dfy(52,7)
    assert true;
    assert true;
    R#22 := Set#Difference(people#18, Set#UnionOne(Set#Empty(): Set BoxType, b#21));
    assume {:captureState "dafny1\Celebrity.dfy(52,7)"} true;
    call CevVarIntro(#tok$0^52.7, cev_local, #loc.R#22, R#22);
    // ----- while statement ----- dafny1\Celebrity.dfy(53,3)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := R#22;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^53.3);
    while (true)
      invariant $w0 ==> Set#Subset(R#22, people#18);
      invariant $w0 ==> people#18[b#21];
      invariant $w0 ==> !R#22[b#21];
      free invariant _default.IsCelebrity($Heap, c#19, Set#Union(R#22, Set#UnionOne(Set#Empty(): Set BoxType, b#21))) ==> Set#Union(R#22, Set#UnionOne(Set#Empty(): Set BoxType, b#21))[c#19] && (forall p#6: BoxType :: Set#Union(R#22, Set#UnionOne(Set#Empty(): Set BoxType, b#21))[p#6] && p#6 != c#19 ==> _default.Knows($Heap, p#6, c#19) && !_default.Knows($Heap, c#19, p#6));
      invariant $w0 && (_default.IsCelebrity($Heap, c#19, Set#Union(R#22, Set#UnionOne(Set#Empty(): Set BoxType, b#21))) ==> Set#Union(R#22, Set#UnionOne(Set#Empty(): Set BoxType, b#21))[c#19] && (forall p#6: BoxType :: Set#Union(R#22, Set#UnionOne(Set#Empty(): Set BoxType, b#21))[p#6] && p#6 != c#19 ==> _default.Knows($Heap, p#6, c#19) && !_default.Knows($Heap, c#19, p#6))) ==> Set#Union(R#22, Set#UnionOne(Set#Empty(): Set BoxType, b#21))[c#19];
      invariant $w0 && (_default.IsCelebrity($Heap, c#19, Set#Union(R#22, Set#UnionOne(Set#Empty(): Set BoxType, b#21))) ==> Set#Union(R#22, Set#UnionOne(Set#Empty(): Set BoxType, b#21))[c#19] && (forall p#6: BoxType :: Set#Union(R#22, Set#UnionOne(Set#Empty(): Set BoxType, b#21))[p#6] && p#6 != c#19 ==> _default.Knows($Heap, p#6, c#19) && !_default.Knows($Heap, c#19, p#6))) ==> (forall p#6: BoxType :: Set#Union(R#22, Set#UnionOne(Set#Empty(): Set BoxType, b#21))[p#6] && p#6 != c#19 ==> _default.Knows($Heap, p#6, c#19) && !_default.Knows($Heap, c#19, p#6));
      free invariant $w0 ==> _default.IsCelebrity($Heap, c#19, Set#Union(R#22, Set#UnionOne(Set#Empty(): Set BoxType, b#21)));
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant Set#Subset(R#22, $decr0$init$0) && (Set#Equal(R#22, $decr0$init$0) ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^53.3;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.r#20, r#20);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} true;
            assume Set#Subset(R#22, people#18);
            assert {:subsumption 0} true;
            assume people#18[b#21];
            assert {:subsumption 0} true;
            assume !R#22[b#21];
            assert {:subsumption 0} true;
            assume _default.IsCelebrity($Heap, c#19, Set#Union(R#22, Set#UnionOne(Set#Empty(): Set BoxType, b#21)));
            assert true;
            assume false;
        }

        assert true;
        if (Set#Equal(R#22, Set#Empty(): Set BoxType))
        {
            break;
        }

        call CevStepEvent(#tok$0^53.3, loop_entered);
        assume {:captureState "dafny1\Celebrity.dfy(53,3): loop entered"} true;
        $decr0$0 := R#22;
        // ----- var-declaration statement ----- dafny1\Celebrity.dfy(61,10)
        call CevVarIntro(#tok$0^61.10, cev_local, #loc.x#23, x#23);
        // ----- call statement ----- dafny1\Celebrity.dfy(61,5)
        assert true;
        S#47 := R#22;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        call x#23 := _default.Pick(this, S#47);
        call CevUpdateHere(#loc.x, x#23);
        call CevStep(#tok$0^61.5);
        assume {:captureState "dafny1\Celebrity.dfy(61,5)"} true;
        // ----- if statement ----- dafny1\Celebrity.dfy(62,5)
        call CevEvent(#tok$0^62.5, conditional_moment);
        assert x#23 != b#21;
        if (_default.Knows($Heap, x#23, b#21))
        {
            call CevEvent(#tok$0^62.22, took_then_branch);
            // ----- assignment statement ----- dafny1\Celebrity.dfy(63,9)
            assert true;
            assert true;
            R#22 := Set#Difference(R#22, Set#UnionOne(Set#Empty(): Set BoxType, x#23));
            assume {:captureState "dafny1\Celebrity.dfy(63,9)"} true;
            call CevUpdate(#tok$0^63.9, #loc.R#22, R#22);
        }
        else
        {
            call CevEvent(#tok$0^64.12, took_else_branch);
            // ----- assignment statement ----- dafny1\Celebrity.dfy(65,9)
            assert true;
            assert true;
            b#21 := x#23;
            assume {:captureState "dafny1\Celebrity.dfy(65,9)"} true;
            call CevUpdate(#tok$0^65.9, #loc.b#21, b#21);
            // ----- assignment statement ----- dafny1\Celebrity.dfy(66,9)
            assert true;
            assert true;
            R#22 := Set#Difference(R#22, Set#UnionOne(Set#Empty(): Set BoxType, x#23));
            assume {:captureState "dafny1\Celebrity.dfy(66,9)"} true;
            call CevUpdate(#tok$0^66.9, #loc.R#22, R#22);
        }

        assert Set#Subset(R#22, $decr0$0) && !Set#Subset($decr0$0, R#22);
    }

    call CevStepEvent(#tok$0^53.3, loop_exited);
    assume {:captureState "dafny1\Celebrity.dfy(53,3): loop exit"} true;
    // ----- assignment statement ----- dafny1\Celebrity.dfy(69,5)
    assert true;
    assert true;
    r#20 := b#21;
    assume {:captureState "dafny1\Celebrity.dfy(69,5)"} true;
    call CevUpdate(#tok$0^69.5, #loc.r#20, r#20);
}



const unique #tok$0^72.8: $token;

procedure CheckWellformed$$_default.FindCelebrity3(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, n#24: int, people#25: Set BoxType, c#26: int) returns (r#27: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^72.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^72.23: $token;

const unique #loc.n#24: $token;

const unique #tok$0^72.31: $token;

const unique #loc.people#25: $token;

const unique #tok$0^72.55: $token;

const unique #loc.c#26: $token;

const unique #tok$0^72.72: $token;

const unique #loc.r#27: $token;

implementation CheckWellformed$$_default.FindCelebrity3(this: ref, n#24: int, people#25: Set BoxType, c#26: int) returns (r#27: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var p#48: int;
  var c#49: BoxType;
  var people#50: Set BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^72.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^72.23, cev_parameter, #loc.n#24, n#24);
    call CevVarIntro(#tok$0^72.31, cev_parameter, #loc.people#25, people#25);
    call CevVarIntro(#tok$0^72.55, cev_parameter, #loc.c#26, c#26);
    call CevVarIntro(#tok$0^72.72, cev_local, #loc.r#27, r#27);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume 0 < n#24;
    if (0 <= p#48)
    {
    }

    assume (forall p#28: int :: people#25[$Box(p#28)] <==> 0 <= p#28 && p#28 < n#24);
    c#49 := $Box(c#26);
    people#50 := people#25;
    assume _default.IsCelebrity($Heap, $Box(c#26), people#25);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc r#27;
    assume r#27 == c#26;
}



procedure _default.FindCelebrity3(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, n#24: int, people#25: Set BoxType, c#26: int) returns (r#27: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires 0 < n#24;
  requires (forall p#28: int :: people#25[$Box(p#28)] <==> 0 <= p#28 && p#28 < n#24);
  free requires _default.IsCelebrity($Heap, $Box(c#26), people#25);
  free requires _default.IsCelebrity($Heap, $Box(c#26), people#25) ==> people#25[$Box(c#26)] && (forall p#6: BoxType :: people#25[p#6] && p#6 != $Box(c#26) ==> _default.Knows($Heap, p#6, $Box(c#26)) && !_default.Knows($Heap, $Box(c#26), p#6));
  requires (_default.IsCelebrity($Heap, $Box(c#26), people#25) ==> people#25[$Box(c#26)] && (forall p#6: BoxType :: people#25[p#6] && p#6 != $Box(c#26) ==> _default.Knows($Heap, p#6, $Box(c#26)) && !_default.Knows($Heap, $Box(c#26), p#6))) ==> people#25[$Box(c#26)];
  requires (_default.IsCelebrity($Heap, $Box(c#26), people#25) ==> people#25[$Box(c#26)] && (forall p#6: BoxType :: people#25[p#6] && p#6 != $Box(c#26) ==> _default.Knows($Heap, p#6, $Box(c#26)) && !_default.Knows($Heap, $Box(c#26), p#6))) ==> (forall p#6: BoxType :: people#25[p#6] && p#6 != $Box(c#26) ==> _default.Knows($Heap, p#6, $Box(c#26)) && !_default.Knows($Heap, $Box(c#26), p#6));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^72.8;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures r#27 == c#26;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^78.5: $token;

const unique #loc.a#29: $token;

const unique #tok$0^79.7: $token;

const unique #loc.b#30: $token;

const unique #tok$0^80.7: $token;

const unique #tok$0^81.3: $token;

const unique #tok$0^86.5: $token;

const unique #tok$0^86.22: $token;

const unique #tok$0^87.9: $token;

const unique #tok$0^88.12: $token;

const unique #tok$0^89.9: $token;

const unique #tok$0^90.9: $token;

const unique #tok$0^93.5: $token;

implementation _default.FindCelebrity3(this: ref, n#24: int, people#25: Set BoxType, c#26: int) returns (r#27: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var a#29: int where #cev_var_update(#cev_pc, cev_local, #loc.a#29, a#29);
  var b#30: int where #cev_var_update(#cev_pc, cev_local, #loc.b#30, b#30);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^72.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^72.23, cev_parameter, #loc.n#24, n#24);
    call CevVarIntro(#tok$0^72.31, cev_parameter, #loc.people#25, people#25);
    call CevVarIntro(#tok$0^72.55, cev_parameter, #loc.c#26, c#26);
    call CevVarIntro(#tok$0^72.72, cev_local, #loc.r#27, r#27);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- assignment statement ----- dafny1\Celebrity.dfy(78,5)
    assert true;
    assert true;
    r#27 := 0;
    assume {:captureState "dafny1\Celebrity.dfy(78,5)"} true;
    call CevUpdate(#tok$0^78.5, #loc.r#27, r#27);
    // ----- var-declaration statement ----- dafny1\Celebrity.dfy(79,7)
    assert true;
    assert true;
    a#29 := 1;
    assume {:captureState "dafny1\Celebrity.dfy(79,7)"} true;
    call CevVarIntro(#tok$0^79.7, cev_local, #loc.a#29, a#29);
    // ----- var-declaration statement ----- dafny1\Celebrity.dfy(80,7)
    assert true;
    assert true;
    b#30 := 0;
    assume {:captureState "dafny1\Celebrity.dfy(80,7)"} true;
    call CevVarIntro(#tok$0^80.7, cev_local, #loc.b#30, b#30);
    // ----- while statement ----- dafny1\Celebrity.dfy(81,3)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := n#24 - a#29;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^81.3);
    while (true)
      invariant $w0 ==> a#29 <= n#24;
      invariant $w0 ==> b#30 < a#29;
      invariant $w0 ==> c#26 == b#30 || (a#29 <= c#26 && c#26 < n#24);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant n#24 - a#29 <= $decr0$init$0 && (n#24 - a#29 == $decr0$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^81.3;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.r#27, r#27);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} true;
            assume a#29 <= n#24;
            assert {:subsumption 0} true;
            assume b#30 < a#29;
            assert {:subsumption 0} c#26 != b#30 ==> a#29 <= c#26 ==> true;
            assume c#26 == b#30 || (a#29 <= c#26 && c#26 < n#24);
            assert true;
            assume false;
        }

        assert true;
        if (a#29 >= n#24)
        {
            break;
        }

        call CevStepEvent(#tok$0^81.3, loop_entered);
        assume {:captureState "dafny1\Celebrity.dfy(81,3): loop entered"} true;
        $decr0$0 := n#24 - a#29;
        // ----- if statement ----- dafny1\Celebrity.dfy(86,5)
        call CevEvent(#tok$0^86.5, conditional_moment);
        assert a#29 != b#30;
        if (_default.Knows($Heap, $Box(a#29), $Box(b#30)))
        {
            call CevEvent(#tok$0^86.22, took_then_branch);
            // ----- assignment statement ----- dafny1\Celebrity.dfy(87,9)
            assert true;
            assert true;
            a#29 := a#29 + 1;
            assume {:captureState "dafny1\Celebrity.dfy(87,9)"} true;
            call CevUpdate(#tok$0^87.9, #loc.a#29, a#29);
        }
        else
        {
            call CevEvent(#tok$0^88.12, took_else_branch);
            // ----- assignment statement ----- dafny1\Celebrity.dfy(89,9)
            assert true;
            assert true;
            b#30 := a#29;
            assume {:captureState "dafny1\Celebrity.dfy(89,9)"} true;
            call CevUpdate(#tok$0^89.9, #loc.b#30, b#30);
            // ----- assignment statement ----- dafny1\Celebrity.dfy(90,9)
            assert true;
            assert true;
            a#29 := a#29 + 1;
            assume {:captureState "dafny1\Celebrity.dfy(90,9)"} true;
            call CevUpdate(#tok$0^90.9, #loc.a#29, a#29);
        }

        assert 0 <= $decr0$0 || n#24 - a#29 == $decr0$0;
        assert n#24 - a#29 < $decr0$0;
    }

    call CevStepEvent(#tok$0^81.3, loop_exited);
    assume {:captureState "dafny1\Celebrity.dfy(81,3): loop exit"} true;
    // ----- assignment statement ----- dafny1\Celebrity.dfy(93,5)
    assert true;
    assert true;
    r#27 := b#30;
    assume {:captureState "dafny1\Celebrity.dfy(93,5)"} true;
    call CevUpdate(#tok$0^93.5, #loc.r#27, r#27);
}


