// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: Test\vacid0\Composite.dfy /print:..\boogie-k-induction-benchmarks\benchmarks\Composite.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class.Composite: ClassName;

axiom FDim(Composite.left) == 0 && DeclType(Composite.left) == class.Composite;

const unique Composite.left: Field ref;

axiom (forall $h: HeapType, $o: ref :: { read($h, $o, Composite.left) } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) ==> read($h, $o, Composite.left) == null || (read($h, read($h, $o, Composite.left), alloc) && dtype(read($h, $o, Composite.left)) == class.Composite));

axiom FDim(Composite.right) == 0 && DeclType(Composite.right) == class.Composite;

const unique Composite.right: Field ref;

axiom (forall $h: HeapType, $o: ref :: { read($h, $o, Composite.right) } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) ==> read($h, $o, Composite.right) == null || (read($h, read($h, $o, Composite.right), alloc) && dtype(read($h, $o, Composite.right)) == class.Composite));

axiom FDim(Composite.parent) == 0 && DeclType(Composite.parent) == class.Composite;

const unique Composite.parent: Field ref;

axiom (forall $h: HeapType, $o: ref :: { read($h, $o, Composite.parent) } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) ==> read($h, $o, Composite.parent) == null || (read($h, read($h, $o, Composite.parent), alloc) && dtype(read($h, $o, Composite.parent)) == class.Composite));

axiom FDim(Composite.val) == 0 && DeclType(Composite.val) == class.Composite;

const unique Composite.val: Field int;

axiom FDim(Composite.sum) == 0 && DeclType(Composite.sum) == class.Composite;

const unique Composite.sum: Field int;

function Composite.Valid($heap: HeapType, this: ref, S#0: Set BoxType) : bool;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (8 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref, S#0: Set BoxType :: { Composite.Valid($Heap, this, S#0) } $IsGoodHeap($Heap) && this != null ==> Composite.Valid($Heap, this, S#0) == (S#0[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> S#0[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this)) && (read($Heap, this, Composite.left) != null ==> S#0[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && (read($Heap, this, Composite.right) != null ==> S#0[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && read($Heap, this, Composite.sum) == read($Heap, this, Composite.val) + $ite(read($Heap, this, Composite.left) == null, 0, read($Heap, read($Heap, this, Composite.left), Composite.sum)) + $ite(read($Heap, this, Composite.right) == null, 0, read($Heap, read($Heap, this, Composite.right), Composite.sum))));

// frame axiom for Composite.Valid
axiom (forall $h0: HeapType, $h1: HeapType, this: ref, S#0: Set BoxType :: { $HeapSucc($h0, $h1), Composite.Valid($h1, this, S#0) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Composite && read($h1, this, alloc) && dtype(this) == class.Composite && (forall $t: BoxType :: { S#0[$t] } S#0[$t] ==> $Unbox($t): ref == null || (read($h0, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)) && (forall $t: BoxType :: { S#0[$t] } S#0[$t] ==> $Unbox($t): ref == null || (read($h1, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && ($o == this || $o == read($h0, this, Composite.parent) || $o == read($h0, this, Composite.left) || $o == read($h0, this, Composite.right)) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Composite.Valid($h0, this, S#0) == Composite.Valid($h1, this, S#0));

procedure CheckWellformed$$Composite.Valid(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Composite, S#0: Set BoxType where (forall $t: BoxType :: { S#0[$t] } S#0[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)));
  free requires 0 == $ModuleContextHeight && 8 == $FunctionContextHeight;



implementation CheckWellformed$$Composite.Valid(this: ref, S#0: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || $o == read($Heap, this, Composite.parent) || $o == read($Heap, this, Composite.left) || $o == read($Heap, this, Composite.right));
    if (S#0[$Box(this)])
    {
        assert $_Frame[this, Composite.parent];
        if (read($Heap, this, Composite.parent) != null)
        {
            assert $_Frame[this, Composite.parent];
            if (S#0[$Box(read($Heap, this, Composite.parent))])
            {
                assert $_Frame[this, Composite.parent];
                assert read($Heap, this, Composite.parent) != null;
                assert $_Frame[read($Heap, this, Composite.parent), Composite.left];
                if (read($Heap, read($Heap, this, Composite.parent), Composite.left) != this)
                {
                    assert $_Frame[this, Composite.parent];
                    assert read($Heap, this, Composite.parent) != null;
                    assert $_Frame[read($Heap, this, Composite.parent), Composite.right];
                }
            }
        }
    }

    if (S#0[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> S#0[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this)))
    {
        assert $_Frame[this, Composite.left];
        if (read($Heap, this, Composite.left) != null)
        {
            assert $_Frame[this, Composite.left];
            if (S#0[$Box(read($Heap, this, Composite.left))])
            {
                assert $_Frame[this, Composite.left];
                assert read($Heap, this, Composite.left) != null;
                assert $_Frame[read($Heap, this, Composite.left), Composite.parent];
            }

            if (S#0[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this)
            {
                assert $_Frame[this, Composite.left];
                assert $_Frame[this, Composite.right];
            }
        }
    }

    if (S#0[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> S#0[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this)) && (read($Heap, this, Composite.left) != null ==> S#0[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)))
    {
        assert $_Frame[this, Composite.right];
        if (read($Heap, this, Composite.right) != null)
        {
            assert $_Frame[this, Composite.right];
            if (S#0[$Box(read($Heap, this, Composite.right))])
            {
                assert $_Frame[this, Composite.right];
                assert read($Heap, this, Composite.right) != null;
                assert $_Frame[read($Heap, this, Composite.right), Composite.parent];
            }

            if (S#0[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this)
            {
                assert $_Frame[this, Composite.left];
                assert $_Frame[this, Composite.right];
            }
        }
    }

    if (S#0[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> S#0[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this)) && (read($Heap, this, Composite.left) != null ==> S#0[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && (read($Heap, this, Composite.right) != null ==> S#0[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)))
    {
        assert $_Frame[this, Composite.sum];
        assert $_Frame[this, Composite.val];
        assert $_Frame[this, Composite.left];
        if (read($Heap, this, Composite.left) == null)
        {
        }
        else
        {
            assert $_Frame[this, Composite.left];
            assert read($Heap, this, Composite.left) != null;
            assert $_Frame[read($Heap, this, Composite.left), Composite.sum];
        }

        assert $_Frame[this, Composite.right];
        if (read($Heap, this, Composite.right) == null)
        {
        }
        else
        {
            assert $_Frame[this, Composite.right];
            assert read($Heap, this, Composite.right) != null;
            assert $_Frame[read($Heap, this, Composite.right), Composite.sum];
        }
    }
}



function Composite.Acyclic($heap: HeapType, this: ref, S#1: Set BoxType) : bool;

function Composite.Acyclic#limited($heap: HeapType, this: ref, S#1: Set BoxType) : bool;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (0 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref, S#1: Set BoxType :: { Composite.Acyclic($Heap, this, S#1) } $IsGoodHeap($Heap) && this != null ==> Composite.Acyclic($Heap, this, S#1) == (S#1[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic#limited($Heap, read($Heap, this, Composite.parent), Set#Difference(S#1, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))));

axiom (forall $Heap: HeapType, this: ref, S#1: Set BoxType :: { Composite.Acyclic($Heap, this, S#1) } Composite.Acyclic($Heap, this, S#1) == Composite.Acyclic#limited($Heap, this, S#1));

// frame axiom for Composite.Acyclic
axiom (forall $h0: HeapType, $h1: HeapType, this: ref, S#1: Set BoxType :: { $HeapSucc($h0, $h1), Composite.Acyclic($h1, this, S#1) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Composite && read($h1, this, alloc) && dtype(this) == class.Composite && (forall $t: BoxType :: { S#1[$t] } S#1[$t] ==> $Unbox($t): ref == null || (read($h0, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)) && (forall $t: BoxType :: { S#1[$t] } S#1[$t] ==> $Unbox($t): ref == null || (read($h1, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && S#1[$Box($o)] ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Composite.Acyclic($h0, this, S#1) == Composite.Acyclic($h1, this, S#1));

axiom (forall $h0: HeapType, $h1: HeapType, this: ref, S#1: Set BoxType :: { $HeapSucc($h0, $h1), Composite.Acyclic#limited($h1, this, S#1) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Composite && read($h1, this, alloc) && dtype(this) == class.Composite && (forall $t: BoxType :: { S#1[$t] } S#1[$t] ==> $Unbox($t): ref == null || (read($h0, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)) && (forall $t: BoxType :: { S#1[$t] } S#1[$t] ==> $Unbox($t): ref == null || (read($h1, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && S#1[$Box($o)] ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Composite.Acyclic#limited($h0, this, S#1) == Composite.Acyclic#limited($h1, this, S#1));

procedure CheckWellformed$$Composite.Acyclic(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Composite, S#1: Set BoxType where (forall $t: BoxType :: { S#1[$t] } S#1[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)));
  free requires 0 == $ModuleContextHeight && 0 == $FunctionContextHeight;



implementation CheckWellformed$$Composite.Acyclic(this: ref, S#1: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var S#44: Set BoxType;

    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> S#1[$Box($o)]);
    if (S#1[$Box(this)])
    {
        assert $_Frame[this, Composite.parent];
        if (read($Heap, this, Composite.parent) != null)
        {
            assert $_Frame[this, Composite.parent];
            assert read($Heap, this, Composite.parent) != null;
            S#44 := Set#Difference(S#1, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)));
            assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && S#44[$Box($o)] ==> $_Frame[$o, $f]);
            assert Set#Subset(S#44, S#1) && !Set#Subset(S#1, S#44);
        }
    }
}



const unique XXXXXXXXXfile: $token;

axiom $file_name_is(0, XXXXXXXXXfile);

const unique #tok$0^25.10: $token;

procedure CheckWellformed$$Composite.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Composite, x#2: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^25.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.this: $token;

const unique #tok$0^25.15: $token;

const unique #loc.x#2: $token;

implementation CheckWellformed$$Composite.Init(this: ref, x#2: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var S#45: Set BoxType;
  var S#46: Set BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^25.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^25.15, cev_parameter, #loc.x#2, x#2);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    S#45 := Set#UnionOne(Set#Empty(): Set BoxType, $Box(this));
    if (Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))))
    {
        S#46 := Set#UnionOne(Set#Empty(): Set BoxType, $Box(this));
    }

    if (Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) && Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))))
    {
    }

    if (Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) && Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) && read($Heap, this, Composite.val) == x#2)
    {
    }

    assume Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) && Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) && read($Heap, this, Composite.val) == x#2 && read($Heap, this, Composite.parent) == null;
}



procedure Composite.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Composite, x#2: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^25.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) && Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) && read($Heap, this, Composite.val) == x#2 && read($Heap, this, Composite.parent) == null;
  free ensures Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this)) && (read($Heap, this, Composite.left) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && (read($Heap, this, Composite.right) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && read($Heap, this, Composite.sum) == read($Heap, this, Composite.val) + $ite(read($Heap, this, Composite.left) == null, 0, read($Heap, read($Heap, this, Composite.left), Composite.sum)) + $ite(read($Heap, this, Composite.right) == null, 0, read($Heap, read($Heap, this, Composite.right), Composite.sum));
  free ensures Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))));
  ensures (Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this)) && (read($Heap, this, Composite.left) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && (read($Heap, this, Composite.right) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && read($Heap, this, Composite.sum) == read($Heap, this, Composite.val) + $ite(read($Heap, this, Composite.left) == null, 0, read($Heap, read($Heap, this, Composite.left), Composite.sum)) + $ite(read($Heap, this, Composite.right) == null, 0, read($Heap, read($Heap, this, Composite.right), Composite.sum))) && (Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)];
  ensures (Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this)) && (read($Heap, this, Composite.left) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && (read($Heap, this, Composite.right) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && read($Heap, this, Composite.sum) == read($Heap, this, Composite.val) + $ite(read($Heap, this, Composite.left) == null, 0, read($Heap, read($Heap, this, Composite.left), Composite.sum)) + $ite(read($Heap, this, Composite.right) == null, 0, read($Heap, read($Heap, this, Composite.right), Composite.sum))) && (Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> read($Heap, this, Composite.parent) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.parent))];
  ensures (Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this)) && (read($Heap, this, Composite.left) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && (read($Heap, this, Composite.right) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && read($Heap, this, Composite.sum) == read($Heap, this, Composite.val) + $ite(read($Heap, this, Composite.left) == null, 0, read($Heap, read($Heap, this, Composite.left), Composite.sum)) + $ite(read($Heap, this, Composite.right) == null, 0, read($Heap, read($Heap, this, Composite.right), Composite.sum))) && (Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> read($Heap, this, Composite.parent) != null ==> read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this;
  ensures (Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this)) && (read($Heap, this, Composite.left) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && (read($Heap, this, Composite.right) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && read($Heap, this, Composite.sum) == read($Heap, this, Composite.val) + $ite(read($Heap, this, Composite.left) == null, 0, read($Heap, read($Heap, this, Composite.left), Composite.sum)) + $ite(read($Heap, this, Composite.right) == null, 0, read($Heap, read($Heap, this, Composite.right), Composite.sum))) && (Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> read($Heap, this, Composite.left) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.left))];
  ensures (Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this)) && (read($Heap, this, Composite.left) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && (read($Heap, this, Composite.right) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && read($Heap, this, Composite.sum) == read($Heap, this, Composite.val) + $ite(read($Heap, this, Composite.left) == null, 0, read($Heap, read($Heap, this, Composite.left), Composite.sum)) + $ite(read($Heap, this, Composite.right) == null, 0, read($Heap, read($Heap, this, Composite.right), Composite.sum))) && (Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> read($Heap, this, Composite.left) != null ==> read($Heap, read($Heap, this, Composite.left), Composite.parent) == this;
  ensures (Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this)) && (read($Heap, this, Composite.left) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && (read($Heap, this, Composite.right) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && read($Heap, this, Composite.sum) == read($Heap, this, Composite.val) + $ite(read($Heap, this, Composite.left) == null, 0, read($Heap, read($Heap, this, Composite.left), Composite.sum)) + $ite(read($Heap, this, Composite.right) == null, 0, read($Heap, read($Heap, this, Composite.right), Composite.sum))) && (Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> read($Heap, this, Composite.left) != null ==> read($Heap, this, Composite.left) != read($Heap, this, Composite.right);
  ensures (Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this)) && (read($Heap, this, Composite.left) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && (read($Heap, this, Composite.right) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && read($Heap, this, Composite.sum) == read($Heap, this, Composite.val) + $ite(read($Heap, this, Composite.left) == null, 0, read($Heap, read($Heap, this, Composite.left), Composite.sum)) + $ite(read($Heap, this, Composite.right) == null, 0, read($Heap, read($Heap, this, Composite.right), Composite.sum))) && (Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> read($Heap, this, Composite.right) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.right))];
  ensures (Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this)) && (read($Heap, this, Composite.left) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && (read($Heap, this, Composite.right) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && read($Heap, this, Composite.sum) == read($Heap, this, Composite.val) + $ite(read($Heap, this, Composite.left) == null, 0, read($Heap, read($Heap, this, Composite.left), Composite.sum)) + $ite(read($Heap, this, Composite.right) == null, 0, read($Heap, read($Heap, this, Composite.right), Composite.sum))) && (Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> read($Heap, this, Composite.right) != null ==> read($Heap, read($Heap, this, Composite.right), Composite.parent) == this;
  ensures (Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this)) && (read($Heap, this, Composite.left) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && (read($Heap, this, Composite.right) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && read($Heap, this, Composite.sum) == read($Heap, this, Composite.val) + $ite(read($Heap, this, Composite.left) == null, 0, read($Heap, read($Heap, this, Composite.left), Composite.sum)) + $ite(read($Heap, this, Composite.right) == null, 0, read($Heap, read($Heap, this, Composite.right), Composite.sum))) && (Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> read($Heap, this, Composite.right) != null ==> read($Heap, this, Composite.left) != read($Heap, this, Composite.right);
  ensures (Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this)) && (read($Heap, this, Composite.left) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && (read($Heap, this, Composite.right) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && read($Heap, this, Composite.sum) == read($Heap, this, Composite.val) + $ite(read($Heap, this, Composite.left) == null, 0, read($Heap, read($Heap, this, Composite.left), Composite.sum)) + $ite(read($Heap, this, Composite.right) == null, 0, read($Heap, read($Heap, this, Composite.right), Composite.sum))) && (Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> read($Heap, this, Composite.sum) == read($Heap, this, Composite.val) + $ite(read($Heap, this, Composite.left) == null, 0, read($Heap, read($Heap, this, Composite.left), Composite.sum)) + $ite(read($Heap, this, Composite.right) == null, 0, read($Heap, read($Heap, this, Composite.right), Composite.sum));
  ensures (Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this)) && (read($Heap, this, Composite.left) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && (read($Heap, this, Composite.right) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && read($Heap, this, Composite.sum) == read($Heap, this, Composite.val) + $ite(read($Heap, this, Composite.left) == null, 0, read($Heap, read($Heap, this, Composite.left), Composite.sum)) + $ite(read($Heap, this, Composite.right) == null, 0, read($Heap, read($Heap, this, Composite.right), Composite.sum))) && (Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)];
  ensures (Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this)) && (read($Heap, this, Composite.left) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && (read($Heap, this, Composite.right) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && read($Heap, this, Composite.sum) == read($Heap, this, Composite.val) + $ite(read($Heap, this, Composite.left) == null, 0, read($Heap, read($Heap, this, Composite.left), Composite.sum)) + $ite(read($Heap, this, Composite.right) == null, 0, read($Heap, read($Heap, this, Composite.right), Composite.sum))) && (Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))));
  ensures (Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this)) && (read($Heap, this, Composite.left) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && (read($Heap, this, Composite.right) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && read($Heap, this, Composite.sum) == read($Heap, this, Composite.val) + $ite(read($Heap, this, Composite.left) == null, 0, read($Heap, read($Heap, this, Composite.left), Composite.sum)) + $ite(read($Heap, this, Composite.right) == null, 0, read($Heap, read($Heap, this, Composite.right), Composite.sum))) && (Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> read($Heap, this, Composite.val) == x#2;
  ensures (Composite.Valid($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this)) && (read($Heap, this, Composite.left) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && (read($Heap, this, Composite.right) != null ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right)) && read($Heap, this, Composite.sum) == read($Heap, this, Composite.val) + $ite(read($Heap, this, Composite.left) == null, 0, read($Heap, read($Heap, this, Composite.left), Composite.sum)) + $ite(read($Heap, this, Composite.right) == null, 0, read($Heap, read($Heap, this, Composite.right), Composite.sum))) && (Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> read($Heap, this, Composite.parent) == null;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^29.12: $token;

const unique #tok$0^30.10: $token;

const unique #tok$0^31.11: $token;

const unique #tok$0^32.9: $token;

const unique #tok$0^33.9: $token;

implementation Composite.Init(this: ref, x#2: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^25.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^25.15, cev_parameter, #loc.x#2, x#2);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    // ----- assignment statement ----- Test\vacid0\Composite.dfy(29,12)
    assert true;
    assert true;
    assert $_Frame[this, Composite.parent];
    $Heap := update($Heap, this, Composite.parent, null);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\Composite.dfy(29,12)"} true;
    call CevUpdateHeap(#tok$0^29.12, #loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\vacid0\Composite.dfy(30,10)
    assert true;
    assert true;
    assert $_Frame[this, Composite.left];
    $Heap := update($Heap, this, Composite.left, null);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\Composite.dfy(30,10)"} true;
    call CevUpdateHeap(#tok$0^30.10, #loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\vacid0\Composite.dfy(31,11)
    assert true;
    assert true;
    assert $_Frame[this, Composite.right];
    $Heap := update($Heap, this, Composite.right, null);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\Composite.dfy(31,11)"} true;
    call CevUpdateHeap(#tok$0^31.11, #loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\vacid0\Composite.dfy(32,9)
    assert true;
    assert true;
    assert $_Frame[this, Composite.val];
    $Heap := update($Heap, this, Composite.val, x#2);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\Composite.dfy(32,9)"} true;
    call CevUpdateHeap(#tok$0^32.9, #loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\vacid0\Composite.dfy(33,9)
    assert true;
    assert true;
    assert $_Frame[this, Composite.sum];
    $Heap := update($Heap, this, Composite.sum, read($Heap, this, Composite.val));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\Composite.dfy(33,9)"} true;
    call CevUpdateHeap(#tok$0^33.9, #loc.$Heap, $Heap);
}



const unique #tok$0^36.10: $token;

procedure CheckWellformed$$Composite.Update(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Composite, x#3: int, S#4: Set BoxType where (forall $t: BoxType :: { S#4[$t] } S#4[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^36.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^36.17: $token;

const unique #loc.x#3: $token;

const unique #tok$0^36.31: $token;

const unique #loc.S#4: $token;

implementation CheckWellformed$$Composite.Update(this: ref, x#3: int, S#4: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var S#47: Set BoxType;
  var c#48: ref;
  var S#49: Set BoxType;
  var c#50: ref;
  var S#51: Set BoxType;
  var c#52: ref;
  var c#53: ref;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^36.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^36.17, cev_parameter, #loc.x#3, x#3);
    call CevVarIntro(#tok$0^36.31, cev_parameter, #loc.S#4, S#4);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> S#4[$Box($o)]);
    if (S#4[$Box(this)])
    {
        S#47 := S#4;
    }

    assume S#4[$Box(this)] && Composite.Acyclic($Heap, this, S#4);
    if (S#4[$Box(c#48)])
    {
        if (c#48 != null)
        {
            assert c#48 != null;
            S#49 := S#4;
        }
    }

    assume (forall c#5: ref :: S#4[$Box(c#5)] ==> c#5 != null && Composite.Valid($Heap, c#5, S#4));
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (S#4[$Box(c#50)])
    {
        assert c#50 != null;
        S#51 := S#4;
    }

    assume (forall c#6: ref :: S#4[$Box(c#6)] ==> Composite.Valid($Heap, c#6, S#4));
    if (S#4[$Box(c#52)])
    {
        assert c#52 != null;
        assert c#52 != null;
        if (read($Heap, c#52, Composite.left) == old(read($Heap, c#52, Composite.left)))
        {
            assert c#52 != null;
            assert c#52 != null;
        }

        if (read($Heap, c#52, Composite.left) == old(read($Heap, c#52, Composite.left)) && read($Heap, c#52, Composite.right) == old(read($Heap, c#52, Composite.right)))
        {
            assert c#52 != null;
            assert c#52 != null;
        }
    }

    assume (forall c#7: ref :: S#4[$Box(c#7)] ==> read($Heap, c#7, Composite.left) == old(read($Heap, c#7, Composite.left)) && read($Heap, c#7, Composite.right) == old(read($Heap, c#7, Composite.right)) && read($Heap, c#7, Composite.parent) == old(read($Heap, c#7, Composite.parent)));
    if (S#4[$Box(c#53)])
    {
    }

    if (S#4[$Box(c#53)] && c#53 != this)
    {
        assert c#53 != null;
        assert c#53 != null;
    }

    assume (forall c#8: ref :: S#4[$Box(c#8)] && c#8 != this ==> read($Heap, c#8, Composite.val) == old(read($Heap, c#8, Composite.val)));
    assume read($Heap, this, Composite.val) == x#3;
}



procedure Composite.Update(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Composite, x#3: int, S#4: Set BoxType where (forall $t: BoxType :: { S#4[$t] } S#4[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires S#4[$Box(this)] && Composite.Acyclic($Heap, this, S#4);
  free requires Composite.Acyclic($Heap, this, S#4) ==> S#4[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(S#4, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))));
  requires (Composite.Acyclic($Heap, this, S#4) ==> S#4[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(S#4, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> S#4[$Box(this)];
  requires (Composite.Acyclic($Heap, this, S#4) ==> S#4[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(S#4, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> S#4[$Box(this)];
  requires (Composite.Acyclic($Heap, this, S#4) ==> S#4[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(S#4, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(S#4, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))));
  requires (forall c#5: ref :: S#4[$Box(c#5)] ==> c#5 != null && Composite.Valid($Heap, c#5, S#4));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^36.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures (forall c#6: ref :: S#4[$Box(c#6)] ==> Composite.Valid($Heap, c#6, S#4));
  ensures (forall c#7: ref :: S#4[$Box(c#7)] ==> read($Heap, c#7, Composite.left) == old(read($Heap, c#7, Composite.left)) && read($Heap, c#7, Composite.right) == old(read($Heap, c#7, Composite.right)) && read($Heap, c#7, Composite.parent) == old(read($Heap, c#7, Composite.parent)));
  ensures (forall c#8: ref :: S#4[$Box(c#8)] && c#8 != this ==> read($Heap, c#8, Composite.val) == old(read($Heap, c#8, Composite.val)));
  ensures read($Heap, this, Composite.val) == x#3;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || S#4[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.delta#9: $token;

const unique #tok$0^45.9: $token;

const unique #tok$0^46.9: $token;

const unique #tok$0^47.5: $token;

implementation Composite.Update(this: ref, x#3: int, S#4: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var delta#9: int where #cev_var_update(#cev_pc, cev_local, #loc.delta#9, delta#9);
  var delta#54: int;
  var U#55: Set BoxType;
  var S#56: Set BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^36.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^36.17, cev_parameter, #loc.x#3, x#3);
    call CevVarIntro(#tok$0^36.31, cev_parameter, #loc.S#4, S#4);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> S#4[$Box($o)]);
    // ----- var-declaration statement ----- Test\vacid0\Composite.dfy(45,9)
    assert true;
    assert true;
    delta#9 := x#3 - read($Heap, this, Composite.val);
    assume {:captureState "Test\vacid0\Composite.dfy(45,9)"} true;
    call CevVarIntro(#tok$0^45.9, cev_local, #loc.delta#9, delta#9);
    // ----- assignment statement ----- Test\vacid0\Composite.dfy(46,9)
    assert true;
    assert true;
    assert $_Frame[this, Composite.val];
    $Heap := update($Heap, this, Composite.val, x#3);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\Composite.dfy(46,9)"} true;
    call CevUpdateHeap(#tok$0^46.9, #loc.$Heap, $Heap);
    // ----- call statement ----- Test\vacid0\Composite.dfy(47,5)
    assert true;
    delta#54 := delta#9;
    assert true;
    U#55 := S#4;
    assert true;
    S#56 := S#4;
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && U#55[$Box($o)] && $f == Composite.sum ==> $_Frame[$o, $f]);
    call Composite.Adjust(this, delta#54, U#55, S#56);
    call CevStep(#tok$0^47.5);
    assume {:captureState "Test\vacid0\Composite.dfy(47,5)"} true;
}



const unique #tok$0^50.10: $token;

procedure CheckWellformed$$Composite.Add(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Composite, S#10: Set BoxType where (forall $t: BoxType :: { S#10[$t] } S#10[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)), child#11: ref where child#11 == null || (read($Heap, child#11, alloc) && dtype(child#11) == class.Composite), U#12: Set BoxType where (forall $t: BoxType :: { U#12[$t] } U#12[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^50.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^50.20: $token;

const unique #loc.S#10: $token;

const unique #tok$0^50.39: $token;

const unique #loc.child#11: $token;

const unique #tok$0^50.63: $token;

const unique #loc.U#12: $token;

implementation CheckWellformed$$Composite.Add(this: ref, S#10: Set BoxType, child#11: ref, U#12: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var S#57: Set BoxType;
  var c#58: ref;
  var S#59: Set BoxType;
  var c#60: ref;
  var S#61: Set BoxType;
  var c#62: ref;
  var c#63: ref;
  var c#64: ref;
  var S#65: Set BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^50.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^50.20, cev_parameter, #loc.S#10, S#10);
    call CevVarIntro(#tok$0^50.39, cev_parameter, #loc.child#11, child#11);
    call CevVarIntro(#tok$0^50.63, cev_parameter, #loc.U#12, U#12);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> S#10[$Box($o)] || $o == child#11);
    if (S#10[$Box(this)])
    {
        S#57 := S#10;
    }

    assume S#10[$Box(this)] && Composite.Acyclic($Heap, this, S#10);
    if (S#10[$Box(c#58)])
    {
        if (c#58 != null)
        {
            assert c#58 != null;
            S#59 := S#10;
        }
    }

    assume (forall c#13: ref :: S#10[$Box(c#13)] ==> c#13 != null && Composite.Valid($Heap, c#13, S#10));
    if (child#11 != null)
    {
    }

    assume child#11 != null && U#12[$Box(child#11)];
    if (U#12[$Box(c#60)])
    {
        if (c#60 != null)
        {
            assert c#60 != null;
            S#61 := U#12;
        }
    }

    assume (forall c#14: ref :: U#12[$Box(c#14)] ==> c#14 != null && Composite.Valid($Heap, c#14, U#12));
    assume Set#Disjoint(S#10, U#12);
    if (read($Heap, this, Composite.left) != null)
    {
    }

    assume read($Heap, this, Composite.left) == null || read($Heap, this, Composite.right) == null;
    assert child#11 != null;
    assume read($Heap, child#11, Composite.parent) == null;
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    assert child#11 != null;
    assert child#11 != null;
    if (read($Heap, child#11, Composite.left) == old(read($Heap, child#11, Composite.left)))
    {
        assert child#11 != null;
        assert child#11 != null;
    }

    if (read($Heap, child#11, Composite.left) == old(read($Heap, child#11, Composite.left)) && read($Heap, child#11, Composite.right) == old(read($Heap, child#11, Composite.right)))
    {
        assert child#11 != null;
        assert child#11 != null;
    }

    assume read($Heap, child#11, Composite.left) == old(read($Heap, child#11, Composite.left)) && read($Heap, child#11, Composite.right) == old(read($Heap, child#11, Composite.right)) && read($Heap, child#11, Composite.val) == old(read($Heap, child#11, Composite.val));
    if (S#10[$Box(c#62)])
    {
    }

    if (S#10[$Box(c#62)] && c#62 != this)
    {
        assert c#62 != null;
        assert c#62 != null;
        if (read($Heap, c#62, Composite.left) == old(read($Heap, c#62, Composite.left)))
        {
            assert c#62 != null;
            assert c#62 != null;
        }
    }

    assume (forall c#15: ref :: S#10[$Box(c#15)] && c#15 != this ==> read($Heap, c#15, Composite.left) == old(read($Heap, c#15, Composite.left)) && read($Heap, c#15, Composite.right) == old(read($Heap, c#15, Composite.right)));
    if (old(read($Heap, this, Composite.left)) != null)
    {
    }

    assume old(read($Heap, this, Composite.left)) != null ==> read($Heap, this, Composite.left) == old(read($Heap, this, Composite.left));
    if (old(read($Heap, this, Composite.right)) != null)
    {
    }

    assume old(read($Heap, this, Composite.right)) != null ==> read($Heap, this, Composite.right) == old(read($Heap, this, Composite.right));
    if (S#10[$Box(c#63)])
    {
        assert c#63 != null;
        assert c#63 != null;
        if (read($Heap, c#63, Composite.parent) == old(read($Heap, c#63, Composite.parent)))
        {
            assert c#63 != null;
            assert c#63 != null;
        }
    }

    assume (forall c#16: ref :: S#10[$Box(c#16)] ==> read($Heap, c#16, Composite.parent) == old(read($Heap, c#16, Composite.parent)) && read($Heap, c#16, Composite.val) == old(read($Heap, c#16, Composite.val)));
    assert child#11 != null;
    assume read($Heap, child#11, Composite.parent) == this;
    if (S#10[$Box(c#64)] || U#12[$Box(c#64)])
    {
        assert c#64 != null;
        S#65 := Set#Union(S#10, U#12);
    }

    assume (forall c#17: ref :: S#10[$Box(c#17)] || U#12[$Box(c#17)] ==> Composite.Valid($Heap, c#17, Set#Union(S#10, U#12)));
}



procedure Composite.Add(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Composite, S#10: Set BoxType where (forall $t: BoxType :: { S#10[$t] } S#10[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)), child#11: ref where child#11 == null || (read($Heap, child#11, alloc) && dtype(child#11) == class.Composite), U#12: Set BoxType where (forall $t: BoxType :: { U#12[$t] } U#12[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires S#10[$Box(this)] && Composite.Acyclic($Heap, this, S#10);
  free requires Composite.Acyclic($Heap, this, S#10) ==> S#10[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(S#10, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))));
  requires (Composite.Acyclic($Heap, this, S#10) ==> S#10[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(S#10, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> S#10[$Box(this)];
  requires (Composite.Acyclic($Heap, this, S#10) ==> S#10[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(S#10, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> S#10[$Box(this)];
  requires (Composite.Acyclic($Heap, this, S#10) ==> S#10[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(S#10, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(S#10, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))));
  requires (forall c#13: ref :: S#10[$Box(c#13)] ==> c#13 != null && Composite.Valid($Heap, c#13, S#10));
  free requires child#11 != null && U#12[$Box(child#11)];
  requires true ==> child#11 != null;
  requires true ==> U#12[$Box(child#11)];
  requires (forall c#14: ref :: U#12[$Box(c#14)] ==> c#14 != null && Composite.Valid($Heap, c#14, U#12));
  requires Set#Disjoint(S#10, U#12);
  requires read($Heap, this, Composite.left) == null || read($Heap, this, Composite.right) == null;
  requires read($Heap, child#11, Composite.parent) == null;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^50.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures read($Heap, child#11, Composite.left) == old(read($Heap, child#11, Composite.left)) && read($Heap, child#11, Composite.right) == old(read($Heap, child#11, Composite.right)) && read($Heap, child#11, Composite.val) == old(read($Heap, child#11, Composite.val));
  ensures true ==> read($Heap, child#11, Composite.left) == old(read($Heap, child#11, Composite.left));
  ensures true ==> read($Heap, child#11, Composite.right) == old(read($Heap, child#11, Composite.right));
  ensures true ==> read($Heap, child#11, Composite.val) == old(read($Heap, child#11, Composite.val));
  ensures (forall c#15: ref :: S#10[$Box(c#15)] && c#15 != this ==> read($Heap, c#15, Composite.left) == old(read($Heap, c#15, Composite.left)) && read($Heap, c#15, Composite.right) == old(read($Heap, c#15, Composite.right)));
  ensures old(read($Heap, this, Composite.left)) != null ==> read($Heap, this, Composite.left) == old(read($Heap, this, Composite.left));
  ensures old(read($Heap, this, Composite.right)) != null ==> read($Heap, this, Composite.right) == old(read($Heap, this, Composite.right));
  ensures (forall c#16: ref :: S#10[$Box(c#16)] ==> read($Heap, c#16, Composite.parent) == old(read($Heap, c#16, Composite.parent)) && read($Heap, c#16, Composite.val) == old(read($Heap, c#16, Composite.val)));
  ensures read($Heap, child#11, Composite.parent) == this;
  ensures (forall c#17: ref :: S#10[$Box(c#17)] || U#12[$Box(c#17)] ==> Composite.Valid($Heap, c#17, Set#Union(S#10, U#12)));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || S#10[$Box($o)] || $o == child#11);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^70.5: $token;

const unique #tok$0^70.23: $token;

const unique #tok$0^71.12: $token;

const unique #tok$0^72.12: $token;

const unique #tok$0^73.13: $token;

const unique #tok$0^75.18: $token;

const unique #tok$0^76.5: $token;

implementation Composite.Add(this: ref, S#10: Set BoxType, child#11: ref, U#12: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var delta#66: int;
  var U#67: Set BoxType;
  var S#68: Set BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^50.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^50.20, cev_parameter, #loc.S#10, S#10);
    call CevVarIntro(#tok$0^50.39, cev_parameter, #loc.child#11, child#11);
    call CevVarIntro(#tok$0^50.63, cev_parameter, #loc.U#12, U#12);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> S#10[$Box($o)] || $o == child#11);
    // ----- if statement ----- Test\vacid0\Composite.dfy(70,5)
    call CevEvent(#tok$0^70.5, conditional_moment);
    assert true;
    if (read($Heap, this, Composite.left) == null)
    {
        call CevEvent(#tok$0^70.23, took_then_branch);
        // ----- assignment statement ----- Test\vacid0\Composite.dfy(71,12)
        assert true;
        assert true;
        assert $_Frame[this, Composite.left];
        $Heap := update($Heap, this, Composite.left, child#11);
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\vacid0\Composite.dfy(71,12)"} true;
        call CevUpdateHeap(#tok$0^71.12, #loc.$Heap, $Heap);
    }
    else
    {
        call CevEvent(#tok$0^72.12, took_else_branch);
        // ----- assignment statement ----- Test\vacid0\Composite.dfy(73,13)
        assert true;
        assert true;
        assert $_Frame[this, Composite.right];
        $Heap := update($Heap, this, Composite.right, child#11);
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\vacid0\Composite.dfy(73,13)"} true;
        call CevUpdateHeap(#tok$0^73.13, #loc.$Heap, $Heap);
    }

    // ----- assignment statement ----- Test\vacid0\Composite.dfy(75,18)
    assert child#11 != null;
    assert true;
    assert $_Frame[child#11, Composite.parent];
    $Heap := update($Heap, child#11, Composite.parent, this);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\Composite.dfy(75,18)"} true;
    call CevUpdateHeap(#tok$0^75.18, #loc.$Heap, $Heap);
    // ----- call statement ----- Test\vacid0\Composite.dfy(76,5)
    assert child#11 != null;
    delta#66 := read($Heap, child#11, Composite.sum);
    assert true;
    U#67 := S#10;
    assert true;
    S#68 := Set#Union(S#10, U#12);
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && U#67[$Box($o)] && $f == Composite.sum ==> $_Frame[$o, $f]);
    call Composite.Adjust(this, delta#66, U#67, S#68);
    call CevStep(#tok$0^76.5);
    assume {:captureState "Test\vacid0\Composite.dfy(76,5)"} true;
}



const unique #tok$0^79.10: $token;

procedure CheckWellformed$$Composite.Dislodge(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Composite, S#18: Set BoxType where (forall $t: BoxType :: { S#18[$t] } S#18[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^79.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^79.25: $token;

const unique #loc.S#18: $token;

implementation CheckWellformed$$Composite.Dislodge(this: ref, S#18: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var S#69: Set BoxType;
  var c#70: ref;
  var S#71: Set BoxType;
  var c#72: ref;
  var S#73: Set BoxType;
  var c#74: ref;
  var c#75: ref;
  var c#76: ref;
  var c#77: ref;
  var S#78: Set BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^79.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^79.25, cev_parameter, #loc.S#18, S#18);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> S#18[$Box($o)]);
    if (S#18[$Box(this)])
    {
        S#69 := S#18;
    }

    assume S#18[$Box(this)] && Composite.Acyclic($Heap, this, S#18);
    if (S#18[$Box(c#70)])
    {
        if (c#70 != null)
        {
            assert c#70 != null;
            S#71 := S#18;
        }
    }

    assume (forall c#19: ref :: S#18[$Box(c#19)] ==> c#19 != null && Composite.Valid($Heap, c#19, S#18));
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (S#18[$Box(c#72)])
    {
        assert c#72 != null;
        S#73 := S#18;
    }

    assume (forall c#20: ref :: S#18[$Box(c#20)] ==> Composite.Valid($Heap, c#20, S#18));
    if (S#18[$Box(c#74)])
    {
        assert c#74 != null;
        assert c#74 != null;
    }

    assume (forall c#21: ref :: S#18[$Box(c#21)] ==> read($Heap, c#21, Composite.val) == old(read($Heap, c#21, Composite.val)));
    if (S#18[$Box(c#75)])
    {
    }

    if (S#18[$Box(c#75)] && c#75 != this)
    {
        assert c#75 != null;
        assert c#75 != null;
    }

    assume (forall c#22: ref :: S#18[$Box(c#22)] && c#22 != this ==> read($Heap, c#22, Composite.parent) == old(read($Heap, c#22, Composite.parent)));
    assume read($Heap, this, Composite.parent) == null;
    if (S#18[$Box(c#76)])
    {
        assert c#76 != null;
        assert c#76 != null;
        if (read($Heap, c#76, Composite.left) != old(read($Heap, c#76, Composite.left)))
        {
            assert c#76 != null;
            if (old(read($Heap, c#76, Composite.left)) == this)
            {
                assert c#76 != null;
            }
        }
    }

    assume (forall c#23: ref :: S#18[$Box(c#23)] ==> read($Heap, c#23, Composite.left) == old(read($Heap, c#23, Composite.left)) || (old(read($Heap, c#23, Composite.left)) == this && read($Heap, c#23, Composite.left) == null));
    if (S#18[$Box(c#77)])
    {
        assert c#77 != null;
        assert c#77 != null;
        if (read($Heap, c#77, Composite.right) != old(read($Heap, c#77, Composite.right)))
        {
            assert c#77 != null;
            if (old(read($Heap, c#77, Composite.right)) == this)
            {
                assert c#77 != null;
            }
        }
    }

    assume (forall c#24: ref :: S#18[$Box(c#24)] ==> read($Heap, c#24, Composite.right) == old(read($Heap, c#24, Composite.right)) || (old(read($Heap, c#24, Composite.right)) == this && read($Heap, c#24, Composite.right) == null));
    S#78 := Set#UnionOne(Set#Empty(): Set BoxType, $Box(this));
    assume Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)));
}



procedure Composite.Dislodge(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Composite, S#18: Set BoxType where (forall $t: BoxType :: { S#18[$t] } S#18[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires S#18[$Box(this)] && Composite.Acyclic($Heap, this, S#18);
  free requires Composite.Acyclic($Heap, this, S#18) ==> S#18[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(S#18, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))));
  requires (Composite.Acyclic($Heap, this, S#18) ==> S#18[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(S#18, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> S#18[$Box(this)];
  requires (Composite.Acyclic($Heap, this, S#18) ==> S#18[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(S#18, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> S#18[$Box(this)];
  requires (Composite.Acyclic($Heap, this, S#18) ==> S#18[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(S#18, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(S#18, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))));
  requires (forall c#19: ref :: S#18[$Box(c#19)] ==> c#19 != null && Composite.Valid($Heap, c#19, S#18));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^79.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures (forall c#20: ref :: S#18[$Box(c#20)] ==> Composite.Valid($Heap, c#20, S#18));
  ensures (forall c#21: ref :: S#18[$Box(c#21)] ==> read($Heap, c#21, Composite.val) == old(read($Heap, c#21, Composite.val)));
  ensures (forall c#22: ref :: S#18[$Box(c#22)] && c#22 != this ==> read($Heap, c#22, Composite.parent) == old(read($Heap, c#22, Composite.parent)));
  ensures read($Heap, this, Composite.parent) == null;
  ensures (forall c#23: ref :: S#18[$Box(c#23)] ==> read($Heap, c#23, Composite.left) == old(read($Heap, c#23, Composite.left)) || (old(read($Heap, c#23, Composite.left)) == this && read($Heap, c#23, Composite.left) == null));
  ensures (forall c#24: ref :: S#18[$Box(c#24)] ==> read($Heap, c#24, Composite.right) == old(read($Heap, c#24, Composite.right)) || (old(read($Heap, c#24, Composite.right)) == this && read($Heap, c#24, Composite.right) == null));
  free ensures Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)));
  free ensures Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))));
  ensures (Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)];
  ensures (Composite.Acyclic($Heap, this, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))) ==> Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || S#18[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.p#25: $token;

const unique #tok$0^91.9: $token;

const unique #tok$0^92.12: $token;

const unique #tok$0^93.5: $token;

const unique #tok$0^93.20: $token;

const unique #tok$0^94.7: $token;

const unique #tok$0^94.27: $token;

const unique #tok$0^95.16: $token;

const unique #tok$0^96.14: $token;

const unique #tok$0^97.17: $token;

const unique #loc.delta#26: $token;

const unique #tok$0^99.11: $token;

const unique #tok$0^100.7: $token;

implementation Composite.Dislodge(this: ref, S#18: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var p#25: ref where (p#25 == null || (read($Heap, p#25, alloc) && dtype(p#25) == class.Composite)) && #cev_var_update(#cev_pc, cev_local, #loc.p#25, p#25);
  var delta#26: int where #cev_var_update(#cev_pc, cev_local, #loc.delta#26, delta#26);
  var delta#79: int;
  var U#80: Set BoxType;
  var S#81: Set BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^79.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^79.25, cev_parameter, #loc.S#18, S#18);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> S#18[$Box($o)]);
    // ----- var-declaration statement ----- Test\vacid0\Composite.dfy(91,9)
    assert true;
    assert true;
    p#25 := read($Heap, this, Composite.parent);
    assume {:captureState "Test\vacid0\Composite.dfy(91,9)"} true;
    call CevVarIntro(#tok$0^91.9, cev_local, #loc.p#25, p#25);
    // ----- assignment statement ----- Test\vacid0\Composite.dfy(92,12)
    assert true;
    assert true;
    assert $_Frame[this, Composite.parent];
    $Heap := update($Heap, this, Composite.parent, null);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\Composite.dfy(92,12)"} true;
    call CevUpdateHeap(#tok$0^92.12, #loc.$Heap, $Heap);
    // ----- if statement ----- Test\vacid0\Composite.dfy(93,5)
    call CevEvent(#tok$0^93.5, conditional_moment);
    assert true;
    if (p#25 != null)
    {
        call CevEvent(#tok$0^93.20, took_then_branch);
        // ----- if statement ----- Test\vacid0\Composite.dfy(94,7)
        call CevEvent(#tok$0^94.7, conditional_moment);
        assert p#25 != null;
        if (read($Heap, p#25, Composite.left) == this)
        {
            call CevEvent(#tok$0^94.27, took_then_branch);
            // ----- assignment statement ----- Test\vacid0\Composite.dfy(95,16)
            assert p#25 != null;
            assert true;
            assert $_Frame[p#25, Composite.left];
            $Heap := update($Heap, p#25, Composite.left, null);
            assume $IsGoodHeap($Heap);
            assume {:captureState "Test\vacid0\Composite.dfy(95,16)"} true;
            call CevUpdateHeap(#tok$0^95.16, #loc.$Heap, $Heap);
        }
        else
        {
            call CevEvent(#tok$0^96.14, took_else_branch);
            // ----- assignment statement ----- Test\vacid0\Composite.dfy(97,17)
            assert p#25 != null;
            assert true;
            assert $_Frame[p#25, Composite.right];
            $Heap := update($Heap, p#25, Composite.right, null);
            assume $IsGoodHeap($Heap);
            assume {:captureState "Test\vacid0\Composite.dfy(97,17)"} true;
            call CevUpdateHeap(#tok$0^97.17, #loc.$Heap, $Heap);
        }

        // ----- var-declaration statement ----- Test\vacid0\Composite.dfy(99,11)
        assert true;
        assert true;
        delta#26 := 0 - read($Heap, this, Composite.sum);
        assume {:captureState "Test\vacid0\Composite.dfy(99,11)"} true;
        call CevVarIntro(#tok$0^99.11, cev_local, #loc.delta#26, delta#26);
        // ----- call statement ----- Test\vacid0\Composite.dfy(100,7)
        assert true;
        delta#79 := delta#26;
        assert true;
        U#80 := Set#Difference(S#18, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)));
        assert true;
        S#81 := S#18;
        assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && U#80[$Box($o)] && $f == Composite.sum ==> $_Frame[$o, $f]);
        call Composite.Adjust(p#25, delta#79, U#80, S#81);
        call CevStep(#tok$0^100.7);
        assume {:captureState "Test\vacid0\Composite.dfy(100,7)"} true;
    }
    else
    {
        call CevEvent(#tok$0^93.5, took_else_branch);
    }
}



const unique #tok$0^104.22: $token;

procedure CheckWellformed$$Composite.Adjust(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Composite, delta#27: int, U#28: Set BoxType where (forall $t: BoxType :: { U#28[$t] } U#28[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)), S#29: Set BoxType where (forall $t: BoxType :: { S#29[$t] } S#29[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^104.22;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^104.29: $token;

const unique #loc.delta#27: $token;

const unique #tok$0^104.47: $token;

const unique #loc.U#28: $token;

const unique #tok$0^104.72: $token;

const unique #loc.S#29: $token;

implementation CheckWellformed$$Composite.Adjust(this: ref, delta#27: int, U#28: Set BoxType, S#29: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var S#82: Set BoxType;
  var c#83: ref;
  var S#84: Set BoxType;
  var c#85: ref;
  var S#86: Set BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^104.22, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^104.29, cev_parameter, #loc.delta#27, delta#27);
    call CevVarIntro(#tok$0^104.47, cev_parameter, #loc.U#28, U#28);
    call CevVarIntro(#tok$0^104.72, cev_parameter, #loc.S#29, S#29);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> U#28[$Box($o)] && $f == Composite.sum);
    if (Set#Subset(U#28, S#29))
    {
        S#82 := U#28;
    }

    assume Set#Subset(U#28, S#29) && Composite.Acyclic($Heap, this, U#28);
    if (S#29[$Box(c#83)])
    {
    }

    if (S#29[$Box(c#83)] && c#83 != this)
    {
        if (c#83 != null)
        {
            assert c#83 != null;
            S#84 := S#29;
        }
    }

    assume (forall c#30: ref :: S#29[$Box(c#30)] && c#30 != this ==> c#30 != null && Composite.Valid($Heap, c#30, S#29));
    if (read($Heap, this, Composite.parent) != null)
    {
        if (S#29[$Box(read($Heap, this, Composite.parent))])
        {
            assert read($Heap, this, Composite.parent) != null;
            if (read($Heap, read($Heap, this, Composite.parent), Composite.left) != this)
            {
                assert read($Heap, this, Composite.parent) != null;
            }
        }
    }

    assume read($Heap, this, Composite.parent) != null ==> S#29[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this);
    if (read($Heap, this, Composite.left) != null)
    {
        if (S#29[$Box(read($Heap, this, Composite.left))])
        {
            assert read($Heap, this, Composite.left) != null;
        }

        if (S#29[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this)
        {
        }
    }

    assume read($Heap, this, Composite.left) != null ==> S#29[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right);
    if (read($Heap, this, Composite.right) != null)
    {
        if (S#29[$Box(read($Heap, this, Composite.right))])
        {
            assert read($Heap, this, Composite.right) != null;
        }

        if (S#29[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this)
        {
        }
    }

    assume read($Heap, this, Composite.right) != null ==> S#29[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right);
    if (read($Heap, this, Composite.left) == null)
    {
    }
    else
    {
        assert read($Heap, this, Composite.left) != null;
    }

    if (read($Heap, this, Composite.right) == null)
    {
    }
    else
    {
        assert read($Heap, this, Composite.right) != null;
    }

    assume read($Heap, this, Composite.sum) + delta#27 == read($Heap, this, Composite.val) + $ite(read($Heap, this, Composite.left) == null, 0, read($Heap, read($Heap, this, Composite.left), Composite.sum)) + $ite(read($Heap, this, Composite.right) == null, 0, read($Heap, read($Heap, this, Composite.right), Composite.sum));
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (S#29[$Box(c#85)])
    {
        assert c#85 != null;
        S#86 := S#29;
    }

    assume (forall c#31: ref :: S#29[$Box(c#31)] ==> Composite.Valid($Heap, c#31, S#29));
}



procedure Composite.Adjust(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Composite, delta#27: int, U#28: Set BoxType where (forall $t: BoxType :: { U#28[$t] } U#28[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)), S#29: Set BoxType where (forall $t: BoxType :: { S#29[$t] } S#29[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires Set#Subset(U#28, S#29) && Composite.Acyclic($Heap, this, U#28);
  free requires Composite.Acyclic($Heap, this, U#28) ==> U#28[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(U#28, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))));
  requires (Composite.Acyclic($Heap, this, U#28) ==> U#28[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(U#28, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> Set#Subset(U#28, S#29);
  requires (Composite.Acyclic($Heap, this, U#28) ==> U#28[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(U#28, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> U#28[$Box(this)];
  requires (Composite.Acyclic($Heap, this, U#28) ==> U#28[$Box(this)] && (read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(U#28, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))))) ==> read($Heap, this, Composite.parent) != null ==> Composite.Acyclic($Heap, read($Heap, this, Composite.parent), Set#Difference(U#28, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))));
  requires (forall c#30: ref :: S#29[$Box(c#30)] && c#30 != this ==> c#30 != null && Composite.Valid($Heap, c#30, S#29));
  free requires read($Heap, this, Composite.parent) != null ==> S#29[$Box(read($Heap, this, Composite.parent))] && (read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this);
  requires true ==> read($Heap, this, Composite.parent) != null ==> S#29[$Box(read($Heap, this, Composite.parent))];
  requires true ==> read($Heap, this, Composite.parent) != null ==> read($Heap, read($Heap, this, Composite.parent), Composite.left) == this || read($Heap, read($Heap, this, Composite.parent), Composite.right) == this;
  free requires read($Heap, this, Composite.left) != null ==> S#29[$Box(read($Heap, this, Composite.left))] && read($Heap, read($Heap, this, Composite.left), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right);
  requires true ==> read($Heap, this, Composite.left) != null ==> S#29[$Box(read($Heap, this, Composite.left))];
  requires true ==> read($Heap, this, Composite.left) != null ==> read($Heap, read($Heap, this, Composite.left), Composite.parent) == this;
  requires true ==> read($Heap, this, Composite.left) != null ==> read($Heap, this, Composite.left) != read($Heap, this, Composite.right);
  free requires read($Heap, this, Composite.right) != null ==> S#29[$Box(read($Heap, this, Composite.right))] && read($Heap, read($Heap, this, Composite.right), Composite.parent) == this && read($Heap, this, Composite.left) != read($Heap, this, Composite.right);
  requires true ==> read($Heap, this, Composite.right) != null ==> S#29[$Box(read($Heap, this, Composite.right))];
  requires true ==> read($Heap, this, Composite.right) != null ==> read($Heap, read($Heap, this, Composite.right), Composite.parent) == this;
  requires true ==> read($Heap, this, Composite.right) != null ==> read($Heap, this, Composite.left) != read($Heap, this, Composite.right);
  requires read($Heap, this, Composite.sum) + delta#27 == read($Heap, this, Composite.val) + $ite(read($Heap, this, Composite.left) == null, 0, read($Heap, read($Heap, this, Composite.left), Composite.sum)) + $ite(read($Heap, this, Composite.right) == null, 0, read($Heap, read($Heap, this, Composite.right), Composite.sum));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^104.22;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures (forall c#31: ref :: S#29[$Box(c#31)] ==> Composite.Valid($Heap, c#31, S#29));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (U#28[$Box($o)] && $f == Composite.sum));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.p#32: $token;

const unique #tok$0^119.9: $token;

const unique #loc.T#33: $token;

const unique #tok$0^120.15: $token;

const unique #tok$0^121.5: $token;

const unique #tok$0^129.13: $token;

const unique #tok$0^130.9: $token;

const unique #tok$0^131.9: $token;

implementation Composite.Adjust(this: ref, delta#27: int, U#28: Set BoxType, S#29: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var p#32: ref where (p#32 == null || (read($Heap, p#32, alloc) && dtype(p#32) == class.Composite)) && #cev_var_update(#cev_pc, cev_local, #loc.p#32, p#32);
  var T#33: Set BoxType where (forall $t: BoxType :: { T#33[$t] } T#33[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Composite)) && #cev_var_update(#cev_pc, cev_local, #loc.T#33, T#33);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: Set BoxType;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: Set BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^104.22, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^104.29, cev_parameter, #loc.delta#27, delta#27);
    call CevVarIntro(#tok$0^104.47, cev_parameter, #loc.U#28, U#28);
    call CevVarIntro(#tok$0^104.72, cev_parameter, #loc.S#29, S#29);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> U#28[$Box($o)] && $f == Composite.sum);
    // ----- var-declaration statement ----- Test\vacid0\Composite.dfy(119,9)
    assert true;
    assert true;
    p#32 := this;
    assume {:captureState "Test\vacid0\Composite.dfy(119,9)"} true;
    call CevVarIntro(#tok$0^119.9, cev_local, #loc.p#32, p#32);
    // ----- var-declaration statement ----- Test\vacid0\Composite.dfy(120,15)
    assert true;
    assert true;
    T#33 := U#28;
    assume {:captureState "Test\vacid0\Composite.dfy(120,15)"} true;
    call CevVarIntro(#tok$0^120.15, cev_local, #loc.T#33, T#33);
    // ----- while statement ----- Test\vacid0\Composite.dfy(121,5)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := T#33;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^121.5);
    while (true)
      invariant $w0 ==> Set#Subset(T#33, U#28);
      invariant $w0 ==> p#32 == null || Composite.Acyclic($Heap, p#32, T#33);
      invariant $w0 ==> (forall c#34: ref :: S#29[$Box(c#34)] && c#34 != p#32 ==> Composite.Valid($Heap, c#34, S#29));
      invariant $w0 ==> p#32 != null ==> read($Heap, p#32, Composite.sum) + delta#27 == read($Heap, p#32, Composite.val) + $ite(read($Heap, p#32, Composite.left) == null, 0, read($Heap, read($Heap, p#32, Composite.left), Composite.sum)) + $ite(read($Heap, p#32, Composite.right) == null, 0, read($Heap, read($Heap, p#32, Composite.right), Composite.sum));
      invariant $w0 ==> (forall c#35: ref :: S#29[$Box(c#35)] ==> read($Heap, c#35, Composite.left) == old(read($Heap, c#35, Composite.left)));
      invariant $w0 ==> (forall c#35: ref :: S#29[$Box(c#35)] ==> read($Heap, c#35, Composite.right) == old(read($Heap, c#35, Composite.right)));
      invariant $w0 ==> (forall c#35: ref :: S#29[$Box(c#35)] ==> read($Heap, c#35, Composite.parent) == old(read($Heap, c#35, Composite.parent)));
      invariant $w0 ==> (forall c#35: ref :: S#29[$Box(c#35)] ==> read($Heap, c#35, Composite.val) == old(read($Heap, c#35, Composite.val)));
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f) || (U#28[$Box($o)] && $f == Composite.sum));
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant Set#Subset(T#33, $decr0$init$0) && (Set#Equal(T#33, $decr0$init$0) ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^121.5;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} true;
            assume Set#Subset(T#33, U#28);
            assert {:subsumption 0} p#32 != null ==> p#32 != null;
            assume p#32 == null || Composite.Acyclic($Heap, p#32, T#33);
            assert {:subsumption 0} (forall c#34: ref :: (S#29[$Box(c#34)] ==> true) && (S#29[$Box(c#34)] && c#34 != p#32 ==> c#34 != null));
            assume (forall c#34: ref :: S#29[$Box(c#34)] && c#34 != p#32 ==> Composite.Valid($Heap, c#34, S#29));
            assert {:subsumption 0} p#32 != null ==> p#32 != null && p#32 != null && p#32 != null && (read($Heap, p#32, Composite.left) == null ==> true) && (read($Heap, p#32, Composite.left) != null ==> p#32 != null && read($Heap, p#32, Composite.left) != null) && p#32 != null && (read($Heap, p#32, Composite.right) == null ==> true) && (read($Heap, p#32, Composite.right) != null ==> p#32 != null && read($Heap, p#32, Composite.right) != null);
            assume p#32 != null ==> read($Heap, p#32, Composite.sum) + delta#27 == read($Heap, p#32, Composite.val) + $ite(read($Heap, p#32, Composite.left) == null, 0, read($Heap, read($Heap, p#32, Composite.left), Composite.sum)) + $ite(read($Heap, p#32, Composite.right) == null, 0, read($Heap, read($Heap, p#32, Composite.right), Composite.sum));
            assert {:subsumption 0} (forall c#35: ref :: S#29[$Box(c#35)] ==> c#35 != null && old(c#35 != null) && (read($Heap, c#35, Composite.left) == old(read($Heap, c#35, Composite.left)) ==> c#35 != null && old(c#35 != null)) && (read($Heap, c#35, Composite.left) == old(read($Heap, c#35, Composite.left)) && read($Heap, c#35, Composite.right) == old(read($Heap, c#35, Composite.right)) ==> c#35 != null && old(c#35 != null)) && (read($Heap, c#35, Composite.left) == old(read($Heap, c#35, Composite.left)) && read($Heap, c#35, Composite.right) == old(read($Heap, c#35, Composite.right)) && read($Heap, c#35, Composite.parent) == old(read($Heap, c#35, Composite.parent)) ==> c#35 != null && old(c#35 != null)));
            assume (forall c#35: ref :: S#29[$Box(c#35)] ==> read($Heap, c#35, Composite.left) == old(read($Heap, c#35, Composite.left)) && read($Heap, c#35, Composite.right) == old(read($Heap, c#35, Composite.right)) && read($Heap, c#35, Composite.parent) == old(read($Heap, c#35, Composite.parent)) && read($Heap, c#35, Composite.val) == old(read($Heap, c#35, Composite.val)));
            assert true;
            assume false;
        }

        assert true;
        if (p#32 == null)
        {
            break;
        }

        call CevStepEvent(#tok$0^121.5, loop_entered);
        assume {:captureState "Test\vacid0\Composite.dfy(121,5): loop entered"} true;
        $decr0$0 := T#33;
        // ----- assignment statement ----- Test\vacid0\Composite.dfy(129,13)
        assert p#32 != null;
        assert p#32 != null;
        assert $_Frame[p#32, Composite.sum];
        $Heap := update($Heap, p#32, Composite.sum, read($Heap, p#32, Composite.sum) + delta#27);
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\vacid0\Composite.dfy(129,13)"} true;
        call CevUpdateHeap(#tok$0^129.13, #loc.$Heap, $Heap);
        // ----- assignment statement ----- Test\vacid0\Composite.dfy(130,9)
        assert true;
        assert true;
        T#33 := Set#Difference(T#33, Set#UnionOne(Set#Empty(): Set BoxType, $Box(p#32)));
        assume {:captureState "Test\vacid0\Composite.dfy(130,9)"} true;
        call CevUpdate(#tok$0^130.9, #loc.T#33, T#33);
        // ----- assignment statement ----- Test\vacid0\Composite.dfy(131,9)
        assert true;
        assert p#32 != null;
        p#32 := read($Heap, p#32, Composite.parent);
        assume {:captureState "Test\vacid0\Composite.dfy(131,9)"} true;
        call CevUpdate(#tok$0^131.9, #loc.p#32, p#32);
        assert Set#Subset(T#33, $decr0$0) && !Set#Subset($decr0$0, T#33);
    }

    call CevStepEvent(#tok$0^121.5, loop_exited);
    assume {:captureState "Test\vacid0\Composite.dfy(121,5): loop exit"} true;
}



const unique class._default: ClassName;

const unique #tok$0^136.8: $token;

procedure CheckWellformed$$_default.Main(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^136.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



implementation CheckWellformed$$_default.Main(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^136.8, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
}



procedure _default.Main(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^136.8;
  modifies $Heap, #cev_pc;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.c0#36: $token;

const unique #tok$0^138.7: $token;

const unique #tok$0^139.3: $token;

const unique #loc.c1#37: $token;

const unique #tok$0^141.7: $token;

const unique #tok$0^142.3: $token;

const unique #tok$0^143.3: $token;

const unique #loc.c2#38: $token;

const unique #tok$0^145.7: $token;

const unique #tok$0^146.3: $token;

const unique #loc.c3#39: $token;

const unique #tok$0^148.7: $token;

const unique #tok$0^149.3: $token;

const unique #tok$0^150.3: $token;

const unique #tok$0^151.3: $token;

const unique #loc.S#40: $token;

const unique #tok$0^153.13: $token;

const unique #tok$0^154.3: $token;

const unique #tok$0^155.3: $token;

const unique #tok$0^157.3: $token;

const unique #tok$0^158.3: $token;

const unique #tok$0^159.3: $token;

implementation _default.Main(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var c0#36: ref where (c0#36 == null || (read($Heap, c0#36, alloc) && dtype(c0#36) == class.Composite)) && #cev_var_update(#cev_pc, cev_local, #loc.c0#36, c0#36);
  var $nw: ref;
  var x#87: int;
  var c1#37: ref where (c1#37 == null || (read($Heap, c1#37, alloc) && dtype(c1#37) == class.Composite)) && #cev_var_update(#cev_pc, cev_local, #loc.c1#37, c1#37);
  var x#88: int;
  var S#89: Set BoxType;
  var child#90: ref;
  var U#91: Set BoxType;
  var c2#38: ref where (c2#38 == null || (read($Heap, c2#38, alloc) && dtype(c2#38) == class.Composite)) && #cev_var_update(#cev_pc, cev_local, #loc.c2#38, c2#38);
  var x#92: int;
  var c3#39: ref where (c3#39 == null || (read($Heap, c3#39, alloc) && dtype(c3#39) == class.Composite)) && #cev_var_update(#cev_pc, cev_local, #loc.c3#39, c3#39);
  var x#93: int;
  var S#94: Set BoxType;
  var child#95: ref;
  var U#96: Set BoxType;
  var S#97: Set BoxType;
  var child#98: ref;
  var U#99: Set BoxType;
  var S#40: Set BoxType where #cev_var_update(#cev_pc, cev_local, #loc.S#40, S#40);
  var x#100: int;
  var S#101: Set BoxType;
  var x#102: int;
  var S#103: Set BoxType;
  var S#104: Set BoxType;
  var x#105: int;
  var S#106: Set BoxType;
  var x#107: int;
  var S#108: Set BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^136.8, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- Test\vacid0\Composite.dfy(138,7)
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.Composite;
    $Heap := update($Heap, $nw, alloc, true);
    c0#36 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\Composite.dfy(138,7)"} true;
    call CevVarIntro(#tok$0^138.7, cev_local, #loc.c0#36, c0#36);
    // ----- call statement ----- Test\vacid0\Composite.dfy(139,3)
    assert true;
    x#87 := 57;
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == c0#36 ==> $_Frame[$o, $f]);
    call Composite.Init(c0#36, x#87);
    call CevStep(#tok$0^139.3);
    assume {:captureState "Test\vacid0\Composite.dfy(139,3)"} true;
    // ----- var-declaration statement ----- Test\vacid0\Composite.dfy(141,7)
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.Composite;
    $Heap := update($Heap, $nw, alloc, true);
    c1#37 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\Composite.dfy(141,7)"} true;
    call CevVarIntro(#tok$0^141.7, cev_local, #loc.c1#37, c1#37);
    // ----- call statement ----- Test\vacid0\Composite.dfy(142,3)
    assert true;
    x#88 := 12;
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == c1#37 ==> $_Frame[$o, $f]);
    call Composite.Init(c1#37, x#88);
    call CevStep(#tok$0^142.3);
    assume {:captureState "Test\vacid0\Composite.dfy(142,3)"} true;
    // ----- call statement ----- Test\vacid0\Composite.dfy(143,3)
    assert true;
    S#89 := Set#UnionOne(Set#Empty(): Set BoxType, $Box(c0#36));
    assert true;
    child#90 := c1#37;
    assert true;
    U#91 := Set#UnionOne(Set#Empty(): Set BoxType, $Box(c1#37));
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && (S#89[$Box($o)] || $o == child#90) ==> $_Frame[$o, $f]);
    call Composite.Add(c0#36, S#89, child#90, U#91);
    call CevStep(#tok$0^143.3);
    assume {:captureState "Test\vacid0\Composite.dfy(143,3)"} true;
    // ----- var-declaration statement ----- Test\vacid0\Composite.dfy(145,7)
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.Composite;
    $Heap := update($Heap, $nw, alloc, true);
    c2#38 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\Composite.dfy(145,7)"} true;
    call CevVarIntro(#tok$0^145.7, cev_local, #loc.c2#38, c2#38);
    // ----- call statement ----- Test\vacid0\Composite.dfy(146,3)
    assert true;
    x#92 := 48;
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == c2#38 ==> $_Frame[$o, $f]);
    call Composite.Init(c2#38, x#92);
    call CevStep(#tok$0^146.3);
    assume {:captureState "Test\vacid0\Composite.dfy(146,3)"} true;
    // ----- var-declaration statement ----- Test\vacid0\Composite.dfy(148,7)
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.Composite;
    $Heap := update($Heap, $nw, alloc, true);
    c3#39 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\Composite.dfy(148,7)"} true;
    call CevVarIntro(#tok$0^148.7, cev_local, #loc.c3#39, c3#39);
    // ----- call statement ----- Test\vacid0\Composite.dfy(149,3)
    assert true;
    x#93 := 48;
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == c3#39 ==> $_Frame[$o, $f]);
    call Composite.Init(c3#39, x#93);
    call CevStep(#tok$0^149.3);
    assume {:captureState "Test\vacid0\Composite.dfy(149,3)"} true;
    // ----- call statement ----- Test\vacid0\Composite.dfy(150,3)
    assert true;
    S#94 := Set#UnionOne(Set#Empty(): Set BoxType, $Box(c2#38));
    assert true;
    child#95 := c3#39;
    assert true;
    U#96 := Set#UnionOne(Set#Empty(): Set BoxType, $Box(c3#39));
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && (S#94[$Box($o)] || $o == child#95) ==> $_Frame[$o, $f]);
    call Composite.Add(c2#38, S#94, child#95, U#96);
    call CevStep(#tok$0^150.3);
    assume {:captureState "Test\vacid0\Composite.dfy(150,3)"} true;
    // ----- call statement ----- Test\vacid0\Composite.dfy(151,3)
    assert true;
    S#97 := Set#UnionOne(Set#UnionOne(Set#Empty(): Set BoxType, $Box(c0#36)), $Box(c1#37));
    assert true;
    child#98 := c2#38;
    assert true;
    U#99 := Set#UnionOne(Set#UnionOne(Set#Empty(): Set BoxType, $Box(c2#38)), $Box(c3#39));
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && (S#97[$Box($o)] || $o == child#98) ==> $_Frame[$o, $f]);
    call Composite.Add(c0#36, S#97, child#98, U#99);
    call CevStep(#tok$0^151.3);
    assume {:captureState "Test\vacid0\Composite.dfy(151,3)"} true;
    // ----- var-declaration statement ----- Test\vacid0\Composite.dfy(153,13)
    assert true;
    assert true;
    S#40 := Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set BoxType, $Box(c0#36)), $Box(c1#37)), $Box(c2#38)), $Box(c3#39));
    assume {:captureState "Test\vacid0\Composite.dfy(153,13)"} true;
    call CevVarIntro(#tok$0^153.13, cev_local, #loc.S#40, S#40);
    // ----- call statement ----- Test\vacid0\Composite.dfy(154,3)
    assert true;
    x#100 := 100;
    assert true;
    S#101 := S#40;
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && S#101[$Box($o)] ==> $_Frame[$o, $f]);
    call Composite.Update(c1#37, x#100, S#101);
    call CevStep(#tok$0^154.3);
    assume {:captureState "Test\vacid0\Composite.dfy(154,3)"} true;
    // ----- call statement ----- Test\vacid0\Composite.dfy(155,3)
    assert true;
    x#102 := 102;
    assert true;
    S#103 := S#40;
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && S#103[$Box($o)] ==> $_Frame[$o, $f]);
    call Composite.Update(c2#38, x#102, S#103);
    call CevStep(#tok$0^155.3);
    assume {:captureState "Test\vacid0\Composite.dfy(155,3)"} true;
    // ----- call statement ----- Test\vacid0\Composite.dfy(157,3)
    assert true;
    S#104 := S#40;
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && S#104[$Box($o)] ==> $_Frame[$o, $f]);
    call Composite.Dislodge(c2#38, S#104);
    call CevStep(#tok$0^157.3);
    assume {:captureState "Test\vacid0\Composite.dfy(157,3)"} true;
    // ----- call statement ----- Test\vacid0\Composite.dfy(158,3)
    assert true;
    x#105 := 496;
    assert true;
    S#106 := S#40;
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && S#106[$Box($o)] ==> $_Frame[$o, $f]);
    call Composite.Update(c2#38, x#105, S#106);
    call CevStep(#tok$0^158.3);
    assume {:captureState "Test\vacid0\Composite.dfy(158,3)"} true;
    // ----- call statement ----- Test\vacid0\Composite.dfy(159,3)
    assert true;
    x#107 := 0;
    assert true;
    S#108 := S#40;
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && S#108[$Box($o)] ==> $_Frame[$o, $f]);
    call Composite.Update(c0#36, x#107, S#108);
    call CevStep(#tok$0^159.3);
    assume {:captureState "Test\vacid0\Composite.dfy(159,3)"} true;
}



const unique #tok$0^162.8: $token;

procedure CheckWellformed$$_default.Harness(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^162.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



implementation CheckWellformed$$_default.Harness(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^162.8, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
}



procedure _default.Harness(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^162.8;
  modifies $Heap, #cev_pc;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.a#41: $token;

const unique #tok$0^163.7: $token;

const unique #tok$0^163.28: $token;

const unique #loc.b#42: $token;

const unique #tok$0^164.7: $token;

const unique #tok$0^164.28: $token;

const unique #tok$0^165.3: $token;

const unique #tok$0^168.3: $token;

const unique #loc.c#43: $token;

const unique #tok$0^171.7: $token;

const unique #tok$0^171.28: $token;

const unique #tok$0^172.3: $token;

const unique #tok$0^173.3: $token;

implementation _default.Harness(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var a#41: ref where (a#41 == null || (read($Heap, a#41, alloc) && dtype(a#41) == class.Composite)) && #cev_var_update(#cev_pc, cev_local, #loc.a#41, a#41);
  var $nw: ref;
  var x#109: int;
  var b#42: ref where (b#42 == null || (read($Heap, b#42, alloc) && dtype(b#42) == class.Composite)) && #cev_var_update(#cev_pc, cev_local, #loc.b#42, b#42);
  var x#110: int;
  var S#111: Set BoxType;
  var child#112: ref;
  var U#113: Set BoxType;
  var x#114: int;
  var S#115: Set BoxType;
  var c#43: ref where (c#43 == null || (read($Heap, c#43, alloc) && dtype(c#43) == class.Composite)) && #cev_var_update(#cev_pc, cev_local, #loc.c#43, c#43);
  var x#116: int;
  var S#117: Set BoxType;
  var child#118: ref;
  var U#119: Set BoxType;
  var S#120: Set BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^162.8, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- Test\vacid0\Composite.dfy(163,7)
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.Composite;
    $Heap := update($Heap, $nw, alloc, true);
    a#41 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\Composite.dfy(163,7)"} true;
    call CevVarIntro(#tok$0^163.7, cev_local, #loc.a#41, a#41);
    // ----- call statement ----- Test\vacid0\Composite.dfy(163,28)
    assert true;
    x#109 := 5;
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == a#41 ==> $_Frame[$o, $f]);
    call Composite.Init(a#41, x#109);
    call CevStep(#tok$0^163.28);
    assume {:captureState "Test\vacid0\Composite.dfy(163,28)"} true;
    // ----- var-declaration statement ----- Test\vacid0\Composite.dfy(164,7)
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.Composite;
    $Heap := update($Heap, $nw, alloc, true);
    b#42 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\Composite.dfy(164,7)"} true;
    call CevVarIntro(#tok$0^164.7, cev_local, #loc.b#42, b#42);
    // ----- call statement ----- Test\vacid0\Composite.dfy(164,28)
    assert true;
    x#110 := 7;
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == b#42 ==> $_Frame[$o, $f]);
    call Composite.Init(b#42, x#110);
    call CevStep(#tok$0^164.28);
    assume {:captureState "Test\vacid0\Composite.dfy(164,28)"} true;
    // ----- call statement ----- Test\vacid0\Composite.dfy(165,3)
    assert true;
    S#111 := Set#UnionOne(Set#Empty(): Set BoxType, $Box(a#41));
    assert true;
    child#112 := b#42;
    assert true;
    U#113 := Set#UnionOne(Set#Empty(): Set BoxType, $Box(b#42));
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && (S#111[$Box($o)] || $o == child#112) ==> $_Frame[$o, $f]);
    call Composite.Add(a#41, S#111, child#112, U#113);
    call CevStep(#tok$0^165.3);
    assume {:captureState "Test\vacid0\Composite.dfy(165,3)"} true;
    // ----- assert statement ----- Test\vacid0\Composite.dfy(166,3)
    assert {:subsumption 0} a#41 != null;
    assert read($Heap, a#41, Composite.sum) == 12;
    // ----- call statement ----- Test\vacid0\Composite.dfy(168,3)
    assert true;
    x#114 := 17;
    assert true;
    S#115 := Set#UnionOne(Set#UnionOne(Set#Empty(): Set BoxType, $Box(a#41)), $Box(b#42));
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && S#115[$Box($o)] ==> $_Frame[$o, $f]);
    call Composite.Update(b#42, x#114, S#115);
    call CevStep(#tok$0^168.3);
    assume {:captureState "Test\vacid0\Composite.dfy(168,3)"} true;
    // ----- assert statement ----- Test\vacid0\Composite.dfy(169,3)
    assert {:subsumption 0} a#41 != null;
    assert read($Heap, a#41, Composite.sum) == 22;
    // ----- var-declaration statement ----- Test\vacid0\Composite.dfy(171,7)
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.Composite;
    $Heap := update($Heap, $nw, alloc, true);
    c#43 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\Composite.dfy(171,7)"} true;
    call CevVarIntro(#tok$0^171.7, cev_local, #loc.c#43, c#43);
    // ----- call statement ----- Test\vacid0\Composite.dfy(171,28)
    assert true;
    x#116 := 10;
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == c#43 ==> $_Frame[$o, $f]);
    call Composite.Init(c#43, x#116);
    call CevStep(#tok$0^171.28);
    assume {:captureState "Test\vacid0\Composite.dfy(171,28)"} true;
    // ----- call statement ----- Test\vacid0\Composite.dfy(172,3)
    assert true;
    S#117 := Set#UnionOne(Set#UnionOne(Set#Empty(): Set BoxType, $Box(a#41)), $Box(b#42));
    assert true;
    child#118 := c#43;
    assert true;
    U#119 := Set#UnionOne(Set#Empty(): Set BoxType, $Box(c#43));
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && (S#117[$Box($o)] || $o == child#118) ==> $_Frame[$o, $f]);
    call Composite.Add(b#42, S#117, child#118, U#119);
    call CevStep(#tok$0^172.3);
    assume {:captureState "Test\vacid0\Composite.dfy(172,3)"} true;
    // ----- call statement ----- Test\vacid0\Composite.dfy(173,3)
    assert true;
    S#120 := Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set BoxType, $Box(a#41)), $Box(b#42)), $Box(c#43));
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && S#120[$Box($o)] ==> $_Frame[$o, $f]);
    call Composite.Dislodge(b#42, S#120);
    call CevStep(#tok$0^173.3);
    assume {:captureState "Test\vacid0\Composite.dfy(173,3)"} true;
    // ----- assert statement ----- Test\vacid0\Composite.dfy(174,3)
    assert {:subsumption 0} b#42 != null;
    assert read($Heap, b#42, Composite.sum) == 27;
}


