// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: dafny1\Cubes.dfy /print:\Users\philipp\Desktop\boogie\boogie-k-induction-benchmarks\benchmarks\Cubes.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class._default: ClassName;

const unique xxxxxxxxxfile: $token;

axiom $file_name_is(0, xxxxxxxxxfile);

const unique #tok$0^1.8: $token;

procedure CheckWellformed$$_default.Cubes(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, a#0: ref where a#0 == null || (read($Heap, a#0, alloc) && dtype(a#0) == class.array && TypeParams(a#0, 0) == class.int));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^1.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.this: $token;

const unique #tok$0^1.14: $token;

const unique #loc.a#0: $token;

implementation CheckWellformed$$_default.Cubes(this: ref, a#0: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#7: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^1.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^1.14, cev_parameter, #loc.a#0, a#0);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == a#0);
    assume a#0 != null;
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (0 <= i#7)
    {
        assert a#0 != null;
    }

    if (0 <= i#7 && i#7 < array.Length(a#0))
    {
        assert 0 <= i#7 && i#7 < array.Length(a#0);
    }

    assume (forall i#1: int :: 0 <= i#1 && i#1 < array.Length(a#0) ==> $Unbox(read($Heap, a#0, IndexField(i#1))): int == i#1 * i#1 * i#1);
}



procedure _default.Cubes(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, a#0: ref where a#0 == null || (read($Heap, a#0, alloc) && dtype(a#0) == class.array && TypeParams(a#0, 0) == class.int));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires a#0 != null;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^1.8;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures (forall i#1: int :: 0 <= i#1 && i#1 < array.Length(a#0) ==> $Unbox(read($Heap, a#0, IndexField(i#1))): int == i#1 * i#1 * i#1);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == a#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.n#2: $token;

const unique #tok$0^6.7: $token;

const unique #loc.c#3: $token;

const unique #tok$0^7.7: $token;

const unique #loc.k#4: $token;

const unique #tok$0^8.7: $token;

const unique #loc.m#5: $token;

const unique #tok$0^9.7: $token;

const unique #tok$0^10.3: $token;

const unique #tok$0^18.7: $token;

const unique #tok$0^19.7: $token;

const unique #tok$0^20.7: $token;

const unique #tok$0^21.7: $token;

implementation _default.Cubes(this: ref, a#0: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var n#2: int where #cev_var_update(#cev_pc, cev_local, #loc.n#2, n#2);
  var c#3: int where #cev_var_update(#cev_pc, cev_local, #loc.c#3, c#3);
  var k#4: int where #cev_var_update(#cev_pc, cev_local, #loc.k#4, k#4);
  var m#5: int where #cev_var_update(#cev_pc, cev_local, #loc.m#5, m#5);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^1.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^1.14, cev_parameter, #loc.a#0, a#0);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == a#0);
    // ----- var-declaration statement ----- dafny1\Cubes.dfy(6,7)
    assert true;
    assert true;
    n#2 := 0;
    assume {:captureState "dafny1\Cubes.dfy(6,7)"} true;
    call CevVarIntro(#tok$0^6.7, cev_local, #loc.n#2, n#2);
    // ----- var-declaration statement ----- dafny1\Cubes.dfy(7,7)
    assert true;
    assert true;
    c#3 := 0;
    assume {:captureState "dafny1\Cubes.dfy(7,7)"} true;
    call CevVarIntro(#tok$0^7.7, cev_local, #loc.c#3, c#3);
    // ----- var-declaration statement ----- dafny1\Cubes.dfy(8,7)
    assert true;
    assert true;
    k#4 := 1;
    assume {:captureState "dafny1\Cubes.dfy(8,7)"} true;
    call CevVarIntro(#tok$0^8.7, cev_local, #loc.k#4, k#4);
    // ----- var-declaration statement ----- dafny1\Cubes.dfy(9,7)
    assert true;
    assert true;
    m#5 := 6;
    assume {:captureState "dafny1\Cubes.dfy(9,7)"} true;
    call CevVarIntro(#tok$0^9.7, cev_local, #loc.m#5, m#5);
    // ----- while statement ----- dafny1\Cubes.dfy(10,3)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := array.Length(a#0) - n#2;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^10.3);
    while (true)
      invariant $w0 ==> n#2 <= array.Length(a#0);
      invariant $w0 ==> (forall i#6: int :: 0 <= i#6 && i#6 < n#2 ==> $Unbox(read($Heap, a#0, IndexField(i#6))): int == i#6 * i#6 * i#6);
      invariant $w0 ==> c#3 == n#2 * n#2 * n#2;
      invariant $w0 ==> k#4 == 3 * n#2 * n#2 + 3 * n#2 + 1;
      invariant $w0 ==> m#5 == 6 * n#2 + 6;
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f) || $o == a#0);
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant array.Length(a#0) - n#2 <= $decr0$init$0 && (array.Length(a#0) - n#2 == $decr0$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^10.3;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} a#0 != null;
            assume n#2 <= array.Length(a#0);
            assert {:subsumption 0} (forall i#6: int :: (0 <= i#6 ==> true) && (0 <= i#6 && i#6 < n#2 ==> 0 <= i#6 && i#6 < array.Length(a#0)));
            assume (forall i#6: int :: 0 <= i#6 && i#6 < n#2 ==> $Unbox(read($Heap, a#0, IndexField(i#6))): int == i#6 * i#6 * i#6);
            assert {:subsumption 0} true;
            assume c#3 == n#2 * n#2 * n#2;
            assert {:subsumption 0} true;
            assume k#4 == 3 * n#2 * n#2 + 3 * n#2 + 1;
            assert {:subsumption 0} true;
            assume m#5 == 6 * n#2 + 6;
            assert a#0 != null;
            assume false;
        }

        assert a#0 != null;
        if (n#2 >= array.Length(a#0))
        {
            break;
        }

        call CevStepEvent(#tok$0^10.3, loop_entered);
        assume {:captureState "dafny1\Cubes.dfy(10,3): loop entered"} true;
        $decr0$0 := array.Length(a#0) - n#2;
        // ----- assignment statement ----- dafny1\Cubes.dfy(17,10)
        assert 0 <= n#2 && n#2 < array.Length(a#0);
        assert true;
        assert $_Frame[a#0, IndexField(n#2)];
        $Heap := update($Heap, a#0, IndexField(n#2), $Box(c#3));
        assume $IsGoodHeap($Heap);
        assume {:captureState "dafny1\Cubes.dfy(17,10)"} true;
        // ----- assignment statement ----- dafny1\Cubes.dfy(18,7)
        assert true;
        assert true;
        c#3 := c#3 + k#4;
        assume {:captureState "dafny1\Cubes.dfy(18,7)"} true;
        call CevUpdate(#tok$0^18.7, #loc.c#3, c#3);
        // ----- assignment statement ----- dafny1\Cubes.dfy(19,7)
        assert true;
        assert true;
        k#4 := k#4 + m#5;
        assume {:captureState "dafny1\Cubes.dfy(19,7)"} true;
        call CevUpdate(#tok$0^19.7, #loc.k#4, k#4);
        // ----- assignment statement ----- dafny1\Cubes.dfy(20,7)
        assert true;
        assert true;
        m#5 := m#5 + 6;
        assume {:captureState "dafny1\Cubes.dfy(20,7)"} true;
        call CevUpdate(#tok$0^20.7, #loc.m#5, m#5);
        // ----- assignment statement ----- dafny1\Cubes.dfy(21,7)
        assert true;
        assert true;
        n#2 := n#2 + 1;
        assume {:captureState "dafny1\Cubes.dfy(21,7)"} true;
        call CevUpdate(#tok$0^21.7, #loc.n#2, n#2);
        assert 0 <= $decr0$0 || array.Length(a#0) - n#2 == $decr0$0;
        assert array.Length(a#0) - n#2 < $decr0$0;
    }

    call CevStepEvent(#tok$0^10.3, loop_exited);
    assume {:captureState "dafny1\Cubes.dfy(10,3): loop exit"} true;
}


