// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: dafny1\ListContents.dfy /print:\Users\philipp\Desktop\boogie\boogie-k-induction-benchmarks\benchmarks\ListContents.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class.Node: ClassName;

axiom FDim(Node.list) == 0 && DeclType(Node.list) == class.Node;

const unique Node.list: Field (Seq BoxType);

axiom FDim(Node.footprint) == 0 && DeclType(Node.footprint) == class.Node;

const unique Node.footprint: Field (Set BoxType);

axiom (forall $h: HeapType, $o: ref, $t: BoxType :: { read($h, $o, Node.footprint)[$t] } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) && read($h, $o, Node.footprint)[$t] ==> $Unbox($t): ref == null || (read($h, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node));

axiom FDim(Node.data) == 0 && DeclType(Node.data) == class.Node;

const unique Node.data: Field BoxType;

axiom FDim(Node.next) == 0 && DeclType(Node.next) == class.Node;

const unique Node.next: Field ref;

axiom (forall $h: HeapType, $o: ref :: { read($h, $o, Node.next) } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) ==> read($h, $o, Node.next) == null || (read($h, read($h, $o, Node.next), alloc) && dtype(read($h, $o, Node.next)) == class.Node));

function Node.Valid($heap: HeapType, this: ref) : bool;

function Node.Valid#limited($heap: HeapType, this: ref) : bool;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (0 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref :: { Node.Valid($Heap, this) } $IsGoodHeap($Heap) && this != null ==> Node.Valid($Heap, this) == (read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid#limited($Heap, read($Heap, this, Node.next)))));

axiom (forall $Heap: HeapType, this: ref :: { Node.Valid($Heap, this) } Node.Valid($Heap, this) == Node.Valid#limited($Heap, this));

// frame axiom for Node.Valid
axiom (forall $h0: HeapType, $h1: HeapType, this: ref :: { $HeapSucc($h0, $h1), Node.Valid($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Node && read($h1, this, alloc) && dtype(this) == class.Node && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && ($o == this || read($h0, this, Node.footprint)[$Box($o)]) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Node.Valid($h0, this) == Node.Valid($h1, this));

axiom (forall $h0: HeapType, $h1: HeapType, this: ref :: { $HeapSucc($h0, $h1), Node.Valid#limited($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Node && read($h1, this, alloc) && dtype(this) == class.Node && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && ($o == this || read($h0, this, Node.footprint)[$Box($o)]) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Node.Valid#limited($h0, this) == Node.Valid#limited($h1, this));

procedure CheckWellformed$$Node.Valid(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Node);
  free requires 0 == $ModuleContextHeight && 0 == $FunctionContextHeight;



implementation CheckWellformed$$Node.Valid(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || read($Heap, this, Node.footprint)[$Box($o)]);
    assert $_Frame[this, Node.footprint];
    if (read($Heap, this, Node.footprint)[$Box(this)])
    {
        assert $_Frame[this, Node.footprint];
    }

    if (read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)])
    {
        assert $_Frame[this, Node.next];
        if (read($Heap, this, Node.next) == null)
        {
            assert $_Frame[this, Node.list];
            assert $_Frame[this, Node.data];
        }
    }

    if (read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))))
    {
        assert $_Frame[this, Node.next];
        if (read($Heap, this, Node.next) != null)
        {
            assert $_Frame[this, Node.next];
            assert $_Frame[this, Node.footprint];
            if (read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))])
            {
                assert $_Frame[this, Node.next];
                assert read($Heap, this, Node.next) != null;
                assert $_Frame[read($Heap, this, Node.next), Node.footprint];
                assert $_Frame[this, Node.footprint];
            }

            if (read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)))
            {
                assert $_Frame[this, Node.next];
                assert read($Heap, this, Node.next) != null;
                assert $_Frame[read($Heap, this, Node.next), Node.footprint];
            }

            if (read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)])
            {
                assert $_Frame[this, Node.list];
                assert $_Frame[this, Node.data];
                assert $_Frame[this, Node.next];
                assert read($Heap, this, Node.next) != null;
                assert $_Frame[read($Heap, this, Node.next), Node.list];
            }

            if (read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))))
            {
                assert $_Frame[this, Node.next];
                assert read($Heap, this, Node.next) != null;
                assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && ($o == read($Heap, this, Node.next) || (read($Heap, this, Node.next) != null && read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box($o)])) ==> $_Frame[$o, $f]);
                assert Set#Subset(Set#Union(read($Heap, read($Heap, this, Node.next), Node.footprint), Set#UnionOne(Set#Empty(): Set BoxType, $Box(read($Heap, this, Node.next)))), Set#Union(read($Heap, this, Node.footprint), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))) && !Set#Subset(Set#Union(read($Heap, this, Node.footprint), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))), Set#Union(read($Heap, read($Heap, this, Node.next), Node.footprint), Set#UnionOne(Set#Empty(): Set BoxType, $Box(read($Heap, this, Node.next)))));
            }
        }
    }
}



const unique xxxxxxxxxfile: $token;

axiom $file_name_is(0, xxxxxxxxxfile);

const unique #tok$0^20.10: $token;

procedure CheckWellformed$$Node.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Node, d#0: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^20.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.this: $token;

const unique #tok$0^20.15: $token;

const unique #loc.d#0: $token;

implementation CheckWellformed$$Node.Init(this: ref, d#0: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^20.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^20.15, cev_parameter, #loc.d#0, d#0);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (Node.Valid($Heap, this))
    {
    }

    assume Node.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, Node.footprint)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc));
    assume Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, d#0, 1));
}



procedure Node.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Node, d#0: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^20.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures Node.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, Node.footprint)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc));
  free ensures Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)));
  ensures (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.footprint)[$Box(this)];
  ensures (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> !read($Heap, this, Node.footprint)[$Box(null)];
  ensures (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1));
  ensures (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))];
  ensures (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint));
  ensures (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)];
  ensures (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list)));
  ensures (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> Node.Valid($Heap, read($Heap, this, Node.next));
  ensures (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> (forall $o: ref :: $o != null && read($Heap, this, Node.footprint)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc));
  ensures Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, d#0, 1));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^25.10: $token;

const unique #tok$0^26.10: $token;

const unique #tok$0^27.10: $token;

const unique #tok$0^28.15: $token;

implementation Node.Init(this: ref, d#0: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^20.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^20.15, cev_parameter, #loc.d#0, d#0);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    // ----- assignment statement ----- dafny1\ListContents.dfy(25,10)
    assert true;
    assert true;
    assert $_Frame[this, Node.data];
    $Heap := update($Heap, this, Node.data, d#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\ListContents.dfy(25,10)"} true;
    call CevUpdateHeap(#tok$0^25.10, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\ListContents.dfy(26,10)
    assert true;
    assert true;
    assert $_Frame[this, Node.next];
    $Heap := update($Heap, this, Node.next, null);
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\ListContents.dfy(26,10)"} true;
    call CevUpdateHeap(#tok$0^26.10, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\ListContents.dfy(27,10)
    assert true;
    assert true;
    assert $_Frame[this, Node.list];
    $Heap := update($Heap, this, Node.list, Seq#Build(Seq#Empty(): Seq BoxType, 0, d#0, 1));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\ListContents.dfy(27,10)"} true;
    call CevUpdateHeap(#tok$0^27.10, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\ListContents.dfy(28,15)
    assert true;
    assert true;
    assert $_Frame[this, Node.footprint];
    $Heap := update($Heap, this, Node.footprint, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\ListContents.dfy(28,15)"} true;
    call CevUpdateHeap(#tok$0^28.15, #loc.$Heap, $Heap);
}



const unique #tok$0^31.10: $token;

procedure CheckWellformed$$Node.SkipHead(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Node) returns (r#1: ref where r#1 == null || (read($Heap, r#1, alloc) && dtype(r#1) == class.Node));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^31.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^31.30: $token;

const unique #loc.r#1: $token;

implementation CheckWellformed$$Node.SkipHead(this: ref) returns (r#1: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^31.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^31.30, cev_local, #loc.r#1, r#1);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume Node.Valid($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc r#1;
    if (r#1 == null)
    {
    }

    assume r#1 == null ==> Seq#Length(read($Heap, this, Node.list)) == 1;
    if (r#1 != null)
    {
        assert r#1 != null;
        if (Node.Valid($Heap, r#1))
        {
            assert r#1 != null;
        }
    }

    assume r#1 != null ==> Node.Valid($Heap, r#1) && Set#Subset(read($Heap, r#1, Node.footprint), read($Heap, this, Node.footprint));
    if (r#1 != null)
    {
        assert r#1 != null;
        assert 0 <= 1 && 1 <= Seq#Length(read($Heap, this, Node.list));
    }

    assume r#1 != null ==> Seq#Equal(read($Heap, r#1, Node.list), Seq#Drop(read($Heap, this, Node.list), 1));
}



procedure Node.SkipHead(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Node) returns (r#1: ref where r#1 == null || (read($Heap, r#1, alloc) && dtype(r#1) == class.Node));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires Node.Valid($Heap, this);
  free requires Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)));
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.footprint)[$Box(this)];
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> !read($Heap, this, Node.footprint)[$Box(null)];
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1));
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))];
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint));
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)];
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list)));
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> Node.Valid($Heap, read($Heap, this, Node.next));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^31.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures r#1 == null ==> Seq#Length(read($Heap, this, Node.list)) == 1;
  free ensures r#1 != null ==> Node.Valid($Heap, r#1) && Set#Subset(read($Heap, r#1, Node.footprint), read($Heap, this, Node.footprint));
  free ensures Node.Valid($Heap, r#1) ==> read($Heap, r#1, Node.footprint)[$Box(r#1)] && !read($Heap, r#1, Node.footprint)[$Box(null)] && (read($Heap, r#1, Node.next) == null ==> Seq#Equal(read($Heap, r#1, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1))) && (read($Heap, r#1, Node.next) != null ==> read($Heap, r#1, Node.footprint)[$Box(read($Heap, r#1, Node.next))] && Set#Subset(read($Heap, read($Heap, r#1, Node.next), Node.footprint), read($Heap, r#1, Node.footprint)) && !read($Heap, read($Heap, r#1, Node.next), Node.footprint)[$Box(r#1)] && Seq#Equal(read($Heap, r#1, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1), read($Heap, read($Heap, r#1, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#1, Node.next)));
  ensures (Node.Valid($Heap, r#1) ==> read($Heap, r#1, Node.footprint)[$Box(r#1)] && !read($Heap, r#1, Node.footprint)[$Box(null)] && (read($Heap, r#1, Node.next) == null ==> Seq#Equal(read($Heap, r#1, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1))) && (read($Heap, r#1, Node.next) != null ==> read($Heap, r#1, Node.footprint)[$Box(read($Heap, r#1, Node.next))] && Set#Subset(read($Heap, read($Heap, r#1, Node.next), Node.footprint), read($Heap, r#1, Node.footprint)) && !read($Heap, read($Heap, r#1, Node.next), Node.footprint)[$Box(r#1)] && Seq#Equal(read($Heap, r#1, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1), read($Heap, read($Heap, r#1, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#1, Node.next)))) ==> r#1 != null ==> read($Heap, r#1, Node.footprint)[$Box(r#1)];
  ensures (Node.Valid($Heap, r#1) ==> read($Heap, r#1, Node.footprint)[$Box(r#1)] && !read($Heap, r#1, Node.footprint)[$Box(null)] && (read($Heap, r#1, Node.next) == null ==> Seq#Equal(read($Heap, r#1, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1))) && (read($Heap, r#1, Node.next) != null ==> read($Heap, r#1, Node.footprint)[$Box(read($Heap, r#1, Node.next))] && Set#Subset(read($Heap, read($Heap, r#1, Node.next), Node.footprint), read($Heap, r#1, Node.footprint)) && !read($Heap, read($Heap, r#1, Node.next), Node.footprint)[$Box(r#1)] && Seq#Equal(read($Heap, r#1, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1), read($Heap, read($Heap, r#1, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#1, Node.next)))) ==> r#1 != null ==> !read($Heap, r#1, Node.footprint)[$Box(null)];
  ensures (Node.Valid($Heap, r#1) ==> read($Heap, r#1, Node.footprint)[$Box(r#1)] && !read($Heap, r#1, Node.footprint)[$Box(null)] && (read($Heap, r#1, Node.next) == null ==> Seq#Equal(read($Heap, r#1, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1))) && (read($Heap, r#1, Node.next) != null ==> read($Heap, r#1, Node.footprint)[$Box(read($Heap, r#1, Node.next))] && Set#Subset(read($Heap, read($Heap, r#1, Node.next), Node.footprint), read($Heap, r#1, Node.footprint)) && !read($Heap, read($Heap, r#1, Node.next), Node.footprint)[$Box(r#1)] && Seq#Equal(read($Heap, r#1, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1), read($Heap, read($Heap, r#1, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#1, Node.next)))) ==> r#1 != null ==> read($Heap, r#1, Node.next) == null ==> Seq#Equal(read($Heap, r#1, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1));
  ensures (Node.Valid($Heap, r#1) ==> read($Heap, r#1, Node.footprint)[$Box(r#1)] && !read($Heap, r#1, Node.footprint)[$Box(null)] && (read($Heap, r#1, Node.next) == null ==> Seq#Equal(read($Heap, r#1, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1))) && (read($Heap, r#1, Node.next) != null ==> read($Heap, r#1, Node.footprint)[$Box(read($Heap, r#1, Node.next))] && Set#Subset(read($Heap, read($Heap, r#1, Node.next), Node.footprint), read($Heap, r#1, Node.footprint)) && !read($Heap, read($Heap, r#1, Node.next), Node.footprint)[$Box(r#1)] && Seq#Equal(read($Heap, r#1, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1), read($Heap, read($Heap, r#1, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#1, Node.next)))) ==> r#1 != null ==> read($Heap, r#1, Node.next) != null ==> read($Heap, r#1, Node.footprint)[$Box(read($Heap, r#1, Node.next))];
  ensures (Node.Valid($Heap, r#1) ==> read($Heap, r#1, Node.footprint)[$Box(r#1)] && !read($Heap, r#1, Node.footprint)[$Box(null)] && (read($Heap, r#1, Node.next) == null ==> Seq#Equal(read($Heap, r#1, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1))) && (read($Heap, r#1, Node.next) != null ==> read($Heap, r#1, Node.footprint)[$Box(read($Heap, r#1, Node.next))] && Set#Subset(read($Heap, read($Heap, r#1, Node.next), Node.footprint), read($Heap, r#1, Node.footprint)) && !read($Heap, read($Heap, r#1, Node.next), Node.footprint)[$Box(r#1)] && Seq#Equal(read($Heap, r#1, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1), read($Heap, read($Heap, r#1, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#1, Node.next)))) ==> r#1 != null ==> read($Heap, r#1, Node.next) != null ==> Set#Subset(read($Heap, read($Heap, r#1, Node.next), Node.footprint), read($Heap, r#1, Node.footprint));
  ensures (Node.Valid($Heap, r#1) ==> read($Heap, r#1, Node.footprint)[$Box(r#1)] && !read($Heap, r#1, Node.footprint)[$Box(null)] && (read($Heap, r#1, Node.next) == null ==> Seq#Equal(read($Heap, r#1, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1))) && (read($Heap, r#1, Node.next) != null ==> read($Heap, r#1, Node.footprint)[$Box(read($Heap, r#1, Node.next))] && Set#Subset(read($Heap, read($Heap, r#1, Node.next), Node.footprint), read($Heap, r#1, Node.footprint)) && !read($Heap, read($Heap, r#1, Node.next), Node.footprint)[$Box(r#1)] && Seq#Equal(read($Heap, r#1, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1), read($Heap, read($Heap, r#1, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#1, Node.next)))) ==> r#1 != null ==> read($Heap, r#1, Node.next) != null ==> !read($Heap, read($Heap, r#1, Node.next), Node.footprint)[$Box(r#1)];
  ensures (Node.Valid($Heap, r#1) ==> read($Heap, r#1, Node.footprint)[$Box(r#1)] && !read($Heap, r#1, Node.footprint)[$Box(null)] && (read($Heap, r#1, Node.next) == null ==> Seq#Equal(read($Heap, r#1, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1))) && (read($Heap, r#1, Node.next) != null ==> read($Heap, r#1, Node.footprint)[$Box(read($Heap, r#1, Node.next))] && Set#Subset(read($Heap, read($Heap, r#1, Node.next), Node.footprint), read($Heap, r#1, Node.footprint)) && !read($Heap, read($Heap, r#1, Node.next), Node.footprint)[$Box(r#1)] && Seq#Equal(read($Heap, r#1, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1), read($Heap, read($Heap, r#1, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#1, Node.next)))) ==> r#1 != null ==> read($Heap, r#1, Node.next) != null ==> Seq#Equal(read($Heap, r#1, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1), read($Heap, read($Heap, r#1, Node.next), Node.list)));
  ensures (Node.Valid($Heap, r#1) ==> read($Heap, r#1, Node.footprint)[$Box(r#1)] && !read($Heap, r#1, Node.footprint)[$Box(null)] && (read($Heap, r#1, Node.next) == null ==> Seq#Equal(read($Heap, r#1, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1))) && (read($Heap, r#1, Node.next) != null ==> read($Heap, r#1, Node.footprint)[$Box(read($Heap, r#1, Node.next))] && Set#Subset(read($Heap, read($Heap, r#1, Node.next), Node.footprint), read($Heap, r#1, Node.footprint)) && !read($Heap, read($Heap, r#1, Node.next), Node.footprint)[$Box(r#1)] && Seq#Equal(read($Heap, r#1, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1), read($Heap, read($Heap, r#1, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#1, Node.next)))) ==> r#1 != null ==> read($Heap, r#1, Node.next) != null ==> Node.Valid($Heap, read($Heap, r#1, Node.next));
  ensures (Node.Valid($Heap, r#1) ==> read($Heap, r#1, Node.footprint)[$Box(r#1)] && !read($Heap, r#1, Node.footprint)[$Box(null)] && (read($Heap, r#1, Node.next) == null ==> Seq#Equal(read($Heap, r#1, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1))) && (read($Heap, r#1, Node.next) != null ==> read($Heap, r#1, Node.footprint)[$Box(read($Heap, r#1, Node.next))] && Set#Subset(read($Heap, read($Heap, r#1, Node.next), Node.footprint), read($Heap, r#1, Node.footprint)) && !read($Heap, read($Heap, r#1, Node.next), Node.footprint)[$Box(r#1)] && Seq#Equal(read($Heap, r#1, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#1, Node.data), 1), read($Heap, read($Heap, r#1, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#1, Node.next)))) ==> r#1 != null ==> Set#Subset(read($Heap, r#1, Node.footprint), read($Heap, this, Node.footprint));
  ensures r#1 != null ==> Seq#Equal(read($Heap, r#1, Node.list), Seq#Drop(read($Heap, this, Node.list), 1));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^37.7: $token;

implementation Node.SkipHead(this: ref) returns (r#1: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^31.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^31.30, cev_local, #loc.r#1, r#1);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- assignment statement ----- dafny1\ListContents.dfy(37,7)
    assert true;
    assert true;
    r#1 := read($Heap, this, Node.next);
    assume {:captureState "dafny1\ListContents.dfy(37,7)"} true;
    call CevUpdate(#tok$0^37.7, #loc.r#1, r#1);
}



const unique #tok$0^40.10: $token;

procedure CheckWellformed$$Node.Prepend(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Node, d#2: BoxType) returns (r#3: ref where r#3 == null || (read($Heap, r#3, alloc) && dtype(r#3) == class.Node));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^40.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^40.18: $token;

const unique #loc.d#2: $token;

const unique #tok$0^40.33: $token;

const unique #loc.r#3: $token;

implementation CheckWellformed$$Node.Prepend(this: ref, d#2: BoxType) returns (r#3: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^40.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^40.18, cev_parameter, #loc.d#2, d#2);
    call CevVarIntro(#tok$0^40.33, cev_local, #loc.r#3, r#3);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume Node.Valid($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc r#3;
    if (r#3 != null)
    {
        assert r#3 != null;
    }

    if (r#3 != null && Node.Valid($Heap, r#3))
    {
        assert r#3 != null;
    }

    assume r#3 != null && Node.Valid($Heap, r#3) && (forall $o: ref :: $o != null && read($Heap, r#3, Node.footprint)[$Box($o)] && !old(read($Heap, this, Node.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
    assert r#3 != null;
    assume Seq#Equal(read($Heap, r#3, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, d#2, 1), read($Heap, this, Node.list)));
}



procedure Node.Prepend(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Node, d#2: BoxType) returns (r#3: ref where r#3 == null || (read($Heap, r#3, alloc) && dtype(r#3) == class.Node));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires Node.Valid($Heap, this);
  free requires Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)));
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.footprint)[$Box(this)];
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> !read($Heap, this, Node.footprint)[$Box(null)];
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1));
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))];
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint));
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)];
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list)));
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> Node.Valid($Heap, read($Heap, this, Node.next));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^40.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures r#3 != null && Node.Valid($Heap, r#3) && (forall $o: ref :: $o != null && read($Heap, r#3, Node.footprint)[$Box($o)] && !old(read($Heap, this, Node.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  free ensures Node.Valid($Heap, r#3) ==> read($Heap, r#3, Node.footprint)[$Box(r#3)] && !read($Heap, r#3, Node.footprint)[$Box(null)] && (read($Heap, r#3, Node.next) == null ==> Seq#Equal(read($Heap, r#3, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1))) && (read($Heap, r#3, Node.next) != null ==> read($Heap, r#3, Node.footprint)[$Box(read($Heap, r#3, Node.next))] && Set#Subset(read($Heap, read($Heap, r#3, Node.next), Node.footprint), read($Heap, r#3, Node.footprint)) && !read($Heap, read($Heap, r#3, Node.next), Node.footprint)[$Box(r#3)] && Seq#Equal(read($Heap, r#3, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1), read($Heap, read($Heap, r#3, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#3, Node.next)));
  ensures (Node.Valid($Heap, r#3) ==> read($Heap, r#3, Node.footprint)[$Box(r#3)] && !read($Heap, r#3, Node.footprint)[$Box(null)] && (read($Heap, r#3, Node.next) == null ==> Seq#Equal(read($Heap, r#3, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1))) && (read($Heap, r#3, Node.next) != null ==> read($Heap, r#3, Node.footprint)[$Box(read($Heap, r#3, Node.next))] && Set#Subset(read($Heap, read($Heap, r#3, Node.next), Node.footprint), read($Heap, r#3, Node.footprint)) && !read($Heap, read($Heap, r#3, Node.next), Node.footprint)[$Box(r#3)] && Seq#Equal(read($Heap, r#3, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1), read($Heap, read($Heap, r#3, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#3, Node.next)))) ==> r#3 != null;
  ensures (Node.Valid($Heap, r#3) ==> read($Heap, r#3, Node.footprint)[$Box(r#3)] && !read($Heap, r#3, Node.footprint)[$Box(null)] && (read($Heap, r#3, Node.next) == null ==> Seq#Equal(read($Heap, r#3, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1))) && (read($Heap, r#3, Node.next) != null ==> read($Heap, r#3, Node.footprint)[$Box(read($Heap, r#3, Node.next))] && Set#Subset(read($Heap, read($Heap, r#3, Node.next), Node.footprint), read($Heap, r#3, Node.footprint)) && !read($Heap, read($Heap, r#3, Node.next), Node.footprint)[$Box(r#3)] && Seq#Equal(read($Heap, r#3, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1), read($Heap, read($Heap, r#3, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#3, Node.next)))) ==> read($Heap, r#3, Node.footprint)[$Box(r#3)];
  ensures (Node.Valid($Heap, r#3) ==> read($Heap, r#3, Node.footprint)[$Box(r#3)] && !read($Heap, r#3, Node.footprint)[$Box(null)] && (read($Heap, r#3, Node.next) == null ==> Seq#Equal(read($Heap, r#3, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1))) && (read($Heap, r#3, Node.next) != null ==> read($Heap, r#3, Node.footprint)[$Box(read($Heap, r#3, Node.next))] && Set#Subset(read($Heap, read($Heap, r#3, Node.next), Node.footprint), read($Heap, r#3, Node.footprint)) && !read($Heap, read($Heap, r#3, Node.next), Node.footprint)[$Box(r#3)] && Seq#Equal(read($Heap, r#3, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1), read($Heap, read($Heap, r#3, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#3, Node.next)))) ==> !read($Heap, r#3, Node.footprint)[$Box(null)];
  ensures (Node.Valid($Heap, r#3) ==> read($Heap, r#3, Node.footprint)[$Box(r#3)] && !read($Heap, r#3, Node.footprint)[$Box(null)] && (read($Heap, r#3, Node.next) == null ==> Seq#Equal(read($Heap, r#3, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1))) && (read($Heap, r#3, Node.next) != null ==> read($Heap, r#3, Node.footprint)[$Box(read($Heap, r#3, Node.next))] && Set#Subset(read($Heap, read($Heap, r#3, Node.next), Node.footprint), read($Heap, r#3, Node.footprint)) && !read($Heap, read($Heap, r#3, Node.next), Node.footprint)[$Box(r#3)] && Seq#Equal(read($Heap, r#3, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1), read($Heap, read($Heap, r#3, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#3, Node.next)))) ==> read($Heap, r#3, Node.next) == null ==> Seq#Equal(read($Heap, r#3, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1));
  ensures (Node.Valid($Heap, r#3) ==> read($Heap, r#3, Node.footprint)[$Box(r#3)] && !read($Heap, r#3, Node.footprint)[$Box(null)] && (read($Heap, r#3, Node.next) == null ==> Seq#Equal(read($Heap, r#3, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1))) && (read($Heap, r#3, Node.next) != null ==> read($Heap, r#3, Node.footprint)[$Box(read($Heap, r#3, Node.next))] && Set#Subset(read($Heap, read($Heap, r#3, Node.next), Node.footprint), read($Heap, r#3, Node.footprint)) && !read($Heap, read($Heap, r#3, Node.next), Node.footprint)[$Box(r#3)] && Seq#Equal(read($Heap, r#3, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1), read($Heap, read($Heap, r#3, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#3, Node.next)))) ==> read($Heap, r#3, Node.next) != null ==> read($Heap, r#3, Node.footprint)[$Box(read($Heap, r#3, Node.next))];
  ensures (Node.Valid($Heap, r#3) ==> read($Heap, r#3, Node.footprint)[$Box(r#3)] && !read($Heap, r#3, Node.footprint)[$Box(null)] && (read($Heap, r#3, Node.next) == null ==> Seq#Equal(read($Heap, r#3, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1))) && (read($Heap, r#3, Node.next) != null ==> read($Heap, r#3, Node.footprint)[$Box(read($Heap, r#3, Node.next))] && Set#Subset(read($Heap, read($Heap, r#3, Node.next), Node.footprint), read($Heap, r#3, Node.footprint)) && !read($Heap, read($Heap, r#3, Node.next), Node.footprint)[$Box(r#3)] && Seq#Equal(read($Heap, r#3, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1), read($Heap, read($Heap, r#3, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#3, Node.next)))) ==> read($Heap, r#3, Node.next) != null ==> Set#Subset(read($Heap, read($Heap, r#3, Node.next), Node.footprint), read($Heap, r#3, Node.footprint));
  ensures (Node.Valid($Heap, r#3) ==> read($Heap, r#3, Node.footprint)[$Box(r#3)] && !read($Heap, r#3, Node.footprint)[$Box(null)] && (read($Heap, r#3, Node.next) == null ==> Seq#Equal(read($Heap, r#3, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1))) && (read($Heap, r#3, Node.next) != null ==> read($Heap, r#3, Node.footprint)[$Box(read($Heap, r#3, Node.next))] && Set#Subset(read($Heap, read($Heap, r#3, Node.next), Node.footprint), read($Heap, r#3, Node.footprint)) && !read($Heap, read($Heap, r#3, Node.next), Node.footprint)[$Box(r#3)] && Seq#Equal(read($Heap, r#3, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1), read($Heap, read($Heap, r#3, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#3, Node.next)))) ==> read($Heap, r#3, Node.next) != null ==> !read($Heap, read($Heap, r#3, Node.next), Node.footprint)[$Box(r#3)];
  ensures (Node.Valid($Heap, r#3) ==> read($Heap, r#3, Node.footprint)[$Box(r#3)] && !read($Heap, r#3, Node.footprint)[$Box(null)] && (read($Heap, r#3, Node.next) == null ==> Seq#Equal(read($Heap, r#3, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1))) && (read($Heap, r#3, Node.next) != null ==> read($Heap, r#3, Node.footprint)[$Box(read($Heap, r#3, Node.next))] && Set#Subset(read($Heap, read($Heap, r#3, Node.next), Node.footprint), read($Heap, r#3, Node.footprint)) && !read($Heap, read($Heap, r#3, Node.next), Node.footprint)[$Box(r#3)] && Seq#Equal(read($Heap, r#3, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1), read($Heap, read($Heap, r#3, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#3, Node.next)))) ==> read($Heap, r#3, Node.next) != null ==> Seq#Equal(read($Heap, r#3, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1), read($Heap, read($Heap, r#3, Node.next), Node.list)));
  ensures (Node.Valid($Heap, r#3) ==> read($Heap, r#3, Node.footprint)[$Box(r#3)] && !read($Heap, r#3, Node.footprint)[$Box(null)] && (read($Heap, r#3, Node.next) == null ==> Seq#Equal(read($Heap, r#3, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1))) && (read($Heap, r#3, Node.next) != null ==> read($Heap, r#3, Node.footprint)[$Box(read($Heap, r#3, Node.next))] && Set#Subset(read($Heap, read($Heap, r#3, Node.next), Node.footprint), read($Heap, r#3, Node.footprint)) && !read($Heap, read($Heap, r#3, Node.next), Node.footprint)[$Box(r#3)] && Seq#Equal(read($Heap, r#3, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1), read($Heap, read($Heap, r#3, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#3, Node.next)))) ==> read($Heap, r#3, Node.next) != null ==> Node.Valid($Heap, read($Heap, r#3, Node.next));
  ensures (Node.Valid($Heap, r#3) ==> read($Heap, r#3, Node.footprint)[$Box(r#3)] && !read($Heap, r#3, Node.footprint)[$Box(null)] && (read($Heap, r#3, Node.next) == null ==> Seq#Equal(read($Heap, r#3, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1))) && (read($Heap, r#3, Node.next) != null ==> read($Heap, r#3, Node.footprint)[$Box(read($Heap, r#3, Node.next))] && Set#Subset(read($Heap, read($Heap, r#3, Node.next), Node.footprint), read($Heap, r#3, Node.footprint)) && !read($Heap, read($Heap, r#3, Node.next), Node.footprint)[$Box(r#3)] && Seq#Equal(read($Heap, r#3, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1), read($Heap, read($Heap, r#3, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, r#3, Node.next)))) ==> (forall $o: ref :: $o != null && read($Heap, r#3, Node.footprint)[$Box($o)] && !old(read($Heap, this, Node.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  ensures Seq#Equal(read($Heap, r#3, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, d#2, 1), read($Heap, this, Node.list)));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^45.7: $token;

const unique #tok$0^46.12: $token;

const unique #tok$0^47.12: $token;

const unique #tok$0^48.17: $token;

const unique #tok$0^49.12: $token;

implementation Node.Prepend(this: ref, d#2: BoxType) returns (r#3: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $nw: ref;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^40.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^40.18, cev_parameter, #loc.d#2, d#2);
    call CevVarIntro(#tok$0^40.33, cev_local, #loc.r#3, r#3);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- assignment statement ----- dafny1\ListContents.dfy(45,7)
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.Node;
    $Heap := update($Heap, $nw, alloc, true);
    r#3 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\ListContents.dfy(45,7)"} true;
    call CevUpdate(#tok$0^45.7, #loc.r#3, r#3);
    // ----- assignment statement ----- dafny1\ListContents.dfy(46,12)
    assert r#3 != null;
    assert true;
    assert $_Frame[r#3, Node.data];
    $Heap := update($Heap, r#3, Node.data, d#2);
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\ListContents.dfy(46,12)"} true;
    call CevUpdateHeap(#tok$0^46.12, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\ListContents.dfy(47,12)
    assert r#3 != null;
    assert true;
    assert $_Frame[r#3, Node.next];
    $Heap := update($Heap, r#3, Node.next, this);
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\ListContents.dfy(47,12)"} true;
    call CevUpdateHeap(#tok$0^47.12, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\ListContents.dfy(48,17)
    assert r#3 != null;
    assert true;
    assert $_Frame[r#3, Node.footprint];
    $Heap := update($Heap, r#3, Node.footprint, Set#Union(Set#UnionOne(Set#Empty(): Set BoxType, $Box(r#3)), read($Heap, this, Node.footprint)));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\ListContents.dfy(48,17)"} true;
    call CevUpdateHeap(#tok$0^48.17, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\ListContents.dfy(49,12)
    assert r#3 != null;
    assert r#3 != null;
    assert $_Frame[r#3, Node.list];
    $Heap := update($Heap, r#3, Node.list, Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, r#3, Node.data), 1), read($Heap, this, Node.list)));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\ListContents.dfy(49,12)"} true;
    call CevUpdateHeap(#tok$0^49.12, #loc.$Heap, $Heap);
}



const unique #tok$0^52.10: $token;

procedure CheckWellformed$$Node.ReverseInPlace(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Node) returns (reverse#4: ref where reverse#4 == null || (read($Heap, reverse#4, alloc) && dtype(reverse#4) == class.Node));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^52.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^52.36: $token;

const unique #loc.reverse#4: $token;

implementation CheckWellformed$$Node.ReverseInPlace(this: ref) returns (reverse#4: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#10: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^52.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^52.36, cev_local, #loc.reverse#4, reverse#4);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, Node.footprint)[$Box($o)]);
    assume Node.Valid($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc reverse#4;
    if (reverse#4 != null)
    {
        assert reverse#4 != null;
    }

    assume reverse#4 != null && Node.Valid($Heap, reverse#4);
    assert reverse#4 != null;
    assume (forall $o: ref :: $o != null && read($Heap, reverse#4, Node.footprint)[$Box($o)] && !old(read($Heap, this, Node.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
    assert reverse#4 != null;
    assume Seq#Length(read($Heap, reverse#4, Node.list)) == Seq#Length(old(read($Heap, this, Node.list)));
    if (0 <= i#10)
    {
    }

    if (0 <= i#10 && i#10 < Seq#Length(old(read($Heap, this, Node.list))))
    {
        assert 0 <= i#10 && i#10 < Seq#Length(old(read($Heap, this, Node.list)));
        assert reverse#4 != null;
        assert 0 <= Seq#Length(old(read($Heap, this, Node.list))) - 1 - i#10 && Seq#Length(old(read($Heap, this, Node.list))) - 1 - i#10 < Seq#Length(read($Heap, reverse#4, Node.list));
    }

    assume (forall i#5: int :: 0 <= i#5 && i#5 < Seq#Length(old(read($Heap, this, Node.list))) ==> Seq#Index(old(read($Heap, this, Node.list)), i#5) == Seq#Index(read($Heap, reverse#4, Node.list), Seq#Length(old(read($Heap, this, Node.list))) - 1 - i#5));
}



procedure Node.ReverseInPlace(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Node) returns (reverse#4: ref where reverse#4 == null || (read($Heap, reverse#4, alloc) && dtype(reverse#4) == class.Node));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires Node.Valid($Heap, this);
  free requires Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)));
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.footprint)[$Box(this)];
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> !read($Heap, this, Node.footprint)[$Box(null)];
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1));
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))];
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint));
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)];
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list)));
  requires (Node.Valid($Heap, this) ==> read($Heap, this, Node.footprint)[$Box(this)] && !read($Heap, this, Node.footprint)[$Box(null)] && (read($Heap, this, Node.next) == null ==> Seq#Equal(read($Heap, this, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1))) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.footprint)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.footprint), read($Heap, this, Node.footprint)) && !read($Heap, read($Heap, this, Node.next), Node.footprint)[$Box(this)] && Seq#Equal(read($Heap, this, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1), read($Heap, read($Heap, this, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, this, Node.next)))) ==> read($Heap, this, Node.next) != null ==> Node.Valid($Heap, read($Heap, this, Node.next));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^52.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures reverse#4 != null && Node.Valid($Heap, reverse#4);
  free ensures Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)));
  ensures (Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)))) ==> reverse#4 != null;
  ensures (Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)))) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)];
  ensures (Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)))) ==> !read($Heap, reverse#4, Node.footprint)[$Box(null)];
  ensures (Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)))) ==> read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1));
  ensures (Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)))) ==> read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))];
  ensures (Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)))) ==> read($Heap, reverse#4, Node.next) != null ==> Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint));
  ensures (Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)))) ==> read($Heap, reverse#4, Node.next) != null ==> !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)];
  ensures (Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)))) ==> read($Heap, reverse#4, Node.next) != null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list)));
  ensures (Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)))) ==> read($Heap, reverse#4, Node.next) != null ==> Node.Valid($Heap, read($Heap, reverse#4, Node.next));
  ensures (forall $o: ref :: $o != null && read($Heap, reverse#4, Node.footprint)[$Box($o)] && !old(read($Heap, this, Node.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  ensures Seq#Length(read($Heap, reverse#4, Node.list)) == Seq#Length(old(read($Heap, this, Node.list)));
  ensures (forall i#5: int :: 0 <= i#5 && i#5 < Seq#Length(old(read($Heap, this, Node.list))) ==> Seq#Index(old(read($Heap, this, Node.list)), i#5) == Seq#Index(read($Heap, reverse#4, Node.list), Seq#Length(old(read($Heap, this, Node.list))) - 1 - i#5));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || read(old($Heap), this, Node.footprint)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.current#6: $token;

const unique #tok$0^60.9: $token;

const unique #tok$0^61.13: $token;

const unique #tok$0^62.18: $token;

const unique #tok$0^63.23: $token;

const unique #tok$0^64.18: $token;

const unique #tok$0^66.5: $token;

const unique #loc.nx#9: $token;

const unique #tok$0^80.11: $token;

const unique #tok$0^83.20: $token;

const unique #tok$0^84.25: $token;

const unique #tok$0^85.20: $token;

const unique #tok$0^87.15: $token;

const unique #tok$0^88.15: $token;

implementation Node.ReverseInPlace(this: ref) returns (reverse#4: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var current#6: ref where (current#6 == null || (read($Heap, current#6, alloc) && dtype(current#6) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.current#6, current#6);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;
  var nx#9: ref where (nx#9 == null || (read($Heap, nx#9, alloc) && dtype(nx#9) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.nx#9, nx#9);

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^52.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^52.36, cev_local, #loc.reverse#4, reverse#4);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, Node.footprint)[$Box($o)]);
    // ----- var-declaration statement ----- dafny1\ListContents.dfy(60,9)
    assert true;
    assert true;
    current#6 := read($Heap, this, Node.next);
    assume {:captureState "dafny1\ListContents.dfy(60,9)"} true;
    call CevVarIntro(#tok$0^60.9, cev_local, #loc.current#6, current#6);
    // ----- assignment statement ----- dafny1\ListContents.dfy(61,13)
    assert true;
    assert true;
    reverse#4 := this;
    assume {:captureState "dafny1\ListContents.dfy(61,13)"} true;
    call CevUpdate(#tok$0^61.13, #loc.reverse#4, reverse#4);
    // ----- assignment statement ----- dafny1\ListContents.dfy(62,18)
    assert reverse#4 != null;
    assert true;
    assert $_Frame[reverse#4, Node.next];
    $Heap := update($Heap, reverse#4, Node.next, null);
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\ListContents.dfy(62,18)"} true;
    call CevUpdateHeap(#tok$0^62.18, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\ListContents.dfy(63,23)
    assert reverse#4 != null;
    assert true;
    assert $_Frame[reverse#4, Node.footprint];
    $Heap := update($Heap, reverse#4, Node.footprint, Set#UnionOne(Set#Empty(): Set BoxType, $Box(reverse#4)));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\ListContents.dfy(63,23)"} true;
    call CevUpdateHeap(#tok$0^63.23, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\ListContents.dfy(64,18)
    assert reverse#4 != null;
    assert true;
    assert $_Frame[reverse#4, Node.list];
    $Heap := update($Heap, reverse#4, Node.list, Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, this, Node.data), 1));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\ListContents.dfy(64,18)"} true;
    call CevUpdateHeap(#tok$0^64.18, #loc.$Heap, $Heap);
    // ----- while statement ----- dafny1\ListContents.dfy(66,5)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := $ite(current#6 != null, Seq#Length(read($Heap, current#6, Node.list)), 0 - 1);
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^66.5);
    while (true)
      free invariant Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)));
      invariant $w0 && (Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)))) ==> reverse#4 != null;
      invariant $w0 && (Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)))) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)];
      invariant $w0 && (Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)))) ==> !read($Heap, reverse#4, Node.footprint)[$Box(null)];
      invariant $w0 && (Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)))) ==> read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1));
      invariant $w0 && (Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)))) ==> read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))];
      invariant $w0 && (Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)))) ==> read($Heap, reverse#4, Node.next) != null ==> Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint));
      invariant $w0 && (Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)))) ==> read($Heap, reverse#4, Node.next) != null ==> !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)];
      invariant $w0 && (Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)))) ==> read($Heap, reverse#4, Node.next) != null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list)));
      invariant $w0 && (Node.Valid($Heap, reverse#4) ==> read($Heap, reverse#4, Node.footprint)[$Box(reverse#4)] && !read($Heap, reverse#4, Node.footprint)[$Box(null)] && (read($Heap, reverse#4, Node.next) == null ==> Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1))) && (read($Heap, reverse#4, Node.next) != null ==> read($Heap, reverse#4, Node.footprint)[$Box(read($Heap, reverse#4, Node.next))] && Set#Subset(read($Heap, read($Heap, reverse#4, Node.next), Node.footprint), read($Heap, reverse#4, Node.footprint)) && !read($Heap, read($Heap, reverse#4, Node.next), Node.footprint)[$Box(reverse#4)] && Seq#Equal(read($Heap, reverse#4, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, reverse#4, Node.data), 1), read($Heap, read($Heap, reverse#4, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, reverse#4, Node.next)))) ==> read($Heap, reverse#4, Node.next) != null ==> Node.Valid($Heap, read($Heap, reverse#4, Node.next));
      free invariant $w0 ==> reverse#4 != null && Node.Valid($Heap, reverse#4);
      invariant $w0 ==> Set#Subset(read($Heap, reverse#4, Node.footprint), old(read($Heap, this, Node.footprint)));
      invariant $w0 ==> current#6 == null ==> Seq#Length(old(read($Heap, this, Node.list))) == Seq#Length(read($Heap, reverse#4, Node.list));
      free invariant Node.Valid($Heap, current#6) ==> read($Heap, current#6, Node.footprint)[$Box(current#6)] && !read($Heap, current#6, Node.footprint)[$Box(null)] && (read($Heap, current#6, Node.next) == null ==> Seq#Equal(read($Heap, current#6, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1))) && (read($Heap, current#6, Node.next) != null ==> read($Heap, current#6, Node.footprint)[$Box(read($Heap, current#6, Node.next))] && Set#Subset(read($Heap, read($Heap, current#6, Node.next), Node.footprint), read($Heap, current#6, Node.footprint)) && !read($Heap, read($Heap, current#6, Node.next), Node.footprint)[$Box(current#6)] && Seq#Equal(read($Heap, current#6, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1), read($Heap, read($Heap, current#6, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, current#6, Node.next)));
      invariant $w0 && (Node.Valid($Heap, current#6) ==> read($Heap, current#6, Node.footprint)[$Box(current#6)] && !read($Heap, current#6, Node.footprint)[$Box(null)] && (read($Heap, current#6, Node.next) == null ==> Seq#Equal(read($Heap, current#6, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1))) && (read($Heap, current#6, Node.next) != null ==> read($Heap, current#6, Node.footprint)[$Box(read($Heap, current#6, Node.next))] && Set#Subset(read($Heap, read($Heap, current#6, Node.next), Node.footprint), read($Heap, current#6, Node.footprint)) && !read($Heap, read($Heap, current#6, Node.next), Node.footprint)[$Box(current#6)] && Seq#Equal(read($Heap, current#6, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1), read($Heap, read($Heap, current#6, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, current#6, Node.next)))) ==> current#6 != null ==> read($Heap, current#6, Node.footprint)[$Box(current#6)];
      invariant $w0 && (Node.Valid($Heap, current#6) ==> read($Heap, current#6, Node.footprint)[$Box(current#6)] && !read($Heap, current#6, Node.footprint)[$Box(null)] && (read($Heap, current#6, Node.next) == null ==> Seq#Equal(read($Heap, current#6, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1))) && (read($Heap, current#6, Node.next) != null ==> read($Heap, current#6, Node.footprint)[$Box(read($Heap, current#6, Node.next))] && Set#Subset(read($Heap, read($Heap, current#6, Node.next), Node.footprint), read($Heap, current#6, Node.footprint)) && !read($Heap, read($Heap, current#6, Node.next), Node.footprint)[$Box(current#6)] && Seq#Equal(read($Heap, current#6, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1), read($Heap, read($Heap, current#6, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, current#6, Node.next)))) ==> current#6 != null ==> !read($Heap, current#6, Node.footprint)[$Box(null)];
      invariant $w0 && (Node.Valid($Heap, current#6) ==> read($Heap, current#6, Node.footprint)[$Box(current#6)] && !read($Heap, current#6, Node.footprint)[$Box(null)] && (read($Heap, current#6, Node.next) == null ==> Seq#Equal(read($Heap, current#6, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1))) && (read($Heap, current#6, Node.next) != null ==> read($Heap, current#6, Node.footprint)[$Box(read($Heap, current#6, Node.next))] && Set#Subset(read($Heap, read($Heap, current#6, Node.next), Node.footprint), read($Heap, current#6, Node.footprint)) && !read($Heap, read($Heap, current#6, Node.next), Node.footprint)[$Box(current#6)] && Seq#Equal(read($Heap, current#6, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1), read($Heap, read($Heap, current#6, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, current#6, Node.next)))) ==> current#6 != null ==> read($Heap, current#6, Node.next) == null ==> Seq#Equal(read($Heap, current#6, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1));
      invariant $w0 && (Node.Valid($Heap, current#6) ==> read($Heap, current#6, Node.footprint)[$Box(current#6)] && !read($Heap, current#6, Node.footprint)[$Box(null)] && (read($Heap, current#6, Node.next) == null ==> Seq#Equal(read($Heap, current#6, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1))) && (read($Heap, current#6, Node.next) != null ==> read($Heap, current#6, Node.footprint)[$Box(read($Heap, current#6, Node.next))] && Set#Subset(read($Heap, read($Heap, current#6, Node.next), Node.footprint), read($Heap, current#6, Node.footprint)) && !read($Heap, read($Heap, current#6, Node.next), Node.footprint)[$Box(current#6)] && Seq#Equal(read($Heap, current#6, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1), read($Heap, read($Heap, current#6, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, current#6, Node.next)))) ==> current#6 != null ==> read($Heap, current#6, Node.next) != null ==> read($Heap, current#6, Node.footprint)[$Box(read($Heap, current#6, Node.next))];
      invariant $w0 && (Node.Valid($Heap, current#6) ==> read($Heap, current#6, Node.footprint)[$Box(current#6)] && !read($Heap, current#6, Node.footprint)[$Box(null)] && (read($Heap, current#6, Node.next) == null ==> Seq#Equal(read($Heap, current#6, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1))) && (read($Heap, current#6, Node.next) != null ==> read($Heap, current#6, Node.footprint)[$Box(read($Heap, current#6, Node.next))] && Set#Subset(read($Heap, read($Heap, current#6, Node.next), Node.footprint), read($Heap, current#6, Node.footprint)) && !read($Heap, read($Heap, current#6, Node.next), Node.footprint)[$Box(current#6)] && Seq#Equal(read($Heap, current#6, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1), read($Heap, read($Heap, current#6, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, current#6, Node.next)))) ==> current#6 != null ==> read($Heap, current#6, Node.next) != null ==> Set#Subset(read($Heap, read($Heap, current#6, Node.next), Node.footprint), read($Heap, current#6, Node.footprint));
      invariant $w0 && (Node.Valid($Heap, current#6) ==> read($Heap, current#6, Node.footprint)[$Box(current#6)] && !read($Heap, current#6, Node.footprint)[$Box(null)] && (read($Heap, current#6, Node.next) == null ==> Seq#Equal(read($Heap, current#6, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1))) && (read($Heap, current#6, Node.next) != null ==> read($Heap, current#6, Node.footprint)[$Box(read($Heap, current#6, Node.next))] && Set#Subset(read($Heap, read($Heap, current#6, Node.next), Node.footprint), read($Heap, current#6, Node.footprint)) && !read($Heap, read($Heap, current#6, Node.next), Node.footprint)[$Box(current#6)] && Seq#Equal(read($Heap, current#6, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1), read($Heap, read($Heap, current#6, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, current#6, Node.next)))) ==> current#6 != null ==> read($Heap, current#6, Node.next) != null ==> !read($Heap, read($Heap, current#6, Node.next), Node.footprint)[$Box(current#6)];
      invariant $w0 && (Node.Valid($Heap, current#6) ==> read($Heap, current#6, Node.footprint)[$Box(current#6)] && !read($Heap, current#6, Node.footprint)[$Box(null)] && (read($Heap, current#6, Node.next) == null ==> Seq#Equal(read($Heap, current#6, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1))) && (read($Heap, current#6, Node.next) != null ==> read($Heap, current#6, Node.footprint)[$Box(read($Heap, current#6, Node.next))] && Set#Subset(read($Heap, read($Heap, current#6, Node.next), Node.footprint), read($Heap, current#6, Node.footprint)) && !read($Heap, read($Heap, current#6, Node.next), Node.footprint)[$Box(current#6)] && Seq#Equal(read($Heap, current#6, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1), read($Heap, read($Heap, current#6, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, current#6, Node.next)))) ==> current#6 != null ==> read($Heap, current#6, Node.next) != null ==> Seq#Equal(read($Heap, current#6, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1), read($Heap, read($Heap, current#6, Node.next), Node.list)));
      invariant $w0 && (Node.Valid($Heap, current#6) ==> read($Heap, current#6, Node.footprint)[$Box(current#6)] && !read($Heap, current#6, Node.footprint)[$Box(null)] && (read($Heap, current#6, Node.next) == null ==> Seq#Equal(read($Heap, current#6, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1))) && (read($Heap, current#6, Node.next) != null ==> read($Heap, current#6, Node.footprint)[$Box(read($Heap, current#6, Node.next))] && Set#Subset(read($Heap, read($Heap, current#6, Node.next), Node.footprint), read($Heap, current#6, Node.footprint)) && !read($Heap, read($Heap, current#6, Node.next), Node.footprint)[$Box(current#6)] && Seq#Equal(read($Heap, current#6, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1), read($Heap, read($Heap, current#6, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, current#6, Node.next)))) ==> current#6 != null ==> read($Heap, current#6, Node.next) != null ==> Node.Valid($Heap, read($Heap, current#6, Node.next));
      invariant $w0 && (Node.Valid($Heap, current#6) ==> read($Heap, current#6, Node.footprint)[$Box(current#6)] && !read($Heap, current#6, Node.footprint)[$Box(null)] && (read($Heap, current#6, Node.next) == null ==> Seq#Equal(read($Heap, current#6, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1))) && (read($Heap, current#6, Node.next) != null ==> read($Heap, current#6, Node.footprint)[$Box(read($Heap, current#6, Node.next))] && Set#Subset(read($Heap, read($Heap, current#6, Node.next), Node.footprint), read($Heap, current#6, Node.footprint)) && !read($Heap, read($Heap, current#6, Node.next), Node.footprint)[$Box(current#6)] && Seq#Equal(read($Heap, current#6, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1), read($Heap, read($Heap, current#6, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, current#6, Node.next)))) ==> current#6 != null ==> old(read($Heap, this, Node.footprint))[$Box(current#6)];
      invariant $w0 && (Node.Valid($Heap, current#6) ==> read($Heap, current#6, Node.footprint)[$Box(current#6)] && !read($Heap, current#6, Node.footprint)[$Box(null)] && (read($Heap, current#6, Node.next) == null ==> Seq#Equal(read($Heap, current#6, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1))) && (read($Heap, current#6, Node.next) != null ==> read($Heap, current#6, Node.footprint)[$Box(read($Heap, current#6, Node.next))] && Set#Subset(read($Heap, read($Heap, current#6, Node.next), Node.footprint), read($Heap, current#6, Node.footprint)) && !read($Heap, read($Heap, current#6, Node.next), Node.footprint)[$Box(current#6)] && Seq#Equal(read($Heap, current#6, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1), read($Heap, read($Heap, current#6, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, current#6, Node.next)))) ==> current#6 != null ==> Set#Subset(read($Heap, current#6, Node.footprint), old(read($Heap, this, Node.footprint)));
      invariant $w0 && (Node.Valid($Heap, current#6) ==> read($Heap, current#6, Node.footprint)[$Box(current#6)] && !read($Heap, current#6, Node.footprint)[$Box(null)] && (read($Heap, current#6, Node.next) == null ==> Seq#Equal(read($Heap, current#6, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1))) && (read($Heap, current#6, Node.next) != null ==> read($Heap, current#6, Node.footprint)[$Box(read($Heap, current#6, Node.next))] && Set#Subset(read($Heap, read($Heap, current#6, Node.next), Node.footprint), read($Heap, current#6, Node.footprint)) && !read($Heap, read($Heap, current#6, Node.next), Node.footprint)[$Box(current#6)] && Seq#Equal(read($Heap, current#6, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1), read($Heap, read($Heap, current#6, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, current#6, Node.next)))) ==> current#6 != null ==> Set#Disjoint(read($Heap, current#6, Node.footprint), read($Heap, reverse#4, Node.footprint));
      invariant $w0 && (Node.Valid($Heap, current#6) ==> read($Heap, current#6, Node.footprint)[$Box(current#6)] && !read($Heap, current#6, Node.footprint)[$Box(null)] && (read($Heap, current#6, Node.next) == null ==> Seq#Equal(read($Heap, current#6, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1))) && (read($Heap, current#6, Node.next) != null ==> read($Heap, current#6, Node.footprint)[$Box(read($Heap, current#6, Node.next))] && Set#Subset(read($Heap, read($Heap, current#6, Node.next), Node.footprint), read($Heap, current#6, Node.footprint)) && !read($Heap, read($Heap, current#6, Node.next), Node.footprint)[$Box(current#6)] && Seq#Equal(read($Heap, current#6, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1), read($Heap, read($Heap, current#6, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, current#6, Node.next)))) ==> current#6 != null ==> Seq#Length(old(read($Heap, this, Node.list))) == Seq#Length(read($Heap, reverse#4, Node.list)) + Seq#Length(read($Heap, current#6, Node.list));
      invariant $w0 && (Node.Valid($Heap, current#6) ==> read($Heap, current#6, Node.footprint)[$Box(current#6)] && !read($Heap, current#6, Node.footprint)[$Box(null)] && (read($Heap, current#6, Node.next) == null ==> Seq#Equal(read($Heap, current#6, Node.list), Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1))) && (read($Heap, current#6, Node.next) != null ==> read($Heap, current#6, Node.footprint)[$Box(read($Heap, current#6, Node.next))] && Set#Subset(read($Heap, read($Heap, current#6, Node.next), Node.footprint), read($Heap, current#6, Node.footprint)) && !read($Heap, read($Heap, current#6, Node.next), Node.footprint)[$Box(current#6)] && Seq#Equal(read($Heap, current#6, Node.list), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1), read($Heap, read($Heap, current#6, Node.next), Node.list))) && Node.Valid($Heap, read($Heap, current#6, Node.next)))) ==> current#6 != null ==> (forall i#7: int :: 0 <= i#7 && i#7 < Seq#Length(read($Heap, current#6, Node.list)) ==> Seq#Index(read($Heap, current#6, Node.list), i#7) == Seq#Index(old(read($Heap, this, Node.list)), Seq#Length(read($Heap, reverse#4, Node.list)) + i#7));
      free invariant $w0 ==> current#6 != null ==> Node.Valid($Heap, current#6) && old(read($Heap, this, Node.footprint))[$Box(current#6)] && Set#Subset(read($Heap, current#6, Node.footprint), old(read($Heap, this, Node.footprint))) && Set#Disjoint(read($Heap, current#6, Node.footprint), read($Heap, reverse#4, Node.footprint)) && Seq#Length(old(read($Heap, this, Node.list))) == Seq#Length(read($Heap, reverse#4, Node.list)) + Seq#Length(read($Heap, current#6, Node.list)) && (forall i#7: int :: 0 <= i#7 && i#7 < Seq#Length(read($Heap, current#6, Node.list)) ==> Seq#Index(read($Heap, current#6, Node.list), i#7) == Seq#Index(old(read($Heap, this, Node.list)), Seq#Length(read($Heap, reverse#4, Node.list)) + i#7));
      invariant $w0 ==> (forall i#8: int :: 0 <= i#8 && i#8 < Seq#Length(read($Heap, reverse#4, Node.list)) ==> Seq#Index(old(read($Heap, this, Node.list)), i#8) == Seq#Index(read($Heap, reverse#4, Node.list), Seq#Length(read($Heap, reverse#4, Node.list)) - 1 - i#8));
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f) || read(old($Heap), this, Node.footprint)[$Box($o)]);
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant $ite(current#6 != null, Seq#Length(read($Heap, current#6, Node.list)), 0 - 1) <= $decr0$init$0 && ($ite(current#6 != null, Seq#Length(read($Heap, current#6, Node.list)), 0 - 1) == $decr0$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^66.5;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.reverse#4, reverse#4);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} reverse#4 != null ==> reverse#4 != null;
            assume reverse#4 != null && Node.Valid($Heap, reverse#4);
            assert {:subsumption 0} reverse#4 != null && old(true);
            assume Set#Subset(read($Heap, reverse#4, Node.footprint), old(read($Heap, this, Node.footprint)));
            assert {:subsumption 0} current#6 == null ==> old(true) && reverse#4 != null;
            assume current#6 == null ==> Seq#Length(old(read($Heap, this, Node.list))) == Seq#Length(read($Heap, reverse#4, Node.list));
            assert {:subsumption 0} current#6 != null ==> current#6 != null && (Node.Valid($Heap, current#6) ==> old(true)) && (Node.Valid($Heap, current#6) && old(read($Heap, this, Node.footprint))[$Box(current#6)] ==> current#6 != null && old(true)) && (Node.Valid($Heap, current#6) && old(read($Heap, this, Node.footprint))[$Box(current#6)] && Set#Subset(read($Heap, current#6, Node.footprint), old(read($Heap, this, Node.footprint))) ==> current#6 != null && reverse#4 != null) && (Node.Valid($Heap, current#6) && old(read($Heap, this, Node.footprint))[$Box(current#6)] && Set#Subset(read($Heap, current#6, Node.footprint), old(read($Heap, this, Node.footprint))) && Set#Disjoint(read($Heap, current#6, Node.footprint), read($Heap, reverse#4, Node.footprint)) ==> old(true) && reverse#4 != null && current#6 != null) && (Node.Valid($Heap, current#6) && old(read($Heap, this, Node.footprint))[$Box(current#6)] && Set#Subset(read($Heap, current#6, Node.footprint), old(read($Heap, this, Node.footprint))) && Set#Disjoint(read($Heap, current#6, Node.footprint), read($Heap, reverse#4, Node.footprint)) && Seq#Length(old(read($Heap, this, Node.list))) == Seq#Length(read($Heap, reverse#4, Node.list)) + Seq#Length(read($Heap, current#6, Node.list)) ==> (forall i#7: int :: (0 <= i#7 ==> current#6 != null) && (0 <= i#7 && i#7 < Seq#Length(read($Heap, current#6, Node.list)) ==> current#6 != null && 0 <= i#7 && i#7 < Seq#Length(read($Heap, current#6, Node.list)) && old(true) && reverse#4 != null && 0 <= Seq#Length(read($Heap, reverse#4, Node.list)) + i#7 && Seq#Length(read($Heap, reverse#4, Node.list)) + i#7 < Seq#Length(old(read($Heap, this, Node.list))))));
            assume current#6 != null ==> Node.Valid($Heap, current#6) && old(read($Heap, this, Node.footprint))[$Box(current#6)] && Set#Subset(read($Heap, current#6, Node.footprint), old(read($Heap, this, Node.footprint))) && Set#Disjoint(read($Heap, current#6, Node.footprint), read($Heap, reverse#4, Node.footprint)) && Seq#Length(old(read($Heap, this, Node.list))) == Seq#Length(read($Heap, reverse#4, Node.list)) + Seq#Length(read($Heap, current#6, Node.list)) && (forall i#7: int :: 0 <= i#7 && i#7 < Seq#Length(read($Heap, current#6, Node.list)) ==> Seq#Index(read($Heap, current#6, Node.list), i#7) == Seq#Index(old(read($Heap, this, Node.list)), Seq#Length(read($Heap, reverse#4, Node.list)) + i#7));
            assert {:subsumption 0} (forall i#8: int :: (0 <= i#8 ==> reverse#4 != null) && (0 <= i#8 && i#8 < Seq#Length(read($Heap, reverse#4, Node.list)) ==> old(true) && 0 <= i#8 && i#8 < Seq#Length(old(read($Heap, this, Node.list))) && reverse#4 != null && reverse#4 != null && 0 <= Seq#Length(read($Heap, reverse#4, Node.list)) - 1 - i#8 && Seq#Length(read($Heap, reverse#4, Node.list)) - 1 - i#8 < Seq#Length(read($Heap, reverse#4, Node.list))));
            assume (forall i#8: int :: 0 <= i#8 && i#8 < Seq#Length(read($Heap, reverse#4, Node.list)) ==> Seq#Index(old(read($Heap, this, Node.list)), i#8) == Seq#Index(read($Heap, reverse#4, Node.list), Seq#Length(read($Heap, reverse#4, Node.list)) - 1 - i#8));
            assert (current#6 != null ==> current#6 != null) && (current#6 == null ==> true);
            assume false;
        }

        assert true;
        if (current#6 == null)
        {
            break;
        }

        call CevStepEvent(#tok$0^66.5, loop_entered);
        assume {:captureState "dafny1\ListContents.dfy(66,5): loop entered"} true;
        $decr0$0 := $ite(current#6 != null, Seq#Length(read($Heap, current#6, Node.list)), 0 - 1);
        // ----- var-declaration statement ----- dafny1\ListContents.dfy(80,11)
        assert true;
        assert current#6 != null;
        nx#9 := read($Heap, current#6, Node.next);
        assume {:captureState "dafny1\ListContents.dfy(80,11)"} true;
        call CevVarIntro(#tok$0^80.11, cev_local, #loc.nx#9, nx#9);
        // ----- assignment statement ----- dafny1\ListContents.dfy(83,20)
        assert current#6 != null;
        assert true;
        assert $_Frame[current#6, Node.next];
        $Heap := update($Heap, current#6, Node.next, reverse#4);
        assume $IsGoodHeap($Heap);
        assume {:captureState "dafny1\ListContents.dfy(83,20)"} true;
        call CevUpdateHeap(#tok$0^83.20, #loc.$Heap, $Heap);
        // ----- assignment statement ----- dafny1\ListContents.dfy(84,25)
        assert current#6 != null;
        assert reverse#4 != null;
        assert $_Frame[current#6, Node.footprint];
        $Heap := update($Heap, current#6, Node.footprint, Set#Union(Set#UnionOne(Set#Empty(): Set BoxType, $Box(current#6)), read($Heap, reverse#4, Node.footprint)));
        assume $IsGoodHeap($Heap);
        assume {:captureState "dafny1\ListContents.dfy(84,25)"} true;
        call CevUpdateHeap(#tok$0^84.25, #loc.$Heap, $Heap);
        // ----- assignment statement ----- dafny1\ListContents.dfy(85,20)
        assert current#6 != null;
        assert current#6 != null && reverse#4 != null;
        assert $_Frame[current#6, Node.list];
        $Heap := update($Heap, current#6, Node.list, Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, read($Heap, current#6, Node.data), 1), read($Heap, reverse#4, Node.list)));
        assume $IsGoodHeap($Heap);
        assume {:captureState "dafny1\ListContents.dfy(85,20)"} true;
        call CevUpdateHeap(#tok$0^85.20, #loc.$Heap, $Heap);
        // ----- assignment statement ----- dafny1\ListContents.dfy(87,15)
        assert true;
        assert true;
        reverse#4 := current#6;
        assume {:captureState "dafny1\ListContents.dfy(87,15)"} true;
        call CevUpdate(#tok$0^87.15, #loc.reverse#4, reverse#4);
        // ----- assignment statement ----- dafny1\ListContents.dfy(88,15)
        assert true;
        assert true;
        current#6 := nx#9;
        assume {:captureState "dafny1\ListContents.dfy(88,15)"} true;
        call CevUpdate(#tok$0^88.15, #loc.current#6, current#6);
        assert 0 <= $decr0$0 || $ite(current#6 != null, Seq#Length(read($Heap, current#6, Node.list)), 0 - 1) == $decr0$0;
        assert $ite(current#6 != null, Seq#Length(read($Heap, current#6, Node.list)), 0 - 1) < $decr0$0;
    }

    call CevStepEvent(#tok$0^66.5, loop_exited);
    assume {:captureState "dafny1\ListContents.dfy(66,5): loop exit"} true;
}



const unique class._default: ClassName;
