// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: dafny1\ListCopy.dfy /print:\Users\philipp\Desktop\boogie\boogie-k-induction-benchmarks\benchmarks\ListCopy.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class.Node: ClassName;

axiom FDim(Node.nxt) == 0 && DeclType(Node.nxt) == class.Node;

const unique Node.nxt: Field ref;

axiom (forall $h: HeapType, $o: ref :: { read($h, $o, Node.nxt) } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) ==> read($h, $o, Node.nxt) == null || (read($h, read($h, $o, Node.nxt), alloc) && dtype(read($h, $o, Node.nxt)) == class.Node));

const unique xxxxxxxxxfile: $token;

axiom $file_name_is(0, xxxxxxxxxfile);

const unique #tok$0^4.10: $token;

procedure CheckWellformed$$Node.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Node);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^4.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.this: $token;

implementation CheckWellformed$$Node.Init(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^4.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    assume read($Heap, this, Node.nxt) == null;
}



procedure Node.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Node);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^4.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures read($Heap, this, Node.nxt) == null;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^8.9: $token;

implementation Node.Init(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^4.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    // ----- assignment statement ----- dafny1\ListCopy.dfy(8,9)
    assert true;
    assert true;
    assert $_Frame[this, Node.nxt];
    $Heap := update($Heap, this, Node.nxt, null);
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\ListCopy.dfy(8,9)"} true;
    call CevUpdateHeap(#tok$0^8.9, #loc.$Heap, $Heap);
}



const unique #tok$0^11.10: $token;

procedure CheckWellformed$$Node.Copy(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Node, root#0: ref where root#0 == null || (read($Heap, root#0, alloc) && dtype(root#0) == class.Node)) returns (result#1: ref where result#1 == null || (read($Heap, result#1, alloc) && dtype(result#1) == class.Node));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^11.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^11.15: $token;

const unique #loc.root#0: $token;

const unique #tok$0^11.36: $token;

const unique #loc.result#1: $token;

implementation CheckWellformed$$Node.Copy(this: ref, root#0: ref) returns (result#1: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^11.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^11.15, cev_parameter, #loc.root#0, root#0);
    call CevVarIntro(#tok$0^11.36, cev_local, #loc.result#1, result#1);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc result#1;
}



procedure Node.Copy(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Node, root#0: ref where root#0 == null || (read($Heap, root#0, alloc) && dtype(root#0) == class.Node)) returns (result#1: ref where result#1 == null || (read($Heap, result#1, alloc) && dtype(result#1) == class.Node));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^11.10;
  modifies $Heap, #cev_pc;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.existingRegion#2: $token;

const unique #tok$0^13.9: $token;

const unique #loc.newRoot#4: $token;

const unique #tok$0^17.9: $token;

const unique #loc.oldListPtr#5: $token;

const unique #tok$0^18.9: $token;

const unique #loc.newRegion#6: $token;

const unique #tok$0^19.9: $token;

const unique #tok$0^21.5: $token;

const unique #tok$0^21.29: $token;

const unique #tok$0^22.15: $token;

const unique #tok$0^23.7: $token;

const unique #tok$0^24.17: $token;

const unique #loc.prev#7: $token;

const unique #tok$0^25.11: $token;

const unique #tok$0^27.7: $token;

const unique #loc.tmp#10: $token;

const unique #tok$0^36.13: $token;

const unique #tok$0^37.9: $token;

const unique #tok$0^39.19: $token;

const unique #tok$0^40.18: $token;

const unique #tok$0^42.14: $token;

const unique #tok$0^43.20: $token;

const unique #tok$0^46.12: $token;

implementation Node.Copy(this: ref, root#0: ref) returns (result#1: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var existingRegion#2: Set BoxType where (forall $t: BoxType :: { existingRegion#2[$t] } existingRegion#2[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.existingRegion#2, existingRegion#2);
  var newRoot#4: ref where (newRoot#4 == null || (read($Heap, newRoot#4, alloc) && dtype(newRoot#4) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.newRoot#4, newRoot#4);
  var oldListPtr#5: ref where (oldListPtr#5 == null || (read($Heap, oldListPtr#5, alloc) && dtype(oldListPtr#5) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.oldListPtr#5, oldListPtr#5);
  var newRegion#6: Set BoxType where (forall $t: BoxType :: { newRegion#6[$t] } newRegion#6[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.newRegion#6, newRegion#6);
  var $nw: ref;
  var prev#7: ref where (prev#7 == null || (read($Heap, prev#7, alloc) && dtype(prev#7) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.prev#7, prev#7);
  var $PreLoopHeap0: HeapType;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var tmp#10: ref where (tmp#10 == null || (read($Heap, tmp#10, alloc) && dtype(tmp#10) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.tmp#10, tmp#10);

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^11.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^11.15, cev_parameter, #loc.root#0, root#0);
    call CevVarIntro(#tok$0^11.36, cev_local, #loc.result#1, result#1);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- dafny1\ListCopy.dfy(13,9)
    call CevVarIntro(#tok$0^13.9, cev_local, #loc.existingRegion#2, existingRegion#2);
    // ----- assume statement ----- dafny1\ListCopy.dfy(14,5)
    assert {:subsumption 0} root#0 != null ==> true;
    assume root#0 == null || existingRegion#2[$Box(root#0)];
    // ----- assume statement ----- dafny1\ListCopy.dfy(15,5)
    assert {:subsumption 0} (forall o#3: ref :: (o#3 != null ==> true) && (o#3 != null && existingRegion#2[$Box(o#3)] ==> o#3 != null) && (o#3 != null && existingRegion#2[$Box(o#3)] && read($Heap, o#3, Node.nxt) != null ==> o#3 != null));
    assume (forall o#3: ref :: o#3 != null && existingRegion#2[$Box(o#3)] && read($Heap, o#3, Node.nxt) != null ==> existingRegion#2[$Box(read($Heap, o#3, Node.nxt))]);
    // ----- var-declaration statement ----- dafny1\ListCopy.dfy(17,9)
    assert true;
    assert true;
    newRoot#4 := null;
    assume {:captureState "dafny1\ListCopy.dfy(17,9)"} true;
    call CevVarIntro(#tok$0^17.9, cev_local, #loc.newRoot#4, newRoot#4);
    // ----- var-declaration statement ----- dafny1\ListCopy.dfy(18,9)
    assert true;
    assert true;
    oldListPtr#5 := root#0;
    assume {:captureState "dafny1\ListCopy.dfy(18,9)"} true;
    call CevVarIntro(#tok$0^18.9, cev_local, #loc.oldListPtr#5, oldListPtr#5);
    // ----- var-declaration statement ----- dafny1\ListCopy.dfy(19,9)
    assert true;
    assert true;
    newRegion#6 := Set#Empty(): Set BoxType;
    assume {:captureState "dafny1\ListCopy.dfy(19,9)"} true;
    call CevVarIntro(#tok$0^19.9, cev_local, #loc.newRegion#6, newRegion#6);
    // ----- if statement ----- dafny1\ListCopy.dfy(21,5)
    call CevEvent(#tok$0^21.5, conditional_moment);
    assert true;
    if (oldListPtr#5 != null)
    {
        call CevEvent(#tok$0^21.29, took_then_branch);
        // ----- assignment statement ----- dafny1\ListCopy.dfy(22,15)
        havoc $nw;
        assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.Node;
        $Heap := update($Heap, $nw, alloc, true);
        newRoot#4 := $nw;
        assume $IsGoodHeap($Heap);
        assume {:captureState "dafny1\ListCopy.dfy(22,15)"} true;
        call CevUpdate(#tok$0^22.15, #loc.newRoot#4, newRoot#4);
        // ----- call statement ----- dafny1\ListCopy.dfy(23,7)
        assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == newRoot#4 ==> $_Frame[$o, $f]);
        call Node.Init(newRoot#4);
        call CevStep(#tok$0^23.7);
        assume {:captureState "dafny1\ListCopy.dfy(23,7)"} true;
        // ----- assignment statement ----- dafny1\ListCopy.dfy(24,17)
        assert true;
        assert true;
        newRegion#6 := Set#Union(newRegion#6, Set#UnionOne(Set#Empty(): Set BoxType, $Box(newRoot#4)));
        assume {:captureState "dafny1\ListCopy.dfy(24,17)"} true;
        call CevUpdate(#tok$0^24.17, #loc.newRegion#6, newRegion#6);
        // ----- var-declaration statement ----- dafny1\ListCopy.dfy(25,11)
        assert true;
        assert true;
        prev#7 := newRoot#4;
        assume {:captureState "dafny1\ListCopy.dfy(25,11)"} true;
        call CevVarIntro(#tok$0^25.11, cev_local, #loc.prev#7, prev#7);
        // ----- while statement ----- dafny1\ListCopy.dfy(27,7)
        $PreLoopHeap0 := $Heap;
        havoc $w0;
        call $PreLoopCevPC0 := CevPreLoop(#tok$0^27.7);
        while (true)
          invariant $w0 ==> newRegion#6[$Box(newRoot#4)];
          invariant $w0 ==> (forall o#8: ref :: newRegion#6[$Box(o#8)] ==> o#8 != null);
          invariant $w0 ==> (forall o#9: ref :: newRegion#6[$Box(o#9)] && read($Heap, o#9, Node.nxt) != null ==> newRegion#6[$Box(read($Heap, o#9, Node.nxt))]);
          invariant $w0 ==> newRegion#6[$Box(prev#7)];
          invariant $w0 ==> (forall $o: ref :: $o != null && newRegion#6[$Box($o)] ==> !read(old($Heap), $o, alloc));
          invariant $w0 ==> Set#Disjoint(newRegion#6, existingRegion#2);
          free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
          free invariant $HeapSucc($PreLoopHeap0, $Heap);
          free invariant #cev_save_position(#cev_pc) == #tok$0^27.7;
          free invariant $PreLoopCevPC0 < #cev_pc;
          free invariant #cev_control_flow_event(#cev_pc, loop_register);
          free invariant #cev_var_update(#cev_pc, cev_local, #loc.result#1, result#1);
	  kUnwind 1;
        {
            if (!$w0)
            {
                assert {:subsumption 0} true;
                assume newRegion#6[$Box(newRoot#4)];
                assert {:subsumption 0} (forall o#8: ref :: newRegion#6[$Box(o#8)] ==> true);
                assume (forall o#8: ref :: newRegion#6[$Box(o#8)] ==> o#8 != null);
                assert {:subsumption 0} (forall o#9: ref :: (newRegion#6[$Box(o#9)] ==> o#9 != null) && (newRegion#6[$Box(o#9)] && read($Heap, o#9, Node.nxt) != null ==> o#9 != null));
                assume (forall o#9: ref :: newRegion#6[$Box(o#9)] && read($Heap, o#9, Node.nxt) != null ==> newRegion#6[$Box(read($Heap, o#9, Node.nxt))]);
                assert {:subsumption 0} true;
                assume newRegion#6[$Box(prev#7)];
                assert {:subsumption 0} true;
                assume (forall $o: ref :: $o != null && newRegion#6[$Box($o)] ==> !read(old($Heap), $o, alloc));
                assert {:subsumption 0} true;
                assume Set#Disjoint(newRegion#6, existingRegion#2);
                assert true;
                assume false;
            }

            assert true;
            if (oldListPtr#5 == null)
            {
                break;
            }

            call CevStepEvent(#tok$0^27.7, loop_entered);
            assume {:captureState "dafny1\ListCopy.dfy(27,7): loop entered"} true;
            // ----- var-declaration statement ----- dafny1\ListCopy.dfy(36,13)
            havoc $nw;
            assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.Node;
            $Heap := update($Heap, $nw, alloc, true);
            tmp#10 := $nw;
            assume $IsGoodHeap($Heap);
            assume {:captureState "dafny1\ListCopy.dfy(36,13)"} true;
            call CevVarIntro(#tok$0^36.13, cev_local, #loc.tmp#10, tmp#10);
            // ----- call statement ----- dafny1\ListCopy.dfy(37,9)
            assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == tmp#10 ==> $_Frame[$o, $f]);
            call Node.Init(tmp#10);
            call CevStep(#tok$0^37.9);
            assume {:captureState "dafny1\ListCopy.dfy(37,9)"} true;
            // ----- assignment statement ----- dafny1\ListCopy.dfy(39,19)
            assert true;
            assert true;
            newRegion#6 := Set#Union(newRegion#6, Set#UnionOne(Set#Empty(): Set BoxType, $Box(tmp#10)));
            assume {:captureState "dafny1\ListCopy.dfy(39,19)"} true;
            call CevUpdate(#tok$0^39.19, #loc.newRegion#6, newRegion#6);
            // ----- assignment statement ----- dafny1\ListCopy.dfy(40,18)
            assert prev#7 != null;
            assert true;
            assert $_Frame[prev#7, Node.nxt];
            $Heap := update($Heap, prev#7, Node.nxt, tmp#10);
            assume $IsGoodHeap($Heap);
            assume {:captureState "dafny1\ListCopy.dfy(40,18)"} true;
            call CevUpdateHeap(#tok$0^40.18, #loc.$Heap, $Heap);
            // ----- assignment statement ----- dafny1\ListCopy.dfy(42,14)
            assert true;
            assert true;
            prev#7 := tmp#10;
            assume {:captureState "dafny1\ListCopy.dfy(42,14)"} true;
            call CevUpdate(#tok$0^42.14, #loc.prev#7, prev#7);
            // ----- assignment statement ----- dafny1\ListCopy.dfy(43,20)
            assert true;
            assert oldListPtr#5 != null;
            oldListPtr#5 := read($Heap, oldListPtr#5, Node.nxt);
            assume {:captureState "dafny1\ListCopy.dfy(43,20)"} true;
            call CevUpdate(#tok$0^43.20, #loc.oldListPtr#5, oldListPtr#5);
        }

        call CevStepEvent(#tok$0^27.7, loop_exited);
        assume {:captureState "dafny1\ListCopy.dfy(27,7): loop exit"} true;
    }
    else
    {
        call CevEvent(#tok$0^21.5, took_else_branch);
    }

    // ----- assignment statement ----- dafny1\ListCopy.dfy(46,12)
    assert true;
    assert true;
    result#1 := newRoot#4;
    assume {:captureState "dafny1\ListCopy.dfy(46,12)"} true;
    call CevUpdate(#tok$0^46.12, #loc.result#1, result#1);
    // ----- assert statement ----- dafny1\ListCopy.dfy(47,5)
    assert {:subsumption 0} result#1 != null ==> true;
    assert result#1 == null || newRegion#6[$Box(result#1)];
    // ----- assert statement ----- dafny1\ListCopy.dfy(50,5)
    assert {:subsumption 0} true;
    assert (forall $o: ref :: $o != null && newRegion#6[$Box($o)] ==> !read(old($Heap), $o, alloc));
    // ----- assert statement ----- dafny1\ListCopy.dfy(53,5)
    assert {:subsumption 0} true;
    assert Set#Disjoint(newRegion#6, existingRegion#2);
}



const unique class._default: ClassName;
