// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: dafny1\ListReverse.dfy /print:\Users\philipp\Desktop\boogie\boogie-k-induction-benchmarks\benchmarks\ListReverse.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class.Node: ClassName;

axiom FDim(Node.nxt) == 0 && DeclType(Node.nxt) == class.Node;

const unique Node.nxt: Field ref;

axiom (forall $h: HeapType, $o: ref :: { read($h, $o, Node.nxt) } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) ==> read($h, $o, Node.nxt) == null || (read($h, read($h, $o, Node.nxt), alloc) && dtype(read($h, $o, Node.nxt)) == class.Node));

const unique xxxxxxxxxfile: $token;

axiom $file_name_is(0, xxxxxxxxxfile);

const unique #tok$0^5.10: $token;

procedure CheckWellformed$$Node.ReverseInPlace(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Node, x#0: ref where x#0 == null || (read($Heap, x#0, alloc) && dtype(x#0) == class.Node), r#1: Set BoxType where (forall $t: BoxType :: { r#1[$t] } r#1[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node))) returns (reverse#2: ref where reverse#2 == null || (read($Heap, reverse#2, alloc) && dtype(reverse#2) == class.Node));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^5.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.this: $token;

const unique #tok$0^5.25: $token;

const unique #loc.x#0: $token;

const unique #tok$0^5.34: $token;

const unique #loc.r#1: $token;

const unique #tok$0^5.57: $token;

const unique #loc.reverse#2: $token;

implementation CheckWellformed$$Node.ReverseInPlace(this: ref, x#0: ref, r#1: Set BoxType) returns (reverse#2: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var y#8: ref;
  var y#9: ref;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^5.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^5.25, cev_parameter, #loc.x#0, x#0);
    call CevVarIntro(#tok$0^5.34, cev_parameter, #loc.r#1, r#1);
    call CevVarIntro(#tok$0^5.57, cev_local, #loc.reverse#2, reverse#2);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> r#1[$Box($o)]);
    assume !r#1[$Box(null)];
    if (x#0 != null)
    {
    }

    assume x#0 == null || r#1[$Box(x#0)];
    if (r#1[$Box(y#8)])
    {
        assert y#8 != null;
        if (read($Heap, y#8, Node.nxt) != null)
        {
            assert y#8 != null;
        }
    }

    assume (forall y#3: ref :: r#1[$Box(y#3)] ==> read($Heap, y#3, Node.nxt) == null || r#1[$Box(read($Heap, y#3, Node.nxt))]);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc reverse#2;
    if (reverse#2 != null)
    {
    }

    assume reverse#2 == null || r#1[$Box(reverse#2)];
    if (r#1[$Box(y#9)])
    {
        assert y#9 != null;
        if (read($Heap, y#9, Node.nxt) != null)
        {
            assert y#9 != null;
        }
    }

    assume (forall y#4: ref :: r#1[$Box(y#4)] ==> read($Heap, y#4, Node.nxt) == null || r#1[$Box(read($Heap, y#4, Node.nxt))]);
}



procedure Node.ReverseInPlace(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Node, x#0: ref where x#0 == null || (read($Heap, x#0, alloc) && dtype(x#0) == class.Node), r#1: Set BoxType where (forall $t: BoxType :: { r#1[$t] } r#1[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node))) returns (reverse#2: ref where reverse#2 == null || (read($Heap, reverse#2, alloc) && dtype(reverse#2) == class.Node));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires !r#1[$Box(null)];
  requires x#0 == null || r#1[$Box(x#0)];
  requires (forall y#3: ref :: r#1[$Box(y#3)] ==> read($Heap, y#3, Node.nxt) == null || r#1[$Box(read($Heap, y#3, Node.nxt))]);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^5.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures reverse#2 == null || r#1[$Box(reverse#2)];
  ensures (forall y#4: ref :: r#1[$Box(y#4)] ==> read($Heap, y#4, Node.nxt) == null || r#1[$Box(read($Heap, y#4, Node.nxt))]);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || r#1[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.current#5: $token;

const unique #tok$0^13.9: $token;

const unique #tok$0^14.13: $token;

const unique #tok$0^15.5: $token;

const unique #loc.tmp#7: $token;

const unique #tok$0^21.11: $token;

const unique #tok$0^22.19: $token;

const unique #tok$0^23.15: $token;

const unique #tok$0^24.15: $token;

implementation Node.ReverseInPlace(this: ref, x#0: ref, r#1: Set BoxType) returns (reverse#2: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var current#5: ref where (current#5 == null || (read($Heap, current#5, alloc) && dtype(current#5) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.current#5, current#5);
  var $PreLoopHeap0: HeapType;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var tmp#7: ref where (tmp#7 == null || (read($Heap, tmp#7, alloc) && dtype(tmp#7) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.tmp#7, tmp#7);

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^5.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^5.25, cev_parameter, #loc.x#0, x#0);
    call CevVarIntro(#tok$0^5.34, cev_parameter, #loc.r#1, r#1);
    call CevVarIntro(#tok$0^5.57, cev_local, #loc.reverse#2, reverse#2);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> r#1[$Box($o)]);
    // ----- var-declaration statement ----- dafny1\ListReverse.dfy(13,9)
    assert true;
    assert true;
    current#5 := x#0;
    assume {:captureState "dafny1\ListReverse.dfy(13,9)"} true;
    call CevVarIntro(#tok$0^13.9, cev_local, #loc.current#5, current#5);
    // ----- assignment statement ----- dafny1\ListReverse.dfy(14,13)
    assert true;
    assert true;
    reverse#2 := null;
    assume {:captureState "dafny1\ListReverse.dfy(14,13)"} true;
    call CevUpdate(#tok$0^14.13, #loc.reverse#2, reverse#2);
    // ----- while statement ----- dafny1\ListReverse.dfy(15,5)
    $PreLoopHeap0 := $Heap;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^15.5);
    while (true)
      invariant $w0 ==> current#5 == null || r#1[$Box(current#5)];
      invariant $w0 ==> reverse#2 == null || r#1[$Box(reverse#2)];
      invariant $w0 ==> (forall y#6: ref :: r#1[$Box(y#6)] ==> read($Heap, y#6, Node.nxt) == null || r#1[$Box(read($Heap, y#6, Node.nxt))]);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f) || r#1[$Box($o)]);
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant #cev_save_position(#cev_pc) == #tok$0^15.5;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.reverse#2, reverse#2);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} current#5 != null ==> true;
            assume current#5 == null || r#1[$Box(current#5)];
            assert {:subsumption 0} reverse#2 != null ==> true;
            assume reverse#2 == null || r#1[$Box(reverse#2)];
            assert {:subsumption 0} (forall y#6: ref :: r#1[$Box(y#6)] ==> y#6 != null && (read($Heap, y#6, Node.nxt) != null ==> y#6 != null));
            assume (forall y#6: ref :: r#1[$Box(y#6)] ==> read($Heap, y#6, Node.nxt) == null || r#1[$Box(read($Heap, y#6, Node.nxt))]);
            assert true;
            assume false;
        }

        assert true;
        if (current#5 == null)
        {
            break;
        }

        call CevStepEvent(#tok$0^15.5, loop_entered);
        assume {:captureState "dafny1\ListReverse.dfy(15,5): loop entered"} true;
        // ----- var-declaration statement ----- dafny1\ListReverse.dfy(21,11)
        assert true;
        assert current#5 != null;
        tmp#7 := read($Heap, current#5, Node.nxt);
        assume {:captureState "dafny1\ListReverse.dfy(21,11)"} true;
        call CevVarIntro(#tok$0^21.11, cev_local, #loc.tmp#7, tmp#7);
        // ----- assignment statement ----- dafny1\ListReverse.dfy(22,19)
        assert current#5 != null;
        assert true;
        assert $_Frame[current#5, Node.nxt];
        $Heap := update($Heap, current#5, Node.nxt, reverse#2);
        assume $IsGoodHeap($Heap);
        assume {:captureState "dafny1\ListReverse.dfy(22,19)"} true;
        call CevUpdateHeap(#tok$0^22.19, #loc.$Heap, $Heap);
        // ----- assignment statement ----- dafny1\ListReverse.dfy(23,15)
        assert true;
        assert true;
        reverse#2 := current#5;
        assume {:captureState "dafny1\ListReverse.dfy(23,15)"} true;
        call CevUpdate(#tok$0^23.15, #loc.reverse#2, reverse#2);
        // ----- assignment statement ----- dafny1\ListReverse.dfy(24,15)
        assert true;
        assert true;
        current#5 := tmp#7;
        assume {:captureState "dafny1\ListReverse.dfy(24,15)"} true;
        call CevUpdate(#tok$0^24.15, #loc.current#5, current#5);
    }

    call CevStepEvent(#tok$0^15.5, loop_exited);
    assume {:captureState "dafny1\ListReverse.dfy(15,5): loop exit"} true;
}



const unique class._default: ClassName;
