procedure LockingExample();


procedure StructuredLockingExample()
{
  var x: int;
  var y: int;
  var held: bool;

  held := false;
  x := 0;

  while (true)
    invariant !held;
    kUnwind 1;
  {
    // Lock
    assert !held;
    held := true;

    y := x;
    if (*) {
      // Unlock
      assert held;
      held := false;

      x := x + 1;
    }

    if (x == y) { break; }
  }

  // Unlock
  assert held;
  held := false;
}

procedure StructuredLockingExampleWithCalls()
{
  var x: int;
  var y: int;
  var mutex: Mutex;

  call mutex := Initialize();
  x := 0;

  while (true)
    invariant !IsHeld(mutex);
    kUnwind 1;
  {
    call mutex := Acquire(mutex);

    y := x;
    if (*) {
      call mutex := Release(mutex);
      x := x + 1;
    }

    if (x == y) { break; }
  }

  call mutex := Release(mutex);
}

type Mutex;
function IsHeld(Mutex) returns (bool);

procedure Initialize() returns (post: Mutex);
  ensures !IsHeld(post);

procedure Acquire(pre: Mutex) returns (post: Mutex);
  requires !IsHeld(pre);
  ensures IsHeld(post);

procedure Release(pre: Mutex) returns (post: Mutex);
  requires IsHeld(pre);
  ensures !IsHeld(post);
