// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: dafny1\MatrixFun.dfy /print:\Users\philipp\Desktop\boogie\boogie-k-induction-benchmarks\benchmarks\MatrixFun.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class.array2: ClassName;

axiom (forall o: ref :: 0 <= array2.Length0(o));

function array2.Length0(this: ref) : int;

axiom (forall o: ref :: 0 <= array2.Length1(o));

function array2.Length1(this: ref) : int;

const unique class._default: ClassName;

const unique xxxxxxxxxfile: $token;

axiom $file_name_is(0, xxxxxxxxxfile);

const unique #tok$0^1.8: $token;

procedure CheckWellformed$$_default.MirrorImage(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, m#0: ref where m#0 == null || (read($Heap, m#0, alloc) && dtype(m#0) == class.array2));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^1.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.this: $token;

const unique #tok$0^1.23: $token;

const unique #loc.m#0: $token;

implementation CheckWellformed$$_default.MirrorImage(this: ref, m#0: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#30: int;
  var j#31: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^1.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^1.23, cev_parameter, #loc.m#0, m#0);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == m#0);
    assume m#0 != null;
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (0 <= i#30)
    {
        assert m#0 != null;
    }

    if (0 <= i#30 && i#30 < array2.Length0(m#0))
    {
    }

    if (0 <= i#30 && i#30 < array2.Length0(m#0) && 0 <= j#31)
    {
        assert m#0 != null;
    }

    if (0 <= i#30 && i#30 < array2.Length0(m#0) && 0 <= j#31 && j#31 < array2.Length1(m#0))
    {
        assert 0 <= i#30 && i#30 < array2.Length0(m#0);
        assert 0 <= j#31 && j#31 < array2.Length1(m#0);
        assert 0 <= i#30 && i#30 < array2.Length0(m#0);
        assert m#0 != null;
        assert 0 <= array2.Length1(m#0) - 1 - j#31 && array2.Length1(m#0) - 1 - j#31 < array2.Length1(m#0);
    }

    assume (forall i#1: int, j#2: int :: 0 <= i#1 && i#1 < array2.Length0(m#0) && 0 <= j#2 && j#2 < array2.Length1(m#0) ==> read($Heap, m#0, MultiIndexField(IndexField(i#1), j#2)) == old(read($Heap, m#0, MultiIndexField(IndexField(i#1), array2.Length1(m#0) - 1 - j#2))));
}



procedure _default.MirrorImage(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, m#0: ref where m#0 == null || (read($Heap, m#0, alloc) && dtype(m#0) == class.array2));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires m#0 != null;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^1.8;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures (forall i#1: int, j#2: int :: 0 <= i#1 && i#1 < array2.Length0(m#0) && 0 <= j#2 && j#2 < array2.Length1(m#0) ==> read($Heap, m#0, MultiIndexField(IndexField(i#1), j#2)) == old(read($Heap, m#0, MultiIndexField(IndexField(i#1), array2.Length1(m#0) - 1 - j#2))));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == m#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.a#3: $token;

const unique #tok$0^7.7: $token;

const unique #tok$0^8.3: $token;

const unique #loc.b#8: $token;

const unique #tok$0^15.9: $token;

const unique #tok$0^16.5: $token;

const unique #loc.tmp#15: $token;

const unique #tok$0^27.11: $token;

const unique #tok$0^28.27: $token;

const unique #tok$0^29.15: $token;

const unique #tok$0^30.9: $token;

const unique #tok$0^32.7: $token;

implementation _default.MirrorImage(this: ref, m#0: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var a#3: int where #cev_var_update(#cev_pc, cev_local, #loc.a#3, a#3);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;
  var b#8: int where #cev_var_update(#cev_pc, cev_local, #loc.b#8, b#8);
  var $PreLoopHeap1: HeapType;
  var $decr1$init$0: int;
  var $w1: bool;
  var $PreLoopCevPC1: int;
  var $decr1$0: int;
  var tmp#15: BoxType where #cev_var_update(#cev_pc, cev_local, #loc.tmp#15, tmp#15);

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^1.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^1.23, cev_parameter, #loc.m#0, m#0);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == m#0);
    // ----- var-declaration statement ----- dafny1\MatrixFun.dfy(7,7)
    assert true;
    assert true;
    a#3 := 0;
    assume {:captureState "dafny1\MatrixFun.dfy(7,7)"} true;
    call CevVarIntro(#tok$0^7.7, cev_local, #loc.a#3, a#3);
    // ----- while statement ----- dafny1\MatrixFun.dfy(8,3)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := array2.Length0(m#0) - a#3;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^8.3);
    while (true)
      invariant $w0 ==> a#3 <= array2.Length0(m#0);
      invariant $w0 ==> (forall i#4: int, j#5: int :: 0 <= i#4 && i#4 < a#3 && 0 <= j#5 && j#5 < array2.Length1(m#0) ==> read($Heap, m#0, MultiIndexField(IndexField(i#4), j#5)) == old(read($Heap, m#0, MultiIndexField(IndexField(i#4), array2.Length1(m#0) - 1 - j#5))));
      invariant $w0 ==> (forall i#6: int, j#7: int :: a#3 <= i#6 && i#6 < array2.Length0(m#0) && 0 <= j#7 && j#7 < array2.Length1(m#0) ==> read($Heap, m#0, MultiIndexField(IndexField(i#6), j#7)) == old(read($Heap, m#0, MultiIndexField(IndexField(i#6), j#7))));
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f) || $o == m#0);
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant array2.Length0(m#0) - a#3 <= $decr0$init$0 && (array2.Length0(m#0) - a#3 == $decr0$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^8.3;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} m#0 != null;
            assume a#3 <= array2.Length0(m#0);
            assert {:subsumption 0} (forall i#4: int, j#5: int :: (0 <= i#4 ==> true) && (0 <= i#4 && i#4 < a#3 ==> true) && (0 <= i#4 && i#4 < a#3 && 0 <= j#5 ==> m#0 != null) && (0 <= i#4 && i#4 < a#3 && 0 <= j#5 && j#5 < array2.Length1(m#0) ==> 0 <= i#4 && i#4 < array2.Length0(m#0) && 0 <= j#5 && j#5 < array2.Length1(m#0) && old(0 <= i#4 && i#4 < array2.Length0(m#0) && m#0 != null && 0 <= array2.Length1(m#0) - 1 - j#5 && array2.Length1(m#0) - 1 - j#5 < array2.Length1(m#0))));
            assume (forall i#4: int, j#5: int :: 0 <= i#4 && i#4 < a#3 && 0 <= j#5 && j#5 < array2.Length1(m#0) ==> read($Heap, m#0, MultiIndexField(IndexField(i#4), j#5)) == old(read($Heap, m#0, MultiIndexField(IndexField(i#4), array2.Length1(m#0) - 1 - j#5))));
            assert {:subsumption 0} (forall i#6: int, j#7: int :: (a#3 <= i#6 ==> m#0 != null) && (a#3 <= i#6 && i#6 < array2.Length0(m#0) ==> true) && (a#3 <= i#6 && i#6 < array2.Length0(m#0) && 0 <= j#7 ==> m#0 != null) && (a#3 <= i#6 && i#6 < array2.Length0(m#0) && 0 <= j#7 && j#7 < array2.Length1(m#0) ==> 0 <= i#6 && i#6 < array2.Length0(m#0) && 0 <= j#7 && j#7 < array2.Length1(m#0) && old(0 <= i#6 && i#6 < array2.Length0(m#0) && 0 <= j#7 && j#7 < array2.Length1(m#0))));
            assume (forall i#6: int, j#7: int :: a#3 <= i#6 && i#6 < array2.Length0(m#0) && 0 <= j#7 && j#7 < array2.Length1(m#0) ==> read($Heap, m#0, MultiIndexField(IndexField(i#6), j#7)) == old(read($Heap, m#0, MultiIndexField(IndexField(i#6), j#7))));
            assert m#0 != null;
            assume false;
        }

        assert m#0 != null;
        if (a#3 >= array2.Length0(m#0))
        {
            break;
        }

        call CevStepEvent(#tok$0^8.3, loop_entered);
        assume {:captureState "dafny1\MatrixFun.dfy(8,3): loop entered"} true;
        $decr0$0 := array2.Length0(m#0) - a#3;
        // ----- var-declaration statement ----- dafny1\MatrixFun.dfy(15,9)
        assert true;
        assert true;
        b#8 := 0;
        assume {:captureState "dafny1\MatrixFun.dfy(15,9)"} true;
        call CevVarIntro(#tok$0^15.9, cev_local, #loc.b#8, b#8);
        // ----- while statement ----- dafny1\MatrixFun.dfy(16,5)
        $PreLoopHeap1 := $Heap;
        $decr1$init$0 := array2.Length1(m#0) / 2 - b#8;
        havoc $w1;
        call $PreLoopCevPC1 := CevPreLoop(#tok$0^16.5);
        while (true)
          invariant $w1 ==> b#8 <= array2.Length1(m#0) / 2;
          invariant $w1 ==> (forall i#9: int, j#10: int :: 0 <= i#9 && i#9 < a#3 && 0 <= j#10 && j#10 < array2.Length1(m#0) ==> read($Heap, m#0, MultiIndexField(IndexField(i#9), j#10)) == old(read($Heap, m#0, MultiIndexField(IndexField(i#9), array2.Length1(m#0) - 1 - j#10))));
          invariant $w1 ==> (forall j#11: int :: 0 <= j#11 && j#11 < b#8 ==> read($Heap, m#0, MultiIndexField(IndexField(a#3), j#11)) == old(read($Heap, m#0, MultiIndexField(IndexField(a#3), array2.Length1(m#0) - 1 - j#11))) && old(read($Heap, m#0, MultiIndexField(IndexField(a#3), j#11))) == read($Heap, m#0, MultiIndexField(IndexField(a#3), array2.Length1(m#0) - 1 - j#11)));
          invariant $w1 ==> (forall j#12: int :: b#8 <= j#12 && j#12 < array2.Length1(m#0) - b#8 ==> read($Heap, m#0, MultiIndexField(IndexField(a#3), j#12)) == old(read($Heap, m#0, MultiIndexField(IndexField(a#3), j#12))));
          invariant $w1 ==> (forall i#13: int, j#14: int :: a#3 + 1 <= i#13 && i#13 < array2.Length0(m#0) && 0 <= j#14 && j#14 < array2.Length1(m#0) ==> read($Heap, m#0, MultiIndexField(IndexField(i#13), j#14)) == old(read($Heap, m#0, MultiIndexField(IndexField(i#13), j#14))));
          free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap1, $o, $f) || $o == m#0);
          free invariant $HeapSucc($PreLoopHeap1, $Heap);
          free invariant array2.Length1(m#0) / 2 - b#8 <= $decr1$init$0 && (array2.Length1(m#0) / 2 - b#8 == $decr1$init$0 ==> true);
          free invariant #cev_save_position(#cev_pc) == #tok$0^16.5;
          free invariant $PreLoopCevPC1 < #cev_pc;
          free invariant #cev_control_flow_event(#cev_pc, loop_register);
	  kUnwind 1;
        {
            if (!$w1)
            {
                assert {:subsumption 0} m#0 != null && 2 != 0;
                assume b#8 <= array2.Length1(m#0) / 2;
                assert {:subsumption 0} (forall i#9: int, j#10: int :: (0 <= i#9 ==> true) && (0 <= i#9 && i#9 < a#3 ==> true) && (0 <= i#9 && i#9 < a#3 && 0 <= j#10 ==> m#0 != null) && (0 <= i#9 && i#9 < a#3 && 0 <= j#10 && j#10 < array2.Length1(m#0) ==> 0 <= i#9 && i#9 < array2.Length0(m#0) && 0 <= j#10 && j#10 < array2.Length1(m#0) && old(0 <= i#9 && i#9 < array2.Length0(m#0) && m#0 != null && 0 <= array2.Length1(m#0) - 1 - j#10 && array2.Length1(m#0) - 1 - j#10 < array2.Length1(m#0))));
                assume (forall i#9: int, j#10: int :: 0 <= i#9 && i#9 < a#3 && 0 <= j#10 && j#10 < array2.Length1(m#0) ==> read($Heap, m#0, MultiIndexField(IndexField(i#9), j#10)) == old(read($Heap, m#0, MultiIndexField(IndexField(i#9), array2.Length1(m#0) - 1 - j#10))));
                assert {:subsumption 0} (forall j#11: int :: (0 <= j#11 ==> true) && (0 <= j#11 && j#11 < b#8 ==> 0 <= a#3 && a#3 < array2.Length0(m#0) && 0 <= j#11 && j#11 < array2.Length1(m#0) && old(0 <= a#3 && a#3 < array2.Length0(m#0) && m#0 != null && 0 <= array2.Length1(m#0) - 1 - j#11 && array2.Length1(m#0) - 1 - j#11 < array2.Length1(m#0)) && (read($Heap, m#0, MultiIndexField(IndexField(a#3), j#11)) == old(read($Heap, m#0, MultiIndexField(IndexField(a#3), array2.Length1(m#0) - 1 - j#11))) ==> old(0 <= a#3 && a#3 < array2.Length0(m#0) && 0 <= j#11 && j#11 < array2.Length1(m#0)) && 0 <= a#3 && a#3 < array2.Length0(m#0) && m#0 != null && 0 <= array2.Length1(m#0) - 1 - j#11 && array2.Length1(m#0) - 1 - j#11 < array2.Length1(m#0))));
                assume (forall j#11: int :: 0 <= j#11 && j#11 < b#8 ==> read($Heap, m#0, MultiIndexField(IndexField(a#3), j#11)) == old(read($Heap, m#0, MultiIndexField(IndexField(a#3), array2.Length1(m#0) - 1 - j#11))) && old(read($Heap, m#0, MultiIndexField(IndexField(a#3), j#11))) == read($Heap, m#0, MultiIndexField(IndexField(a#3), array2.Length1(m#0) - 1 - j#11)));
                assert {:subsumption 0} (forall j#12: int :: (b#8 <= j#12 ==> m#0 != null) && (b#8 <= j#12 && j#12 < array2.Length1(m#0) - b#8 ==> 0 <= a#3 && a#3 < array2.Length0(m#0) && 0 <= j#12 && j#12 < array2.Length1(m#0) && old(0 <= a#3 && a#3 < array2.Length0(m#0) && 0 <= j#12 && j#12 < array2.Length1(m#0))));
                assume (forall j#12: int :: b#8 <= j#12 && j#12 < array2.Length1(m#0) - b#8 ==> read($Heap, m#0, MultiIndexField(IndexField(a#3), j#12)) == old(read($Heap, m#0, MultiIndexField(IndexField(a#3), j#12))));
                assert {:subsumption 0} (forall i#13: int, j#14: int :: (a#3 + 1 <= i#13 ==> m#0 != null) && (a#3 + 1 <= i#13 && i#13 < array2.Length0(m#0) ==> true) && (a#3 + 1 <= i#13 && i#13 < array2.Length0(m#0) && 0 <= j#14 ==> m#0 != null) && (a#3 + 1 <= i#13 && i#13 < array2.Length0(m#0) && 0 <= j#14 && j#14 < array2.Length1(m#0) ==> 0 <= i#13 && i#13 < array2.Length0(m#0) && 0 <= j#14 && j#14 < array2.Length1(m#0) && old(0 <= i#13 && i#13 < array2.Length0(m#0) && 0 <= j#14 && j#14 < array2.Length1(m#0))));
                assume (forall i#13: int, j#14: int :: a#3 + 1 <= i#13 && i#13 < array2.Length0(m#0) && 0 <= j#14 && j#14 < array2.Length1(m#0) ==> read($Heap, m#0, MultiIndexField(IndexField(i#13), j#14)) == old(read($Heap, m#0, MultiIndexField(IndexField(i#13), j#14))));
                assert m#0 != null && 2 != 0;
                assume false;
            }

            assert m#0 != null && 2 != 0;
            if (b#8 >= array2.Length1(m#0) / 2)
            {
                break;
            }

            call CevStepEvent(#tok$0^16.5, loop_entered);
            assume {:captureState "dafny1\MatrixFun.dfy(16,5): loop entered"} true;
            $decr1$0 := array2.Length1(m#0) / 2 - b#8;
            // ----- var-declaration statement ----- dafny1\MatrixFun.dfy(27,11)
            assert true;
            assert 0 <= a#3 && a#3 < array2.Length0(m#0) && m#0 != null && 0 <= array2.Length1(m#0) - 1 - b#8 && array2.Length1(m#0) - 1 - b#8 < array2.Length1(m#0);
            tmp#15 := read($Heap, m#0, MultiIndexField(IndexField(a#3), array2.Length1(m#0) - 1 - b#8));
            assume {:captureState "dafny1\MatrixFun.dfy(27,11)"} true;
            call CevVarIntro(#tok$0^27.11, cev_local, #loc.tmp#15, tmp#15);
            // ----- assignment statement ----- dafny1\MatrixFun.dfy(28,27)
            assert 0 <= a#3 && a#3 < array2.Length0(m#0) && m#0 != null && 0 <= array2.Length1(m#0) - 1 - b#8 && array2.Length1(m#0) - 1 - b#8 < array2.Length1(m#0);
            assert 0 <= a#3 && a#3 < array2.Length0(m#0) && 0 <= b#8 && b#8 < array2.Length1(m#0);
            assert $_Frame[m#0, MultiIndexField(IndexField(a#3), array2.Length1(m#0) - 1 - b#8)];
            $Heap := update($Heap, m#0, MultiIndexField(IndexField(a#3), array2.Length1(m#0) - 1 - b#8), read($Heap, m#0, MultiIndexField(IndexField(a#3), b#8)));
            assume $IsGoodHeap($Heap);
            assume {:captureState "dafny1\MatrixFun.dfy(28,27)"} true;
            call CevUpdateHeap(#tok$0^28.27, #loc.$Heap, $Heap);
            // ----- assignment statement ----- dafny1\MatrixFun.dfy(29,15)
            assert 0 <= a#3 && a#3 < array2.Length0(m#0) && 0 <= b#8 && b#8 < array2.Length1(m#0);
            assert true;
            assert $_Frame[m#0, MultiIndexField(IndexField(a#3), b#8)];
            $Heap := update($Heap, m#0, MultiIndexField(IndexField(a#3), b#8), tmp#15);
            assume $IsGoodHeap($Heap);
            assume {:captureState "dafny1\MatrixFun.dfy(29,15)"} true;
            call CevUpdateHeap(#tok$0^29.15, #loc.$Heap, $Heap);
            // ----- assignment statement ----- dafny1\MatrixFun.dfy(30,9)
            assert true;
            assert true;
            b#8 := b#8 + 1;
            assume {:captureState "dafny1\MatrixFun.dfy(30,9)"} true;
            call CevUpdate(#tok$0^30.9, #loc.b#8, b#8);
            assert 0 <= $decr1$0 || array2.Length1(m#0) / 2 - b#8 == $decr1$0;
            assert array2.Length1(m#0) / 2 - b#8 < $decr1$0;
        }

        call CevStepEvent(#tok$0^16.5, loop_exited);
        assume {:captureState "dafny1\MatrixFun.dfy(16,5): loop exit"} true;
        // ----- assignment statement ----- dafny1\MatrixFun.dfy(32,7)
        assert true;
        assert true;
        a#3 := a#3 + 1;
        assume {:captureState "dafny1\MatrixFun.dfy(32,7)"} true;
        call CevUpdate(#tok$0^32.7, #loc.a#3, a#3);
        assert 0 <= $decr0$0 || array2.Length0(m#0) - a#3 == $decr0$0;
        assert array2.Length0(m#0) - a#3 < $decr0$0;
    }

    call CevStepEvent(#tok$0^8.3, loop_exited);
    assume {:captureState "dafny1\MatrixFun.dfy(8,3): loop exit"} true;
}



const unique #tok$0^36.8: $token;

procedure CheckWellformed$$_default.Flip(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, m#16: ref where m#16 == null || (read($Heap, m#16, alloc) && dtype(m#16) == class.array2));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^36.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^36.16: $token;

const unique #loc.m#16: $token;

implementation CheckWellformed$$_default.Flip(this: ref, m#16: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#32: int;
  var j#33: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^36.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^36.16, cev_parameter, #loc.m#16, m#16);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == m#16);
    if (m#16 != null)
    {
        assert m#16 != null;
        assert m#16 != null;
    }

    assume m#16 != null && array2.Length0(m#16) == array2.Length1(m#16);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (0 <= i#32)
    {
        assert m#16 != null;
    }

    if (0 <= i#32 && i#32 < array2.Length0(m#16))
    {
    }

    if (0 <= i#32 && i#32 < array2.Length0(m#16) && 0 <= j#33)
    {
        assert m#16 != null;
    }

    if (0 <= i#32 && i#32 < array2.Length0(m#16) && 0 <= j#33 && j#33 < array2.Length1(m#16))
    {
        assert 0 <= i#32 && i#32 < array2.Length0(m#16);
        assert 0 <= j#33 && j#33 < array2.Length1(m#16);
        assert 0 <= j#33 && j#33 < array2.Length0(m#16);
        assert 0 <= i#32 && i#32 < array2.Length1(m#16);
    }

    assume (forall i#17: int, j#18: int :: 0 <= i#17 && i#17 < array2.Length0(m#16) && 0 <= j#18 && j#18 < array2.Length1(m#16) ==> read($Heap, m#16, MultiIndexField(IndexField(i#17), j#18)) == old(read($Heap, m#16, MultiIndexField(IndexField(j#18), i#17))));
}



procedure _default.Flip(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, m#16: ref where m#16 == null || (read($Heap, m#16, alloc) && dtype(m#16) == class.array2));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires m#16 != null && array2.Length0(m#16) == array2.Length1(m#16);
  requires true ==> m#16 != null;
  requires true ==> array2.Length0(m#16) == array2.Length1(m#16);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^36.8;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures (forall i#17: int, j#18: int :: 0 <= i#17 && i#17 < array2.Length0(m#16) && 0 <= j#18 && j#18 < array2.Length1(m#16) ==> read($Heap, m#16, MultiIndexField(IndexField(i#17), j#18)) == old(read($Heap, m#16, MultiIndexField(IndexField(j#18), i#17))));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == m#16);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.N#19: $token;

const unique #tok$0^41.7: $token;

const unique #loc.a#20: $token;

const unique #tok$0^42.7: $token;

const unique #loc.b#21: $token;

const unique #tok$0^43.7: $token;

const unique #tok$0^44.3: $token;

const unique #tok$0^52.5: $token;

const unique #tok$0^52.16: $token;

const unique #loc.tmp#24: $token;

const unique #tok$0^53.11: $token;

const unique #tok$0^53.34: $token;

const unique #tok$0^53.53: $token;

const unique #tok$0^54.9: $token;

const unique #tok$0^55.12: $token;

const unique #tok$0^56.9: $token;

const unique #tok$0^56.22: $token;

implementation _default.Flip(this: ref, m#16: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var N#19: int where #cev_var_update(#cev_pc, cev_local, #loc.N#19, N#19);
  var a#20: int where #cev_var_update(#cev_pc, cev_local, #loc.a#20, a#20);
  var b#21: int where #cev_var_update(#cev_pc, cev_local, #loc.b#21, b#21);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $decr0$init$1: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;
  var $decr0$1: int;
  var tmp#24: BoxType where #cev_var_update(#cev_pc, cev_local, #loc.tmp#24, tmp#24);

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^36.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^36.16, cev_parameter, #loc.m#16, m#16);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == m#16);
    // ----- var-declaration statement ----- dafny1\MatrixFun.dfy(41,7)
    assert true;
    assert m#16 != null;
    N#19 := array2.Length0(m#16);
    assume {:captureState "dafny1\MatrixFun.dfy(41,7)"} true;
    call CevVarIntro(#tok$0^41.7, cev_local, #loc.N#19, N#19);
    // ----- var-declaration statement ----- dafny1\MatrixFun.dfy(42,7)
    assert true;
    assert true;
    a#20 := 0;
    assume {:captureState "dafny1\MatrixFun.dfy(42,7)"} true;
    call CevVarIntro(#tok$0^42.7, cev_local, #loc.a#20, a#20);
    // ----- var-declaration statement ----- dafny1\MatrixFun.dfy(43,7)
    assert true;
    assert true;
    b#21 := 0;
    assume {:captureState "dafny1\MatrixFun.dfy(43,7)"} true;
    call CevVarIntro(#tok$0^43.7, cev_local, #loc.b#21, b#21);
    // ----- while statement ----- dafny1\MatrixFun.dfy(44,3)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := N#19 - a#20;
    $decr0$init$1 := N#19 - b#21;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^44.3);
    while (true)
      invariant $w0 ==> a#20 <= b#21;
      invariant $w0 ==> b#21 <= N#19;
//      free invariant $w0 ==> a#20 <= b#21 && b#21 <= N#19;
      invariant $w0 ==> (forall i#22: int, j#23: int :: 0 <= i#22 && i#22 <= j#23 && j#23 < N#19 ==> $ite(i#22 < a#20 || (i#22 == a#20 && j#23 < b#21), read($Heap, m#16, MultiIndexField(IndexField(i#22), j#23)) == old(read($Heap, m#16, MultiIndexField(IndexField(j#23), i#22))) && read($Heap, m#16, MultiIndexField(IndexField(j#23), i#22)) == old(read($Heap, m#16, MultiIndexField(IndexField(i#22), j#23))), read($Heap, m#16, MultiIndexField(IndexField(i#22), j#23)) == old(read($Heap, m#16, MultiIndexField(IndexField(i#22), j#23))) && read($Heap, m#16, MultiIndexField(IndexField(j#23), i#22)) == old(read($Heap, m#16, MultiIndexField(IndexField(j#23), i#22)))));
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f) || $o == m#16);
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant N#19 - a#20 <= $decr0$init$0 && (N#19 - a#20 == $decr0$init$0 ==> N#19 - b#21 <= $decr0$init$1 && (N#19 - b#21 == $decr0$init$1 ==> true));
      free invariant #cev_save_position(#cev_pc) == #tok$0^44.3;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} a#20 <= b#21 ==> true;
            assume a#20 <= b#21 && b#21 <= N#19;
            assert {:subsumption 0} (forall i#22: int, j#23: int :: (0 <= i#22 ==> true) && (0 <= i#22 && i#22 <= j#23 ==> true) && (0 <= i#22 && i#22 <= j#23 && j#23 < N#19 ==> (i#22 >= a#20 ==> i#22 == a#20 ==> true) && (i#22 < a#20 || (i#22 == a#20 && j#23 < b#21) ==> 0 <= i#22 && i#22 < array2.Length0(m#16) && 0 <= j#23 && j#23 < array2.Length1(m#16) && old(0 <= j#23 && j#23 < array2.Length0(m#16) && 0 <= i#22 && i#22 < array2.Length1(m#16)) && (read($Heap, m#16, MultiIndexField(IndexField(i#22), j#23)) == old(read($Heap, m#16, MultiIndexField(IndexField(j#23), i#22))) ==> 0 <= j#23 && j#23 < array2.Length0(m#16) && 0 <= i#22 && i#22 < array2.Length1(m#16) && old(0 <= i#22 && i#22 < array2.Length0(m#16) && 0 <= j#23 && j#23 < array2.Length1(m#16)))) && (!(i#22 < a#20 || (i#22 == a#20 && j#23 < b#21)) ==> 0 <= i#22 && i#22 < array2.Length0(m#16) && 0 <= j#23 && j#23 < array2.Length1(m#16) && old(0 <= i#22 && i#22 < array2.Length0(m#16) && 0 <= j#23 && j#23 < array2.Length1(m#16)) && (read($Heap, m#16, MultiIndexField(IndexField(i#22), j#23)) == old(read($Heap, m#16, MultiIndexField(IndexField(i#22), j#23))) ==> 0 <= j#23 && j#23 < array2.Length0(m#16) && 0 <= i#22 && i#22 < array2.Length1(m#16) && old(0 <= j#23 && j#23 < array2.Length0(m#16) && 0 <= i#22 && i#22 < array2.Length1(m#16))))));
            assume (forall i#22: int, j#23: int :: 0 <= i#22 && i#22 <= j#23 && j#23 < N#19 ==> $ite(i#22 < a#20 || (i#22 == a#20 && j#23 < b#21), read($Heap, m#16, MultiIndexField(IndexField(i#22), j#23)) == old(read($Heap, m#16, MultiIndexField(IndexField(j#23), i#22))) && read($Heap, m#16, MultiIndexField(IndexField(j#23), i#22)) == old(read($Heap, m#16, MultiIndexField(IndexField(i#22), j#23))), read($Heap, m#16, MultiIndexField(IndexField(i#22), j#23)) == old(read($Heap, m#16, MultiIndexField(IndexField(i#22), j#23))) && read($Heap, m#16, MultiIndexField(IndexField(j#23), i#22)) == old(read($Heap, m#16, MultiIndexField(IndexField(j#23), i#22)))));
            assert true;
            assert true;
            assume false;
        }

        assert true;
        if (a#20 == N#19)
        {
            break;
        }

        call CevStepEvent(#tok$0^44.3, loop_entered);
        assume {:captureState "dafny1\MatrixFun.dfy(44,3): loop entered"} true;
        $decr0$0 := N#19 - a#20;
        $decr0$1 := N#19 - b#21;
        // ----- if statement ----- dafny1\MatrixFun.dfy(52,5)
        call CevEvent(#tok$0^52.5, conditional_moment);
        assert true;
        if (b#21 < N#19)
        {
            call CevEvent(#tok$0^52.16, took_then_branch);
            // ----- var-declaration statement ----- dafny1\MatrixFun.dfy(53,11)
            assert true;
            assert 0 <= a#20 && a#20 < array2.Length0(m#16) && 0 <= b#21 && b#21 < array2.Length1(m#16);
            tmp#24 := read($Heap, m#16, MultiIndexField(IndexField(a#20), b#21));
            assume {:captureState "dafny1\MatrixFun.dfy(53,11)"} true;
            call CevVarIntro(#tok$0^53.11, cev_local, #loc.tmp#24, tmp#24);
            // ----- assignment statement ----- dafny1\MatrixFun.dfy(53,34)
            assert 0 <= a#20 && a#20 < array2.Length0(m#16) && 0 <= b#21 && b#21 < array2.Length1(m#16);
            assert 0 <= b#21 && b#21 < array2.Length0(m#16) && 0 <= a#20 && a#20 < array2.Length1(m#16);
            assert $_Frame[m#16, MultiIndexField(IndexField(a#20), b#21)];
            $Heap := update($Heap, m#16, MultiIndexField(IndexField(a#20), b#21), read($Heap, m#16, MultiIndexField(IndexField(b#21), a#20)));
            assume $IsGoodHeap($Heap);
            assume {:captureState "dafny1\MatrixFun.dfy(53,34)"} true;
            call CevUpdateHeap(#tok$0^53.34, #loc.$Heap, $Heap);
            // ----- assignment statement ----- dafny1\MatrixFun.dfy(53,53)
            assert 0 <= b#21 && b#21 < array2.Length0(m#16) && 0 <= a#20 && a#20 < array2.Length1(m#16);
            assert true;
            assert $_Frame[m#16, MultiIndexField(IndexField(b#21), a#20)];
            $Heap := update($Heap, m#16, MultiIndexField(IndexField(b#21), a#20), tmp#24);
            assume $IsGoodHeap($Heap);
            assume {:captureState "dafny1\MatrixFun.dfy(53,53)"} true;
            call CevUpdateHeap(#tok$0^53.53, #loc.$Heap, $Heap);
            // ----- assignment statement ----- dafny1\MatrixFun.dfy(54,9)
            assert true;
            assert true;
            b#21 := b#21 + 1;
            assume {:captureState "dafny1\MatrixFun.dfy(54,9)"} true;
            call CevUpdate(#tok$0^54.9, #loc.b#21, b#21);
        }
        else
        {
            call CevEvent(#tok$0^55.12, took_else_branch);
            // ----- assignment statement ----- dafny1\MatrixFun.dfy(56,9)
            assert true;
            assert true;
            a#20 := a#20 + 1;
            assume {:captureState "dafny1\MatrixFun.dfy(56,9)"} true;
            call CevUpdate(#tok$0^56.9, #loc.a#20, a#20);
            // ----- assignment statement ----- dafny1\MatrixFun.dfy(56,22)
            assert true;
            assert true;
            b#21 := a#20;
            assume {:captureState "dafny1\MatrixFun.dfy(56,22)"} true;
            call CevUpdate(#tok$0^56.22, #loc.b#21, b#21);
        }

        assert 0 <= $decr0$0 || N#19 - a#20 == $decr0$0;
        assert 0 <= $decr0$1 || N#19 - a#20 < $decr0$0 || N#19 - b#21 == $decr0$1;
        assert N#19 - a#20 < $decr0$0 || (N#19 - a#20 == $decr0$0 && N#19 - b#21 < $decr0$1);
    }

    call CevStepEvent(#tok$0^44.3, loop_exited);
    assume {:captureState "dafny1\MatrixFun.dfy(44,3): loop exit"} true;
}



const unique #tok$0^61.8: $token;

procedure CheckWellformed$$_default.Main(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^61.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



implementation CheckWellformed$$_default.Main(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^61.8, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
}



procedure _default.Main(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^61.8;
  modifies $Heap, #cev_pc;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.B#25: $token;

const unique #tok$0^63.7: $token;

const unique #tok$0^64.10: $token;

const unique #tok$0^64.27: $token;

const unique #tok$0^64.45: $token;

const unique #tok$0^64.63: $token;

const unique #tok$0^64.80: $token;

const unique #tok$0^65.10: $token;

const unique #tok$0^65.27: $token;

const unique #tok$0^65.45: $token;

const unique #tok$0^65.63: $token;

const unique #tok$0^65.80: $token;

const unique #tok$0^67.3: $token;

const unique #tok$0^68.3: $token;

const unique #tok$0^70.3: $token;

const unique #loc.A#26: $token;

const unique #tok$0^72.7: $token;

const unique #tok$0^73.10: $token;

const unique #tok$0^73.24: $token;

const unique #tok$0^73.38: $token;

const unique #tok$0^74.10: $token;

const unique #tok$0^74.24: $token;

const unique #tok$0^74.38: $token;

const unique #tok$0^75.10: $token;

const unique #tok$0^75.24: $token;

const unique #tok$0^75.38: $token;

const unique #tok$0^77.3: $token;

const unique #tok$0^78.3: $token;

const unique #tok$0^80.3: $token;

implementation _default.Main(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var B#25: ref where (B#25 == null || (read($Heap, B#25, alloc) && dtype(B#25) == class.array2 && TypeParams(B#25, 0) == class.bool)) && #cev_var_update(#cev_pc, cev_local, #loc.B#25, B#25);
  var $nw: ref;
  var m#34: ref;
  var m#35: ref;
  var m#36: ref;
  var A#26: ref where (A#26 == null || (read($Heap, A#26, alloc) && dtype(A#26) == class.array2 && TypeParams(A#26, 0) == class.int)) && #cev_var_update(#cev_pc, cev_local, #loc.A#26, A#26);
  var m#37: ref;
  var m#38: ref;
  var m#39: ref;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^61.8, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- dafny1\MatrixFun.dfy(63,7)
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.array2 && TypeParams($nw, 0) == class.bool;
    assume array2.Length0($nw) == 2;
    assume array2.Length1($nw) == 5;
    $Heap := update($Heap, $nw, alloc, true);
    B#25 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(63,7)"} true;
    call CevVarIntro(#tok$0^63.7, cev_local, #loc.B#25, B#25);
    // ----- assignment statement ----- dafny1\MatrixFun.dfy(64,10)
    assert 0 <= 0 && 0 < array2.Length0(B#25) && 0 <= 0 && 0 < array2.Length1(B#25);
    assert true;
    assert $_Frame[B#25, MultiIndexField(IndexField(0), 0)];
    $Heap := update($Heap, B#25, MultiIndexField(IndexField(0), 0), $Box(true));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(64,10)"} true;
    call CevUpdateHeap(#tok$0^64.10, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\MatrixFun.dfy(64,27)
    assert 0 <= 0 && 0 < array2.Length0(B#25) && 0 <= 1 && 1 < array2.Length1(B#25);
    assert true;
    assert $_Frame[B#25, MultiIndexField(IndexField(0), 1)];
    $Heap := update($Heap, B#25, MultiIndexField(IndexField(0), 1), $Box(false));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(64,27)"} true;
    call CevUpdateHeap(#tok$0^64.27, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\MatrixFun.dfy(64,45)
    assert 0 <= 0 && 0 < array2.Length0(B#25) && 0 <= 2 && 2 < array2.Length1(B#25);
    assert true;
    assert $_Frame[B#25, MultiIndexField(IndexField(0), 2)];
    $Heap := update($Heap, B#25, MultiIndexField(IndexField(0), 2), $Box(false));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(64,45)"} true;
    call CevUpdateHeap(#tok$0^64.45, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\MatrixFun.dfy(64,63)
    assert 0 <= 0 && 0 < array2.Length0(B#25) && 0 <= 3 && 3 < array2.Length1(B#25);
    assert true;
    assert $_Frame[B#25, MultiIndexField(IndexField(0), 3)];
    $Heap := update($Heap, B#25, MultiIndexField(IndexField(0), 3), $Box(true));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(64,63)"} true;
    call CevUpdateHeap(#tok$0^64.63, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\MatrixFun.dfy(64,80)
    assert 0 <= 0 && 0 < array2.Length0(B#25) && 0 <= 4 && 4 < array2.Length1(B#25);
    assert true;
    assert $_Frame[B#25, MultiIndexField(IndexField(0), 4)];
    $Heap := update($Heap, B#25, MultiIndexField(IndexField(0), 4), $Box(false));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(64,80)"} true;
    call CevUpdateHeap(#tok$0^64.80, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\MatrixFun.dfy(65,10)
    assert 0 <= 1 && 1 < array2.Length0(B#25) && 0 <= 0 && 0 < array2.Length1(B#25);
    assert true;
    assert $_Frame[B#25, MultiIndexField(IndexField(1), 0)];
    $Heap := update($Heap, B#25, MultiIndexField(IndexField(1), 0), $Box(true));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(65,10)"} true;
    call CevUpdateHeap(#tok$0^65.10, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\MatrixFun.dfy(65,27)
    assert 0 <= 1 && 1 < array2.Length0(B#25) && 0 <= 1 && 1 < array2.Length1(B#25);
    assert true;
    assert $_Frame[B#25, MultiIndexField(IndexField(1), 1)];
    $Heap := update($Heap, B#25, MultiIndexField(IndexField(1), 1), $Box(true));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(65,27)"} true;
    call CevUpdateHeap(#tok$0^65.27, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\MatrixFun.dfy(65,45)
    assert 0 <= 1 && 1 < array2.Length0(B#25) && 0 <= 2 && 2 < array2.Length1(B#25);
    assert true;
    assert $_Frame[B#25, MultiIndexField(IndexField(1), 2)];
    $Heap := update($Heap, B#25, MultiIndexField(IndexField(1), 2), $Box(true));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(65,45)"} true;
    call CevUpdateHeap(#tok$0^65.45, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\MatrixFun.dfy(65,63)
    assert 0 <= 1 && 1 < array2.Length0(B#25) && 0 <= 3 && 3 < array2.Length1(B#25);
    assert true;
    assert $_Frame[B#25, MultiIndexField(IndexField(1), 3)];
    $Heap := update($Heap, B#25, MultiIndexField(IndexField(1), 3), $Box(true));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(65,63)"} true;
    call CevUpdateHeap(#tok$0^65.63, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\MatrixFun.dfy(65,80)
    assert 0 <= 1 && 1 < array2.Length0(B#25) && 0 <= 4 && 4 < array2.Length1(B#25);
    assert true;
    assert $_Frame[B#25, MultiIndexField(IndexField(1), 4)];
    $Heap := update($Heap, B#25, MultiIndexField(IndexField(1), 4), $Box(false));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(65,80)"} true;
    call CevUpdateHeap(#tok$0^65.80, #loc.$Heap, $Heap);
    // ----- print statement ----- dafny1\MatrixFun.dfy(66,3)
    // ----- call statement ----- dafny1\MatrixFun.dfy(67,3)
    assert true;
    m#34 := B#25;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.PrintMatrix(this, m#34);
    call CevStep(#tok$0^67.3);
    assume {:captureState "dafny1\MatrixFun.dfy(67,3)"} true;
    // ----- call statement ----- dafny1\MatrixFun.dfy(68,3)
    assert true;
    m#35 := B#25;
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == m#35 ==> $_Frame[$o, $f]);
    call _default.MirrorImage(this, m#35);
    call CevStep(#tok$0^68.3);
    assume {:captureState "dafny1\MatrixFun.dfy(68,3)"} true;
    // ----- print statement ----- dafny1\MatrixFun.dfy(69,3)
    // ----- call statement ----- dafny1\MatrixFun.dfy(70,3)
    assert true;
    m#36 := B#25;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.PrintMatrix(this, m#36);
    call CevStep(#tok$0^70.3);
    assume {:captureState "dafny1\MatrixFun.dfy(70,3)"} true;
    // ----- var-declaration statement ----- dafny1\MatrixFun.dfy(72,7)
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.array2 && TypeParams($nw, 0) == class.int;
    assume array2.Length0($nw) == 3;
    assume array2.Length1($nw) == 3;
    $Heap := update($Heap, $nw, alloc, true);
    A#26 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(72,7)"} true;
    call CevVarIntro(#tok$0^72.7, cev_local, #loc.A#26, A#26);
    // ----- assignment statement ----- dafny1\MatrixFun.dfy(73,10)
    assert 0 <= 0 && 0 < array2.Length0(A#26) && 0 <= 0 && 0 < array2.Length1(A#26);
    assert true;
    assert $_Frame[A#26, MultiIndexField(IndexField(0), 0)];
    $Heap := update($Heap, A#26, MultiIndexField(IndexField(0), 0), $Box(5));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(73,10)"} true;
    call CevUpdateHeap(#tok$0^73.10, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\MatrixFun.dfy(73,24)
    assert 0 <= 0 && 0 < array2.Length0(A#26) && 0 <= 1 && 1 < array2.Length1(A#26);
    assert true;
    assert $_Frame[A#26, MultiIndexField(IndexField(0), 1)];
    $Heap := update($Heap, A#26, MultiIndexField(IndexField(0), 1), $Box(7));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(73,24)"} true;
    call CevUpdateHeap(#tok$0^73.24, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\MatrixFun.dfy(73,38)
    assert 0 <= 0 && 0 < array2.Length0(A#26) && 0 <= 2 && 2 < array2.Length1(A#26);
    assert true;
    assert $_Frame[A#26, MultiIndexField(IndexField(0), 2)];
    $Heap := update($Heap, A#26, MultiIndexField(IndexField(0), 2), $Box(9));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(73,38)"} true;
    call CevUpdateHeap(#tok$0^73.38, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\MatrixFun.dfy(74,10)
    assert 0 <= 1 && 1 < array2.Length0(A#26) && 0 <= 0 && 0 < array2.Length1(A#26);
    assert true;
    assert $_Frame[A#26, MultiIndexField(IndexField(1), 0)];
    $Heap := update($Heap, A#26, MultiIndexField(IndexField(1), 0), $Box(6));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(74,10)"} true;
    call CevUpdateHeap(#tok$0^74.10, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\MatrixFun.dfy(74,24)
    assert 0 <= 1 && 1 < array2.Length0(A#26) && 0 <= 1 && 1 < array2.Length1(A#26);
    assert true;
    assert $_Frame[A#26, MultiIndexField(IndexField(1), 1)];
    $Heap := update($Heap, A#26, MultiIndexField(IndexField(1), 1), $Box(2));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(74,24)"} true;
    call CevUpdateHeap(#tok$0^74.24, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\MatrixFun.dfy(74,38)
    assert 0 <= 1 && 1 < array2.Length0(A#26) && 0 <= 2 && 2 < array2.Length1(A#26);
    assert true;
    assert $_Frame[A#26, MultiIndexField(IndexField(1), 2)];
    $Heap := update($Heap, A#26, MultiIndexField(IndexField(1), 2), $Box(3));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(74,38)"} true;
    call CevUpdateHeap(#tok$0^74.38, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\MatrixFun.dfy(75,10)
    assert 0 <= 2 && 2 < array2.Length0(A#26) && 0 <= 0 && 0 < array2.Length1(A#26);
    assert true;
    assert $_Frame[A#26, MultiIndexField(IndexField(2), 0)];
    $Heap := update($Heap, A#26, MultiIndexField(IndexField(2), 0), $Box(7));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(75,10)"} true;
    call CevUpdateHeap(#tok$0^75.10, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\MatrixFun.dfy(75,24)
    assert 0 <= 2 && 2 < array2.Length0(A#26) && 0 <= 1 && 1 < array2.Length1(A#26);
    assert true;
    assert $_Frame[A#26, MultiIndexField(IndexField(2), 1)];
    $Heap := update($Heap, A#26, MultiIndexField(IndexField(2), 1), $Box(1));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(75,24)"} true;
    call CevUpdateHeap(#tok$0^75.24, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\MatrixFun.dfy(75,38)
    assert 0 <= 2 && 2 < array2.Length0(A#26) && 0 <= 2 && 2 < array2.Length1(A#26);
    assert true;
    assert $_Frame[A#26, MultiIndexField(IndexField(2), 2)];
    $Heap := update($Heap, A#26, MultiIndexField(IndexField(2), 2), $Box(0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\MatrixFun.dfy(75,38)"} true;
    call CevUpdateHeap(#tok$0^75.38, #loc.$Heap, $Heap);
    // ----- print statement ----- dafny1\MatrixFun.dfy(76,3)
    // ----- call statement ----- dafny1\MatrixFun.dfy(77,3)
    assert true;
    m#37 := A#26;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.PrintMatrix(this, m#37);
    call CevStep(#tok$0^77.3);
    assume {:captureState "dafny1\MatrixFun.dfy(77,3)"} true;
    // ----- call statement ----- dafny1\MatrixFun.dfy(78,3)
    assert true;
    m#38 := A#26;
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == m#38 ==> $_Frame[$o, $f]);
    call _default.Flip(this, m#38);
    call CevStep(#tok$0^78.3);
    assume {:captureState "dafny1\MatrixFun.dfy(78,3)"} true;
    // ----- print statement ----- dafny1\MatrixFun.dfy(79,3)
    // ----- call statement ----- dafny1\MatrixFun.dfy(80,3)
    assert true;
    m#39 := A#26;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.PrintMatrix(this, m#39);
    call CevStep(#tok$0^80.3);
    assume {:captureState "dafny1\MatrixFun.dfy(80,3)"} true;
}



const unique #tok$0^83.8: $token;

procedure CheckWellformed$$_default.PrintMatrix(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, m#27: ref where m#27 == null || (read($Heap, m#27, alloc) && dtype(m#27) == class.array2));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^83.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^83.23: $token;

const unique #loc.m#27: $token;

implementation CheckWellformed$$_default.PrintMatrix(this: ref, m#27: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^83.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^83.23, cev_parameter, #loc.m#27, m#27);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume m#27 != null;
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
}



procedure _default.PrintMatrix(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, m#27: ref where m#27 == null || (read($Heap, m#27, alloc) && dtype(m#27) == class.array2));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires m#27 != null;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^83.8;
  modifies $Heap, #cev_pc;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.i#28: $token;

const unique #tok$0^86.7: $token;

const unique #tok$0^87.3: $token;

const unique #loc.j#29: $token;

const unique #tok$0^88.9: $token;

const unique #tok$0^89.5: $token;

const unique #tok$0^91.9: $token;

const unique #tok$0^92.7: $token;

const unique #tok$0^92.27: $token;

const unique #tok$0^94.14: $token;

const unique #tok$0^98.7: $token;

implementation _default.PrintMatrix(this: ref, m#27: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#28: int where #cev_var_update(#cev_pc, cev_local, #loc.i#28, i#28);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;
  var j#29: int where #cev_var_update(#cev_pc, cev_local, #loc.j#29, j#29);
  var $PreLoopHeap1: HeapType;
  var $decr1$init$0: int;
  var $w1: bool;
  var $PreLoopCevPC1: int;
  var $decr1$0: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^83.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^83.23, cev_parameter, #loc.m#27, m#27);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- dafny1\MatrixFun.dfy(86,7)
    assert true;
    assert true;
    i#28 := 0;
    assume {:captureState "dafny1\MatrixFun.dfy(86,7)"} true;
    call CevVarIntro(#tok$0^86.7, cev_local, #loc.i#28, i#28);
    // ----- while statement ----- dafny1\MatrixFun.dfy(87,3)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := array2.Length0(m#27) - i#28;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^87.3);
    while (true)
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant array2.Length0(m#27) - i#28 <= $decr0$init$0 && (array2.Length0(m#27) - i#28 == $decr0$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^87.3;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert m#27 != null;
            assume false;
        }

        assert m#27 != null;
        if (i#28 >= array2.Length0(m#27))
        {
            break;
        }

        call CevStepEvent(#tok$0^87.3, loop_entered);
        assume {:captureState "dafny1\MatrixFun.dfy(87,3): loop entered"} true;
        $decr0$0 := array2.Length0(m#27) - i#28;
        // ----- var-declaration statement ----- dafny1\MatrixFun.dfy(88,9)
        assert true;
        assert true;
        j#29 := 0;
        assume {:captureState "dafny1\MatrixFun.dfy(88,9)"} true;
        call CevVarIntro(#tok$0^88.9, cev_local, #loc.j#29, j#29);
        // ----- while statement ----- dafny1\MatrixFun.dfy(89,5)
        $PreLoopHeap1 := $Heap;
        $decr1$init$0 := array2.Length1(m#27) - j#29;
        havoc $w1;
        call $PreLoopCevPC1 := CevPreLoop(#tok$0^89.5);
        while (true)
          free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap1, $o, $f));
          free invariant $HeapSucc($PreLoopHeap1, $Heap);
          free invariant array2.Length1(m#27) - j#29 <= $decr1$init$0 && (array2.Length1(m#27) - j#29 == $decr1$init$0 ==> true);
          free invariant #cev_save_position(#cev_pc) == #tok$0^89.5;
          free invariant $PreLoopCevPC1 < #cev_pc;
          free invariant #cev_control_flow_event(#cev_pc, loop_register);
	  kUnwind 1;
        {
            if (!$w1)
            {
                assert m#27 != null;
                assume false;
            }

            assert m#27 != null;
            if (j#29 >= array2.Length1(m#27))
            {
                break;
            }

            call CevStepEvent(#tok$0^89.5, loop_entered);
            assume {:captureState "dafny1\MatrixFun.dfy(89,5): loop entered"} true;
            $decr1$0 := array2.Length1(m#27) - j#29;
            // ----- print statement ----- dafny1\MatrixFun.dfy(90,7)
            assert {:subsumption 0} 0 <= i#28 && i#28 < array2.Length0(m#27) && 0 <= j#29 && j#29 < array2.Length1(m#27);
            // ----- assignment statement ----- dafny1\MatrixFun.dfy(91,9)
            assert true;
            assert true;
            j#29 := j#29 + 1;
            assume {:captureState "dafny1\MatrixFun.dfy(91,9)"} true;
            call CevUpdate(#tok$0^91.9, #loc.j#29, j#29);
            // ----- if statement ----- dafny1\MatrixFun.dfy(92,7)
            call CevEvent(#tok$0^92.7, conditional_moment);
            assert m#27 != null;
            if (j#29 == array2.Length1(m#27))
            {
                call CevEvent(#tok$0^92.27, took_then_branch);
                // ----- print statement ----- dafny1\MatrixFun.dfy(93,9)
            }
            else
            {
                call CevEvent(#tok$0^94.14, took_else_branch);
                // ----- print statement ----- dafny1\MatrixFun.dfy(95,9)
            }

            assert 0 <= $decr1$0 || array2.Length1(m#27) - j#29 == $decr1$0;
            assert array2.Length1(m#27) - j#29 < $decr1$0;
        }

        call CevStepEvent(#tok$0^89.5, loop_exited);
        assume {:captureState "dafny1\MatrixFun.dfy(89,5): loop exit"} true;
        // ----- assignment statement ----- dafny1\MatrixFun.dfy(98,7)
        assert true;
        assert true;
        i#28 := i#28 + 1;
        assume {:captureState "dafny1\MatrixFun.dfy(98,7)"} true;
        call CevUpdate(#tok$0^98.7, #loc.i#28, i#28);
        assert 0 <= $decr0$0 || array2.Length0(m#27) - i#28 == $decr0$0;
        assert array2.Length0(m#27) - i#28 < $decr0$0;
    }

    call CevStepEvent(#tok$0^87.3, loop_exited);
    assume {:captureState "dafny1\MatrixFun.dfy(87,3): loop exit"} true;
}


