// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: dafny1\PriorityQueue.dfy /print:\Users\philipp\Desktop\boogie\boogie-k-induction-benchmarks\benchmarks\PriorityQueue.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class.PriorityQueue: ClassName;

axiom FDim(PriorityQueue.N) == 0 && DeclType(PriorityQueue.N) == class.PriorityQueue;

const unique PriorityQueue.N: Field int;

axiom FDim(PriorityQueue.n) == 0 && DeclType(PriorityQueue.n) == class.PriorityQueue;

const unique PriorityQueue.n: Field int;

axiom FDim(PriorityQueue.Repr) == 0 && DeclType(PriorityQueue.Repr) == class.PriorityQueue;

const unique PriorityQueue.Repr: Field (Set BoxType);

axiom (forall $h: HeapType, $o: ref, $t: BoxType :: { read($h, $o, PriorityQueue.Repr)[$t] } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) && read($h, $o, PriorityQueue.Repr)[$t] ==> $Unbox($t): ref == null || read($h, $Unbox($t): ref, alloc));

axiom FDim(PriorityQueue.a) == 0 && DeclType(PriorityQueue.a) == class.PriorityQueue;

const unique PriorityQueue.a: Field ref;

axiom (forall $h: HeapType, $o: ref :: { read($h, $o, PriorityQueue.a) } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) ==> read($h, $o, PriorityQueue.a) == null || (read($h, read($h, $o, PriorityQueue.a), alloc) && dtype(read($h, $o, PriorityQueue.a)) == class.array && TypeParams(read($h, $o, PriorityQueue.a), 0) == class.int));

function PriorityQueue.Valid($heap: HeapType, this: ref) : bool;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (1 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref :: { PriorityQueue.Valid($Heap, this) } $IsGoodHeap($Heap) && this != null ==> PriorityQueue.Valid($Heap, this) == (PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)));

// frame axiom for PriorityQueue.Valid
axiom (forall $h0: HeapType, $h1: HeapType, this: ref :: { $HeapSucc($h0, $h1), PriorityQueue.Valid($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.PriorityQueue && read($h1, this, alloc) && dtype(this) == class.PriorityQueue && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && ($o == this || read($h0, this, PriorityQueue.Repr)[$Box($o)]) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> PriorityQueue.Valid($h0, this) == PriorityQueue.Valid($h1, this));

procedure CheckWellformed$$PriorityQueue.Valid(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.PriorityQueue);
  free requires 0 == $ModuleContextHeight && 1 == $FunctionContextHeight;



implementation CheckWellformed$$PriorityQueue.Valid(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var j#20: int;

    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || read($Heap, this, PriorityQueue.Repr)[$Box($o)]);
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && ($o == this || read($Heap, this, PriorityQueue.Repr)[$Box($o)]) ==> $_Frame[$o, $f]);
    if (PriorityQueue.MostlyValid($Heap, this))
    {
        if (2 <= j#20)
        {
            assert $_Frame[this, PriorityQueue.n];
        }

        if (2 <= j#20 && j#20 <= read($Heap, this, PriorityQueue.n))
        {
            assert $_Frame[this, PriorityQueue.a];
            assert 2 != 0;
            assert 0 <= j#20 / 2 && j#20 / 2 < array.Length(read($Heap, this, PriorityQueue.a));
            assert $_Frame[read($Heap, this, PriorityQueue.a), IndexField(j#20 / 2)];
            assert $_Frame[this, PriorityQueue.a];
            assert 0 <= j#20 && j#20 < array.Length(read($Heap, this, PriorityQueue.a));
            assert $_Frame[read($Heap, this, PriorityQueue.a), IndexField(j#20)];
        }
    }
}



function PriorityQueue.MostlyValid($heap: HeapType, this: ref) : bool;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (0 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref :: { PriorityQueue.MostlyValid($Heap, this) } $IsGoodHeap($Heap) && this != null ==> PriorityQueue.MostlyValid($Heap, this) == (read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)));

// frame axiom for PriorityQueue.MostlyValid
axiom (forall $h0: HeapType, $h1: HeapType, this: ref :: { $HeapSucc($h0, $h1), PriorityQueue.MostlyValid($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.PriorityQueue && read($h1, this, alloc) && dtype(this) == class.PriorityQueue && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && ($o == this || read($h0, this, PriorityQueue.Repr)[$Box($o)]) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> PriorityQueue.MostlyValid($h0, this) == PriorityQueue.MostlyValid($h1, this));

procedure CheckWellformed$$PriorityQueue.MostlyValid(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.PriorityQueue);
  free requires 0 == $ModuleContextHeight && 0 == $FunctionContextHeight;



implementation CheckWellformed$$PriorityQueue.MostlyValid(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || read($Heap, this, PriorityQueue.Repr)[$Box($o)]);
    assert $_Frame[this, PriorityQueue.Repr];
    if (read($Heap, this, PriorityQueue.Repr)[$Box(this)])
    {
        assert $_Frame[this, PriorityQueue.a];
        assert $_Frame[this, PriorityQueue.Repr];
    }

    if (read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))])
    {
        assert $_Frame[this, PriorityQueue.a];
    }

    if (read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null)
    {
        assert $_Frame[this, PriorityQueue.a];
        assert read($Heap, this, PriorityQueue.a) != null;
        assert $_Frame[this, PriorityQueue.N];
    }

    if (read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1)
    {
        assert $_Frame[this, PriorityQueue.n];
    }

    if (read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n))
    {
        assert $_Frame[this, PriorityQueue.n];
        assert $_Frame[this, PriorityQueue.N];
    }
}



const unique xxxxxxxxxfile: $token;

axiom $file_name_is(0, xxxxxxxxxfile);

const unique #tok$0^23.10: $token;

procedure CheckWellformed$$PriorityQueue.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.PriorityQueue, capacity#1: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^23.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.this: $token;

const unique #tok$0^23.15: $token;

const unique #loc.capacity#1: $token;

implementation CheckWellformed$$PriorityQueue.Init(this: ref, capacity#1: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^23.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^23.15, cev_parameter, #loc.capacity#1, capacity#1);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    assume 0 <= capacity#1;
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (PriorityQueue.Valid($Heap, this))
    {
    }

    assume PriorityQueue.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, PriorityQueue.Repr)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc));
    assume read($Heap, this, PriorityQueue.N) == capacity#1;
}



procedure PriorityQueue.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.PriorityQueue, capacity#1: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires 0 <= capacity#1;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^23.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures PriorityQueue.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, PriorityQueue.Repr)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc));
  free ensures PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int);
  ensures (PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)) ==> PriorityQueue.MostlyValid($Heap, this);
  ensures (PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)) ==> (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int);
  ensures (PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)) ==> (forall $o: ref :: $o != null && read($Heap, this, PriorityQueue.Repr)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc));
  ensures read($Heap, this, PriorityQueue.N) == capacity#1;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^29.7: $token;

const unique #loc.arr#2: $token;

const unique #tok$0^30.9: $token;

const unique #tok$0^31.7: $token;

const unique #tok$0^32.7: $token;

const unique #tok$0^33.10: $token;

const unique #tok$0^34.10: $token;

implementation PriorityQueue.Init(this: ref, capacity#1: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var arr#2: ref where (arr#2 == null || (read($Heap, arr#2, alloc) && dtype(arr#2) == class.array && TypeParams(arr#2, 0) == class.int)) && #cev_var_update(#cev_pc, cev_local, #loc.arr#2, arr#2);
  var $nw: ref;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^23.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^23.15, cev_parameter, #loc.capacity#1, capacity#1);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    // ----- assignment statement ----- dafny1\PriorityQueue.dfy(29,7)
    assert true;
    assert true;
    assert $_Frame[this, PriorityQueue.N];
    $Heap := update($Heap, this, PriorityQueue.N, capacity#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\PriorityQueue.dfy(29,7)"} true;
    call CevUpdateHeap(#tok$0^29.7, #loc.$Heap, $Heap);
    // ----- var-declaration statement ----- dafny1\PriorityQueue.dfy(30,9)
    assert 0 <= read($Heap, this, PriorityQueue.N) + 1;
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.array && TypeParams($nw, 0) == class.int;
    assume array.Length($nw) == read($Heap, this, PriorityQueue.N) + 1;
    $Heap := update($Heap, $nw, alloc, true);
    arr#2 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\PriorityQueue.dfy(30,9)"} true;
    call CevVarIntro(#tok$0^30.9, cev_local, #loc.arr#2, arr#2);
    // ----- assignment statement ----- dafny1\PriorityQueue.dfy(31,7)
    assert true;
    assert true;
    assert $_Frame[this, PriorityQueue.a];
    $Heap := update($Heap, this, PriorityQueue.a, arr#2);
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\PriorityQueue.dfy(31,7)"} true;
    call CevUpdateHeap(#tok$0^31.7, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\PriorityQueue.dfy(32,7)
    assert true;
    assert true;
    assert $_Frame[this, PriorityQueue.n];
    $Heap := update($Heap, this, PriorityQueue.n, 0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\PriorityQueue.dfy(32,7)"} true;
    call CevUpdateHeap(#tok$0^32.7, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\PriorityQueue.dfy(33,10)
    assert true;
    assert true;
    assert $_Frame[this, PriorityQueue.Repr];
    $Heap := update($Heap, this, PriorityQueue.Repr, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\PriorityQueue.dfy(33,10)"} true;
    call CevUpdateHeap(#tok$0^33.10, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\PriorityQueue.dfy(34,10)
    assert true;
    assert true;
    assert $_Frame[this, PriorityQueue.Repr];
    $Heap := update($Heap, this, PriorityQueue.Repr, Set#Union(read($Heap, this, PriorityQueue.Repr), Set#UnionOne(Set#Empty(): Set BoxType, $Box(read($Heap, this, PriorityQueue.a)))));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\PriorityQueue.dfy(34,10)"} true;
    call CevUpdateHeap(#tok$0^34.10, #loc.$Heap, $Heap);
}



const unique #tok$0^37.10: $token;

procedure CheckWellformed$$PriorityQueue.Insert(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.PriorityQueue, x#3: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^37.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^37.17: $token;

const unique #loc.x#3: $token;

implementation CheckWellformed$$PriorityQueue.Insert(this: ref, x#3: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^37.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^37.17, cev_parameter, #loc.x#3, x#3);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || $o == read($Heap, this, PriorityQueue.a));
    if (PriorityQueue.Valid($Heap, this))
    {
    }

    assume PriorityQueue.Valid($Heap, this) && read($Heap, this, PriorityQueue.n) < read($Heap, this, PriorityQueue.N);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (PriorityQueue.Valid($Heap, this))
    {
    }

    assume PriorityQueue.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, PriorityQueue.Repr)[$Box($o)] && !old(read($Heap, this, PriorityQueue.Repr))[$Box($o)] ==> !read(old($Heap), $o, alloc));
    if (read($Heap, this, PriorityQueue.n) == old(read($Heap, this, PriorityQueue.n)) + 1)
    {
    }

    assume read($Heap, this, PriorityQueue.n) == old(read($Heap, this, PriorityQueue.n)) + 1 && read($Heap, this, PriorityQueue.N) == old(read($Heap, this, PriorityQueue.N));
}



procedure PriorityQueue.Insert(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.PriorityQueue, x#3: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires PriorityQueue.Valid($Heap, this) && read($Heap, this, PriorityQueue.n) < read($Heap, this, PriorityQueue.N);
  free requires PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int);
  requires (PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)) ==> PriorityQueue.MostlyValid($Heap, this);
  requires (PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)) ==> (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int);
  requires (PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)) ==> read($Heap, this, PriorityQueue.n) < read($Heap, this, PriorityQueue.N);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^37.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures PriorityQueue.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, PriorityQueue.Repr)[$Box($o)] && !old(read($Heap, this, PriorityQueue.Repr))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  free ensures PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int);
  ensures (PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)) ==> PriorityQueue.MostlyValid($Heap, this);
  ensures (PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)) ==> (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int);
  ensures (PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)) ==> (forall $o: ref :: $o != null && read($Heap, this, PriorityQueue.Repr)[$Box($o)] && !old(read($Heap, this, PriorityQueue.Repr))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  free ensures read($Heap, this, PriorityQueue.n) == old(read($Heap, this, PriorityQueue.n)) + 1 && read($Heap, this, PriorityQueue.N) == old(read($Heap, this, PriorityQueue.N));
  ensures true ==> read($Heap, this, PriorityQueue.n) == old(read($Heap, this, PriorityQueue.n)) + 1;
  ensures true ==> read($Heap, this, PriorityQueue.N) == old(read($Heap, this, PriorityQueue.N));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this || $o == read(old($Heap), this, PriorityQueue.a));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^43.7: $token;

const unique #tok$0^45.5: $token;

implementation PriorityQueue.Insert(this: ref, x#3: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var k#21: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^37.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^37.17, cev_parameter, #loc.x#3, x#3);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || $o == read($Heap, this, PriorityQueue.a));
    // ----- assignment statement ----- dafny1\PriorityQueue.dfy(43,7)
    assert true;
    assert true;
    assert $_Frame[this, PriorityQueue.n];
    $Heap := update($Heap, this, PriorityQueue.n, read($Heap, this, PriorityQueue.n) + 1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\PriorityQueue.dfy(43,7)"} true;
    call CevUpdateHeap(#tok$0^43.7, #loc.$Heap, $Heap);
    // ----- assignment statement ----- dafny1\PriorityQueue.dfy(44,10)
    assert 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) < array.Length(read($Heap, this, PriorityQueue.a));
    assert true;
    assert $_Frame[read($Heap, this, PriorityQueue.a), IndexField(read($Heap, this, PriorityQueue.n))];
    $Heap := update($Heap, read($Heap, this, PriorityQueue.a), IndexField(read($Heap, this, PriorityQueue.n)), $Box(x#3));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\PriorityQueue.dfy(44,10)"} true;
    // ----- call statement ----- dafny1\PriorityQueue.dfy(45,5)
    assert true;
    k#21 := read($Heap, this, PriorityQueue.n);
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == read($Heap, this, PriorityQueue.a) ==> $_Frame[$o, $f]);
    call PriorityQueue.SiftUp(this, k#21);
    call CevStep(#tok$0^45.5);
    assume {:captureState "dafny1\PriorityQueue.dfy(45,5)"} true;
}



const unique #tok$0^48.10: $token;

procedure CheckWellformed$$PriorityQueue.SiftUp(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.PriorityQueue, k#4: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^48.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^48.17: $token;

const unique #loc.k#4: $token;

implementation CheckWellformed$$PriorityQueue.SiftUp(this: ref, k#4: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var j#22: int;
  var j#23: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^48.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^48.17, cev_parameter, #loc.k#4, k#4);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == read($Heap, this, PriorityQueue.a));
    if (1 <= k#4)
    {
    }

    assume 1 <= k#4 && k#4 <= read($Heap, this, PriorityQueue.n);
    assume PriorityQueue.MostlyValid($Heap, this);
    if (2 <= j#22)
    {
    }

    if (2 <= j#22 && j#22 <= read($Heap, this, PriorityQueue.n))
    {
    }

    if (2 <= j#22 && j#22 <= read($Heap, this, PriorityQueue.n) && j#22 != k#4)
    {
        assert 2 != 0;
        assert 0 <= j#22 / 2 && j#22 / 2 < array.Length(read($Heap, this, PriorityQueue.a));
        assert 0 <= j#22 && j#22 < array.Length(read($Heap, this, PriorityQueue.a));
    }

    assume (forall j#5: int :: 2 <= j#5 && j#5 <= read($Heap, this, PriorityQueue.n) && j#5 != k#4 ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#5 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#5))): int);
    if (2 <= j#23)
    {
    }

    if (2 <= j#23 && j#23 <= read($Heap, this, PriorityQueue.n))
    {
        assert 2 != 0;
        assert 2 != 0;
    }

    if (2 <= j#23 && j#23 <= read($Heap, this, PriorityQueue.n) && 1 <= j#23 / 2 / 2)
    {
    }

    if (2 <= j#23 && j#23 <= read($Heap, this, PriorityQueue.n) && 1 <= j#23 / 2 / 2 && j#23 != k#4)
    {
        assert 2 != 0;
        assert 2 != 0;
        assert 0 <= j#23 / 2 / 2 && j#23 / 2 / 2 < array.Length(read($Heap, this, PriorityQueue.a));
        assert 0 <= j#23 && j#23 < array.Length(read($Heap, this, PriorityQueue.a));
    }

    assume (forall j#6: int :: 2 <= j#6 && j#6 <= read($Heap, this, PriorityQueue.n) && 1 <= j#6 / 2 / 2 && j#6 != k#4 ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#6 / 2 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#6))): int);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    assume PriorityQueue.Valid($Heap, this);
}



procedure PriorityQueue.SiftUp(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.PriorityQueue, k#4: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires 1 <= k#4 && k#4 <= read($Heap, this, PriorityQueue.n);
  requires true ==> 1 <= k#4;
  requires true ==> k#4 <= read($Heap, this, PriorityQueue.n);
  free requires PriorityQueue.MostlyValid($Heap, this);
  free requires PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N);
  requires (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)];
  requires (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))];
  requires (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> read($Heap, this, PriorityQueue.a) != null;
  requires (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1;
  requires (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> 0 <= read($Heap, this, PriorityQueue.n);
  requires (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N);
  requires (forall j#5: int :: 2 <= j#5 && j#5 <= read($Heap, this, PriorityQueue.n) && j#5 != k#4 ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#5 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#5))): int);
  requires (forall j#6: int :: 2 <= j#6 && j#6 <= read($Heap, this, PriorityQueue.n) && 1 <= j#6 / 2 / 2 && j#6 != k#4 ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#6 / 2 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#6))): int);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^48.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures PriorityQueue.Valid($Heap, this);
  free ensures PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int);
  ensures (PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)) ==> PriorityQueue.MostlyValid($Heap, this);
  ensures (PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)) ==> (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == read(old($Heap), this, PriorityQueue.a));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.i#7: $token;

const unique #tok$0^56.9: $token;

const unique #tok$0^58.5: $token;

const unique #tok$0^63.7: $token;

const unique #tok$0^63.27: $token;

const unique #loc.tmp#10: $token;

const unique #tok$0^66.11: $token;

const unique #tok$0^67.9: $token;

implementation PriorityQueue.SiftUp(this: ref, k#4: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#7: int where #cev_var_update(#cev_pc, cev_local, #loc.i#7, i#7);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;
  var tmp#10: int where #cev_var_update(#cev_pc, cev_local, #loc.tmp#10, tmp#10);

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^48.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^48.17, cev_parameter, #loc.k#4, k#4);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == read($Heap, this, PriorityQueue.a));
    // ----- var-declaration statement ----- dafny1\PriorityQueue.dfy(56,9)
    assert true;
    assert true;
    i#7 := k#4;
    assume {:captureState "dafny1\PriorityQueue.dfy(56,9)"} true;
    call CevVarIntro(#tok$0^56.9, cev_local, #loc.i#7, i#7);
    // ----- assert statement ----- dafny1\PriorityQueue.dfy(57,5)
    assert {:subsumption 0} true;
    assume PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N);
    assert {:subsumption 0} read($Heap, this, PriorityQueue.Repr)[$Box(this)];
    assert {:subsumption 0} read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))];
    assert {:subsumption 0} read($Heap, this, PriorityQueue.a) != null;
    assert {:subsumption 0} array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1;
    assert {:subsumption 0} 0 <= read($Heap, this, PriorityQueue.n);
    assert {:subsumption 0} read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N);
    assume PriorityQueue.MostlyValid($Heap, this);
    // ----- while statement ----- dafny1\PriorityQueue.dfy(58,5)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := i#7 - 1;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^58.5);
    while (true)
      free invariant PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N);
      invariant $w0 && (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> i#7 <= k#4;
      invariant $w0 && (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)];
      invariant $w0 && (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))];
      invariant $w0 && (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> read($Heap, this, PriorityQueue.a) != null;
      invariant $w0 && (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1;
      invariant $w0 && (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> 0 <= read($Heap, this, PriorityQueue.n);
      invariant $w0 && (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N);
//      free invariant $w0 ==> i#7 <= k#4 && PriorityQueue.MostlyValid($Heap, this);
      invariant $w0 ==> (forall j#8: int :: 2 <= j#8 && j#8 <= read($Heap, this, PriorityQueue.n) && j#8 != i#7 ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#8 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#8))): int);
      invariant $w0 ==> (forall j#9: int :: 2 <= j#9 && j#9 <= read($Heap, this, PriorityQueue.n) && 1 <= j#9 / 2 / 2 && j#9 != i#7 ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#9 / 2 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#9))): int);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f) || $o == read(old($Heap), this, PriorityQueue.a));
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant i#7 - 1 <= $decr0$init$0 && (i#7 - 1 == $decr0$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^58.5;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} i#7 <= k#4 ==> true;
            assume i#7 <= k#4 && PriorityQueue.MostlyValid($Heap, this);
            assert {:subsumption 0} (forall j#8: int :: (2 <= j#8 ==> true) && (2 <= j#8 && j#8 <= read($Heap, this, PriorityQueue.n) ==> true) && (2 <= j#8 && j#8 <= read($Heap, this, PriorityQueue.n) && j#8 != i#7 ==> 2 != 0 && 0 <= j#8 / 2 && j#8 / 2 < array.Length(read($Heap, this, PriorityQueue.a)) && 0 <= j#8 && j#8 < array.Length(read($Heap, this, PriorityQueue.a))));
            assume (forall j#8: int :: 2 <= j#8 && j#8 <= read($Heap, this, PriorityQueue.n) && j#8 != i#7 ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#8 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#8))): int);
            assert {:subsumption 0} (forall j#9: int :: (2 <= j#9 ==> true) && (2 <= j#9 && j#9 <= read($Heap, this, PriorityQueue.n) ==> 2 != 0 && 2 != 0) && (2 <= j#9 && j#9 <= read($Heap, this, PriorityQueue.n) && 1 <= j#9 / 2 / 2 ==> true) && (2 <= j#9 && j#9 <= read($Heap, this, PriorityQueue.n) && 1 <= j#9 / 2 / 2 && j#9 != i#7 ==> 2 != 0 && 2 != 0 && 0 <= j#9 / 2 / 2 && j#9 / 2 / 2 < array.Length(read($Heap, this, PriorityQueue.a)) && 0 <= j#9 && j#9 < array.Length(read($Heap, this, PriorityQueue.a))));
            assume (forall j#9: int :: 2 <= j#9 && j#9 <= read($Heap, this, PriorityQueue.n) && 1 <= j#9 / 2 / 2 && j#9 != i#7 ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#9 / 2 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#9))): int);
            assert true;
            assume false;
        }

        assert true;
        if (1 >= i#7)
        {
            break;
        }

        call CevStepEvent(#tok$0^58.5, loop_entered);
        assume {:captureState "dafny1\PriorityQueue.dfy(58,5): loop entered"} true;
        $decr0$0 := i#7 - 1;
        // ----- if statement ----- dafny1\PriorityQueue.dfy(63,7)
        call CevEvent(#tok$0^63.7, conditional_moment);
        assert 2 != 0 && 0 <= i#7 / 2 && i#7 / 2 < array.Length(read($Heap, this, PriorityQueue.a)) && 0 <= i#7 && i#7 < array.Length(read($Heap, this, PriorityQueue.a));
        if ($Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(i#7 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(i#7))): int)
        {
            call CevEvent(#tok$0^63.27, took_then_branch);
            // ----- return statement ----- dafny1\PriorityQueue.dfy(64,9)
            return;
        }
        else
        {
            call CevEvent(#tok$0^63.7, took_else_branch);
        }

        // ----- var-declaration statement ----- dafny1\PriorityQueue.dfy(66,11)
        assert true;
        assert 0 <= i#7 && i#7 < array.Length(read($Heap, this, PriorityQueue.a));
        tmp#10 := $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(i#7))): int;
        assume {:captureState "dafny1\PriorityQueue.dfy(66,11)"} true;
        call CevVarIntro(#tok$0^66.11, cev_local, #loc.tmp#10, tmp#10);
        // ----- assignment statement ----- dafny1\PriorityQueue.dfy(66,30)
        assert 0 <= i#7 && i#7 < array.Length(read($Heap, this, PriorityQueue.a));
        assert 2 != 0 && 0 <= i#7 / 2 && i#7 / 2 < array.Length(read($Heap, this, PriorityQueue.a));
        assert $_Frame[read($Heap, this, PriorityQueue.a), IndexField(i#7)];
        $Heap := update($Heap, read($Heap, this, PriorityQueue.a), IndexField(i#7), $Box($Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(i#7 / 2))): int));
        assume $IsGoodHeap($Heap);
        assume {:captureState "dafny1\PriorityQueue.dfy(66,30)"} true;
        // ----- assignment statement ----- dafny1\PriorityQueue.dfy(66,49)
        assert 2 != 0 && 0 <= i#7 / 2 && i#7 / 2 < array.Length(read($Heap, this, PriorityQueue.a));
        assert true;
        assert $_Frame[read($Heap, this, PriorityQueue.a), IndexField(i#7 / 2)];
        $Heap := update($Heap, read($Heap, this, PriorityQueue.a), IndexField(i#7 / 2), $Box(tmp#10));
        assume $IsGoodHeap($Heap);
        assume {:captureState "dafny1\PriorityQueue.dfy(66,49)"} true;
        // ----- assignment statement ----- dafny1\PriorityQueue.dfy(67,9)
        assert true;
        assert 2 != 0;
        i#7 := i#7 / 2;
        assume {:captureState "dafny1\PriorityQueue.dfy(67,9)"} true;
        call CevUpdate(#tok$0^67.9, #loc.i#7, i#7);
        assert 0 <= $decr0$0 || i#7 - 1 == $decr0$0;
        assert i#7 - 1 < $decr0$0;
    }

    call CevStepEvent(#tok$0^58.5, loop_exited);
    assume {:captureState "dafny1\PriorityQueue.dfy(58,5): loop exit"} true;
}



const unique #tok$0^71.10: $token;

procedure CheckWellformed$$PriorityQueue.RemoveMin(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.PriorityQueue) returns (x#11: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^71.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^71.31: $token;

const unique #loc.x#11: $token;

implementation CheckWellformed$$PriorityQueue.RemoveMin(this: ref) returns (x#11: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^71.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^71.31, cev_local, #loc.x#11, x#11);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || $o == read($Heap, this, PriorityQueue.a));
    if (PriorityQueue.Valid($Heap, this))
    {
    }

    assume PriorityQueue.Valid($Heap, this) && 1 <= read($Heap, this, PriorityQueue.n);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc x#11;
    if (PriorityQueue.Valid($Heap, this))
    {
    }

    assume PriorityQueue.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, PriorityQueue.Repr)[$Box($o)] && !old(read($Heap, this, PriorityQueue.Repr))[$Box($o)] ==> !read(old($Heap), $o, alloc));
    assume read($Heap, this, PriorityQueue.n) == old(read($Heap, this, PriorityQueue.n)) - 1;
}



procedure PriorityQueue.RemoveMin(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.PriorityQueue) returns (x#11: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires PriorityQueue.Valid($Heap, this) && 1 <= read($Heap, this, PriorityQueue.n);
  free requires PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int);
  requires (PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)) ==> PriorityQueue.MostlyValid($Heap, this);
  requires (PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)) ==> (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int);
  requires (PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)) ==> 1 <= read($Heap, this, PriorityQueue.n);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^71.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures PriorityQueue.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, PriorityQueue.Repr)[$Box($o)] && !old(read($Heap, this, PriorityQueue.Repr))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  free ensures PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int);
  ensures (PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)) ==> PriorityQueue.MostlyValid($Heap, this);
  ensures (PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)) ==> (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int);
  ensures (PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)) ==> (forall $o: ref :: $o != null && read($Heap, this, PriorityQueue.Repr)[$Box($o)] && !old(read($Heap, this, PriorityQueue.Repr))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  ensures read($Heap, this, PriorityQueue.n) == old(read($Heap, this, PriorityQueue.n)) - 1;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this || $o == read(old($Heap), this, PriorityQueue.a));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^77.7: $token;

const unique #tok$0^79.7: $token;

const unique #tok$0^80.5: $token;

implementation PriorityQueue.RemoveMin(this: ref) returns (x#11: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var k#24: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^71.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^71.31, cev_local, #loc.x#11, x#11);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || $o == read($Heap, this, PriorityQueue.a));
    // ----- assignment statement ----- dafny1\PriorityQueue.dfy(77,7)
    assert true;
    assert 0 <= 1 && 1 < array.Length(read($Heap, this, PriorityQueue.a));
    x#11 := $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(1))): int;
    assume {:captureState "dafny1\PriorityQueue.dfy(77,7)"} true;
    call CevUpdate(#tok$0^77.7, #loc.x#11, x#11);
    // ----- assignment statement ----- dafny1\PriorityQueue.dfy(78,10)
    assert 0 <= 1 && 1 < array.Length(read($Heap, this, PriorityQueue.a));
    assert 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) < array.Length(read($Heap, this, PriorityQueue.a));
    assert $_Frame[read($Heap, this, PriorityQueue.a), IndexField(1)];
    $Heap := update($Heap, read($Heap, this, PriorityQueue.a), IndexField(1), $Box($Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(read($Heap, this, PriorityQueue.n)))): int));
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\PriorityQueue.dfy(78,10)"} true;
    // ----- assignment statement ----- dafny1\PriorityQueue.dfy(79,7)
    assert true;
    assert true;
    assert $_Frame[this, PriorityQueue.n];
    $Heap := update($Heap, this, PriorityQueue.n, read($Heap, this, PriorityQueue.n) - 1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "dafny1\PriorityQueue.dfy(79,7)"} true;
    call CevUpdateHeap(#tok$0^79.7, #loc.$Heap, $Heap);
    // ----- call statement ----- dafny1\PriorityQueue.dfy(80,5)
    assert true;
    k#24 := 1;
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == read($Heap, this, PriorityQueue.a) ==> $_Frame[$o, $f]);
    call PriorityQueue.SiftDown(this, k#24);
    call CevStep(#tok$0^80.5);
    assume {:captureState "dafny1\PriorityQueue.dfy(80,5)"} true;
}



const unique #tok$0^83.10: $token;

procedure CheckWellformed$$PriorityQueue.SiftDown(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.PriorityQueue, k#12: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^83.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^83.19: $token;

const unique #loc.k#12: $token;

implementation CheckWellformed$$PriorityQueue.SiftDown(this: ref, k#12: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var j#25: int;
  var j#26: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^83.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^83.19, cev_parameter, #loc.k#12, k#12);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == read($Heap, this, PriorityQueue.a));
    assume 1 <= k#12;
    assume PriorityQueue.MostlyValid($Heap, this);
    if (2 <= j#25)
    {
    }

    if (2 <= j#25 && j#25 <= read($Heap, this, PriorityQueue.n))
    {
        assert 2 != 0;
    }

    if (2 <= j#25 && j#25 <= read($Heap, this, PriorityQueue.n) && j#25 / 2 != k#12)
    {
        assert 2 != 0;
        assert 0 <= j#25 / 2 && j#25 / 2 < array.Length(read($Heap, this, PriorityQueue.a));
        assert 0 <= j#25 && j#25 < array.Length(read($Heap, this, PriorityQueue.a));
    }

    assume (forall j#13: int :: 2 <= j#13 && j#13 <= read($Heap, this, PriorityQueue.n) && j#13 / 2 != k#12 ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#13 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#13))): int);
    if (2 <= j#26)
    {
    }

    if (2 <= j#26 && j#26 <= read($Heap, this, PriorityQueue.n))
    {
        assert 2 != 0;
        assert 2 != 0;
    }

    if (2 <= j#26 && j#26 <= read($Heap, this, PriorityQueue.n) && 1 <= j#26 / 2 / 2)
    {
        assert 2 != 0;
        assert 2 != 0;
    }

    if (2 <= j#26 && j#26 <= read($Heap, this, PriorityQueue.n) && 1 <= j#26 / 2 / 2 && j#26 / 2 / 2 != k#12)
    {
        assert 2 != 0;
        assert 2 != 0;
        assert 0 <= j#26 / 2 / 2 && j#26 / 2 / 2 < array.Length(read($Heap, this, PriorityQueue.a));
        assert 0 <= j#26 && j#26 < array.Length(read($Heap, this, PriorityQueue.a));
    }

    assume (forall j#14: int :: 2 <= j#14 && j#14 <= read($Heap, this, PriorityQueue.n) && 1 <= j#14 / 2 / 2 && j#14 / 2 / 2 != k#12 ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#14 / 2 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#14))): int);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    assume PriorityQueue.Valid($Heap, this);
}



procedure PriorityQueue.SiftDown(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.PriorityQueue, k#12: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires 1 <= k#12;
  free requires PriorityQueue.MostlyValid($Heap, this);
  free requires PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N);
  requires (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)];
  requires (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))];
  requires (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> read($Heap, this, PriorityQueue.a) != null;
  requires (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1;
  requires (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> 0 <= read($Heap, this, PriorityQueue.n);
  requires (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N);
  requires (forall j#13: int :: 2 <= j#13 && j#13 <= read($Heap, this, PriorityQueue.n) && j#13 / 2 != k#12 ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#13 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#13))): int);
  requires (forall j#14: int :: 2 <= j#14 && j#14 <= read($Heap, this, PriorityQueue.n) && 1 <= j#14 / 2 / 2 && j#14 / 2 / 2 != k#12 ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#14 / 2 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#14))): int);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^83.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures PriorityQueue.Valid($Heap, this);
  free ensures PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int);
  ensures (PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)) ==> PriorityQueue.MostlyValid($Heap, this);
  ensures (PriorityQueue.Valid($Heap, this) ==> PriorityQueue.MostlyValid($Heap, this) && (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int)) ==> (forall j#0: int :: 2 <= j#0 && j#0 <= read($Heap, this, PriorityQueue.n) ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#0))): int);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == read(old($Heap), this, PriorityQueue.a));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.i#15: $token;

const unique #tok$0^91.9: $token;

const unique #tok$0^92.5: $token;

const unique #loc.smallestChild#18: $token;

const unique #tok$0^97.11: $token;

const unique #tok$0^98.7: $token;

const unique #tok$0^98.48: $token;

const unique #tok$0^99.23: $token;

const unique #tok$0^100.14: $token;

const unique #tok$0^101.23: $token;

const unique #tok$0^103.7: $token;

const unique #tok$0^103.37: $token;

const unique #loc.tmp#19: $token;

const unique #tok$0^106.11: $token;

const unique #tok$0^107.9: $token;

implementation PriorityQueue.SiftDown(this: ref, k#12: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#15: int where #cev_var_update(#cev_pc, cev_local, #loc.i#15, i#15);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;
  var smallestChild#18: int where #cev_var_update(#cev_pc, cev_local, #loc.smallestChild#18, smallestChild#18);
  var tmp#19: int where #cev_var_update(#cev_pc, cev_local, #loc.tmp#19, tmp#19);

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^83.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^83.19, cev_parameter, #loc.k#12, k#12);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == read($Heap, this, PriorityQueue.a));
    // ----- var-declaration statement ----- dafny1\PriorityQueue.dfy(91,9)
    assert true;
    assert true;
    i#15 := k#12;
    assume {:captureState "dafny1\PriorityQueue.dfy(91,9)"} true;
    call CevVarIntro(#tok$0^91.9, cev_local, #loc.i#15, i#15);
    // ----- while statement ----- dafny1\PriorityQueue.dfy(92,5)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := read($Heap, this, PriorityQueue.n) - 2 * i#15;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^92.5);
    while (true)
      free invariant PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N);
      invariant $w0 && (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> 1 <= i#15;
      invariant $w0 && (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)];
      invariant $w0 && (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))];
      invariant $w0 && (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> read($Heap, this, PriorityQueue.a) != null;
      invariant $w0 && (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1;
      invariant $w0 && (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> 0 <= read($Heap, this, PriorityQueue.n);
      invariant $w0 && (PriorityQueue.MostlyValid($Heap, this) ==> read($Heap, this, PriorityQueue.Repr)[$Box(this)] && read($Heap, this, PriorityQueue.Repr)[$Box(read($Heap, this, PriorityQueue.a))] && read($Heap, this, PriorityQueue.a) != null && array.Length(read($Heap, this, PriorityQueue.a)) == read($Heap, this, PriorityQueue.N) + 1 && 0 <= read($Heap, this, PriorityQueue.n) && read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N)) ==> read($Heap, this, PriorityQueue.n) <= read($Heap, this, PriorityQueue.N);
//      free invariant $w0 ==> 1 <= i#15 && PriorityQueue.MostlyValid($Heap, this);
      invariant $w0 ==> (forall j#16: int :: 2 <= j#16 && j#16 <= read($Heap, this, PriorityQueue.n) && j#16 / 2 != i#15 ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#16 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#16))): int);
      invariant $w0 ==> (forall j#17: int :: 2 <= j#17 && j#17 <= read($Heap, this, PriorityQueue.n) && 1 <= j#17 / 2 / 2 && j#17 / 2 / 2 != i#15 ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#17 / 2 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#17))): int);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f) || $o == read(old($Heap), this, PriorityQueue.a));
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant read($Heap, this, PriorityQueue.n) - 2 * i#15 <= $decr0$init$0 && (read($Heap, this, PriorityQueue.n) - 2 * i#15 == $decr0$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^92.5;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} 1 <= i#15 ==> true;
            assume 1 <= i#15 && PriorityQueue.MostlyValid($Heap, this);
            assert {:subsumption 0} (forall j#16: int :: (2 <= j#16 ==> true) && (2 <= j#16 && j#16 <= read($Heap, this, PriorityQueue.n) ==> 2 != 0) && (2 <= j#16 && j#16 <= read($Heap, this, PriorityQueue.n) && j#16 / 2 != i#15 ==> 2 != 0 && 0 <= j#16 / 2 && j#16 / 2 < array.Length(read($Heap, this, PriorityQueue.a)) && 0 <= j#16 && j#16 < array.Length(read($Heap, this, PriorityQueue.a))));
            assume (forall j#16: int :: 2 <= j#16 && j#16 <= read($Heap, this, PriorityQueue.n) && j#16 / 2 != i#15 ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#16 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#16))): int);
            assert {:subsumption 0} (forall j#17: int :: (2 <= j#17 ==> true) && (2 <= j#17 && j#17 <= read($Heap, this, PriorityQueue.n) ==> 2 != 0 && 2 != 0) && (2 <= j#17 && j#17 <= read($Heap, this, PriorityQueue.n) && 1 <= j#17 / 2 / 2 ==> 2 != 0 && 2 != 0) && (2 <= j#17 && j#17 <= read($Heap, this, PriorityQueue.n) && 1 <= j#17 / 2 / 2 && j#17 / 2 / 2 != i#15 ==> 2 != 0 && 2 != 0 && 0 <= j#17 / 2 / 2 && j#17 / 2 / 2 < array.Length(read($Heap, this, PriorityQueue.a)) && 0 <= j#17 && j#17 < array.Length(read($Heap, this, PriorityQueue.a))));
            assume (forall j#17: int :: 2 <= j#17 && j#17 <= read($Heap, this, PriorityQueue.n) && 1 <= j#17 / 2 / 2 && j#17 / 2 / 2 != i#15 ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#17 / 2 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(j#17))): int);
            assert true;
            assume false;
        }

        assert true;
        if (2 * i#15 > read($Heap, this, PriorityQueue.n))
        {
            break;
        }

        call CevStepEvent(#tok$0^92.5, loop_entered);
        assume {:captureState "dafny1\PriorityQueue.dfy(92,5): loop entered"} true;
        $decr0$0 := read($Heap, this, PriorityQueue.n) - 2 * i#15;
        // ----- var-declaration statement ----- dafny1\PriorityQueue.dfy(97,11)
        call CevVarIntro(#tok$0^97.11, cev_local, #loc.smallestChild#18, smallestChild#18);
        // ----- if statement ----- dafny1\PriorityQueue.dfy(98,7)
        call CevEvent(#tok$0^98.7, conditional_moment);
        assert 2 * i#15 + 1 <= read($Heap, this, PriorityQueue.n) ==> 0 <= 2 * i#15 + 1 && 2 * i#15 + 1 < array.Length(read($Heap, this, PriorityQueue.a)) && 0 <= 2 * i#15 && 2 * i#15 < array.Length(read($Heap, this, PriorityQueue.a));
        if (2 * i#15 + 1 <= read($Heap, this, PriorityQueue.n) && $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(2 * i#15 + 1))): int < $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(2 * i#15))): int)
        {
            call CevEvent(#tok$0^98.48, took_then_branch);
            // ----- assignment statement ----- dafny1\PriorityQueue.dfy(99,23)
            assert true;
            assert true;
            smallestChild#18 := 2 * i#15 + 1;
            assume {:captureState "dafny1\PriorityQueue.dfy(99,23)"} true;
            call CevUpdate(#tok$0^99.23, #loc.smallestChild#18, smallestChild#18);
        }
        else
        {
            call CevEvent(#tok$0^100.14, took_else_branch);
            // ----- assignment statement ----- dafny1\PriorityQueue.dfy(101,23)
            assert true;
            assert true;
            smallestChild#18 := 2 * i#15;
            assume {:captureState "dafny1\PriorityQueue.dfy(101,23)"} true;
            call CevUpdate(#tok$0^101.23, #loc.smallestChild#18, smallestChild#18);
        }

        // ----- if statement ----- dafny1\PriorityQueue.dfy(103,7)
        call CevEvent(#tok$0^103.7, conditional_moment);
        assert 0 <= i#15 && i#15 < array.Length(read($Heap, this, PriorityQueue.a)) && 0 <= smallestChild#18 && smallestChild#18 < array.Length(read($Heap, this, PriorityQueue.a));
        if ($Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(i#15))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(smallestChild#18))): int)
        {
            call CevEvent(#tok$0^103.37, took_then_branch);
            // ----- return statement ----- dafny1\PriorityQueue.dfy(104,9)
            return;
        }
        else
        {
            call CevEvent(#tok$0^103.7, took_else_branch);
        }

        // ----- var-declaration statement ----- dafny1\PriorityQueue.dfy(106,11)
        assert true;
        assert 0 <= i#15 && i#15 < array.Length(read($Heap, this, PriorityQueue.a));
        tmp#19 := $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(i#15))): int;
        assume {:captureState "dafny1\PriorityQueue.dfy(106,11)"} true;
        call CevVarIntro(#tok$0^106.11, cev_local, #loc.tmp#19, tmp#19);
        // ----- assignment statement ----- dafny1\PriorityQueue.dfy(106,30)
        assert 0 <= i#15 && i#15 < array.Length(read($Heap, this, PriorityQueue.a));
        assert 0 <= smallestChild#18 && smallestChild#18 < array.Length(read($Heap, this, PriorityQueue.a));
        assert $_Frame[read($Heap, this, PriorityQueue.a), IndexField(i#15)];
        $Heap := update($Heap, read($Heap, this, PriorityQueue.a), IndexField(i#15), $Box($Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(smallestChild#18))): int));
        assume $IsGoodHeap($Heap);
        assume {:captureState "dafny1\PriorityQueue.dfy(106,30)"} true;
        // ----- assignment statement ----- dafny1\PriorityQueue.dfy(106,69)
        assert 0 <= smallestChild#18 && smallestChild#18 < array.Length(read($Heap, this, PriorityQueue.a));
        assert true;
        assert $_Frame[read($Heap, this, PriorityQueue.a), IndexField(smallestChild#18)];
        $Heap := update($Heap, read($Heap, this, PriorityQueue.a), IndexField(smallestChild#18), $Box(tmp#19));
        assume $IsGoodHeap($Heap);
        assume {:captureState "dafny1\PriorityQueue.dfy(106,69)"} true;
        // ----- assignment statement ----- dafny1\PriorityQueue.dfy(107,9)
        assert true;
        assert true;
        i#15 := smallestChild#18;
        assume {:captureState "dafny1\PriorityQueue.dfy(107,9)"} true;
        call CevUpdate(#tok$0^107.9, #loc.i#15, i#15);
        // ----- assert statement ----- dafny1\PriorityQueue.dfy(108,7)
        assert {:subsumption 0} 2 != 0 && 2 != 0 && (1 <= i#15 / 2 / 2 ==> 2 != 0 && 2 != 0 && 0 <= i#15 / 2 / 2 && i#15 / 2 / 2 < array.Length(read($Heap, this, PriorityQueue.a)) && 0 <= i#15 && i#15 < array.Length(read($Heap, this, PriorityQueue.a)));
        assert 1 <= i#15 / 2 / 2 ==> $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(i#15 / 2 / 2))): int <= $Unbox(read($Heap, read($Heap, this, PriorityQueue.a), IndexField(i#15))): int;
        assert 0 <= $decr0$0 || read($Heap, this, PriorityQueue.n) - 2 * i#15 == $decr0$0;
        assert read($Heap, this, PriorityQueue.n) - 2 * i#15 < $decr0$0;
    }

    call CevStepEvent(#tok$0^92.5, loop_exited);
    assume {:captureState "dafny1\PriorityQueue.dfy(92,5): loop exit"} true;
}



const unique class._default: ClassName;
