// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: Test\VSComp2010\Problem1-SumMax.dfy /print:..\boogie-k-induction-benchmarks\benchmarks\Problem1-SumMax.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class._default: ClassName;

const unique xxxxxxfile: $token;

axiom $file_name_is(0, xxxxxxfile);

const unique #tok$0^10.8: $token;

procedure CheckWellformed$$_default.M(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, N#0: int, a#1: ref where a#1 == null || (read($Heap, a#1, alloc) && dtype(a#1) == class.array && TypeParams(a#1, 0) == class.int)) returns (sum#2: int, max#3: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^10.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.this: $token;

const unique #tok$0^10.10: $token;

const unique #loc.N#0: $token;

const unique #tok$0^10.18: $token;

const unique #loc.a#1: $token;

const unique #tok$0^10.42: $token;

const unique #loc.sum#2: $token;

const unique #tok$0^10.52: $token;

const unique #loc.max#3: $token;

implementation CheckWellformed$$_default.M(this: ref, N#0: int, a#1: ref) returns (sum#2: int, max#3: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var k#9: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^10.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^10.10, cev_parameter, #loc.N#0, N#0);
    call CevVarIntro(#tok$0^10.18, cev_parameter, #loc.a#1, a#1);
    call CevVarIntro(#tok$0^10.42, cev_local, #loc.sum#2, sum#2);
    call CevVarIntro(#tok$0^10.52, cev_local, #loc.max#3, max#3);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    if (0 <= N#0)
    {
    }

    if (0 <= N#0 && a#1 != null)
    {
        assert a#1 != null;
    }

    if (0 <= N#0 && a#1 != null && array.Length(a#1) == N#0)
    {
        if (0 <= k#9)
        {
        }

        if (0 <= k#9 && k#9 < N#0)
        {
            assert 0 <= k#9 && k#9 < array.Length(a#1);
        }
    }

    assume 0 <= N#0 && a#1 != null && array.Length(a#1) == N#0 && (forall k#4: int :: 0 <= k#4 && k#4 < N#0 ==> 0 <= $Unbox(read($Heap, a#1, IndexField(k#4))): int);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc sum#2, max#3;
    assume sum#2 <= N#0 * max#3;
}



procedure _default.M(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, N#0: int, a#1: ref where a#1 == null || (read($Heap, a#1, alloc) && dtype(a#1) == class.array && TypeParams(a#1, 0) == class.int)) returns (sum#2: int, max#3: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires 0 <= N#0 && a#1 != null && array.Length(a#1) == N#0 && (forall k#4: int :: 0 <= k#4 && k#4 < N#0 ==> 0 <= $Unbox(read($Heap, a#1, IndexField(k#4))): int);
  requires true ==> 0 <= N#0;
  requires true ==> a#1 != null;
  requires true ==> array.Length(a#1) == N#0;
  requires true ==> (forall k#4: int :: 0 <= k#4 && k#4 < N#0 ==> 0 <= $Unbox(read($Heap, a#1, IndexField(k#4))): int);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^10.8;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures sum#2 <= N#0 * max#3;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^14.7: $token;

const unique #tok$0^15.7: $token;

const unique #loc.i#5: $token;

const unique #tok$0^16.7: $token;

const unique #tok$0^17.3: $token;

const unique #tok$0^20.5: $token;

const unique #tok$0^20.21: $token;

const unique #tok$0^21.11: $token;

const unique #tok$0^23.9: $token;

const unique #tok$0^24.7: $token;

implementation _default.M(this: ref, N#0: int, a#1: ref) returns (sum#2: int, max#3: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#5: int where #cev_var_update(#cev_pc, cev_local, #loc.i#5, i#5);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^10.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^10.10, cev_parameter, #loc.N#0, N#0);
    call CevVarIntro(#tok$0^10.18, cev_parameter, #loc.a#1, a#1);
    call CevVarIntro(#tok$0^10.42, cev_local, #loc.sum#2, sum#2);
    call CevVarIntro(#tok$0^10.52, cev_local, #loc.max#3, max#3);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- assignment statement ----- Test\VSComp2010\Problem1-SumMax.dfy(14,7)
    assert true;
    assert true;
    sum#2 := 0;
    assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(14,7)"} true;
    call CevUpdate(#tok$0^14.7, #loc.sum#2, sum#2);
    // ----- assignment statement ----- Test\VSComp2010\Problem1-SumMax.dfy(15,7)
    assert true;
    assert true;
    max#3 := 0;
    assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(15,7)"} true;
    call CevUpdate(#tok$0^15.7, #loc.max#3, max#3);
    // ----- var-declaration statement ----- Test\VSComp2010\Problem1-SumMax.dfy(16,7)
    assert true;
    assert true;
    i#5 := 0;
    assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(16,7)"} true;
    call CevVarIntro(#tok$0^16.7, cev_local, #loc.i#5, i#5);
    // ----- while statement ----- Test\VSComp2010\Problem1-SumMax.dfy(17,3)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := N#0 - i#5;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^17.3);
    while (true)
      invariant $w0 ==> i#5 <= N#0;
      invariant $w0 ==> sum#2 <= i#5 * max#3;
 //     free invariant $w0 ==> i#5 <= N#0 && sum#2 <= i#5 * max#3;
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant N#0 - i#5 <= $decr0$init$0 && (N#0 - i#5 == $decr0$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^17.3;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.sum#2, sum#2);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.max#3, max#3);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} i#5 <= N#0 ==> true;
            assume i#5 <= N#0 && sum#2 <= i#5 * max#3;
            assert true;
            assume false;
        }

        assert true;
        if (i#5 >= N#0)
        {
            break;
        }

        call CevStepEvent(#tok$0^17.3, loop_entered);
        assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(17,3): loop entered"} true;
        $decr0$0 := N#0 - i#5;
        // ----- if statement ----- Test\VSComp2010\Problem1-SumMax.dfy(20,5)
        call CevEvent(#tok$0^20.5, conditional_moment);
        assert 0 <= i#5 && i#5 < array.Length(a#1);
        if (max#3 < $Unbox(read($Heap, a#1, IndexField(i#5))): int)
        {
            call CevEvent(#tok$0^20.21, took_then_branch);
            // ----- assignment statement ----- Test\VSComp2010\Problem1-SumMax.dfy(21,11)
            assert true;
            assert 0 <= i#5 && i#5 < array.Length(a#1);
            max#3 := $Unbox(read($Heap, a#1, IndexField(i#5))): int;
            assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(21,11)"} true;
            call CevUpdate(#tok$0^21.11, #loc.max#3, max#3);
        }
        else
        {
            call CevEvent(#tok$0^20.5, took_else_branch);
        }

        // ----- assignment statement ----- Test\VSComp2010\Problem1-SumMax.dfy(23,9)
        assert true;
        assert 0 <= i#5 && i#5 < array.Length(a#1);
        sum#2 := sum#2 + $Unbox(read($Heap, a#1, IndexField(i#5))): int;
        assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(23,9)"} true;
        call CevUpdate(#tok$0^23.9, #loc.sum#2, sum#2);
        // ----- assignment statement ----- Test\VSComp2010\Problem1-SumMax.dfy(24,7)
        assert true;
        assert true;
        i#5 := i#5 + 1;
        assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(24,7)"} true;
        call CevUpdate(#tok$0^24.7, #loc.i#5, i#5);
        assert 0 <= $decr0$0 || N#0 - i#5 == $decr0$0;
        assert N#0 - i#5 < $decr0$0;
    }

    call CevStepEvent(#tok$0^17.3, loop_exited);
    assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(17,3): loop exit"} true;
}



const unique #tok$0^28.8: $token;

procedure CheckWellformed$$_default.Main(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^28.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



implementation CheckWellformed$$_default.Main(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^28.8, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
}



procedure _default.Main(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^28.8;
  modifies $Heap, #cev_pc;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.a#6: $token;

const unique #tok$0^30.7: $token;

const unique #loc.s#7: $token;

const unique #tok$0^41.8: $token;

const unique #loc.m#8: $token;

const unique #tok$0^41.11: $token;

const unique #loc.s: $token;

const unique #loc.m: $token;

const unique #tok$0^41.3: $token;

implementation _default.Main(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var a#6: ref where (a#6 == null || (read($Heap, a#6, alloc) && dtype(a#6) == class.array && TypeParams(a#6, 0) == class.int)) && #cev_var_update(#cev_pc, cev_local, #loc.a#6, a#6);
  var $nw: ref;
  var s#7: int where #cev_var_update(#cev_pc, cev_local, #loc.s#7, s#7);
  var m#8: int where #cev_var_update(#cev_pc, cev_local, #loc.m#8, m#8);
  var N#10: int;
  var a#11: ref;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^28.8, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- Test\VSComp2010\Problem1-SumMax.dfy(30,7)
    assert 0 <= 10;
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.array && TypeParams($nw, 0) == class.int;
    assume array.Length($nw) == 10;
    $Heap := update($Heap, $nw, alloc, true);
    a#6 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(30,7)"} true;
    call CevVarIntro(#tok$0^30.7, cev_local, #loc.a#6, a#6);
    // ----- assignment statement ----- Test\VSComp2010\Problem1-SumMax.dfy(31,8)
    assert 0 <= 0 && 0 < array.Length(a#6);
    assert true;
    assert $_Frame[a#6, IndexField(0)];
    $Heap := update($Heap, a#6, IndexField(0), $Box(9));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(31,8)"} true;
    // ----- assignment statement ----- Test\VSComp2010\Problem1-SumMax.dfy(32,8)
    assert 0 <= 1 && 1 < array.Length(a#6);
    assert true;
    assert $_Frame[a#6, IndexField(1)];
    $Heap := update($Heap, a#6, IndexField(1), $Box(5));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(32,8)"} true;
    // ----- assignment statement ----- Test\VSComp2010\Problem1-SumMax.dfy(33,8)
    assert 0 <= 2 && 2 < array.Length(a#6);
    assert true;
    assert $_Frame[a#6, IndexField(2)];
    $Heap := update($Heap, a#6, IndexField(2), $Box(0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(33,8)"} true;
    // ----- assignment statement ----- Test\VSComp2010\Problem1-SumMax.dfy(34,8)
    assert 0 <= 3 && 3 < array.Length(a#6);
    assert true;
    assert $_Frame[a#6, IndexField(3)];
    $Heap := update($Heap, a#6, IndexField(3), $Box(2));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(34,8)"} true;
    // ----- assignment statement ----- Test\VSComp2010\Problem1-SumMax.dfy(35,8)
    assert 0 <= 4 && 4 < array.Length(a#6);
    assert true;
    assert $_Frame[a#6, IndexField(4)];
    $Heap := update($Heap, a#6, IndexField(4), $Box(7));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(35,8)"} true;
    // ----- assignment statement ----- Test\VSComp2010\Problem1-SumMax.dfy(36,8)
    assert 0 <= 5 && 5 < array.Length(a#6);
    assert true;
    assert $_Frame[a#6, IndexField(5)];
    $Heap := update($Heap, a#6, IndexField(5), $Box(3));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(36,8)"} true;
    // ----- assignment statement ----- Test\VSComp2010\Problem1-SumMax.dfy(37,8)
    assert 0 <= 6 && 6 < array.Length(a#6);
    assert true;
    assert $_Frame[a#6, IndexField(6)];
    $Heap := update($Heap, a#6, IndexField(6), $Box(2));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(37,8)"} true;
    // ----- assignment statement ----- Test\VSComp2010\Problem1-SumMax.dfy(38,8)
    assert 0 <= 7 && 7 < array.Length(a#6);
    assert true;
    assert $_Frame[a#6, IndexField(7)];
    $Heap := update($Heap, a#6, IndexField(7), $Box(1));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(38,8)"} true;
    // ----- assignment statement ----- Test\VSComp2010\Problem1-SumMax.dfy(39,8)
    assert 0 <= 8 && 8 < array.Length(a#6);
    assert true;
    assert $_Frame[a#6, IndexField(8)];
    $Heap := update($Heap, a#6, IndexField(8), $Box(10));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(39,8)"} true;
    // ----- assignment statement ----- Test\VSComp2010\Problem1-SumMax.dfy(40,8)
    assert 0 <= 9 && 9 < array.Length(a#6);
    assert true;
    assert $_Frame[a#6, IndexField(9)];
    $Heap := update($Heap, a#6, IndexField(9), $Box(6));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(40,8)"} true;
    // ----- var-declaration statement ----- Test\VSComp2010\Problem1-SumMax.dfy(41,8)
    call CevVarIntro(#tok$0^41.8, cev_local, #loc.s#7, s#7);
    // ----- var-declaration statement ----- Test\VSComp2010\Problem1-SumMax.dfy(41,11)
    call CevVarIntro(#tok$0^41.11, cev_local, #loc.m#8, m#8);
    // ----- call statement ----- Test\VSComp2010\Problem1-SumMax.dfy(41,3)
    assert true;
    N#10 := 10;
    assert true;
    a#11 := a#6;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call s#7, m#8 := _default.M(this, N#10, a#11);
    call CevUpdateHere(#loc.s, s#7);
    call CevUpdateHere(#loc.m, m#8);
    call CevStep(#tok$0^41.3);
    assume {:captureState "Test\VSComp2010\Problem1-SumMax.dfy(41,3)"} true;
    // ----- print statement ----- Test\VSComp2010\Problem1-SumMax.dfy(42,3)
    assert {:subsumption 0} a#6 != null;
    assert {:subsumption 0} true;
    assert {:subsumption 0} true;
}


