// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: Test\VSComp2010\Problem3-FindZero.dfy /print:..\boogie-k-induction-benchmarks\benchmarks\Problem3-FindZero.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class.Node: ClassName;

axiom FDim(Node.List) == 0 && DeclType(Node.List) == class.Node;

const unique Node.List: Field (Seq BoxType);

axiom FDim(Node.Repr) == 0 && DeclType(Node.Repr) == class.Node;

const unique Node.Repr: Field (Set BoxType);

axiom (forall $h: HeapType, $o: ref, $t: BoxType :: { read($h, $o, Node.Repr)[$t] } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) && read($h, $o, Node.Repr)[$t] ==> $Unbox($t): ref == null || (read($h, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node));

axiom FDim(Node.head) == 0 && DeclType(Node.head) == class.Node;

const unique Node.head: Field int;

axiom FDim(Node.next) == 0 && DeclType(Node.next) == class.Node;

const unique Node.next: Field ref;

axiom (forall $h: HeapType, $o: ref :: { read($h, $o, Node.next) } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) ==> read($h, $o, Node.next) == null || (read($h, read($h, $o, Node.next), alloc) && dtype(read($h, $o, Node.next)) == class.Node));

function Node.Valid($heap: HeapType, this: ref) : bool;

function Node.Valid#limited($heap: HeapType, this: ref) : bool;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (0 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref :: { Node.Valid($Heap, this) } $IsGoodHeap($Heap) && this != null ==> Node.Valid($Heap, this) == (read($Heap, this, Node.Repr)[$Box(this)] && 1 <= Seq#Length(read($Heap, this, Node.List)) && $Unbox(Seq#Index(read($Heap, this, Node.List), 0)): int == read($Heap, this, Node.head) && (read($Heap, this, Node.next) == null ==> Seq#Length(read($Heap, this, Node.List)) == 1) && (read($Heap, this, Node.next) != null ==> read($Heap, this, Node.Repr)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.Repr), read($Heap, this, Node.Repr)) && !read($Heap, read($Heap, this, Node.next), Node.Repr)[$Box(this)] && Node.Valid#limited($Heap, read($Heap, this, Node.next)) && Seq#Equal(read($Heap, read($Heap, this, Node.next), Node.List), Seq#Drop(read($Heap, this, Node.List), 1)))));

axiom (forall $Heap: HeapType, this: ref :: { Node.Valid($Heap, this) } Node.Valid($Heap, this) == Node.Valid#limited($Heap, this));

// frame axiom for Node.Valid
axiom (forall $h0: HeapType, $h1: HeapType, this: ref :: { $HeapSucc($h0, $h1), Node.Valid($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Node && read($h1, this, alloc) && dtype(this) == class.Node && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && ($o == this || read($h0, this, Node.Repr)[$Box($o)]) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Node.Valid($h0, this) == Node.Valid($h1, this));

axiom (forall $h0: HeapType, $h1: HeapType, this: ref :: { $HeapSucc($h0, $h1), Node.Valid#limited($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Node && read($h1, this, alloc) && dtype(this) == class.Node && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && ($o == this || read($h0, this, Node.Repr)[$Box($o)]) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Node.Valid#limited($h0, this) == Node.Valid#limited($h1, this));

procedure CheckWellformed$$Node.Valid(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Node);
  free requires 0 == $ModuleContextHeight && 0 == $FunctionContextHeight;



implementation CheckWellformed$$Node.Valid(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || read($Heap, this, Node.Repr)[$Box($o)]);
    assert $_Frame[this, Node.Repr];
    if (read($Heap, this, Node.Repr)[$Box(this)])
    {
        assert $_Frame[this, Node.List];
    }

    if (read($Heap, this, Node.Repr)[$Box(this)] && 1 <= Seq#Length(read($Heap, this, Node.List)))
    {
        assert $_Frame[this, Node.List];
        assert 0 <= 0 && 0 < Seq#Length(read($Heap, this, Node.List));
        assert $_Frame[this, Node.head];
    }

    if (read($Heap, this, Node.Repr)[$Box(this)] && 1 <= Seq#Length(read($Heap, this, Node.List)) && $Unbox(Seq#Index(read($Heap, this, Node.List), 0)): int == read($Heap, this, Node.head))
    {
        assert $_Frame[this, Node.next];
        if (read($Heap, this, Node.next) == null)
        {
            assert $_Frame[this, Node.List];
        }
    }

    if (read($Heap, this, Node.Repr)[$Box(this)] && 1 <= Seq#Length(read($Heap, this, Node.List)) && $Unbox(Seq#Index(read($Heap, this, Node.List), 0)): int == read($Heap, this, Node.head) && (read($Heap, this, Node.next) == null ==> Seq#Length(read($Heap, this, Node.List)) == 1))
    {
        assert $_Frame[this, Node.next];
        if (read($Heap, this, Node.next) != null)
        {
            assert $_Frame[this, Node.next];
            assert $_Frame[this, Node.Repr];
            if (read($Heap, this, Node.Repr)[$Box(read($Heap, this, Node.next))])
            {
                assert $_Frame[this, Node.next];
                assert read($Heap, this, Node.next) != null;
                assert $_Frame[read($Heap, this, Node.next), Node.Repr];
                assert $_Frame[this, Node.Repr];
            }

            if (read($Heap, this, Node.Repr)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.Repr), read($Heap, this, Node.Repr)))
            {
                assert $_Frame[this, Node.next];
                assert read($Heap, this, Node.next) != null;
                assert $_Frame[read($Heap, this, Node.next), Node.Repr];
            }

            if (read($Heap, this, Node.Repr)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.Repr), read($Heap, this, Node.Repr)) && !read($Heap, read($Heap, this, Node.next), Node.Repr)[$Box(this)])
            {
                assert $_Frame[this, Node.next];
                assert read($Heap, this, Node.next) != null;
                assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && ($o == read($Heap, this, Node.next) || (read($Heap, this, Node.next) != null && read($Heap, read($Heap, this, Node.next), Node.Repr)[$Box($o)])) ==> $_Frame[$o, $f]);
                assert Set#Subset(Set#Union(read($Heap, read($Heap, this, Node.next), Node.Repr), Set#UnionOne(Set#Empty(): Set BoxType, $Box(read($Heap, this, Node.next)))), Set#Union(read($Heap, this, Node.Repr), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)))) && !Set#Subset(Set#Union(read($Heap, this, Node.Repr), Set#UnionOne(Set#Empty(): Set BoxType, $Box(this))), Set#Union(read($Heap, read($Heap, this, Node.next), Node.Repr), Set#UnionOne(Set#Empty(): Set BoxType, $Box(read($Heap, this, Node.next)))));
            }

            if (read($Heap, this, Node.Repr)[$Box(read($Heap, this, Node.next))] && Set#Subset(read($Heap, read($Heap, this, Node.next), Node.Repr), read($Heap, this, Node.Repr)) && !read($Heap, read($Heap, this, Node.next), Node.Repr)[$Box(this)] && Node.Valid($Heap, read($Heap, this, Node.next)))
            {
                assert $_Frame[this, Node.next];
                assert read($Heap, this, Node.next) != null;
                assert $_Frame[read($Heap, this, Node.next), Node.List];
                assert $_Frame[this, Node.List];
                assert 0 <= 1 && 1 <= Seq#Length(read($Heap, this, Node.List));
            }
        }
    }
}



const unique xxxxxxfile: $token;

axiom $file_name_is(0, xxxxxxfile);

const unique #tok$0^38.17: $token;

procedure CheckWellformed$$Node.Cons(x#0: int, tail#1: ref where tail#1 == null || (read($Heap, tail#1, alloc) && dtype(tail#1) == class.Node)) returns (n#2: ref where n#2 == null || (read($Heap, n#2, alloc) && dtype(n#2) == class.Node));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^38.17;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^38.22: $token;

const unique #loc.x#0: $token;

const unique #tok$0^38.30: $token;

const unique #loc.tail#1: $token;

const unique #tok$0^38.51: $token;

const unique #loc.n#2: $token;

implementation CheckWellformed$$Node.Cons(x#0: int, tail#1: ref) returns (n#2: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^38.22, cev_parameter, #loc.x#0, x#0);
    call CevVarIntro(#tok$0^38.30, cev_parameter, #loc.tail#1, tail#1);
    call CevVarIntro(#tok$0^38.51, cev_local, #loc.n#2, n#2);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    if (tail#1 != null)
    {
        assert tail#1 != null;
    }

    assume tail#1 == null || Node.Valid($Heap, tail#1);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc n#2;
    if (n#2 != null)
    {
        assert n#2 != null;
    }

    assume n#2 != null && Node.Valid($Heap, n#2);
    if (tail#1 == null)
    {
        assert n#2 != null;
    }
    else
    {
        assert n#2 != null;
        assert tail#1 != null;
    }

    assume $ite(tail#1 == null, Seq#Equal(read($Heap, n#2, Node.List), Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box(x#0), 1)), Seq#Equal(read($Heap, n#2, Node.List), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box(x#0), 1), read($Heap, tail#1, Node.List))));
}



procedure Node.Cons(x#0: int, tail#1: ref where tail#1 == null || (read($Heap, tail#1, alloc) && dtype(tail#1) == class.Node)) returns (n#2: ref where n#2 == null || (read($Heap, n#2, alloc) && dtype(n#2) == class.Node));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires tail#1 == null || Node.Valid($Heap, tail#1);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^38.17;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures n#2 != null && Node.Valid($Heap, n#2);
  free ensures Node.Valid($Heap, n#2) ==> read($Heap, n#2, Node.Repr)[$Box(n#2)] && 1 <= Seq#Length(read($Heap, n#2, Node.List)) && $Unbox(Seq#Index(read($Heap, n#2, Node.List), 0)): int == read($Heap, n#2, Node.head) && (read($Heap, n#2, Node.next) == null ==> Seq#Length(read($Heap, n#2, Node.List)) == 1) && (read($Heap, n#2, Node.next) != null ==> read($Heap, n#2, Node.Repr)[$Box(read($Heap, n#2, Node.next))] && Set#Subset(read($Heap, read($Heap, n#2, Node.next), Node.Repr), read($Heap, n#2, Node.Repr)) && !read($Heap, read($Heap, n#2, Node.next), Node.Repr)[$Box(n#2)] && Node.Valid($Heap, read($Heap, n#2, Node.next)) && Seq#Equal(read($Heap, read($Heap, n#2, Node.next), Node.List), Seq#Drop(read($Heap, n#2, Node.List), 1)));
  ensures (Node.Valid($Heap, n#2) ==> read($Heap, n#2, Node.Repr)[$Box(n#2)] && 1 <= Seq#Length(read($Heap, n#2, Node.List)) && $Unbox(Seq#Index(read($Heap, n#2, Node.List), 0)): int == read($Heap, n#2, Node.head) && (read($Heap, n#2, Node.next) == null ==> Seq#Length(read($Heap, n#2, Node.List)) == 1) && (read($Heap, n#2, Node.next) != null ==> read($Heap, n#2, Node.Repr)[$Box(read($Heap, n#2, Node.next))] && Set#Subset(read($Heap, read($Heap, n#2, Node.next), Node.Repr), read($Heap, n#2, Node.Repr)) && !read($Heap, read($Heap, n#2, Node.next), Node.Repr)[$Box(n#2)] && Node.Valid($Heap, read($Heap, n#2, Node.next)) && Seq#Equal(read($Heap, read($Heap, n#2, Node.next), Node.List), Seq#Drop(read($Heap, n#2, Node.List), 1)))) ==> n#2 != null;
  ensures (Node.Valid($Heap, n#2) ==> read($Heap, n#2, Node.Repr)[$Box(n#2)] && 1 <= Seq#Length(read($Heap, n#2, Node.List)) && $Unbox(Seq#Index(read($Heap, n#2, Node.List), 0)): int == read($Heap, n#2, Node.head) && (read($Heap, n#2, Node.next) == null ==> Seq#Length(read($Heap, n#2, Node.List)) == 1) && (read($Heap, n#2, Node.next) != null ==> read($Heap, n#2, Node.Repr)[$Box(read($Heap, n#2, Node.next))] && Set#Subset(read($Heap, read($Heap, n#2, Node.next), Node.Repr), read($Heap, n#2, Node.Repr)) && !read($Heap, read($Heap, n#2, Node.next), Node.Repr)[$Box(n#2)] && Node.Valid($Heap, read($Heap, n#2, Node.next)) && Seq#Equal(read($Heap, read($Heap, n#2, Node.next), Node.List), Seq#Drop(read($Heap, n#2, Node.List), 1)))) ==> read($Heap, n#2, Node.Repr)[$Box(n#2)];
  ensures (Node.Valid($Heap, n#2) ==> read($Heap, n#2, Node.Repr)[$Box(n#2)] && 1 <= Seq#Length(read($Heap, n#2, Node.List)) && $Unbox(Seq#Index(read($Heap, n#2, Node.List), 0)): int == read($Heap, n#2, Node.head) && (read($Heap, n#2, Node.next) == null ==> Seq#Length(read($Heap, n#2, Node.List)) == 1) && (read($Heap, n#2, Node.next) != null ==> read($Heap, n#2, Node.Repr)[$Box(read($Heap, n#2, Node.next))] && Set#Subset(read($Heap, read($Heap, n#2, Node.next), Node.Repr), read($Heap, n#2, Node.Repr)) && !read($Heap, read($Heap, n#2, Node.next), Node.Repr)[$Box(n#2)] && Node.Valid($Heap, read($Heap, n#2, Node.next)) && Seq#Equal(read($Heap, read($Heap, n#2, Node.next), Node.List), Seq#Drop(read($Heap, n#2, Node.List), 1)))) ==> 1 <= Seq#Length(read($Heap, n#2, Node.List));
  ensures (Node.Valid($Heap, n#2) ==> read($Heap, n#2, Node.Repr)[$Box(n#2)] && 1 <= Seq#Length(read($Heap, n#2, Node.List)) && $Unbox(Seq#Index(read($Heap, n#2, Node.List), 0)): int == read($Heap, n#2, Node.head) && (read($Heap, n#2, Node.next) == null ==> Seq#Length(read($Heap, n#2, Node.List)) == 1) && (read($Heap, n#2, Node.next) != null ==> read($Heap, n#2, Node.Repr)[$Box(read($Heap, n#2, Node.next))] && Set#Subset(read($Heap, read($Heap, n#2, Node.next), Node.Repr), read($Heap, n#2, Node.Repr)) && !read($Heap, read($Heap, n#2, Node.next), Node.Repr)[$Box(n#2)] && Node.Valid($Heap, read($Heap, n#2, Node.next)) && Seq#Equal(read($Heap, read($Heap, n#2, Node.next), Node.List), Seq#Drop(read($Heap, n#2, Node.List), 1)))) ==> $Unbox(Seq#Index(read($Heap, n#2, Node.List), 0)): int == read($Heap, n#2, Node.head);
  ensures (Node.Valid($Heap, n#2) ==> read($Heap, n#2, Node.Repr)[$Box(n#2)] && 1 <= Seq#Length(read($Heap, n#2, Node.List)) && $Unbox(Seq#Index(read($Heap, n#2, Node.List), 0)): int == read($Heap, n#2, Node.head) && (read($Heap, n#2, Node.next) == null ==> Seq#Length(read($Heap, n#2, Node.List)) == 1) && (read($Heap, n#2, Node.next) != null ==> read($Heap, n#2, Node.Repr)[$Box(read($Heap, n#2, Node.next))] && Set#Subset(read($Heap, read($Heap, n#2, Node.next), Node.Repr), read($Heap, n#2, Node.Repr)) && !read($Heap, read($Heap, n#2, Node.next), Node.Repr)[$Box(n#2)] && Node.Valid($Heap, read($Heap, n#2, Node.next)) && Seq#Equal(read($Heap, read($Heap, n#2, Node.next), Node.List), Seq#Drop(read($Heap, n#2, Node.List), 1)))) ==> read($Heap, n#2, Node.next) == null ==> Seq#Length(read($Heap, n#2, Node.List)) == 1;
  ensures (Node.Valid($Heap, n#2) ==> read($Heap, n#2, Node.Repr)[$Box(n#2)] && 1 <= Seq#Length(read($Heap, n#2, Node.List)) && $Unbox(Seq#Index(read($Heap, n#2, Node.List), 0)): int == read($Heap, n#2, Node.head) && (read($Heap, n#2, Node.next) == null ==> Seq#Length(read($Heap, n#2, Node.List)) == 1) && (read($Heap, n#2, Node.next) != null ==> read($Heap, n#2, Node.Repr)[$Box(read($Heap, n#2, Node.next))] && Set#Subset(read($Heap, read($Heap, n#2, Node.next), Node.Repr), read($Heap, n#2, Node.Repr)) && !read($Heap, read($Heap, n#2, Node.next), Node.Repr)[$Box(n#2)] && Node.Valid($Heap, read($Heap, n#2, Node.next)) && Seq#Equal(read($Heap, read($Heap, n#2, Node.next), Node.List), Seq#Drop(read($Heap, n#2, Node.List), 1)))) ==> read($Heap, n#2, Node.next) != null ==> read($Heap, n#2, Node.Repr)[$Box(read($Heap, n#2, Node.next))];
  ensures (Node.Valid($Heap, n#2) ==> read($Heap, n#2, Node.Repr)[$Box(n#2)] && 1 <= Seq#Length(read($Heap, n#2, Node.List)) && $Unbox(Seq#Index(read($Heap, n#2, Node.List), 0)): int == read($Heap, n#2, Node.head) && (read($Heap, n#2, Node.next) == null ==> Seq#Length(read($Heap, n#2, Node.List)) == 1) && (read($Heap, n#2, Node.next) != null ==> read($Heap, n#2, Node.Repr)[$Box(read($Heap, n#2, Node.next))] && Set#Subset(read($Heap, read($Heap, n#2, Node.next), Node.Repr), read($Heap, n#2, Node.Repr)) && !read($Heap, read($Heap, n#2, Node.next), Node.Repr)[$Box(n#2)] && Node.Valid($Heap, read($Heap, n#2, Node.next)) && Seq#Equal(read($Heap, read($Heap, n#2, Node.next), Node.List), Seq#Drop(read($Heap, n#2, Node.List), 1)))) ==> read($Heap, n#2, Node.next) != null ==> Set#Subset(read($Heap, read($Heap, n#2, Node.next), Node.Repr), read($Heap, n#2, Node.Repr));
  ensures (Node.Valid($Heap, n#2) ==> read($Heap, n#2, Node.Repr)[$Box(n#2)] && 1 <= Seq#Length(read($Heap, n#2, Node.List)) && $Unbox(Seq#Index(read($Heap, n#2, Node.List), 0)): int == read($Heap, n#2, Node.head) && (read($Heap, n#2, Node.next) == null ==> Seq#Length(read($Heap, n#2, Node.List)) == 1) && (read($Heap, n#2, Node.next) != null ==> read($Heap, n#2, Node.Repr)[$Box(read($Heap, n#2, Node.next))] && Set#Subset(read($Heap, read($Heap, n#2, Node.next), Node.Repr), read($Heap, n#2, Node.Repr)) && !read($Heap, read($Heap, n#2, Node.next), Node.Repr)[$Box(n#2)] && Node.Valid($Heap, read($Heap, n#2, Node.next)) && Seq#Equal(read($Heap, read($Heap, n#2, Node.next), Node.List), Seq#Drop(read($Heap, n#2, Node.List), 1)))) ==> read($Heap, n#2, Node.next) != null ==> !read($Heap, read($Heap, n#2, Node.next), Node.Repr)[$Box(n#2)];
  ensures (Node.Valid($Heap, n#2) ==> read($Heap, n#2, Node.Repr)[$Box(n#2)] && 1 <= Seq#Length(read($Heap, n#2, Node.List)) && $Unbox(Seq#Index(read($Heap, n#2, Node.List), 0)): int == read($Heap, n#2, Node.head) && (read($Heap, n#2, Node.next) == null ==> Seq#Length(read($Heap, n#2, Node.List)) == 1) && (read($Heap, n#2, Node.next) != null ==> read($Heap, n#2, Node.Repr)[$Box(read($Heap, n#2, Node.next))] && Set#Subset(read($Heap, read($Heap, n#2, Node.next), Node.Repr), read($Heap, n#2, Node.Repr)) && !read($Heap, read($Heap, n#2, Node.next), Node.Repr)[$Box(n#2)] && Node.Valid($Heap, read($Heap, n#2, Node.next)) && Seq#Equal(read($Heap, read($Heap, n#2, Node.next), Node.List), Seq#Drop(read($Heap, n#2, Node.List), 1)))) ==> read($Heap, n#2, Node.next) != null ==> Node.Valid($Heap, read($Heap, n#2, Node.next));
  ensures (Node.Valid($Heap, n#2) ==> read($Heap, n#2, Node.Repr)[$Box(n#2)] && 1 <= Seq#Length(read($Heap, n#2, Node.List)) && $Unbox(Seq#Index(read($Heap, n#2, Node.List), 0)): int == read($Heap, n#2, Node.head) && (read($Heap, n#2, Node.next) == null ==> Seq#Length(read($Heap, n#2, Node.List)) == 1) && (read($Heap, n#2, Node.next) != null ==> read($Heap, n#2, Node.Repr)[$Box(read($Heap, n#2, Node.next))] && Set#Subset(read($Heap, read($Heap, n#2, Node.next), Node.Repr), read($Heap, n#2, Node.Repr)) && !read($Heap, read($Heap, n#2, Node.next), Node.Repr)[$Box(n#2)] && Node.Valid($Heap, read($Heap, n#2, Node.next)) && Seq#Equal(read($Heap, read($Heap, n#2, Node.next), Node.List), Seq#Drop(read($Heap, n#2, Node.List), 1)))) ==> read($Heap, n#2, Node.next) != null ==> Seq#Equal(read($Heap, read($Heap, n#2, Node.next), Node.List), Seq#Drop(read($Heap, n#2, Node.List), 1));
  free ensures $ite(tail#1 == null, Seq#Equal(read($Heap, n#2, Node.List), Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box(x#0), 1)), Seq#Equal(read($Heap, n#2, Node.List), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box(x#0), 1), read($Heap, tail#1, Node.List))));
  ensures true ==> tail#1 == null ==> Seq#Equal(read($Heap, n#2, Node.List), Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box(x#0), 1));
  ensures true ==> tail#1 != null ==> Seq#Equal(read($Heap, n#2, Node.List), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box(x#0), 1), read($Heap, tail#1, Node.List)));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^43.7: $token;

const unique #tok$0^44.12: $token;

const unique #tok$0^45.12: $token;

const unique #tok$0^46.5: $token;

const unique #tok$0^46.23: $token;

const unique #tok$0^47.14: $token;

const unique #tok$0^48.14: $token;

const unique #tok$0^49.12: $token;

const unique #tok$0^50.14: $token;

const unique #tok$0^51.14: $token;

implementation Node.Cons(x#0: int, tail#1: ref) returns (n#2: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $nw: ref;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^38.22, cev_parameter, #loc.x#0, x#0);
    call CevVarIntro(#tok$0^38.30, cev_parameter, #loc.tail#1, tail#1);
    call CevVarIntro(#tok$0^38.51, cev_local, #loc.n#2, n#2);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- assignment statement ----- Test\VSComp2010\Problem3-FindZero.dfy(43,7)
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.Node;
    $Heap := update($Heap, $nw, alloc, true);
    n#2 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(43,7)"} true;
    call CevUpdate(#tok$0^43.7, #loc.n#2, n#2);
    // ----- assignment statement ----- Test\VSComp2010\Problem3-FindZero.dfy(44,12)
    assert n#2 != null;
    assert true;
    assert $_Frame[n#2, Node.head];
    $Heap := update($Heap, n#2, Node.head, x#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(44,12)"} true;
    call CevUpdateHeap(#tok$0^44.12, #loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\VSComp2010\Problem3-FindZero.dfy(45,12)
    assert n#2 != null;
    assert true;
    assert $_Frame[n#2, Node.next];
    $Heap := update($Heap, n#2, Node.next, tail#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(45,12)"} true;
    call CevUpdateHeap(#tok$0^45.12, #loc.$Heap, $Heap);
    // ----- if statement ----- Test\VSComp2010\Problem3-FindZero.dfy(46,5)
    call CevEvent(#tok$0^46.5, conditional_moment);
    assert true;
    if (tail#1 == null)
    {
        call CevEvent(#tok$0^46.23, took_then_branch);
        // ----- assignment statement ----- Test\VSComp2010\Problem3-FindZero.dfy(47,14)
        assert n#2 != null;
        assert true;
        assert $_Frame[n#2, Node.List];
        $Heap := update($Heap, n#2, Node.List, Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box(x#0), 1));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(47,14)"} true;
        call CevUpdateHeap(#tok$0^47.14, #loc.$Heap, $Heap);
        // ----- assignment statement ----- Test\VSComp2010\Problem3-FindZero.dfy(48,14)
        assert n#2 != null;
        assert true;
        assert $_Frame[n#2, Node.Repr];
        $Heap := update($Heap, n#2, Node.Repr, Set#UnionOne(Set#Empty(): Set BoxType, $Box(n#2)));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(48,14)"} true;
        call CevUpdateHeap(#tok$0^48.14, #loc.$Heap, $Heap);
    }
    else
    {
        call CevEvent(#tok$0^49.12, took_else_branch);
        // ----- assignment statement ----- Test\VSComp2010\Problem3-FindZero.dfy(50,14)
        assert n#2 != null;
        assert tail#1 != null;
        assert $_Frame[n#2, Node.List];
        $Heap := update($Heap, n#2, Node.List, Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box(x#0), 1), read($Heap, tail#1, Node.List)));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(50,14)"} true;
        call CevUpdateHeap(#tok$0^50.14, #loc.$Heap, $Heap);
        // ----- assignment statement ----- Test\VSComp2010\Problem3-FindZero.dfy(51,14)
        assert n#2 != null;
        assert tail#1 != null;
        assert $_Frame[n#2, Node.Repr];
        $Heap := update($Heap, n#2, Node.Repr, Set#Union(Set#UnionOne(Set#Empty(): Set BoxType, $Box(n#2)), read($Heap, tail#1, Node.Repr)));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(51,14)"} true;
        call CevUpdateHeap(#tok$0^51.14, #loc.$Heap, $Heap);
    }
}



const unique class._default: ClassName;

const unique #tok$0^56.15: $token;

procedure CheckWellformed$$_default.Search(ll#3: ref where ll#3 == null || (read($Heap, ll#3, alloc) && dtype(ll#3) == class.Node)) returns (r#4: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^56.15;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^56.22: $token;

const unique #loc.ll#3: $token;

const unique #tok$0^56.41: $token;

const unique #loc.r#4: $token;

implementation CheckWellformed$$_default.Search(ll#3: ref) returns (r#4: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^56.22, cev_parameter, #loc.ll#3, ll#3);
    call CevVarIntro(#tok$0^56.41, cev_local, #loc.r#4, r#4);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    if (ll#3 != null)
    {
        assert ll#3 != null;
    }

    assume ll#3 == null || Node.Valid($Heap, ll#3);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc r#4;
    if (ll#3 == null)
    {
    }

    assume ll#3 == null ==> r#4 == 0;
    if (ll#3 != null)
    {
        if (0 <= r#4)
        {
            assert ll#3 != null;
        }

        if (0 <= r#4 && r#4 <= Seq#Length(read($Heap, ll#3, Node.List)))
        {
            assert ll#3 != null;
            if (r#4 < Seq#Length(read($Heap, ll#3, Node.List)))
            {
                assert ll#3 != null;
                assert 0 <= r#4 && r#4 < Seq#Length(read($Heap, ll#3, Node.List));
                if ($Unbox(Seq#Index(read($Heap, ll#3, Node.List), r#4)): int == 0)
                {
                    assert ll#3 != null;
                    assert 0 <= r#4 && r#4 <= Seq#Length(read($Heap, ll#3, Node.List));
                }
            }
        }

        if (0 <= r#4 && r#4 <= Seq#Length(read($Heap, ll#3, Node.List)) && (r#4 < Seq#Length(read($Heap, ll#3, Node.List)) ==> $Unbox(Seq#Index(read($Heap, ll#3, Node.List), r#4)): int == 0 && !Seq#Contains(Seq#Take(read($Heap, ll#3, Node.List), r#4), $Box(0))))
        {
            assert ll#3 != null;
            if (r#4 == Seq#Length(read($Heap, ll#3, Node.List)))
            {
                assert ll#3 != null;
            }
        }
    }

    assume ll#3 != null ==> 0 <= r#4 && r#4 <= Seq#Length(read($Heap, ll#3, Node.List)) && (r#4 < Seq#Length(read($Heap, ll#3, Node.List)) ==> $Unbox(Seq#Index(read($Heap, ll#3, Node.List), r#4)): int == 0 && !Seq#Contains(Seq#Take(read($Heap, ll#3, Node.List), r#4), $Box(0))) && (r#4 == Seq#Length(read($Heap, ll#3, Node.List)) ==> !Seq#Contains(read($Heap, ll#3, Node.List), $Box(0)));
}



procedure _default.Search(ll#3: ref where ll#3 == null || (read($Heap, ll#3, alloc) && dtype(ll#3) == class.Node)) returns (r#4: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires ll#3 == null || Node.Valid($Heap, ll#3);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^56.15;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures ll#3 == null ==> r#4 == 0;
  free ensures ll#3 != null ==> 0 <= r#4 && r#4 <= Seq#Length(read($Heap, ll#3, Node.List)) && (r#4 < Seq#Length(read($Heap, ll#3, Node.List)) ==> $Unbox(Seq#Index(read($Heap, ll#3, Node.List), r#4)): int == 0 && !Seq#Contains(Seq#Take(read($Heap, ll#3, Node.List), r#4), $Box(0))) && (r#4 == Seq#Length(read($Heap, ll#3, Node.List)) ==> !Seq#Contains(read($Heap, ll#3, Node.List), $Box(0)));
  ensures true ==> ll#3 != null ==> 0 <= r#4;
  ensures true ==> ll#3 != null ==> r#4 <= Seq#Length(read($Heap, ll#3, Node.List));
  ensures true ==> ll#3 != null ==> r#4 < Seq#Length(read($Heap, ll#3, Node.List)) ==> $Unbox(Seq#Index(read($Heap, ll#3, Node.List), r#4)): int == 0;
  ensures true ==> ll#3 != null ==> r#4 < Seq#Length(read($Heap, ll#3, Node.List)) ==> !Seq#Contains(Seq#Take(read($Heap, ll#3, Node.List), r#4), $Box(0));
  ensures true ==> ll#3 != null ==> r#4 == Seq#Length(read($Heap, ll#3, Node.List)) ==> !Seq#Contains(read($Heap, ll#3, Node.List), $Box(0));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^64.3: $token;

const unique #tok$0^64.19: $token;

const unique #tok$0^65.7: $token;

const unique #tok$0^66.10: $token;

const unique #loc.jj#5: $token;

const unique #tok$0^67.9: $token;

const unique #loc.i#6: $token;

const unique #tok$0^68.9: $token;

const unique #tok$0^69.5: $token;

const unique #tok$0^75.10: $token;

const unique #tok$0^76.9: $token;

const unique #tok$0^78.7: $token;

implementation _default.Search(ll#3: ref) returns (r#4: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var jj#5: ref where (jj#5 == null || (read($Heap, jj#5, alloc) && dtype(jj#5) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.jj#5, jj#5);
  var i#6: int where #cev_var_update(#cev_pc, cev_local, #loc.i#6, i#6);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^56.22, cev_parameter, #loc.ll#3, ll#3);
    call CevVarIntro(#tok$0^56.41, cev_local, #loc.r#4, r#4);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- if statement ----- Test\VSComp2010\Problem3-FindZero.dfy(64,3)
    call CevEvent(#tok$0^64.3, conditional_moment);
    assert true;
    if (ll#3 == null)
    {
        call CevEvent(#tok$0^64.19, took_then_branch);
        // ----- assignment statement ----- Test\VSComp2010\Problem3-FindZero.dfy(65,7)
        assert true;
        assert true;
        r#4 := 0;
        assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(65,7)"} true;
        call CevUpdate(#tok$0^65.7, #loc.r#4, r#4);
    }
    else
    {
        call CevEvent(#tok$0^66.10, took_else_branch);
        // ----- var-declaration statement ----- Test\VSComp2010\Problem3-FindZero.dfy(67,9)
        assert true;
        assert true;
        jj#5 := ll#3;
        assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(67,9)"} true;
        call CevVarIntro(#tok$0^67.9, cev_local, #loc.jj#5, jj#5);
        // ----- var-declaration statement ----- Test\VSComp2010\Problem3-FindZero.dfy(68,9)
        assert true;
        assert true;
        i#6 := 0;
        assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(68,9)"} true;
        call CevVarIntro(#tok$0^68.9, cev_local, #loc.i#6, i#6);
        // ----- while statement ----- Test\VSComp2010\Problem3-FindZero.dfy(69,5)
        $PreLoopHeap0 := $Heap;
        $decr0$init$0 := Seq#Length(read($Heap, ll#3, Node.List)) - i#6;
        havoc $w0;
        call $PreLoopCevPC0 := CevPreLoop(#tok$0^69.5);
        while (true)
          free invariant Node.Valid($Heap, jj#5) ==> read($Heap, jj#5, Node.Repr)[$Box(jj#5)] && 1 <= Seq#Length(read($Heap, jj#5, Node.List)) && $Unbox(Seq#Index(read($Heap, jj#5, Node.List), 0)): int == read($Heap, jj#5, Node.head) && (read($Heap, jj#5, Node.next) == null ==> Seq#Length(read($Heap, jj#5, Node.List)) == 1) && (read($Heap, jj#5, Node.next) != null ==> read($Heap, jj#5, Node.Repr)[$Box(read($Heap, jj#5, Node.next))] && Set#Subset(read($Heap, read($Heap, jj#5, Node.next), Node.Repr), read($Heap, jj#5, Node.Repr)) && !read($Heap, read($Heap, jj#5, Node.next), Node.Repr)[$Box(jj#5)] && Node.Valid($Heap, read($Heap, jj#5, Node.next)) && Seq#Equal(read($Heap, read($Heap, jj#5, Node.next), Node.List), Seq#Drop(read($Heap, jj#5, Node.List), 1)));
          invariant $w0 && (Node.Valid($Heap, jj#5)
                    ==> read($Heap, jj#5, Node.Repr)[$Box(jj#5)] && 1 <= Seq#Length(read($Heap, jj#5, Node.List)) && $Unbox(Seq#Index(read($Heap, jj#5, Node.List), 0)): int == read($Heap, jj#5, Node.head) && (read($Heap, jj#5, Node.next) == null
                    ==> Seq#Length(read($Heap, jj#5, Node.List)) == 1) && (read($Heap, jj#5, Node.next) != null
                    ==> read($Heap, jj#5, Node.Repr)[$Box(read($Heap, jj#5, Node.next))] && Set#Subset(read($Heap, read($Heap, jj#5, Node.next), Node.Repr), read($Heap, jj#5, Node.Repr)) && !read($Heap, read($Heap, jj#5, Node.next), Node.Repr)[$Box(jj#5)] && Node.Valid($Heap, read($Heap, jj#5, Node.next)) && Seq#Equal(read($Heap, read($Heap, jj#5, Node.next), Node.List), Seq#Drop(read($Heap, jj#5, Node.List), 1))))
                    ==> jj#5 != null
                    ==> read($Heap, jj#5, Node.Repr)[$Box(jj#5)];
          invariant $w0 && (Node.Valid($Heap, jj#5) ==> read($Heap, jj#5, Node.Repr)[$Box(jj#5)] && 1 <= Seq#Length(read($Heap, jj#5, Node.List)) && $Unbox(Seq#Index(read($Heap, jj#5, Node.List), 0)): int == read($Heap, jj#5, Node.head) && (read($Heap, jj#5, Node.next) == null ==> Seq#Length(read($Heap, jj#5, Node.List)) == 1) && (read($Heap, jj#5, Node.next) != null ==> read($Heap, jj#5, Node.Repr)[$Box(read($Heap, jj#5, Node.next))] && Set#Subset(read($Heap, read($Heap, jj#5, Node.next), Node.Repr), read($Heap, jj#5, Node.Repr)) && !read($Heap, read($Heap, jj#5, Node.next), Node.Repr)[$Box(jj#5)] && Node.Valid($Heap, read($Heap, jj#5, Node.next)) && Seq#Equal(read($Heap, read($Heap, jj#5, Node.next), Node.List), Seq#Drop(read($Heap, jj#5, Node.List), 1)))) ==> jj#5 != null ==> 1 <= Seq#Length(read($Heap, jj#5, Node.List));
          invariant $w0 && (Node.Valid($Heap, jj#5) ==> read($Heap, jj#5, Node.Repr)[$Box(jj#5)] && 1 <= Seq#Length(read($Heap, jj#5, Node.List)) && $Unbox(Seq#Index(read($Heap, jj#5, Node.List), 0)): int == read($Heap, jj#5, Node.head) && (read($Heap, jj#5, Node.next) == null ==> Seq#Length(read($Heap, jj#5, Node.List)) == 1) && (read($Heap, jj#5, Node.next) != null ==> read($Heap, jj#5, Node.Repr)[$Box(read($Heap, jj#5, Node.next))] && Set#Subset(read($Heap, read($Heap, jj#5, Node.next), Node.Repr), read($Heap, jj#5, Node.Repr)) && !read($Heap, read($Heap, jj#5, Node.next), Node.Repr)[$Box(jj#5)] && Node.Valid($Heap, read($Heap, jj#5, Node.next)) && Seq#Equal(read($Heap, read($Heap, jj#5, Node.next), Node.List), Seq#Drop(read($Heap, jj#5, Node.List), 1)))) ==> jj#5 != null ==> $Unbox(Seq#Index(read($Heap, jj#5, Node.List), 0)): int == read($Heap, jj#5, Node.head);
          invariant $w0 && (Node.Valid($Heap, jj#5) ==> read($Heap, jj#5, Node.Repr)[$Box(jj#5)] && 1 <= Seq#Length(read($Heap, jj#5, Node.List)) && $Unbox(Seq#Index(read($Heap, jj#5, Node.List), 0)): int == read($Heap, jj#5, Node.head) && (read($Heap, jj#5, Node.next) == null ==> Seq#Length(read($Heap, jj#5, Node.List)) == 1) && (read($Heap, jj#5, Node.next) != null ==> read($Heap, jj#5, Node.Repr)[$Box(read($Heap, jj#5, Node.next))] && Set#Subset(read($Heap, read($Heap, jj#5, Node.next), Node.Repr), read($Heap, jj#5, Node.Repr)) && !read($Heap, read($Heap, jj#5, Node.next), Node.Repr)[$Box(jj#5)] && Node.Valid($Heap, read($Heap, jj#5, Node.next)) && Seq#Equal(read($Heap, read($Heap, jj#5, Node.next), Node.List), Seq#Drop(read($Heap, jj#5, Node.List), 1)))) ==> jj#5 != null ==> read($Heap, jj#5, Node.next) == null ==> Seq#Length(read($Heap, jj#5, Node.List)) == 1;
          invariant $w0 && (Node.Valid($Heap, jj#5) ==> read($Heap, jj#5, Node.Repr)[$Box(jj#5)] && 1 <= Seq#Length(read($Heap, jj#5, Node.List)) && $Unbox(Seq#Index(read($Heap, jj#5, Node.List), 0)): int == read($Heap, jj#5, Node.head) && (read($Heap, jj#5, Node.next) == null ==> Seq#Length(read($Heap, jj#5, Node.List)) == 1) && (read($Heap, jj#5, Node.next) != null ==> read($Heap, jj#5, Node.Repr)[$Box(read($Heap, jj#5, Node.next))] && Set#Subset(read($Heap, read($Heap, jj#5, Node.next), Node.Repr), read($Heap, jj#5, Node.Repr)) && !read($Heap, read($Heap, jj#5, Node.next), Node.Repr)[$Box(jj#5)] && Node.Valid($Heap, read($Heap, jj#5, Node.next)) && Seq#Equal(read($Heap, read($Heap, jj#5, Node.next), Node.List), Seq#Drop(read($Heap, jj#5, Node.List), 1)))) ==> jj#5 != null ==> read($Heap, jj#5, Node.next) != null ==> read($Heap, jj#5, Node.Repr)[$Box(read($Heap, jj#5, Node.next))];
          invariant $w0 && (Node.Valid($Heap, jj#5) ==> read($Heap, jj#5, Node.Repr)[$Box(jj#5)] && 1 <= Seq#Length(read($Heap, jj#5, Node.List)) && $Unbox(Seq#Index(read($Heap, jj#5, Node.List), 0)): int == read($Heap, jj#5, Node.head) && (read($Heap, jj#5, Node.next) == null ==> Seq#Length(read($Heap, jj#5, Node.List)) == 1) && (read($Heap, jj#5, Node.next) != null ==> read($Heap, jj#5, Node.Repr)[$Box(read($Heap, jj#5, Node.next))] && Set#Subset(read($Heap, read($Heap, jj#5, Node.next), Node.Repr), read($Heap, jj#5, Node.Repr)) && !read($Heap, read($Heap, jj#5, Node.next), Node.Repr)[$Box(jj#5)] && Node.Valid($Heap, read($Heap, jj#5, Node.next)) && Seq#Equal(read($Heap, read($Heap, jj#5, Node.next), Node.List), Seq#Drop(read($Heap, jj#5, Node.List), 1)))) ==> jj#5 != null ==> read($Heap, jj#5, Node.next) != null ==> Set#Subset(read($Heap, read($Heap, jj#5, Node.next), Node.Repr), read($Heap, jj#5, Node.Repr));
          invariant $w0 && (Node.Valid($Heap, jj#5) ==> read($Heap, jj#5, Node.Repr)[$Box(jj#5)] && 1 <= Seq#Length(read($Heap, jj#5, Node.List)) && $Unbox(Seq#Index(read($Heap, jj#5, Node.List), 0)): int == read($Heap, jj#5, Node.head) && (read($Heap, jj#5, Node.next) == null ==> Seq#Length(read($Heap, jj#5, Node.List)) == 1) && (read($Heap, jj#5, Node.next) != null ==> read($Heap, jj#5, Node.Repr)[$Box(read($Heap, jj#5, Node.next))] && Set#Subset(read($Heap, read($Heap, jj#5, Node.next), Node.Repr), read($Heap, jj#5, Node.Repr)) && !read($Heap, read($Heap, jj#5, Node.next), Node.Repr)[$Box(jj#5)] && Node.Valid($Heap, read($Heap, jj#5, Node.next)) && Seq#Equal(read($Heap, read($Heap, jj#5, Node.next), Node.List), Seq#Drop(read($Heap, jj#5, Node.List), 1)))) ==> jj#5 != null ==> read($Heap, jj#5, Node.next) != null ==> !read($Heap, read($Heap, jj#5, Node.next), Node.Repr)[$Box(jj#5)];
          invariant $w0 && (Node.Valid($Heap, jj#5) ==> read($Heap, jj#5, Node.Repr)[$Box(jj#5)] && 1 <= Seq#Length(read($Heap, jj#5, Node.List)) && $Unbox(Seq#Index(read($Heap, jj#5, Node.List), 0)): int == read($Heap, jj#5, Node.head) && (read($Heap, jj#5, Node.next) == null ==> Seq#Length(read($Heap, jj#5, Node.List)) == 1) && (read($Heap, jj#5, Node.next) != null ==> read($Heap, jj#5, Node.Repr)[$Box(read($Heap, jj#5, Node.next))] && Set#Subset(read($Heap, read($Heap, jj#5, Node.next), Node.Repr), read($Heap, jj#5, Node.Repr)) && !read($Heap, read($Heap, jj#5, Node.next), Node.Repr)[$Box(jj#5)] && Node.Valid($Heap, read($Heap, jj#5, Node.next)) && Seq#Equal(read($Heap, read($Heap, jj#5, Node.next), Node.List), Seq#Drop(read($Heap, jj#5, Node.List), 1)))) ==> jj#5 != null ==> read($Heap, jj#5, Node.next) != null ==> Node.Valid($Heap, read($Heap, jj#5, Node.next));
          invariant $w0 && (Node.Valid($Heap, jj#5) ==> read($Heap, jj#5, Node.Repr)[$Box(jj#5)] && 1 <= Seq#Length(read($Heap, jj#5, Node.List)) && $Unbox(Seq#Index(read($Heap, jj#5, Node.List), 0)): int == read($Heap, jj#5, Node.head) && (read($Heap, jj#5, Node.next) == null ==> Seq#Length(read($Heap, jj#5, Node.List)) == 1) && (read($Heap, jj#5, Node.next) != null ==> read($Heap, jj#5, Node.Repr)[$Box(read($Heap, jj#5, Node.next))] && Set#Subset(read($Heap, read($Heap, jj#5, Node.next), Node.Repr), read($Heap, jj#5, Node.Repr)) && !read($Heap, read($Heap, jj#5, Node.next), Node.Repr)[$Box(jj#5)] && Node.Valid($Heap, read($Heap, jj#5, Node.next)) && Seq#Equal(read($Heap, read($Heap, jj#5, Node.next), Node.List), Seq#Drop(read($Heap, jj#5, Node.List), 1)))) ==> jj#5 != null ==> read($Heap, jj#5, Node.next) != null ==> Seq#Equal(read($Heap, read($Heap, jj#5, Node.next), Node.List), Seq#Drop(read($Heap, jj#5, Node.List), 1));
          invariant $w0 && (Node.Valid($Heap, jj#5) ==> read($Heap, jj#5, Node.Repr)[$Box(jj#5)] && 1 <= Seq#Length(read($Heap, jj#5, Node.List)) && $Unbox(Seq#Index(read($Heap, jj#5, Node.List), 0)): int == read($Heap, jj#5, Node.head) && (read($Heap, jj#5, Node.next) == null ==> Seq#Length(read($Heap, jj#5, Node.List)) == 1) && (read($Heap, jj#5, Node.next) != null ==> read($Heap, jj#5, Node.Repr)[$Box(read($Heap, jj#5, Node.next))] && Set#Subset(read($Heap, read($Heap, jj#5, Node.next), Node.Repr), read($Heap, jj#5, Node.Repr)) && !read($Heap, read($Heap, jj#5, Node.next), Node.Repr)[$Box(jj#5)] && Node.Valid($Heap, read($Heap, jj#5, Node.next)) && Seq#Equal(read($Heap, read($Heap, jj#5, Node.next), Node.List), Seq#Drop(read($Heap, jj#5, Node.List), 1)))) ==> jj#5 != null ==> i#6 + Seq#Length(read($Heap, jj#5, Node.List)) == Seq#Length(read($Heap, ll#3, Node.List));
          invariant $w0 && (Node.Valid($Heap, jj#5) ==> read($Heap, jj#5, Node.Repr)[$Box(jj#5)] && 1 <= Seq#Length(read($Heap, jj#5, Node.List)) && $Unbox(Seq#Index(read($Heap, jj#5, Node.List), 0)): int == read($Heap, jj#5, Node.head) && (read($Heap, jj#5, Node.next) == null ==> Seq#Length(read($Heap, jj#5, Node.List)) == 1) && (read($Heap, jj#5, Node.next) != null ==> read($Heap, jj#5, Node.Repr)[$Box(read($Heap, jj#5, Node.next))] && Set#Subset(read($Heap, read($Heap, jj#5, Node.next), Node.Repr), read($Heap, jj#5, Node.Repr)) && !read($Heap, read($Heap, jj#5, Node.next), Node.Repr)[$Box(jj#5)] && Node.Valid($Heap, read($Heap, jj#5, Node.next)) && Seq#Equal(read($Heap, read($Heap, jj#5, Node.next), Node.List), Seq#Drop(read($Heap, jj#5, Node.List), 1)))) ==> jj#5 != null ==> Seq#Equal(Seq#Drop(read($Heap, ll#3, Node.List), i#6), read($Heap, jj#5, Node.List));
          free invariant $w0 ==> jj#5 != null ==> Node.Valid($Heap, jj#5) && i#6 + Seq#Length(read($Heap, jj#5, Node.List)) == Seq#Length(read($Heap, ll#3, Node.List)) && Seq#Equal(Seq#Drop(read($Heap, ll#3, Node.List), i#6), read($Heap, jj#5, Node.List));
          invariant $w0 ==> jj#5 == null ==> i#6 == Seq#Length(read($Heap, ll#3, Node.List));
          invariant $w0 ==> !Seq#Contains(Seq#Take(read($Heap, ll#3, Node.List), i#6), $Box(0));
          free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
          free invariant $HeapSucc($PreLoopHeap0, $Heap);
          free invariant Seq#Length(read($Heap, ll#3, Node.List)) - i#6 <= $decr0$init$0 && (Seq#Length(read($Heap, ll#3, Node.List)) - i#6 == $decr0$init$0 ==> true);
          free invariant #cev_save_position(#cev_pc) == #tok$0^69.5;
          free invariant $PreLoopCevPC0 < #cev_pc;
          free invariant #cev_control_flow_event(#cev_pc, loop_register);
          free invariant #cev_var_update(#cev_pc, cev_local, #loc.r#4, r#4);
          kUnwind 1;
        {
            if (!$w0)
            {
                assert {:subsumption 0} jj#5 != null ==> jj#5 != null && (Node.Valid($Heap, jj#5) ==> jj#5 != null && ll#3 != null) && (Node.Valid($Heap, jj#5) && i#6 + Seq#Length(read($Heap, jj#5, Node.List)) == Seq#Length(read($Heap, ll#3, Node.List)) ==> ll#3 != null && 0 <= i#6 && i#6 <= Seq#Length(read($Heap, ll#3, Node.List)) && jj#5 != null);
                assume jj#5 != null ==> Node.Valid($Heap, jj#5) && i#6 + Seq#Length(read($Heap, jj#5, Node.List)) == Seq#Length(read($Heap, ll#3, Node.List)) && Seq#Equal(Seq#Drop(read($Heap, ll#3, Node.List), i#6), read($Heap, jj#5, Node.List));
                assert {:subsumption 0} jj#5 == null ==> ll#3 != null;
                assume jj#5 == null ==> i#6 == Seq#Length(read($Heap, ll#3, Node.List));
                assert {:subsumption 0} ll#3 != null && 0 <= i#6 && i#6 <= Seq#Length(read($Heap, ll#3, Node.List));
                assume !Seq#Contains(Seq#Take(read($Heap, ll#3, Node.List), i#6), $Box(0));
                assert ll#3 != null;
                assume false;
            }

            assert jj#5 != null ==> jj#5 != null;
            if (!(jj#5 != null && read($Heap, jj#5, Node.head) != 0))
            {
                break;
            }

            call CevStepEvent(#tok$0^69.5, loop_entered);
            assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(69,5): loop entered"} true;
            $decr0$0 := Seq#Length(read($Heap, ll#3, Node.List)) - i#6;
            // ----- assignment statement ----- Test\VSComp2010\Problem3-FindZero.dfy(75,10)
            assert true;
            assert jj#5 != null;
            jj#5 := read($Heap, jj#5, Node.next);
            assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(75,10)"} true;
            call CevUpdate(#tok$0^75.10, #loc.jj#5, jj#5);
            // ----- assignment statement ----- Test\VSComp2010\Problem3-FindZero.dfy(76,9)
            assert true;
            assert true;
            i#6 := i#6 + 1;
            assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(76,9)"} true;
            call CevUpdate(#tok$0^76.9, #loc.i#6, i#6);
            assert 0 <= $decr0$0 || Seq#Length(read($Heap, ll#3, Node.List)) - i#6 == $decr0$0;
            assert Seq#Length(read($Heap, ll#3, Node.List)) - i#6 < $decr0$0;
        }

        call CevStepEvent(#tok$0^69.5, loop_exited);
        assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(69,5): loop exit"} true;
        // ----- assignment statement ----- Test\VSComp2010\Problem3-FindZero.dfy(78,7)
        assert true;
        assert true;
        r#4 := i#6;
        assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(78,7)"} true;
        call CevUpdate(#tok$0^78.7, #loc.r#4, r#4);
    }
}



const unique #tok$0^82.8: $token;

procedure CheckWellformed$$_default.Main(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^82.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.this: $token;

implementation CheckWellformed$$_default.Main(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^82.8, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
}



procedure _default.Main(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^82.8;
  modifies $Heap, #cev_pc;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.list#7: $token;

const unique #tok$0^84.7: $token;

const unique #loc.list: $token;

const unique #tok$0^85.3: $token;

const unique #tok$0^86.3: $token;

const unique #tok$0^87.3: $token;

const unique #tok$0^88.3: $token;

const unique #loc.r#8: $token;

const unique #tok$0^89.8: $token;

const unique #loc.r: $token;

const unique #tok$0^89.3: $token;

implementation _default.Main(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var list#7: ref where (list#7 == null || (read($Heap, list#7, alloc) && dtype(list#7) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.list#7, list#7);
  var x#9: int;
  var tail#10: ref;
  var x#11: int;
  var tail#12: ref;
  var x#13: int;
  var tail#14: ref;
  var x#15: int;
  var tail#16: ref;
  var r#8: int where #cev_var_update(#cev_pc, cev_local, #loc.r#8, r#8);
  var ll#17: ref;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^82.8, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- Test\VSComp2010\Problem3-FindZero.dfy(84,7)
    assert true;
    assert true;
    list#7 := null;
    assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(84,7)"} true;
    call CevVarIntro(#tok$0^84.7, cev_local, #loc.list#7, list#7);
    // ----- call statement ----- Test\VSComp2010\Problem3-FindZero.dfy(85,3)
    assert true;
    x#9 := 0;
    assert true;
    tail#10 := list#7;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call list#7 := Node.Cons(x#9, tail#10);
    call CevUpdateHere(#loc.list, list#7);
    call CevStep(#tok$0^85.3);
    assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(85,3)"} true;
    // ----- call statement ----- Test\VSComp2010\Problem3-FindZero.dfy(86,3)
    assert true;
    x#11 := 5;
    assert true;
    tail#12 := list#7;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call list#7 := Node.Cons(x#11, tail#12);
    call CevUpdateHere(#loc.list, list#7);
    call CevStep(#tok$0^86.3);
    assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(86,3)"} true;
    // ----- call statement ----- Test\VSComp2010\Problem3-FindZero.dfy(87,3)
    assert true;
    x#13 := 0;
    assert true;
    tail#14 := list#7;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call list#7 := Node.Cons(x#13, tail#14);
    call CevUpdateHere(#loc.list, list#7);
    call CevStep(#tok$0^87.3);
    assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(87,3)"} true;
    // ----- call statement ----- Test\VSComp2010\Problem3-FindZero.dfy(88,3)
    assert true;
    x#15 := 8;
    assert true;
    tail#16 := list#7;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call list#7 := Node.Cons(x#15, tail#16);
    call CevUpdateHere(#loc.list, list#7);
    call CevStep(#tok$0^88.3);
    assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(88,3)"} true;
    // ----- var-declaration statement ----- Test\VSComp2010\Problem3-FindZero.dfy(89,8)
    call CevVarIntro(#tok$0^89.8, cev_local, #loc.r#8, r#8);
    // ----- call statement ----- Test\VSComp2010\Problem3-FindZero.dfy(89,3)
    assert true;
    ll#17 := list#7;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call r#8 := _default.Search(ll#17);
    call CevUpdateHere(#loc.r, r#8);
    call CevStep(#tok$0^89.3);
    assume {:captureState "Test\VSComp2010\Problem3-FindZero.dfy(89,3)"} true;
    // ----- print statement ----- Test\VSComp2010\Problem3-FindZero.dfy(90,3)
    assert {:subsumption 0} true;
    // ----- assert statement ----- Test\VSComp2010\Problem3-FindZero.dfy(91,3)
    assert {:subsumption 0} true;
    assert r#8 == 1;
}


