// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: Test\VSComp2010\Problem4-Queens.dfy /print:..\boogie-k-induction-benchmarks\benchmarks\Problem4-Queens.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class._default: ClassName;

const unique xxxxxxxxfile: $token;

axiom $file_name_is(0, xxxxxxxxfile);

const unique #tok$0^37.8: $token;

procedure CheckWellformed$$_default.Search(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, N#0: int) returns (success#1: bool, board#2: Seq BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^37.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.this: $token;

const unique #tok$0^37.15: $token;

const unique #loc.N#0: $token;

const unique #tok$0^37.32: $token;

const unique #loc.success#1: $token;

const unique #tok$0^37.47: $token;

const unique #loc.board#2: $token;

implementation CheckWellformed$$_default.Search(this: ref, N#0: int) returns (success#1: bool, board#2: Seq BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var p#44: int;
  var board#45: Seq BoxType;
  var pos#46: int;
  var B#47: Seq BoxType;
  var i#48: int;
  var p#49: int;
  var board#50: Seq BoxType;
  var pos#51: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^37.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^37.15, cev_parameter, #loc.N#0, N#0);
    call CevVarIntro(#tok$0^37.32, cev_local, #loc.success#1, success#1);
    call CevVarIntro(#tok$0^37.47, cev_local, #loc.board#2, board#2);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume 0 <= N#0;
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc success#1, board#2;
    if (success#1)
    {
        if (Seq#Length(board#2) == N#0)
        {
            if (0 <= p#44)
            {
            }

            if (0 <= p#44 && p#44 < N#0)
            {
                board#45 := board#2;
                pos#46 := p#44;
            }
        }
    }

    assume success#1 ==> Seq#Length(board#2) == N#0 && (forall p#3: int :: 0 <= p#3 && p#3 < N#0 ==> _default.IsConsistent($Heap, board#2, p#3));
    if (!success#1)
    {
        if (Seq#Length(B#47) == N#0)
        {
            if (0 <= i#48)
            {
            }

            if (0 <= i#48 && i#48 < N#0)
            {
                assert 0 <= i#48 && i#48 < Seq#Length(B#47);
                if (0 <= $Unbox(Seq#Index(B#47, i#48)): int)
                {
                    assert 0 <= i#48 && i#48 < Seq#Length(B#47);
                }
            }
        }

        if (Seq#Length(B#47) == N#0 && (forall i#5: int :: 0 <= i#5 && i#5 < N#0 ==> 0 <= $Unbox(Seq#Index(B#47, i#5)): int && $Unbox(Seq#Index(B#47, i#5)): int < N#0))
        {
            if (0 <= p#49)
            {
            }

            if (0 <= p#49 && p#49 < N#0)
            {
                board#50 := B#47;
                pos#51 := p#49;
            }
        }
    }

    assume !success#1 ==> (forall B#4: Seq BoxType :: Seq#Length(B#4) == N#0 && (forall i#5: int :: 0 <= i#5 && i#5 < N#0 ==> 0 <= $Unbox(Seq#Index(B#4, i#5)): int && $Unbox(Seq#Index(B#4, i#5)): int < N#0) ==> (exists p#6: int :: 0 <= p#6 && p#6 < N#0 && !_default.IsConsistent($Heap, B#4, p#6)));
}



procedure _default.Search(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, N#0: int) returns (success#1: bool, board#2: Seq BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires 0 <= N#0;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^37.8;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures success#1 ==> Seq#Length(board#2) == N#0 && (forall p#3: int :: 0 <= p#3 && p#3 < N#0 ==> _default.IsConsistent($Heap, board#2, p#3));
  ensures true ==> success#1 ==> Seq#Length(board#2) == N#0;
  ensures true ==> success#1 ==> (forall p#3: int :: 0 <= p#3 && p#3 < N#0 ==> _default.IsConsistent($Heap, board#2, p#3));
  ensures !success#1 ==> (forall B#4: Seq BoxType :: Seq#Length(B#4) == N#0 && (forall i#5: int :: 0 <= i#5 && i#5 < N#0 ==> 0 <= $Unbox(Seq#Index(B#4, i#5)): int && $Unbox(Seq#Index(B#4, i#5)): int < N#0) ==> (exists p#6: int :: 0 <= p#6 && p#6 < N#0 && !_default.IsConsistent($Heap, B#4, p#6)));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.success: $token;

const unique #loc.board: $token;

const unique #tok$0^48.3: $token;

implementation _default.Search(this: ref, N#0: int) returns (success#1: bool, board#2: Seq BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var N#52: int;
  var boardSoFar#53: Seq BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^37.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^37.15, cev_parameter, #loc.N#0, N#0);
    call CevVarIntro(#tok$0^37.32, cev_local, #loc.success#1, success#1);
    call CevVarIntro(#tok$0^37.47, cev_local, #loc.board#2, board#2);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- call statement ----- Test\VSComp2010\Problem4-Queens.dfy(48,3)
    assert true;
    N#52 := N#0;
    assert true;
    boardSoFar#53 := Seq#Empty(): Seq BoxType;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call success#1, board#2 := _default.SearchAux(this, N#52, boardSoFar#53);
    call CevUpdateHere(#loc.success, success#1);
    call CevUpdateHere(#loc.board, board#2);
    call CevStep(#tok$0^48.3);
    assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(48,3)"} true;
}



function _default.IsConsistent($heap: HeapType, board#7: Seq BoxType, pos#8: int) : bool;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (5 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, board#7: Seq BoxType, pos#8: int :: { _default.IsConsistent($Heap, board#7, pos#8) } $IsGoodHeap($Heap) ==> _default.IsConsistent($Heap, board#7, pos#8) == (0 <= pos#8 && pos#8 < Seq#Length(board#7) && (forall q#9: int :: 0 <= q#9 && q#9 < pos#8 ==> $Unbox(Seq#Index(board#7, q#9)): int != $Unbox(Seq#Index(board#7, pos#8)): int && $Unbox(Seq#Index(board#7, q#9)): int - $Unbox(Seq#Index(board#7, pos#8)): int != pos#8 - q#9 && $Unbox(Seq#Index(board#7, pos#8)): int - $Unbox(Seq#Index(board#7, q#9)): int != pos#8 - q#9)));

// frame axiom for _default.IsConsistent
axiom (forall $h0: HeapType, $h1: HeapType, board#7: Seq BoxType, pos#8: int :: { $HeapSucc($h0, $h1), _default.IsConsistent($h1, board#7, pos#8) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: false ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> _default.IsConsistent($h0, board#7, pos#8) == _default.IsConsistent($h1, board#7, pos#8));

procedure CheckWellformed$$_default.IsConsistent(board#7: Seq BoxType, pos#8: int);
  free requires 0 == $ModuleContextHeight && 5 == $FunctionContextHeight;



implementation CheckWellformed$$_default.IsConsistent(board#7: Seq BoxType, pos#8: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var q#54: int;

    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    if (0 <= pos#8)
    {
    }

    if (0 <= pos#8 && pos#8 < Seq#Length(board#7))
    {
        if (0 <= q#54)
        {
        }

        if (0 <= q#54 && q#54 < pos#8)
        {
            assert 0 <= q#54 && q#54 < Seq#Length(board#7);
            assert 0 <= pos#8 && pos#8 < Seq#Length(board#7);
            if ($Unbox(Seq#Index(board#7, q#54)): int != $Unbox(Seq#Index(board#7, pos#8)): int)
            {
                assert 0 <= q#54 && q#54 < Seq#Length(board#7);
                assert 0 <= pos#8 && pos#8 < Seq#Length(board#7);
            }

            if ($Unbox(Seq#Index(board#7, q#54)): int != $Unbox(Seq#Index(board#7, pos#8)): int && $Unbox(Seq#Index(board#7, q#54)): int - $Unbox(Seq#Index(board#7, pos#8)): int != pos#8 - q#54)
            {
                assert 0 <= pos#8 && pos#8 < Seq#Length(board#7);
                assert 0 <= q#54 && q#54 < Seq#Length(board#7);
            }
        }
    }
}



const unique #tok$0^62.8: $token;

procedure CheckWellformed$$_default.CheckConsistent(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, board#10: Seq BoxType, pos#11: int) returns (b#12: bool);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^62.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^62.24: $token;

const unique #loc.board#10: $token;

const unique #tok$0^62.41: $token;

const unique #loc.pos#11: $token;

const unique #tok$0^62.60: $token;

const unique #loc.b#12: $token;

implementation CheckWellformed$$_default.CheckConsistent(this: ref, board#10: Seq BoxType, pos#11: int) returns (b#12: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var board#55: Seq BoxType;
  var pos#56: int;
  var B#57: Seq BoxType;
  var p#58: int;
  var board#59: Seq BoxType;
  var pos#60: int;
  var board#61: Seq BoxType;
  var pos#62: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^62.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^62.24, cev_parameter, #loc.board#10, board#10);
    call CevVarIntro(#tok$0^62.41, cev_parameter, #loc.pos#11, pos#11);
    call CevVarIntro(#tok$0^62.60, cev_local, #loc.b#12, b#12);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc b#12;
    board#55 := board#10;
    pos#56 := pos#11;
    assume b#12 <==> _default.IsConsistent($Heap, board#10, pos#11);
    board#59 := B#57;
    pos#60 := p#58;
    board#61 := B#57;
    pos#62 := p#58;
    assume (forall B#13: Seq BoxType, p#14: int :: _default.IsConsistent($Heap, B#13, p#14) <==> old(_default.IsConsistent($Heap, B#13, p#14)));
}



procedure _default.CheckConsistent(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, board#10: Seq BoxType, pos#11: int) returns (b#12: bool);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^62.8;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures b#12 <==> _default.IsConsistent($Heap, board#10, pos#11);
  ensures (forall B#13: Seq BoxType, p#14: int :: _default.IsConsistent($Heap, B#13, p#14) <==> old(_default.IsConsistent($Heap, B#13, p#14)));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^70.3: $token;

const unique #tok$0^70.34: $token;

const unique #loc.p#15: $token;

const unique #tok$0^71.9: $token;

const unique #tok$0^72.5: $token;

const unique #tok$0^79.7: $token;

const unique #tok$0^81.48: $token;

const unique #tok$0^82.11: $token;

const unique #tok$0^85.9: $token;

const unique #tok$0^87.7: $token;

const unique #tok$0^90.5: $token;

implementation _default.CheckConsistent(this: ref, board#10: Seq BoxType, pos#11: int) returns (b#12: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var p#15: int where #cev_var_update(#cev_pc, cev_local, #loc.p#15, p#15);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^62.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^62.24, cev_parameter, #loc.board#10, board#10);
    call CevVarIntro(#tok$0^62.41, cev_parameter, #loc.pos#11, pos#11);
    call CevVarIntro(#tok$0^62.60, cev_local, #loc.b#12, b#12);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- if statement ----- Test\VSComp2010\Problem4-Queens.dfy(70,3)
    call CevEvent(#tok$0^70.3, conditional_moment);
    assert 0 <= pos#11 ==> true;
    if (0 <= pos#11 && pos#11 < Seq#Length(board#10))
    {
        call CevEvent(#tok$0^70.34, took_then_branch);
        // ----- var-declaration statement ----- Test\VSComp2010\Problem4-Queens.dfy(71,9)
        assert true;
        assert true;
        p#15 := 0;
        assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(71,9)"} true;
        call CevVarIntro(#tok$0^71.9, cev_local, #loc.p#15, p#15);
        // ----- while statement ----- Test\VSComp2010\Problem4-Queens.dfy(72,5)
        $PreLoopHeap0 := $Heap;
        $decr0$init$0 := pos#11 - p#15;
        havoc $w0;
        call $PreLoopCevPC0 := CevPreLoop(#tok$0^72.5);
        while (true)
          invariant $w0 ==> p#15 <= pos#11;
          invariant $w0 ==> (forall q#16: int :: 0 <= q#16 && q#16 < p#15
                 ==> $Unbox(Seq#Index(board#10, q#16)): int != $Unbox(Seq#Index(board#10, pos#11)): int);
          invariant $w0 ==> (forall q#16: int :: 0 <= q#16 && q#16 < p#15
                 ==> $Unbox(Seq#Index(board#10, q#16)): int - $Unbox(Seq#Index(board#10, pos#11)): int != pos#11 - q#16);
          invariant $w0 ==> (forall q#16: int :: 0 <= q#16 && q#16 < p#15
                 ==> $Unbox(Seq#Index(board#10, pos#11)): int - $Unbox(Seq#Index(board#10, q#16)): int != pos#11 - q#16);
          free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc)
                         ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
          free invariant $HeapSucc($PreLoopHeap0, $Heap);
          free invariant pos#11 - p#15 <= $decr0$init$0 && (pos#11 - p#15 == $decr0$init$0 ==> true);
          free invariant #cev_save_position(#cev_pc) == #tok$0^72.5;
          free invariant $PreLoopCevPC0 < #cev_pc;
          free invariant #cev_control_flow_event(#cev_pc, loop_register);
          free invariant #cev_var_update(#cev_pc, cev_local, #loc.b#12, b#12);
          kUnwind 1;
        {
            if (!$w0)
            {
                assert {:subsumption 0} true;
                assume p#15 <= pos#11;
                assert {:subsumption 0} (forall q#16: int :: (0 <= q#16 ==> true) && (0 <= q#16 && q#16 < p#15 ==> 0 <= q#16 && q#16 < Seq#Length(board#10) && 0 <= pos#11 && pos#11 < Seq#Length(board#10) && ($Unbox(Seq#Index(board#10, q#16)): int != $Unbox(Seq#Index(board#10, pos#11)): int ==> 0 <= q#16 && q#16 < Seq#Length(board#10) && 0 <= pos#11 && pos#11 < Seq#Length(board#10)) && ($Unbox(Seq#Index(board#10, q#16)): int != $Unbox(Seq#Index(board#10, pos#11)): int && $Unbox(Seq#Index(board#10, q#16)): int - $Unbox(Seq#Index(board#10, pos#11)): int != pos#11 - q#16 ==> 0 <= pos#11 && pos#11 < Seq#Length(board#10) && 0 <= q#16 && q#16 < Seq#Length(board#10))));
                assume (forall q#16: int :: 0 <= q#16 && q#16 < p#15 ==> $Unbox(Seq#Index(board#10, q#16)): int != $Unbox(Seq#Index(board#10, pos#11)): int && $Unbox(Seq#Index(board#10, q#16)): int - $Unbox(Seq#Index(board#10, pos#11)): int != pos#11 - q#16 && $Unbox(Seq#Index(board#10, pos#11)): int - $Unbox(Seq#Index(board#10, q#16)): int != pos#11 - q#16);
                assert true;
                assume false;
            }

            assert true;
            if (p#15 >= pos#11)
            {
                break;
            }

            call CevStepEvent(#tok$0^72.5, loop_entered);
            assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(72,5): loop entered"} true;
            $decr0$0 := pos#11 - p#15;
            // ----- if statement ----- Test\VSComp2010\Problem4-Queens.dfy(79,7)
            call CevEvent(#tok$0^79.7, conditional_moment);
            assert 0 <= p#15 && p#15 < Seq#Length(board#10) && 0 <= pos#11 && pos#11 < Seq#Length(board#10) && ($Unbox(Seq#Index(board#10, p#15)): int != $Unbox(Seq#Index(board#10, pos#11)): int ==> 0 <= p#15 && p#15 < Seq#Length(board#10) && 0 <= pos#11 && pos#11 < Seq#Length(board#10)) && ($Unbox(Seq#Index(board#10, p#15)): int != $Unbox(Seq#Index(board#10, pos#11)): int && $Unbox(Seq#Index(board#10, p#15)): int - $Unbox(Seq#Index(board#10, pos#11)): int != pos#11 - p#15 ==> 0 <= pos#11 && pos#11 < Seq#Length(board#10) && 0 <= p#15 && p#15 < Seq#Length(board#10));
            if (!($Unbox(Seq#Index(board#10, p#15)): int != $Unbox(Seq#Index(board#10, pos#11)): int && $Unbox(Seq#Index(board#10, p#15)): int - $Unbox(Seq#Index(board#10, pos#11)): int != pos#11 - p#15 && $Unbox(Seq#Index(board#10, pos#11)): int - $Unbox(Seq#Index(board#10, p#15)): int != pos#11 - p#15))
            {
                call CevEvent(#tok$0^81.48, took_then_branch);
                // ----- assignment statement ----- Test\VSComp2010\Problem4-Queens.dfy(82,11)
                assert true;
                assert true;
                b#12 := false;
                assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(82,11)"} true;
                call CevUpdate(#tok$0^82.11, #loc.b#12, b#12);
                // ----- return statement ----- Test\VSComp2010\Problem4-Queens.dfy(83,9)
                return;
            }
            else
            {
                call CevEvent(#tok$0^79.7, took_else_branch);
            }

            // ----- assignment statement ----- Test\VSComp2010\Problem4-Queens.dfy(85,9)
            assert true;
            assert true;
            p#15 := p#15 + 1;
            assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(85,9)"} true;
            call CevUpdate(#tok$0^85.9, #loc.p#15, p#15);
            assert 0 <= $decr0$0 || pos#11 - p#15 == $decr0$0;
            assert pos#11 - p#15 < $decr0$0;
        }

        call CevStepEvent(#tok$0^72.5, loop_exited);
        assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(72,5): loop exit"} true;
        // ----- assignment statement ----- Test\VSComp2010\Problem4-Queens.dfy(87,7)
        assert true;
        assert true;
        b#12 := true;
        assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(87,7)"} true;
        call CevUpdate(#tok$0^87.7, #loc.b#12, b#12);
        // ----- return statement ----- Test\VSComp2010\Problem4-Queens.dfy(88,5)
        return;
    }
    else
    {
        call CevEvent(#tok$0^70.3, took_else_branch);
    }

    // ----- assignment statement ----- Test\VSComp2010\Problem4-Queens.dfy(90,5)
    assert true;
    assert true;
    b#12 := false;
    assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(90,5)"} true;
    call CevUpdate(#tok$0^90.5, #loc.b#12, b#12);
}



const unique #tok$0^98.8: $token;

procedure CheckWellformed$$_default.SearchAux(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, N#17: int, boardSoFar#18: Seq BoxType) returns (success#19: bool, newBoard#20: Seq BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^98.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^98.18: $token;

const unique #loc.N#17: $token;

const unique #tok$0^98.26: $token;

const unique #loc.boardSoFar#18: $token;

const unique #tok$0^98.57: $token;

const unique #loc.success#19: $token;

const unique #tok$0^98.72: $token;

const unique #loc.newBoard#20: $token;

implementation CheckWellformed$$_default.SearchAux(this: ref, N#17: int, boardSoFar#18: Seq BoxType) returns (success#19: bool, newBoard#20: Seq BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var k#63: int;
  var board#64: Seq BoxType;
  var pos#65: int;
  var p#66: int;
  var board#67: Seq BoxType;
  var pos#68: int;
  var B#69: Seq BoxType;
  var i#70: int;
  var p#71: int;
  var board#72: Seq BoxType;
  var pos#73: int;
  var B#74: Seq BoxType;
  var p#75: int;
  var board#76: Seq BoxType;
  var pos#77: int;
  var board#78: Seq BoxType;
  var pos#79: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^98.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^98.18, cev_parameter, #loc.N#17, N#17);
    call CevVarIntro(#tok$0^98.26, cev_parameter, #loc.boardSoFar#18, boardSoFar#18);
    call CevVarIntro(#tok$0^98.57, cev_local, #loc.success#19, success#19);
    call CevVarIntro(#tok$0^98.72, cev_local, #loc.newBoard#20, newBoard#20);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    if (0 <= N#17)
    {
    }

    assume 0 <= N#17 && Seq#Length(boardSoFar#18) <= N#17;
    if (0 <= k#63)
    {
    }

    if (0 <= k#63 && k#63 < Seq#Length(boardSoFar#18))
    {
        board#64 := boardSoFar#18;
        pos#65 := k#63;
    }

    assume (forall k#21: int :: 0 <= k#21 && k#21 < Seq#Length(boardSoFar#18) ==> _default.IsConsistent($Heap, boardSoFar#18, k#21));
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc success#19, newBoard#20;
    if (success#19)
    {
        if (Seq#Length(newBoard#20) == N#17)
        {
            if (0 <= p#66)
            {
            }

            if (0 <= p#66 && p#66 < N#17)
            {
                board#67 := newBoard#20;
                pos#68 := p#66;
            }
        }
    }

    assume success#19 ==> Seq#Length(newBoard#20) == N#17 && (forall p#22: int :: 0 <= p#22 && p#22 < N#17 ==> _default.IsConsistent($Heap, newBoard#20, p#22));
    if (!success#19)
    {
        if (Seq#Length(B#69) == N#17)
        {
            if (0 <= i#70)
            {
            }

            if (0 <= i#70 && i#70 < N#17)
            {
                assert 0 <= i#70 && i#70 < Seq#Length(B#69);
                if (0 <= $Unbox(Seq#Index(B#69, i#70)): int)
                {
                    assert 0 <= i#70 && i#70 < Seq#Length(B#69);
                }
            }
        }

        if (Seq#Length(B#69) == N#17 && (forall i#24: int :: 0 <= i#24 && i#24 < N#17 ==> 0 <= $Unbox(Seq#Index(B#69, i#24)): int && $Unbox(Seq#Index(B#69, i#24)): int < N#17))
        {
        }

        if (Seq#Length(B#69) == N#17 && (forall i#24: int :: 0 <= i#24 && i#24 < N#17 ==> 0 <= $Unbox(Seq#Index(B#69, i#24)): int && $Unbox(Seq#Index(B#69, i#24)): int < N#17) && Seq#Length(boardSoFar#18) <= Seq#Length(B#69) && Seq#SameUntil(boardSoFar#18, B#69, Seq#Length(boardSoFar#18)))
        {
            if (0 <= p#71)
            {
            }

            if (0 <= p#71 && p#71 < N#17)
            {
                board#72 := B#69;
                pos#73 := p#71;
            }
        }
    }

    assume !success#19 ==> (forall B#23: Seq BoxType :: Seq#Length(B#23) == N#17 && (forall i#24: int :: 0 <= i#24 && i#24 < N#17 ==> 0 <= $Unbox(Seq#Index(B#23, i#24)): int && $Unbox(Seq#Index(B#23, i#24)): int < N#17) && Seq#Length(boardSoFar#18) <= Seq#Length(B#23) && Seq#SameUntil(boardSoFar#18, B#23, Seq#Length(boardSoFar#18)) ==> (exists p#25: int :: 0 <= p#25 && p#25 < N#17 && !_default.IsConsistent($Heap, B#23, p#25)));
    board#76 := B#74;
    pos#77 := p#75;
    board#78 := B#74;
    pos#79 := p#75;
    assume (forall B#26: Seq BoxType, p#27: int :: _default.IsConsistent($Heap, B#26, p#27) <==> old(_default.IsConsistent($Heap, B#26, p#27)));
}



procedure _default.SearchAux(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, N#17: int, boardSoFar#18: Seq BoxType) returns (success#19: bool, newBoard#20: Seq BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires 0 <= N#17 && Seq#Length(boardSoFar#18) <= N#17;
  requires true ==> 0 <= N#17;
  requires true ==> Seq#Length(boardSoFar#18) <= N#17;
  requires (forall k#21: int :: 0 <= k#21 && k#21 < Seq#Length(boardSoFar#18) ==> _default.IsConsistent($Heap, boardSoFar#18, k#21));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^98.8;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures success#19 ==> Seq#Length(newBoard#20) == N#17 && (forall p#22: int :: 0 <= p#22 && p#22 < N#17 ==> _default.IsConsistent($Heap, newBoard#20, p#22));
  ensures true ==> success#19 ==> Seq#Length(newBoard#20) == N#17;
  ensures true ==> success#19 ==> (forall p#22: int :: 0 <= p#22 && p#22 < N#17 ==> _default.IsConsistent($Heap, newBoard#20, p#22));
  ensures !success#19 ==> (forall B#23: Seq BoxType :: Seq#Length(B#23) == N#17 && (forall i#24: int :: 0 <= i#24 && i#24 < N#17 ==> 0 <= $Unbox(Seq#Index(B#23, i#24)): int && $Unbox(Seq#Index(B#23, i#24)): int < N#17) && Seq#Length(boardSoFar#18) <= Seq#Length(B#23) && Seq#SameUntil(boardSoFar#18, B#23, Seq#Length(boardSoFar#18)) ==> (exists p#25: int :: 0 <= p#25 && p#25 < N#17 && !_default.IsConsistent($Heap, B#23, p#25)));
  ensures (forall B#26: Seq BoxType, p#27: int :: _default.IsConsistent($Heap, B#26, p#27) <==> old(_default.IsConsistent($Heap, B#26, p#27)));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.pos#28: $token;

const unique #tok$0^114.7: $token;

const unique #tok$0^115.3: $token;

const unique #tok$0^115.17: $token;

const unique #tok$0^117.14: $token;

const unique #tok$0^118.13: $token;

const unique #tok$0^119.10: $token;

const unique #loc.n#29: $token;

const unique #tok$0^121.9: $token;

const unique #tok$0^122.5: $token;

const unique #loc.candidateBoard#33: $token;

const unique #tok$0^137.11: $token;

const unique #loc.consistent#34: $token;

const unique #tok$0^138.12: $token;

const unique #loc.consistent: $token;

const unique #tok$0^138.7: $token;

const unique #tok$0^139.7: $token;

const unique #tok$0^139.23: $token;

const unique #loc.s#36: $token;

const unique #tok$0^151.14: $token;

const unique #loc.b#37: $token;

const unique #tok$0^151.17: $token;

const unique #loc.s: $token;

const unique #loc.b: $token;

const unique #tok$0^151.9: $token;

const unique #tok$0^152.9: $token;

const unique #tok$0^152.16: $token;

const unique #tok$0^154.20: $token;

const unique #tok$0^155.19: $token;

const unique #tok$0^160.14: $token;

const unique #tok$0^169.9: $token;

const unique #tok$0^172.13: $token;

implementation _default.SearchAux(this: ref, N#17: int, boardSoFar#18: Seq BoxType) returns (success#19: bool, newBoard#20: Seq BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var pos#28: int where #cev_var_update(#cev_pc, cev_local, #loc.pos#28, pos#28);
  var n#29: int where #cev_var_update(#cev_pc, cev_local, #loc.n#29, n#29);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;
  var candidateBoard#33: Seq BoxType where #cev_var_update(#cev_pc, cev_local, #loc.candidateBoard#33, candidateBoard#33);
  var consistent#34: bool where #cev_var_update(#cev_pc, cev_local, #loc.consistent#34, consistent#34);
  var board#80: Seq BoxType;
  var pos#81: int;
  var s#36: bool where #cev_var_update(#cev_pc, cev_local, #loc.s#36, s#36);
  var b#37: Seq BoxType where #cev_var_update(#cev_pc, cev_local, #loc.b#37, b#37);
  var N#82: int;
  var boardSoFar#83: Seq BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^98.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^98.18, cev_parameter, #loc.N#17, N#17);
    call CevVarIntro(#tok$0^98.26, cev_parameter, #loc.boardSoFar#18, boardSoFar#18);
    call CevVarIntro(#tok$0^98.57, cev_local, #loc.success#19, success#19);
    call CevVarIntro(#tok$0^98.72, cev_local, #loc.newBoard#20, newBoard#20);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- Test\VSComp2010\Problem4-Queens.dfy(114,7)
    assert true;
    assert true;
    pos#28 := Seq#Length(boardSoFar#18);
    assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(114,7)"} true;
    call CevVarIntro(#tok$0^114.7, cev_local, #loc.pos#28, pos#28);
    // ----- if statement ----- Test\VSComp2010\Problem4-Queens.dfy(115,3)
    call CevEvent(#tok$0^115.3, conditional_moment);
    assert true;
    if (pos#28 == N#17)
    {
        call CevEvent(#tok$0^115.17, took_then_branch);
        // ----- assignment statement ----- Test\VSComp2010\Problem4-Queens.dfy(117,14)
        assert true;
        assert true;
        newBoard#20 := boardSoFar#18;
        assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(117,14)"} true;
        call CevUpdate(#tok$0^117.14, #loc.newBoard#20, newBoard#20);
        // ----- assignment statement ----- Test\VSComp2010\Problem4-Queens.dfy(118,13)
        assert true;
        assert true;
        success#19 := true;
        assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(118,13)"} true;
        call CevUpdate(#tok$0^118.13, #loc.success#19, success#19);
    }
    else
    {
        call CevEvent(#tok$0^119.10, took_else_branch);
        // ----- var-declaration statement ----- Test\VSComp2010\Problem4-Queens.dfy(121,9)
        assert true;
        assert true;
        n#29 := 0;
        assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(121,9)"} true;
        call CevVarIntro(#tok$0^121.9, cev_local, #loc.n#29, n#29);
        // ----- while statement ----- Test\VSComp2010\Problem4-Queens.dfy(122,5)
        $PreLoopHeap0 := $Heap;
        $decr0$init$0 := N#17 - n#29;
        havoc $w0;
        call $PreLoopCevPC0 := CevPreLoop(#tok$0^122.5);
        while (true)
          invariant $w0 ==> n#29 <= N#17;
          invariant $w0 ==> (forall B#30: Seq BoxType :: Seq#Length(B#30) == N#17 &&
                                       (forall i#31: int :: 0 <= i#31 && i#31 < N#17 ==> 
                                                      0 <= $Unbox(Seq#Index(B#30, i#31)): int &&
                                                     $Unbox(Seq#Index(B#30, i#31)): int < N#17)
                              && Seq#Length(boardSoFar#18) <= Seq#Length(B#30)
                              && Seq#SameUntil(boardSoFar#18, B#30, Seq#Length(boardSoFar#18))
                              && 0 <= $Unbox(Seq#Index(B#30, pos#28)): int
                              && $Unbox(Seq#Index(B#30, pos#28)): int < n#29
                        ==> (exists p#32: int :: 0 <= p#32 && p#32 < N#17 && !_default.IsConsistent($Heap, B#30, p#32)));
          free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
          free invariant $HeapSucc($PreLoopHeap0, $Heap);
          free invariant N#17 - n#29 <= $decr0$init$0 && (N#17 - n#29 == $decr0$init$0 ==> true);
          free invariant #cev_save_position(#cev_pc) == #tok$0^122.5;
          free invariant $PreLoopCevPC0 < #cev_pc;
          free invariant #cev_control_flow_event(#cev_pc, loop_register);
          free invariant #cev_var_update(#cev_pc, cev_local, #loc.success#19, success#19);
          free invariant #cev_var_update(#cev_pc, cev_local, #loc.newBoard#20, newBoard#20);
          kUnwind 1;
        {
            if (!$w0)
            {
                assert {:subsumption 0} true;
                assume n#29 <= N#17;
                assert {:subsumption 0} (forall B#30: Seq BoxType :: (Seq#Length(B#30) == N#17 ==> (forall i#31: int :: (0 <= i#31 ==> true) && (0 <= i#31 && i#31 < N#17 ==> 0 <= i#31 && i#31 < Seq#Length(B#30) && (0 <= $Unbox(Seq#Index(B#30, i#31)): int ==> 0 <= i#31 && i#31 < Seq#Length(B#30))))) && (Seq#Length(B#30) == N#17 && (forall i#31: int :: 0 <= i#31 && i#31 < N#17 ==> 0 <= $Unbox(Seq#Index(B#30, i#31)): int && $Unbox(Seq#Index(B#30, i#31)): int < N#17) ==> true) && (Seq#Length(B#30) == N#17 && (forall i#31: int :: 0 <= i#31 && i#31 < N#17 ==> 0 <= $Unbox(Seq#Index(B#30, i#31)): int && $Unbox(Seq#Index(B#30, i#31)): int < N#17) && Seq#Length(boardSoFar#18) <= Seq#Length(B#30) && Seq#SameUntil(boardSoFar#18, B#30, Seq#Length(boardSoFar#18)) ==> 0 <= pos#28 && pos#28 < Seq#Length(B#30)) && (Seq#Length(B#30) == N#17 && (forall i#31: int :: 0 <= i#31 && i#31 < N#17 ==> 0 <= $Unbox(Seq#Index(B#30, i#31)): int && $Unbox(Seq#Index(B#30, i#31)): int < N#17) && Seq#Length(boardSoFar#18) <= Seq#Length(B#30) && Seq#SameUntil(boardSoFar#18, B#30, Seq#Length(boardSoFar#18)) && 0 <= $Unbox(Seq#Index(B#30, pos#28)): int ==> 0 <= pos#28 && pos#28 < Seq#Length(B#30)) && (Seq#Length(B#30) == N#17 && (forall i#31: int :: 0 <= i#31 && i#31 < N#17 ==> 0 <= $Unbox(Seq#Index(B#30, i#31)): int && $Unbox(Seq#Index(B#30, i#31)): int < N#17) && Seq#Length(boardSoFar#18) <= Seq#Length(B#30) && Seq#SameUntil(boardSoFar#18, B#30, Seq#Length(boardSoFar#18)) && 0 <= $Unbox(Seq#Index(B#30, pos#28)): int && $Unbox(Seq#Index(B#30, pos#28)): int < n#29 ==> (forall p#32: int :: (0 <= p#32 ==> true) && (0 <= p#32 && p#32 < N#17 ==> true))));
                assume (forall B#30: Seq BoxType :: Seq#Length(B#30) == N#17 && (forall i#31: int :: 0 <= i#31 && i#31 < N#17 ==> 0 <= $Unbox(Seq#Index(B#30, i#31)): int && $Unbox(Seq#Index(B#30, i#31)): int < N#17) && Seq#Length(boardSoFar#18) <= Seq#Length(B#30) && Seq#SameUntil(boardSoFar#18, B#30, Seq#Length(boardSoFar#18)) && 0 <= $Unbox(Seq#Index(B#30, pos#28)): int && $Unbox(Seq#Index(B#30, pos#28)): int < n#29 ==> (exists p#32: int :: 0 <= p#32 && p#32 < N#17 && !_default.IsConsistent($Heap, B#30, p#32)));
                assert true;
                assume false;
            }

            assert true;
            if (n#29 >= N#17)
            {
                break;
            }

            call CevStepEvent(#tok$0^122.5, loop_entered);
            assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(122,5): loop entered"} true;
            $decr0$0 := N#17 - n#29;
            // ----- var-declaration statement ----- Test\VSComp2010\Problem4-Queens.dfy(137,11)
            assert true;
            assert true;
            candidateBoard#33 := Seq#Append(boardSoFar#18, Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box(n#29), 1));
            assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(137,11)"} true;
            call CevVarIntro(#tok$0^137.11, cev_local, #loc.candidateBoard#33, candidateBoard#33);
            // ----- var-declaration statement ----- Test\VSComp2010\Problem4-Queens.dfy(138,12)
            call CevVarIntro(#tok$0^138.12, cev_local, #loc.consistent#34, consistent#34);
            // ----- call statement ----- Test\VSComp2010\Problem4-Queens.dfy(138,7)
            assert true;
            board#80 := candidateBoard#33;
            assert true;
            pos#81 := pos#28;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            call consistent#34 := _default.CheckConsistent(this, board#80, pos#81);
            call CevUpdateHere(#loc.consistent, consistent#34);
            call CevStep(#tok$0^138.7);
            assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(138,7)"} true;
            // ----- if statement ----- Test\VSComp2010\Problem4-Queens.dfy(139,7)
            call CevEvent(#tok$0^139.7, conditional_moment);
            assert true;
            if (consistent#34)
            {
                call CevEvent(#tok$0^139.23, took_then_branch);
                // ----- assert statement ----- Test\VSComp2010\Problem4-Queens.dfy(144,9)
                assert {:subsumption 0} (forall k#35: int :: (0 <= k#35 ==> true) && (0 <= k#35 && k#35 < Seq#Length(boardSoFar#18) ==> true) && (0 <= k#35 && k#35 < Seq#Length(boardSoFar#18) && _default.IsConsistent($Heap, boardSoFar#18, k#35) ==> true));
                assert (forall k#35: int :: 0 <= k#35 && k#35 < Seq#Length(boardSoFar#18) && _default.IsConsistent($Heap, boardSoFar#18, k#35) ==> _default.IsConsistent($Heap, candidateBoard#33, k#35));
                // ----- var-declaration statement ----- Test\VSComp2010\Problem4-Queens.dfy(151,14)
                call CevVarIntro(#tok$0^151.14, cev_local, #loc.s#36, s#36);
                // ----- var-declaration statement ----- Test\VSComp2010\Problem4-Queens.dfy(151,17)
                call CevVarIntro(#tok$0^151.17, cev_local, #loc.b#37, b#37);
                // ----- call statement ----- Test\VSComp2010\Problem4-Queens.dfy(151,9)
                assert true;
                N#82 := N#17;
                assert true;
                boardSoFar#83 := candidateBoard#33;
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                assert 0 <= N#17 - Seq#Length(boardSoFar#18) || N#82 - Seq#Length(boardSoFar#83) == N#17 - Seq#Length(boardSoFar#18);
                assert N#82 - Seq#Length(boardSoFar#83) < N#17 - Seq#Length(boardSoFar#18);
                call s#36, b#37 := _default.SearchAux(this, N#82, boardSoFar#83);
                call CevUpdateHere(#loc.s, s#36);
                call CevUpdateHere(#loc.b, b#37);
                call CevStep(#tok$0^151.9);
                assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(151,9)"} true;
                // ----- if statement ----- Test\VSComp2010\Problem4-Queens.dfy(152,9)
                call CevEvent(#tok$0^152.9, conditional_moment);
                assert true;
                if (s#36)
                {
                    call CevEvent(#tok$0^152.16, took_then_branch);
                    // ----- assignment statement ----- Test\VSComp2010\Problem4-Queens.dfy(154,20)
                    assert true;
                    assert true;
                    newBoard#20 := b#37;
                    assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(154,20)"} true;
                    call CevUpdate(#tok$0^154.20, #loc.newBoard#20, newBoard#20);
                    // ----- assignment statement ----- Test\VSComp2010\Problem4-Queens.dfy(155,19)
                    assert true;
                    assert true;
                    success#19 := true;
                    assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(155,19)"} true;
                    call CevUpdate(#tok$0^155.19, #loc.success#19, success#19);
                    // ----- return statement ----- Test\VSComp2010\Problem4-Queens.dfy(156,11)
                    return;
                }
                else
                {
                    call CevEvent(#tok$0^152.9, took_else_branch);
                }
            }
            else
            {
                call CevEvent(#tok$0^160.14, took_else_branch);
                // ----- assert statement ----- Test\VSComp2010\Problem4-Queens.dfy(163,9)
                assert {:subsumption 0} (forall B#38: Seq BoxType :: (Seq#Length(B#38) == N#17 ==> (forall i#39: int :: (0 <= i#39 ==> true) && (0 <= i#39 && i#39 < N#17 ==> 0 <= i#39 && i#39 < Seq#Length(B#38) && (0 <= $Unbox(Seq#Index(B#38, i#39)): int ==> 0 <= i#39 && i#39 < Seq#Length(B#38))))) && (Seq#Length(B#38) == N#17 && (forall i#39: int :: 0 <= i#39 && i#39 < N#17 ==> 0 <= $Unbox(Seq#Index(B#38, i#39)): int && $Unbox(Seq#Index(B#38, i#39)): int < N#17) ==> true) && (Seq#Length(B#38) == N#17 && (forall i#39: int :: 0 <= i#39 && i#39 < N#17 ==> 0 <= $Unbox(Seq#Index(B#38, i#39)): int && $Unbox(Seq#Index(B#38, i#39)): int < N#17) && Seq#Length(candidateBoard#33) <= Seq#Length(B#38) && Seq#SameUntil(candidateBoard#33, B#38, Seq#Length(candidateBoard#33)) ==> true));
                assert (forall B#38: Seq BoxType :: Seq#Length(B#38) == N#17 && (forall i#39: int :: 0 <= i#39 && i#39 < N#17 ==> 0 <= $Unbox(Seq#Index(B#38, i#39)): int && $Unbox(Seq#Index(B#38, i#39)): int < N#17) && Seq#Length(candidateBoard#33) <= Seq#Length(B#38) && Seq#SameUntil(candidateBoard#33, B#38, Seq#Length(candidateBoard#33)) ==> !_default.IsConsistent($Heap, B#38, pos#28));
            }

            // ----- assignment statement ----- Test\VSComp2010\Problem4-Queens.dfy(169,9)
            assert true;
            assert true;
            n#29 := n#29 + 1;
            assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(169,9)"} true;
            call CevUpdate(#tok$0^169.9, #loc.n#29, n#29);
            assert 0 <= $decr0$0 || N#17 - n#29 == $decr0$0;
            assert N#17 - n#29 < $decr0$0;
        }

        call CevStepEvent(#tok$0^122.5, loop_exited);
        assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(122,5): loop exit"} true;
        // ----- assignment statement ----- Test\VSComp2010\Problem4-Queens.dfy(172,13)
        assert true;
        assert true;
        success#19 := false;
        assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(172,13)"} true;
        call CevUpdate(#tok$0^172.13, #loc.success#19, success#19);
    }
}



const unique #tok$0^176.8: $token;

procedure CheckWellformed$$_default.Main(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^176.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



implementation CheckWellformed$$_default.Main(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^176.8, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
}



procedure _default.Main(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^176.8;
  modifies $Heap, #cev_pc;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.s#40: $token;

const unique #tok$0^178.8: $token;

const unique #loc.b#41: $token;

const unique #tok$0^178.11: $token;

const unique #tok$0^178.3: $token;

const unique #tok$0^180.3: $token;

const unique #tok$0^182.3: $token;

implementation _default.Main(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var s#40: bool where #cev_var_update(#cev_pc, cev_local, #loc.s#40, s#40);
  var b#41: Seq BoxType where #cev_var_update(#cev_pc, cev_local, #loc.b#41, b#41);
  var N#84: int;
  var N#85: int;
  var b#86: Seq BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^176.8, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- Test\VSComp2010\Problem4-Queens.dfy(178,8)
    call CevVarIntro(#tok$0^178.8, cev_local, #loc.s#40, s#40);
    // ----- var-declaration statement ----- Test\VSComp2010\Problem4-Queens.dfy(178,11)
    call CevVarIntro(#tok$0^178.11, cev_local, #loc.b#41, b#41);
    // ----- call statement ----- Test\VSComp2010\Problem4-Queens.dfy(178,3)
    assert true;
    N#84 := 2;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call s#40, b#41 := _default.Search(this, N#84);
    call CevUpdateHere(#loc.s, s#40);
    call CevUpdateHere(#loc.b, b#41);
    call CevStep(#tok$0^178.3);
    assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(178,3)"} true;
    // ----- print statement ----- Test\VSComp2010\Problem4-Queens.dfy(179,3)
    assert {:subsumption 0} true;
    // ----- call statement ----- Test\VSComp2010\Problem4-Queens.dfy(180,3)
    assert true;
    N#85 := 4;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call s#40, b#41 := _default.Search(this, N#85);
    call CevUpdateHere(#loc.s, s#40);
    call CevUpdateHere(#loc.b, b#41);
    call CevStep(#tok$0^180.3);
    assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(180,3)"} true;
    // ----- print statement ----- Test\VSComp2010\Problem4-Queens.dfy(181,3)
    assert {:subsumption 0} true;
    // ----- call statement ----- Test\VSComp2010\Problem4-Queens.dfy(182,3)
    assert true;
    b#86 := b#41;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.PrintSeq(this, b#86);
    call CevStep(#tok$0^182.3);
    assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(182,3)"} true;
}



const unique #tok$0^185.8: $token;

procedure CheckWellformed$$_default.PrintSeq(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, b#42: Seq BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^185.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^185.17: $token;

const unique #loc.b#42: $token;

implementation CheckWellformed$$_default.PrintSeq(this: ref, b#42: Seq BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^185.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^185.17, cev_parameter, #loc.b#42, b#42);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
}



procedure _default.PrintSeq(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, b#42: Seq BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^185.8;
  modifies $Heap, #cev_pc;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.i#43: $token;

const unique #tok$0^187.7: $token;

const unique #tok$0^188.3: $token;

const unique #tok$0^190.7: $token;

implementation _default.PrintSeq(this: ref, b#42: Seq BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#43: int where #cev_var_update(#cev_pc, cev_local, #loc.i#43, i#43);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^185.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^185.17, cev_parameter, #loc.b#42, b#42);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- Test\VSComp2010\Problem4-Queens.dfy(187,7)
    assert true;
    assert true;
    i#43 := 0;
    assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(187,7)"} true;
    call CevVarIntro(#tok$0^187.7, cev_local, #loc.i#43, i#43);
    // ----- while statement ----- Test\VSComp2010\Problem4-Queens.dfy(188,3)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := Seq#Length(b#42) - i#43;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^188.3);
    while (true)
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant Seq#Length(b#42) - i#43 <= $decr0$init$0 && (Seq#Length(b#42) - i#43 == $decr0$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^188.3;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert true;
            assume false;
        }

        assert true;
        if (i#43 >= Seq#Length(b#42))
        {
            break;
        }

        call CevStepEvent(#tok$0^188.3, loop_entered);
        assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(188,3): loop entered"} true;
        $decr0$0 := Seq#Length(b#42) - i#43;
        // ----- print statement ----- Test\VSComp2010\Problem4-Queens.dfy(189,5)
        assert {:subsumption 0} 0 <= i#43 && i#43 < Seq#Length(b#42);
        // ----- assignment statement ----- Test\VSComp2010\Problem4-Queens.dfy(190,7)
        assert true;
        assert true;
        i#43 := i#43 + 1;
        assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(190,7)"} true;
        call CevUpdate(#tok$0^190.7, #loc.i#43, i#43);
        assert 0 <= $decr0$0 || Seq#Length(b#42) - i#43 == $decr0$0;
        assert Seq#Length(b#42) - i#43 < $decr0$0;
    }

    call CevStepEvent(#tok$0^188.3, loop_exited);
    assume {:captureState "Test\VSComp2010\Problem4-Queens.dfy(188,3): loop exit"} true;
}


