// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: SchorrWaite.dfy /compile:0 /print:SchorrWaite.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class.Node: ClassName;

axiom FDim(Node.children) == 0 && DeclType(Node.children) == class.Node;

const unique Node.children: Field (Seq BoxType);

axiom (forall $h: HeapType, $o: ref, $i: int :: { Seq#Index(read($h, $o, Node.children), $i) } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) && 0 <= $i && $i < Seq#Length(read($h, $o, Node.children)) ==> $Unbox(Seq#Index(read($h, $o, Node.children), $i)): ref == null || (read($h, $Unbox(Seq#Index(read($h, $o, Node.children), $i)): ref, alloc) && dtype($Unbox(Seq#Index(read($h, $o, Node.children), $i)): ref) == class.Node));

axiom FDim(Node.marked) == 0 && DeclType(Node.marked) == class.Node;

const unique Node.marked: Field bool;

axiom FDim(Node.childrenVisited) == 0 && DeclType(Node.childrenVisited) == class.Node;

const unique Node.childrenVisited: Field int;

axiom FDim(Node.pathFromRoot) == 0 && DeclType(Node.pathFromRoot) == class.Node;

const unique Node.pathFromRoot: Field DatatypeType;

const unique class.Main: ClassName;

const unique #file^SchorrWaite.dfy: $token;

axiom $file_name_is(0, #file^SchorrWaite.dfy);

const unique #tok$0^14.10: $token;

procedure CheckWellformed$$Main.RecursiveMark(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Main, root#0: ref where root#0 == null || (read($Heap, root#0, alloc) && dtype(root#0) == class.Node), S#1: Set BoxType where (forall $t: BoxType :: { S#1[$t] } S#1[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^14.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.this: $token;

const unique #tok$0^14.24: $token;

const unique #loc.root#0: $token;

const unique #tok$0^14.42: $token;

const unique #loc.S#1: $token;

implementation CheckWellformed$$Main.RecursiveMark(this: ref, root#0: ref, S#1: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var n#96: ref;
  var ch#97: ref;
  var n#98: ref;
  var n#99: ref;
  var ch#100: ref;
  var n#101: ref;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^14.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^14.24, cev_parameter, #loc.root#0, root#0);
    call CevVarIntro(#tok$0^14.42, cev_parameter, #loc.S#1, S#1);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> S#1[$Box($o)]);
    assume S#1[$Box(root#0)];
    if (S#1[$Box(n#96)])
    {
        if (n#96 != null)
        {
            assert n#96 != null;
            if (Seq#Contains(read($Heap, n#96, Node.children), $Box(ch#97)))
            {
                if (ch#97 != null)
                {
                }
            }
        }
    }

    assume (forall n#2: ref :: S#1[$Box(n#2)] ==> n#2 != null && (forall ch#3: ref :: Seq#Contains(read($Heap, n#2, Node.children), $Box(ch#3)) ==> ch#3 == null || S#1[$Box(ch#3)]));
    if (S#1[$Box(n#98)])
    {
        assert n#98 != null;
        if (!read($Heap, n#98, Node.marked))
        {
            assert n#98 != null;
        }
    }

    assume (forall n#4: ref :: S#1[$Box(n#4)] ==> !read($Heap, n#4, Node.marked) && read($Heap, n#4, Node.childrenVisited) == 0);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    assert root#0 != null;
    assume read($Heap, root#0, Node.marked);
    if (S#1[$Box(n#99)])
    {
        assert n#99 != null;
    }

    if (S#1[$Box(n#99)] && read($Heap, n#99, Node.marked))
    {
        assert n#99 != null;
        if (Seq#Contains(read($Heap, n#99, Node.children), $Box(ch#100)))
        {
        }

        if (Seq#Contains(read($Heap, n#99, Node.children), $Box(ch#100)) && ch#100 != null)
        {
            assert ch#100 != null;
        }
    }

    assume (forall n#5: ref :: S#1[$Box(n#5)] && read($Heap, n#5, Node.marked) ==> (forall ch#6: ref :: Seq#Contains(read($Heap, n#5, Node.children), $Box(ch#6)) && ch#6 != null ==> read($Heap, ch#6, Node.marked)));
    if (S#1[$Box(n#101)])
    {
        assert n#101 != null;
        assert n#101 != null;
        if (read($Heap, n#101, Node.childrenVisited) == old(read($Heap, n#101, Node.childrenVisited)))
        {
            assert n#101 != null;
            assert n#101 != null;
        }
    }

    assume (forall n#7: ref :: S#1[$Box(n#7)] ==> read($Heap, n#7, Node.childrenVisited) == old(read($Heap, n#7, Node.childrenVisited)) && Seq#Equal(read($Heap, n#7, Node.children), old(read($Heap, n#7, Node.children))));
}



procedure Main.RecursiveMark(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Main, root#0: ref where root#0 == null || (read($Heap, root#0, alloc) && dtype(root#0) == class.Node), S#1: Set BoxType where (forall $t: BoxType :: { S#1[$t] } S#1[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires S#1[$Box(root#0)];
  requires (forall n#2: ref :: S#1[$Box(n#2)] ==> n#2 != null && (forall ch#3: ref :: Seq#Contains(read($Heap, n#2, Node.children), $Box(ch#3)) ==> ch#3 == null || S#1[$Box(ch#3)]));
  requires (forall n#4: ref :: S#1[$Box(n#4)] ==> !read($Heap, n#4, Node.marked) && read($Heap, n#4, Node.childrenVisited) == 0);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^14.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures read($Heap, root#0, Node.marked);
  ensures (forall n#5: ref :: S#1[$Box(n#5)] && read($Heap, n#5, Node.marked) ==> (forall ch#6: ref :: Seq#Contains(read($Heap, n#5, Node.children), $Box(ch#6)) && ch#6 != null ==> read($Heap, ch#6, Node.marked)));
  ensures (forall n#7: ref :: S#1[$Box(n#7)] ==> read($Heap, n#7, Node.childrenVisited) == old(read($Heap, n#7, Node.childrenVisited)) && Seq#Equal(read($Heap, n#7, Node.children), old(read($Heap, n#7, Node.children))));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || S#1[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^29.5: $token;

implementation Main.RecursiveMark(this: ref, root#0: ref, S#1: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var root#102: ref;
  var S#103: Set BoxType;
  var stackNodes#104: Set BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^14.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^14.24, cev_parameter, #loc.root#0, root#0);
    call CevVarIntro(#tok$0^14.42, cev_parameter, #loc.S#1, S#1);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> S#1[$Box($o)]);
    // ----- call statement ----- SchorrWaite.dfy(29,5)
    assert true;
    root#102 := root#0;
    assert true;
    S#103 := S#1;
    assert true;
    stackNodes#104 := Set#Empty(): Set BoxType;
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && S#103[$Box($o)] ==> $_Frame[$o, $f]);
    call Main.RecursiveMarkWorker(this, root#102, S#103, stackNodes#104);
    call CevStep(#tok$0^29.5);
    assume {:captureState "SchorrWaite.dfy(29,5)"} true;
}



const unique #tok$0^32.10: $token;

procedure CheckWellformed$$Main.RecursiveMarkWorker(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Main, root#8: ref where root#8 == null || (read($Heap, root#8, alloc) && dtype(root#8) == class.Node), S#9: Set BoxType where (forall $t: BoxType :: { S#9[$t] } S#9[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)), stackNodes#10: Set BoxType where (forall $t: BoxType :: { stackNodes#10[$t] } stackNodes#10[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^32.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^32.30: $token;

const unique #loc.root#8: $token;

const unique #tok$0^32.48: $token;

const unique #loc.S#9: $token;

const unique #tok$0^32.68: $token;

const unique #loc.stackNodes#10: $token;

implementation CheckWellformed$$Main.RecursiveMarkWorker(this: ref, root#8: ref, S#9: Set BoxType, stackNodes#10: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var n#105: ref;
  var ch#106: ref;
  var n#107: ref;
  var ch#108: ref;
  var n#109: ref;
  var n#110: ref;
  var ch#111: ref;
  var n#112: ref;
  var n#113: ref;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^32.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^32.30, cev_parameter, #loc.root#8, root#8);
    call CevVarIntro(#tok$0^32.48, cev_parameter, #loc.S#9, S#9);
    call CevVarIntro(#tok$0^32.68, cev_parameter, #loc.stackNodes#10, stackNodes#10);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> S#9[$Box($o)]);
    if (root#8 != null)
    {
    }

    assume root#8 != null && S#9[$Box(root#8)];
    if (S#9[$Box(n#105)])
    {
        if (n#105 != null)
        {
            assert n#105 != null;
            if (Seq#Contains(read($Heap, n#105, Node.children), $Box(ch#106)))
            {
                if (ch#106 != null)
                {
                }
            }
        }
    }

    assume (forall n#11: ref :: S#9[$Box(n#11)] ==> n#11 != null && (forall ch#12: ref :: Seq#Contains(read($Heap, n#11, Node.children), $Box(ch#12)) ==> ch#12 == null || S#9[$Box(ch#12)]));
    if (S#9[$Box(n#107)])
    {
        assert n#107 != null;
    }

    if (S#9[$Box(n#107)] && read($Heap, n#107, Node.marked))
    {
        if (!stackNodes#10[$Box(n#107)])
        {
            assert n#107 != null;
            if (Seq#Contains(read($Heap, n#107, Node.children), $Box(ch#108)))
            {
            }

            if (Seq#Contains(read($Heap, n#107, Node.children), $Box(ch#108)) && ch#108 != null)
            {
                assert ch#108 != null;
            }
        }
    }

    assume (forall n#13: ref :: S#9[$Box(n#13)] && read($Heap, n#13, Node.marked) ==> stackNodes#10[$Box(n#13)] || (forall ch#14: ref :: Seq#Contains(read($Heap, n#13, Node.children), $Box(ch#14)) && ch#14 != null ==> read($Heap, ch#14, Node.marked)));
    if (stackNodes#10[$Box(n#109)])
    {
        if (n#109 != null)
        {
            assert n#109 != null;
        }
    }

    assume (forall n#15: ref :: stackNodes#10[$Box(n#15)] ==> n#15 != null && read($Heap, n#15, Node.marked));
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    assert root#8 != null;
    assume read($Heap, root#8, Node.marked);
    if (S#9[$Box(n#110)])
    {
        assert n#110 != null;
    }

    if (S#9[$Box(n#110)] && read($Heap, n#110, Node.marked))
    {
        if (!stackNodes#10[$Box(n#110)])
        {
            assert n#110 != null;
            if (Seq#Contains(read($Heap, n#110, Node.children), $Box(ch#111)))
            {
            }

            if (Seq#Contains(read($Heap, n#110, Node.children), $Box(ch#111)) && ch#111 != null)
            {
                assert ch#111 != null;
            }
        }
    }

    assume (forall n#16: ref :: S#9[$Box(n#16)] && read($Heap, n#16, Node.marked) ==> stackNodes#10[$Box(n#16)] || (forall ch#17: ref :: Seq#Contains(read($Heap, n#16, Node.children), $Box(ch#17)) && ch#17 != null ==> read($Heap, ch#17, Node.marked)));
    if (S#9[$Box(n#112)])
    {
        assert n#112 != null;
    }

    if (S#9[$Box(n#112)] && old(read($Heap, n#112, Node.marked)))
    {
        assert n#112 != null;
    }

    assume (forall n#18: ref :: S#9[$Box(n#18)] && old(read($Heap, n#18, Node.marked)) ==> read($Heap, n#18, Node.marked));
    if (S#9[$Box(n#113)])
    {
        assert n#113 != null;
        assert n#113 != null;
        if (read($Heap, n#113, Node.childrenVisited) == old(read($Heap, n#113, Node.childrenVisited)))
        {
            assert n#113 != null;
            assert n#113 != null;
        }
    }

    assume (forall n#19: ref :: S#9[$Box(n#19)] ==> read($Heap, n#19, Node.childrenVisited) == old(read($Heap, n#19, Node.childrenVisited)) && Seq#Equal(read($Heap, n#19, Node.children), old(read($Heap, n#19, Node.children))));
}



procedure Main.RecursiveMarkWorker(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Main, root#8: ref where root#8 == null || (read($Heap, root#8, alloc) && dtype(root#8) == class.Node), S#9: Set BoxType where (forall $t: BoxType :: { S#9[$t] } S#9[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)), stackNodes#10: Set BoxType where (forall $t: BoxType :: { stackNodes#10[$t] } stackNodes#10[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires root#8 != null && S#9[$Box(root#8)];
  requires true ==> root#8 != null;
  requires true ==> S#9[$Box(root#8)];
  requires (forall n#11: ref :: S#9[$Box(n#11)] ==> n#11 != null && (forall ch#12: ref :: Seq#Contains(read($Heap, n#11, Node.children), $Box(ch#12)) ==> ch#12 == null || S#9[$Box(ch#12)]));
  requires (forall n#13: ref :: S#9[$Box(n#13)] && read($Heap, n#13, Node.marked) ==> stackNodes#10[$Box(n#13)] || (forall ch#14: ref :: Seq#Contains(read($Heap, n#13, Node.children), $Box(ch#14)) && ch#14 != null ==> read($Heap, ch#14, Node.marked)));
  requires (forall n#15: ref :: stackNodes#10[$Box(n#15)] ==> n#15 != null && read($Heap, n#15, Node.marked));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^32.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures read($Heap, root#8, Node.marked);
  ensures (forall n#16: ref :: S#9[$Box(n#16)] && read($Heap, n#16, Node.marked) ==> stackNodes#10[$Box(n#16)] || (forall ch#17: ref :: Seq#Contains(read($Heap, n#16, Node.children), $Box(ch#17)) && ch#17 != null ==> read($Heap, ch#17, Node.marked)));
  ensures (forall n#18: ref :: S#9[$Box(n#18)] && old(read($Heap, n#18, Node.marked)) ==> read($Heap, n#18, Node.marked));
  ensures (forall n#19: ref :: S#9[$Box(n#19)] ==> read($Heap, n#19, Node.childrenVisited) == old(read($Heap, n#19, Node.childrenVisited)) && Seq#Equal(read($Heap, n#19, Node.children), old(read($Heap, n#19, Node.children))));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || S#9[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^52.5: $token;

const unique #tok$0^52.24: $token;

const unique #tok$0^53.19: $token;

const unique #loc.i#20: $token;

const unique #tok$0^54.11: $token;

const unique #tok$0^55.7: $token;

const unique #loc.c#26: $token;

const unique #tok$0^68.13: $token;

const unique #tok$0^69.9: $token;

const unique #tok$0^69.24: $token;

const unique #tok$0^70.11: $token;

const unique #tok$0^72.11: $token;

implementation Main.RecursiveMarkWorker(this: ref, root#8: ref, S#9: Set BoxType, stackNodes#10: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#20: int where #cev_var_update(#cev_pc, cev_local, #loc.i#20, i#20);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;
  var c#26: ref where (c#26 == null || (read($Heap, c#26, alloc) && dtype(c#26) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.c#26, c#26);
  var root#114: ref;
  var S#115: Set BoxType;
  var stackNodes#116: Set BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^32.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^32.30, cev_parameter, #loc.root#8, root#8);
    call CevVarIntro(#tok$0^32.48, cev_parameter, #loc.S#9, S#9);
    call CevVarIntro(#tok$0^32.68, cev_parameter, #loc.stackNodes#10, stackNodes#10);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> S#9[$Box($o)]);
    // ----- if statement ----- SchorrWaite.dfy(52,5)
    call CevEvent(#tok$0^52.5, conditional_moment);
    assert root#8 != null;
    if (!read($Heap, root#8, Node.marked))
    {
        call CevEvent(#tok$0^52.24, took_then_branch);
        // ----- assignment statement ----- SchorrWaite.dfy(53,19)
        assert root#8 != null;
        assert true;
        assert $_Frame[root#8, Node.marked];
        $Heap := update($Heap, root#8, Node.marked, true);
        assume $IsGoodHeap($Heap);
        assume {:captureState "SchorrWaite.dfy(53,19)"} true;
        call CevUpdateHeap(#tok$0^53.19, #loc.$Heap, $Heap);
        // ----- var-declaration statement ----- SchorrWaite.dfy(54,11)
        assert true;
        assert true;
        i#20 := 0;
        assume {:captureState "SchorrWaite.dfy(54,11)"} true;
        call CevVarIntro(#tok$0^54.11, cev_local, #loc.i#20, i#20);
        // ----- while statement ----- SchorrWaite.dfy(55,7)
        $PreLoopHeap0 := $Heap;
        $decr0$init$0 := Seq#Length(read($Heap, root#8, Node.children)) - i#20;
        havoc $w0;
        call $PreLoopCevPC0 := CevPreLoop(#tok$0^55.7);
        while (true)
          invariant $w0 ==> read($Heap, root#8, Node.marked);
          invariant $w0 ==> i#20 <= Seq#Length(read($Heap, root#8, Node.children));
    //      free invariant $w0 ==> read($Heap, root#8, Node.marked) && i#20 <= Seq#Length(read($Heap, root#8, Node.children));
          invariant $w0 ==> (forall n#21: ref :: S#9[$Box(n#21)] && read($Heap, n#21, Node.marked) ==> n#21 == root#8 || stackNodes#10[$Box(n#21)] || (forall ch#22: ref :: Seq#Contains(read($Heap, n#21, Node.children), $Box(ch#22)) && ch#22 != null ==> read($Heap, ch#22, Node.marked)));
          invariant $w0 ==> (forall j#23: int :: 0 <= j#23 && j#23 < i#20 ==> $Unbox(Seq#Index(read($Heap, root#8, Node.children), j#23)): ref == null || read($Heap, $Unbox(Seq#Index(read($Heap, root#8, Node.children), j#23)): ref, Node.marked));
          invariant $w0 ==> (forall n#24: ref :: S#9[$Box(n#24)] && old(read($Heap, n#24, Node.marked)) ==> read($Heap, n#24, Node.marked));
          invariant $w0 ==> (forall n#25: ref :: S#9[$Box(n#25)] ==> read($Heap, n#25, Node.childrenVisited) == old(read($Heap, n#25, Node.childrenVisited)));
          invariant $w0 ==> (forall n#25: ref :: S#9[$Box(n#25)] ==> Seq#Equal(read($Heap, n#25, Node.children), old(read($Heap, n#25, Node.children))));
          free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f) || S#9[$Box($o)]);
          free invariant $HeapSucc($PreLoopHeap0, $Heap);
          free invariant Seq#Length(read($Heap, root#8, Node.children)) - i#20 <= $decr0$init$0 && (Seq#Length(read($Heap, root#8, Node.children)) - i#20 == $decr0$init$0 ==> true);
          free invariant #cev_save_position(#cev_pc) == #tok$0^55.7;
          free invariant $PreLoopCevPC0 < #cev_pc;
          free invariant #cev_control_flow_event(#cev_pc, loop_register);
          kUnwind 1;
        {
            if (!$w0)
            {
                assert {:subsumption 0} root#8 != null && (read($Heap, root#8, Node.marked) ==> root#8 != null);
                assume read($Heap, root#8, Node.marked) && i#20 <= Seq#Length(read($Heap, root#8, Node.children));
                assert {:subsumption 0} (forall n#21: ref :: (S#9[$Box(n#21)] ==> n#21 != null) && (S#9[$Box(n#21)] && read($Heap, n#21, Node.marked) ==> (n#21 != root#8 ==> true) && (!(n#21 == root#8 || stackNodes#10[$Box(n#21)]) ==> (forall ch#22: ref :: n#21 != null && (Seq#Contains(read($Heap, n#21, Node.children), $Box(ch#22)) ==> true) && (Seq#Contains(read($Heap, n#21, Node.children), $Box(ch#22)) && ch#22 != null ==> ch#22 != null)))));
                assume (forall n#21: ref :: S#9[$Box(n#21)] && read($Heap, n#21, Node.marked) ==> n#21 == root#8 || stackNodes#10[$Box(n#21)] || (forall ch#22: ref :: Seq#Contains(read($Heap, n#21, Node.children), $Box(ch#22)) && ch#22 != null ==> read($Heap, ch#22, Node.marked)));
                assert {:subsumption 0} (forall j#23: int :: (0 <= j#23 ==> true) && (0 <= j#23 && j#23 < i#20 ==> root#8 != null && 0 <= j#23 && j#23 < Seq#Length(read($Heap, root#8, Node.children)) && ($Unbox(Seq#Index(read($Heap, root#8, Node.children), j#23)): ref != null ==> root#8 != null && 0 <= j#23 && j#23 < Seq#Length(read($Heap, root#8, Node.children)) && $Unbox(Seq#Index(read($Heap, root#8, Node.children), j#23)): ref != null)));
                assume (forall j#23: int :: 0 <= j#23 && j#23 < i#20 ==> $Unbox(Seq#Index(read($Heap, root#8, Node.children), j#23)): ref == null || read($Heap, $Unbox(Seq#Index(read($Heap, root#8, Node.children), j#23)): ref, Node.marked));
                assert {:subsumption 0} (forall n#24: ref :: (S#9[$Box(n#24)] ==> old(n#24 != null)) && (S#9[$Box(n#24)] && old(read($Heap, n#24, Node.marked)) ==> n#24 != null));
                assume (forall n#24: ref :: S#9[$Box(n#24)] && old(read($Heap, n#24, Node.marked)) ==> read($Heap, n#24, Node.marked));
                assert {:subsumption 0} (forall n#25: ref :: S#9[$Box(n#25)] ==> n#25 != null && old(n#25 != null) && (read($Heap, n#25, Node.childrenVisited) == old(read($Heap, n#25, Node.childrenVisited)) ==> n#25 != null && old(n#25 != null)));
                assume (forall n#25: ref :: S#9[$Box(n#25)] ==> read($Heap, n#25, Node.childrenVisited) == old(read($Heap, n#25, Node.childrenVisited)) && Seq#Equal(read($Heap, n#25, Node.children), old(read($Heap, n#25, Node.children))));
                assert root#8 != null;
                assume false;
            }

            assert root#8 != null;
            if (i#20 >= Seq#Length(read($Heap, root#8, Node.children)))
            {
                break;
            }

            call CevStepEvent(#tok$0^55.7, loop_entered);
            assume {:captureState "SchorrWaite.dfy(55,7): loop entered"} true;
            $decr0$0 := Seq#Length(read($Heap, root#8, Node.children)) - i#20;
            // ----- var-declaration statement ----- SchorrWaite.dfy(68,13)
            assert true;
            assert root#8 != null && 0 <= i#20 && i#20 < Seq#Length(read($Heap, root#8, Node.children));
            c#26 := $Unbox(Seq#Index(read($Heap, root#8, Node.children), i#20)): ref;
            assume {:captureState "SchorrWaite.dfy(68,13)"} true;
            call CevVarIntro(#tok$0^68.13, cev_local, #loc.c#26, c#26);
            // ----- if statement ----- SchorrWaite.dfy(69,9)
            call CevEvent(#tok$0^69.9, conditional_moment);
            assert true;
            if (c#26 != null)
            {
                call CevEvent(#tok$0^69.24, took_then_branch);
                // ----- call statement ----- SchorrWaite.dfy(70,11)
                assert true;
                root#114 := c#26;
                assert true;
                S#115 := S#9;
                assert true;
                stackNodes#116 := Set#Union(stackNodes#10, Set#UnionOne(Set#Empty(): Set BoxType, $Box(root#8)));
                assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && S#115[$Box($o)] ==> $_Frame[$o, $f]);
                assert Set#Subset(Set#Difference(S#115, stackNodes#116), Set#Difference(S#9, stackNodes#10)) && !Set#Subset(Set#Difference(S#9, stackNodes#10), Set#Difference(S#115, stackNodes#116));
                call Main.RecursiveMarkWorker(this, root#114, S#115, stackNodes#116);
                call CevStep(#tok$0^70.11);
                assume {:captureState "SchorrWaite.dfy(70,11)"} true;
            }
            else
            {
                call CevEvent(#tok$0^69.9, took_else_branch);
            }

            // ----- assignment statement ----- SchorrWaite.dfy(72,11)
            assert true;
            assert true;
            i#20 := i#20 + 1;
            assume {:captureState "SchorrWaite.dfy(72,11)"} true;
            call CevUpdate(#tok$0^72.11, #loc.i#20, i#20);
            assert 0 <= $decr0$0 || Seq#Length(read($Heap, root#8, Node.children)) - i#20 == $decr0$0;
            assert Seq#Length(read($Heap, root#8, Node.children)) - i#20 < $decr0$0;
        }

        call CevStepEvent(#tok$0^55.7, loop_exited);
        assume {:captureState "SchorrWaite.dfy(55,7): loop exit"} true;
    }
    else
    {
        call CevEvent(#tok$0^52.5, took_else_branch);
    }
}



const unique #tok$0^79.10: $token;

procedure CheckWellformed$$Main.IterativeMark(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Main, root#27: ref where root#27 == null || (read($Heap, root#27, alloc) && dtype(root#27) == class.Node), S#28: Set BoxType where (forall $t: BoxType :: { S#28[$t] } S#28[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^79.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^79.24: $token;

const unique #loc.root#27: $token;

const unique #tok$0^79.42: $token;

const unique #loc.S#28: $token;

implementation CheckWellformed$$Main.IterativeMark(this: ref, root#27: ref, S#28: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var n#117: ref;
  var ch#118: ref;
  var n#119: ref;
  var n#120: ref;
  var ch#121: ref;
  var n#122: ref;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^79.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^79.24, cev_parameter, #loc.root#27, root#27);
    call CevVarIntro(#tok$0^79.42, cev_parameter, #loc.S#28, S#28);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> S#28[$Box($o)]);
    assume S#28[$Box(root#27)];
    if (S#28[$Box(n#117)])
    {
        if (n#117 != null)
        {
            assert n#117 != null;
            if (Seq#Contains(read($Heap, n#117, Node.children), $Box(ch#118)))
            {
                if (ch#118 != null)
                {
                }
            }
        }
    }

    assume (forall n#29: ref :: S#28[$Box(n#29)] ==> n#29 != null && (forall ch#30: ref :: Seq#Contains(read($Heap, n#29, Node.children), $Box(ch#30)) ==> ch#30 == null || S#28[$Box(ch#30)]));
    if (S#28[$Box(n#119)])
    {
        assert n#119 != null;
        if (!read($Heap, n#119, Node.marked))
        {
            assert n#119 != null;
        }
    }

    assume (forall n#31: ref :: S#28[$Box(n#31)] ==> !read($Heap, n#31, Node.marked) && read($Heap, n#31, Node.childrenVisited) == 0);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    assert root#27 != null;
    assume read($Heap, root#27, Node.marked);
    if (S#28[$Box(n#120)])
    {
        assert n#120 != null;
    }

    if (S#28[$Box(n#120)] && read($Heap, n#120, Node.marked))
    {
        assert n#120 != null;
        if (Seq#Contains(read($Heap, n#120, Node.children), $Box(ch#121)))
        {
        }

        if (Seq#Contains(read($Heap, n#120, Node.children), $Box(ch#121)) && ch#121 != null)
        {
            assert ch#121 != null;
        }
    }

    assume (forall n#32: ref :: S#28[$Box(n#32)] && read($Heap, n#32, Node.marked) ==> (forall ch#33: ref :: Seq#Contains(read($Heap, n#32, Node.children), $Box(ch#33)) && ch#33 != null ==> read($Heap, ch#33, Node.marked)));
    if (S#28[$Box(n#122)])
    {
        assert n#122 != null;
        assert n#122 != null;
        if (read($Heap, n#122, Node.childrenVisited) == old(read($Heap, n#122, Node.childrenVisited)))
        {
            assert n#122 != null;
            assert n#122 != null;
        }
    }

    assume (forall n#34: ref :: S#28[$Box(n#34)] ==> read($Heap, n#34, Node.childrenVisited) == old(read($Heap, n#34, Node.childrenVisited)) && Seq#Equal(read($Heap, n#34, Node.children), old(read($Heap, n#34, Node.children))));
}



procedure Main.IterativeMark(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Main, root#27: ref where root#27 == null || (read($Heap, root#27, alloc) && dtype(root#27) == class.Node), S#28: Set BoxType where (forall $t: BoxType :: { S#28[$t] } S#28[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires S#28[$Box(root#27)];
  requires (forall n#29: ref :: S#28[$Box(n#29)] ==> n#29 != null && (forall ch#30: ref :: Seq#Contains(read($Heap, n#29, Node.children), $Box(ch#30)) ==> ch#30 == null || S#28[$Box(ch#30)]));
  requires (forall n#31: ref :: S#28[$Box(n#31)] ==> !read($Heap, n#31, Node.marked) && read($Heap, n#31, Node.childrenVisited) == 0);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^79.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures read($Heap, root#27, Node.marked);
  ensures (forall n#32: ref :: S#28[$Box(n#32)] && read($Heap, n#32, Node.marked) ==> (forall ch#33: ref :: Seq#Contains(read($Heap, n#32, Node.children), $Box(ch#33)) && ch#33 != null ==> read($Heap, ch#33, Node.marked)));
  ensures (forall n#34: ref :: S#28[$Box(n#34)] ==> read($Heap, n#34, Node.childrenVisited) == old(read($Heap, n#34, Node.childrenVisited)) && Seq#Equal(read($Heap, n#34, Node.children), old(read($Heap, n#34, Node.children))));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || S#28[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.t#35: $token;

const unique #tok$0^94.9: $token;

const unique #tok$0^95.14: $token;

const unique #loc.stackNodes#36: $token;

const unique #tok$0^96.9: $token;

const unique #loc.unmarkedNodes#37: $token;

const unique #tok$0^97.15: $token;

const unique #tok$0^98.5: $token;

const unique #tok$0^123.7: $token;

const unique #tok$0^123.46: $token;

const unique #tok$0^125.27: $token;

const unique #tok$0^126.9: $token;

const unique #tok$0^126.32: $token;

const unique #tok$0^129.11: $token;

const unique #tok$0^130.20: $token;

const unique #tok$0^131.27: $token;

const unique #tok$0^132.14: $token;

const unique #tok$0^132.97: $token;

const unique #tok$0^134.27: $token;

const unique #tok$0^135.14: $token;

const unique #tok$0^137.20: $token;

const unique #tok$0^138.11: $token;

const unique #tok$0^139.18: $token;

const unique #tok$0^140.23: $token;

implementation Main.IterativeMark(this: ref, root#27: ref, S#28: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var t#35: ref where (t#35 == null || (read($Heap, t#35, alloc) && dtype(t#35) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.t#35, t#35);
  var stackNodes#36: Seq BoxType where #cev_var_update(#cev_pc, cev_local, #loc.stackNodes#36, stackNodes#36);
  var unmarkedNodes#37: Set BoxType where (forall $t: BoxType :: { unmarkedNodes#37[$t] } unmarkedNodes#37[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.unmarkedNodes#37, unmarkedNodes#37);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: Set BoxType;
  var $decr0$init$1: Seq BoxType;
  var $decr0$init$2: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: Set BoxType;
  var $decr0$1: Seq BoxType;
  var $decr0$2: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^79.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^79.24, cev_parameter, #loc.root#27, root#27);
    call CevVarIntro(#tok$0^79.42, cev_parameter, #loc.S#28, S#28);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> S#28[$Box($o)]);
    // ----- var-declaration statement ----- SchorrWaite.dfy(94,9)
    assert true;
    assert true;
    t#35 := root#27;
    assume {:captureState "SchorrWaite.dfy(94,9)"} true;
    call CevVarIntro(#tok$0^94.9, cev_local, #loc.t#35, t#35);
    // ----- assignment statement ----- SchorrWaite.dfy(95,14)
    assert t#35 != null;
    assert true;
    assert $_Frame[t#35, Node.marked];
    $Heap := update($Heap, t#35, Node.marked, true);
    assume $IsGoodHeap($Heap);
    assume {:captureState "SchorrWaite.dfy(95,14)"} true;
    call CevUpdateHeap(#tok$0^95.14, #loc.$Heap, $Heap);
    // ----- var-declaration statement ----- SchorrWaite.dfy(96,9)
    assert true;
    assert true;
    stackNodes#36 := Seq#Empty(): Seq BoxType;
    assume {:captureState "SchorrWaite.dfy(96,9)"} true;
    call CevVarIntro(#tok$0^96.9, cev_local, #loc.stackNodes#36, stackNodes#36);
    // ----- var-declaration statement ----- SchorrWaite.dfy(97,15)
    assert true;
    assert true;
    unmarkedNodes#37 := Set#Difference(S#28, Set#UnionOne(Set#Empty(): Set BoxType, $Box(t#35)));
    assume {:captureState "SchorrWaite.dfy(97,15)"} true;
    call CevVarIntro(#tok$0^97.15, cev_local, #loc.unmarkedNodes#37, unmarkedNodes#37);
    // ----- while statement ----- SchorrWaite.dfy(98,5)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := unmarkedNodes#37;
    $decr0$init$1 := stackNodes#36;
    $decr0$init$2 := Seq#Length(read($Heap, t#35, Node.children)) - read($Heap, t#35, Node.childrenVisited);
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^98.5);
    while (true)
      invariant $w0 ==> read($Heap, root#27, Node.marked);
      invariant $w0 ==> S#28[$Box(t#35)];
      invariant $w0 ==> !Seq#Contains(stackNodes#36, $Box(t#35));
  //    free invariant $w0 ==> read($Heap, root#27, Node.marked) && S#28[$Box(t#35)] && !Seq#Contains(stackNodes#36, $Box(t#35));
      invariant $w0 ==> (forall i#38: int, j#39: int :: 0 <= i#38 && i#38 < j#39 && j#39 < Seq#Length(stackNodes#36) ==> $Unbox(Seq#Index(stackNodes#36, i#38)): ref != $Unbox(Seq#Index(stackNodes#36, j#39)): ref);
      invariant $w0 ==> (forall n#40: ref :: Seq#Contains(stackNodes#36, $Box(n#40)) ==> S#28[$Box(n#40)]);
      invariant $w0 ==> (forall n#41: ref :: Seq#Contains(stackNodes#36, $Box(n#41))
                                         ==>
                                             read($Heap, n#41, Node.marked));
      invariant $w0 ==> (forall n#41: ref :: Seq#Contains(stackNodes#36, $Box(n#41))
                                         ==>
                                             0 <= read($Heap, n#41, Node.childrenVisited));
      invariant $w0 ==> (forall n#41: ref :: Seq#Contains(stackNodes#36, $Box(n#41))
                                         ==>
                                             read($Heap, n#41, Node.childrenVisited) <= Seq#Length(read($Heap, n#41, Node.children)));
      invariant $w0 ==> (forall n#41: ref :: Seq#Contains(stackNodes#36, $Box(n#41))
                                         ==>
                                             (forall j#42: int :: 0 <= j#42 && j#42 < read($Heap, n#41, Node.childrenVisited) ==> $Unbox(Seq#Index(read($Heap, n#41, Node.children), j#42)): ref == null || read($Heap, $Unbox(Seq#Index(read($Heap, n#41, Node.children), j#42)): ref, Node.marked)));
      invariant $w0 ==> read($Heap, t#35, Node.marked);
      invariant $w0 ==> 0 <= read($Heap, t#35, Node.childrenVisited);
      invariant $w0 ==> read($Heap, t#35, Node.childrenVisited) <= Seq#Length(read($Heap, t#35, Node.children));
      invariant $w0 ==> (forall j#42: int :: 0 <= j#42 && j#42 < read($Heap, t#35, Node.childrenVisited) ==> $Unbox(Seq#Index(read($Heap, t#35, Node.children), j#42)): ref == null || read($Heap, $Unbox(Seq#Index(read($Heap, t#35, Node.children), j#42)): ref, Node.marked));
      invariant $w0 ==> (forall n#43: ref :: Seq#Contains(stackNodes#36, $Box(n#43)) ==> read($Heap, n#43, Node.childrenVisited) < Seq#Length(read($Heap, n#43, Node.children)));
      invariant $w0 ==> (forall j#44: int :: 0 <= j#44 && j#44 + 1 < Seq#Length(stackNodes#36) ==> $Unbox(Seq#Index(read($Heap, $Unbox(Seq#Index(stackNodes#36, j#44)): ref, Node.children), read($Heap, $Unbox(Seq#Index(stackNodes#36, j#44)): ref, Node.childrenVisited))): ref == $Unbox(Seq#Index(stackNodes#36, j#44 + 1)): ref);
      invariant $w0 ==> 0 < Seq#Length(stackNodes#36) ==> $Unbox(Seq#Index(read($Heap, $Unbox(Seq#Index(stackNodes#36, Seq#Length(stackNodes#36) - 1)): ref, Node.children), read($Heap, $Unbox(Seq#Index(stackNodes#36, Seq#Length(stackNodes#36) - 1)): ref, Node.childrenVisited))): ref == t#35;
      invariant $w0 ==> (forall n#45: ref :: S#28[$Box(n#45)] && read($Heap, n#45, Node.marked) && !Seq#Contains(stackNodes#36, $Box(n#45)) && n#45 != t#35 ==> (forall ch#46: ref :: Seq#Contains(read($Heap, n#45, Node.children), $Box(ch#46)) && ch#46 != null ==> read($Heap, ch#46, Node.marked)));
      invariant $w0 ==> (forall n#47: ref :: S#28[$Box(n#47)] && !Seq#Contains(stackNodes#36, $Box(n#47)) && n#47 != t#35 ==> read($Heap, n#47, Node.childrenVisited) == old(read($Heap, n#47, Node.childrenVisited)));
      invariant $w0 ==> (forall n#48: ref :: S#28[$Box(n#48)] ==> Seq#Equal(read($Heap, n#48, Node.children), old(read($Heap, n#48, Node.children))));
      invariant $w0 ==> (forall n#49: ref :: S#28[$Box(n#49)] && !read($Heap, n#49, Node.marked) ==> unmarkedNodes#37[$Box(n#49)]);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f) || S#28[$Box($o)]);
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant Set#Subset(unmarkedNodes#37, $decr0$init$0) && (Set#Equal(unmarkedNodes#37, $decr0$init$0) ==> Seq#Length(stackNodes#36) <= Seq#Length($decr0$init$1) && (Seq#Length(stackNodes#36) == Seq#Length($decr0$init$1) ==> Seq#Length(read($Heap, t#35, Node.children)) - read($Heap, t#35, Node.childrenVisited) <= $decr0$init$2 && (Seq#Length(read($Heap, t#35, Node.children)) - read($Heap, t#35, Node.childrenVisited) == $decr0$init$2 ==> true)));
      free invariant #cev_save_position(#cev_pc) == #tok$0^98.5;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} root#27 != null && (read($Heap, root#27, Node.marked) ==> true) && (read($Heap, root#27, Node.marked) && S#28[$Box(t#35)] ==> true);
            assume read($Heap, root#27, Node.marked) && S#28[$Box(t#35)] && !Seq#Contains(stackNodes#36, $Box(t#35));
            assert {:subsumption 0} (forall i#38: int, j#39: int :: (0 <= i#38 ==> true) && (0 <= i#38 && i#38 < j#39 ==> true) && (0 <= i#38 && i#38 < j#39 && j#39 < Seq#Length(stackNodes#36) ==> 0 <= i#38 && i#38 < Seq#Length(stackNodes#36) && 0 <= j#39 && j#39 < Seq#Length(stackNodes#36)));
            assume (forall i#38: int, j#39: int :: 0 <= i#38 && i#38 < j#39 && j#39 < Seq#Length(stackNodes#36) ==> $Unbox(Seq#Index(stackNodes#36, i#38)): ref != $Unbox(Seq#Index(stackNodes#36, j#39)): ref);
            assert {:subsumption 0} (forall n#40: ref :: Seq#Contains(stackNodes#36, $Box(n#40)) ==> true);
            assume (forall n#40: ref :: Seq#Contains(stackNodes#36, $Box(n#40)) ==> S#28[$Box(n#40)]);
            assert {:subsumption 0} (forall n#41: ref :: (!Seq#Contains(stackNodes#36, $Box(n#41)) ==> true) && (Seq#Contains(stackNodes#36, $Box(n#41)) || n#41 == t#35 ==> n#41 != null && (read($Heap, n#41, Node.marked) ==> n#41 != null) && (read($Heap, n#41, Node.marked) && 0 <= read($Heap, n#41, Node.childrenVisited) ==> n#41 != null && n#41 != null) && (read($Heap, n#41, Node.marked) && 0 <= read($Heap, n#41, Node.childrenVisited) && read($Heap, n#41, Node.childrenVisited) <= Seq#Length(read($Heap, n#41, Node.children)) ==> (forall j#42: int :: (0 <= j#42 ==> n#41 != null) && (0 <= j#42 && j#42 < read($Heap, n#41, Node.childrenVisited) ==> n#41 != null && 0 <= j#42 && j#42 < Seq#Length(read($Heap, n#41, Node.children)) && ($Unbox(Seq#Index(read($Heap, n#41, Node.children), j#42)): ref != null ==> n#41 != null && 0 <= j#42 && j#42 < Seq#Length(read($Heap, n#41, Node.children)) && $Unbox(Seq#Index(read($Heap, n#41, Node.children), j#42)): ref != null))))));
            assume (forall n#41: ref :: Seq#Contains(stackNodes#36, $Box(n#41)) || n#41 == t#35 ==> read($Heap, n#41, Node.marked) && 0 <= read($Heap, n#41, Node.childrenVisited) && read($Heap, n#41, Node.childrenVisited) <= Seq#Length(read($Heap, n#41, Node.children)) && (forall j#42: int :: 0 <= j#42 && j#42 < read($Heap, n#41, Node.childrenVisited) ==> $Unbox(Seq#Index(read($Heap, n#41, Node.children), j#42)): ref == null || read($Heap, $Unbox(Seq#Index(read($Heap, n#41, Node.children), j#42)): ref, Node.marked)));
            assert {:subsumption 0} (forall n#43: ref :: Seq#Contains(stackNodes#36, $Box(n#43)) ==> n#43 != null && n#43 != null);
            assume (forall n#43: ref :: Seq#Contains(stackNodes#36, $Box(n#43)) ==> read($Heap, n#43, Node.childrenVisited) < Seq#Length(read($Heap, n#43, Node.children)));
            assert {:subsumption 0} (forall j#44: int :: (0 <= j#44 ==> true) && (0 <= j#44 && j#44 + 1 < Seq#Length(stackNodes#36) ==> 0 <= j#44 && j#44 < Seq#Length(stackNodes#36) && $Unbox(Seq#Index(stackNodes#36, j#44)): ref != null && 0 <= j#44 && j#44 < Seq#Length(stackNodes#36) && $Unbox(Seq#Index(stackNodes#36, j#44)): ref != null && 0 <= read($Heap, $Unbox(Seq#Index(stackNodes#36, j#44)): ref, Node.childrenVisited) && read($Heap, $Unbox(Seq#Index(stackNodes#36, j#44)): ref, Node.childrenVisited) < Seq#Length(read($Heap, $Unbox(Seq#Index(stackNodes#36, j#44)): ref, Node.children)) && 0 <= j#44 + 1 && j#44 + 1 < Seq#Length(stackNodes#36)));
            assume (forall j#44: int :: 0 <= j#44 && j#44 + 1 < Seq#Length(stackNodes#36) ==> $Unbox(Seq#Index(read($Heap, $Unbox(Seq#Index(stackNodes#36, j#44)): ref, Node.children), read($Heap, $Unbox(Seq#Index(stackNodes#36, j#44)): ref, Node.childrenVisited))): ref == $Unbox(Seq#Index(stackNodes#36, j#44 + 1)): ref);
            assert {:subsumption 0} 0 < Seq#Length(stackNodes#36) ==> 0 <= Seq#Length(stackNodes#36) - 1 && Seq#Length(stackNodes#36) - 1 < Seq#Length(stackNodes#36) && $Unbox(Seq#Index(stackNodes#36, Seq#Length(stackNodes#36) - 1)): ref != null && 0 <= Seq#Length(stackNodes#36) - 1 && Seq#Length(stackNodes#36) - 1 < Seq#Length(stackNodes#36) && $Unbox(Seq#Index(stackNodes#36, Seq#Length(stackNodes#36) - 1)): ref != null && 0 <= read($Heap, $Unbox(Seq#Index(stackNodes#36, Seq#Length(stackNodes#36) - 1)): ref, Node.childrenVisited) && read($Heap, $Unbox(Seq#Index(stackNodes#36, Seq#Length(stackNodes#36) - 1)): ref, Node.childrenVisited) < Seq#Length(read($Heap, $Unbox(Seq#Index(stackNodes#36, Seq#Length(stackNodes#36) - 1)): ref, Node.children));
            assume 0 < Seq#Length(stackNodes#36) ==> $Unbox(Seq#Index(read($Heap, $Unbox(Seq#Index(stackNodes#36, Seq#Length(stackNodes#36) - 1)): ref, Node.children), read($Heap, $Unbox(Seq#Index(stackNodes#36, Seq#Length(stackNodes#36) - 1)): ref, Node.childrenVisited))): ref == t#35;
            assert {:subsumption 0} (forall n#45: ref :: (S#28[$Box(n#45)] ==> n#45 != null) && (S#28[$Box(n#45)] && read($Heap, n#45, Node.marked) ==> true) && (S#28[$Box(n#45)] && read($Heap, n#45, Node.marked) && !Seq#Contains(stackNodes#36, $Box(n#45)) ==> true) && (S#28[$Box(n#45)] && read($Heap, n#45, Node.marked) && !Seq#Contains(stackNodes#36, $Box(n#45)) && n#45 != t#35 ==> (forall ch#46: ref :: n#45 != null && (Seq#Contains(read($Heap, n#45, Node.children), $Box(ch#46)) ==> true) && (Seq#Contains(read($Heap, n#45, Node.children), $Box(ch#46)) && ch#46 != null ==> ch#46 != null))));
            assume (forall n#45: ref :: S#28[$Box(n#45)] && read($Heap, n#45, Node.marked) && !Seq#Contains(stackNodes#36, $Box(n#45)) && n#45 != t#35 ==> (forall ch#46: ref :: Seq#Contains(read($Heap, n#45, Node.children), $Box(ch#46)) && ch#46 != null ==> read($Heap, ch#46, Node.marked)));
            assert {:subsumption 0} (forall n#47: ref :: (S#28[$Box(n#47)] ==> true) && (S#28[$Box(n#47)] && !Seq#Contains(stackNodes#36, $Box(n#47)) ==> true) && (S#28[$Box(n#47)] && !Seq#Contains(stackNodes#36, $Box(n#47)) && n#47 != t#35 ==> n#47 != null && old(n#47 != null)));
            assume (forall n#47: ref :: S#28[$Box(n#47)] && !Seq#Contains(stackNodes#36, $Box(n#47)) && n#47 != t#35 ==> read($Heap, n#47, Node.childrenVisited) == old(read($Heap, n#47, Node.childrenVisited)));
            assert {:subsumption 0} (forall n#48: ref :: S#28[$Box(n#48)] ==> n#48 != null && old(n#48 != null));
            assume (forall n#48: ref :: S#28[$Box(n#48)] ==> Seq#Equal(read($Heap, n#48, Node.children), old(read($Heap, n#48, Node.children))));
            assert {:subsumption 0} (forall n#49: ref :: (S#28[$Box(n#49)] ==> n#49 != null) && (S#28[$Box(n#49)] && !read($Heap, n#49, Node.marked) ==> true));
            assume (forall n#49: ref :: S#28[$Box(n#49)] && !read($Heap, n#49, Node.marked) ==> unmarkedNodes#37[$Box(n#49)]);
            assert true;
            assert true;
            assert t#35 != null && t#35 != null;
            assume false;
        }

        assert true;
        if (!true)
        {
            break;
        }

        call CevStepEvent(#tok$0^98.5, loop_entered);
        assume {:captureState "SchorrWaite.dfy(98,5): loop entered"} true;
        $decr0$0 := unmarkedNodes#37;
        $decr0$1 := stackNodes#36;
        $decr0$2 := Seq#Length(read($Heap, t#35, Node.children)) - read($Heap, t#35, Node.childrenVisited);
        // ----- if statement ----- SchorrWaite.dfy(123,7)
        call CevEvent(#tok$0^123.7, conditional_moment);
        assert t#35 != null && t#35 != null;
        if (read($Heap, t#35, Node.childrenVisited) == Seq#Length(read($Heap, t#35, Node.children)))
        {
            call CevEvent(#tok$0^123.46, took_then_branch);
            // ----- assignment statement ----- SchorrWaite.dfy(125,27)
            assert t#35 != null;
            assert true;
            assert $_Frame[t#35, Node.childrenVisited];
            $Heap := update($Heap, t#35, Node.childrenVisited, 0);
            assume $IsGoodHeap($Heap);
            assume {:captureState "SchorrWaite.dfy(125,27)"} true;
            call CevUpdateHeap(#tok$0^125.27, #loc.$Heap, $Heap);
            // ----- if statement ----- SchorrWaite.dfy(126,9)
            call CevEvent(#tok$0^126.9, conditional_moment);
            assert true;
            if (Seq#Length(stackNodes#36) == 0)
            {
                call CevEvent(#tok$0^126.32, took_then_branch);
                // ----- return statement ----- SchorrWaite.dfy(127,11)
                return;
            }
            else
            {
                call CevEvent(#tok$0^126.9, took_else_branch);
            }

            // ----- assignment statement ----- SchorrWaite.dfy(129,11)
            assert true;
            assert 0 <= Seq#Length(stackNodes#36) - 1 && Seq#Length(stackNodes#36) - 1 < Seq#Length(stackNodes#36);
            t#35 := $Unbox(Seq#Index(stackNodes#36, Seq#Length(stackNodes#36) - 1)): ref;
            assume {:captureState "SchorrWaite.dfy(129,11)"} true;
            call CevUpdate(#tok$0^129.11, #loc.t#35, t#35);
            // ----- assignment statement ----- SchorrWaite.dfy(130,20)
            assert true;
            assert 0 <= Seq#Length(stackNodes#36) - 1 && Seq#Length(stackNodes#36) - 1 <= Seq#Length(stackNodes#36);
            stackNodes#36 := Seq#Take(stackNodes#36, Seq#Length(stackNodes#36) - 1);
            assume {:captureState "SchorrWaite.dfy(130,20)"} true;
            call CevUpdate(#tok$0^130.20, #loc.stackNodes#36, stackNodes#36);
            // ----- assignment statement ----- SchorrWaite.dfy(131,27)
            assert t#35 != null;
            assert t#35 != null;
            assert $_Frame[t#35, Node.childrenVisited];
            $Heap := update($Heap, t#35, Node.childrenVisited, read($Heap, t#35, Node.childrenVisited) + 1);
            assume $IsGoodHeap($Heap);
            assume {:captureState "SchorrWaite.dfy(131,27)"} true;
            call CevUpdateHeap(#tok$0^131.27, #loc.$Heap, $Heap);
        }
        else
        {
            call CevEvent(#tok$0^132.14, took_else_branch);
            // ----- if statement ----- SchorrWaite.dfy(132,14)
            call CevEvent(#tok$0^132.14, conditional_moment);
            assert t#35 != null && t#35 != null && 0 <= read($Heap, t#35, Node.childrenVisited) && read($Heap, t#35, Node.childrenVisited) < Seq#Length(read($Heap, t#35, Node.children)) && ($Unbox(Seq#Index(read($Heap, t#35, Node.children), read($Heap, t#35, Node.childrenVisited))): ref != null ==> t#35 != null && t#35 != null && 0 <= read($Heap, t#35, Node.childrenVisited) && read($Heap, t#35, Node.childrenVisited) < Seq#Length(read($Heap, t#35, Node.children)) && $Unbox(Seq#Index(read($Heap, t#35, Node.children), read($Heap, t#35, Node.childrenVisited))): ref != null);
            if ($Unbox(Seq#Index(read($Heap, t#35, Node.children), read($Heap, t#35, Node.childrenVisited))): ref == null || read($Heap, $Unbox(Seq#Index(read($Heap, t#35, Node.children), read($Heap, t#35, Node.childrenVisited))): ref, Node.marked))
            {
                call CevEvent(#tok$0^132.97, took_then_branch);
                // ----- assignment statement ----- SchorrWaite.dfy(134,27)
                assert t#35 != null;
                assert t#35 != null;
                assert $_Frame[t#35, Node.childrenVisited];
                $Heap := update($Heap, t#35, Node.childrenVisited, read($Heap, t#35, Node.childrenVisited) + 1);
                assume $IsGoodHeap($Heap);
                assume {:captureState "SchorrWaite.dfy(134,27)"} true;
                call CevUpdateHeap(#tok$0^134.27, #loc.$Heap, $Heap);
            }
            else
            {
                call CevEvent(#tok$0^135.14, took_else_branch);
                // ----- assignment statement ----- SchorrWaite.dfy(137,20)
                assert true;
                assert true;
                stackNodes#36 := Seq#Append(stackNodes#36, Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box(t#35), 1));
                assume {:captureState "SchorrWaite.dfy(137,20)"} true;
                call CevUpdate(#tok$0^137.20, #loc.stackNodes#36, stackNodes#36);
                // ----- assignment statement ----- SchorrWaite.dfy(138,11)
                assert true;
                assert t#35 != null && t#35 != null && 0 <= read($Heap, t#35, Node.childrenVisited) && read($Heap, t#35, Node.childrenVisited) < Seq#Length(read($Heap, t#35, Node.children));
                t#35 := $Unbox(Seq#Index(read($Heap, t#35, Node.children), read($Heap, t#35, Node.childrenVisited))): ref;
                assume {:captureState "SchorrWaite.dfy(138,11)"} true;
                call CevUpdate(#tok$0^138.11, #loc.t#35, t#35);
                // ----- assignment statement ----- SchorrWaite.dfy(139,18)
                assert t#35 != null;
                assert true;
                assert $_Frame[t#35, Node.marked];
                $Heap := update($Heap, t#35, Node.marked, true);
                assume $IsGoodHeap($Heap);
                assume {:captureState "SchorrWaite.dfy(139,18)"} true;
                call CevUpdateHeap(#tok$0^139.18, #loc.$Heap, $Heap);
                // ----- assignment statement ----- SchorrWaite.dfy(140,23)
                assert true;
                assert true;
                unmarkedNodes#37 := Set#Difference(unmarkedNodes#37, Set#UnionOne(Set#Empty(): Set BoxType, $Box(t#35)));
                assume {:captureState "SchorrWaite.dfy(140,23)"} true;
                call CevUpdate(#tok$0^140.23, #loc.unmarkedNodes#37, unmarkedNodes#37);
            }
        }

        assert 0 <= $decr0$2 || (Set#Subset(unmarkedNodes#37, $decr0$0) && !Set#Subset($decr0$0, unmarkedNodes#37)) || Seq#Length(stackNodes#36) < Seq#Length($decr0$1) || Seq#Length(read($Heap, t#35, Node.children)) - read($Heap, t#35, Node.childrenVisited) == $decr0$2;
        assert (Set#Subset(unmarkedNodes#37, $decr0$0) && !Set#Subset($decr0$0, unmarkedNodes#37)) || (Set#Equal(unmarkedNodes#37, $decr0$0) && (Seq#Length(stackNodes#36) < Seq#Length($decr0$1) || (Seq#Length(stackNodes#36) == Seq#Length($decr0$1) && Seq#Length(read($Heap, t#35, Node.children)) - read($Heap, t#35, Node.childrenVisited) < $decr0$2)));
    }

    call CevStepEvent(#tok$0^98.5, loop_exited);
    assume {:captureState "SchorrWaite.dfy(98,5): loop exit"} true;
}



function Main.Reachable($heap: HeapType, this: ref, from#50: ref, to#51: ref, S#52: Set BoxType) : bool;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (3 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref, from#50: ref, to#51: ref, S#52: Set BoxType :: { Main.Reachable($Heap, this, from#50, to#51, S#52) } $IsGoodHeap($Heap) && this != null && !S#52[$Box(null)] ==> Main.Reachable($Heap, this, from#50, to#51, S#52) == (exists via#53: DatatypeType :: Main.ReachableVia($Heap, this, from#50, via#53, to#51, S#52)));

// frame axiom for Main.Reachable
axiom (forall $h0: HeapType, $h1: HeapType, this: ref, from#50: ref, to#51: ref, S#52: Set BoxType :: { $HeapSucc($h0, $h1), Main.Reachable($h1, this, from#50, to#51, S#52) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Main && read($h1, this, alloc) && dtype(this) == class.Main && (from#50 == null || (read($h0, from#50, alloc) && dtype(from#50) == class.Node)) && (from#50 == null || (read($h1, from#50, alloc) && dtype(from#50) == class.Node)) && (to#51 == null || (read($h0, to#51, alloc) && dtype(to#51) == class.Node)) && (to#51 == null || (read($h1, to#51, alloc) && dtype(to#51) == class.Node)) && (forall $t: BoxType :: { S#52[$t] } S#52[$t] ==> $Unbox($t): ref == null || (read($h0, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)) && (forall $t: BoxType :: { S#52[$t] } S#52[$t] ==> $Unbox($t): ref == null || (read($h1, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && S#52[$Box($o)] ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Main.Reachable($h0, this, from#50, to#51, S#52) == Main.Reachable($h1, this, from#50, to#51, S#52));

procedure CheckWellformed$$Main.Reachable(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Main, from#50: ref where from#50 == null || (read($Heap, from#50, alloc) && dtype(from#50) == class.Node), to#51: ref where to#51 == null || (read($Heap, to#51, alloc) && dtype(to#51) == class.Node), S#52: Set BoxType where (forall $t: BoxType :: { S#52[$t] } S#52[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)));
  free requires 0 == $ModuleContextHeight && 3 == $FunctionContextHeight;



implementation CheckWellformed$$Main.Reachable(this: ref, from#50: ref, to#51: ref, S#52: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var via#123: DatatypeType;
  var from#124: ref;
  var via#125: DatatypeType;
  var to#126: ref;
  var S#127: Set BoxType;

    assume !S#52[$Box(null)];
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> S#52[$Box($o)]);
    from#124 := from#50;
    via#125 := via#123;
    to#126 := to#51;
    S#127 := S#52;
    assert !S#127[$Box(null)];
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && S#127[$Box($o)] ==> $_Frame[$o, $f]);
}



function Main.ReachableVia($heap: HeapType, this: ref, from#54: ref, via#55: DatatypeType, to#56: ref, S#57: Set BoxType) : bool;

function Main.ReachableVia#limited($heap: HeapType, this: ref, from#54: ref, via#55: DatatypeType, to#56: ref, S#57: Set BoxType) : bool;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (2 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref, from#54: ref, to#56: ref, S#57: Set BoxType :: { Main.ReachableVia($Heap, this, from#54, #Path.Empty(), to#56, S#57) } $IsGoodHeap($Heap) && this != null && !S#57[$Box(null)] ==> Main.ReachableVia($Heap, this, from#54, #Path.Empty(), to#56, S#57) == (from#54 == to#56));

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (2 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref, prefix#58: DatatypeType, n#59: ref, from#54: ref, to#56: ref, S#57: Set BoxType :: { Main.ReachableVia($Heap, this, from#54, #Path.Extend(prefix#58, n#59), to#56, S#57) } $IsGoodHeap($Heap) && this != null && !S#57[$Box(null)] ==> Main.ReachableVia($Heap, this, from#54, #Path.Extend(prefix#58, n#59), to#56, S#57) == (S#57[$Box(n#59)] && Seq#Contains(read($Heap, n#59, Node.children), $Box(to#56)) && Main.ReachableVia#limited($Heap, this, from#54, prefix#58, n#59, S#57)));

axiom (forall $Heap: HeapType, this: ref, from#54: ref, via#55: DatatypeType, to#56: ref, S#57: Set BoxType :: { Main.ReachableVia($Heap, this, from#54, via#55, to#56, S#57) } Main.ReachableVia($Heap, this, from#54, via#55, to#56, S#57) == Main.ReachableVia#limited($Heap, this, from#54, via#55, to#56, S#57));

// frame axiom for Main.ReachableVia
axiom (forall $h0: HeapType, $h1: HeapType, this: ref, from#54: ref, via#55: DatatypeType, to#56: ref, S#57: Set BoxType :: { $HeapSucc($h0, $h1), Main.ReachableVia($h1, this, from#54, via#55, to#56, S#57) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Main && read($h1, this, alloc) && dtype(this) == class.Main && (from#54 == null || (read($h0, from#54, alloc) && dtype(from#54) == class.Node)) && (from#54 == null || (read($h1, from#54, alloc) && dtype(from#54) == class.Node)) && (to#56 == null || (read($h0, to#56, alloc) && dtype(to#56) == class.Node)) && (to#56 == null || (read($h1, to#56, alloc) && dtype(to#56) == class.Node)) && (forall $t: BoxType :: { S#57[$t] } S#57[$t] ==> $Unbox($t): ref == null || (read($h0, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)) && (forall $t: BoxType :: { S#57[$t] } S#57[$t] ==> $Unbox($t): ref == null || (read($h1, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && S#57[$Box($o)] ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Main.ReachableVia($h0, this, from#54, via#55, to#56, S#57) == Main.ReachableVia($h1, this, from#54, via#55, to#56, S#57));

axiom (forall $h0: HeapType, $h1: HeapType, this: ref, from#54: ref, via#55: DatatypeType, to#56: ref, S#57: Set BoxType :: { $HeapSucc($h0, $h1), Main.ReachableVia#limited($h1, this, from#54, via#55, to#56, S#57) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Main && read($h1, this, alloc) && dtype(this) == class.Main && (from#54 == null || (read($h0, from#54, alloc) && dtype(from#54) == class.Node)) && (from#54 == null || (read($h1, from#54, alloc) && dtype(from#54) == class.Node)) && (to#56 == null || (read($h0, to#56, alloc) && dtype(to#56) == class.Node)) && (to#56 == null || (read($h1, to#56, alloc) && dtype(to#56) == class.Node)) && (forall $t: BoxType :: { S#57[$t] } S#57[$t] ==> $Unbox($t): ref == null || (read($h0, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)) && (forall $t: BoxType :: { S#57[$t] } S#57[$t] ==> $Unbox($t): ref == null || (read($h1, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && S#57[$Box($o)] ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Main.ReachableVia#limited($h0, this, from#54, via#55, to#56, S#57) == Main.ReachableVia#limited($h1, this, from#54, via#55, to#56, S#57));

procedure CheckWellformed$$Main.ReachableVia(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Main, from#54: ref where from#54 == null || (read($Heap, from#54, alloc) && dtype(from#54) == class.Node), via#55: DatatypeType, to#56: ref where to#56 == null || (read($Heap, to#56, alloc) && dtype(to#56) == class.Node), S#57: Set BoxType where (forall $t: BoxType :: { S#57[$t] } S#57[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)));
  free requires 0 == $ModuleContextHeight && 2 == $FunctionContextHeight;



implementation CheckWellformed$$Main.ReachableVia(this: ref, from#54: ref, via#55: DatatypeType, to#56: ref, S#57: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var prefix#58: DatatypeType;
  var n#59: ref;
  var from#128: ref;
  var via#129: DatatypeType;
  var to#130: ref;
  var S#131: Set BoxType;

    assume !S#57[$Box(null)];
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> S#57[$Box($o)]);
    if (via#55 == #Path.Empty())
    {
    }

    if (via#55 == #Path.Extend(prefix#58, n#59))
    {
        if (S#57[$Box(n#59)])
        {
            assert n#59 != null;
            assert $_Frame[n#59, Node.children];
        }

        if (S#57[$Box(n#59)] && Seq#Contains(read($Heap, n#59, Node.children), $Box(to#56)))
        {
            from#128 := from#54;
            via#129 := prefix#58;
            to#130 := n#59;
            S#131 := S#57;
            assert !S#131[$Box(null)];
            assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && S#131[$Box($o)] ==> $_Frame[$o, $f]);
            assert DtRank(via#129) < DtRank(via#55);
        }
    }
}



const unique #tok$0^164.10: $token;

procedure CheckWellformed$$Main.SchorrWaite(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Main, root#60: ref where root#60 == null || (read($Heap, root#60, alloc) && dtype(root#60) == class.Node), S#61: Set BoxType where (forall $t: BoxType :: { S#61[$t] } S#61[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^164.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^164.22: $token;

const unique #loc.root#60: $token;

const unique #tok$0^164.40: $token;

const unique #loc.S#61: $token;

implementation CheckWellformed$$Main.SchorrWaite(this: ref, root#60: ref, S#61: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var n#132: ref;
  var ch#133: ref;
  var n#134: ref;
  var n#135: ref;
  var ch#136: ref;
  var n#137: ref;
  var from#138: ref;
  var to#139: ref;
  var S#140: Set BoxType;
  var n#141: ref;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^164.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^164.22, cev_parameter, #loc.root#60, root#60);
    call CevVarIntro(#tok$0^164.40, cev_parameter, #loc.S#61, S#61);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> S#61[$Box($o)]);
    assume S#61[$Box(root#60)];
    if (S#61[$Box(n#132)])
    {
        if (n#132 != null)
        {
            assert n#132 != null;
            if (Seq#Contains(read($Heap, n#132, Node.children), $Box(ch#133)))
            {
                if (ch#133 != null)
                {
                }
            }
        }
    }

    assume (forall n#62: ref :: S#61[$Box(n#62)] ==> n#62 != null && (forall ch#63: ref :: Seq#Contains(read($Heap, n#62, Node.children), $Box(ch#63)) ==> ch#63 == null || S#61[$Box(ch#63)]));
    if (S#61[$Box(n#134)])
    {
        assert n#134 != null;
        if (!read($Heap, n#134, Node.marked))
        {
            assert n#134 != null;
        }
    }

    assume (forall n#64: ref :: S#61[$Box(n#64)] ==> !read($Heap, n#64, Node.marked) && read($Heap, n#64, Node.childrenVisited) == 0);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    assert root#60 != null;
    assume read($Heap, root#60, Node.marked);
    if (S#61[$Box(n#135)])
    {
        assert n#135 != null;
    }

    if (S#61[$Box(n#135)] && read($Heap, n#135, Node.marked))
    {
        assert n#135 != null;
        if (Seq#Contains(read($Heap, n#135, Node.children), $Box(ch#136)))
        {
        }

        if (Seq#Contains(read($Heap, n#135, Node.children), $Box(ch#136)) && ch#136 != null)
        {
            assert ch#136 != null;
        }
    }

    assume (forall n#65: ref :: S#61[$Box(n#65)] && read($Heap, n#65, Node.marked) ==> (forall ch#66: ref :: Seq#Contains(read($Heap, n#65, Node.children), $Box(ch#66)) && ch#66 != null ==> read($Heap, ch#66, Node.marked)));
    if (S#61[$Box(n#137)])
    {
        assert n#137 != null;
    }

    if (S#61[$Box(n#137)] && read($Heap, n#137, Node.marked))
    {
        from#138 := root#60;
        to#139 := n#137;
        S#140 := S#61;
        assert !S#140[$Box(null)];
    }

    assume (forall n#67: ref :: S#61[$Box(n#67)] && read($Heap, n#67, Node.marked) ==> old(Main.Reachable($Heap, this, root#60, n#67, S#61)));
    if (S#61[$Box(n#141)])
    {
        assert n#141 != null;
        assert n#141 != null;
        if (read($Heap, n#141, Node.childrenVisited) == old(read($Heap, n#141, Node.childrenVisited)))
        {
            assert n#141 != null;
            assert n#141 != null;
        }
    }

    assume (forall n#68: ref :: S#61[$Box(n#68)] ==> read($Heap, n#68, Node.childrenVisited) == old(read($Heap, n#68, Node.childrenVisited)) && Seq#Equal(read($Heap, n#68, Node.children), old(read($Heap, n#68, Node.children))));
}



procedure Main.SchorrWaite(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Main, root#60: ref where root#60 == null || (read($Heap, root#60, alloc) && dtype(root#60) == class.Node), S#61: Set BoxType where (forall $t: BoxType :: { S#61[$t] } S#61[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires S#61[$Box(root#60)];
  requires (forall n#62: ref :: S#61[$Box(n#62)] ==> n#62 != null && (forall ch#63: ref :: Seq#Contains(read($Heap, n#62, Node.children), $Box(ch#63)) ==> ch#63 == null || S#61[$Box(ch#63)]));
  requires (forall n#64: ref :: S#61[$Box(n#64)] ==> !read($Heap, n#64, Node.marked) && read($Heap, n#64, Node.childrenVisited) == 0);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^164.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures read($Heap, root#60, Node.marked);
  ensures (forall n#65: ref :: S#61[$Box(n#65)] && read($Heap, n#65, Node.marked) ==> (forall ch#66: ref :: Seq#Contains(read($Heap, n#65, Node.children), $Box(ch#66)) && ch#66 != null ==> read($Heap, ch#66, Node.marked)));
  ensures (forall n#67: ref :: S#61[$Box(n#67)] && read($Heap, n#67, Node.marked) ==> old(Main.Reachable($Heap, this, root#60, n#67, S#61)));
  ensures (forall n#68: ref :: S#61[$Box(n#68)] ==> read($Heap, n#68, Node.childrenVisited) == old(read($Heap, n#68, Node.childrenVisited)) && Seq#Equal(read($Heap, n#68, Node.children), old(read($Heap, n#68, Node.children))));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || S#61[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.t#69: $token;

const unique #tok$0^183.9: $token;

const unique #loc.p#70: $token;

const unique #tok$0^184.9: $token;

const unique #loc.path#71: $token;

const unique #tok$0^185.15: $token;

const unique #tok$0^186.14: $token;

const unique #tok$0^187.20: $token;

const unique #loc.stackNodes#72: $token;

const unique #tok$0^188.15: $token;

const unique #loc.unmarkedNodes#73: $token;

const unique #tok$0^189.15: $token;

const unique #tok$0^190.5: $token;

const unique #tok$0^230.7: $token;

const unique #tok$0^230.46: $token;

const unique #tok$0^232.27: $token;

const unique #tok$0^233.9: $token;

const unique #tok$0^233.24: $token;

const unique #loc.oldP#92: $token;

const unique #tok$0^236.13: $token;

const unique #tok$0^238.20: $token;

const unique #tok$0^239.11: $token;

const unique #tok$0^240.11: $token;

const unique #tok$0^241.20: $token;

const unique #tok$0^242.27: $token;

const unique #tok$0^243.14: $token;

const unique #tok$0^245.14: $token;

const unique #tok$0^245.97: $token;

const unique #tok$0^247.27: $token;

const unique #tok$0^249.14: $token;

const unique #loc.newT#93: $token;

const unique #tok$0^252.13: $token;

const unique #tok$0^254.20: $token;

const unique #tok$0^255.11: $token;

const unique #tok$0^256.20: $token;

const unique #tok$0^257.14: $token;

const unique #tok$0^258.11: $token;

const unique #tok$0^259.18: $token;

const unique #tok$0^260.24: $token;

const unique #tok$0^261.23: $token;

implementation Main.SchorrWaite(this: ref, root#60: ref, S#61: Set BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var t#69: ref where (t#69 == null || (read($Heap, t#69, alloc) && dtype(t#69) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.t#69, t#69);
  var p#70: ref where (p#70 == null || (read($Heap, p#70, alloc) && dtype(p#70) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.p#70, p#70);
  var path#71: DatatypeType where #cev_var_update(#cev_pc, cev_local, #loc.path#71, path#71);
  var stackNodes#72: Seq BoxType where #cev_var_update(#cev_pc, cev_local, #loc.stackNodes#72, stackNodes#72);
  var unmarkedNodes#73: Set BoxType where (forall $t: BoxType :: { unmarkedNodes#73[$t] } unmarkedNodes#73[$t] ==> $Unbox($t): ref == null || (read($Heap, $Unbox($t): ref, alloc) && dtype($Unbox($t): ref) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.unmarkedNodes#73, unmarkedNodes#73);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: Set BoxType;
  var $decr0$init$1: Seq BoxType;
  var $decr0$init$2: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: Set BoxType;
  var $decr0$1: Seq BoxType;
  var $decr0$2: int;
  var oldP#92: ref where (oldP#92 == null || (read($Heap, oldP#92, alloc) && dtype(oldP#92) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.oldP#92, oldP#92);
  var newT#93: ref where (newT#93 == null || (read($Heap, newT#93, alloc) && dtype(newT#93) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.newT#93, newT#93);

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^164.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^164.22, cev_parameter, #loc.root#60, root#60);
    call CevVarIntro(#tok$0^164.40, cev_parameter, #loc.S#61, S#61);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> S#61[$Box($o)]);
    // ----- var-declaration statement ----- SchorrWaite.dfy(183,9)
    assert true;
    assert true;
    t#69 := root#60;
    assume {:captureState "SchorrWaite.dfy(183,9)"} true;
    call CevVarIntro(#tok$0^183.9, cev_local, #loc.t#69, t#69);
    // ----- var-declaration statement ----- SchorrWaite.dfy(184,9)
    assert true;
    assert true;
    p#70 := null;
    assume {:captureState "SchorrWaite.dfy(184,9)"} true;
    call CevVarIntro(#tok$0^184.9, cev_local, #loc.p#70, p#70);
    // ----- var-declaration statement ----- SchorrWaite.dfy(185,15)
    assert true;
    assert true;
    path#71 := #Path.Empty();
    assume {:captureState "SchorrWaite.dfy(185,15)"} true;
    call CevVarIntro(#tok$0^185.15, cev_local, #loc.path#71, path#71);
    // ----- assignment statement ----- SchorrWaite.dfy(186,14)
    assert t#69 != null;
    assert true;
    assert $_Frame[t#69, Node.marked];
    $Heap := update($Heap, t#69, Node.marked, true);
    assume $IsGoodHeap($Heap);
    assume {:captureState "SchorrWaite.dfy(186,14)"} true;
    call CevUpdateHeap(#tok$0^186.14, #loc.$Heap, $Heap);
    // ----- assignment statement ----- SchorrWaite.dfy(187,20)
    assert t#69 != null;
    assert true;
    assert $_Frame[t#69, Node.pathFromRoot];
    $Heap := update($Heap, t#69, Node.pathFromRoot, path#71);
    assume $IsGoodHeap($Heap);
    assume {:captureState "SchorrWaite.dfy(187,20)"} true;
    call CevUpdateHeap(#tok$0^187.20, #loc.$Heap, $Heap);
    // ----- var-declaration statement ----- SchorrWaite.dfy(188,15)
    assert true;
    assert true;
    stackNodes#72 := Seq#Empty(): Seq BoxType;
    assume {:captureState "SchorrWaite.dfy(188,15)"} true;
    call CevVarIntro(#tok$0^188.15, cev_local, #loc.stackNodes#72, stackNodes#72);
    // ----- var-declaration statement ----- SchorrWaite.dfy(189,15)
    assert true;
    assert true;
    unmarkedNodes#73 := Set#Difference(S#61, Set#UnionOne(Set#Empty(): Set BoxType, $Box(t#69)));
    assume {:captureState "SchorrWaite.dfy(189,15)"} true;
    call CevVarIntro(#tok$0^189.15, cev_local, #loc.unmarkedNodes#73, unmarkedNodes#73);
    // ----- while statement ----- SchorrWaite.dfy(190,5)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := unmarkedNodes#73;
    $decr0$init$1 := stackNodes#72;
    $decr0$init$2 := Seq#Length(read($Heap, t#69, Node.children)) - read($Heap, t#69, Node.childrenVisited);
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^190.5);
    while (true)
      invariant $w0 ==> read($Heap, root#60, Node.marked);
      invariant $w0 ==> t#69 != null;
      invariant $w0 ==> S#61[$Box(t#69)];
      invariant $w0 ==> !Seq#Contains(stackNodes#72, $Box(t#69));
 //     free invariant $w0 ==> read($Heap, root#60, Node.marked) && t#69 != null && S#61[$Box(t#69)] && !Seq#Contains(stackNodes#72, $Box(t#69));
      invariant $w0 ==> (Seq#Length(stackNodes#72) == 0 ==> p#70 == null);
      invariant $w0 ==> (Seq#Length(stackNodes#72) == 0 <== p#70 == null);
      invariant $w0 ==> 0 < Seq#Length(stackNodes#72) ==> p#70 == $Unbox(Seq#Index(stackNodes#72, Seq#Length(stackNodes#72) - 1)): ref;
      invariant $w0 ==> (forall i#74: int, j#75: int :: 0 <= i#74 && i#74 < j#75 && j#75 < Seq#Length(stackNodes#72) ==> $Unbox(Seq#Index(stackNodes#72, i#74)): ref != $Unbox(Seq#Index(stackNodes#72, j#75)): ref);
      invariant $w0 ==> (forall n#76: ref :: Seq#Contains(stackNodes#72, $Box(n#76)) ==> S#61[$Box(n#76)]);
      invariant $w0 ==> (forall n#77: ref :: Seq#Contains(stackNodes#72, $Box(n#77))
                                         ==>
                                             read($Heap, n#77, Node.marked));
      invariant $w0 ==> (forall n#77: ref :: Seq#Contains(stackNodes#72, $Box(n#77))
                                         ==>
                                             0 <= read($Heap, n#77, Node.childrenVisited));
      invariant $w0 ==> (forall n#77: ref :: Seq#Contains(stackNodes#72, $Box(n#77))
                                         ==>
                                             read($Heap, n#77, Node.childrenVisited) <= Seq#Length(read($Heap, n#77, Node.children)));
      invariant $w0 ==> (forall n#77: ref :: Seq#Contains(stackNodes#72, $Box(n#77))
                                         ==>
                                             (forall j#78: int :: 0 <= j#78 && j#78 < read($Heap, n#77, Node.childrenVisited) ==> $Unbox(Seq#Index(read($Heap, n#77, Node.children), j#78)): ref == null || read($Heap, $Unbox(Seq#Index(read($Heap, n#77, Node.children), j#78)): ref, Node.marked)));
      invariant $w0 ==> read($Heap, t#69, Node.marked);
      invariant $w0 ==>                      0 <= read($Heap, t#69, Node.childrenVisited);
      invariant $w0 ==>                      read($Heap, t#69, Node.childrenVisited) <= Seq#Length(read($Heap, t#69, Node.children));
      invariant $w0 ==> (forall j#78: int :: 0 <= j#78 && j#78 < read($Heap, t#69, Node.childrenVisited) ==> $Unbox(Seq#Index(read($Heap, t#69, Node.children), j#78)): ref == null || read($Heap, $Unbox(Seq#Index(read($Heap, t#69, Node.children), j#78)): ref, Node.marked));

      invariant $w0 ==> (forall n#79: ref :: Seq#Contains(stackNodes#72, $Box(n#79)) ==> read($Heap, n#79, Node.childrenVisited) < Seq#Length(read($Heap, n#79, Node.children)));

      invariant $w0 ==> (forall n#80: ref :: S#61[$Box(n#80)] && read($Heap, n#80, Node.marked) && !Seq#Contains(stackNodes#72, $Box(n#80)) && n#80 != t#69 ==> (forall ch#81: ref :: Seq#Contains(read($Heap, n#80, Node.children), $Box(ch#81)) && ch#81 != null ==> read($Heap, ch#81, Node.marked)));

      invariant $w0 ==> (forall n#82: ref :: S#61[$Box(n#82)] && !Seq#Contains(stackNodes#72, $Box(n#82)) && n#82 != t#69 ==> read($Heap, n#82, Node.childrenVisited) == old(read($Heap, n#82, Node.childrenVisited)));

      invariant $w0 ==> (forall n#83: ref :: S#61[$Box(n#83)] ==> Seq#Contains(stackNodes#72, $Box(n#83)) || Seq#Equal(read($Heap, n#83, Node.children), old(read($Heap, n#83, Node.children))));

      invariant $w0 ==> (forall n#84: ref :: Seq#Contains(stackNodes#72, $Box(n#84)) ==> Seq#Length(read($Heap, n#84, Node.children)) == old(Seq#Length(read($Heap, n#84, Node.children))) && (forall j#85: int :: 0 <= j#85 && j#85 < Seq#Length(read($Heap, n#84, Node.children)) ==> j#85 == read($Heap, n#84, Node.childrenVisited) || $Unbox(Seq#Index(read($Heap, n#84, Node.children), j#85)): ref == old($Unbox(Seq#Index(read($Heap, n#84, Node.children), j#85)): ref)));

      invariant $w0 ==> old(Main.ReachableVia($Heap, this, root#60, path#71, t#69, S#61));

      invariant $w0 ==> (forall n#86: ref, pth#87: DatatypeType :: S#61[$Box(n#86)] && read($Heap, n#86, Node.marked) && pth#87 == read($Heap, n#86, Node.pathFromRoot) ==> old(Main.ReachableVia($Heap, this, root#60, pth#87, n#86, S#61)));

      invariant $w0 ==> (forall n#88: ref :: S#61[$Box(n#88)] && read($Heap, n#88, Node.marked) ==> old(Main.Reachable($Heap, this, root#60, n#88, S#61)));

      invariant $w0 ==> 0 < Seq#Length(stackNodes#72) ==> $Unbox(Seq#Index(read($Heap, $Unbox(Seq#Index(stackNodes#72, 0)): ref, Node.children), read($Heap, $Unbox(Seq#Index(stackNodes#72, 0)): ref, Node.childrenVisited))): ref == null;

      invariant $w0 ==> (forall k#89: int :: 0 < k#89 && k#89 < Seq#Length(stackNodes#72) ==> $Unbox(Seq#Index(read($Heap, $Unbox(Seq#Index(stackNodes#72, k#89)): ref, Node.children), read($Heap, $Unbox(Seq#Index(stackNodes#72, k#89)): ref, Node.childrenVisited))): ref == $Unbox(Seq#Index(stackNodes#72, k#89 - 1)): ref);

      invariant $w0 ==> (forall k#90: int :: 0 <= k#90 && k#90 + 1 < Seq#Length(stackNodes#72) ==> $Unbox(Seq#Index(old(read($Heap, $Unbox(Seq#Index(stackNodes#72, k#90)): ref, Node.children)), read($Heap, $Unbox(Seq#Index(stackNodes#72, k#90)): ref, Node.childrenVisited))): ref == $Unbox(Seq#Index(stackNodes#72, k#90 + 1)): ref);

      invariant $w0 ==> 0 < Seq#Length(stackNodes#72) ==> $Unbox(Seq#Index(old(read($Heap, $Unbox(Seq#Index(stackNodes#72, Seq#Length(stackNodes#72) - 1)): ref, Node.children)), read($Heap, $Unbox(Seq#Index(stackNodes#72, Seq#Length(stackNodes#72) - 1)): ref, Node.childrenVisited))): ref == t#69;

      invariant $w0 ==> (forall n#91: ref :: S#61[$Box(n#91)] && !read($Heap, n#91, Node.marked) ==> unmarkedNodes#73[$Box(n#91)]);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f) || S#61[$Box($o)]);
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant Set#Subset(unmarkedNodes#73, $decr0$init$0) && (Set#Equal(unmarkedNodes#73, $decr0$init$0) ==> Seq#Length(stackNodes#72) <= Seq#Length($decr0$init$1) && (Seq#Length(stackNodes#72) == Seq#Length($decr0$init$1) ==> Seq#Length(read($Heap, t#69, Node.children)) - read($Heap, t#69, Node.childrenVisited) <= $decr0$init$2 && (Seq#Length(read($Heap, t#69, Node.children)) - read($Heap, t#69, Node.childrenVisited) == $decr0$init$2 ==> true)));
      free invariant #cev_save_position(#cev_pc) == #tok$0^190.5;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} root#60 != null && (read($Heap, root#60, Node.marked) ==> true) && (read($Heap, root#60, Node.marked) && t#69 != null ==> true) && (read($Heap, root#60, Node.marked) && t#69 != null && S#61[$Box(t#69)] ==> true);
            assume read($Heap, root#60, Node.marked) && t#69 != null && S#61[$Box(t#69)] && !Seq#Contains(stackNodes#72, $Box(t#69));
            assert {:subsumption 0} true;
            assume Seq#Length(stackNodes#72) == 0 <==> p#70 == null;
            assert {:subsumption 0} 0 < Seq#Length(stackNodes#72) ==> 0 <= Seq#Length(stackNodes#72) - 1 && Seq#Length(stackNodes#72) - 1 < Seq#Length(stackNodes#72);
            assume 0 < Seq#Length(stackNodes#72) ==> p#70 == $Unbox(Seq#Index(stackNodes#72, Seq#Length(stackNodes#72) - 1)): ref;
            assert {:subsumption 0} (forall i#74: int, j#75: int :: (0 <= i#74 ==> true) && (0 <= i#74 && i#74 < j#75 ==> true) && (0 <= i#74 && i#74 < j#75 && j#75 < Seq#Length(stackNodes#72) ==> 0 <= i#74 && i#74 < Seq#Length(stackNodes#72) && 0 <= j#75 && j#75 < Seq#Length(stackNodes#72)));
            assume (forall i#74: int, j#75: int :: 0 <= i#74 && i#74 < j#75 && j#75 < Seq#Length(stackNodes#72) ==> $Unbox(Seq#Index(stackNodes#72, i#74)): ref != $Unbox(Seq#Index(stackNodes#72, j#75)): ref);
            assert {:subsumption 0} (forall n#76: ref :: Seq#Contains(stackNodes#72, $Box(n#76)) ==> true);
            assume (forall n#76: ref :: Seq#Contains(stackNodes#72, $Box(n#76)) ==> S#61[$Box(n#76)]);
            assert {:subsumption 0} (forall n#77: ref :: (!Seq#Contains(stackNodes#72, $Box(n#77)) ==> true) && (Seq#Contains(stackNodes#72, $Box(n#77)) || n#77 == t#69 ==> n#77 != null && (read($Heap, n#77, Node.marked) ==> n#77 != null) && (read($Heap, n#77, Node.marked) && 0 <= read($Heap, n#77, Node.childrenVisited) ==> n#77 != null && n#77 != null) && (read($Heap, n#77, Node.marked) && 0 <= read($Heap, n#77, Node.childrenVisited) && read($Heap, n#77, Node.childrenVisited) <= Seq#Length(read($Heap, n#77, Node.children)) ==> (forall j#78: int :: (0 <= j#78 ==> n#77 != null) && (0 <= j#78 && j#78 < read($Heap, n#77, Node.childrenVisited) ==> n#77 != null && 0 <= j#78 && j#78 < Seq#Length(read($Heap, n#77, Node.children)) && ($Unbox(Seq#Index(read($Heap, n#77, Node.children), j#78)): ref != null ==> n#77 != null && 0 <= j#78 && j#78 < Seq#Length(read($Heap, n#77, Node.children)) && $Unbox(Seq#Index(read($Heap, n#77, Node.children), j#78)): ref != null))))));
            assume (forall n#77: ref :: Seq#Contains(stackNodes#72, $Box(n#77)) || n#77 == t#69 ==> read($Heap, n#77, Node.marked) && 0 <= read($Heap, n#77, Node.childrenVisited) && read($Heap, n#77, Node.childrenVisited) <= Seq#Length(read($Heap, n#77, Node.children)) && (forall j#78: int :: 0 <= j#78 && j#78 < read($Heap, n#77, Node.childrenVisited) ==> $Unbox(Seq#Index(read($Heap, n#77, Node.children), j#78)): ref == null || read($Heap, $Unbox(Seq#Index(read($Heap, n#77, Node.children), j#78)): ref, Node.marked)));
            assert {:subsumption 0} (forall n#79: ref :: Seq#Contains(stackNodes#72, $Box(n#79)) ==> n#79 != null && n#79 != null);
            assume (forall n#79: ref :: Seq#Contains(stackNodes#72, $Box(n#79)) ==> read($Heap, n#79, Node.childrenVisited) < Seq#Length(read($Heap, n#79, Node.children)));
            assert {:subsumption 0} (forall n#80: ref :: (S#61[$Box(n#80)] ==> n#80 != null) && (S#61[$Box(n#80)] && read($Heap, n#80, Node.marked) ==> true) && (S#61[$Box(n#80)] && read($Heap, n#80, Node.marked) && !Seq#Contains(stackNodes#72, $Box(n#80)) ==> true) && (S#61[$Box(n#80)] && read($Heap, n#80, Node.marked) && !Seq#Contains(stackNodes#72, $Box(n#80)) && n#80 != t#69 ==> (forall ch#81: ref :: n#80 != null && (Seq#Contains(read($Heap, n#80, Node.children), $Box(ch#81)) ==> true) && (Seq#Contains(read($Heap, n#80, Node.children), $Box(ch#81)) && ch#81 != null ==> ch#81 != null))));
            assume (forall n#80: ref :: S#61[$Box(n#80)] && read($Heap, n#80, Node.marked) && !Seq#Contains(stackNodes#72, $Box(n#80)) && n#80 != t#69 ==> (forall ch#81: ref :: Seq#Contains(read($Heap, n#80, Node.children), $Box(ch#81)) && ch#81 != null ==> read($Heap, ch#81, Node.marked)));
            assert {:subsumption 0} (forall n#82: ref :: (S#61[$Box(n#82)] ==> true) && (S#61[$Box(n#82)] && !Seq#Contains(stackNodes#72, $Box(n#82)) ==> true) && (S#61[$Box(n#82)] && !Seq#Contains(stackNodes#72, $Box(n#82)) && n#82 != t#69 ==> n#82 != null && old(n#82 != null)));
            assume (forall n#82: ref :: S#61[$Box(n#82)] && !Seq#Contains(stackNodes#72, $Box(n#82)) && n#82 != t#69 ==> read($Heap, n#82, Node.childrenVisited) == old(read($Heap, n#82, Node.childrenVisited)));
            assert {:subsumption 0} (forall n#83: ref :: S#61[$Box(n#83)] ==> !Seq#Contains(stackNodes#72, $Box(n#83)) ==> n#83 != null && old(n#83 != null));
            assume (forall n#83: ref :: S#61[$Box(n#83)] ==> Seq#Contains(stackNodes#72, $Box(n#83)) || Seq#Equal(read($Heap, n#83, Node.children), old(read($Heap, n#83, Node.children))));
            assert {:subsumption 0} (forall n#84: ref :: Seq#Contains(stackNodes#72, $Box(n#84)) ==> n#84 != null && old(n#84 != null) && (Seq#Length(read($Heap, n#84, Node.children)) == old(Seq#Length(read($Heap, n#84, Node.children))) ==> (forall j#85: int :: (0 <= j#85 ==> n#84 != null) && (0 <= j#85 && j#85 < Seq#Length(read($Heap, n#84, Node.children)) ==> n#84 != null && (j#85 != read($Heap, n#84, Node.childrenVisited) ==> n#84 != null && 0 <= j#85 && j#85 < Seq#Length(read($Heap, n#84, Node.children)) && old(n#84 != null && 0 <= j#85 && j#85 < Seq#Length(read($Heap, n#84, Node.children))))))));
            assume (forall n#84: ref :: Seq#Contains(stackNodes#72, $Box(n#84)) ==> Seq#Length(read($Heap, n#84, Node.children)) == old(Seq#Length(read($Heap, n#84, Node.children))) && (forall j#85: int :: 0 <= j#85 && j#85 < Seq#Length(read($Heap, n#84, Node.children)) ==> j#85 == read($Heap, n#84, Node.childrenVisited) || $Unbox(Seq#Index(read($Heap, n#84, Node.children), j#85)): ref == old($Unbox(Seq#Index(read($Heap, n#84, Node.children), j#85)): ref)));
            assert {:subsumption 0} old(!S#61[$Box(null)]);
            assume old(Main.ReachableVia($Heap, this, root#60, path#71, t#69, S#61));
            assert {:subsumption 0} (forall n#86: ref, pth#87: DatatypeType :: (S#61[$Box(n#86)] ==> n#86 != null) && (S#61[$Box(n#86)] && read($Heap, n#86, Node.marked) ==> n#86 != null) && (S#61[$Box(n#86)] && read($Heap, n#86, Node.marked) && pth#87 == read($Heap, n#86, Node.pathFromRoot) ==> old(!S#61[$Box(null)])));
            assume (forall n#86: ref, pth#87: DatatypeType :: S#61[$Box(n#86)] && read($Heap, n#86, Node.marked) && pth#87 == read($Heap, n#86, Node.pathFromRoot) ==> old(Main.ReachableVia($Heap, this, root#60, pth#87, n#86, S#61)));
            assert {:subsumption 0} (forall n#88: ref :: (S#61[$Box(n#88)] ==> n#88 != null) && (S#61[$Box(n#88)] && read($Heap, n#88, Node.marked) ==> old(!S#61[$Box(null)])));
            assume (forall n#88: ref :: S#61[$Box(n#88)] && read($Heap, n#88, Node.marked) ==> old(Main.Reachable($Heap, this, root#60, n#88, S#61)));
            assert {:subsumption 0} 0 < Seq#Length(stackNodes#72) ==> 0 <= 0 && 0 < Seq#Length(stackNodes#72) && $Unbox(Seq#Index(stackNodes#72, 0)): ref != null && 0 <= 0 && 0 < Seq#Length(stackNodes#72) && $Unbox(Seq#Index(stackNodes#72, 0)): ref != null && 0 <= read($Heap, $Unbox(Seq#Index(stackNodes#72, 0)): ref, Node.childrenVisited) && read($Heap, $Unbox(Seq#Index(stackNodes#72, 0)): ref, Node.childrenVisited) < Seq#Length(read($Heap, $Unbox(Seq#Index(stackNodes#72, 0)): ref, Node.children));
            assume 0 < Seq#Length(stackNodes#72) ==> $Unbox(Seq#Index(read($Heap, $Unbox(Seq#Index(stackNodes#72, 0)): ref, Node.children), read($Heap, $Unbox(Seq#Index(stackNodes#72, 0)): ref, Node.childrenVisited))): ref == null;
            assert {:subsumption 0} (forall k#89: int :: (0 < k#89 ==> true) && (0 < k#89 && k#89 < Seq#Length(stackNodes#72) ==> 0 <= k#89 && k#89 < Seq#Length(stackNodes#72) && $Unbox(Seq#Index(stackNodes#72, k#89)): ref != null && 0 <= k#89 && k#89 < Seq#Length(stackNodes#72) && $Unbox(Seq#Index(stackNodes#72, k#89)): ref != null && 0 <= read($Heap, $Unbox(Seq#Index(stackNodes#72, k#89)): ref, Node.childrenVisited) && read($Heap, $Unbox(Seq#Index(stackNodes#72, k#89)): ref, Node.childrenVisited) < Seq#Length(read($Heap, $Unbox(Seq#Index(stackNodes#72, k#89)): ref, Node.children)) && 0 <= k#89 - 1 && k#89 - 1 < Seq#Length(stackNodes#72)));
            assume (forall k#89: int :: 0 < k#89 && k#89 < Seq#Length(stackNodes#72) ==> $Unbox(Seq#Index(read($Heap, $Unbox(Seq#Index(stackNodes#72, k#89)): ref, Node.children), read($Heap, $Unbox(Seq#Index(stackNodes#72, k#89)): ref, Node.childrenVisited))): ref == $Unbox(Seq#Index(stackNodes#72, k#89 - 1)): ref);
            assert {:subsumption 0} (forall k#90: int :: (0 <= k#90 ==> true) && (0 <= k#90 && k#90 + 1 < Seq#Length(stackNodes#72) ==> old(0 <= k#90 && k#90 < Seq#Length(stackNodes#72) && $Unbox(Seq#Index(stackNodes#72, k#90)): ref != null) && 0 <= k#90 && k#90 < Seq#Length(stackNodes#72) && $Unbox(Seq#Index(stackNodes#72, k#90)): ref != null && 0 <= read($Heap, $Unbox(Seq#Index(stackNodes#72, k#90)): ref, Node.childrenVisited) && read($Heap, $Unbox(Seq#Index(stackNodes#72, k#90)): ref, Node.childrenVisited) < Seq#Length(old(read($Heap, $Unbox(Seq#Index(stackNodes#72, k#90)): ref, Node.children))) && 0 <= k#90 + 1 && k#90 + 1 < Seq#Length(stackNodes#72)));
            assume (forall k#90: int :: 0 <= k#90 && k#90 + 1 < Seq#Length(stackNodes#72) ==> $Unbox(Seq#Index(old(read($Heap, $Unbox(Seq#Index(stackNodes#72, k#90)): ref, Node.children)), read($Heap, $Unbox(Seq#Index(stackNodes#72, k#90)): ref, Node.childrenVisited))): ref == $Unbox(Seq#Index(stackNodes#72, k#90 + 1)): ref);
            assert {:subsumption 0} 0 < Seq#Length(stackNodes#72) ==> old(0 <= Seq#Length(stackNodes#72) - 1 && Seq#Length(stackNodes#72) - 1 < Seq#Length(stackNodes#72) && $Unbox(Seq#Index(stackNodes#72, Seq#Length(stackNodes#72) - 1)): ref != null) && 0 <= Seq#Length(stackNodes#72) - 1 && Seq#Length(stackNodes#72) - 1 < Seq#Length(stackNodes#72) && $Unbox(Seq#Index(stackNodes#72, Seq#Length(stackNodes#72) - 1)): ref != null && 0 <= read($Heap, $Unbox(Seq#Index(stackNodes#72, Seq#Length(stackNodes#72) - 1)): ref, Node.childrenVisited) && read($Heap, $Unbox(Seq#Index(stackNodes#72, Seq#Length(stackNodes#72) - 1)): ref, Node.childrenVisited) < Seq#Length(old(read($Heap, $Unbox(Seq#Index(stackNodes#72, Seq#Length(stackNodes#72) - 1)): ref, Node.children)));
            assume 0 < Seq#Length(stackNodes#72) ==> $Unbox(Seq#Index(old(read($Heap, $Unbox(Seq#Index(stackNodes#72, Seq#Length(stackNodes#72) - 1)): ref, Node.children)), read($Heap, $Unbox(Seq#Index(stackNodes#72, Seq#Length(stackNodes#72) - 1)): ref, Node.childrenVisited))): ref == t#69;
            assert {:subsumption 0} (forall n#91: ref :: (S#61[$Box(n#91)] ==> n#91 != null) && (S#61[$Box(n#91)] && !read($Heap, n#91, Node.marked) ==> true));
            assume (forall n#91: ref :: S#61[$Box(n#91)] && !read($Heap, n#91, Node.marked) ==> unmarkedNodes#73[$Box(n#91)]);
            assert true;
            assert true;
            assert t#69 != null && t#69 != null;
            assume false;
        }

        assert true;
        if (!true)
        {
            break;
        }

        call CevStepEvent(#tok$0^190.5, loop_entered);
        assume {:captureState "SchorrWaite.dfy(190,5): loop entered"} true;
        $decr0$0 := unmarkedNodes#73;
        $decr0$1 := stackNodes#72;
        $decr0$2 := Seq#Length(read($Heap, t#69, Node.children)) - read($Heap, t#69, Node.childrenVisited);
        // ----- if statement ----- SchorrWaite.dfy(230,7)
        call CevEvent(#tok$0^230.7, conditional_moment);
        assert t#69 != null && t#69 != null;
        if (read($Heap, t#69, Node.childrenVisited) == Seq#Length(read($Heap, t#69, Node.children)))
        {
            call CevEvent(#tok$0^230.46, took_then_branch);
            // ----- assignment statement ----- SchorrWaite.dfy(232,27)
            assert t#69 != null;
            assert true;
            assert $_Frame[t#69, Node.childrenVisited];
            $Heap := update($Heap, t#69, Node.childrenVisited, 0);
            assume $IsGoodHeap($Heap);
            assume {:captureState "SchorrWaite.dfy(232,27)"} true;
            call CevUpdateHeap(#tok$0^232.27, #loc.$Heap, $Heap);
            // ----- if statement ----- SchorrWaite.dfy(233,9)
            call CevEvent(#tok$0^233.9, conditional_moment);
            assert true;
            if (p#70 == null)
            {
                call CevEvent(#tok$0^233.24, took_then_branch);
                // ----- return statement ----- SchorrWaite.dfy(234,11)
                return;
            }
            else
            {
                call CevEvent(#tok$0^233.9, took_else_branch);
            }

            // ----- var-declaration statement ----- SchorrWaite.dfy(236,13)
            assert true;
            assert p#70 != null && p#70 != null && 0 <= read($Heap, p#70, Node.childrenVisited) && read($Heap, p#70, Node.childrenVisited) < Seq#Length(read($Heap, p#70, Node.children));
            oldP#92 := $Unbox(Seq#Index(read($Heap, p#70, Node.children), read($Heap, p#70, Node.childrenVisited))): ref;
            assume {:captureState "SchorrWaite.dfy(236,13)"} true;
            call CevVarIntro(#tok$0^236.13, cev_local, #loc.oldP#92, oldP#92);
            // ----- assignment statement ----- SchorrWaite.dfy(238,20)
            assert p#70 != null;
            assert p#70 != null && p#70 != null && 0 <= read($Heap, p#70, Node.childrenVisited) && read($Heap, p#70, Node.childrenVisited) <= Seq#Length(read($Heap, p#70, Node.children)) && p#70 != null && p#70 != null && 0 <= read($Heap, p#70, Node.childrenVisited) + 1 && read($Heap, p#70, Node.childrenVisited) + 1 <= Seq#Length(read($Heap, p#70, Node.children));
            assert $_Frame[p#70, Node.children];
            $Heap := update($Heap, p#70, Node.children, Seq#Append(Seq#Append(Seq#Take(read($Heap, p#70, Node.children), read($Heap, p#70, Node.childrenVisited)), Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box(t#69), 1)), Seq#Drop(read($Heap, p#70, Node.children), read($Heap, p#70, Node.childrenVisited) + 1)));
            assume $IsGoodHeap($Heap);
            assume {:captureState "SchorrWaite.dfy(238,20)"} true;
            call CevUpdateHeap(#tok$0^238.20, #loc.$Heap, $Heap);
            // ----- assignment statement ----- SchorrWaite.dfy(239,11)
            assert true;
            assert true;
            t#69 := p#70;
            assume {:captureState "SchorrWaite.dfy(239,11)"} true;
            call CevUpdate(#tok$0^239.11, #loc.t#69, t#69);
            // ----- assignment statement ----- SchorrWaite.dfy(240,11)
            assert true;
            assert true;
            p#70 := oldP#92;
            assume {:captureState "SchorrWaite.dfy(240,11)"} true;
            call CevUpdate(#tok$0^240.11, #loc.p#70, p#70);
            // ----- assignment statement ----- SchorrWaite.dfy(241,20)
            assert true;
            assert 0 <= Seq#Length(stackNodes#72) - 1 && Seq#Length(stackNodes#72) - 1 <= Seq#Length(stackNodes#72);
            stackNodes#72 := Seq#Take(stackNodes#72, Seq#Length(stackNodes#72) - 1);
            assume {:captureState "SchorrWaite.dfy(241,20)"} true;
            call CevUpdate(#tok$0^241.20, #loc.stackNodes#72, stackNodes#72);
            // ----- assignment statement ----- SchorrWaite.dfy(242,27)
            assert t#69 != null;
            assert t#69 != null;
            assert $_Frame[t#69, Node.childrenVisited];
            $Heap := update($Heap, t#69, Node.childrenVisited, read($Heap, t#69, Node.childrenVisited) + 1);
            assume $IsGoodHeap($Heap);
            assume {:captureState "SchorrWaite.dfy(242,27)"} true;
            call CevUpdateHeap(#tok$0^242.27, #loc.$Heap, $Heap);
            // ----- assignment statement ----- SchorrWaite.dfy(243,14)
            assert true;
            assert t#69 != null;
            path#71 := read($Heap, t#69, Node.pathFromRoot);
            assume {:captureState "SchorrWaite.dfy(243,14)"} true;
            call CevUpdate(#tok$0^243.14, #loc.path#71, path#71);
        }
        else
        {
            call CevEvent(#tok$0^245.14, took_else_branch);
            // ----- if statement ----- SchorrWaite.dfy(245,14)
            call CevEvent(#tok$0^245.14, conditional_moment);
            assert t#69 != null && t#69 != null && 0 <= read($Heap, t#69, Node.childrenVisited) && read($Heap, t#69, Node.childrenVisited) < Seq#Length(read($Heap, t#69, Node.children)) && ($Unbox(Seq#Index(read($Heap, t#69, Node.children), read($Heap, t#69, Node.childrenVisited))): ref != null ==> t#69 != null && t#69 != null && 0 <= read($Heap, t#69, Node.childrenVisited) && read($Heap, t#69, Node.childrenVisited) < Seq#Length(read($Heap, t#69, Node.children)) && $Unbox(Seq#Index(read($Heap, t#69, Node.children), read($Heap, t#69, Node.childrenVisited))): ref != null);
            if ($Unbox(Seq#Index(read($Heap, t#69, Node.children), read($Heap, t#69, Node.childrenVisited))): ref == null || read($Heap, $Unbox(Seq#Index(read($Heap, t#69, Node.children), read($Heap, t#69, Node.childrenVisited))): ref, Node.marked))
            {
                call CevEvent(#tok$0^245.97, took_then_branch);
                // ----- assignment statement ----- SchorrWaite.dfy(247,27)
                assert t#69 != null;
                assert t#69 != null;
                assert $_Frame[t#69, Node.childrenVisited];
                $Heap := update($Heap, t#69, Node.childrenVisited, read($Heap, t#69, Node.childrenVisited) + 1);
                assume $IsGoodHeap($Heap);
                assume {:captureState "SchorrWaite.dfy(247,27)"} true;
                call CevUpdateHeap(#tok$0^247.27, #loc.$Heap, $Heap);
            }
            else
            {
                call CevEvent(#tok$0^249.14, took_else_branch);
                // ----- var-declaration statement ----- SchorrWaite.dfy(252,13)
                assert true;
                assert t#69 != null && t#69 != null && 0 <= read($Heap, t#69, Node.childrenVisited) && read($Heap, t#69, Node.childrenVisited) < Seq#Length(read($Heap, t#69, Node.children));
                newT#93 := $Unbox(Seq#Index(read($Heap, t#69, Node.children), read($Heap, t#69, Node.childrenVisited))): ref;
                assume {:captureState "SchorrWaite.dfy(252,13)"} true;
                call CevVarIntro(#tok$0^252.13, cev_local, #loc.newT#93, newT#93);
                // ----- assignment statement ----- SchorrWaite.dfy(254,20)
                assert t#69 != null;
                assert t#69 != null && t#69 != null && 0 <= read($Heap, t#69, Node.childrenVisited) && read($Heap, t#69, Node.childrenVisited) <= Seq#Length(read($Heap, t#69, Node.children)) && t#69 != null && t#69 != null && 0 <= read($Heap, t#69, Node.childrenVisited) + 1 && read($Heap, t#69, Node.childrenVisited) + 1 <= Seq#Length(read($Heap, t#69, Node.children));
                assert $_Frame[t#69, Node.children];
                $Heap := update($Heap, t#69, Node.children, Seq#Append(Seq#Append(Seq#Take(read($Heap, t#69, Node.children), read($Heap, t#69, Node.childrenVisited)), Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box(p#70), 1)), Seq#Drop(read($Heap, t#69, Node.children), read($Heap, t#69, Node.childrenVisited) + 1)));
                assume $IsGoodHeap($Heap);
                assume {:captureState "SchorrWaite.dfy(254,20)"} true;
                call CevUpdateHeap(#tok$0^254.20, #loc.$Heap, $Heap);
                // ----- assignment statement ----- SchorrWaite.dfy(255,11)
                assert true;
                assert true;
                p#70 := t#69;
                assume {:captureState "SchorrWaite.dfy(255,11)"} true;
                call CevUpdate(#tok$0^255.11, #loc.p#70, p#70);
                // ----- assignment statement ----- SchorrWaite.dfy(256,20)
                assert true;
                assert true;
                stackNodes#72 := Seq#Append(stackNodes#72, Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box(t#69), 1));
                assume {:captureState "SchorrWaite.dfy(256,20)"} true;
                call CevUpdate(#tok$0^256.20, #loc.stackNodes#72, stackNodes#72);
                // ----- assignment statement ----- SchorrWaite.dfy(257,14)
                assert true;
                assert true;
                path#71 := #Path.Extend(path#71, t#69);
                assume {:captureState "SchorrWaite.dfy(257,14)"} true;
                call CevUpdate(#tok$0^257.14, #loc.path#71, path#71);
                // ----- assignment statement ----- SchorrWaite.dfy(258,11)
                assert true;
                assert true;
                t#69 := newT#93;
                assume {:captureState "SchorrWaite.dfy(258,11)"} true;
                call CevUpdate(#tok$0^258.11, #loc.t#69, t#69);
                // ----- assignment statement ----- SchorrWaite.dfy(259,18)
                assert t#69 != null;
                assert true;
                assert $_Frame[t#69, Node.marked];
                $Heap := update($Heap, t#69, Node.marked, true);
                assume $IsGoodHeap($Heap);
                assume {:captureState "SchorrWaite.dfy(259,18)"} true;
                call CevUpdateHeap(#tok$0^259.18, #loc.$Heap, $Heap);
                // ----- assignment statement ----- SchorrWaite.dfy(260,24)
                assert t#69 != null;
                assert true;
                assert $_Frame[t#69, Node.pathFromRoot];
                $Heap := update($Heap, t#69, Node.pathFromRoot, path#71);
                assume $IsGoodHeap($Heap);
                assume {:captureState "SchorrWaite.dfy(260,24)"} true;
                call CevUpdateHeap(#tok$0^260.24, #loc.$Heap, $Heap);
                // ----- assignment statement ----- SchorrWaite.dfy(261,23)
                assert true;
                assert true;
                unmarkedNodes#73 := Set#Difference(unmarkedNodes#73, Set#UnionOne(Set#Empty(): Set BoxType, $Box(t#69)));
                assume {:captureState "SchorrWaite.dfy(261,23)"} true;
                call CevUpdate(#tok$0^261.23, #loc.unmarkedNodes#73, unmarkedNodes#73);
            }
        }

        assert 0 <= $decr0$2 || (Set#Subset(unmarkedNodes#73, $decr0$0) && !Set#Subset($decr0$0, unmarkedNodes#73)) || Seq#Length(stackNodes#72) < Seq#Length($decr0$1) || Seq#Length(read($Heap, t#69, Node.children)) - read($Heap, t#69, Node.childrenVisited) == $decr0$2;
        assert (Set#Subset(unmarkedNodes#73, $decr0$0) && !Set#Subset($decr0$0, unmarkedNodes#73)) || (Set#Equal(unmarkedNodes#73, $decr0$0) && (Seq#Length(stackNodes#72) < Seq#Length($decr0$1) || (Seq#Length(stackNodes#72) == Seq#Length($decr0$1) && Seq#Length(read($Heap, t#69, Node.children)) - read($Heap, t#69, Node.childrenVisited) < $decr0$2)));
    }

    call CevStepEvent(#tok$0^190.5, loop_exited);
    assume {:captureState "SchorrWaite.dfy(190,5): loop exit"} true;
}



function #Path.Empty() : DatatypeType;

const unique ##Path.Empty: DtCtorId;

axiom DatatypeCtorId(#Path.Empty()) == ##Path.Empty;

function #Path.Extend(DatatypeType, ref) : DatatypeType;

const unique ##Path.Extend: DtCtorId;

axiom (forall a0: DatatypeType, a1: ref :: DatatypeCtorId(#Path.Extend(a0, a1)) == ##Path.Extend);

function ##Path.Extend#0(DatatypeType) : DatatypeType;

axiom (forall a0: DatatypeType, a1: ref :: ##Path.Extend#0(#Path.Extend(a0, a1)) == a0);

axiom (forall a0: DatatypeType, a1: ref :: DtRank(a0) < DtRank(#Path.Extend(a0, a1)));

function ##Path.Extend#1(DatatypeType) : ref;

axiom (forall a0: DatatypeType, a1: ref :: ##Path.Extend#1(#Path.Extend(a0, a1)) == a1);

const unique class._default: ClassName;
