// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: dafny1\Substitution.dfy /print:\Users\philipp\Desktop\boogie\boogie-k-induction-benchmarks\benchmarks\Substitution.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

function #List.Nil() : DatatypeType;

const unique ##List.Nil: DtCtorId;

axiom DatatypeCtorId(#List.Nil()) == ##List.Nil;

function #List.Cons(DatatypeType, DatatypeType) : DatatypeType;

const unique ##List.Cons: DtCtorId;

axiom (forall a0: DatatypeType, a1: DatatypeType :: DatatypeCtorId(#List.Cons(a0, a1)) == ##List.Cons);

function ##List.Cons#0(DatatypeType) : DatatypeType;

axiom (forall a0: DatatypeType, a1: DatatypeType :: ##List.Cons#0(#List.Cons(a0, a1)) == a0);

axiom (forall a0: DatatypeType, a1: DatatypeType :: DtRank(a0) < DtRank(#List.Cons(a0, a1)));

function ##List.Cons#1(DatatypeType) : DatatypeType;

axiom (forall a0: DatatypeType, a1: DatatypeType :: ##List.Cons#1(#List.Cons(a0, a1)) == a1);

axiom (forall a0: DatatypeType, a1: DatatypeType :: DtRank(a1) < DtRank(#List.Cons(a0, a1)));

function #Expr.Const(int) : DatatypeType;

const unique ##Expr.Const: DtCtorId;

axiom (forall a0: int :: DatatypeCtorId(#Expr.Const(a0)) == ##Expr.Const);

function ##Expr.Const#0(DatatypeType) : int;

axiom (forall a0: int :: ##Expr.Const#0(#Expr.Const(a0)) == a0);

function #Expr.Var(int) : DatatypeType;

const unique ##Expr.Var: DtCtorId;

axiom (forall a0: int :: DatatypeCtorId(#Expr.Var(a0)) == ##Expr.Var);

function ##Expr.Var#0(DatatypeType) : int;

axiom (forall a0: int :: ##Expr.Var#0(#Expr.Var(a0)) == a0);

function #Expr.Nary(int, DatatypeType) : DatatypeType;

const unique ##Expr.Nary: DtCtorId;

axiom (forall a0: int, a1: DatatypeType :: DatatypeCtorId(#Expr.Nary(a0, a1)) == ##Expr.Nary);

function ##Expr.Nary#0(DatatypeType) : int;

axiom (forall a0: int, a1: DatatypeType :: ##Expr.Nary#0(#Expr.Nary(a0, a1)) == a0);

function ##Expr.Nary#1(DatatypeType) : DatatypeType;

axiom (forall a0: int, a1: DatatypeType :: ##Expr.Nary#1(#Expr.Nary(a0, a1)) == a1);

axiom (forall a0: int, a1: DatatypeType :: DtRank(a1) < DtRank(#Expr.Nary(a0, a1)));

function #Expression.Const(int) : DatatypeType;

const unique ##Expression.Const: DtCtorId;

axiom (forall a0: int :: DatatypeCtorId(#Expression.Const(a0)) == ##Expression.Const);

function ##Expression.Const#0(DatatypeType) : int;

axiom (forall a0: int :: ##Expression.Const#0(#Expression.Const(a0)) == a0);

function #Expression.Var(int) : DatatypeType;

const unique ##Expression.Var: DtCtorId;

axiom (forall a0: int :: DatatypeCtorId(#Expression.Var(a0)) == ##Expression.Var);

function ##Expression.Var#0(DatatypeType) : int;

axiom (forall a0: int :: ##Expression.Var#0(#Expression.Var(a0)) == a0);

function #Expression.Nary(int, Seq BoxType) : DatatypeType;

const unique ##Expression.Nary: DtCtorId;

axiom (forall a0: int, a1: Seq BoxType :: DatatypeCtorId(#Expression.Nary(a0, a1)) == ##Expression.Nary);

function ##Expression.Nary#0(DatatypeType) : int;

axiom (forall a0: int, a1: Seq BoxType :: ##Expression.Nary#0(#Expression.Nary(a0, a1)) == a0);

function ##Expression.Nary#1(DatatypeType) : Seq BoxType;

axiom (forall a0: int, a1: Seq BoxType :: ##Expression.Nary#1(#Expression.Nary(a0, a1)) == a1);

axiom (forall a0: int, a1: Seq BoxType, i: int :: 0 <= i && i < Seq#Length(a1) ==> DtRank($Unbox(Seq#Index(a1, i)): DatatypeType) < DtRank(#Expression.Nary(a0, a1)));

const unique class._default: ClassName;

function _default.Subst($heap: HeapType, e#6: DatatypeType, v#7: int, val#8: int) : DatatypeType;

function _default.Subst#limited($heap: HeapType, e#6: DatatypeType, v#7: int, val#8: int) : DatatypeType;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (0 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, c#9: int, v#7: int, val#8: int :: { _default.Subst($Heap, #Expr.Const(c#9), v#7, val#8) } $IsGoodHeap($Heap) ==> _default.Subst($Heap, #Expr.Const(c#9), v#7, val#8) == #Expr.Const(c#9));

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (0 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, x#10: int, v#7: int, val#8: int :: { _default.Subst($Heap, #Expr.Var(x#10), v#7, val#8) } $IsGoodHeap($Heap) ==> _default.Subst($Heap, #Expr.Var(x#10), v#7, val#8) == $ite(x#10 == v#7, #Expr.Const(val#8), #Expr.Var(x#10)));

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (0 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, op#11: int, args#12: DatatypeType, v#7: int, val#8: int :: { _default.Subst($Heap, #Expr.Nary(op#11, args#12), v#7, val#8) } $IsGoodHeap($Heap) ==> _default.Subst($Heap, #Expr.Nary(op#11, args#12), v#7, val#8) == #Expr.Nary(op#11, _default.SubstList#limited($Heap, args#12, v#7, val#8)));

axiom (forall $Heap: HeapType, e#6: DatatypeType, v#7: int, val#8: int :: { _default.Subst($Heap, e#6, v#7, val#8) } _default.Subst($Heap, e#6, v#7, val#8) == _default.Subst#limited($Heap, e#6, v#7, val#8));

// frame axiom for _default.Subst
axiom (forall $h0: HeapType, $h1: HeapType, e#6: DatatypeType, v#7: int, val#8: int :: { $HeapSucc($h0, $h1), _default.Subst($h1, e#6, v#7, val#8) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: false ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> _default.Subst($h0, e#6, v#7, val#8) == _default.Subst($h1, e#6, v#7, val#8));

axiom (forall $h0: HeapType, $h1: HeapType, e#6: DatatypeType, v#7: int, val#8: int :: { $HeapSucc($h0, $h1), _default.Subst#limited($h1, e#6, v#7, val#8) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: false ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> _default.Subst#limited($h0, e#6, v#7, val#8) == _default.Subst#limited($h1, e#6, v#7, val#8));

procedure CheckWellformed$$_default.Subst(e#6: DatatypeType, v#7: int, val#8: int);
  free requires 0 == $ModuleContextHeight && 0 == $FunctionContextHeight;



implementation CheckWellformed$$_default.Subst(e#6: DatatypeType, v#7: int, val#8: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var c#9: int;
  var x#10: int;
  var op#11: int;
  var args#12: DatatypeType;
  var l#65: DatatypeType;
  var v#66: int;
  var val#67: int;

    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    if (e#6 == #Expr.Const(c#9))
    {
    }

    if (e#6 == #Expr.Var(x#10))
    {
        if (x#10 == v#7)
        {
        }
        else
        {
        }
    }

    if (e#6 == #Expr.Nary(op#11, args#12))
    {
        l#65 := args#12;
        v#66 := v#7;
        val#67 := val#8;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assert 0 <= v#7 || DtRank(l#65) < DtRank(e#6) || v#66 == v#7;
        assert 0 <= val#8 || DtRank(l#65) < DtRank(e#6) || v#66 < v#7 || val#67 == val#8;
        assert DtRank(l#65) < DtRank(e#6) || (DtRank(l#65) == DtRank(e#6) && (v#66 < v#7 || (v#66 == v#7 && val#67 < val#8)));
    }
}



function _default.SubstList($heap: HeapType, l#13: DatatypeType, v#14: int, val#15: int) : DatatypeType;

function _default.SubstList#limited($heap: HeapType, l#13: DatatypeType, v#14: int, val#15: int) : DatatypeType;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (0 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, v#14: int, val#15: int :: { _default.SubstList($Heap, #List.Nil(), v#14, val#15) } $IsGoodHeap($Heap) ==> _default.SubstList($Heap, #List.Nil(), v#14, val#15) == #List.Nil());

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (0 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, e#16: DatatypeType, tail#17: DatatypeType, v#14: int, val#15: int :: { _default.SubstList($Heap, #List.Cons(e#16, tail#17), v#14, val#15) } $IsGoodHeap($Heap) ==> _default.SubstList($Heap, #List.Cons(e#16, tail#17), v#14, val#15) == #List.Cons(_default.Subst#limited($Heap, e#16, v#14, val#15), _default.SubstList#limited($Heap, tail#17, v#14, val#15)));

axiom (forall $Heap: HeapType, l#13: DatatypeType, v#14: int, val#15: int :: { _default.SubstList($Heap, l#13, v#14, val#15) } _default.SubstList($Heap, l#13, v#14, val#15) == _default.SubstList#limited($Heap, l#13, v#14, val#15));

// frame axiom for _default.SubstList
axiom (forall $h0: HeapType, $h1: HeapType, l#13: DatatypeType, v#14: int, val#15: int :: { $HeapSucc($h0, $h1), _default.SubstList($h1, l#13, v#14, val#15) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: false ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> _default.SubstList($h0, l#13, v#14, val#15) == _default.SubstList($h1, l#13, v#14, val#15));

axiom (forall $h0: HeapType, $h1: HeapType, l#13: DatatypeType, v#14: int, val#15: int :: { $HeapSucc($h0, $h1), _default.SubstList#limited($h1, l#13, v#14, val#15) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: false ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> _default.SubstList#limited($h0, l#13, v#14, val#15) == _default.SubstList#limited($h1, l#13, v#14, val#15));

procedure CheckWellformed$$_default.SubstList(l#13: DatatypeType, v#14: int, val#15: int);
  free requires 0 == $ModuleContextHeight && 0 == $FunctionContextHeight;



implementation CheckWellformed$$_default.SubstList(l#13: DatatypeType, v#14: int, val#15: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var e#16: DatatypeType;
  var tail#17: DatatypeType;
  var e#68: DatatypeType;
  var v#69: int;
  var val#70: int;
  var l#71: DatatypeType;
  var v#72: int;
  var val#73: int;

    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    if (l#13 == #List.Nil())
    {
    }

    if (l#13 == #List.Cons(e#16, tail#17))
    {
        e#68 := e#16;
        v#69 := v#14;
        val#70 := val#15;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assert 0 <= v#14 || DtRank(e#68) < DtRank(l#13) || v#69 == v#14;
        assert 0 <= val#15 || DtRank(e#68) < DtRank(l#13) || v#69 < v#14 || val#70 == val#15;
        assert DtRank(e#68) < DtRank(l#13) || (DtRank(e#68) == DtRank(l#13) && (v#69 < v#14 || (v#69 == v#14 && val#70 < val#15)));
        l#71 := tail#17;
        v#72 := v#14;
        val#73 := val#15;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assert 0 <= v#14 || DtRank(l#71) < DtRank(l#13) || v#72 == v#14;
        assert 0 <= val#15 || DtRank(l#71) < DtRank(l#13) || v#72 < v#14 || val#73 == val#15;
        assert DtRank(l#71) < DtRank(l#13) || (DtRank(l#71) == DtRank(l#13) && (v#72 < v#14 || (v#72 == v#14 && val#73 < val#15)));
    }
}



const unique xxxxxxxxxfile: $token;

axiom $file_name_is(0, xxxxxxxxxfile);

const unique #tok$0^27.21: $token;

procedure CheckWellformed$$_default.Theorem(e#18: DatatypeType, v#19: int, val#20: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^27.21;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^27.29: $token;

const unique #loc.e#18: $token;

const unique #tok$0^27.38: $token;

const unique #loc.v#19: $token;

const unique #tok$0^27.46: $token;

const unique #loc.val#20: $token;

implementation CheckWellformed$$_default.Theorem(e#18: DatatypeType, v#19: int, val#20: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var e#74: DatatypeType;
  var v#75: int;
  var val#76: int;
  var e#77: DatatypeType;
  var v#78: int;
  var val#79: int;
  var e#80: DatatypeType;
  var v#81: int;
  var val#82: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^27.29, cev_parameter, #loc.e#18, e#18);
    call CevVarIntro(#tok$0^27.38, cev_parameter, #loc.v#19, v#19);
    call CevVarIntro(#tok$0^27.46, cev_parameter, #loc.val#20, val#20);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    e#74 := e#18;
    v#75 := v#19;
    val#76 := val#20;
    e#77 := _default.Subst($Heap, e#18, v#19, val#20);
    v#78 := v#19;
    val#79 := val#20;
    e#80 := e#18;
    v#81 := v#19;
    val#82 := val#20;
    assume _default.Subst($Heap, _default.Subst($Heap, e#18, v#19, val#20), v#19, val#20) == _default.Subst($Heap, e#18, v#19, val#20);
}



procedure _default.Theorem(e#18: DatatypeType, v#19: int, val#20: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^27.21;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures _default.Subst($Heap, _default.Subst($Heap, e#18, v#19, val#20), v#19, val#20) == _default.Subst($Heap, e#18, v#19, val#20);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^34.7: $token;

implementation _default.Theorem(e#18: DatatypeType, v#19: int, val#20: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var op#23: int;
  var args#24: DatatypeType;
  var l#83: DatatypeType;
  var v#84: int;
  var val#85: int;
  var x#22: int;
  var c#21: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^27.29, cev_parameter, #loc.e#18, e#18);
    call CevVarIntro(#tok$0^27.38, cev_parameter, #loc.v#19, v#19);
    call CevVarIntro(#tok$0^27.46, cev_parameter, #loc.val#20, val#20);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assert true;
    havoc op#23, args#24;
    havoc x#22;
    havoc c#21;
    if (e#18 == #Expr.Const(c#21))
    {
    }
    else if (e#18 == #Expr.Var(x#22))
    {
    }
    else if (e#18 == #Expr.Nary(op#23, args#24))
    {
        // ----- call statement ----- dafny1\Substitution.dfy(34,7)
        assert true;
        l#83 := args#24;
        assert true;
        v#84 := v#19;
        assert true;
        val#85 := val#20;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assert 0 <= v#19 || DtRank(l#83) < DtRank(e#18) || v#84 == v#19;
        assert 0 <= val#20 || DtRank(l#83) < DtRank(e#18) || v#84 < v#19 || val#85 == val#20;
        assert DtRank(l#83) < DtRank(e#18) || (DtRank(l#83) == DtRank(e#18) && (v#84 < v#19 || (v#84 == v#19 && val#85 < val#20)));
        call _default.Lemma(l#83, v#84, val#85);
        call CevStep(#tok$0^34.7);
        assume {:captureState "dafny1\Substitution.dfy(34,7)"} true;
    }
    else
    {
        assume false;
    }
}



const unique #tok$0^38.21: $token;

procedure CheckWellformed$$_default.Lemma(l#25: DatatypeType, v#26: int, val#27: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^38.21;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^38.27: $token;

const unique #loc.l#25: $token;

const unique #tok$0^38.36: $token;

const unique #loc.v#26: $token;

const unique #tok$0^38.44: $token;

const unique #loc.val#27: $token;

implementation CheckWellformed$$_default.Lemma(l#25: DatatypeType, v#26: int, val#27: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var l#86: DatatypeType;
  var v#87: int;
  var val#88: int;
  var l#89: DatatypeType;
  var v#90: int;
  var val#91: int;
  var l#92: DatatypeType;
  var v#93: int;
  var val#94: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^38.27, cev_parameter, #loc.l#25, l#25);
    call CevVarIntro(#tok$0^38.36, cev_parameter, #loc.v#26, v#26);
    call CevVarIntro(#tok$0^38.44, cev_parameter, #loc.val#27, val#27);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    l#86 := l#25;
    v#87 := v#26;
    val#88 := val#27;
    l#89 := _default.SubstList($Heap, l#25, v#26, val#27);
    v#90 := v#26;
    val#91 := val#27;
    l#92 := l#25;
    v#93 := v#26;
    val#94 := val#27;
    assume _default.SubstList($Heap, _default.SubstList($Heap, l#25, v#26, val#27), v#26, val#27) == _default.SubstList($Heap, l#25, v#26, val#27);
}



procedure _default.Lemma(l#25: DatatypeType, v#26: int, val#27: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^38.21;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures _default.SubstList($Heap, _default.SubstList($Heap, l#25, v#26, val#27), v#26, val#27) == _default.SubstList($Heap, l#25, v#26, val#27);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^44.7: $token;

const unique #tok$0^45.7: $token;

implementation _default.Lemma(l#25: DatatypeType, v#26: int, val#27: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var e#28: DatatypeType;
  var tail#29: DatatypeType;
  var e#95: DatatypeType;
  var v#96: int;
  var val#97: int;
  var l#98: DatatypeType;
  var v#99: int;
  var val#100: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^38.27, cev_parameter, #loc.l#25, l#25);
    call CevVarIntro(#tok$0^38.36, cev_parameter, #loc.v#26, v#26);
    call CevVarIntro(#tok$0^38.44, cev_parameter, #loc.val#27, val#27);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assert true;
    havoc e#28, tail#29;
    if (l#25 == #List.Nil())
    {
    }
    else if (l#25 == #List.Cons(e#28, tail#29))
    {
        // ----- call statement ----- dafny1\Substitution.dfy(44,7)
        assert true;
        e#95 := e#28;
        assert true;
        v#96 := v#26;
        assert true;
        val#97 := val#27;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assert 0 <= v#26 || DtRank(e#95) < DtRank(l#25) || v#96 == v#26;
        assert 0 <= val#27 || DtRank(e#95) < DtRank(l#25) || v#96 < v#26 || val#97 == val#27;
        assert DtRank(e#95) < DtRank(l#25) || (DtRank(e#95) == DtRank(l#25) && (v#96 < v#26 || (v#96 == v#26 && val#97 < val#27)));
        call _default.Theorem(e#95, v#96, val#97);
        call CevStep(#tok$0^44.7);
        assume {:captureState "dafny1\Substitution.dfy(44,7)"} true;
        // ----- call statement ----- dafny1\Substitution.dfy(45,7)
        assert true;
        l#98 := tail#29;
        assert true;
        v#99 := v#26;
        assert true;
        val#100 := val#27;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assert 0 <= v#26 || DtRank(l#98) < DtRank(l#25) || v#99 == v#26;
        assert 0 <= val#27 || DtRank(l#98) < DtRank(l#25) || v#99 < v#26 || val#100 == val#27;
        assert DtRank(l#98) < DtRank(l#25) || (DtRank(l#98) == DtRank(l#25) && (v#99 < v#26 || (v#99 == v#26 && val#100 < val#27)));
        call _default.Lemma(l#98, v#99, val#100);
        call CevStep(#tok$0^45.7);
        assume {:captureState "dafny1\Substitution.dfy(45,7)"} true;
    }
    else
    {
        assume false;
    }
}



function _default.Substitute($heap: HeapType, e#34: DatatypeType, v#35: int, val#36: int) : DatatypeType;

function _default.Substitute#limited($heap: HeapType, e#34: DatatypeType, v#35: int, val#36: int) : DatatypeType;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (2 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, c#37: int, v#35: int, val#36: int :: { _default.Substitute($Heap, #Expression.Const(c#37), v#35, val#36) } $IsGoodHeap($Heap) ==> _default.Substitute($Heap, #Expression.Const(c#37), v#35, val#36) == #Expression.Const(c#37));

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (2 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, x#38: int, v#35: int, val#36: int :: { _default.Substitute($Heap, #Expression.Var(x#38), v#35, val#36) } $IsGoodHeap($Heap) ==> _default.Substitute($Heap, #Expression.Var(x#38), v#35, val#36) == $ite(x#38 == v#35, #Expression.Const(val#36), #Expression.Var(x#38)));

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (2 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, op#39: int, args#40: Seq BoxType, v#35: int, val#36: int :: { _default.Substitute($Heap, #Expression.Nary(op#39, args#40), v#35, val#36) } $IsGoodHeap($Heap) ==> _default.Substitute($Heap, #Expression.Nary(op#39, args#40), v#35, val#36) == #Expression.Nary(op#39, _default.SubstSeq#limited($Heap, #Expression.Nary(op#39, args#40), args#40, v#35, val#36)));

axiom (forall $Heap: HeapType, e#34: DatatypeType, v#35: int, val#36: int :: { _default.Substitute($Heap, e#34, v#35, val#36) } _default.Substitute($Heap, e#34, v#35, val#36) == _default.Substitute#limited($Heap, e#34, v#35, val#36));

// frame axiom for _default.Substitute
axiom (forall $h0: HeapType, $h1: HeapType, e#34: DatatypeType, v#35: int, val#36: int :: { $HeapSucc($h0, $h1), _default.Substitute($h1, e#34, v#35, val#36) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: false ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> _default.Substitute($h0, e#34, v#35, val#36) == _default.Substitute($h1, e#34, v#35, val#36));

axiom (forall $h0: HeapType, $h1: HeapType, e#34: DatatypeType, v#35: int, val#36: int :: { $HeapSucc($h0, $h1), _default.Substitute#limited($h1, e#34, v#35, val#36) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: false ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> _default.Substitute#limited($h0, e#34, v#35, val#36) == _default.Substitute#limited($h1, e#34, v#35, val#36));

procedure CheckWellformed$$_default.Substitute(e#34: DatatypeType, v#35: int, val#36: int);
  free requires 0 == $ModuleContextHeight && 2 == $FunctionContextHeight;



implementation CheckWellformed$$_default.Substitute(e#34: DatatypeType, v#35: int, val#36: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var c#37: int;
  var x#38: int;
  var op#39: int;
  var args#40: Seq BoxType;
  var parent#101: DatatypeType;
  var q#102: Seq BoxType;
  var v#103: int;
  var val#104: int;

    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    if (e#34 == #Expression.Const(c#37))
    {
    }

    if (e#34 == #Expression.Var(x#38))
    {
        if (x#38 == v#35)
        {
        }
        else
        {
        }
    }

    if (e#34 == #Expression.Nary(op#39, args#40))
    {
        parent#101 := e#34;
        q#102 := args#40;
        v#103 := v#35;
        val#104 := val#36;
        assert (forall a#45: DatatypeType :: Seq#Contains(q#102, $Box(a#45)) ==> DtRank(a#45) < DtRank(parent#101));
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assert DtRank(parent#101) < DtRank(e#34) || (DtRank(parent#101) == DtRank(e#34) && !false && true);
    }
}



function _default.SubstSeq($heap: HeapType, parent#41: DatatypeType, q#42: Seq BoxType, v#43: int, val#44: int) : Seq BoxType;

function _default.SubstSeq#limited($heap: HeapType, parent#41: DatatypeType, q#42: Seq BoxType, v#43: int, val#44: int) : Seq BoxType;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (2 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, parent#41: DatatypeType, q#42: Seq BoxType, v#43: int, val#44: int :: { _default.SubstSeq($Heap, parent#41, q#42, v#43, val#44) } $IsGoodHeap($Heap) && (forall a#45: DatatypeType :: Seq#Contains(q#42, $Box(a#45)) ==> DtRank(a#45) < DtRank(parent#41)) ==> _default.SubstSeq($Heap, parent#41, q#42, v#43, val#44) == $ite(Seq#Equal(q#42, Seq#Empty(): Seq BoxType), Seq#Empty(): Seq BoxType, Seq#Append(_default.SubstSeq#limited($Heap, parent#41, Seq#Take(q#42, Seq#Length(q#42) - 1), v#43, val#44), Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box(_default.Substitute#limited($Heap, $Unbox(Seq#Index(q#42, Seq#Length(q#42) - 1)): DatatypeType, v#43, val#44)), 1))));

axiom (forall $Heap: HeapType, parent#41: DatatypeType, q#42: Seq BoxType, v#43: int, val#44: int :: { _default.SubstSeq($Heap, parent#41, q#42, v#43, val#44) } _default.SubstSeq($Heap, parent#41, q#42, v#43, val#44) == _default.SubstSeq#limited($Heap, parent#41, q#42, v#43, val#44));

// frame axiom for _default.SubstSeq
axiom (forall $h0: HeapType, $h1: HeapType, parent#41: DatatypeType, q#42: Seq BoxType, v#43: int, val#44: int :: { $HeapSucc($h0, $h1), _default.SubstSeq($h1, parent#41, q#42, v#43, val#44) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: false ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> _default.SubstSeq($h0, parent#41, q#42, v#43, val#44) == _default.SubstSeq($h1, parent#41, q#42, v#43, val#44));

axiom (forall $h0: HeapType, $h1: HeapType, parent#41: DatatypeType, q#42: Seq BoxType, v#43: int, val#44: int :: { $HeapSucc($h0, $h1), _default.SubstSeq#limited($h1, parent#41, q#42, v#43, val#44) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: false ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> _default.SubstSeq#limited($h0, parent#41, q#42, v#43, val#44) == _default.SubstSeq#limited($h1, parent#41, q#42, v#43, val#44));

procedure CheckWellformed$$_default.SubstSeq(parent#41: DatatypeType, q#42: Seq BoxType, v#43: int, val#44: int);
  free requires 0 == $ModuleContextHeight && 2 == $FunctionContextHeight;



implementation CheckWellformed$$_default.SubstSeq(parent#41: DatatypeType, q#42: Seq BoxType, v#43: int, val#44: int)
{
  var a#105: DatatypeType;
  var $_Frame: <beta>[ref,Field beta]bool;
  var parent#106: DatatypeType;
  var q#107: Seq BoxType;
  var v#108: int;
  var val#109: int;
  var e#110: DatatypeType;
  var v#111: int;
  var val#112: int;

    if (Seq#Contains(q#42, $Box(a#105)))
    {
    }

    assume (forall a#45: DatatypeType :: Seq#Contains(q#42, $Box(a#45)) ==> DtRank(a#45) < DtRank(parent#41));
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    if (Seq#Equal(q#42, Seq#Empty(): Seq BoxType))
    {
    }
    else
    {
        assert 0 <= Seq#Length(q#42) - 1 && Seq#Length(q#42) - 1 <= Seq#Length(q#42);
        parent#106 := parent#41;
        q#107 := Seq#Take(q#42, Seq#Length(q#42) - 1);
        v#108 := v#43;
        val#109 := val#44;
        assert (forall a#45: DatatypeType :: Seq#Contains(q#107, $Box(a#45)) ==> DtRank(a#45) < DtRank(parent#106));
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assert DtRank(parent#106) < DtRank(parent#41) || (DtRank(parent#106) == DtRank(parent#41) && ((!false && false) || ((false <==> false) && Seq#Length(q#107) < Seq#Length(q#42))));
        assert 0 <= Seq#Length(q#42) - 1 && Seq#Length(q#42) - 1 < Seq#Length(q#42);
        e#110 := $Unbox(Seq#Index(q#42, Seq#Length(q#42) - 1)): DatatypeType;
        v#111 := v#43;
        val#112 := val#44;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assert DtRank(e#110) < DtRank(parent#41) || (DtRank(e#110) == DtRank(parent#41) && !true && false);
    }
}



const unique #tok$0^75.21: $token;

procedure CheckWellformed$$_default.TheoremSeq(e#46: DatatypeType, v#47: int, val#48: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^75.21;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^75.32: $token;

const unique #loc.e#46: $token;

const unique #tok$0^75.47: $token;

const unique #loc.v#47: $token;

const unique #tok$0^75.55: $token;

const unique #loc.val#48: $token;

implementation CheckWellformed$$_default.TheoremSeq(e#46: DatatypeType, v#47: int, val#48: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var e#113: DatatypeType;
  var v#114: int;
  var val#115: int;
  var e#116: DatatypeType;
  var v#117: int;
  var val#118: int;
  var e#119: DatatypeType;
  var v#120: int;
  var val#121: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^75.32, cev_parameter, #loc.e#46, e#46);
    call CevVarIntro(#tok$0^75.47, cev_parameter, #loc.v#47, v#47);
    call CevVarIntro(#tok$0^75.55, cev_parameter, #loc.val#48, val#48);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    e#113 := e#46;
    v#114 := v#47;
    val#115 := val#48;
    e#116 := _default.Substitute($Heap, e#46, v#47, val#48);
    v#117 := v#47;
    val#118 := val#48;
    e#119 := e#46;
    v#120 := v#47;
    val#121 := val#48;
    assume _default.Substitute($Heap, _default.Substitute($Heap, e#46, v#47, val#48), v#47, val#48) == _default.Substitute($Heap, e#46, v#47, val#48);
}



procedure _default.TheoremSeq(e#46: DatatypeType, v#47: int, val#48: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^75.21;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures _default.Substitute($Heap, _default.Substitute($Heap, e#46, v#47, val#48), v#47, val#48) == _default.Substitute($Heap, e#46, v#47, val#48);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.seArgs#53: $token;

const unique #tok$0^83.17: $token;

const unique #tok$0^84.7: $token;

const unique #loc.se#54: $token;

const unique #tok$0^86.17: $token;

const unique #loc.seArgs2#55: $token;

const unique #tok$0^87.17: $token;

const unique #tok$0^88.7: $token;

const unique #loc.N#56: $token;

const unique #tok$0^90.11: $token;

const unique #loc.j#57: $token;

const unique #tok$0^91.11: $token;

const unique #tok$0^92.7: $token;

const unique #tok$0^96.9: $token;

const unique #tok$0^97.11: $token;

implementation _default.TheoremSeq(e#46: DatatypeType, v#47: int, val#48: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var op#51: int;
  var args#52: Seq BoxType;
  var seArgs#53: Seq BoxType where #cev_var_update(#cev_pc, cev_local, #loc.seArgs#53, seArgs#53);
  var parent#122: DatatypeType;
  var q#123: Seq BoxType;
  var v#124: int;
  var val#125: int;
  var se#54: DatatypeType where #cev_var_update(#cev_pc, cev_local, #loc.se#54, se#54);
  var seArgs2#55: Seq BoxType where #cev_var_update(#cev_pc, cev_local, #loc.seArgs2#55, seArgs2#55);
  var parent#126: DatatypeType;
  var q#127: Seq BoxType;
  var v#128: int;
  var val#129: int;
  var N#56: int where #cev_var_update(#cev_pc, cev_local, #loc.N#56, N#56);
  var j#57: int where #cev_var_update(#cev_pc, cev_local, #loc.j#57, j#57);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;
  var e#130: DatatypeType;
  var v#131: int;
  var val#132: int;
  var x#50: int;
  var c#49: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^75.32, cev_parameter, #loc.e#46, e#46);
    call CevVarIntro(#tok$0^75.47, cev_parameter, #loc.v#47, v#47);
    call CevVarIntro(#tok$0^75.55, cev_parameter, #loc.val#48, val#48);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assert true;
    havoc op#51, args#52;
    havoc x#50;
    havoc c#49;
    if (e#46 == #Expression.Const(c#49))
    {
    }
    else if (e#46 == #Expression.Var(x#50))
    {
    }
    else if (e#46 == #Expression.Nary(op#51, args#52))
    {
        // ----- var-declaration statement ----- dafny1\Substitution.dfy(83,17)
        assert true;
        assert (forall a#45: DatatypeType :: Seq#Contains(args#52, $Box(a#45)) ==> DtRank(a#45) < DtRank(e#46));
        seArgs#53 := _default.SubstSeq($Heap, e#46, args#52, v#47, val#48);
        assume {:captureState "dafny1\Substitution.dfy(83,17)"} true;
        call CevVarIntro(#tok$0^83.17, cev_local, #loc.seArgs#53, seArgs#53);
        // ----- call statement ----- dafny1\Substitution.dfy(84,7)
        assert true;
        parent#122 := e#46;
        assert true;
        q#123 := args#52;
        assert true;
        v#124 := v#47;
        assert true;
        val#125 := val#48;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        call _default.LemmaSeq(parent#122, q#123, v#124, val#125);
        call CevStep(#tok$0^84.7);
        assume {:captureState "dafny1\Substitution.dfy(84,7)"} true;
        // ----- var-declaration statement ----- dafny1\Substitution.dfy(86,17)
        assert true;
        assert true;
        se#54 := _default.Substitute($Heap, e#46, v#47, val#48);
        assume {:captureState "dafny1\Substitution.dfy(86,17)"} true;
        call CevVarIntro(#tok$0^86.17, cev_local, #loc.se#54, se#54);
        // ----- var-declaration statement ----- dafny1\Substitution.dfy(87,17)
        assert true;
        assert (forall a#45: DatatypeType :: Seq#Contains(seArgs#53, $Box(a#45)) ==> DtRank(a#45) < DtRank(se#54));
        seArgs2#55 := _default.SubstSeq($Heap, se#54, seArgs#53, v#47, val#48);
        assume {:captureState "dafny1\Substitution.dfy(87,17)"} true;
        call CevVarIntro(#tok$0^87.17, cev_local, #loc.seArgs2#55, seArgs2#55);
        // ----- call statement ----- dafny1\Substitution.dfy(88,7)
        assert true;
        parent#126 := se#54;
        assert true;
        q#127 := seArgs#53;
        assert true;
        v#128 := v#47;
        assert true;
        val#129 := val#48;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        call _default.LemmaSeq(parent#126, q#127, v#128, val#129);
        call CevStep(#tok$0^88.7);
        assume {:captureState "dafny1\Substitution.dfy(88,7)"} true;
        // ----- var-declaration statement ----- dafny1\Substitution.dfy(90,11)
        assert true;
        assert true;
        N#56 := Seq#Length(args#52);
        assume {:captureState "dafny1\Substitution.dfy(90,11)"} true;
        call CevVarIntro(#tok$0^90.11, cev_local, #loc.N#56, N#56);
        // ----- var-declaration statement ----- dafny1\Substitution.dfy(91,11)
        assert true;
        assert true;
        j#57 := 0;
        assume {:captureState "dafny1\Substitution.dfy(91,11)"} true;
        call CevVarIntro(#tok$0^91.11, cev_local, #loc.j#57, j#57);
        // ----- while statement ----- dafny1\Substitution.dfy(92,7)
        $PreLoopHeap0 := $Heap;
        $decr0$init$0 := N#56 - j#57;
        havoc $w0;
        call $PreLoopCevPC0 := CevPreLoop(#tok$0^92.7);
        while (true)
          invariant $w0 ==> j#57 <= N#56;
          invariant $w0 ==> (forall k#58: int :: 0 <= k#58 && k#58 < j#57 ==> $Unbox(Seq#Index(seArgs2#55, k#58)): DatatypeType == $Unbox(Seq#Index(seArgs#53, k#58)): DatatypeType);
          free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
          free invariant $HeapSucc($PreLoopHeap0, $Heap);
          free invariant N#56 - j#57 <= $decr0$init$0 && (N#56 - j#57 == $decr0$init$0 ==> true);
          free invariant #cev_save_position(#cev_pc) == #tok$0^92.7;
          free invariant $PreLoopCevPC0 < #cev_pc;
          free invariant #cev_control_flow_event(#cev_pc, loop_register);
	  kUnwind 1;
        {
            if (!$w0)
            {
                assert {:subsumption 0} true;
                assume j#57 <= N#56;
                assert {:subsumption 0} (forall k#58: int :: (0 <= k#58 ==> true) && (0 <= k#58 && k#58 < j#57 ==> 0 <= k#58 && k#58 < Seq#Length(seArgs2#55) && 0 <= k#58 && k#58 < Seq#Length(seArgs#53)));
                assume (forall k#58: int :: 0 <= k#58 && k#58 < j#57 ==> $Unbox(Seq#Index(seArgs2#55, k#58)): DatatypeType == $Unbox(Seq#Index(seArgs#53, k#58)): DatatypeType);
                assert true;
                assume false;
            }

            assert true;
            if (j#57 >= N#56)
            {
                break;
            }

            call CevStepEvent(#tok$0^92.7, loop_entered);
            assume {:captureState "dafny1\Substitution.dfy(92,7): loop entered"} true;
            $decr0$0 := N#56 - j#57;
            // ----- call statement ----- dafny1\Substitution.dfy(96,9)
            assert 0 <= j#57 && j#57 < Seq#Length(args#52);
            e#130 := $Unbox(Seq#Index(args#52, j#57)): DatatypeType;
            assert true;
            v#131 := v#47;
            assert true;
            val#132 := val#48;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assert DtRank(e#130) < DtRank(e#46) || (DtRank(e#130) == DtRank(e#46) && !true && true);
            call _default.TheoremSeq(e#130, v#131, val#132);
            call CevStep(#tok$0^96.9);
            assume {:captureState "dafny1\Substitution.dfy(96,9)"} true;
            // ----- assignment statement ----- dafny1\Substitution.dfy(97,11)
            assert true;
            assert true;
            j#57 := j#57 + 1;
            assume {:captureState "dafny1\Substitution.dfy(97,11)"} true;
            call CevUpdate(#tok$0^97.11, #loc.j#57, j#57);
            assert 0 <= $decr0$0 || N#56 - j#57 == $decr0$0;
            assert N#56 - j#57 < $decr0$0;
        }

        call CevStepEvent(#tok$0^92.7, loop_exited);
        assume {:captureState "dafny1\Substitution.dfy(92,7): loop exit"} true;
        // ----- assert statement ----- dafny1\Substitution.dfy(99,7)
        assert {:subsumption 0} true;
        assert Seq#Equal(seArgs#53, seArgs2#55);
    }
    else
    {
        assume false;
    }
}



const unique #tok$0^103.21: $token;

procedure CheckWellformed$$_default.LemmaSeq(parent#59: DatatypeType, q#60: Seq BoxType, v#61: int, val#62: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^103.21;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^103.36: $token;

const unique #loc.parent#59: $token;

const unique #tok$0^103.62: $token;

const unique #loc.q#60: $token;

const unique #tok$0^104.37: $token;

const unique #loc.v#61: $token;

const unique #tok$0^104.45: $token;

const unique #loc.val#62: $token;

implementation CheckWellformed$$_default.LemmaSeq(parent#59: DatatypeType, q#60: Seq BoxType, v#61: int, val#62: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var a#133: DatatypeType;
  var parent#134: DatatypeType;
  var q#135: Seq BoxType;
  var v#136: int;
  var val#137: int;
  var k#138: int;
  var parent#139: DatatypeType;
  var q#140: Seq BoxType;
  var v#141: int;
  var val#142: int;
  var e#143: DatatypeType;
  var v#144: int;
  var val#145: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^103.36, cev_parameter, #loc.parent#59, parent#59);
    call CevVarIntro(#tok$0^103.62, cev_parameter, #loc.q#60, q#60);
    call CevVarIntro(#tok$0^104.37, cev_parameter, #loc.v#61, v#61);
    call CevVarIntro(#tok$0^104.45, cev_parameter, #loc.val#62, val#62);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    if (Seq#Contains(q#60, $Box(a#133)))
    {
    }

    assume (forall a#63: DatatypeType :: Seq#Contains(q#60, $Box(a#63)) ==> DtRank(a#63) < DtRank(parent#59));
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    parent#134 := parent#59;
    q#135 := q#60;
    v#136 := v#61;
    val#137 := val#62;
    assert (forall a#45: DatatypeType :: Seq#Contains(q#135, $Box(a#45)) ==> DtRank(a#45) < DtRank(parent#134));
    assume Seq#Length(_default.SubstSeq($Heap, parent#59, q#60, v#61, val#62)) == Seq#Length(q#60);
    if (0 <= k#138)
    {
    }

    if (0 <= k#138 && k#138 < Seq#Length(q#60))
    {
        parent#139 := parent#59;
        q#140 := q#60;
        v#141 := v#61;
        val#142 := val#62;
        assert (forall a#45: DatatypeType :: Seq#Contains(q#140, $Box(a#45)) ==> DtRank(a#45) < DtRank(parent#139));
        assert 0 <= k#138 && k#138 < Seq#Length(_default.SubstSeq($Heap, parent#59, q#60, v#61, val#62));
        assert 0 <= k#138 && k#138 < Seq#Length(q#60);
        e#143 := $Unbox(Seq#Index(q#60, k#138)): DatatypeType;
        v#144 := v#61;
        val#145 := val#62;
    }

    assume (forall k#64: int :: 0 <= k#64 && k#64 < Seq#Length(q#60) ==> $Unbox(Seq#Index(_default.SubstSeq($Heap, parent#59, q#60, v#61, val#62), k#64)): DatatypeType == _default.Substitute($Heap, $Unbox(Seq#Index(q#60, k#64)): DatatypeType, v#61, val#62));
}



procedure _default.LemmaSeq(parent#59: DatatypeType, q#60: Seq BoxType, v#61: int, val#62: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires (forall a#63: DatatypeType :: Seq#Contains(q#60, $Box(a#63)) ==> DtRank(a#63) < DtRank(parent#59));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^103.21;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures Seq#Length(_default.SubstSeq($Heap, parent#59, q#60, v#61, val#62)) == Seq#Length(q#60);
  ensures (forall k#64: int :: 0 <= k#64 && k#64 < Seq#Length(q#60) ==> $Unbox(Seq#Index(_default.SubstSeq($Heap, parent#59, q#60, v#61, val#62), k#64)): DatatypeType == _default.Substitute($Heap, $Unbox(Seq#Index(q#60, k#64)): DatatypeType, v#61, val#62));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^110.3: $token;

const unique #tok$0^110.16: $token;

const unique #tok$0^111.10: $token;

const unique #tok$0^112.5: $token;

implementation _default.LemmaSeq(parent#59: DatatypeType, q#60: Seq BoxType, v#61: int, val#62: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var parent#146: DatatypeType;
  var q#147: Seq BoxType;
  var v#148: int;
  var val#149: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^103.36, cev_parameter, #loc.parent#59, parent#59);
    call CevVarIntro(#tok$0^103.62, cev_parameter, #loc.q#60, q#60);
    call CevVarIntro(#tok$0^104.37, cev_parameter, #loc.v#61, v#61);
    call CevVarIntro(#tok$0^104.45, cev_parameter, #loc.val#62, val#62);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- if statement ----- dafny1\Substitution.dfy(110,3)
    call CevEvent(#tok$0^110.3, conditional_moment);
    assert true;
    if (Seq#Equal(q#60, Seq#Empty(): Seq BoxType))
    {
        call CevEvent(#tok$0^110.16, took_then_branch);
    }
    else
    {
        call CevEvent(#tok$0^111.10, took_else_branch);
        // ----- call statement ----- dafny1\Substitution.dfy(112,5)
        assert true;
        parent#146 := parent#59;
        assert 0 <= Seq#Length(q#60) - 1 && Seq#Length(q#60) - 1 <= Seq#Length(q#60);
        q#147 := Seq#Take(q#60, Seq#Length(q#60) - 1);
        assert true;
        v#148 := v#61;
        assert true;
        val#149 := val#62;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assert 0 <= v#61 || DtRank(parent#146) < DtRank(parent#59) || Seq#Length(q#147) < Seq#Length(q#60) || v#148 == v#61;
        assert 0 <= val#62 || DtRank(parent#146) < DtRank(parent#59) || Seq#Length(q#147) < Seq#Length(q#60) || v#148 < v#61 || val#149 == val#62;
        assert DtRank(parent#146) < DtRank(parent#59) || (DtRank(parent#146) == DtRank(parent#59) && (Seq#Length(q#147) < Seq#Length(q#60) || (Seq#Length(q#147) == Seq#Length(q#60) && (v#148 < v#61 || (v#148 == v#61 && val#149 < val#62)))));
        call _default.LemmaSeq(parent#146, q#147, v#148, val#149);
        call CevStep(#tok$0^112.5);
        assume {:captureState "dafny1\Substitution.dfy(112,5)"} true;
    }
}


