// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: dafny1\SumOfCubes.dfy /print:\Users\philipp\Desktop\boogie\boogie-k-induction-benchmarks\benchmarks\SumOfCubes.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class.SumOfCubes: ClassName;

function SumOfCubes.SumEmUp($heap: HeapType, n#0: int, m#1: int) : int;

function SumOfCubes.SumEmUp#limited($heap: HeapType, n#0: int, m#1: int) : int;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (0 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, n#0: int, m#1: int :: { SumOfCubes.SumEmUp($Heap, n#0, m#1) } $IsGoodHeap($Heap) && 0 <= n#0 && n#0 <= m#1 ==> SumOfCubes.SumEmUp($Heap, n#0, m#1) == $ite(m#1 == n#0, 0, n#0 * n#0 * n#0 + SumOfCubes.SumEmUp#limited($Heap, n#0 + 1, m#1)));

axiom (forall $Heap: HeapType, n#0: int, m#1: int :: { SumOfCubes.SumEmUp($Heap, n#0, m#1) } SumOfCubes.SumEmUp($Heap, n#0, m#1) == SumOfCubes.SumEmUp#limited($Heap, n#0, m#1));

// frame axiom for SumOfCubes.SumEmUp
axiom (forall $h0: HeapType, $h1: HeapType, n#0: int, m#1: int :: { $HeapSucc($h0, $h1), SumOfCubes.SumEmUp($h1, n#0, m#1) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: false ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> SumOfCubes.SumEmUp($h0, n#0, m#1) == SumOfCubes.SumEmUp($h1, n#0, m#1));

axiom (forall $h0: HeapType, $h1: HeapType, n#0: int, m#1: int :: { $HeapSucc($h0, $h1), SumOfCubes.SumEmUp#limited($h1, n#0, m#1) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: false ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> SumOfCubes.SumEmUp#limited($h0, n#0, m#1) == SumOfCubes.SumEmUp#limited($h1, n#0, m#1));

procedure CheckWellformed$$SumOfCubes.SumEmUp(n#0: int, m#1: int);
  free requires 0 == $ModuleContextHeight && 0 == $FunctionContextHeight;



implementation CheckWellformed$$SumOfCubes.SumEmUp(n#0: int, m#1: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var n#25: int;
  var m#26: int;

    if (0 <= n#0)
    {
    }

    assume 0 <= n#0 && n#0 <= m#1;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    if (m#1 == n#0)
    {
    }
    else
    {
        n#25 := n#0 + 1;
        m#26 := m#1;
        assert 0 <= n#25 && n#25 <= m#26;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assert 0 <= m#1 - n#0 || m#26 - n#25 == m#1 - n#0;
        assert m#26 - n#25 < m#1 - n#0;
    }
}



const unique xxxxxxxxxfile: $token;

axiom $file_name_is(0, xxxxxxxxxfile);

const unique #tok$0^9.17: $token;

procedure CheckWellformed$$SumOfCubes.Socu(n#2: int, m#3: int) returns (r#4: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^9.17;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^9.22: $token;

const unique #loc.n#2: $token;

const unique #tok$0^9.30: $token;

const unique #loc.m#3: $token;

const unique #tok$0^9.47: $token;

const unique #loc.r#4: $token;

implementation CheckWellformed$$SumOfCubes.Socu(n#2: int, m#3: int) returns (r#4: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var n#27: int;
  var m#28: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^9.22, cev_parameter, #loc.n#2, n#2);
    call CevVarIntro(#tok$0^9.30, cev_parameter, #loc.m#3, m#3);
    call CevVarIntro(#tok$0^9.47, cev_local, #loc.r#4, r#4);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    if (0 <= n#2)
    {
    }

    assume 0 <= n#2 && n#2 <= m#3;
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc r#4;
    n#27 := n#2;
    m#28 := m#3;
    assert 0 <= n#27 && n#27 <= m#28;
    assume r#4 == SumOfCubes.SumEmUp($Heap, n#2, m#3);
}



procedure SumOfCubes.Socu(n#2: int, m#3: int) returns (r#4: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires 0 <= n#2 && n#2 <= m#3;
  requires true ==> 0 <= n#2;
  requires true ==> n#2 <= m#3;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^9.17;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures r#4 == SumOfCubes.SumEmUp($Heap, n#2, m#3);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.a#5: $token;

const unique #tok$0^13.10: $token;

const unique #loc.a: $token;

const unique #tok$0^13.5: $token;

const unique #loc.b#6: $token;

const unique #tok$0^14.10: $token;

const unique #loc.b: $token;

const unique #tok$0^14.5: $token;

const unique #tok$0^15.7: $token;

const unique #tok$0^16.5: $token;

implementation SumOfCubes.Socu(n#2: int, m#3: int) returns (r#4: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var a#5: int where #cev_var_update(#cev_pc, cev_local, #loc.a#5, a#5);
  var k#29: int;
  var b#6: int where #cev_var_update(#cev_pc, cev_local, #loc.b#6, b#6);
  var k#30: int;
  var n#31: int;
  var m#32: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^9.22, cev_parameter, #loc.n#2, n#2);
    call CevVarIntro(#tok$0^9.30, cev_parameter, #loc.m#3, m#3);
    call CevVarIntro(#tok$0^9.47, cev_local, #loc.r#4, r#4);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- dafny1\SumOfCubes.dfy(13,10)
    call CevVarIntro(#tok$0^13.10, cev_local, #loc.a#5, a#5);
    // ----- call statement ----- dafny1\SumOfCubes.dfy(13,5)
    assert true;
    k#29 := m#3;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call a#5 := SumOfCubes.SocuFromZero(k#29);
    call CevUpdateHere(#loc.a, a#5);
    call CevStep(#tok$0^13.5);
    assume {:captureState "dafny1\SumOfCubes.dfy(13,5)"} true;
    // ----- var-declaration statement ----- dafny1\SumOfCubes.dfy(14,10)
    call CevVarIntro(#tok$0^14.10, cev_local, #loc.b#6, b#6);
    // ----- call statement ----- dafny1\SumOfCubes.dfy(14,5)
    assert true;
    k#30 := n#2;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call b#6 := SumOfCubes.SocuFromZero(k#30);
    call CevUpdateHere(#loc.b, b#6);
    call CevStep(#tok$0^14.5);
    assume {:captureState "dafny1\SumOfCubes.dfy(14,5)"} true;
    // ----- assignment statement ----- dafny1\SumOfCubes.dfy(15,7)
    assert true;
    assert true;
    r#4 := a#5 - b#6;
    assume {:captureState "dafny1\SumOfCubes.dfy(15,7)"} true;
    call CevUpdate(#tok$0^15.7, #loc.r#4, r#4);
    // ----- call statement ----- dafny1\SumOfCubes.dfy(16,5)
    assert true;
    n#31 := n#2;
    assert true;
    m#32 := m#3;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call SumOfCubes.Lemma0(n#31, m#32);
    call CevStep(#tok$0^16.5);
    assume {:captureState "dafny1\SumOfCubes.dfy(16,5)"} true;
}



const unique #tok$0^19.17: $token;

procedure CheckWellformed$$SumOfCubes.SocuFromZero(k#7: int) returns (r#8: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^19.17;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^19.30: $token;

const unique #loc.k#7: $token;

const unique #tok$0^19.47: $token;

const unique #loc.r#8: $token;

implementation CheckWellformed$$SumOfCubes.SocuFromZero(k#7: int) returns (r#8: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var n#33: int;
  var m#34: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^19.30, cev_parameter, #loc.k#7, k#7);
    call CevVarIntro(#tok$0^19.47, cev_local, #loc.r#8, r#8);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume 0 <= k#7;
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc r#8;
    n#33 := 0;
    m#34 := k#7;
    assert 0 <= n#33 && n#33 <= m#34;
    assume r#8 == SumOfCubes.SumEmUp($Heap, 0, k#7);
}



procedure SumOfCubes.SocuFromZero(k#7: int) returns (r#8: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires 0 <= k#7;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^19.17;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures r#8 == SumOfCubes.SumEmUp($Heap, 0, k#7);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.g#9: $token;

const unique #tok$0^23.10: $token;

const unique #loc.g: $token;

const unique #tok$0^23.5: $token;

const unique #tok$0^24.7: $token;

const unique #tok$0^25.5: $token;

implementation SumOfCubes.SocuFromZero(k#7: int) returns (r#8: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var g#9: int where #cev_var_update(#cev_pc, cev_local, #loc.g#9, g#9);
  var k#35: int;
  var k#36: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^19.30, cev_parameter, #loc.k#7, k#7);
    call CevVarIntro(#tok$0^19.47, cev_local, #loc.r#8, r#8);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- dafny1\SumOfCubes.dfy(23,10)
    call CevVarIntro(#tok$0^23.10, cev_local, #loc.g#9, g#9);
    // ----- call statement ----- dafny1\SumOfCubes.dfy(23,5)
    assert true;
    k#35 := k#7;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call g#9 := SumOfCubes.Gauss(k#35);
    call CevUpdateHere(#loc.g, g#9);
    call CevStep(#tok$0^23.5);
    assume {:captureState "dafny1\SumOfCubes.dfy(23,5)"} true;
    // ----- assignment statement ----- dafny1\SumOfCubes.dfy(24,7)
    assert true;
    assert true;
    r#8 := g#9 * g#9;
    assume {:captureState "dafny1\SumOfCubes.dfy(24,7)"} true;
    call CevUpdate(#tok$0^24.7, #loc.r#8, r#8);
    // ----- call statement ----- dafny1\SumOfCubes.dfy(25,5)
    assert true;
    k#36 := k#7;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call SumOfCubes.Lemma1(k#36);
    call CevStep(#tok$0^25.5);
    assume {:captureState "dafny1\SumOfCubes.dfy(25,5)"} true;
}



const unique #tok$0^28.23: $token;

procedure CheckWellformed$$SumOfCubes.Lemma0(n#10: int, m#11: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^28.23;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^28.30: $token;

const unique #loc.n#10: $token;

const unique #tok$0^28.38: $token;

const unique #loc.m#11: $token;

implementation CheckWellformed$$SumOfCubes.Lemma0(n#10: int, m#11: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var n#37: int;
  var m#38: int;
  var n#39: int;
  var m#40: int;
  var n#41: int;
  var m#42: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^28.30, cev_parameter, #loc.n#10, n#10);
    call CevVarIntro(#tok$0^28.38, cev_parameter, #loc.m#11, m#11);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    if (0 <= n#10)
    {
    }

    assume 0 <= n#10 && n#10 <= m#11;
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    n#37 := n#10;
    m#38 := m#11;
    assert 0 <= n#37 && n#37 <= m#38;
    n#39 := 0;
    m#40 := m#11;
    assert 0 <= n#39 && n#39 <= m#40;
    n#41 := 0;
    m#42 := n#10;
    assert 0 <= n#41 && n#41 <= m#42;
    assume SumOfCubes.SumEmUp($Heap, n#10, m#11) == SumOfCubes.SumEmUp($Heap, 0, m#11) - SumOfCubes.SumEmUp($Heap, 0, n#10);
}



procedure SumOfCubes.Lemma0(n#10: int, m#11: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires 0 <= n#10 && n#10 <= m#11;
  requires true ==> 0 <= n#10;
  requires true ==> n#10 <= m#11;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^28.23;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures SumOfCubes.SumEmUp($Heap, n#10, m#11) == SumOfCubes.SumEmUp($Heap, 0, m#11) - SumOfCubes.SumEmUp($Heap, 0, n#10);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.k#12: $token;

const unique #tok$0^32.9: $token;

const unique #tok$0^33.5: $token;

const unique #tok$0^37.9: $token;

const unique #tok$0^39.5: $token;

const unique #tok$0^40.5: $token;

const unique #tok$0^41.5: $token;

implementation SumOfCubes.Lemma0(n#10: int, m#11: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var k#12: int where #cev_var_update(#cev_pc, cev_local, #loc.k#12, k#12);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;
  var n#43: int;
  var m#44: int;
  var n#45: int;
  var m#46: int;
  var n#47: int;
  var m#48: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^28.30, cev_parameter, #loc.n#10, n#10);
    call CevVarIntro(#tok$0^28.38, cev_parameter, #loc.m#11, m#11);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- dafny1\SumOfCubes.dfy(32,9)
    assert true;
    assert true;
    k#12 := n#10;
    assume {:captureState "dafny1\SumOfCubes.dfy(32,9)"} true;
    call CevVarIntro(#tok$0^32.9, cev_local, #loc.k#12, k#12);
    // ----- while statement ----- dafny1\SumOfCubes.dfy(33,5)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := m#11 - k#12;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^33.5);
    while (true)
      invariant $w0 ==> n#10 <= k#12;
      invariant $w0 ==> k#12 <= m#11;
//      free invariant $w0 ==> n#10 <= k#12 && k#12 <= m#11;
      invariant $w0 ==> SumOfCubes.SumEmDown($Heap, 0, n#10) + SumOfCubes.SumEmDown($Heap, n#10, k#12) == SumOfCubes.SumEmDown($Heap, 0, k#12);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant m#11 - k#12 <= $decr0$init$0 && (m#11 - k#12 == $decr0$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^33.5;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} n#10 <= k#12 ==> true;
            assume n#10 <= k#12 && k#12 <= m#11;
            assert {:subsumption 0} 0 <= 0 && 0 <= n#10 && 0 <= n#10 && n#10 <= k#12 && 0 <= 0 && 0 <= k#12;
            assume SumOfCubes.SumEmDown($Heap, 0, n#10) + SumOfCubes.SumEmDown($Heap, n#10, k#12) == SumOfCubes.SumEmDown($Heap, 0, k#12);
            assert true;
            assume false;
        }

        assert true;
        if (k#12 >= m#11)
        {
            break;
        }

        call CevStepEvent(#tok$0^33.5, loop_entered);
        assume {:captureState "dafny1\SumOfCubes.dfy(33,5): loop entered"} true;
        $decr0$0 := m#11 - k#12;
        // ----- assignment statement ----- dafny1\SumOfCubes.dfy(37,9)
        assert true;
        assert true;
        k#12 := k#12 + 1;
        assume {:captureState "dafny1\SumOfCubes.dfy(37,9)"} true;
        call CevUpdate(#tok$0^37.9, #loc.k#12, k#12);
        assert 0 <= $decr0$0 || m#11 - k#12 == $decr0$0;
        assert m#11 - k#12 < $decr0$0;
    }

    call CevStepEvent(#tok$0^33.5, loop_exited);
    assume {:captureState "dafny1\SumOfCubes.dfy(33,5): loop exit"} true;
    // ----- call statement ----- dafny1\SumOfCubes.dfy(39,5)
    assert true;
    n#43 := 0;
    assert true;
    m#44 := n#10;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call SumOfCubes.Lemma3(n#43, m#44);
    call CevStep(#tok$0^39.5);
    assume {:captureState "dafny1\SumOfCubes.dfy(39,5)"} true;
    // ----- call statement ----- dafny1\SumOfCubes.dfy(40,5)
    assert true;
    n#45 := n#10;
    assert true;
    m#46 := k#12;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call SumOfCubes.Lemma3(n#45, m#46);
    call CevStep(#tok$0^40.5);
    assume {:captureState "dafny1\SumOfCubes.dfy(40,5)"} true;
    // ----- call statement ----- dafny1\SumOfCubes.dfy(41,5)
    assert true;
    n#47 := 0;
    assert true;
    m#48 := k#12;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call SumOfCubes.Lemma3(n#47, m#48);
    call CevStep(#tok$0^41.5);
    assume {:captureState "dafny1\SumOfCubes.dfy(41,5)"} true;
}



function SumOfCubes.GSum($heap: HeapType, k#13: int) : int;

function SumOfCubes.GSum#limited($heap: HeapType, k#13: int) : int;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (8 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, k#13: int :: { SumOfCubes.GSum($Heap, k#13) } $IsGoodHeap($Heap) && 0 <= k#13 ==> SumOfCubes.GSum($Heap, k#13) == $ite(k#13 == 0, 0, SumOfCubes.GSum#limited($Heap, k#13 - 1) + k#13 - 1));

axiom (forall $Heap: HeapType, k#13: int :: { SumOfCubes.GSum($Heap, k#13) } SumOfCubes.GSum($Heap, k#13) == SumOfCubes.GSum#limited($Heap, k#13));

// frame axiom for SumOfCubes.GSum
axiom (forall $h0: HeapType, $h1: HeapType, k#13: int :: { $HeapSucc($h0, $h1), SumOfCubes.GSum($h1, k#13) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: false ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> SumOfCubes.GSum($h0, k#13) == SumOfCubes.GSum($h1, k#13));

axiom (forall $h0: HeapType, $h1: HeapType, k#13: int :: { $HeapSucc($h0, $h1), SumOfCubes.GSum#limited($h1, k#13) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: false ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> SumOfCubes.GSum#limited($h0, k#13) == SumOfCubes.GSum#limited($h1, k#13));

procedure CheckWellformed$$SumOfCubes.GSum(k#13: int);
  free requires 0 == $ModuleContextHeight && 8 == $FunctionContextHeight;



implementation CheckWellformed$$SumOfCubes.GSum(k#13: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var k#49: int;

    assume 0 <= k#13;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    if (k#13 == 0)
    {
    }
    else
    {
        k#49 := k#13 - 1;
        assert 0 <= k#49;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assert 0 <= k#13 || k#49 == k#13;
        assert k#49 < k#13;
    }
}



const unique #tok$0^50.17: $token;

procedure CheckWellformed$$SumOfCubes.Gauss(k#14: int) returns (r#15: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^50.17;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^50.23: $token;

const unique #loc.k#14: $token;

const unique #tok$0^50.40: $token;

const unique #loc.r#15: $token;

implementation CheckWellformed$$SumOfCubes.Gauss(k#14: int) returns (r#15: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var k#50: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^50.23, cev_parameter, #loc.k#14, k#14);
    call CevVarIntro(#tok$0^50.40, cev_local, #loc.r#15, r#15);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume 0 <= k#14;
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc r#15;
    k#50 := k#14;
    assert 0 <= k#50;
    assume r#15 == SumOfCubes.GSum($Heap, k#14);
}



procedure SumOfCubes.Gauss(k#14: int) returns (r#15: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires 0 <= k#14;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^50.17;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures r#15 == SumOfCubes.GSum($Heap, k#14);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^54.7: $token;

const unique #tok$0^55.5: $token;

implementation SumOfCubes.Gauss(k#14: int) returns (r#15: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var k#51: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^50.23, cev_parameter, #loc.k#14, k#14);
    call CevVarIntro(#tok$0^50.40, cev_local, #loc.r#15, r#15);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- assignment statement ----- dafny1\SumOfCubes.dfy(54,7)
    assert true;
    assert 2 != 0;
    r#15 := k#14 * (k#14 - 1) / 2;
    assume {:captureState "dafny1\SumOfCubes.dfy(54,7)"} true;
    call CevUpdate(#tok$0^54.7, #loc.r#15, r#15);
    // ----- call statement ----- dafny1\SumOfCubes.dfy(55,5)
    assert true;
    k#51 := k#14;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call SumOfCubes.Lemma2(k#51);
    call CevStep(#tok$0^55.5);
    assume {:captureState "dafny1\SumOfCubes.dfy(55,5)"} true;
}



const unique #tok$0^58.23: $token;

procedure CheckWellformed$$SumOfCubes.Lemma1(k#16: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^58.23;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^58.30: $token;

const unique #loc.k#16: $token;

implementation CheckWellformed$$SumOfCubes.Lemma1(k#16: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var n#52: int;
  var m#53: int;
  var k#54: int;
  var k#55: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^58.30, cev_parameter, #loc.k#16, k#16);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume 0 <= k#16;
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    n#52 := 0;
    m#53 := k#16;
    assert 0 <= n#52 && n#52 <= m#53;
    k#54 := k#16;
    assert 0 <= k#54;
    k#55 := k#16;
    assert 0 <= k#55;
    assume SumOfCubes.SumEmUp($Heap, 0, k#16) == SumOfCubes.GSum($Heap, k#16) * SumOfCubes.GSum($Heap, k#16);
}



procedure SumOfCubes.Lemma1(k#16: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires 0 <= k#16;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^58.23;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures SumOfCubes.SumEmUp($Heap, 0, k#16) == SumOfCubes.GSum($Heap, k#16) * SumOfCubes.GSum($Heap, k#16);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.i#17: $token;

const unique #tok$0^62.9: $token;

const unique #tok$0^63.5: $token;

const unique #tok$0^67.7: $token;

const unique #tok$0^68.9: $token;

const unique #tok$0^70.5: $token;

implementation SumOfCubes.Lemma1(k#16: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#17: int where #cev_var_update(#cev_pc, cev_local, #loc.i#17, i#17);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;
  var k#56: int;
  var n#57: int;
  var m#58: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^58.30, cev_parameter, #loc.k#16, k#16);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- dafny1\SumOfCubes.dfy(62,9)
    assert true;
    assert true;
    i#17 := 0;
    assume {:captureState "dafny1\SumOfCubes.dfy(62,9)"} true;
    call CevVarIntro(#tok$0^62.9, cev_local, #loc.i#17, i#17);
    // ----- while statement ----- dafny1\SumOfCubes.dfy(63,5)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := k#16 - i#17;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^63.5);
    while (true)
      invariant $w0 ==> i#17 <= k#16;
      invariant $w0 ==> SumOfCubes.SumEmDown($Heap, 0, i#17) == SumOfCubes.GSum($Heap, i#17) * SumOfCubes.GSum($Heap, i#17);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant k#16 - i#17 <= $decr0$init$0 && (k#16 - i#17 == $decr0$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^63.5;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} true;
            assume i#17 <= k#16;
            assert {:subsumption 0} 0 <= 0 && 0 <= i#17 && 0 <= i#17 && 0 <= i#17;
            assume SumOfCubes.SumEmDown($Heap, 0, i#17) == SumOfCubes.GSum($Heap, i#17) * SumOfCubes.GSum($Heap, i#17);
            assert true;
            assume false;
        }

        assert true;
        if (i#17 >= k#16)
        {
            break;
        }

        call CevStepEvent(#tok$0^63.5, loop_entered);
        assume {:captureState "dafny1\SumOfCubes.dfy(63,5): loop entered"} true;
        $decr0$0 := k#16 - i#17;
        // ----- call statement ----- dafny1\SumOfCubes.dfy(67,7)
        assert true;
        k#56 := i#17;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        call SumOfCubes.Lemma2(k#56);
        call CevStep(#tok$0^67.7);
        assume {:captureState "dafny1\SumOfCubes.dfy(67,7)"} true;
        // ----- assignment statement ----- dafny1\SumOfCubes.dfy(68,9)
        assert true;
        assert true;
        i#17 := i#17 + 1;
        assume {:captureState "dafny1\SumOfCubes.dfy(68,9)"} true;
        call CevUpdate(#tok$0^68.9, #loc.i#17, i#17);
        assert 0 <= $decr0$0 || k#16 - i#17 == $decr0$0;
        assert k#16 - i#17 < $decr0$0;
    }

    call CevStepEvent(#tok$0^63.5, loop_exited);
    assume {:captureState "dafny1\SumOfCubes.dfy(63,5): loop exit"} true;
    // ----- call statement ----- dafny1\SumOfCubes.dfy(70,5)
    assert true;
    n#57 := 0;
    assert true;
    m#58 := k#16;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call SumOfCubes.Lemma3(n#57, m#58);
    call CevStep(#tok$0^70.5);
    assume {:captureState "dafny1\SumOfCubes.dfy(70,5)"} true;
}



const unique #tok$0^73.23: $token;

procedure CheckWellformed$$SumOfCubes.Lemma2(k#18: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^73.23;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^73.30: $token;

const unique #loc.k#18: $token;

implementation CheckWellformed$$SumOfCubes.Lemma2(k#18: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var k#59: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^73.30, cev_parameter, #loc.k#18, k#18);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume 0 <= k#18;
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    k#59 := k#18;
    assert 0 <= k#59;
    assume 2 * SumOfCubes.GSum($Heap, k#18) == k#18 * (k#18 - 1);
}



procedure SumOfCubes.Lemma2(k#18: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires 0 <= k#18;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^73.23;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures 2 * SumOfCubes.GSum($Heap, k#18) == k#18 * (k#18 - 1);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.i#19: $token;

const unique #tok$0^77.9: $token;

const unique #tok$0^78.5: $token;

const unique #tok$0^82.9: $token;

implementation SumOfCubes.Lemma2(k#18: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#19: int where #cev_var_update(#cev_pc, cev_local, #loc.i#19, i#19);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^73.30, cev_parameter, #loc.k#18, k#18);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- dafny1\SumOfCubes.dfy(77,9)
    assert true;
    assert true;
    i#19 := 0;
    assume {:captureState "dafny1\SumOfCubes.dfy(77,9)"} true;
    call CevVarIntro(#tok$0^77.9, cev_local, #loc.i#19, i#19);
    // ----- while statement ----- dafny1\SumOfCubes.dfy(78,5)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := k#18 - i#19;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^78.5);
    while (true)
      invariant $w0 ==> i#19 <= k#18;
      invariant $w0 ==> 2 * SumOfCubes.GSum($Heap, i#19) == i#19 * (i#19 - 1);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant k#18 - i#19 <= $decr0$init$0 && (k#18 - i#19 == $decr0$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^78.5;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} true;
            assume i#19 <= k#18;
            assert {:subsumption 0} 0 <= i#19;
            assume 2 * SumOfCubes.GSum($Heap, i#19) == i#19 * (i#19 - 1);
            assert true;
            assume false;
        }

        assert true;
        if (i#19 >= k#18)
        {
            break;
        }

        call CevStepEvent(#tok$0^78.5, loop_entered);
        assume {:captureState "dafny1\SumOfCubes.dfy(78,5): loop entered"} true;
        $decr0$0 := k#18 - i#19;
        // ----- assignment statement ----- dafny1\SumOfCubes.dfy(82,9)
        assert true;
        assert true;
        i#19 := i#19 + 1;
        assume {:captureState "dafny1\SumOfCubes.dfy(82,9)"} true;
        call CevUpdate(#tok$0^82.9, #loc.i#19, i#19);
        assert 0 <= $decr0$0 || k#18 - i#19 == $decr0$0;
        assert k#18 - i#19 < $decr0$0;
    }

    call CevStepEvent(#tok$0^78.5, loop_exited);
    assume {:captureState "dafny1\SumOfCubes.dfy(78,5): loop exit"} true;
}



function SumOfCubes.SumEmDown($heap: HeapType, n#20: int, m#21: int) : int;

function SumOfCubes.SumEmDown#limited($heap: HeapType, n#20: int, m#21: int) : int;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (9 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, n#20: int, m#21: int :: { SumOfCubes.SumEmDown($Heap, n#20, m#21) } $IsGoodHeap($Heap) && 0 <= n#20 && n#20 <= m#21 ==> SumOfCubes.SumEmDown($Heap, n#20, m#21) == $ite(m#21 == n#20, 0, SumOfCubes.SumEmDown#limited($Heap, n#20, m#21 - 1) + (m#21 - 1) * (m#21 - 1) * (m#21 - 1)));

axiom (forall $Heap: HeapType, n#20: int, m#21: int :: { SumOfCubes.SumEmDown($Heap, n#20, m#21) } SumOfCubes.SumEmDown($Heap, n#20, m#21) == SumOfCubes.SumEmDown#limited($Heap, n#20, m#21));

// frame axiom for SumOfCubes.SumEmDown
axiom (forall $h0: HeapType, $h1: HeapType, n#20: int, m#21: int :: { $HeapSucc($h0, $h1), SumOfCubes.SumEmDown($h1, n#20, m#21) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: false ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> SumOfCubes.SumEmDown($h0, n#20, m#21) == SumOfCubes.SumEmDown($h1, n#20, m#21));

axiom (forall $h0: HeapType, $h1: HeapType, n#20: int, m#21: int :: { $HeapSucc($h0, $h1), SumOfCubes.SumEmDown#limited($h1, n#20, m#21) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: false ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> SumOfCubes.SumEmDown#limited($h0, n#20, m#21) == SumOfCubes.SumEmDown#limited($h1, n#20, m#21));

procedure CheckWellformed$$SumOfCubes.SumEmDown(n#20: int, m#21: int);
  free requires 0 == $ModuleContextHeight && 9 == $FunctionContextHeight;



implementation CheckWellformed$$SumOfCubes.SumEmDown(n#20: int, m#21: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var n#60: int;
  var m#61: int;

    if (0 <= n#20)
    {
    }

    assume 0 <= n#20 && n#20 <= m#21;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    if (m#21 == n#20)
    {
    }
    else
    {
        n#60 := n#20;
        m#61 := m#21 - 1;
        assert 0 <= n#60 && n#60 <= m#61;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assert 0 <= n#20 || n#60 == n#20;
        assert 0 <= m#21 || n#60 < n#20 || m#61 == m#21;
        assert n#60 < n#20 || (n#60 == n#20 && m#61 < m#21);
    }
}



const unique #tok$0^92.23: $token;

procedure CheckWellformed$$SumOfCubes.Lemma3(n#22: int, m#23: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^92.23;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^92.30: $token;

const unique #loc.n#22: $token;

const unique #tok$0^92.38: $token;

const unique #loc.m#23: $token;

implementation CheckWellformed$$SumOfCubes.Lemma3(n#22: int, m#23: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var n#62: int;
  var m#63: int;
  var n#64: int;
  var m#65: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^92.30, cev_parameter, #loc.n#22, n#22);
    call CevVarIntro(#tok$0^92.38, cev_parameter, #loc.m#23, m#23);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    if (0 <= n#22)
    {
    }

    assume 0 <= n#22 && n#22 <= m#23;
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    n#62 := n#22;
    m#63 := m#23;
    assert 0 <= n#62 && n#62 <= m#63;
    n#64 := n#22;
    m#65 := m#23;
    assert 0 <= n#64 && n#64 <= m#65;
    assume SumOfCubes.SumEmUp($Heap, n#22, m#23) == SumOfCubes.SumEmDown($Heap, n#22, m#23);
}



procedure SumOfCubes.Lemma3(n#22: int, m#23: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires 0 <= n#22 && n#22 <= m#23;
  requires true ==> 0 <= n#22;
  requires true ==> n#22 <= m#23;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^92.23;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures SumOfCubes.SumEmUp($Heap, n#22, m#23) == SumOfCubes.SumEmDown($Heap, n#22, m#23);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.k#24: $token;

const unique #tok$0^96.9: $token;

const unique #tok$0^97.5: $token;

const unique #tok$0^101.9: $token;

implementation SumOfCubes.Lemma3(n#22: int, m#23: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var k#24: int where #cev_var_update(#cev_pc, cev_local, #loc.k#24, k#24);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^92.30, cev_parameter, #loc.n#22, n#22);
    call CevVarIntro(#tok$0^92.38, cev_parameter, #loc.m#23, m#23);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- dafny1\SumOfCubes.dfy(96,9)
    assert true;
    assert true;
    k#24 := n#22;
    assume {:captureState "dafny1\SumOfCubes.dfy(96,9)"} true;
    call CevVarIntro(#tok$0^96.9, cev_local, #loc.k#24, k#24);
    // ----- while statement ----- dafny1\SumOfCubes.dfy(97,5)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := m#23 - k#24;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^97.5);
    while (true)
      invariant $w0 ==> n#22 <= k#24;
      invariant $w0 ==> k#24 <= m#23;
//      free invariant $w0 ==> n#22 <= k#24 && k#24 <= m#23;
      invariant $w0 ==> SumOfCubes.SumEmUp($Heap, n#22, m#23) == SumOfCubes.SumEmDown($Heap, n#22, k#24) + SumOfCubes.SumEmUp($Heap, k#24, m#23);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant m#23 - k#24 <= $decr0$init$0 && (m#23 - k#24 == $decr0$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^97.5;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} n#22 <= k#24 ==> true;
            assume n#22 <= k#24 && k#24 <= m#23;
            assert {:subsumption 0} 0 <= n#22 && n#22 <= m#23 && 0 <= n#22 && n#22 <= k#24 && 0 <= k#24 && k#24 <= m#23;
            assume SumOfCubes.SumEmUp($Heap, n#22, m#23) == SumOfCubes.SumEmDown($Heap, n#22, k#24) + SumOfCubes.SumEmUp($Heap, k#24, m#23);
            assert true;
            assume false;
        }

        assert true;
        if (k#24 >= m#23)
        {
            break;
        }

        call CevStepEvent(#tok$0^97.5, loop_entered);
        assume {:captureState "dafny1\SumOfCubes.dfy(97,5): loop entered"} true;
        $decr0$0 := m#23 - k#24;
        // ----- assignment statement ----- dafny1\SumOfCubes.dfy(101,9)
        assert true;
        assert true;
        k#24 := k#24 + 1;
        assume {:captureState "dafny1\SumOfCubes.dfy(101,9)"} true;
        call CevUpdate(#tok$0^101.9, #loc.k#24, k#24);
        assert 0 <= $decr0$0 || m#23 - k#24 == $decr0$0;
        assert m#23 - k#24 < $decr0$0;
    }

    call CevStepEvent(#tok$0^97.5, loop_exited);
    assume {:captureState "dafny1\SumOfCubes.dfy(97,5): loop exit"} true;
}



const unique class._default: ClassName;
