// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: Test\VSI-Benchmarks\b1.dfy /print:..\boogie-k-induction-benchmarks\benchmarks\VSI-b1.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class._default: ClassName;

const unique xxxxflie: $token;

axiom $file_name_is(0, xxxxflie);

const unique #tok$0^8.8: $token;

procedure CheckWellformed$$_default.Add(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, x#0: int, y#1: int) returns (r#2: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^8.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.this: $token;

const unique #tok$0^8.12: $token;

const unique #loc.x#0: $token;

const unique #tok$0^8.20: $token;

const unique #loc.y#1: $token;

const unique #tok$0^8.37: $token;

const unique #loc.r#2: $token;

implementation CheckWellformed$$_default.Add(this: ref, x#0: int, y#1: int) returns (r#2: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^8.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^8.12, cev_parameter, #loc.x#0, x#0);
    call CevVarIntro(#tok$0^8.20, cev_parameter, #loc.y#1, y#1);
    call CevVarIntro(#tok$0^8.37, cev_local, #loc.r#2, r#2);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc r#2;
    assume r#2 == x#0 + y#1;
}



procedure _default.Add(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, x#0: int, y#1: int) returns (r#2: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^8.8;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures r#2 == x#0 + y#1;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^11.5: $token;

const unique #tok$0^12.3: $token;

const unique #tok$0^12.14: $token;

const unique #loc.n#3: $token;

const unique #tok$0^13.9: $token;

const unique #tok$0^14.5: $token;

const unique #tok$0^17.9: $token;

const unique #tok$0^18.9: $token;

const unique #tok$0^20.10: $token;

const unique #loc.n#4: $token;

const unique #tok$0^21.9: $token;

const unique #tok$0^22.5: $token;

const unique #tok$0^25.9: $token;

const unique #tok$0^26.9: $token;

implementation _default.Add(this: ref, x#0: int, y#1: int) returns (r#2: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var n#3: int where #cev_var_update(#cev_pc, cev_local, #loc.n#3, n#3);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;
  var n#4: int where #cev_var_update(#cev_pc, cev_local, #loc.n#4, n#4);
  var $PreLoopHeap1: HeapType;
  var $decr1$init$0: int;
  var $w1: bool;
  var $PreLoopCevPC1: int;
  var $decr1$0: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^8.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^8.12, cev_parameter, #loc.x#0, x#0);
    call CevVarIntro(#tok$0^8.20, cev_parameter, #loc.y#1, y#1);
    call CevVarIntro(#tok$0^8.37, cev_local, #loc.r#2, r#2);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b1.dfy(11,5)
    assert true;
    assert true;
    r#2 := x#0;
    assume {:captureState "Test\VSI-Benchmarks\b1.dfy(11,5)"} true;
    call CevUpdate(#tok$0^11.5, #loc.r#2, r#2);
    // ----- if statement ----- Test\VSI-Benchmarks\b1.dfy(12,3)
    call CevEvent(#tok$0^12.3, conditional_moment);
    assert true;
    if (y#1 < 0)
    {
        call CevEvent(#tok$0^12.14, took_then_branch);
        // ----- var-declaration statement ----- Test\VSI-Benchmarks\b1.dfy(13,9)
        assert true;
        assert true;
        n#3 := y#1;
        assume {:captureState "Test\VSI-Benchmarks\b1.dfy(13,9)"} true;
        call CevVarIntro(#tok$0^13.9, cev_local, #loc.n#3, n#3);
        // ----- while statement ----- Test\VSI-Benchmarks\b1.dfy(14,5)
        $PreLoopHeap0 := $Heap;
        $decr0$init$0 := $ite(0 <= n#3 - 0, n#3 - 0, 0 - n#3);
        havoc $w0;
        call $PreLoopCevPC0 := CevPreLoop(#tok$0^14.5);
        while (true)
          invariant $w0 ==> r#2 == x#0 + y#1 - n#3;
          invariant $w0 ==> 0 <= 0 - n#3;
//          free invariant $w0 ==> r#2 == x#0 + y#1 - n#3 && 0 <= 0 - n#3;
          free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
          free invariant $HeapSucc($PreLoopHeap0, $Heap);
          free invariant $ite(0 <= n#3 - 0, n#3 - 0, 0 - n#3) <= $decr0$init$0 && ($ite(0 <= n#3 - 0, n#3 - 0, 0 - n#3) == $decr0$init$0 ==> true);
          free invariant #cev_save_position(#cev_pc) == #tok$0^14.5;
          free invariant $PreLoopCevPC0 < #cev_pc;
          free invariant #cev_control_flow_event(#cev_pc, loop_register);
          free invariant #cev_var_update(#cev_pc, cev_local, #loc.r#2, r#2);
	  kUnwind 1;
        {
            if (!$w0)
            {
                assert {:subsumption 0} r#2 == x#0 + y#1 - n#3 ==> true;
                assume r#2 == x#0 + y#1 - n#3 && 0 <= 0 - n#3;
                assert (0 <= n#3 - 0 ==> true) && (0 > n#3 - 0 ==> true);
                assume false;
            }

            assert true;
            if (n#3 == 0)
            {
                break;
            }

            call CevStepEvent(#tok$0^14.5, loop_entered);
            assume {:captureState "Test\VSI-Benchmarks\b1.dfy(14,5): loop entered"} true;
            $decr0$0 := $ite(0 <= n#3 - 0, n#3 - 0, 0 - n#3);
            // ----- assignment statement ----- Test\VSI-Benchmarks\b1.dfy(17,9)
            assert true;
            assert true;
            r#2 := r#2 - 1;
            assume {:captureState "Test\VSI-Benchmarks\b1.dfy(17,9)"} true;
            call CevUpdate(#tok$0^17.9, #loc.r#2, r#2);
            // ----- assignment statement ----- Test\VSI-Benchmarks\b1.dfy(18,9)
            assert true;
            assert true;
            n#3 := n#3 + 1;
            assume {:captureState "Test\VSI-Benchmarks\b1.dfy(18,9)"} true;
            call CevUpdate(#tok$0^18.9, #loc.n#3, n#3);
            assert 0 <= $decr0$0 || $ite(0 <= n#3 - 0, n#3 - 0, 0 - n#3) == $decr0$0;
            assert $ite(0 <= n#3 - 0, n#3 - 0, 0 - n#3) < $decr0$0;
        }

        call CevStepEvent(#tok$0^14.5, loop_exited);
        assume {:captureState "Test\VSI-Benchmarks\b1.dfy(14,5): loop exit"} true;
    }
    else
    {
        call CevEvent(#tok$0^20.10, took_else_branch);
        // ----- var-declaration statement ----- Test\VSI-Benchmarks\b1.dfy(21,9)
        assert true;
        assert true;
        n#4 := y#1;
        assume {:captureState "Test\VSI-Benchmarks\b1.dfy(21,9)"} true;
        call CevVarIntro(#tok$0^21.9, cev_local, #loc.n#4, n#4);
        // ----- while statement ----- Test\VSI-Benchmarks\b1.dfy(22,5)
        $PreLoopHeap1 := $Heap;
        $decr1$init$0 := $ite(0 <= n#4 - 0, n#4 - 0, 0 - n#4);
        havoc $w1;
        call $PreLoopCevPC1 := CevPreLoop(#tok$0^22.5);
        while (true)
          invariant $w1 ==> r#2 == x#0 + y#1 - n#4;
          invariant $w1 ==> 0 <= n#4;
//          free invariant $w1 ==> r#2 == x#0 + y#1 - n#4 && 0 <= n#4;
          free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap1, $o, $f));
          free invariant $HeapSucc($PreLoopHeap1, $Heap);
          free invariant $ite(0 <= n#4 - 0, n#4 - 0, 0 - n#4) <= $decr1$init$0 && ($ite(0 <= n#4 - 0, n#4 - 0, 0 - n#4) == $decr1$init$0 ==> true);
          free invariant #cev_save_position(#cev_pc) == #tok$0^22.5;
          free invariant $PreLoopCevPC1 < #cev_pc;
          free invariant #cev_control_flow_event(#cev_pc, loop_register);
          free invariant #cev_var_update(#cev_pc, cev_local, #loc.r#2, r#2);
	  kUnwind 1;
        {
            if (!$w1)
            {
                assert {:subsumption 0} r#2 == x#0 + y#1 - n#4 ==> true;
                assume r#2 == x#0 + y#1 - n#4 && 0 <= n#4;
                assert (0 <= n#4 - 0 ==> true) && (0 > n#4 - 0 ==> true);
                assume false;
            }

            assert true;
            if (n#4 == 0)
            {
                break;
            }

            call CevStepEvent(#tok$0^22.5, loop_entered);
            assume {:captureState "Test\VSI-Benchmarks\b1.dfy(22,5): loop entered"} true;
            $decr1$0 := $ite(0 <= n#4 - 0, n#4 - 0, 0 - n#4);
            // ----- assignment statement ----- Test\VSI-Benchmarks\b1.dfy(25,9)
            assert true;
            assert true;
            r#2 := r#2 + 1;
            assume {:captureState "Test\VSI-Benchmarks\b1.dfy(25,9)"} true;
            call CevUpdate(#tok$0^25.9, #loc.r#2, r#2);
            // ----- assignment statement ----- Test\VSI-Benchmarks\b1.dfy(26,9)
            assert true;
            assert true;
            n#4 := n#4 - 1;
            assume {:captureState "Test\VSI-Benchmarks\b1.dfy(26,9)"} true;
            call CevUpdate(#tok$0^26.9, #loc.n#4, n#4);
            assert 0 <= $decr1$0 || $ite(0 <= n#4 - 0, n#4 - 0, 0 - n#4) == $decr1$0;
            assert $ite(0 <= n#4 - 0, n#4 - 0, 0 - n#4) < $decr1$0;
        }

        call CevStepEvent(#tok$0^22.5, loop_exited);
        assume {:captureState "Test\VSI-Benchmarks\b1.dfy(22,5): loop exit"} true;
    }
}



const unique #tok$0^31.8: $token;

procedure CheckWellformed$$_default.Mul(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, x#5: int, y#6: int) returns (r#7: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^31.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^31.12: $token;

const unique #loc.x#5: $token;

const unique #tok$0^31.20: $token;

const unique #loc.y#6: $token;

const unique #tok$0^31.37: $token;

const unique #loc.r#7: $token;

implementation CheckWellformed$$_default.Mul(this: ref, x#5: int, y#6: int) returns (r#7: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^31.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^31.12, cev_parameter, #loc.x#5, x#5);
    call CevVarIntro(#tok$0^31.20, cev_parameter, #loc.y#6, y#6);
    call CevVarIntro(#tok$0^31.37, cev_local, #loc.r#7, r#7);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc r#7;
    assume r#7 == x#5 * y#6;
}



procedure _default.Mul(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, x#5: int, y#6: int) returns (r#7: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^31.8;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures r#7 == x#5 * y#6;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^35.3: $token;

const unique #tok$0^35.15: $token;

const unique #tok$0^36.7: $token;

const unique #tok$0^37.10: $token;

const unique #tok$0^37.21: $token;

const unique #loc.r: $token;

const unique #tok$0^38.5: $token;

const unique #tok$0^39.7: $token;

const unique #tok$0^40.10: $token;

const unique #tok$0^41.5: $token;

const unique #tok$0^42.5: $token;

implementation _default.Mul(this: ref, x#5: int, y#6: int) returns (r#7: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var x#14: int;
  var y#15: int;
  var x#16: int;
  var y#17: int;
  var x#18: int;
  var y#19: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^31.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^31.12, cev_parameter, #loc.x#5, x#5);
    call CevVarIntro(#tok$0^31.20, cev_parameter, #loc.y#6, y#6);
    call CevVarIntro(#tok$0^31.37, cev_local, #loc.r#7, r#7);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- if statement ----- Test\VSI-Benchmarks\b1.dfy(35,3)
    call CevEvent(#tok$0^35.3, conditional_moment);
    assert true;
    if (x#5 == 0)
    {
        call CevEvent(#tok$0^35.15, took_then_branch);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b1.dfy(36,7)
        assert true;
        assert true;
        r#7 := 0;
        assume {:captureState "Test\VSI-Benchmarks\b1.dfy(36,7)"} true;
        call CevUpdate(#tok$0^36.7, #loc.r#7, r#7);
    }
    else
    {
        call CevEvent(#tok$0^37.10, took_else_branch);
        // ----- if statement ----- Test\VSI-Benchmarks\b1.dfy(37,10)
        call CevEvent(#tok$0^37.10, conditional_moment);
        assert true;
        if (x#5 < 0)
        {
            call CevEvent(#tok$0^37.21, took_then_branch);
            // ----- call statement ----- Test\VSI-Benchmarks\b1.dfy(38,5)
            assert true;
            x#14 := 0 - x#5;
            assert true;
            y#15 := y#6;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assert 0 <= x#5 || (x#14 >= 0 && x#5 < 0) || x#14 == x#5;
            assert (x#14 >= 0 && x#5 < 0) || ((x#14 < 0 <==> x#5 < 0) && x#14 < x#5);
            call r#7 := _default.Mul(this, x#14, y#15);
            call CevUpdateHere(#loc.r, r#7);
            call CevStep(#tok$0^38.5);
            assume {:captureState "Test\VSI-Benchmarks\b1.dfy(38,5)"} true;
            // ----- assignment statement ----- Test\VSI-Benchmarks\b1.dfy(39,7)
            assert true;
            assert true;
            r#7 := 0 - r#7;
            assume {:captureState "Test\VSI-Benchmarks\b1.dfy(39,7)"} true;
            call CevUpdate(#tok$0^39.7, #loc.r#7, r#7);
        }
        else
        {
            call CevEvent(#tok$0^40.10, took_else_branch);
            // ----- call statement ----- Test\VSI-Benchmarks\b1.dfy(41,5)
            assert true;
            x#16 := x#5 - 1;
            assert true;
            y#17 := y#6;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assert 0 <= x#5 || (x#16 >= 0 && x#5 < 0) || x#16 == x#5;
            assert (x#16 >= 0 && x#5 < 0) || ((x#16 < 0 <==> x#5 < 0) && x#16 < x#5);
            call r#7 := _default.Mul(this, x#16, y#17);
            call CevUpdateHere(#loc.r, r#7);
            call CevStep(#tok$0^41.5);
            assume {:captureState "Test\VSI-Benchmarks\b1.dfy(41,5)"} true;
            // ----- call statement ----- Test\VSI-Benchmarks\b1.dfy(42,5)
            assert true;
            x#18 := r#7;
            assert true;
            y#19 := y#6;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            call r#7 := _default.Add(this, x#18, y#19);
            call CevUpdateHere(#loc.r, r#7);
            call CevStep(#tok$0^42.5);
            assume {:captureState "Test\VSI-Benchmarks\b1.dfy(42,5)"} true;
        }
    }
}



const unique #tok$0^48.8: $token;

procedure CheckWellformed$$_default.Main(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^48.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



implementation CheckWellformed$$_default.Main(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^48.8, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
}



procedure _default.Main(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^48.8;
  modifies $Heap, #cev_pc;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^49.3: $token;

const unique #tok$0^50.3: $token;

const unique #tok$0^51.3: $token;

const unique #tok$0^53.3: $token;

const unique #tok$0^54.3: $token;

const unique #tok$0^55.3: $token;

const unique #tok$0^56.3: $token;

const unique #tok$0^57.3: $token;

const unique #tok$0^58.3: $token;

implementation _default.Main(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var x#20: int;
  var y#21: int;
  var x#22: int;
  var y#23: int;
  var x#24: int;
  var y#25: int;
  var x#26: int;
  var y#27: int;
  var x#28: int;
  var y#29: int;
  var x#30: int;
  var y#31: int;
  var x#32: int;
  var y#33: int;
  var x#34: int;
  var y#35: int;
  var x#36: int;
  var y#37: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^48.8, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- call statement ----- Test\VSI-Benchmarks\b1.dfy(49,3)
    assert true;
    x#20 := 3;
    assert true;
    y#21 := 180;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.TestAdd(this, x#20, y#21);
    call CevStep(#tok$0^49.3);
    assume {:captureState "Test\VSI-Benchmarks\b1.dfy(49,3)"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b1.dfy(50,3)
    assert true;
    x#22 := 3;
    assert true;
    y#23 := 0 - 180;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.TestAdd(this, x#22, y#23);
    call CevStep(#tok$0^50.3);
    assume {:captureState "Test\VSI-Benchmarks\b1.dfy(50,3)"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b1.dfy(51,3)
    assert true;
    x#24 := 0;
    assert true;
    y#25 := 1;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.TestAdd(this, x#24, y#25);
    call CevStep(#tok$0^51.3);
    assume {:captureState "Test\VSI-Benchmarks\b1.dfy(51,3)"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b1.dfy(53,3)
    assert true;
    x#26 := 3;
    assert true;
    y#27 := 180;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.TestMul(this, x#26, y#27);
    call CevStep(#tok$0^53.3);
    assume {:captureState "Test\VSI-Benchmarks\b1.dfy(53,3)"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b1.dfy(54,3)
    assert true;
    x#28 := 3;
    assert true;
    y#29 := 0 - 180;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.TestMul(this, x#28, y#29);
    call CevStep(#tok$0^54.3);
    assume {:captureState "Test\VSI-Benchmarks\b1.dfy(54,3)"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b1.dfy(55,3)
    assert true;
    x#30 := 180;
    assert true;
    y#31 := 3;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.TestMul(this, x#30, y#31);
    call CevStep(#tok$0^55.3);
    assume {:captureState "Test\VSI-Benchmarks\b1.dfy(55,3)"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b1.dfy(56,3)
    assert true;
    x#32 := 0 - 180;
    assert true;
    y#33 := 3;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.TestMul(this, x#32, y#33);
    call CevStep(#tok$0^56.3);
    assume {:captureState "Test\VSI-Benchmarks\b1.dfy(56,3)"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b1.dfy(57,3)
    assert true;
    x#34 := 0;
    assert true;
    y#35 := 1;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.TestMul(this, x#34, y#35);
    call CevStep(#tok$0^57.3);
    assume {:captureState "Test\VSI-Benchmarks\b1.dfy(57,3)"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b1.dfy(58,3)
    assert true;
    x#36 := 1;
    assert true;
    y#37 := 0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.TestMul(this, x#36, y#37);
    call CevStep(#tok$0^58.3);
    assume {:captureState "Test\VSI-Benchmarks\b1.dfy(58,3)"} true;
}



const unique #tok$0^61.8: $token;

procedure CheckWellformed$$_default.TestAdd(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, x#8: int, y#9: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^61.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^61.16: $token;

const unique #loc.x#8: $token;

const unique #tok$0^61.24: $token;

const unique #loc.y#9: $token;

implementation CheckWellformed$$_default.TestAdd(this: ref, x#8: int, y#9: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^61.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^61.16, cev_parameter, #loc.x#8, x#8);
    call CevVarIntro(#tok$0^61.24, cev_parameter, #loc.y#9, y#9);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
}



procedure _default.TestAdd(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, x#8: int, y#9: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^61.8;
  modifies $Heap, #cev_pc;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.z#10: $token;

const unique #tok$0^63.8: $token;

const unique #loc.z: $token;

const unique #tok$0^63.3: $token;

implementation _default.TestAdd(this: ref, x#8: int, y#9: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var z#10: int where #cev_var_update(#cev_pc, cev_local, #loc.z#10, z#10);
  var x#38: int;
  var y#39: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^61.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^61.16, cev_parameter, #loc.x#8, x#8);
    call CevVarIntro(#tok$0^61.24, cev_parameter, #loc.y#9, y#9);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- print statement ----- Test\VSI-Benchmarks\b1.dfy(62,3)
    assert {:subsumption 0} true;
    assert {:subsumption 0} true;
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b1.dfy(63,8)
    call CevVarIntro(#tok$0^63.8, cev_local, #loc.z#10, z#10);
    // ----- call statement ----- Test\VSI-Benchmarks\b1.dfy(63,3)
    assert true;
    x#38 := x#8;
    assert true;
    y#39 := y#9;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call z#10 := _default.Add(this, x#38, y#39);
    call CevUpdateHere(#loc.z, z#10);
    call CevStep(#tok$0^63.3);
    assume {:captureState "Test\VSI-Benchmarks\b1.dfy(63,3)"} true;
    // ----- print statement ----- Test\VSI-Benchmarks\b1.dfy(64,3)
    assert {:subsumption 0} true;
}



const unique #tok$0^67.8: $token;

procedure CheckWellformed$$_default.TestMul(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, x#11: int, y#12: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^67.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^67.16: $token;

const unique #loc.x#11: $token;

const unique #tok$0^67.24: $token;

const unique #loc.y#12: $token;

implementation CheckWellformed$$_default.TestMul(this: ref, x#11: int, y#12: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^67.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^67.16, cev_parameter, #loc.x#11, x#11);
    call CevVarIntro(#tok$0^67.24, cev_parameter, #loc.y#12, y#12);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
}



procedure _default.TestMul(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, x#11: int, y#12: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^67.8;
  modifies $Heap, #cev_pc;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.z#13: $token;

const unique #tok$0^69.8: $token;

const unique #tok$0^69.3: $token;

implementation _default.TestMul(this: ref, x#11: int, y#12: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var z#13: int where #cev_var_update(#cev_pc, cev_local, #loc.z#13, z#13);
  var x#40: int;
  var y#41: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^67.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^67.16, cev_parameter, #loc.x#11, x#11);
    call CevVarIntro(#tok$0^67.24, cev_parameter, #loc.y#12, y#12);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- print statement ----- Test\VSI-Benchmarks\b1.dfy(68,3)
    assert {:subsumption 0} true;
    assert {:subsumption 0} true;
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b1.dfy(69,8)
    call CevVarIntro(#tok$0^69.8, cev_local, #loc.z#13, z#13);
    // ----- call statement ----- Test\VSI-Benchmarks\b1.dfy(69,3)
    assert true;
    x#40 := x#11;
    assert true;
    y#41 := y#12;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call z#13 := _default.Mul(this, x#40, y#41);
    call CevUpdateHere(#loc.z, z#13);
    call CevStep(#tok$0^69.3);
    assume {:captureState "Test\VSI-Benchmarks\b1.dfy(69,3)"} true;
    // ----- print statement ----- Test\VSI-Benchmarks\b1.dfy(70,3)
    assert {:subsumption 0} true;
}


