// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: Test\VSI-Benchmarks\b2.dfy /print:..\boogie-k-induction-benchmarks\benchmarks\VSI-b2.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class.Benchmark2: ClassName;

const unique xxxxxfile: $token;

axiom $file_name_is(0, xxxxxfile);

const unique #tok$0^3.10: $token;

procedure CheckWellformed$$Benchmark2.BinarySearch(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Benchmark2, a#0: ref where a#0 == null || (read($Heap, a#0, alloc) && dtype(a#0) == class.array && TypeParams(a#0, 0) == class.int), key#1: int) returns (result#2: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^3.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.this: $token;

const unique #tok$0^3.23: $token;

const unique #loc.a#0: $token;

const unique #tok$0^3.38: $token;

const unique #loc.key#1: $token;

const unique #tok$0^3.57: $token;

const unique #loc.result#2: $token;

implementation CheckWellformed$$Benchmark2.BinarySearch(this: ref, a#0: ref, key#1: int) returns (result#2: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#19: int;
  var j#20: int;
  var i#21: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^3.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^3.23, cev_parameter, #loc.a#0, a#0);
    call CevVarIntro(#tok$0^3.38, cev_parameter, #loc.key#1, key#1);
    call CevVarIntro(#tok$0^3.57, cev_local, #loc.result#2, result#2);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume a#0 != null;
    if (0 <= i#19)
    {
    }

    if (0 <= i#19 && i#19 < j#20)
    {
        assert a#0 != null;
    }

    if (0 <= i#19 && i#19 < j#20 && j#20 < array.Length(a#0))
    {
        assert 0 <= i#19 && i#19 < array.Length(a#0);
        assert 0 <= j#20 && j#20 < array.Length(a#0);
    }

    assume (forall i#3: int, j#4: int :: 0 <= i#3 && i#3 < j#4 && j#4 < array.Length(a#0) ==> $Unbox(read($Heap, a#0, IndexField(i#3))): int <= $Unbox(read($Heap, a#0, IndexField(j#4))): int);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc result#2;
    if (0 - 1 <= result#2)
    {
        assert a#0 != null;
    }

    assume 0 - 1 <= result#2 && result#2 < array.Length(a#0);
    if (0 <= result#2)
    {
        assert 0 <= result#2 && result#2 < array.Length(a#0);
    }

    assume 0 <= result#2 ==> $Unbox(read($Heap, a#0, IndexField(result#2))): int == key#1;
    if (result#2 == 0 - 1)
    {
        if (0 <= i#21)
        {
            assert a#0 != null;
        }

        if (0 <= i#21 && i#21 < array.Length(a#0))
        {
            assert 0 <= i#21 && i#21 < array.Length(a#0);
        }
    }

    assume result#2 == 0 - 1 ==> (forall i#5: int :: 0 <= i#5 && i#5 < array.Length(a#0) ==> $Unbox(read($Heap, a#0, IndexField(i#5))): int != key#1);
}



procedure Benchmark2.BinarySearch(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Benchmark2, a#0: ref where a#0 == null || (read($Heap, a#0, alloc) && dtype(a#0) == class.array && TypeParams(a#0, 0) == class.int), key#1: int) returns (result#2: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires a#0 != null;
  requires (forall i#3: int, j#4: int :: 0 <= i#3 && i#3 < j#4 && j#4 < array.Length(a#0) ==> $Unbox(read($Heap, a#0, IndexField(i#3))): int <= $Unbox(read($Heap, a#0, IndexField(j#4))): int);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^3.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures 0 - 1 <= result#2 && result#2 < array.Length(a#0);
  ensures true ==> 0 - 1 <= result#2;
  ensures true ==> result#2 < array.Length(a#0);
  ensures 0 <= result#2 ==> $Unbox(read($Heap, a#0, IndexField(result#2))): int == key#1;
  ensures result#2 == 0 - 1 ==> (forall i#5: int :: 0 <= i#5 && i#5 < array.Length(a#0) ==> $Unbox(read($Heap, a#0, IndexField(i#5))): int != key#1);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.low#6: $token;

const unique #tok$0^10.9: $token;

const unique #loc.high#7: $token;

const unique #tok$0^11.9: $token;

const unique #tok$0^13.5: $token;

const unique #loc.mid#10: $token;

const unique #tok$0^18.11: $token;

const unique #loc.midVal#11: $token;

const unique #tok$0^19.11: $token;

const unique #tok$0^21.7: $token;

const unique #tok$0^21.25: $token;

const unique #tok$0^22.13: $token;

const unique #tok$0^23.14: $token;

const unique #tok$0^23.32: $token;

const unique #tok$0^24.14: $token;

const unique #tok$0^25.14: $token;

const unique #tok$0^26.16: $token;

const unique #tok$0^30.12: $token;

implementation Benchmark2.BinarySearch(this: ref, a#0: ref, key#1: int) returns (result#2: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var low#6: int where #cev_var_update(#cev_pc, cev_local, #loc.low#6, low#6);
  var high#7: int where #cev_var_update(#cev_pc, cev_local, #loc.high#7, high#7);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;
  var mid#10: int where #cev_var_update(#cev_pc, cev_local, #loc.mid#10, mid#10);
  var midVal#11: int where #cev_var_update(#cev_pc, cev_local, #loc.midVal#11, midVal#11);

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^3.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^3.23, cev_parameter, #loc.a#0, a#0);
    call CevVarIntro(#tok$0^3.38, cev_parameter, #loc.key#1, key#1);
    call CevVarIntro(#tok$0^3.57, cev_local, #loc.result#2, result#2);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b2.dfy(10,9)
    assert true;
    assert true;
    low#6 := 0;
    assume {:captureState "Test\VSI-Benchmarks\b2.dfy(10,9)"} true;
    call CevVarIntro(#tok$0^10.9, cev_local, #loc.low#6, low#6);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b2.dfy(11,9)
    assert true;
    assert a#0 != null;
    high#7 := array.Length(a#0);
    assume {:captureState "Test\VSI-Benchmarks\b2.dfy(11,9)"} true;
    call CevVarIntro(#tok$0^11.9, cev_local, #loc.high#7, high#7);
    // ----- while statement ----- Test\VSI-Benchmarks\b2.dfy(13,5)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := high#7 - low#6;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^13.5);
    while (true)
      invariant $w0 ==> 0 <= low#6;
      invariant $w0 ==> low#6 <= high#7;
      invariant $w0 ==> high#7 <= array.Length(a#0);
//      free invariant $w0 ==> 0 <= low#6 && low#6 <= high#7 && high#7 <= array.Length(a#0);
      invariant $w0 ==> (forall i#8: int :: 0 <= i#8 && i#8 < low#6 ==> $Unbox(read($Heap, a#0, IndexField(i#8))): int < key#1);
      invariant $w0 ==> (forall i#9: int :: high#7 <= i#9 && i#9 < array.Length(a#0) ==> key#1 < $Unbox(read($Heap, a#0, IndexField(i#9))): int);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant high#7 - low#6 <= $decr0$init$0 && (high#7 - low#6 == $decr0$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^13.5;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.result#2, result#2);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} (0 <= low#6 ==> true) && (0 <= low#6 && low#6 <= high#7 ==> a#0 != null);
            assume 0 <= low#6 && low#6 <= high#7 && high#7 <= array.Length(a#0);
            assert {:subsumption 0} (forall i#8: int :: (0 <= i#8 ==> true) && (0 <= i#8 && i#8 < low#6 ==> 0 <= i#8 && i#8 < array.Length(a#0)));
            assume (forall i#8: int :: 0 <= i#8 && i#8 < low#6 ==> $Unbox(read($Heap, a#0, IndexField(i#8))): int < key#1);
            assert {:subsumption 0} (forall i#9: int :: (high#7 <= i#9 ==> a#0 != null) && (high#7 <= i#9 && i#9 < array.Length(a#0) ==> 0 <= i#9 && i#9 < array.Length(a#0)));
            assume (forall i#9: int :: high#7 <= i#9 && i#9 < array.Length(a#0) ==> key#1 < $Unbox(read($Heap, a#0, IndexField(i#9))): int);
            assert true;
            assume false;
        }

        assert true;
        if (low#6 >= high#7)
        {
            break;
        }

        call CevStepEvent(#tok$0^13.5, loop_entered);
        assume {:captureState "Test\VSI-Benchmarks\b2.dfy(13,5): loop entered"} true;
        $decr0$0 := high#7 - low#6;
        // ----- var-declaration statement ----- Test\VSI-Benchmarks\b2.dfy(18,11)
        assert true;
        assert 2 != 0;
        mid#10 := low#6 + (high#7 - low#6) / 2;
        assume {:captureState "Test\VSI-Benchmarks\b2.dfy(18,11)"} true;
        call CevVarIntro(#tok$0^18.11, cev_local, #loc.mid#10, mid#10);
        // ----- var-declaration statement ----- Test\VSI-Benchmarks\b2.dfy(19,11)
        assert true;
        assert 0 <= mid#10 && mid#10 < array.Length(a#0);
        midVal#11 := $Unbox(read($Heap, a#0, IndexField(mid#10))): int;
        assume {:captureState "Test\VSI-Benchmarks\b2.dfy(19,11)"} true;
        call CevVarIntro(#tok$0^19.11, cev_local, #loc.midVal#11, midVal#11);
        // ----- if statement ----- Test\VSI-Benchmarks\b2.dfy(21,7)
        call CevEvent(#tok$0^21.7, conditional_moment);
        assert true;
        if (midVal#11 < key#1)
        {
            call CevEvent(#tok$0^21.25, took_then_branch);
            // ----- assignment statement ----- Test\VSI-Benchmarks\b2.dfy(22,13)
            assert true;
            assert true;
            low#6 := mid#10 + 1;
            assume {:captureState "Test\VSI-Benchmarks\b2.dfy(22,13)"} true;
            call CevUpdate(#tok$0^22.13, #loc.low#6, low#6);
        }
        else
        {
            call CevEvent(#tok$0^23.14, took_else_branch);
            // ----- if statement ----- Test\VSI-Benchmarks\b2.dfy(23,14)
            call CevEvent(#tok$0^23.14, conditional_moment);
            assert true;
            if (key#1 < midVal#11)
            {
                call CevEvent(#tok$0^23.32, took_then_branch);
                // ----- assignment statement ----- Test\VSI-Benchmarks\b2.dfy(24,14)
                assert true;
                assert true;
                high#7 := mid#10;
                assume {:captureState "Test\VSI-Benchmarks\b2.dfy(24,14)"} true;
                call CevUpdate(#tok$0^24.14, #loc.high#7, high#7);
            }
            else
            {
                call CevEvent(#tok$0^25.14, took_else_branch);
                // ----- assignment statement ----- Test\VSI-Benchmarks\b2.dfy(26,16)
                assert true;
                assert true;
                result#2 := mid#10;
                assume {:captureState "Test\VSI-Benchmarks\b2.dfy(26,16)"} true;
                call CevUpdate(#tok$0^26.16, #loc.result#2, result#2);
                // ----- return statement ----- Test\VSI-Benchmarks\b2.dfy(27,9)
                return;
            }
        }

        assert 0 <= $decr0$0 || high#7 - low#6 == $decr0$0;
        assert high#7 - low#6 < $decr0$0;
    }

    call CevStepEvent(#tok$0^13.5, loop_exited);
    assume {:captureState "Test\VSI-Benchmarks\b2.dfy(13,5): loop exit"} true;
    // ----- assignment statement ----- Test\VSI-Benchmarks\b2.dfy(30,12)
    assert true;
    assert true;
    result#2 := 0 - 1;
    assume {:captureState "Test\VSI-Benchmarks\b2.dfy(30,12)"} true;
    call CevUpdate(#tok$0^30.12, #loc.result#2, result#2);
}



const unique class._default: ClassName;

const unique #tok$0^34.8: $token;

procedure CheckWellformed$$_default.Main(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^34.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



implementation CheckWellformed$$_default.Main(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^34.8, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
}



procedure _default.Main(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^34.8;
  modifies $Heap, #cev_pc;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.a#12: $token;

const unique #tok$0^35.7: $token;

const unique #tok$0^41.3: $token;

const unique #tok$0^42.3: $token;

const unique #tok$0^43.3: $token;

const unique #tok$0^44.3: $token;

const unique #tok$0^45.3: $token;

const unique #tok$0^46.3: $token;

const unique #tok$0^47.3: $token;

implementation _default.Main(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var a#12: ref where (a#12 == null || (read($Heap, a#12, alloc) && dtype(a#12) == class.array && TypeParams(a#12, 0) == class.int)) && #cev_var_update(#cev_pc, cev_local, #loc.a#12, a#12);
  var $nw: ref;
  var a#22: ref;
  var key#23: int;
  var a#24: ref;
  var key#25: int;
  var a#26: ref;
  var key#27: int;
  var a#28: ref;
  var key#29: int;
  var a#30: ref;
  var key#31: int;
  var a#32: ref;
  var key#33: int;
  var a#34: ref;
  var key#35: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^34.8, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b2.dfy(35,7)
    assert 0 <= 5;
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.array && TypeParams($nw, 0) == class.int;
    assume array.Length($nw) == 5;
    $Heap := update($Heap, $nw, alloc, true);
    a#12 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b2.dfy(35,7)"} true;
    call CevVarIntro(#tok$0^35.7, cev_local, #loc.a#12, a#12);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b2.dfy(36,8)
    assert 0 <= 0 && 0 < array.Length(a#12);
    assert true;
    assert $_Frame[a#12, IndexField(0)];
    $Heap := update($Heap, a#12, IndexField(0), $Box(0 - 4));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b2.dfy(36,8)"} true;
    // ----- assignment statement ----- Test\VSI-Benchmarks\b2.dfy(37,8)
    assert 0 <= 1 && 1 < array.Length(a#12);
    assert true;
    assert $_Frame[a#12, IndexField(1)];
    $Heap := update($Heap, a#12, IndexField(1), $Box(0 - 2));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b2.dfy(37,8)"} true;
    // ----- assignment statement ----- Test\VSI-Benchmarks\b2.dfy(38,8)
    assert 0 <= 2 && 2 < array.Length(a#12);
    assert true;
    assert $_Frame[a#12, IndexField(2)];
    $Heap := update($Heap, a#12, IndexField(2), $Box(0 - 2));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b2.dfy(38,8)"} true;
    // ----- assignment statement ----- Test\VSI-Benchmarks\b2.dfy(39,8)
    assert 0 <= 3 && 3 < array.Length(a#12);
    assert true;
    assert $_Frame[a#12, IndexField(3)];
    $Heap := update($Heap, a#12, IndexField(3), $Box(0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b2.dfy(39,8)"} true;
    // ----- assignment statement ----- Test\VSI-Benchmarks\b2.dfy(40,8)
    assert 0 <= 4 && 4 < array.Length(a#12);
    assert true;
    assert $_Frame[a#12, IndexField(4)];
    $Heap := update($Heap, a#12, IndexField(4), $Box(25));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b2.dfy(40,8)"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b2.dfy(41,3)
    assert true;
    a#22 := a#12;
    assert true;
    key#23 := 4;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.TestSearch(this, a#22, key#23);
    call CevStep(#tok$0^41.3);
    assume {:captureState "Test\VSI-Benchmarks\b2.dfy(41,3)"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b2.dfy(42,3)
    assert true;
    a#24 := a#12;
    assert true;
    key#25 := 0 - 8;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.TestSearch(this, a#24, key#25);
    call CevStep(#tok$0^42.3);
    assume {:captureState "Test\VSI-Benchmarks\b2.dfy(42,3)"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b2.dfy(43,3)
    assert true;
    a#26 := a#12;
    assert true;
    key#27 := 0 - 2;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.TestSearch(this, a#26, key#27);
    call CevStep(#tok$0^43.3);
    assume {:captureState "Test\VSI-Benchmarks\b2.dfy(43,3)"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b2.dfy(44,3)
    assert true;
    a#28 := a#12;
    assert true;
    key#29 := 0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.TestSearch(this, a#28, key#29);
    call CevStep(#tok$0^44.3);
    assume {:captureState "Test\VSI-Benchmarks\b2.dfy(44,3)"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b2.dfy(45,3)
    assert true;
    a#30 := a#12;
    assert true;
    key#31 := 23;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.TestSearch(this, a#30, key#31);
    call CevStep(#tok$0^45.3);
    assume {:captureState "Test\VSI-Benchmarks\b2.dfy(45,3)"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b2.dfy(46,3)
    assert true;
    a#32 := a#12;
    assert true;
    key#33 := 25;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.TestSearch(this, a#32, key#33);
    call CevStep(#tok$0^46.3);
    assume {:captureState "Test\VSI-Benchmarks\b2.dfy(46,3)"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b2.dfy(47,3)
    assert true;
    a#34 := a#12;
    assert true;
    key#35 := 27;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call _default.TestSearch(this, a#34, key#35);
    call CevStep(#tok$0^47.3);
    assume {:captureState "Test\VSI-Benchmarks\b2.dfy(47,3)"} true;
}



const unique #tok$0^50.8: $token;

procedure CheckWellformed$$_default.TestSearch(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, a#13: ref where a#13 == null || (read($Heap, a#13, alloc) && dtype(a#13) == class.array && TypeParams(a#13, 0) == class.int), key#14: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^50.8;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^50.19: $token;

const unique #loc.a#13: $token;

const unique #tok$0^50.34: $token;

const unique #loc.key#14: $token;

implementation CheckWellformed$$_default.TestSearch(this: ref, a#13: ref, key#14: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#36: int;
  var j#37: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^50.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^50.19, cev_parameter, #loc.a#13, a#13);
    call CevVarIntro(#tok$0^50.34, cev_parameter, #loc.key#14, key#14);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume a#13 != null;
    if (0 <= i#36)
    {
    }

    if (0 <= i#36 && i#36 < j#37)
    {
        assert a#13 != null;
    }

    if (0 <= i#36 && i#36 < j#37 && j#37 < array.Length(a#13))
    {
        assert 0 <= i#36 && i#36 < array.Length(a#13);
        assert 0 <= j#37 && j#37 < array.Length(a#13);
    }

    assume (forall i#15: int, j#16: int :: 0 <= i#15 && i#15 < j#16 && j#16 < array.Length(a#13) ==> $Unbox(read($Heap, a#13, IndexField(i#15))): int <= $Unbox(read($Heap, a#13, IndexField(j#16))): int);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
}



procedure _default.TestSearch(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class._default, a#13: ref where a#13 == null || (read($Heap, a#13, alloc) && dtype(a#13) == class.array && TypeParams(a#13, 0) == class.int), key#14: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires a#13 != null;
  requires (forall i#15: int, j#16: int :: 0 <= i#15 && i#15 < j#16 && j#16 < array.Length(a#13) ==> $Unbox(read($Heap, a#13, IndexField(i#15))): int <= $Unbox(read($Heap, a#13, IndexField(j#16))): int);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^50.8;
  modifies $Heap, #cev_pc;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.b#17: $token;

const unique #tok$0^54.7: $token;

const unique #loc.r#18: $token;

const unique #tok$0^55.8: $token;

const unique #loc.r: $token;

const unique #tok$0^55.3: $token;

implementation _default.TestSearch(this: ref, a#13: ref, key#14: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b#17: ref where (b#17 == null || (read($Heap, b#17, alloc) && dtype(b#17) == class.Benchmark2)) && #cev_var_update(#cev_pc, cev_local, #loc.b#17, b#17);
  var $nw: ref;
  var r#18: int where #cev_var_update(#cev_pc, cev_local, #loc.r#18, r#18);
  var a#38: ref;
  var key#39: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^50.8, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^50.19, cev_parameter, #loc.a#13, a#13);
    call CevVarIntro(#tok$0^50.34, cev_parameter, #loc.key#14, key#14);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b2.dfy(54,7)
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.Benchmark2;
    $Heap := update($Heap, $nw, alloc, true);
    b#17 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b2.dfy(54,7)"} true;
    call CevVarIntro(#tok$0^54.7, cev_local, #loc.b#17, b#17);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b2.dfy(55,8)
    call CevVarIntro(#tok$0^55.8, cev_local, #loc.r#18, r#18);
    // ----- call statement ----- Test\VSI-Benchmarks\b2.dfy(55,3)
    assert true;
    a#38 := a#13;
    assert true;
    key#39 := key#14;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call r#18 := Benchmark2.BinarySearch(b#17, a#38, key#39);
    call CevUpdateHere(#loc.r, r#18);
    call CevStep(#tok$0^55.3);
    assume {:captureState "Test\VSI-Benchmarks\b2.dfy(55,3)"} true;
    // ----- print statement ----- Test\VSI-Benchmarks\b2.dfy(56,3)
    assert {:subsumption 0} true;
    assert {:subsumption 0} true;
}


