// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: Test\VSI-Benchmarks\b3.dfy /print:..\boogie-k-induction-benchmarks\benchmarks\VSI-b3.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class.Queue: ClassName;

axiom FDim(Queue.contents) == 0 && DeclType(Queue.contents) == class.Queue;

const unique Queue.contents: Field (Seq BoxType);

const unique xxxxxfile: $token;

axiom $file_name_is(0, xxxxxfile);

const unique #tok$0^15.10: $token;

procedure CheckWellformed$$Queue.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Queue);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^15.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.this: $token;

implementation CheckWellformed$$Queue.Init(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^15.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    assume Seq#Length(read($Heap, this, Queue.contents)) == 0;
}



procedure Queue.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Queue);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^15.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures Seq#Length(read($Heap, this, Queue.contents)) == 0;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^18.10: $token;

procedure CheckWellformed$$Queue.Enqueue(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Queue, x#0: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^18.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^18.18: $token;

const unique #loc.x#0: $token;

implementation CheckWellformed$$Queue.Enqueue(this: ref, x#0: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^18.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^18.18, cev_parameter, #loc.x#0, x#0);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    assume Seq#Equal(read($Heap, this, Queue.contents), Seq#Append(old(read($Heap, this, Queue.contents)), Seq#Build(Seq#Empty(): Seq BoxType, 0, x#0, 1)));
}



procedure Queue.Enqueue(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Queue, x#0: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^18.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures Seq#Equal(read($Heap, this, Queue.contents), Seq#Append(old(read($Heap, this, Queue.contents)), Seq#Build(Seq#Empty(): Seq BoxType, 0, x#0, 1)));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^21.10: $token;

procedure CheckWellformed$$Queue.Dequeue(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Queue) returns (x#1: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^21.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^21.29: $token;

const unique #loc.x#1: $token;

implementation CheckWellformed$$Queue.Dequeue(this: ref) returns (x#1: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^21.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^21.29, cev_local, #loc.x#1, x#1);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    assume 0 < Seq#Length(read($Heap, this, Queue.contents));
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc x#1;
    assert 0 <= 1 && 1 <= Seq#Length(old(read($Heap, this, Queue.contents)));
    if (Seq#Equal(read($Heap, this, Queue.contents), Seq#Drop(old(read($Heap, this, Queue.contents)), 1)))
    {
        assert 0 <= 0 && 0 < Seq#Length(old(read($Heap, this, Queue.contents)));
    }

    assume Seq#Equal(read($Heap, this, Queue.contents), Seq#Drop(old(read($Heap, this, Queue.contents)), 1)) && x#1 == Seq#Index(old(read($Heap, this, Queue.contents)), 0);
}



procedure Queue.Dequeue(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Queue) returns (x#1: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires 0 < Seq#Length(read($Heap, this, Queue.contents));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^21.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures Seq#Equal(read($Heap, this, Queue.contents), Seq#Drop(old(read($Heap, this, Queue.contents)), 1)) && x#1 == Seq#Index(old(read($Heap, this, Queue.contents)), 0);
  ensures true ==> Seq#Equal(read($Heap, this, Queue.contents), Seq#Drop(old(read($Heap, this, Queue.contents)), 1));
  ensures true ==> x#1 == Seq#Index(old(read($Heap, this, Queue.contents)), 0);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



function Queue.Head($heap: HeapType, this: ref) : BoxType;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (5 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref :: { Queue.Head($Heap, this) } $IsGoodHeap($Heap) && this != null && 0 < Seq#Length(read($Heap, this, Queue.contents)) ==> Queue.Head($Heap, this) == Seq#Index(read($Heap, this, Queue.contents), 0));

// frame axiom for Queue.Head
axiom (forall $h0: HeapType, $h1: HeapType, this: ref :: { $HeapSucc($h0, $h1), Queue.Head($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Queue && read($h1, this, alloc) && dtype(this) == class.Queue && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Queue.Head($h0, this) == Queue.Head($h1, this));

procedure CheckWellformed$$Queue.Head(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Queue);
  free requires 0 == $ModuleContextHeight && 5 == $FunctionContextHeight;



implementation CheckWellformed$$Queue.Head(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    assume 0 < Seq#Length(read($Heap, this, Queue.contents));
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    assert $_Frame[this, Queue.contents];
    assert 0 <= 0 && 0 < Seq#Length(read($Heap, this, Queue.contents));
}



function Queue.Get($heap: HeapType, this: ref, i#2: int) : BoxType;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (6 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref, i#2: int :: { Queue.Get($Heap, this, i#2) } $IsGoodHeap($Heap) && this != null && 0 <= i#2 && i#2 < Seq#Length(read($Heap, this, Queue.contents)) ==> Queue.Get($Heap, this, i#2) == Seq#Index(read($Heap, this, Queue.contents), i#2));

// frame axiom for Queue.Get
axiom (forall $h0: HeapType, $h1: HeapType, this: ref, i#2: int :: { $HeapSucc($h0, $h1), Queue.Get($h1, this, i#2) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Queue && read($h1, this, alloc) && dtype(this) == class.Queue && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Queue.Get($h0, this, i#2) == Queue.Get($h1, this, i#2));

procedure CheckWellformed$$Queue.Get(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Queue, i#2: int);
  free requires 0 == $ModuleContextHeight && 6 == $FunctionContextHeight;



implementation CheckWellformed$$Queue.Get(this: ref, i#2: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    if (0 <= i#2)
    {
    }

    assume 0 <= i#2 && i#2 < Seq#Length(read($Heap, this, Queue.contents));
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    assert $_Frame[this, Queue.contents];
    assert 0 <= i#2 && i#2 < Seq#Length(read($Heap, this, Queue.contents));
}



const unique class.Comparable: ClassName;

function Comparable.AtMost($heap: HeapType, this: ref, c#3: ref) : bool;

// frame axiom for Comparable.AtMost
axiom (forall $h0: HeapType, $h1: HeapType, this: ref, c#3: ref :: { $HeapSucc($h0, $h1), Comparable.AtMost($h1, this, c#3) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Comparable && read($h1, this, alloc) && dtype(this) == class.Comparable && (c#3 == null || (read($h0, c#3, alloc) && dtype(c#3) == class.Comparable)) && (c#3 == null || (read($h1, c#3, alloc) && dtype(c#3) == class.Comparable)) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && ($o == this || $o == c#3) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Comparable.AtMost($h0, this, c#3) == Comparable.AtMost($h1, this, c#3));

procedure CheckWellformed$$Comparable.AtMost(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Comparable, c#3: ref where c#3 == null || (read($Heap, c#3, alloc) && dtype(c#3) == class.Comparable));
  free requires 0 == $ModuleContextHeight && 7 == $FunctionContextHeight;



implementation CheckWellformed$$Comparable.AtMost(this: ref, c#3: ref)
{
}



const unique class.Benchmark3: ClassName;

const unique #tok$0^43.10: $token;

procedure CheckWellformed$$Benchmark3.Sort(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Benchmark3, q#4: ref where q#4 == null || (read($Heap, q#4, alloc) && dtype(q#4) == class.Queue && TypeParams(q#4, 0) == class.int)) returns (r#5: ref where r#5 == null || (read($Heap, r#5, alloc) && dtype(r#5) == class.Queue && TypeParams(r#5, 0) == class.int), perm#6: Seq BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^43.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^43.15: $token;

const unique #loc.q#4: $token;

const unique #tok$0^43.39: $token;

const unique #loc.r#5: $token;

const unique #tok$0^43.60: $token;

const unique #loc.perm#6: $token;



procedure Benchmark3.Sort(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Benchmark3, q#4: ref where q#4 == null || (read($Heap, q#4, alloc) && dtype(q#4) == class.Queue && TypeParams(q#4, 0) == class.int)) returns (r#5: ref where r#5 == null || (read($Heap, r#5, alloc) && dtype(r#5) == class.Queue && TypeParams(r#5, 0) == class.int), perm#6: Seq BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires q#4 != null;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^43.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures r#5 != null && (r#5 == null || !read(old($Heap), r#5, alloc));
  ensures true ==> r#5 != null;
  ensures true ==> r#5 == null || !read(old($Heap), r#5, alloc);
  ensures Seq#Length(read($Heap, r#5, Queue.contents)) == Seq#Length(old(read($Heap, q#4, Queue.contents)));
  ensures (forall i#7: int, j#8: int :: 0 <= i#7 && i#7 < j#8 && j#8 < Seq#Length(read($Heap, r#5, Queue.contents)) ==> $Unbox(Queue.Get($Heap, r#5, i#7)): int <= $Unbox(Queue.Get($Heap, r#5, j#8)): int);
  ensures Seq#Length(perm#6) == Seq#Length(read($Heap, r#5, Queue.contents));
  ensures (forall i#9: int :: 0 <= i#9 && i#9 < Seq#Length(perm#6) ==> 0 <= $Unbox(Seq#Index(perm#6, i#9)): int && $Unbox(Seq#Index(perm#6, i#9)): int < Seq#Length(perm#6));
  ensures (forall i#10: int, j#11: int :: 0 <= i#10 && i#10 < j#11 && j#11 < Seq#Length(perm#6) ==> $Unbox(Seq#Index(perm#6, i#10)): int != $Unbox(Seq#Index(perm#6, j#11)): int);
  ensures (forall i#12: int :: 0 <= i#12 && i#12 < Seq#Length(perm#6) ==> $Unbox(Seq#Index(read($Heap, r#5, Queue.contents), i#12)): int == $Unbox(Seq#Index(old(read($Heap, q#4, Queue.contents)), $Unbox(Seq#Index(perm#6, i#12)): int)): int);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == q#4);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^57.7: $token;

const unique #tok$0^58.5: $token;

const unique #loc.p#13: $token;

const unique #tok$0^59.15: $token;

const unique #loc.n#14: $token;

const unique #tok$0^61.9: $token;

const unique #tok$0^62.5: $token;

const unique #tok$0^67.9: $token;

const unique #tok$0^68.9: $token;

const unique #tok$0^70.10: $token;

const unique #loc.pperm#16: $token;

const unique #tok$0^71.15: $token;

const unique #tok$0^73.5: $token;

const unique #loc.m#27: $token;

const unique #tok$0^91.12: $token;

const unique #loc.k#28: $token;

const unique #tok$0^91.14: $token;

const unique #loc.m: $token;

const unique #loc.k: $token;

const unique #tok$0^91.7: $token;

const unique #tok$0^92.12: $token;

const unique #tok$0^93.9: $token;

const unique #tok$0^94.7: $token;

const unique #tok$0^95.13: $token;

implementation Benchmark3.Sort(this: ref, q#4: ref) returns (r#5: ref, perm#6: Seq BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $nw: ref;
  var p#13: Seq BoxType where #cev_var_update(#cev_pc, cev_local, #loc.p#13, p#13);
  var n#14: int where #cev_var_update(#cev_pc, cev_local, #loc.n#14, n#14);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;
  var pperm#16: Seq BoxType where #cev_var_update(#cev_pc, cev_local, #loc.pperm#16, pperm#16);
  var $PreLoopHeap1: HeapType;
  var $decr1$init$0: int;
  var $w1: bool;
  var $PreLoopCevPC1: int;
  var $decr1$0: int;
  var m#27: int where #cev_var_update(#cev_pc, cev_local, #loc.m#27, m#27);
  var k#28: int where #cev_var_update(#cev_pc, cev_local, #loc.k#28, k#28);
  var q#46: ref;
  var x#47: BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^43.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^43.15, cev_parameter, #loc.q#4, q#4);
    call CevVarIntro(#tok$0^43.39, cev_local, #loc.r#5, r#5);
    call CevVarIntro(#tok$0^43.60, cev_local, #loc.perm#6, perm#6);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == q#4);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b3.dfy(57,7)
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.Queue && TypeParams($nw, 0) == class.int;
    $Heap := update($Heap, $nw, alloc, true);
    r#5 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b3.dfy(57,7)"} true;
    call CevUpdate(#tok$0^57.7, #loc.r#5, r#5);
    // ----- call statement ----- Test\VSI-Benchmarks\b3.dfy(58,5)
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == r#5 ==> $_Frame[$o, $f]);
    call Queue.Init(r#5);
    call CevStep(#tok$0^58.5);
    assume {:captureState "Test\VSI-Benchmarks\b3.dfy(58,5)"} true;
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b3.dfy(59,15)
    assert true;
    assert true;
    p#13 := Seq#Empty(): Seq BoxType;
    assume {:captureState "Test\VSI-Benchmarks\b3.dfy(59,15)"} true;
    call CevVarIntro(#tok$0^59.15, cev_local, #loc.p#13, p#13);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b3.dfy(61,9)
    assert true;
    assert true;
    n#14 := 0;
    assume {:captureState "Test\VSI-Benchmarks\b3.dfy(61,9)"} true;
    call CevVarIntro(#tok$0^61.9, cev_local, #loc.n#14, n#14);
    // ----- while statement ----- Test\VSI-Benchmarks\b3.dfy(62,5)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := Seq#Length(read($Heap, q#4, Queue.contents)) - n#14;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^62.5);
    while (true)
      invariant $w0 ==> n#14 <= Seq#Length(read($Heap, q#4, Queue.contents));
      invariant $w0 ==> n#14 == Seq#Length(p#13);
      invariant $w0 ==> (forall i#15: int :: 0 <= i#15 && i#15 < n#14 ==> $Unbox(Seq#Index(p#13, i#15)): int == i#15);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f) || $o == q#4);
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant Seq#Length(read($Heap, q#4, Queue.contents)) - n#14 <= $decr0$init$0 && (Seq#Length(read($Heap, q#4, Queue.contents)) - n#14 == $decr0$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^62.5;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.r#5, r#5);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.perm#6, perm#6);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} q#4 != null;
            assume n#14 <= Seq#Length(read($Heap, q#4, Queue.contents));
            assert {:subsumption 0} true;
            assume n#14 == Seq#Length(p#13);
            assert {:subsumption 0} (forall i#15: int :: (0 <= i#15 ==> true) && (0 <= i#15 && i#15 < n#14 ==> 0 <= i#15 && i#15 < Seq#Length(p#13)));
            assume (forall i#15: int :: 0 <= i#15 && i#15 < n#14 ==> $Unbox(Seq#Index(p#13, i#15)): int == i#15);
            assert q#4 != null;
            assume false;
        }

        assert q#4 != null;
        if (n#14 >= Seq#Length(read($Heap, q#4, Queue.contents)))
        {
            break;
        }

        call CevStepEvent(#tok$0^62.5, loop_entered);
        assume {:captureState "Test\VSI-Benchmarks\b3.dfy(62,5): loop entered"} true;
        $decr0$0 := Seq#Length(read($Heap, q#4, Queue.contents)) - n#14;
        // ----- assignment statement ----- Test\VSI-Benchmarks\b3.dfy(67,9)
        assert true;
        assert true;
        p#13 := Seq#Append(p#13, Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box(n#14), 1));
        assume {:captureState "Test\VSI-Benchmarks\b3.dfy(67,9)"} true;
        call CevUpdate(#tok$0^67.9, #loc.p#13, p#13);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b3.dfy(68,9)
        assert true;
        assert true;
        n#14 := n#14 + 1;
        assume {:captureState "Test\VSI-Benchmarks\b3.dfy(68,9)"} true;
        call CevUpdate(#tok$0^68.9, #loc.n#14, n#14);
        assert 0 <= $decr0$0 || Seq#Length(read($Heap, q#4, Queue.contents)) - n#14 == $decr0$0;
        assert Seq#Length(read($Heap, q#4, Queue.contents)) - n#14 < $decr0$0;
    }

    call CevStepEvent(#tok$0^62.5, loop_exited);
    assume {:captureState "Test\VSI-Benchmarks\b3.dfy(62,5): loop exit"} true;
    // ----- assignment statement ----- Test\VSI-Benchmarks\b3.dfy(70,10)
    assert true;
    assert true;
    perm#6 := Seq#Empty(): Seq BoxType;
    assume {:captureState "Test\VSI-Benchmarks\b3.dfy(70,10)"} true;
    call CevUpdate(#tok$0^70.10, #loc.perm#6, perm#6);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b3.dfy(71,15)
    assert true;
    assert true;
    pperm#16 := Seq#Append(p#13, perm#6);
    assume {:captureState "Test\VSI-Benchmarks\b3.dfy(71,15)"} true;
    call CevVarIntro(#tok$0^71.15, cev_local, #loc.pperm#16, pperm#16);
    // ----- while statement ----- Test\VSI-Benchmarks\b3.dfy(73,5)
    $PreLoopHeap1 := $Heap;
    $decr1$init$0 := $ite(0 <= Seq#Length(read($Heap, q#4, Queue.contents)) - 0, Seq#Length(read($Heap, q#4, Queue.contents)) - 0, 0 - Seq#Length(read($Heap, q#4, Queue.contents)));
    havoc $w1;
    call $PreLoopCevPC1 := CevPreLoop(#tok$0^73.5);
    while (true)
      invariant $w1 ==> Seq#Length(read($Heap, r#5, Queue.contents)) == Seq#Length(old(read($Heap, q#4, Queue.contents))) - Seq#Length(read($Heap, q#4, Queue.contents));
      invariant $w1 ==> (forall i#17: int, j#18: int :: 0 <= i#17 && i#17 < j#18 && j#18 < Seq#Length(read($Heap, r#5, Queue.contents)) ==> $Unbox(Seq#Index(read($Heap, r#5, Queue.contents), i#17)): int <= $Unbox(Seq#Index(read($Heap, r#5, Queue.contents), j#18)): int);
      invariant $w1 ==> (forall i#19: int, j#20: int :: 0 <= i#19 && i#19 < Seq#Length(read($Heap, r#5, Queue.contents)) && 0 <= j#20 && j#20 < Seq#Length(read($Heap, q#4, Queue.contents)) ==> $Unbox(Seq#Index(read($Heap, r#5, Queue.contents), i#19)): int <= $Unbox(Seq#Index(read($Heap, q#4, Queue.contents), j#20)): int);
      invariant $w1 ==> Seq#Equal(pperm#16, Seq#Append(p#13, perm#6));
      invariant $w1 ==> Seq#Length(p#13) == Seq#Length(read($Heap, q#4, Queue.contents));
      invariant $w1 ==> Seq#Length(perm#6) == Seq#Length(read($Heap, r#5, Queue.contents));
//      free invariant $w1 ==> Seq#Equal(pperm#16, Seq#Append(p#13, perm#6)) && Seq#Length(p#13) == Seq#Length(read($Heap, q#4, Queue.contents)) && Seq#Length(perm#6) == Seq#Length(read($Heap, r#5, Queue.contents));
      invariant $w1 ==> (forall i#21: int :: 0 <= i#21 && i#21 < Seq#Length(perm#6) ==> $Unbox(Seq#Index(perm#6, i#21)): int < Seq#Length(pperm#16));
      invariant $w1 ==> (forall i#21: int :: 0 <= i#21 && i#21 < Seq#Length(perm#6) ==> 0 <= $Unbox(Seq#Index(perm#6, i#21)): int);
      invariant $w1 ==> (forall i#22: int :: 0 <= i#22 && i#22 < Seq#Length(p#13) ==> 0 <= $Unbox(Seq#Index(p#13, i#22)): int);
      invariant $w1 ==> (forall i#22: int :: 0 <= i#22 && i#22 < Seq#Length(p#13) ==> $Unbox(Seq#Index(p#13, i#22)): int < Seq#Length(pperm#16));
      invariant $w1 ==> (forall i#23: int, j#24: int :: 0 <= i#23 && i#23 < j#24 && j#24 < Seq#Length(pperm#16) ==> $Unbox(Seq#Index(pperm#16, i#23)): int != $Unbox(Seq#Index(pperm#16, j#24)): int);
      invariant $w1 ==> (forall i#25: int :: 0 <= i#25 && i#25 < Seq#Length(perm#6) ==> $Unbox(Seq#Index(read($Heap, r#5, Queue.contents), i#25)): int == $Unbox(Seq#Index(old(read($Heap, q#4, Queue.contents)), $Unbox(Seq#Index(perm#6, i#25)): int)): int);
      invariant $w1 ==> (forall i#26: int :: 0 <= i#26 && i#26 < Seq#Length(p#13) ==> $Unbox(Seq#Index(read($Heap, q#4, Queue.contents), i#26)): int == $Unbox(Seq#Index(old(read($Heap, q#4, Queue.contents)), $Unbox(Seq#Index(p#13, i#26)): int)): int);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap1, $o, $f) || $o == q#4);
      free invariant $HeapSucc($PreLoopHeap1, $Heap);
      free invariant $ite(0 <= Seq#Length(read($Heap, q#4, Queue.contents)) - 0, Seq#Length(read($Heap, q#4, Queue.contents)) - 0, 0 - Seq#Length(read($Heap, q#4, Queue.contents))) <= $decr1$init$0 && ($ite(0 <= Seq#Length(read($Heap, q#4, Queue.contents)) - 0, Seq#Length(read($Heap, q#4, Queue.contents)) - 0, 0 - Seq#Length(read($Heap, q#4, Queue.contents))) == $decr1$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^73.5;
      free invariant $PreLoopCevPC1 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.r#5, r#5);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.perm#6, perm#6);
      kUnwind 1;
    {
        if (!$w1)
        {
            assert {:subsumption 0} r#5 != null && old(q#4 != null) && q#4 != null;
            assume Seq#Length(read($Heap, r#5, Queue.contents)) == Seq#Length(old(read($Heap, q#4, Queue.contents))) - Seq#Length(read($Heap, q#4, Queue.contents));
            assert {:subsumption 0} (forall i#17: int, j#18: int :: (0 <= i#17 ==> true) && (0 <= i#17 && i#17 < j#18 ==> r#5 != null) && (0 <= i#17 && i#17 < j#18 && j#18 < Seq#Length(read($Heap, r#5, Queue.contents)) ==> r#5 != null && 0 <= i#17 && i#17 < Seq#Length(read($Heap, r#5, Queue.contents)) && r#5 != null && 0 <= j#18 && j#18 < Seq#Length(read($Heap, r#5, Queue.contents))));
            assume (forall i#17: int, j#18: int :: 0 <= i#17 && i#17 < j#18 && j#18 < Seq#Length(read($Heap, r#5, Queue.contents)) ==> $Unbox(Seq#Index(read($Heap, r#5, Queue.contents), i#17)): int <= $Unbox(Seq#Index(read($Heap, r#5, Queue.contents), j#18)): int);
            assert {:subsumption 0} (forall i#19: int, j#20: int :: (0 <= i#19 ==> r#5 != null) && (0 <= i#19 && i#19 < Seq#Length(read($Heap, r#5, Queue.contents)) ==> true) && (0 <= i#19 && i#19 < Seq#Length(read($Heap, r#5, Queue.contents)) && 0 <= j#20 ==> q#4 != null) && (0 <= i#19 && i#19 < Seq#Length(read($Heap, r#5, Queue.contents)) && 0 <= j#20 && j#20 < Seq#Length(read($Heap, q#4, Queue.contents)) ==> r#5 != null && 0 <= i#19 && i#19 < Seq#Length(read($Heap, r#5, Queue.contents)) && q#4 != null && 0 <= j#20 && j#20 < Seq#Length(read($Heap, q#4, Queue.contents))));
            assume (forall i#19: int, j#20: int :: 0 <= i#19 && i#19 < Seq#Length(read($Heap, r#5, Queue.contents)) && 0 <= j#20 && j#20 < Seq#Length(read($Heap, q#4, Queue.contents)) ==> $Unbox(Seq#Index(read($Heap, r#5, Queue.contents), i#19)): int <= $Unbox(Seq#Index(read($Heap, q#4, Queue.contents), j#20)): int);
            assert {:subsumption 0} (Seq#Equal(pperm#16, Seq#Append(p#13, perm#6)) ==> q#4 != null) && (Seq#Equal(pperm#16, Seq#Append(p#13, perm#6)) && Seq#Length(p#13) == Seq#Length(read($Heap, q#4, Queue.contents)) ==> r#5 != null);
            assume Seq#Equal(pperm#16, Seq#Append(p#13, perm#6)) && Seq#Length(p#13) == Seq#Length(read($Heap, q#4, Queue.contents)) && Seq#Length(perm#6) == Seq#Length(read($Heap, r#5, Queue.contents));
            assert {:subsumption 0} (forall i#21: int :: (0 <= i#21 ==> true) && (0 <= i#21 && i#21 < Seq#Length(perm#6) ==> 0 <= i#21 && i#21 < Seq#Length(perm#6) && (0 <= $Unbox(Seq#Index(perm#6, i#21)): int ==> 0 <= i#21 && i#21 < Seq#Length(perm#6))));
            assume (forall i#21: int :: 0 <= i#21 && i#21 < Seq#Length(perm#6) ==> 0 <= $Unbox(Seq#Index(perm#6, i#21)): int && $Unbox(Seq#Index(perm#6, i#21)): int < Seq#Length(pperm#16));
            assert {:subsumption 0} (forall i#22: int :: (0 <= i#22 ==> true) && (0 <= i#22 && i#22 < Seq#Length(p#13) ==> 0 <= i#22 && i#22 < Seq#Length(p#13) && (0 <= $Unbox(Seq#Index(p#13, i#22)): int ==> 0 <= i#22 && i#22 < Seq#Length(p#13))));
            assume (forall i#22: int :: 0 <= i#22 && i#22 < Seq#Length(p#13) ==> 0 <= $Unbox(Seq#Index(p#13, i#22)): int && $Unbox(Seq#Index(p#13, i#22)): int < Seq#Length(pperm#16));
            assert {:subsumption 0} (forall i#23: int, j#24: int :: (0 <= i#23 ==> true) && (0 <= i#23 && i#23 < j#24 ==> true) && (0 <= i#23 && i#23 < j#24 && j#24 < Seq#Length(pperm#16) ==> 0 <= i#23 && i#23 < Seq#Length(pperm#16) && 0 <= j#24 && j#24 < Seq#Length(pperm#16)));
            assume (forall i#23: int, j#24: int :: 0 <= i#23 && i#23 < j#24 && j#24 < Seq#Length(pperm#16) ==> $Unbox(Seq#Index(pperm#16, i#23)): int != $Unbox(Seq#Index(pperm#16, j#24)): int);
            assert {:subsumption 0} (forall i#25: int :: (0 <= i#25 ==> true) && (0 <= i#25 && i#25 < Seq#Length(perm#6) ==> r#5 != null && 0 <= i#25 && i#25 < Seq#Length(read($Heap, r#5, Queue.contents)) && old(q#4 != null) && 0 <= i#25 && i#25 < Seq#Length(perm#6) && 0 <= $Unbox(Seq#Index(perm#6, i#25)): int && $Unbox(Seq#Index(perm#6, i#25)): int < Seq#Length(old(read($Heap, q#4, Queue.contents)))));
            assume (forall i#25: int :: 0 <= i#25 && i#25 < Seq#Length(perm#6) ==> $Unbox(Seq#Index(read($Heap, r#5, Queue.contents), i#25)): int == $Unbox(Seq#Index(old(read($Heap, q#4, Queue.contents)), $Unbox(Seq#Index(perm#6, i#25)): int)): int);
            assert {:subsumption 0} (forall i#26: int :: (0 <= i#26 ==> true) && (0 <= i#26 && i#26 < Seq#Length(p#13) ==> q#4 != null && 0 <= i#26 && i#26 < Seq#Length(read($Heap, q#4, Queue.contents)) && old(q#4 != null) && 0 <= i#26 && i#26 < Seq#Length(p#13) && 0 <= $Unbox(Seq#Index(p#13, i#26)): int && $Unbox(Seq#Index(p#13, i#26)): int < Seq#Length(old(read($Heap, q#4, Queue.contents)))));
            assume (forall i#26: int :: 0 <= i#26 && i#26 < Seq#Length(p#13) ==> $Unbox(Seq#Index(read($Heap, q#4, Queue.contents), i#26)): int == $Unbox(Seq#Index(old(read($Heap, q#4, Queue.contents)), $Unbox(Seq#Index(p#13, i#26)): int)): int);
            assert q#4 != null && (0 <= Seq#Length(read($Heap, q#4, Queue.contents)) - 0 ==> q#4 != null) && (0 > Seq#Length(read($Heap, q#4, Queue.contents)) - 0 ==> q#4 != null);
            assume false;
        }

        assert q#4 != null;
        if (Seq#Length(read($Heap, q#4, Queue.contents)) == 0)
        {
            break;
        }

        call CevStepEvent(#tok$0^73.5, loop_entered);
        assume {:captureState "Test\VSI-Benchmarks\b3.dfy(73,5): loop entered"} true;
        $decr1$0 := $ite(0 <= Seq#Length(read($Heap, q#4, Queue.contents)) - 0, Seq#Length(read($Heap, q#4, Queue.contents)) - 0, 0 - Seq#Length(read($Heap, q#4, Queue.contents)));
        // ----- var-declaration statement ----- Test\VSI-Benchmarks\b3.dfy(91,12)
        call CevVarIntro(#tok$0^91.12, cev_local, #loc.m#27, m#27);
        // ----- var-declaration statement ----- Test\VSI-Benchmarks\b3.dfy(91,14)
        call CevVarIntro(#tok$0^91.14, cev_local, #loc.k#28, k#28);
        // ----- call statement ----- Test\VSI-Benchmarks\b3.dfy(91,7)
        assert true;
        q#46 := q#4;
        assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == q#46 ==> $_Frame[$o, $f]);
        call m#27, k#28 := Benchmark3.RemoveMin(this, q#46);
        call CevUpdateHere(#loc.m, m#27);
        call CevUpdateHere(#loc.k, k#28);
        call CevStep(#tok$0^91.7);
        assume {:captureState "Test\VSI-Benchmarks\b3.dfy(91,7)"} true;
        // ----- assignment statement ----- Test\VSI-Benchmarks\b3.dfy(92,12)
        assert true;
        assert 0 <= k#28 && k#28 < Seq#Length(p#13);
        perm#6 := Seq#Append(perm#6, Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box($Unbox(Seq#Index(p#13, k#28)): int), 1));
        assume {:captureState "Test\VSI-Benchmarks\b3.dfy(92,12)"} true;
        call CevUpdate(#tok$0^92.12, #loc.perm#6, perm#6);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b3.dfy(93,9)
        assert true;
        assert 0 <= k#28 + 1 && k#28 + 1 <= Seq#Length(p#13) && 0 <= k#28 && k#28 <= Seq#Length(p#13);
        p#13 := Seq#Append(Seq#Drop(p#13, k#28 + 1), Seq#Take(p#13, k#28));
        assume {:captureState "Test\VSI-Benchmarks\b3.dfy(93,9)"} true;
        call CevUpdate(#tok$0^93.9, #loc.p#13, p#13);
        // ----- call statement ----- Test\VSI-Benchmarks\b3.dfy(94,7)
        assert true;
        x#47 := $Box(m#27);
        assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == r#5 ==> $_Frame[$o, $f]);
        call Queue.Enqueue(r#5, x#47);
        call CevStep(#tok$0^94.7);
        assume {:captureState "Test\VSI-Benchmarks\b3.dfy(94,7)"} true;
        // ----- assignment statement ----- Test\VSI-Benchmarks\b3.dfy(95,13)
        assert true;
        assert 0 <= k#28 + 1 && k#28 + 1 <= Seq#Length(pperm#16) && k#28 + 1 <= Seq#Length(p#13) + 1 && Seq#Length(p#13) + 1 <= Seq#Length(pperm#16) && 0 <= k#28 && k#28 <= Seq#Length(pperm#16) && 0 <= Seq#Length(p#13) + 1 && Seq#Length(p#13) + 1 <= Seq#Length(pperm#16) && 0 <= k#28 && k#28 < Seq#Length(pperm#16);
        pperm#16 := Seq#Append(Seq#Append(Seq#Append(Seq#Drop(Seq#Take(pperm#16, Seq#Length(p#13) + 1), k#28 + 1), Seq#Take(pperm#16, k#28)), Seq#Drop(pperm#16, Seq#Length(p#13) + 1)), Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box($Unbox(Seq#Index(pperm#16, k#28)): int), 1));
        assume {:captureState "Test\VSI-Benchmarks\b3.dfy(95,13)"} true;
        call CevUpdate(#tok$0^95.13, #loc.pperm#16, pperm#16);
        assert 0 <= $decr1$0 || $ite(0 <= Seq#Length(read($Heap, q#4, Queue.contents)) - 0, Seq#Length(read($Heap, q#4, Queue.contents)) - 0, 0 - Seq#Length(read($Heap, q#4, Queue.contents))) == $decr1$0;
        assert $ite(0 <= Seq#Length(read($Heap, q#4, Queue.contents)) - 0, Seq#Length(read($Heap, q#4, Queue.contents)) - 0, 0 - Seq#Length(read($Heap, q#4, Queue.contents))) < $decr1$0;
    }

    call CevStepEvent(#tok$0^73.5, loop_exited);
    assume {:captureState "Test\VSI-Benchmarks\b3.dfy(73,5): loop exit"} true;
}



const unique #tok$0^101.10: $token;

procedure CheckWellformed$$Benchmark3.RemoveMin(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Benchmark3, q#29: ref where q#29 == null || (read($Heap, q#29, alloc) && dtype(q#29) == class.Queue && TypeParams(q#29, 0) == class.int)) returns (m#30: int, k#31: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^101.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^101.20: $token;

const unique #loc.q#29: $token;

const unique #tok$0^101.44: $token;

const unique #loc.m#30: $token;

const unique #tok$0^101.52: $token;

const unique #loc.k#31: $token;



procedure Benchmark3.RemoveMin(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Benchmark3, q#29: ref where q#29 == null || (read($Heap, q#29, alloc) && dtype(q#29) == class.Queue && TypeParams(q#29, 0) == class.int)) returns (m#30: int, k#31: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires q#29 != null && Seq#Length(read($Heap, q#29, Queue.contents)) != 0;
  requires true ==> q#29 != null;
  requires true ==> Seq#Length(read($Heap, q#29, Queue.contents)) != 0;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^101.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures Seq#Length(old(read($Heap, q#29, Queue.contents))) == Seq#Length(read($Heap, q#29, Queue.contents)) + 1;
  free ensures 0 <= k#31 && k#31 < Seq#Length(old(read($Heap, q#29, Queue.contents))) && old($Unbox(Seq#Index(read($Heap, q#29, Queue.contents), k#31)): int) == m#30;
  ensures true ==> 0 <= k#31;
  ensures true ==> k#31 < Seq#Length(old(read($Heap, q#29, Queue.contents)));
  ensures true ==> old($Unbox(Seq#Index(read($Heap, q#29, Queue.contents), k#31)): int) == m#30;
  ensures (forall i#32: int :: 0 <= i#32 && i#32 < Seq#Length(read($Heap, q#29, Queue.contents)) ==> m#30 <= $Unbox(Seq#Index(read($Heap, q#29, Queue.contents), i#32)): int);
  ensures Seq#Equal(read($Heap, q#29, Queue.contents), Seq#Append(Seq#Drop(old(read($Heap, q#29, Queue.contents)), k#31 + 1), Seq#Take(old(read($Heap, q#29, Queue.contents)), k#31)));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == q#29);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.n#33: $token;

const unique #tok$0^109.9: $token;

const unique #tok$0^110.7: $token;

const unique #tok$0^111.7: $token;

const unique #loc.j#34: $token;

const unique #tok$0^112.9: $token;

const unique #tok$0^114.5: $token;

const unique #loc.x#36: $token;

const unique #tok$0^120.12: $token;

const unique #loc.x: $token;

const unique #tok$0^120.7: $token;

const unique #tok$0^121.7: $token;

const unique #tok$0^122.7: $token;

const unique #tok$0^122.18: $token;

const unique #tok$0^122.22: $token;

const unique #tok$0^122.30: $token;

const unique #tok$0^123.9: $token;

const unique #tok$0^126.7: $token;

const unique #tok$0^127.5: $token;

const unique #loc.x#37: $token;

const unique #tok$0^131.12: $token;

const unique #tok$0^131.7: $token;

const unique #tok$0^132.7: $token;

const unique #tok$0^133.9: $token;

const unique #tok$0^136.5: $token;

implementation Benchmark3.RemoveMin(this: ref, q#29: ref) returns (m#30: int, k#31: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var n#33: int where #cev_var_update(#cev_pc, cev_local, #loc.n#33, n#33);
  var j#34: int where #cev_var_update(#cev_pc, cev_local, #loc.j#34, j#34);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;
  var x#36: int where #cev_var_update(#cev_pc, cev_local, #loc.x#36, x#36);
  var $tmp#0: BoxType;
  var x#49: BoxType;
  var $PreLoopHeap1: HeapType;
  var $decr1$init$0: int;
  var $w1: bool;
  var $PreLoopCevPC1: int;
  var $decr1$0: int;
  var x#37: int where #cev_var_update(#cev_pc, cev_local, #loc.x#37, x#37);
  var $tmp#1: BoxType;
  var x#50: BoxType;
  var $tmp#2: BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^101.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^101.20, cev_parameter, #loc.q#29, q#29);
    call CevVarIntro(#tok$0^101.44, cev_local, #loc.m#30, m#30);
    call CevVarIntro(#tok$0^101.52, cev_local, #loc.k#31, k#31);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == q#29);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b3.dfy(109,9)
    assert true;
    assert q#29 != null;
    n#33 := Seq#Length(read($Heap, q#29, Queue.contents));
    assume {:captureState "Test\VSI-Benchmarks\b3.dfy(109,9)"} true;
    call CevVarIntro(#tok$0^109.9, cev_local, #loc.n#33, n#33);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b3.dfy(110,7)
    assert true;
    assert true;
    k#31 := 0;
    assume {:captureState "Test\VSI-Benchmarks\b3.dfy(110,7)"} true;
    call CevUpdate(#tok$0^110.7, #loc.k#31, k#31);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b3.dfy(111,7)
    assert true;
    assert q#29 != null && 0 < Seq#Length(read($Heap, q#29, Queue.contents));
    m#30 := $Unbox(Queue.Head($Heap, q#29)): int;
    assume {:captureState "Test\VSI-Benchmarks\b3.dfy(111,7)"} true;
    call CevUpdate(#tok$0^111.7, #loc.m#30, m#30);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b3.dfy(112,9)
    assert true;
    assert true;
    j#34 := 0;
    assume {:captureState "Test\VSI-Benchmarks\b3.dfy(112,9)"} true;
    call CevVarIntro(#tok$0^112.9, cev_local, #loc.j#34, j#34);
    // ----- while statement ----- Test\VSI-Benchmarks\b3.dfy(114,5)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := n#33 - j#34;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^114.5);
    while (true)
      invariant $w0 ==> j#34 <= n#33;
      invariant $w0 ==> Seq#Equal(read($Heap, q#29, Queue.contents), Seq#Append(Seq#Drop(old(read($Heap, q#29, Queue.contents)), j#34), Seq#Take(old(read($Heap, q#29, Queue.contents)), j#34)));
      invariant $w0 ==> 0 <= k#31;
      invariant $w0 ==> k#31 < Seq#Length(old(read($Heap, q#29, Queue.contents)));
      invariant $w0 ==> $Unbox(Seq#Index(old(read($Heap, q#29, Queue.contents)), k#31)): int == m#30;
//      free invariant $w0 ==> 0 <= k#31 && k#31 < Seq#Length(old(read($Heap, q#29, Queue.contents))) && $Unbox(Seq#Index(old(read($Heap, q#29, Queue.contents)), k#31)): int == m#30;
      invariant $w0 ==> (forall i#35: int :: 0 <= i#35 && i#35 < j#34 ==> m#30 <= $Unbox(Seq#Index(old(read($Heap, q#29, Queue.contents)), i#35)): int);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f) || $o == q#29);
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant n#33 - j#34 <= $decr0$init$0 && (n#33 - j#34 == $decr0$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^114.5;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.m#30, m#30);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.k#31, k#31);	
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} true;
            assume j#34 <= n#33;
            assert {:subsumption 0} q#29 != null && old(q#29 != null) && 0 <= j#34 && j#34 <= Seq#Length(old(read($Heap, q#29, Queue.contents))) && old(q#29 != null) && 0 <= j#34 && j#34 <= Seq#Length(old(read($Heap, q#29, Queue.contents)));
            assume Seq#Equal(read($Heap, q#29, Queue.contents), Seq#Append(Seq#Drop(old(read($Heap, q#29, Queue.contents)), j#34), Seq#Take(old(read($Heap, q#29, Queue.contents)), j#34)));
            assert {:subsumption 0} (0 <= k#31 ==> old(q#29 != null)) && (0 <= k#31 && k#31 < Seq#Length(old(read($Heap, q#29, Queue.contents))) ==> old(q#29 != null) && 0 <= k#31 && k#31 < Seq#Length(old(read($Heap, q#29, Queue.contents))));
            assume 0 <= k#31 && k#31 < Seq#Length(old(read($Heap, q#29, Queue.contents))) && $Unbox(Seq#Index(old(read($Heap, q#29, Queue.contents)), k#31)): int == m#30;
            assert {:subsumption 0} (forall i#35: int :: (0 <= i#35 ==> true) && (0 <= i#35 && i#35 < j#34 ==> old(q#29 != null) && 0 <= i#35 && i#35 < Seq#Length(old(read($Heap, q#29, Queue.contents)))));
            assume (forall i#35: int :: 0 <= i#35 && i#35 < j#34 ==> m#30 <= $Unbox(Seq#Index(old(read($Heap, q#29, Queue.contents)), i#35)): int);
            assert true;
            assume false;
        }

        assert true;
        if (j#34 >= n#33)
        {
            break;
        }

        call CevStepEvent(#tok$0^114.5, loop_entered);
        assume {:captureState "Test\VSI-Benchmarks\b3.dfy(114,5): loop entered"} true;
        $decr0$0 := n#33 - j#34;
        // ----- var-declaration statement ----- Test\VSI-Benchmarks\b3.dfy(120,12)
        call CevVarIntro(#tok$0^120.12, cev_local, #loc.x#36, x#36);
        // ----- call statement ----- Test\VSI-Benchmarks\b3.dfy(120,7)
        assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == q#29 ==> $_Frame[$o, $f]);
        call $tmp#0 := Queue.Dequeue(q#29);
        x#36 := $Unbox($tmp#0): int;
        call CevUpdateHere(#loc.x, x#36);
        call CevStep(#tok$0^120.7);
        assume {:captureState "Test\VSI-Benchmarks\b3.dfy(120,7)"} true;
        // ----- call statement ----- Test\VSI-Benchmarks\b3.dfy(121,7)
        assert true;
        x#49 := $Box(x#36);
        assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == q#29 ==> $_Frame[$o, $f]);
        call Queue.Enqueue(q#29, x#49);
        call CevStep(#tok$0^121.7);
        assume {:captureState "Test\VSI-Benchmarks\b3.dfy(121,7)"} true;
        // ----- if statement ----- Test\VSI-Benchmarks\b3.dfy(122,7)
        call CevEvent(#tok$0^122.7, conditional_moment);
        assert true;
        if (x#36 < m#30)
        {
            call CevEvent(#tok$0^122.18, took_then_branch);
            // ----- assignment statement ----- Test\VSI-Benchmarks\b3.dfy(122,22)
            assert true;
            assert true;
            k#31 := j#34;
            assume {:captureState "Test\VSI-Benchmarks\b3.dfy(122,22)"} true;
            call CevUpdate(#tok$0^122.22, #loc.k#31, k#31);
            // ----- assignment statement ----- Test\VSI-Benchmarks\b3.dfy(122,30)
            assert true;
            assert true;
            m#30 := x#36;
            assume {:captureState "Test\VSI-Benchmarks\b3.dfy(122,30)"} true;
            call CevUpdate(#tok$0^122.30, #loc.m#30, m#30);
        }
        else
        {
            call CevEvent(#tok$0^122.7, took_else_branch);
        }

        // ----- assignment statement ----- Test\VSI-Benchmarks\b3.dfy(123,9)
        assert true;
        assert true;
        j#34 := j#34 + 1;
        assume {:captureState "Test\VSI-Benchmarks\b3.dfy(123,9)"} true;
        call CevUpdate(#tok$0^123.9, #loc.j#34, j#34);
        assert 0 <= $decr0$0 || n#33 - j#34 == $decr0$0;
        assert n#33 - j#34 < $decr0$0;
    }

    call CevStepEvent(#tok$0^114.5, loop_exited);
    assume {:captureState "Test\VSI-Benchmarks\b3.dfy(114,5): loop exit"} true;
    // ----- assignment statement ----- Test\VSI-Benchmarks\b3.dfy(126,7)
    assert true;
    assert true;
    j#34 := 0;
    assume {:captureState "Test\VSI-Benchmarks\b3.dfy(126,7)"} true;
    call CevUpdate(#tok$0^126.7, #loc.j#34, j#34);
    // ----- while statement ----- Test\VSI-Benchmarks\b3.dfy(127,5)
    $PreLoopHeap1 := $Heap;
    $decr1$init$0 := k#31 - j#34;
    havoc $w1;
    call $PreLoopCevPC1 := CevPreLoop(#tok$0^127.5);
    while (true)
      invariant $w1 ==> j#34 <= k#31;
      invariant $w1 ==> Seq#Equal(read($Heap, q#29, Queue.contents), Seq#Append(Seq#Drop(old(read($Heap, q#29, Queue.contents)), j#34), Seq#Take(old(read($Heap, q#29, Queue.contents)), j#34)));
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap1, $o, $f) || $o == q#29);
      free invariant $HeapSucc($PreLoopHeap1, $Heap);
      free invariant k#31 - j#34 <= $decr1$init$0 && (k#31 - j#34 == $decr1$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^127.5;
      free invariant $PreLoopCevPC1 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.m#30, m#30);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.k#31, k#31);
      kUnwind 1;
    {
        if (!$w1)
        {
            assert {:subsumption 0} true;
            assume j#34 <= k#31;
            assert {:subsumption 0} q#29 != null && old(q#29 != null) && 0 <= j#34 && j#34 <= Seq#Length(old(read($Heap, q#29, Queue.contents))) && old(q#29 != null) && 0 <= j#34 && j#34 <= Seq#Length(old(read($Heap, q#29, Queue.contents)));
            assume Seq#Equal(read($Heap, q#29, Queue.contents), Seq#Append(Seq#Drop(old(read($Heap, q#29, Queue.contents)), j#34), Seq#Take(old(read($Heap, q#29, Queue.contents)), j#34)));
            assert true;
            assume false;
        }

        assert true;
        if (j#34 >= k#31)
        {
            break;
        }

        call CevStepEvent(#tok$0^127.5, loop_entered);
        assume {:captureState "Test\VSI-Benchmarks\b3.dfy(127,5): loop entered"} true;
        $decr1$0 := k#31 - j#34;
        // ----- var-declaration statement ----- Test\VSI-Benchmarks\b3.dfy(131,12)
        call CevVarIntro(#tok$0^131.12, cev_local, #loc.x#37, x#37);
        // ----- call statement ----- Test\VSI-Benchmarks\b3.dfy(131,7)
        assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == q#29 ==> $_Frame[$o, $f]);
        call $tmp#1 := Queue.Dequeue(q#29);
        x#37 := $Unbox($tmp#1): int;
        call CevUpdateHere(#loc.x, x#37);
        call CevStep(#tok$0^131.7);
        assume {:captureState "Test\VSI-Benchmarks\b3.dfy(131,7)"} true;
        // ----- call statement ----- Test\VSI-Benchmarks\b3.dfy(132,7)
        assert true;
        x#50 := $Box(x#37);
        assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == q#29 ==> $_Frame[$o, $f]);
        call Queue.Enqueue(q#29, x#50);
        call CevStep(#tok$0^132.7);
        assume {:captureState "Test\VSI-Benchmarks\b3.dfy(132,7)"} true;
        // ----- assignment statement ----- Test\VSI-Benchmarks\b3.dfy(133,9)
        assert true;
        assert true;
        j#34 := j#34 + 1;
        assume {:captureState "Test\VSI-Benchmarks\b3.dfy(133,9)"} true;
        call CevUpdate(#tok$0^133.9, #loc.j#34, j#34);
        assert 0 <= $decr1$0 || k#31 - j#34 == $decr1$0;
        assert k#31 - j#34 < $decr1$0;
    }

    call CevStepEvent(#tok$0^127.5, loop_exited);
    assume {:captureState "Test\VSI-Benchmarks\b3.dfy(127,5): loop exit"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b3.dfy(136,5)
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == q#29 ==> $_Frame[$o, $f]);
    call $tmp#2 := Queue.Dequeue(q#29);
    m#30 := $Unbox($tmp#2): int;
    call CevUpdateHere(#loc.m, m#30);
    call CevStep(#tok$0^136.5);
    assume {:captureState "Test\VSI-Benchmarks\b3.dfy(136,5)"} true;
}



const unique class._default: ClassName;
