// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: Test\VSI-Benchmarks\b6.dfy /print:..\boogie-k-induction-benchmarks\benchmarks\VSI-b6.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class.Collection: ClassName;

axiom FDim(Collection.footprint) == 0 && DeclType(Collection.footprint) == class.Collection;

const unique Collection.footprint: Field (Set BoxType);

axiom (forall $h: HeapType, $o: ref, $t: BoxType :: { read($h, $o, Collection.footprint)[$t] } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) && read($h, $o, Collection.footprint)[$t] ==> $Unbox($t): ref == null || read($h, $Unbox($t): ref, alloc));

axiom FDim(Collection.elements) == 0 && DeclType(Collection.elements) == class.Collection;

const unique Collection.elements: Field (Seq BoxType);

function Collection.Valid($heap: HeapType, this: ref) : bool;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (9 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref :: { Collection.Valid($Heap, this) } $IsGoodHeap($Heap) && this != null ==> Collection.Valid($Heap, this) == read($Heap, this, Collection.footprint)[$Box(this)]);

// frame axiom for Collection.Valid
axiom (forall $h0: HeapType, $h1: HeapType, this: ref :: { $HeapSucc($h0, $h1), Collection.Valid($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Collection && read($h1, this, alloc) && dtype(this) == class.Collection && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && ($o == this || read($h0, this, Collection.footprint)[$Box($o)]) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Collection.Valid($h0, this) == Collection.Valid($h1, this));

procedure CheckWellformed$$Collection.Valid(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Collection);
  free requires 0 == $ModuleContextHeight && 9 == $FunctionContextHeight;



implementation CheckWellformed$$Collection.Valid(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || read($Heap, this, Collection.footprint)[$Box($o)]);
    assert $_Frame[this, Collection.footprint];
}



const unique xxxxxfile: $token;

axiom $file_name_is(0, xxxxxfile);

const unique #tok$0^12.10: $token;

procedure CheckWellformed$$Collection.GetCount(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Collection) returns (c#0: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^12.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.this: $token;

const unique #tok$0^12.30: $token;

const unique #loc.c#0: $token;

implementation CheckWellformed$$Collection.GetCount(this: ref) returns (c#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^12.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^12.30, cev_local, #loc.c#0, c#0);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume Collection.Valid($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc c#0;
    assume 0 <= c#0;
}



procedure Collection.GetCount(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Collection) returns (c#0: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires Collection.Valid($Heap, this);
  free requires Collection.Valid($Heap, this) ==> read($Heap, this, Collection.footprint)[$Box(this)];
  requires (Collection.Valid($Heap, this) ==> read($Heap, this, Collection.footprint)[$Box(this)]) ==> read($Heap, this, Collection.footprint)[$Box(this)];
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^12.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures 0 <= c#0;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^16.6: $token;

implementation Collection.GetCount(this: ref) returns (c#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^12.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^12.30, cev_local, #loc.c#0, c#0);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b6.dfy(16,6)
    assert true;
    assert true;
    c#0 := Seq#Length(read($Heap, this, Collection.elements));
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(16,6)"} true;
    call CevUpdate(#tok$0^16.6, #loc.c#0, c#0);
}



const unique #tok$0^19.10: $token;

procedure CheckWellformed$$Collection.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Collection);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^19.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



implementation CheckWellformed$$Collection.Init(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^19.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (Collection.Valid($Heap, this))
    {
    }

    assume Collection.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, Collection.footprint)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc));
}



procedure Collection.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Collection);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^19.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures Collection.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, Collection.footprint)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc));
  free ensures Collection.Valid($Heap, this) ==> read($Heap, this, Collection.footprint)[$Box(this)];
  ensures (Collection.Valid($Heap, this) ==> read($Heap, this, Collection.footprint)[$Box(this)]) ==> read($Heap, this, Collection.footprint)[$Box(this)];
  ensures (Collection.Valid($Heap, this) ==> read($Heap, this, Collection.footprint)[$Box(this)]) ==> (forall $o: ref :: $o != null && read($Heap, this, Collection.footprint)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^23.14: $token;

const unique #tok$0^24.15: $token;

implementation Collection.Init(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^19.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b6.dfy(23,14)
    assert true;
    assert true;
    assert $_Frame[this, Collection.elements];
    $Heap := update($Heap, this, Collection.elements, Seq#Empty(): Seq BoxType);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(23,14)"} true;
    call CevUpdateHeap(#tok$0^23.14, #loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b6.dfy(24,15)
    assert true;
    assert true;
    assert $_Frame[this, Collection.footprint];
    $Heap := update($Heap, this, Collection.footprint, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(24,15)"} true;
    call CevUpdateHeap(#tok$0^24.15, #loc.$Heap, $Heap);
}



const unique #tok$0^27.10: $token;

procedure CheckWellformed$$Collection.GetItem(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Collection, i#1: int) returns (x#2: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^27.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^27.18: $token;

const unique #loc.i#1: $token;

const unique #tok$0^27.35: $token;

const unique #loc.x#2: $token;

implementation CheckWellformed$$Collection.GetItem(this: ref, i#1: int) returns (x#2: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^27.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^27.18, cev_parameter, #loc.i#1, i#1);
    call CevVarIntro(#tok$0^27.35, cev_local, #loc.x#2, x#2);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume Collection.Valid($Heap, this);
    if (0 <= i#1)
    {
    }

    assume 0 <= i#1 && i#1 < Seq#Length(read($Heap, this, Collection.elements));
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc x#2;
    assert 0 <= i#1 && i#1 < Seq#Length(read($Heap, this, Collection.elements));
    assume Seq#Index(read($Heap, this, Collection.elements), i#1) == x#2;
}



procedure Collection.GetItem(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Collection, i#1: int) returns (x#2: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires Collection.Valid($Heap, this);
  free requires Collection.Valid($Heap, this) ==> read($Heap, this, Collection.footprint)[$Box(this)];
  requires (Collection.Valid($Heap, this) ==> read($Heap, this, Collection.footprint)[$Box(this)]) ==> read($Heap, this, Collection.footprint)[$Box(this)];
  free requires 0 <= i#1 && i#1 < Seq#Length(read($Heap, this, Collection.elements));
  requires true ==> 0 <= i#1;
  requires true ==> i#1 < Seq#Length(read($Heap, this, Collection.elements));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^27.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures Seq#Index(read($Heap, this, Collection.elements), i#1) == x#2;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^32.6: $token;

implementation Collection.GetItem(this: ref, i#1: int) returns (x#2: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^27.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^27.18, cev_parameter, #loc.i#1, i#1);
    call CevVarIntro(#tok$0^27.35, cev_local, #loc.x#2, x#2);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b6.dfy(32,6)
    assert true;
    assert 0 <= i#1 && i#1 < Seq#Length(read($Heap, this, Collection.elements));
    x#2 := Seq#Index(read($Heap, this, Collection.elements), i#1);
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(32,6)"} true;
    call CevUpdate(#tok$0^32.6, #loc.x#2, x#2);
}



const unique #tok$0^35.10: $token;

procedure CheckWellformed$$Collection.Add(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Collection, x#3: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^35.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^35.14: $token;

const unique #loc.x#3: $token;

implementation CheckWellformed$$Collection.Add(this: ref, x#3: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^35.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^35.14, cev_parameter, #loc.x#3, x#3);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, Collection.footprint)[$Box($o)]);
    assume Collection.Valid($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (Collection.Valid($Heap, this))
    {
    }

    assume Collection.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, Collection.footprint)[$Box($o)] && !old(read($Heap, this, Collection.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
    assume Seq#Equal(read($Heap, this, Collection.elements), Seq#Append(old(read($Heap, this, Collection.elements)), Seq#Build(Seq#Empty(): Seq BoxType, 0, x#3, 1)));
}



procedure Collection.Add(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Collection, x#3: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires Collection.Valid($Heap, this);
  free requires Collection.Valid($Heap, this) ==> read($Heap, this, Collection.footprint)[$Box(this)];
  requires (Collection.Valid($Heap, this) ==> read($Heap, this, Collection.footprint)[$Box(this)]) ==> read($Heap, this, Collection.footprint)[$Box(this)];
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^35.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures Collection.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, Collection.footprint)[$Box($o)] && !old(read($Heap, this, Collection.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  free ensures Collection.Valid($Heap, this) ==> read($Heap, this, Collection.footprint)[$Box(this)];
  ensures (Collection.Valid($Heap, this) ==> read($Heap, this, Collection.footprint)[$Box(this)]) ==> read($Heap, this, Collection.footprint)[$Box(this)];
  ensures (Collection.Valid($Heap, this) ==> read($Heap, this, Collection.footprint)[$Box(this)]) ==> (forall $o: ref :: $o != null && read($Heap, this, Collection.footprint)[$Box($o)] && !old(read($Heap, this, Collection.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  ensures Seq#Equal(read($Heap, this, Collection.elements), Seq#Append(old(read($Heap, this, Collection.elements)), Seq#Build(Seq#Empty(): Seq BoxType, 0, x#3, 1)));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || read(old($Heap), this, Collection.footprint)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^41.13: $token;

implementation Collection.Add(this: ref, x#3: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^35.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^35.14, cev_parameter, #loc.x#3, x#3);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, Collection.footprint)[$Box($o)]);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b6.dfy(41,13)
    assert true;
    assert true;
    assert $_Frame[this, Collection.elements];
    $Heap := update($Heap, this, Collection.elements, Seq#Append(read($Heap, this, Collection.elements), Seq#Build(Seq#Empty(): Seq BoxType, 0, x#3, 1)));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(41,13)"} true;
    call CevUpdateHeap(#tok$0^41.13, #loc.$Heap, $Heap);
}



const unique #tok$0^44.10: $token;

procedure CheckWellformed$$Collection.GetIterator(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Collection) returns (iter#4: ref where iter#4 == null || (read($Heap, iter#4, alloc) && dtype(iter#4) == class.Iterator));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^44.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^44.33: $token;

const unique #loc.iter#4: $token;

axiom FDim(Iterator.footprint) == 0 && DeclType(Iterator.footprint) == class.Iterator;

axiom FDim(Iterator.pos) == 0 && DeclType(Iterator.pos) == class.Iterator;

axiom FDim(Iterator.c) == 0 && DeclType(Iterator.c) == class.Iterator;

implementation CheckWellformed$$Collection.GetIterator(this: ref) returns (iter#4: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^44.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^44.33, cev_local, #loc.iter#4, iter#4);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume Collection.Valid($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc iter#4;
    if (iter#4 != null)
    {
        assert iter#4 != null;
    }

    assume iter#4 != null && Iterator.Valid($Heap, iter#4);
    assert iter#4 != null;
    if ((forall $o: ref :: $o != null && read($Heap, iter#4, Iterator.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc)))
    {
        assert iter#4 != null;
    }

    assume (forall $o: ref :: $o != null && read($Heap, iter#4, Iterator.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc)) && read($Heap, iter#4, Iterator.pos) == 0 - 1;
    assert iter#4 != null;
    assume read($Heap, iter#4, Iterator.c) == this;
}



procedure Collection.GetIterator(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Collection) returns (iter#4: ref where iter#4 == null || (read($Heap, iter#4, alloc) && dtype(iter#4) == class.Iterator));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires Collection.Valid($Heap, this);
  free requires Collection.Valid($Heap, this) ==> read($Heap, this, Collection.footprint)[$Box(this)];
  requires (Collection.Valid($Heap, this) ==> read($Heap, this, Collection.footprint)[$Box(this)]) ==> read($Heap, this, Collection.footprint)[$Box(this)];
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^44.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures iter#4 != null && Iterator.Valid($Heap, iter#4);
  free ensures Iterator.Valid($Heap, iter#4) ==> read($Heap, iter#4, Iterator.footprint)[$Box(iter#4)] && read($Heap, iter#4, Iterator.c) != null && 0 - 1 <= read($Heap, iter#4, Iterator.pos) && !read($Heap, iter#4, Iterator.footprint)[$Box(null)];
  ensures (Iterator.Valid($Heap, iter#4) ==> read($Heap, iter#4, Iterator.footprint)[$Box(iter#4)] && read($Heap, iter#4, Iterator.c) != null && 0 - 1 <= read($Heap, iter#4, Iterator.pos) && !read($Heap, iter#4, Iterator.footprint)[$Box(null)]) ==> iter#4 != null;
  ensures (Iterator.Valid($Heap, iter#4) ==> read($Heap, iter#4, Iterator.footprint)[$Box(iter#4)] && read($Heap, iter#4, Iterator.c) != null && 0 - 1 <= read($Heap, iter#4, Iterator.pos) && !read($Heap, iter#4, Iterator.footprint)[$Box(null)]) ==> read($Heap, iter#4, Iterator.footprint)[$Box(iter#4)];
  ensures (Iterator.Valid($Heap, iter#4) ==> read($Heap, iter#4, Iterator.footprint)[$Box(iter#4)] && read($Heap, iter#4, Iterator.c) != null && 0 - 1 <= read($Heap, iter#4, Iterator.pos) && !read($Heap, iter#4, Iterator.footprint)[$Box(null)]) ==> read($Heap, iter#4, Iterator.c) != null;
  ensures (Iterator.Valid($Heap, iter#4) ==> read($Heap, iter#4, Iterator.footprint)[$Box(iter#4)] && read($Heap, iter#4, Iterator.c) != null && 0 - 1 <= read($Heap, iter#4, Iterator.pos) && !read($Heap, iter#4, Iterator.footprint)[$Box(null)]) ==> 0 - 1 <= read($Heap, iter#4, Iterator.pos);
  ensures (Iterator.Valid($Heap, iter#4) ==> read($Heap, iter#4, Iterator.footprint)[$Box(iter#4)] && read($Heap, iter#4, Iterator.c) != null && 0 - 1 <= read($Heap, iter#4, Iterator.pos) && !read($Heap, iter#4, Iterator.footprint)[$Box(null)]) ==> !read($Heap, iter#4, Iterator.footprint)[$Box(null)];
  free ensures (forall $o: ref :: $o != null && read($Heap, iter#4, Iterator.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc)) && read($Heap, iter#4, Iterator.pos) == 0 - 1;
  ensures true ==> (forall $o: ref :: $o != null && read($Heap, iter#4, Iterator.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc));
  ensures true ==> read($Heap, iter#4, Iterator.pos) == 0 - 1;
  ensures read($Heap, iter#4, Iterator.c) == this;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^50.11: $token;

const unique #tok$0^51.7: $token;

implementation Collection.GetIterator(this: ref) returns (iter#4: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $nw: ref;
  var coll#13: ref;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^44.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^44.33, cev_local, #loc.iter#4, iter#4);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b6.dfy(50,11)
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.Iterator;
    $Heap := update($Heap, $nw, alloc, true);
    iter#4 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(50,11)"} true;
    call CevUpdate(#tok$0^50.11, #loc.iter#4, iter#4);
    // ----- call statement ----- Test\VSI-Benchmarks\b6.dfy(51,7)
    assert true;
    coll#13 := this;
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == iter#4 ==> $_Frame[$o, $f]);
    call Iterator.Init(iter#4, coll#13);
    call CevStep(#tok$0^51.7);
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(51,7)"} true;
}



const unique class.Iterator: ClassName;

const unique Iterator.c: Field ref;

axiom (forall $h: HeapType, $o: ref :: { read($h, $o, Iterator.c) } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) ==> read($h, $o, Iterator.c) == null || (read($h, read($h, $o, Iterator.c), alloc) && dtype(read($h, $o, Iterator.c)) == class.Collection));

const unique Iterator.pos: Field int;

const unique Iterator.footprint: Field (Set BoxType);

axiom (forall $h: HeapType, $o: ref, $t: BoxType :: { read($h, $o, Iterator.footprint)[$t] } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) && read($h, $o, Iterator.footprint)[$t] ==> $Unbox($t): ref == null || read($h, $Unbox($t): ref, alloc));

function Iterator.Valid($heap: HeapType, this: ref) : bool;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (2 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref :: { Iterator.Valid($Heap, this) } $IsGoodHeap($Heap) && this != null ==> Iterator.Valid($Heap, this) == (read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]));

// frame axiom for Iterator.Valid
axiom (forall $h0: HeapType, $h1: HeapType, this: ref :: { $HeapSucc($h0, $h1), Iterator.Valid($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Iterator && read($h1, this, alloc) && dtype(this) == class.Iterator && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && ($o == this || read($h0, this, Iterator.footprint)[$Box($o)]) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Iterator.Valid($h0, this) == Iterator.Valid($h1, this));

procedure CheckWellformed$$Iterator.Valid(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Iterator);
  free requires 0 == $ModuleContextHeight && 2 == $FunctionContextHeight;



implementation CheckWellformed$$Iterator.Valid(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || read($Heap, this, Iterator.footprint)[$Box($o)]);
    assert $_Frame[this, Iterator.footprint];
    if (read($Heap, this, Iterator.footprint)[$Box(this)])
    {
        assert $_Frame[this, Iterator.c];
    }

    if (read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null)
    {
        assert $_Frame[this, Iterator.pos];
    }

    if (read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos))
    {
        assert $_Frame[this, Iterator.footprint];
    }
}



const unique #tok$0^69.10: $token;

procedure CheckWellformed$$Iterator.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Iterator, coll#5: ref where coll#5 == null || (read($Heap, coll#5, alloc) && dtype(coll#5) == class.Collection));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^69.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^69.15: $token;

const unique #loc.coll#5: $token;

implementation CheckWellformed$$Iterator.Init(this: ref, coll#5: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^69.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^69.15, cev_parameter, #loc.coll#5, coll#5);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    assume coll#5 != null;
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (Iterator.Valid($Heap, this))
    {
    }

    if (Iterator.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, Iterator.footprint)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc)))
    {
    }

    assume Iterator.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, Iterator.footprint)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc)) && read($Heap, this, Iterator.pos) == 0 - 1;
    assume read($Heap, this, Iterator.c) == coll#5;
}



procedure Iterator.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Iterator, coll#5: ref where coll#5 == null || (read($Heap, coll#5, alloc) && dtype(coll#5) == class.Collection));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires coll#5 != null;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^69.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures Iterator.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, Iterator.footprint)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc)) && read($Heap, this, Iterator.pos) == 0 - 1;
  free ensures Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)];
  ensures (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) ==> read($Heap, this, Iterator.footprint)[$Box(this)];
  ensures (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) ==> read($Heap, this, Iterator.c) != null;
  ensures (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) ==> 0 - 1 <= read($Heap, this, Iterator.pos);
  ensures (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) ==> !read($Heap, this, Iterator.footprint)[$Box(null)];
  ensures (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) ==> (forall $o: ref :: $o != null && read($Heap, this, Iterator.footprint)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc));
  ensures (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) ==> read($Heap, this, Iterator.pos) == 0 - 1;
  ensures read($Heap, this, Iterator.c) == coll#5;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^75.7: $token;

const unique #tok$0^76.9: $token;

const unique #tok$0^77.15: $token;

implementation Iterator.Init(this: ref, coll#5: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^69.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^69.15, cev_parameter, #loc.coll#5, coll#5);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b6.dfy(75,7)
    assert true;
    assert true;
    assert $_Frame[this, Iterator.c];
    $Heap := update($Heap, this, Iterator.c, coll#5);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(75,7)"} true;
    call CevUpdateHeap(#tok$0^75.7, #loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b6.dfy(76,9)
    assert true;
    assert true;
    assert $_Frame[this, Iterator.pos];
    $Heap := update($Heap, this, Iterator.pos, 0 - 1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(76,9)"} true;
    call CevUpdateHeap(#tok$0^76.9, #loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b6.dfy(77,15)
    assert true;
    assert true;
    assert $_Frame[this, Iterator.footprint];
    $Heap := update($Heap, this, Iterator.footprint, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(77,15)"} true;
    call CevUpdateHeap(#tok$0^77.15, #loc.$Heap, $Heap);
}



const unique #tok$0^80.10: $token;

procedure CheckWellformed$$Iterator.MoveNext(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Iterator) returns (b#6: bool);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^80.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^80.30: $token;

const unique #loc.b#6: $token;

implementation CheckWellformed$$Iterator.MoveNext(this: ref) returns (b#6: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^80.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^80.30, cev_local, #loc.b#6, b#6);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, Iterator.footprint)[$Box($o)]);
    assume Iterator.Valid($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc b#6;
    if ((forall $o: ref :: $o != null && read($Heap, this, Iterator.footprint)[$Box($o)] && !old(read($Heap, this, Iterator.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc)))
    {
    }

    if ((forall $o: ref :: $o != null && read($Heap, this, Iterator.footprint)[$Box($o)] && !old(read($Heap, this, Iterator.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc)) && Iterator.Valid($Heap, this))
    {
    }

    assume (forall $o: ref :: $o != null && read($Heap, this, Iterator.footprint)[$Box($o)] && !old(read($Heap, this, Iterator.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc)) && Iterator.Valid($Heap, this) && read($Heap, this, Iterator.pos) == old(read($Heap, this, Iterator.pos)) + 1;
    assert Iterator.Valid($Heap, this);
    if (b#6 == Iterator.HasCurrent($Heap, this))
    {
    }

    assume b#6 == Iterator.HasCurrent($Heap, this) && read($Heap, this, Iterator.c) == old(read($Heap, this, Iterator.c));
}



procedure Iterator.MoveNext(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Iterator) returns (b#6: bool);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires Iterator.Valid($Heap, this);
  free requires Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)];
  requires (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) ==> read($Heap, this, Iterator.footprint)[$Box(this)];
  requires (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) ==> read($Heap, this, Iterator.c) != null;
  requires (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) ==> 0 - 1 <= read($Heap, this, Iterator.pos);
  requires (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) ==> !read($Heap, this, Iterator.footprint)[$Box(null)];
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^80.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures (forall $o: ref :: $o != null && read($Heap, this, Iterator.footprint)[$Box($o)] && !old(read($Heap, this, Iterator.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc)) && Iterator.Valid($Heap, this) && read($Heap, this, Iterator.pos) == old(read($Heap, this, Iterator.pos)) + 1;
  free ensures Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)];
  ensures (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) ==> (forall $o: ref :: $o != null && read($Heap, this, Iterator.footprint)[$Box($o)] && !old(read($Heap, this, Iterator.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  ensures (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) ==> read($Heap, this, Iterator.footprint)[$Box(this)];
  ensures (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) ==> read($Heap, this, Iterator.c) != null;
  ensures (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) ==> 0 - 1 <= read($Heap, this, Iterator.pos);
  ensures (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) ==> !read($Heap, this, Iterator.footprint)[$Box(null)];
  ensures (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) ==> read($Heap, this, Iterator.pos) == old(read($Heap, this, Iterator.pos)) + 1;
  free ensures b#6 == Iterator.HasCurrent($Heap, this) && read($Heap, this, Iterator.c) == old(read($Heap, this, Iterator.c));
  ensures true ==> b#6 == Iterator.HasCurrent($Heap, this);
  ensures true ==> read($Heap, this, Iterator.c) == old(read($Heap, this, Iterator.c));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || read(old($Heap), this, Iterator.footprint)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^86.9: $token;

const unique #tok$0^87.7: $token;

implementation Iterator.MoveNext(this: ref) returns (b#6: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^80.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^80.30, cev_local, #loc.b#6, b#6);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, Iterator.footprint)[$Box($o)]);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b6.dfy(86,9)
    assert true;
    assert true;
    assert $_Frame[this, Iterator.pos];
    $Heap := update($Heap, this, Iterator.pos, read($Heap, this, Iterator.pos) + 1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(86,9)"} true;
    call CevUpdateHeap(#tok$0^86.9, #loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b6.dfy(87,7)
    assert true;
    assert read($Heap, this, Iterator.c) != null;
    b#6 := read($Heap, this, Iterator.pos) < Seq#Length(read($Heap, read($Heap, this, Iterator.c), Collection.elements));
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(87,7)"} true;
    call CevUpdate(#tok$0^87.7, #loc.b#6, b#6);
}



function Iterator.HasCurrent($heap: HeapType, this: ref) : bool;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (3 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref :: { Iterator.HasCurrent($Heap, this) } $IsGoodHeap($Heap) && this != null && Iterator.Valid($Heap, this) ==> Iterator.HasCurrent($Heap, this) == (0 <= read($Heap, this, Iterator.pos) && read($Heap, this, Iterator.pos) < Seq#Length(read($Heap, read($Heap, this, Iterator.c), Collection.elements))));

// frame axiom for Iterator.HasCurrent
axiom (forall $h0: HeapType, $h1: HeapType, this: ref :: { $HeapSucc($h0, $h1), Iterator.HasCurrent($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Iterator && read($h1, this, alloc) && dtype(this) == class.Iterator && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && ($o == this || $o == read($h0, this, Iterator.c)) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Iterator.HasCurrent($h0, this) == Iterator.HasCurrent($h1, this));

procedure CheckWellformed$$Iterator.HasCurrent(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Iterator);
  free requires 0 == $ModuleContextHeight && 3 == $FunctionContextHeight;



implementation CheckWellformed$$Iterator.HasCurrent(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    assume Iterator.Valid($Heap, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || $o == read($Heap, this, Iterator.c));
    assert $_Frame[this, Iterator.pos];
    if (0 <= read($Heap, this, Iterator.pos))
    {
        assert $_Frame[this, Iterator.pos];
        assert $_Frame[this, Iterator.c];
        assert read($Heap, this, Iterator.c) != null;
        assert $_Frame[read($Heap, this, Iterator.c), Collection.elements];
    }
}



const unique #tok$0^97.10: $token;

procedure CheckWellformed$$Iterator.GetCurrent(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Iterator) returns (x#7: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^97.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^97.32: $token;

const unique #loc.x#7: $token;

implementation CheckWellformed$$Iterator.GetCurrent(this: ref) returns (x#7: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^97.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^97.32, cev_local, #loc.x#7, x#7);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    if (Iterator.Valid($Heap, this))
    {
        assert Iterator.Valid($Heap, this);
    }

    assume Iterator.Valid($Heap, this) && Iterator.HasCurrent($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc x#7;
    assert read($Heap, this, Iterator.c) != null;
    assert 0 <= read($Heap, this, Iterator.pos) && read($Heap, this, Iterator.pos) < Seq#Length(read($Heap, read($Heap, this, Iterator.c), Collection.elements));
    assume Seq#Index(read($Heap, read($Heap, this, Iterator.c), Collection.elements), read($Heap, this, Iterator.pos)) == x#7;
}



procedure Iterator.GetCurrent(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Iterator) returns (x#7: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires Iterator.Valid($Heap, this) && Iterator.HasCurrent($Heap, this);
  free requires Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)];
  free requires Iterator.HasCurrent($Heap, this) ==> 0 <= read($Heap, this, Iterator.pos) && read($Heap, this, Iterator.pos) < Seq#Length(read($Heap, read($Heap, this, Iterator.c), Collection.elements));
  requires (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) && (Iterator.HasCurrent($Heap, this) ==> 0 <= read($Heap, this, Iterator.pos) && read($Heap, this, Iterator.pos) < Seq#Length(read($Heap, read($Heap, this, Iterator.c), Collection.elements))) ==> read($Heap, this, Iterator.footprint)[$Box(this)];
  requires (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) && (Iterator.HasCurrent($Heap, this) ==> 0 <= read($Heap, this, Iterator.pos) && read($Heap, this, Iterator.pos) < Seq#Length(read($Heap, read($Heap, this, Iterator.c), Collection.elements))) ==> read($Heap, this, Iterator.c) != null;
  requires (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) && (Iterator.HasCurrent($Heap, this) ==> 0 <= read($Heap, this, Iterator.pos) && read($Heap, this, Iterator.pos) < Seq#Length(read($Heap, read($Heap, this, Iterator.c), Collection.elements))) ==> 0 - 1 <= read($Heap, this, Iterator.pos);
  requires (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) && (Iterator.HasCurrent($Heap, this) ==> 0 <= read($Heap, this, Iterator.pos) && read($Heap, this, Iterator.pos) < Seq#Length(read($Heap, read($Heap, this, Iterator.c), Collection.elements))) ==> !read($Heap, this, Iterator.footprint)[$Box(null)];
  requires (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) && (Iterator.HasCurrent($Heap, this) ==> 0 <= read($Heap, this, Iterator.pos) && read($Heap, this, Iterator.pos) < Seq#Length(read($Heap, read($Heap, this, Iterator.c), Collection.elements))) ==> 0 <= read($Heap, this, Iterator.pos);
  requires (Iterator.Valid($Heap, this) ==> read($Heap, this, Iterator.footprint)[$Box(this)] && read($Heap, this, Iterator.c) != null && 0 - 1 <= read($Heap, this, Iterator.pos) && !read($Heap, this, Iterator.footprint)[$Box(null)]) && (Iterator.HasCurrent($Heap, this) ==> 0 <= read($Heap, this, Iterator.pos) && read($Heap, this, Iterator.pos) < Seq#Length(read($Heap, read($Heap, this, Iterator.c), Collection.elements))) ==> read($Heap, this, Iterator.pos) < Seq#Length(read($Heap, read($Heap, this, Iterator.c), Collection.elements));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^97.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures Seq#Index(read($Heap, read($Heap, this, Iterator.c), Collection.elements), read($Heap, this, Iterator.pos)) == x#7;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^101.7: $token;

implementation Iterator.GetCurrent(this: ref) returns (x#7: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^97.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^97.32, cev_local, #loc.x#7, x#7);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b6.dfy(101,7)
    assert true;
    assert read($Heap, this, Iterator.c) != null && 0 <= read($Heap, this, Iterator.pos) && read($Heap, this, Iterator.pos) < Seq#Length(read($Heap, read($Heap, this, Iterator.c), Collection.elements));
    x#7 := Seq#Index(read($Heap, read($Heap, this, Iterator.c), Collection.elements), read($Heap, this, Iterator.pos));
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(101,7)"} true;
    call CevUpdate(#tok$0^101.7, #loc.x#7, x#7);
}



const unique class.Client: ClassName;

const unique #tok$0^108.10: $token;

procedure CheckWellformed$$Client.Main(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Client);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^108.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



implementation CheckWellformed$$Client.Main(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^108.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
}



procedure Client.Main(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Client);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^108.10;
  modifies $Heap, #cev_pc;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.c#8: $token;

const unique #tok$0^110.9: $token;

const unique #tok$0^111.5: $token;

const unique #tok$0^112.5: $token;

const unique #tok$0^113.5: $token;

const unique #tok$0^114.5: $token;

const unique #loc.s#9: $token;

const unique #tok$0^116.9: $token;

const unique #loc.iter#10: $token;

const unique #tok$0^118.10: $token;

const unique #loc.iter: $token;

const unique #tok$0^118.5: $token;

const unique #loc.b#11: $token;

const unique #tok$0^119.10: $token;

const unique #loc.b: $token;

const unique #tok$0^119.5: $token;

const unique #tok$0^121.5: $token;

const unique #loc.x#12: $token;

const unique #tok$0^128.12: $token;

const unique #loc.x: $token;

const unique #tok$0^128.7: $token;

const unique #tok$0^129.9: $token;

const unique #tok$0^130.7: $token;

const unique #tok$0^134.5: $token;

implementation Client.Main(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var c#8: ref where (c#8 == null || (read($Heap, c#8, alloc) && dtype(c#8) == class.Collection && TypeParams(c#8, 0) == class.int)) && #cev_var_update(#cev_pc, cev_local, #loc.c#8, c#8);
  var $nw: ref;
  var x#14: BoxType;
  var x#15: BoxType;
  var x#16: BoxType;
  var s#9: Seq BoxType where #cev_var_update(#cev_pc, cev_local, #loc.s#9, s#9);
  var iter#10: ref where (iter#10 == null || (read($Heap, iter#10, alloc) && dtype(iter#10) == class.Iterator && TypeParams(iter#10, 0) == class.int)) && #cev_var_update(#cev_pc, cev_local, #loc.iter#10, iter#10);
  var b#11: bool where #cev_var_update(#cev_pc, cev_local, #loc.b#11, b#11);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;
  var x#12: int where #cev_var_update(#cev_pc, cev_local, #loc.x#12, x#12);
  var $tmp#0: BoxType;
  var x#17: BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^108.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b6.dfy(110,9)
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.Collection && TypeParams($nw, 0) == class.int;
    $Heap := update($Heap, $nw, alloc, true);
    c#8 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(110,9)"} true;
    call CevVarIntro(#tok$0^110.9, cev_local, #loc.c#8, c#8);
    // ----- call statement ----- Test\VSI-Benchmarks\b6.dfy(111,5)
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == c#8 ==> $_Frame[$o, $f]);
    call Collection.Init(c#8);
    call CevStep(#tok$0^111.5);
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(111,5)"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b6.dfy(112,5)
    assert true;
    x#14 := $Box(33);
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && c#8 != null && read($Heap, c#8, Collection.footprint)[$Box($o)] ==> $_Frame[$o, $f]);
    call Collection.Add(c#8, x#14);
    call CevStep(#tok$0^112.5);
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(112,5)"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b6.dfy(113,5)
    assert true;
    x#15 := $Box(45);
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && c#8 != null && read($Heap, c#8, Collection.footprint)[$Box($o)] ==> $_Frame[$o, $f]);
    call Collection.Add(c#8, x#15);
    call CevStep(#tok$0^113.5);
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(113,5)"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b6.dfy(114,5)
    assert true;
    x#16 := $Box(78);
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && c#8 != null && read($Heap, c#8, Collection.footprint)[$Box($o)] ==> $_Frame[$o, $f]);
    call Collection.Add(c#8, x#16);
    call CevStep(#tok$0^114.5);
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(114,5)"} true;
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b6.dfy(116,9)
    assert true;
    assert true;
    s#9 := Seq#Empty(): Seq BoxType;
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(116,9)"} true;
    call CevVarIntro(#tok$0^116.9, cev_local, #loc.s#9, s#9);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b6.dfy(118,10)
    call CevVarIntro(#tok$0^118.10, cev_local, #loc.iter#10, iter#10);
    // ----- call statement ----- Test\VSI-Benchmarks\b6.dfy(118,5)
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call iter#10 := Collection.GetIterator(c#8);
    call CevUpdateHere(#loc.iter, iter#10);
    call CevStep(#tok$0^118.5);
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(118,5)"} true;
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b6.dfy(119,10)
    call CevVarIntro(#tok$0^119.10, cev_local, #loc.b#11, b#11);
    // ----- call statement ----- Test\VSI-Benchmarks\b6.dfy(119,5)
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && iter#10 != null && read($Heap, iter#10, Iterator.footprint)[$Box($o)] ==> $_Frame[$o, $f]);
    call b#11 := Iterator.MoveNext(iter#10);
    call CevUpdateHere(#loc.b, b#11);
    call CevStep(#tok$0^119.5);
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(119,5)"} true;
    // ----- while statement ----- Test\VSI-Benchmarks\b6.dfy(121,5)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := Seq#Length(read($Heap, c#8, Collection.elements)) - read($Heap, iter#10, Iterator.pos);
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^121.5);
    while (true)
      free invariant Iterator.Valid($Heap, iter#10) ==> read($Heap, iter#10, Iterator.footprint)[$Box(iter#10)] && read($Heap, iter#10, Iterator.c) != null && 0 - 1 <= read($Heap, iter#10, Iterator.pos) && !read($Heap, iter#10, Iterator.footprint)[$Box(null)];
      invariant $w0 && (Iterator.Valid($Heap, iter#10) ==> read($Heap, iter#10, Iterator.footprint)[$Box(iter#10)] && read($Heap, iter#10, Iterator.c) != null && 0 - 1 <= read($Heap, iter#10, Iterator.pos) && !read($Heap, iter#10, Iterator.footprint)[$Box(null)]) ==> read($Heap, iter#10, Iterator.footprint)[$Box(iter#10)];
      invariant $w0 && (Iterator.Valid($Heap, iter#10) ==> read($Heap, iter#10, Iterator.footprint)[$Box(iter#10)] && read($Heap, iter#10, Iterator.c) != null && 0 - 1 <= read($Heap, iter#10, Iterator.pos) && !read($Heap, iter#10, Iterator.footprint)[$Box(null)]) ==> read($Heap, iter#10, Iterator.c) != null;
      invariant $w0 && (Iterator.Valid($Heap, iter#10) ==> read($Heap, iter#10, Iterator.footprint)[$Box(iter#10)] && read($Heap, iter#10, Iterator.c) != null && 0 - 1 <= read($Heap, iter#10, Iterator.pos) && !read($Heap, iter#10, Iterator.footprint)[$Box(null)]) ==> 0 - 1 <= read($Heap, iter#10, Iterator.pos);
      invariant $w0 && (Iterator.Valid($Heap, iter#10) ==> read($Heap, iter#10, Iterator.footprint)[$Box(iter#10)] && read($Heap, iter#10, Iterator.c) != null && 0 - 1 <= read($Heap, iter#10, Iterator.pos) && !read($Heap, iter#10, Iterator.footprint)[$Box(null)]) ==> !read($Heap, iter#10, Iterator.footprint)[$Box(null)];
      invariant $w0 && (Iterator.Valid($Heap, iter#10) ==> read($Heap, iter#10, Iterator.footprint)[$Box(iter#10)] && read($Heap, iter#10, Iterator.c) != null && 0 - 1 <= read($Heap, iter#10, Iterator.pos) && !read($Heap, iter#10, Iterator.footprint)[$Box(null)]) ==> b#11 == Iterator.HasCurrent($Heap, iter#10);
      invariant $w0 && (Iterator.Valid($Heap, iter#10) ==> read($Heap, iter#10, Iterator.footprint)[$Box(iter#10)] && read($Heap, iter#10, Iterator.c) != null && 0 - 1 <= read($Heap, iter#10, Iterator.pos) && !read($Heap, iter#10, Iterator.footprint)[$Box(null)]) ==> (forall $o: ref :: $o != null && read($Heap, iter#10, Iterator.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc));
      free invariant $w0 ==> Iterator.Valid($Heap, iter#10) && b#11 == Iterator.HasCurrent($Heap, iter#10) && (forall $o: ref :: $o != null && read($Heap, iter#10, Iterator.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc));
      free invariant Collection.Valid($Heap, c#8) ==> read($Heap, c#8, Collection.footprint)[$Box(c#8)];
      invariant $w0 && (Collection.Valid($Heap, c#8) ==> read($Heap, c#8, Collection.footprint)[$Box(c#8)]) ==> read($Heap, c#8, Collection.footprint)[$Box(c#8)];
      invariant $w0 && (Collection.Valid($Heap, c#8) ==> read($Heap, c#8, Collection.footprint)[$Box(c#8)]) ==> (forall $o: ref :: $o != null && read($Heap, c#8, Collection.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc));
      invariant $w0 && (Collection.Valid($Heap, c#8) ==> read($Heap, c#8, Collection.footprint)[$Box(c#8)]) ==> Set#Disjoint(read($Heap, iter#10, Iterator.footprint), read($Heap, c#8, Collection.footprint));
      free invariant $w0 ==> Collection.Valid($Heap, c#8) && (forall $o: ref :: $o != null && read($Heap, c#8, Collection.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc)) && Set#Disjoint(read($Heap, iter#10, Iterator.footprint), read($Heap, c#8, Collection.footprint));
      invariant $w0 ==> 0 <= read($Heap, iter#10, Iterator.pos);
      invariant $w0 ==> read($Heap, iter#10, Iterator.pos) <= Seq#Length(read($Heap, c#8, Collection.elements));
      invariant $w0 ==> Seq#Equal(s#9, Seq#Take(read($Heap, c#8, Collection.elements), read($Heap, iter#10, Iterator.pos)));
//      free invariant $w0 ==> 0 <= read($Heap, iter#10, Iterator.pos) && read($Heap, iter#10, Iterator.pos) <= Seq#Length(read($Heap, c#8, Collection.elements)) && Seq#Equal(s#9, Seq#Take(read($Heap, c#8, Collection.elements), read($Heap, iter#10, Iterator.pos)));
      invariant $w0 ==> read($Heap, iter#10, Iterator.c) == c#8;
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant Seq#Length(read($Heap, c#8, Collection.elements)) - read($Heap, iter#10, Iterator.pos) <= $decr0$init$0 && (Seq#Length(read($Heap, c#8, Collection.elements)) - read($Heap, iter#10, Iterator.pos) == $decr0$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^121.5;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} iter#10 != null && (Iterator.Valid($Heap, iter#10) ==> iter#10 != null && Iterator.Valid($Heap, iter#10)) && (Iterator.Valid($Heap, iter#10) && b#11 == Iterator.HasCurrent($Heap, iter#10) ==> iter#10 != null);
            assume Iterator.Valid($Heap, iter#10) && b#11 == Iterator.HasCurrent($Heap, iter#10) && (forall $o: ref :: $o != null && read($Heap, iter#10, Iterator.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc));
            assert {:subsumption 0} c#8 != null && (Collection.Valid($Heap, c#8) ==> c#8 != null) && (Collection.Valid($Heap, c#8) && (forall $o: ref :: $o != null && read($Heap, c#8, Collection.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc)) ==> iter#10 != null && c#8 != null);
            assume Collection.Valid($Heap, c#8) && (forall $o: ref :: $o != null && read($Heap, c#8, Collection.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc)) && Set#Disjoint(read($Heap, iter#10, Iterator.footprint), read($Heap, c#8, Collection.footprint));
            assert {:subsumption 0} iter#10 != null && (0 <= read($Heap, iter#10, Iterator.pos) ==> iter#10 != null && c#8 != null) && (0 <= read($Heap, iter#10, Iterator.pos) && read($Heap, iter#10, Iterator.pos) <= Seq#Length(read($Heap, c#8, Collection.elements)) ==> c#8 != null && iter#10 != null && 0 <= read($Heap, iter#10, Iterator.pos) && read($Heap, iter#10, Iterator.pos) <= Seq#Length(read($Heap, c#8, Collection.elements)));
            assume 0 <= read($Heap, iter#10, Iterator.pos) && read($Heap, iter#10, Iterator.pos) <= Seq#Length(read($Heap, c#8, Collection.elements)) && Seq#Equal(s#9, Seq#Take(read($Heap, c#8, Collection.elements), read($Heap, iter#10, Iterator.pos)));
            assert {:subsumption 0} iter#10 != null;
            assume read($Heap, iter#10, Iterator.c) == c#8;
            assert c#8 != null && iter#10 != null;
            assume false;
        }

        assert true;
        if (!b#11)
        {
            break;
        }

        call CevStepEvent(#tok$0^121.5, loop_entered);
        assume {:captureState "Test\VSI-Benchmarks\b6.dfy(121,5): loop entered"} true;
        $decr0$0 := Seq#Length(read($Heap, c#8, Collection.elements)) - read($Heap, iter#10, Iterator.pos);
        // ----- var-declaration statement ----- Test\VSI-Benchmarks\b6.dfy(128,12)
        call CevVarIntro(#tok$0^128.12, cev_local, #loc.x#12, x#12);
        // ----- call statement ----- Test\VSI-Benchmarks\b6.dfy(128,7)
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        call $tmp#0 := Iterator.GetCurrent(iter#10);
        x#12 := $Unbox($tmp#0): int;
        call CevUpdateHere(#loc.x, x#12);
        call CevStep(#tok$0^128.7);
        assume {:captureState "Test\VSI-Benchmarks\b6.dfy(128,7)"} true;
        // ----- assignment statement ----- Test\VSI-Benchmarks\b6.dfy(129,9)
        assert true;
        assert true;
        s#9 := Seq#Append(s#9, Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box(x#12), 1));
        assume {:captureState "Test\VSI-Benchmarks\b6.dfy(129,9)"} true;
        call CevUpdate(#tok$0^129.9, #loc.s#9, s#9);
        // ----- call statement ----- Test\VSI-Benchmarks\b6.dfy(130,7)
        assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && iter#10 != null && read($Heap, iter#10, Iterator.footprint)[$Box($o)] ==> $_Frame[$o, $f]);
        call b#11 := Iterator.MoveNext(iter#10);
        call CevUpdateHere(#loc.b, b#11);
        call CevStep(#tok$0^130.7);
        assume {:captureState "Test\VSI-Benchmarks\b6.dfy(130,7)"} true;
        assert 0 <= $decr0$0 || Seq#Length(read($Heap, c#8, Collection.elements)) - read($Heap, iter#10, Iterator.pos) == $decr0$0;
        assert Seq#Length(read($Heap, c#8, Collection.elements)) - read($Heap, iter#10, Iterator.pos) < $decr0$0;
    }

    call CevStepEvent(#tok$0^121.5, loop_exited);
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(121,5): loop exit"} true;
    // ----- assert statement ----- Test\VSI-Benchmarks\b6.dfy(133,5)
    assert {:subsumption 0} c#8 != null;
    assert Seq#Equal(s#9, read($Heap, c#8, Collection.elements));
    // ----- call statement ----- Test\VSI-Benchmarks\b6.dfy(134,5)
    assert true;
    x#17 := $Box(100);
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && c#8 != null && read($Heap, c#8, Collection.footprint)[$Box($o)] ==> $_Frame[$o, $f]);
    call Collection.Add(c#8, x#17);
    call CevStep(#tok$0^134.5);
    assume {:captureState "Test\VSI-Benchmarks\b6.dfy(134,5)"} true;
}



const unique class._default: ClassName;
