// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: Test\vacid0\LazyInitArray.dfy /print:..\boogie-k-induction-benchmarks\benchmarks\LazyInitArray.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set___Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set___Empty()[o] } !Set___Empty()[o]);

function Set___Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set___Singleton(r) } Set___Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set___Singleton(r)[o] } Set___Singleton(r)[o] <==> r == o);

function Set___UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set___UnionOne(a, x)[o] } Set___UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set___UnionOne(a, x) } Set___UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set___UnionOne(a, x), a[y] } a[y] ==> Set___UnionOne(a, x)[y]);

function Set___Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set___Union(a, b)[o] } Set___Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set___Union(a, b), a[y] } a[y] ==> Set___Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set___Union(a, b), b[y] } b[y] ==> Set___Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set___Union(a, b) } Set___Disjoint(a, b) ==> Set___Difference(Set___Union(a, b), a) == b && Set___Difference(Set___Union(a, b), b) == a);

function Set___Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set___Intersection(a, b)[o] } Set___Intersection(a, b)[o] <==> a[o] && b[o]);

function Set___Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set___Difference(a, b)[o] } Set___Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set___Difference(a, b), b[y] } b[y] ==> !Set___Difference(a, b)[y]);

function Set___Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set___Subset(a, b) } Set___Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set___Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set___Equal(a, b) } Set___Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set___Equal(a, b) } Set___Equal(a, b) ==> a == b);

function Set___Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set___Disjoint(a, b) } Set___Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq___Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq___Length(s) } 0 <= Seq___Length(s));

function Seq___Empty<T>() : Seq T;

axiom (forall<T>  :: Seq___Length(Seq___Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq___Length(s) } Seq___Length(s) == 0 ==> s == Seq___Empty());

function Seq___Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq___Length(Seq___Singleton(t)) } Seq___Length(Seq___Singleton(t)) == 1);

function Seq___Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq___Length(Seq___Build(s, i, v, len)) } 0 <= len ==> Seq___Length(Seq___Build(s, i, v, len)) == len);

function Seq___Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq___Length(Seq___Append(s0, s1)) } Seq___Length(Seq___Append(s0, s1)) == Seq___Length(s0) + Seq___Length(s1));

function Seq___Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq___Index(Seq___Singleton(t), 0) } Seq___Index(Seq___Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq___Index(Seq___Append(s0, s1), n) } (n < Seq___Length(s0) ==> Seq___Index(Seq___Append(s0, s1), n) == Seq___Index(s0, n)) && (Seq___Length(s0) <= n ==> Seq___Index(Seq___Append(s0, s1), n) == Seq___Index(s1, n - Seq___Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq___Index(Seq___Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq___Index(Seq___Build(s, i, v, len), n) == v) && (i != n ==> Seq___Index(Seq___Build(s, i, v, len), n) == Seq___Index(s, n)));

function Seq___Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq___Length(Seq___Update(s, i, v)) } 0 <= i && i < Seq___Length(s) ==> Seq___Length(Seq___Update(s, i, v)) == Seq___Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq___Index(Seq___Update(s, i, v), n) } 0 <= n && n < Seq___Length(s) ==> (i == n ==> Seq___Index(Seq___Update(s, i, v), n) == v) && (i != n ==> Seq___Index(Seq___Update(s, i, v), n) == Seq___Index(s, n)));

function Seq___Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq___Contains(s, x) } Seq___Contains(s, x) <==> (exists i: int :: { Seq___Index(s, i) } 0 <= i && i < Seq___Length(s) && Seq___Index(s, i) == x));

axiom (forall x: ref :: { Seq___Contains(Seq___Empty(), x) } !Seq___Contains(Seq___Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq___Contains(Seq___Append(s0, s1), x) } Seq___Contains(Seq___Append(s0, s1), x) <==> Seq___Contains(s0, x) || Seq___Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq___Contains(Seq___Build(s, i, v, len), x) } Seq___Contains(Seq___Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq___Index(s, j) } 0 <= j && j < Seq___Length(s) && j < len && j != i && Seq___Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq___Contains(Seq___Take(s, n), x) } Seq___Contains(Seq___Take(s, n), x) <==> (exists i: int :: { Seq___Index(s, i) } 0 <= i && i < n && i < Seq___Length(s) && Seq___Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq___Contains(Seq___Drop(s, n), x) } Seq___Contains(Seq___Drop(s, n), x) <==> (exists i: int :: { Seq___Index(s, i) } 0 <= n && n <= i && i < Seq___Length(s) && Seq___Index(s, i) == x));

function Seq___Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq___Equal(s0, s1) } Seq___Equal(s0, s1) <==> Seq___Length(s0) == Seq___Length(s1) && (forall j: int :: { Seq___Index(s0, j) } { Seq___Index(s1, j) } 0 <= j && j < Seq___Length(s0) ==> Seq___Index(s0, j) == Seq___Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq___Equal(a, b) } Seq___Equal(a, b) ==> a == b);

function Seq___SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq___SameUntil(s0, s1, n) } Seq___SameUntil(s0, s1, n) <==> (forall j: int :: { Seq___Index(s0, j) } { Seq___Index(s1, j) } 0 <= j && j < n ==> Seq___Index(s0, j) == Seq___Index(s1, j)));

function Seq___Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq___Length(Seq___Take(s, n)) } 0 <= n ==> (n <= Seq___Length(s) ==> Seq___Length(Seq___Take(s, n)) == n) && (Seq___Length(s) < n ==> Seq___Length(Seq___Take(s, n)) == Seq___Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq___Index(Seq___Take(s, n), j) } 0 <= j && j < n && j < Seq___Length(s) ==> Seq___Index(Seq___Take(s, n), j) == Seq___Index(s, j));

function Seq___Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq___Length(Seq___Drop(s, n)) } 0 <= n ==> (n <= Seq___Length(s) ==> Seq___Length(Seq___Drop(s, n)) == Seq___Length(s) - n) && (Seq___Length(s) < n ==> Seq___Length(Seq___Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq___Index(Seq___Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq___Length(s) - n ==> Seq___Index(Seq___Drop(s, n), j) == Seq___Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq___Append(s, t) } Seq___Take(Seq___Append(s, t), Seq___Length(s)) == s && Seq___Drop(Seq___Append(s, t), Seq___Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && ___cev_var_update(___cev_pc, cev_implicit, ___loc.$Heap, $Heap);

const unique ___loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function ___cev_init(n: int) : bool;

function ___cev_save_position(n: int) : $token;

function ___cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function ___cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function ___cev_control_flow_event(n: int, tag: cf_event) : bool;

function ___cev_function_call(n: int) : bool;

var ___cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies ___cev_pc;
  ensures ___cev_var_intro(old(___cev_pc), locorglob, name, val, 0);
  ensures ___cev_save_position(old(___cev_pc)) == pos;
  ensures ___cev_pc == old(___cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures ___cev_var_update(___cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies ___cev_pc;
  ensures ___cev_save_position(old(___cev_pc)) == pos;
  ensures ___cev_pc == old(___cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies ___cev_pc;
  ensures ___cev_var_update(old(___cev_pc), cev_local, name, val);
  ensures ___cev_save_position(old(___cev_pc)) == pos;
  ensures ___cev_pc == old(___cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies ___cev_pc;
  ensures ___cev_var_update(old(___cev_pc), cev_implicit, name, val);
  ensures ___cev_save_position(old(___cev_pc)) == pos;
  ensures ___cev_pc == old(___cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies ___cev_pc;
  ensures ___cev_control_flow_event(old(___cev_pc), tag);
  ensures ___cev_save_position(old(___cev_pc)) == pos;
  ensures ___cev_pc == old(___cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies ___cev_pc;
  ensures ___cev_control_flow_event(old(___cev_pc) + 1, tag);
  ensures ___cev_save_position(old(___cev_pc) + 1) == pos;
  ensures ___cev_pc == old(___cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies ___cev_pc;
  ensures ___cev_control_flow_event(old(___cev_pc), conditional_moment);
  ensures ___cev_save_position(old(___cev_pc)) == pos;
  ensures oldPC == old(___cev_pc) && ___cev_pc == old(___cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class.LazyInitArray: ClassName;

axiom FDim(LazyInitArray.Contents) == 0 && DeclType(LazyInitArray.Contents) == class.LazyInitArray;

const unique LazyInitArray.Contents: Field (Seq BoxType);

axiom FDim(LazyInitArray.Zero) == 0 && DeclType(LazyInitArray.Zero) == class.LazyInitArray;

const unique LazyInitArray.Zero: Field BoxType;

axiom FDim(LazyInitArray.a) == 0 && DeclType(LazyInitArray.a) == class.LazyInitArray;

const unique LazyInitArray.a: Field ref;

axiom (forall $h: HeapType, $o: ref :: { read($h, $o, LazyInitArray.a) } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) ==> read($h, $o, LazyInitArray.a) == null || (read($h, read($h, $o, LazyInitArray.a), alloc) && dtype(read($h, $o, LazyInitArray.a)) == class.array));

axiom FDim(LazyInitArray.b) == 0 && DeclType(LazyInitArray.b) == class.LazyInitArray;

const unique LazyInitArray.b: Field ref;

axiom (forall $h: HeapType, $o: ref :: { read($h, $o, LazyInitArray.b) } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) ==> read($h, $o, LazyInitArray.b) == null || (read($h, read($h, $o, LazyInitArray.b), alloc) && dtype(read($h, $o, LazyInitArray.b)) == class.array && TypeParams(read($h, $o, LazyInitArray.b), 0) == class.int));

axiom FDim(LazyInitArray.c) == 0 && DeclType(LazyInitArray.c) == class.LazyInitArray;

const unique LazyInitArray.c: Field ref;

axiom (forall $h: HeapType, $o: ref :: { read($h, $o, LazyInitArray.c) } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) ==> read($h, $o, LazyInitArray.c) == null || (read($h, read($h, $o, LazyInitArray.c), alloc) && dtype(read($h, $o, LazyInitArray.c)) == class.array && TypeParams(read($h, $o, LazyInitArray.c), 0) == class.int));

axiom FDim(LazyInitArray.n) == 0 && DeclType(LazyInitArray.n) == class.LazyInitArray;

const unique LazyInitArray.n: Field int;

axiom FDim(LazyInitArray.d) == 0 && DeclType(LazyInitArray.d) == class.LazyInitArray;

const unique LazyInitArray.d: Field (Seq BoxType);

axiom FDim(LazyInitArray.e) == 0 && DeclType(LazyInitArray.e) == class.LazyInitArray;

const unique LazyInitArray.e: Field (Seq BoxType);

function LazyInitArray.Valid($heap: HeapType, this: ref) : bool;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (0 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref :: { LazyInitArray.Valid($Heap, this) } $IsGoodHeap($Heap) && this != null ==> LazyInitArray.Valid($Heap, this) == (read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)));

// frame axiom for LazyInitArray.Valid
axiom (forall $h0: HeapType, $h1: HeapType, this: ref :: { $HeapSucc($h0, $h1), LazyInitArray.Valid($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.LazyInitArray && read($h1, this, alloc) && dtype(this) == class.LazyInitArray && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && ($o == this || $o == read($h0, this, LazyInitArray.a) || $o == read($h0, this, LazyInitArray.b) || $o == read($h0, this, LazyInitArray.c)) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> LazyInitArray.Valid($h0, this) == LazyInitArray.Valid($h1, this));

procedure CheckWellformed$$LazyInitArray.Valid(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.LazyInitArray);
  free requires 0 == $ModuleContextHeight && 0 == $FunctionContextHeight;



implementation CheckWellformed$$LazyInitArray.Valid(this: ref)
{
  var __Frame: <beta>[ref,Field beta]bool;
  var i___23: int;
  var i___24: int;
  var j___25: int;
  var i___26: int;
  var i___27: int;
  var i___28: int;
  var i___29: int;

    __Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || $o == read($Heap, this, LazyInitArray.a) || $o == read($Heap, this, LazyInitArray.b) || $o == read($Heap, this, LazyInitArray.c));
    assert __Frame[this, LazyInitArray.a];
    if (read($Heap, this, LazyInitArray.a) != null)
    {
        assert __Frame[this, LazyInitArray.b];
    }

    if (read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null)
    {
        assert __Frame[this, LazyInitArray.c];
    }

    if (read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null)
    {
        assert __Frame[this, LazyInitArray.a];
        assert read($Heap, this, LazyInitArray.a) != null;
        assert __Frame[this, LazyInitArray.Contents];
    }

    if (read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1)
    {
        assert __Frame[this, LazyInitArray.b];
        assert read($Heap, this, LazyInitArray.b) != null;
        assert __Frame[this, LazyInitArray.Contents];
    }

    if (read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)))
    {
        assert __Frame[this, LazyInitArray.c];
        assert read($Heap, this, LazyInitArray.c) != null;
        assert __Frame[this, LazyInitArray.Contents];
    }

    if (read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)))
    {
        assert __Frame[this, LazyInitArray.b];
        assert __Frame[this, LazyInitArray.c];
    }

    if (read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c))
    {
        assert __Frame[this, LazyInitArray.n];
    }

    if (read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n))
    {
        assert __Frame[this, LazyInitArray.n];
        assert __Frame[this, LazyInitArray.c];
        assert read($Heap, this, LazyInitArray.c) != null;
    }

    if (read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)))
    {
        if (0 <= i___23)
        {
            assert __Frame[this, LazyInitArray.Contents];
        }

        if (0 <= i___23 && i___23 < Seq___Length(read($Heap, this, LazyInitArray.Contents)))
        {
            assert __Frame[this, LazyInitArray.Contents];
            assert 0 <= i___23 && i___23 < Seq___Length(read($Heap, this, LazyInitArray.Contents));
            assert __Frame[this, LazyInitArray.b];
            assert 0 <= i___23 && i___23 < array.Length(read($Heap, this, LazyInitArray.b));
            assert __Frame[read($Heap, this, LazyInitArray.b), IndexField(i___23)];
            if (0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___23))): int)
            {
                assert __Frame[this, LazyInitArray.b];
                assert 0 <= i___23 && i___23 < array.Length(read($Heap, this, LazyInitArray.b));
                assert __Frame[read($Heap, this, LazyInitArray.b), IndexField(i___23)];
                assert __Frame[this, LazyInitArray.n];
            }

            if (0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___23))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___23))): int < read($Heap, this, LazyInitArray.n))
            {
                assert __Frame[this, LazyInitArray.c];
                assert __Frame[this, LazyInitArray.b];
                assert 0 <= i___23 && i___23 < array.Length(read($Heap, this, LazyInitArray.b));
                assert __Frame[read($Heap, this, LazyInitArray.b), IndexField(i___23)];
                assert 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___23))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___23))): int < array.Length(read($Heap, this, LazyInitArray.c));
                assert __Frame[read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___23))): int)];
            }

            if (0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___23))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___23))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___23))): int))): int == i___23)
            {
                assert __Frame[this, LazyInitArray.a];
                assert 0 <= i___23 && i___23 < array.Length(read($Heap, this, LazyInitArray.a));
                assert __Frame[read($Heap, this, LazyInitArray.a), IndexField(i___23)];
            }
            else
            {
                assert __Frame[this, LazyInitArray.Zero];
            }
        }
    }

    if (read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))))
    {
        if (0 <= i___24)
        {
            assert __Frame[this, LazyInitArray.Contents];
        }

        if (0 <= i___24 && i___24 < Seq___Length(read($Heap, this, LazyInitArray.Contents)))
        {
            if (0 <= j___25)
            {
                assert __Frame[this, LazyInitArray.n];
            }

            if (0 <= j___25 && j___25 < read($Heap, this, LazyInitArray.n))
            {
                assert __Frame[this, LazyInitArray.c];
                assert 0 <= j___25 && j___25 < array.Length(read($Heap, this, LazyInitArray.c));
                assert __Frame[read($Heap, this, LazyInitArray.c), IndexField(j___25)];
            }

            assert __Frame[this, LazyInitArray.b];
            assert 0 <= i___24 && i___24 < array.Length(read($Heap, this, LazyInitArray.b));
            assert __Frame[read($Heap, this, LazyInitArray.b), IndexField(i___24)];
            if (0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___24))): int)
            {
                assert __Frame[this, LazyInitArray.b];
                assert 0 <= i___24 && i___24 < array.Length(read($Heap, this, LazyInitArray.b));
                assert __Frame[read($Heap, this, LazyInitArray.b), IndexField(i___24)];
                assert __Frame[this, LazyInitArray.n];
            }

            if (0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___24))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___24))): int < read($Heap, this, LazyInitArray.n))
            {
                assert __Frame[this, LazyInitArray.c];
                assert __Frame[this, LazyInitArray.b];
                assert 0 <= i___24 && i___24 < array.Length(read($Heap, this, LazyInitArray.b));
                assert __Frame[read($Heap, this, LazyInitArray.b), IndexField(i___24)];
                assert 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___24))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___24))): int < array.Length(read($Heap, this, LazyInitArray.c));
                assert __Frame[read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___24))): int)];
            }
        }
    }

    if (read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)))
    {
        assert __Frame[this, LazyInitArray.d];
        assert __Frame[this, LazyInitArray.Contents];
    }

    if (read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)))
    {
        assert __Frame[this, LazyInitArray.e];
        assert __Frame[this, LazyInitArray.Contents];
    }

    if (read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)))
    {
        if (0 <= i___26)
        {
            assert __Frame[this, LazyInitArray.n];
        }

        if (0 <= i___26 && i___26 < read($Heap, this, LazyInitArray.n))
        {
            assert __Frame[this, LazyInitArray.c];
            assert 0 <= i___26 && i___26 < array.Length(read($Heap, this, LazyInitArray.c));
            assert __Frame[read($Heap, this, LazyInitArray.c), IndexField(i___26)];
            assert __Frame[this, LazyInitArray.d];
            assert 0 <= i___26 && i___26 < Seq___Length(read($Heap, this, LazyInitArray.d));
        }
    }

    if (read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int))
    {
        if (0 <= i___27)
        {
            assert __Frame[this, LazyInitArray.d];
        }

        if (0 <= i___27 && i___27 < Seq___Length(read($Heap, this, LazyInitArray.d)))
        {
            assert __Frame[this, LazyInitArray.d];
            assert 0 <= i___27 && i___27 < Seq___Length(read($Heap, this, LazyInitArray.d));
            if (0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___27)): int)
            {
                assert __Frame[this, LazyInitArray.d];
                assert 0 <= i___27 && i___27 < Seq___Length(read($Heap, this, LazyInitArray.d));
                assert __Frame[this, LazyInitArray.d];
            }
        }
    }

    if (read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))))
    {
        if (0 <= i___28)
        {
            assert __Frame[this, LazyInitArray.e];
        }

        if (0 <= i___28 && i___28 < Seq___Length(read($Heap, this, LazyInitArray.e)))
        {
            assert __Frame[this, LazyInitArray.e];
            assert 0 <= i___28 && i___28 < Seq___Length(read($Heap, this, LazyInitArray.e));
            if (0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___28)): int)
            {
                assert __Frame[this, LazyInitArray.e];
                assert 0 <= i___28 && i___28 < Seq___Length(read($Heap, this, LazyInitArray.e));
                assert __Frame[this, LazyInitArray.e];
            }
        }
    }

    if (read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))))
    {
        if (0 <= i___29)
        {
            assert __Frame[this, LazyInitArray.e];
        }

        if (0 <= i___29 && i___29 < Seq___Length(read($Heap, this, LazyInitArray.e)))
        {
            assert __Frame[this, LazyInitArray.d];
            assert __Frame[this, LazyInitArray.e];
            assert 0 <= i___29 && i___29 < Seq___Length(read($Heap, this, LazyInitArray.e));
            assert 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___29)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___29)): int < Seq___Length(read($Heap, this, LazyInitArray.d));
        }
    }
}



const unique xxxxxxxxfile: $token;

axiom $file_name_is(0, xxxxxxxxfile);

const unique ___tok$0^37.10: $token;

procedure CheckWellformed$$LazyInitArray.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.LazyInitArray, N___7: int, zero___8: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires ___cev_pc == 0;
  free requires ___cev_init(0);
  free requires ___cev_var_intro(0, cev_implicit, ___loc.$Heap, $Heap, 0);
  free requires ___cev_save_position(0) == ___tok$0^37.10;
  modifies $Heap, ___cev_pc;
  // CEV information
  free ensures old(___cev_pc) < ___cev_pc;



const unique ___loc.this: $token;

const unique ___tok$0^37.15: $token;

const unique ___loc.N___7: $token;

const unique ___tok$0^37.23: $token;

const unique ___loc.zero___8: $token;

implementation CheckWellformed$$LazyInitArray.Init(this: ref, N___7: int, zero___8: BoxType)
{
  var __Frame: <beta>[ref,Field beta]bool;
  var x___30: BoxType;

    ___cev_pc := ___cev_pc + 1;
    call CevVarIntro(___tok$0^37.10, cev_parameter, ___loc.this, this);
    call CevVarIntro(___tok$0^37.15, cev_parameter, ___loc.N___7, N___7);
    call CevVarIntro(___tok$0^37.23, cev_parameter, ___loc.zero___8, zero___8);
    __Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || $o == read($Heap, this, LazyInitArray.a) || $o == read($Heap, this, LazyInitArray.b) || $o == read($Heap, this, LazyInitArray.c));
    assume 0 <= N___7;
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } __Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    assume LazyInitArray.Valid($Heap, this);
    if (Seq___Length(read($Heap, this, LazyInitArray.Contents)) == N___7)
    {
    }

    assume Seq___Length(read($Heap, this, LazyInitArray.Contents)) == N___7 && read($Heap, this, LazyInitArray.Zero) == zero___8;
    if (Seq___Contains(read($Heap, this, LazyInitArray.Contents), x___30))
    {
    }

    assume (forall x___9: BoxType :: Seq___Contains(read($Heap, this, LazyInitArray.Contents), x___9) ==> x___9 == zero___8);
}



procedure LazyInitArray.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.LazyInitArray, N___7: int, zero___8: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires 0 <= N___7;
  // CEV information
  free requires ___cev_pc == 0;
  free requires ___cev_init(0);
  free requires ___cev_var_intro(0, cev_implicit, ___loc.$Heap, $Heap, 0);
  free requires ___cev_save_position(0) == ___tok$0^37.10;
  modifies $Heap, ___cev_pc;
  // user-defined postconditions
  free ensures LazyInitArray.Valid($Heap, this);
  free ensures LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6);
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.a) != null;
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.b) != null;
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.c) != null;
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1;
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents));
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents));
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c);
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> 0 <= read($Heap, this, LazyInitArray.n);
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c));
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero)));
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1));
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents));
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents));
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int);
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d)));
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e)));
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6);
  free ensures Seq___Length(read($Heap, this, LazyInitArray.Contents)) == N___7 && read($Heap, this, LazyInitArray.Zero) == zero___8;
  ensures true ==> Seq___Length(read($Heap, this, LazyInitArray.Contents)) == N___7;
  ensures true ==> read($Heap, this, LazyInitArray.Zero) == zero___8;
  ensures (forall x___9: BoxType :: Seq___Contains(read($Heap, this, LazyInitArray.Contents), x___9) ==> x___9 == zero___8);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this || $o == read(old($Heap), this, LazyInitArray.a) || $o == read(old($Heap), this, LazyInitArray.b) || $o == read(old($Heap), this, LazyInitArray.c));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(___cev_pc) < ___cev_pc;



const unique ___loc.aa___10: $token;

const unique ___tok$0^44.9: $token;

const unique ___tok$0^44.30: $token;

const unique ___loc.ii___11: $token;

const unique ___tok$0^45.9: $token;

const unique ___tok$0^45.30: $token;

const unique ___tok$0^46.8: $token;

const unique ___tok$0^46.30: $token;

const unique ___tok$0^47.7: $token;

const unique ___loc.s___12: $token;

const unique ___tok$0^51.15: $token;

const unique ___loc.id___13: $token;

const unique ___tok$0^52.15: $token;

const unique ___loc.k___14: $token;

const unique ___tok$0^53.15: $token;

const unique ___tok$0^54.5: $token;

const unique ___tok$0^59.9: $token;

const unique ___tok$0^60.10: $token;

const unique ___tok$0^61.9: $token;

const unique ___tok$0^64.7: $token;

const unique ___tok$0^65.7: $token;

const unique ___tok$0^66.10: $token;

const unique ___tok$0^67.14: $token;

implementation LazyInitArray.Init(this: ref, N___7: int, zero___8: BoxType)
{
  var __Frame: <beta>[ref,Field beta]bool;
  var aa___10: ref where (aa___10 == null || (read($Heap, aa___10, alloc) && dtype(aa___10) == class.array)) && ___cev_var_update(___cev_pc, cev_local, ___loc.aa___10, aa___10);
  var $nw: ref;
  var ii___11: ref where (ii___11 == null || (read($Heap, ii___11, alloc) && dtype(ii___11) == class.array && TypeParams(ii___11, 0) == class.int)) && ___cev_var_update(___cev_pc, cev_local, ___loc.ii___11, ii___11);
  var s___12: Seq BoxType where ___cev_var_update(___cev_pc, cev_local, ___loc.s___12, s___12);
  var id___13: Seq BoxType where ___cev_var_update(___cev_pc, cev_local, ___loc.id___13, id___13);
  var k___14: int where ___cev_var_update(___cev_pc, cev_local, ___loc.k___14, k___14);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;

    ___cev_pc := ___cev_pc + 1;
    call CevVarIntro(___tok$0^37.10, cev_parameter, ___loc.this, this);
    call CevVarIntro(___tok$0^37.15, cev_parameter, ___loc.N___7, N___7);
    call CevVarIntro(___tok$0^37.23, cev_parameter, ___loc.zero___8, zero___8);
    __Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || $o == read($Heap, this, LazyInitArray.a) || $o == read($Heap, this, LazyInitArray.b) || $o == read($Heap, this, LazyInitArray.c));
    // ----- var-declaration statement ----- Test\vacid0\LazyInitArray.dfy(44,9)
    assert 0 <= N___7 + 1;
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.array;
    assume array.Length($nw) == N___7 + 1;
    $Heap := update($Heap, $nw, alloc, true);
    aa___10 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\LazyInitArray.dfy(44,9)"} true;
    call CevVarIntro(___tok$0^44.9, cev_local, ___loc.aa___10, aa___10);
    // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(44,30)
    assert true;
    assert true;
    assert __Frame[this, LazyInitArray.a];
    $Heap := update($Heap, this, LazyInitArray.a, aa___10);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\LazyInitArray.dfy(44,30)"} true;
    call CevUpdateHeap(___tok$0^44.30, ___loc.$Heap, $Heap);
    // ----- var-declaration statement ----- Test\vacid0\LazyInitArray.dfy(45,9)
    assert 0 <= N___7;
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.array && TypeParams($nw, 0) == class.int;
    assume array.Length($nw) == N___7;
    $Heap := update($Heap, $nw, alloc, true);
    ii___11 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\LazyInitArray.dfy(45,9)"} true;
    call CevVarIntro(___tok$0^45.9, cev_local, ___loc.ii___11, ii___11);
    // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(45,30)
    assert true;
    assert true;
    assert __Frame[this, LazyInitArray.b];
    $Heap := update($Heap, this, LazyInitArray.b, ii___11);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\LazyInitArray.dfy(45,30)"} true;
    call CevUpdateHeap(___tok$0^45.30, ___loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(46,8)
    assert 0 <= N___7;
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.array && TypeParams($nw, 0) == class.int;
    assume array.Length($nw) == N___7;
    $Heap := update($Heap, $nw, alloc, true);
    ii___11 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\LazyInitArray.dfy(46,8)"} true;
    call CevUpdate(___tok$0^46.8, ___loc.ii___11, ii___11);
    // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(46,30)
    assert true;
    assert true;
    assert __Frame[this, LazyInitArray.c];
    $Heap := update($Heap, this, LazyInitArray.c, ii___11);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\LazyInitArray.dfy(46,30)"} true;
    call CevUpdateHeap(___tok$0^46.30, ___loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(47,7)
    assert true;
    assert true;
    assert __Frame[this, LazyInitArray.n];
    $Heap := update($Heap, this, LazyInitArray.n, 0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\LazyInitArray.dfy(47,7)"} true;
    call CevUpdateHeap(___tok$0^47.7, ___loc.$Heap, $Heap);
    // ----- var-declaration statement ----- Test\vacid0\LazyInitArray.dfy(51,15)
    assert true;
    assert true;
    s___12 := Seq___Empty(): Seq BoxType;
    assume {:captureState "Test\vacid0\LazyInitArray.dfy(51,15)"} true;
    call CevVarIntro(___tok$0^51.15, cev_local, ___loc.s___12, s___12);
    // ----- var-declaration statement ----- Test\vacid0\LazyInitArray.dfy(52,15)
    assert true;
    assert true;
    id___13 := Seq___Empty(): Seq BoxType;
    assume {:captureState "Test\vacid0\LazyInitArray.dfy(52,15)"} true;
    call CevVarIntro(___tok$0^52.15, cev_local, ___loc.id___13, id___13);
    // ----- var-declaration statement ----- Test\vacid0\LazyInitArray.dfy(53,15)
    assert true;
    assert true;
    k___14 := 0;
    assume {:captureState "Test\vacid0\LazyInitArray.dfy(53,15)"} true;
    call CevVarIntro(___tok$0^53.15, cev_local, ___loc.k___14, k___14);
    // ----- while statement ----- Test\vacid0\LazyInitArray.dfy(54,5)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := N___7 - k___14;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(___tok$0^54.5);
    while (true)
      invariant $w0 ==> k___14 <= N___7;
      invariant $w0 ==> Seq___Length(s___12) == k___14;
      invariant $w0 ==> (forall i___15: int :: 0 <= i___15 && i___15 < Seq___Length(s___12) ==> Seq___Index(s___12, i___15) == zero___8);
  //    free invariant $w0 ==> Seq___Length(s___12) == k___14 && (forall i___15: int :: 0 <= i___15 && i___15 < Seq___Length(s___12) ==> Seq___Index(s___12, i___15) == zero___8);
      invariant $w0 ==> Seq___Length(id___13) == k___14;
      invariant $w0 ==> (forall i___16: int :: 0 <= i___16 && i___16 < k___14 ==> $Unbox(Seq___Index(id___13, i___16)): int == i___16);
  //    free invariant $w0 ==> Seq___Length(id___13) == k___14 && (forall i___16: int :: 0 <= i___16 && i___16 < k___14 ==> $Unbox(Seq___Index(id___13, i___16)): int == i___16);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f) || $o == this || $o == read(old($Heap), this, LazyInitArray.a) || $o == read(old($Heap), this, LazyInitArray.b) || $o == read(old($Heap), this, LazyInitArray.c));
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant N___7 - k___14 <= $decr0$init$0 && (N___7 - k___14 == $decr0$init$0 ==> true);
      free invariant ___cev_save_position(___cev_pc) == ___tok$0^54.5;
      free invariant $PreLoopCevPC0 < ___cev_pc;
      free invariant ___cev_control_flow_event(___cev_pc, loop_register);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} true;
            assume k___14 <= N___7;
            assert {:subsumption 0} Seq___Length(s___12) == k___14 ==> (forall i___15: int :: (0 <= i___15 ==> true) && (0 <= i___15 && i___15 < Seq___Length(s___12) ==> 0 <= i___15 && i___15 < Seq___Length(s___12)));
            assume Seq___Length(s___12) == k___14 && (forall i___15: int :: 0 <= i___15 && i___15 < Seq___Length(s___12) ==> Seq___Index(s___12, i___15) == zero___8);
            assert {:subsumption 0} Seq___Length(id___13) == k___14 ==> (forall i___16: int :: (0 <= i___16 ==> true) && (0 <= i___16 && i___16 < k___14 ==> 0 <= i___16 && i___16 < Seq___Length(id___13)));
            assume Seq___Length(id___13) == k___14 && (forall i___16: int :: 0 <= i___16 && i___16 < k___14 ==> $Unbox(Seq___Index(id___13, i___16)): int == i___16);
            assert true;
            assume false;
        }

        assert true;
        if (k___14 >= N___7)
        {
            break;
        }

        call CevStepEvent(___tok$0^54.5, loop_entered);
        assume {:captureState "Test\vacid0\LazyInitArray.dfy(54,5): loop entered"} true;
        $decr0$0 := N___7 - k___14;
        // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(59,9)
        assert true;
        assert true;
        s___12 := Seq___Append(s___12, Seq___Build(Seq___Empty(): Seq BoxType, 0, zero___8, 1));
        assume {:captureState "Test\vacid0\LazyInitArray.dfy(59,9)"} true;
        call CevUpdate(___tok$0^59.9, ___loc.s___12, s___12);
        // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(60,10)
        assert true;
        assert true;
        id___13 := Seq___Append(id___13, Seq___Build(Seq___Empty(): Seq BoxType, 0, $Box(k___14), 1));
        assume {:captureState "Test\vacid0\LazyInitArray.dfy(60,10)"} true;
        call CevUpdate(___tok$0^60.10, ___loc.id___13, id___13);
        // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(61,9)
        assert true;
        assert true;
        k___14 := k___14 + 1;
        assume {:captureState "Test\vacid0\LazyInitArray.dfy(61,9)"} true;
        call CevUpdate(___tok$0^61.9, ___loc.k___14, k___14);
        assert 0 <= $decr0$0 || N___7 - k___14 == $decr0$0;
        assert N___7 - k___14 < $decr0$0;
    }

    call CevStepEvent(___tok$0^54.5, loop_exited);
    assume {:captureState "Test\vacid0\LazyInitArray.dfy(54,5): loop exit"} true;
    // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(64,7)
    assert true;
    assert true;
    assert __Frame[this, LazyInitArray.d];
    $Heap := update($Heap, this, LazyInitArray.d, id___13);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\LazyInitArray.dfy(64,7)"} true;
    call CevUpdateHeap(___tok$0^64.7, ___loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(65,7)
    assert true;
    assert true;
    assert __Frame[this, LazyInitArray.e];
    $Heap := update($Heap, this, LazyInitArray.e, id___13);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\LazyInitArray.dfy(65,7)"} true;
    call CevUpdateHeap(___tok$0^65.7, ___loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(66,10)
    assert true;
    assert true;
    assert __Frame[this, LazyInitArray.Zero];
    $Heap := update($Heap, this, LazyInitArray.Zero, zero___8);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\LazyInitArray.dfy(66,10)"} true;
    call CevUpdateHeap(___tok$0^66.10, ___loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(67,14)
    assert true;
    assert true;
    assert __Frame[this, LazyInitArray.Contents];
    $Heap := update($Heap, this, LazyInitArray.Contents, s___12);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\LazyInitArray.dfy(67,14)"} true;
    call CevUpdateHeap(___tok$0^67.14, ___loc.$Heap, $Heap);
}



const unique ___tok$0^70.10: $token;

procedure CheckWellformed$$LazyInitArray.Get(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.LazyInitArray, i___17: int) returns (x___18: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires ___cev_pc == 0;
  free requires ___cev_init(0);
  free requires ___cev_var_intro(0, cev_implicit, ___loc.$Heap, $Heap, 0);
  free requires ___cev_save_position(0) == ___tok$0^70.10;
  modifies $Heap, ___cev_pc;
  // CEV information
  free ensures old(___cev_pc) < ___cev_pc;



const unique ___tok$0^70.14: $token;

const unique ___loc.i___17: $token;

const unique ___tok$0^70.31: $token;

const unique ___loc.x___18: $token;

implementation CheckWellformed$$LazyInitArray.Get(this: ref, i___17: int) returns (x___18: BoxType)
{
  var __Frame: <beta>[ref,Field beta]bool;

    ___cev_pc := ___cev_pc + 1;
    call CevVarIntro(___tok$0^70.10, cev_parameter, ___loc.this, this);
    call CevVarIntro(___tok$0^70.14, cev_parameter, ___loc.i___17, i___17);
    call CevVarIntro(___tok$0^70.31, cev_local, ___loc.x___18, x___18);
    __Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume LazyInitArray.Valid($Heap, this);
    if (0 <= i___17)
    {
    }

    assume 0 <= i___17 && i___17 < Seq___Length(read($Heap, this, LazyInitArray.Contents));
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } __Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc x___18;
    assert 0 <= i___17 && i___17 < Seq___Length(read($Heap, this, LazyInitArray.Contents));
    assume x___18 == Seq___Index(read($Heap, this, LazyInitArray.Contents), i___17);
}



procedure LazyInitArray.Get(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.LazyInitArray, i___17: int) returns (x___18: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires LazyInitArray.Valid($Heap, this);
  free requires LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6);
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.a) != null;
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.b) != null;
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.c) != null;
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1;
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents));
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents));
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c);
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> 0 <= read($Heap, this, LazyInitArray.n);
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c));
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero)));
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1));
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents));
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents));
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int);
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d)));
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e)));
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6);
  free requires 0 <= i___17 && i___17 < Seq___Length(read($Heap, this, LazyInitArray.Contents));
  requires true ==> 0 <= i___17;
  requires true ==> i___17 < Seq___Length(read($Heap, this, LazyInitArray.Contents));
  // CEV information
  free requires ___cev_pc == 0;
  free requires ___cev_init(0);
  free requires ___cev_var_intro(0, cev_implicit, ___loc.$Heap, $Heap, 0);
  free requires ___cev_save_position(0) == ___tok$0^70.10;
  modifies $Heap, ___cev_pc;
  // user-defined postconditions
  ensures x___18 == Seq___Index(read($Heap, this, LazyInitArray.Contents), i___17);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(___cev_pc) < ___cev_pc;



const unique ___tok$0^75.5: $token;

const unique ___tok$0^75.48: $token;

const unique ___tok$0^76.9: $token;

const unique ___tok$0^77.12: $token;

const unique ___tok$0^78.9: $token;

implementation LazyInitArray.Get(this: ref, i___17: int) returns (x___18: BoxType)
{
  var __Frame: <beta>[ref,Field beta]bool;

    ___cev_pc := ___cev_pc + 1;
    call CevVarIntro(___tok$0^70.10, cev_parameter, ___loc.this, this);
    call CevVarIntro(___tok$0^70.14, cev_parameter, ___loc.i___17, i___17);
    call CevVarIntro(___tok$0^70.31, cev_local, ___loc.x___18, x___18);
    __Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- if statement ----- Test\vacid0\LazyInitArray.dfy(75,5)
    call CevEvent(___tok$0^75.5, conditional_moment);
    assert 0 <= i___17 && i___17 < array.Length(read($Heap, this, LazyInitArray.b)) && (0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___17))): int ==> 0 <= i___17 && i___17 < array.Length(read($Heap, this, LazyInitArray.b))) && (0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___17))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___17))): int < read($Heap, this, LazyInitArray.n) ==> 0 <= i___17 && i___17 < array.Length(read($Heap, this, LazyInitArray.b)) && 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___17))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___17))): int < array.Length(read($Heap, this, LazyInitArray.c)));
    if (0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___17))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___17))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___17))): int))): int == i___17)
    {
        call CevEvent(___tok$0^75.48, took_then_branch);
        // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(76,9)
        assert true;
        assert 0 <= i___17 && i___17 < array.Length(read($Heap, this, LazyInitArray.a));
        x___18 := read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___17));
        assume {:captureState "Test\vacid0\LazyInitArray.dfy(76,9)"} true;
        call CevUpdate(___tok$0^76.9, ___loc.x___18, x___18);
    }
    else
    {
        call CevEvent(___tok$0^77.12, took_else_branch);
        // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(78,9)
        assert true;
        assert true;
        x___18 := read($Heap, this, LazyInitArray.Zero);
        assume {:captureState "Test\vacid0\LazyInitArray.dfy(78,9)"} true;
        call CevUpdate(___tok$0^78.9, ___loc.x___18, x___18);
    }
}



const unique ___tok$0^82.10: $token;

procedure CheckWellformed$$LazyInitArray.Set(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.LazyInitArray, i___19: int, x___20: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires ___cev_pc == 0;
  free requires ___cev_init(0);
  free requires ___cev_var_intro(0, cev_implicit, ___loc.$Heap, $Heap, 0);
  free requires ___cev_save_position(0) == ___tok$0^82.10;
  modifies $Heap, ___cev_pc;
  // CEV information
  free ensures old(___cev_pc) < ___cev_pc;



const unique ___tok$0^82.14: $token;

const unique ___loc.i___19: $token;

const unique ___tok$0^82.22: $token;

const unique ___loc.x___20: $token;

implementation CheckWellformed$$LazyInitArray.Set(this: ref, i___19: int, x___20: BoxType)
{
  var __Frame: <beta>[ref,Field beta]bool;

    ___cev_pc := ___cev_pc + 1;
    call CevVarIntro(___tok$0^82.10, cev_parameter, ___loc.this, this);
    call CevVarIntro(___tok$0^82.14, cev_parameter, ___loc.i___19, i___19);
    call CevVarIntro(___tok$0^82.22, cev_parameter, ___loc.x___20, x___20);
    __Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || $o == read($Heap, this, LazyInitArray.a) || $o == read($Heap, this, LazyInitArray.b) || $o == read($Heap, this, LazyInitArray.c));
    assume LazyInitArray.Valid($Heap, this);
    if (0 <= i___19)
    {
    }

    assume 0 <= i___19 && i___19 < Seq___Length(read($Heap, this, LazyInitArray.Contents));
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } __Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    assume LazyInitArray.Valid($Heap, this);
    if (Seq___Length(read($Heap, this, LazyInitArray.Contents)) == Seq___Length(old(read($Heap, this, LazyInitArray.Contents))))
    {
        assert 0 <= i___19 && i___19 < Seq___Length(read($Heap, this, LazyInitArray.Contents));
    }

    assume Seq___Length(read($Heap, this, LazyInitArray.Contents)) == Seq___Length(old(read($Heap, this, LazyInitArray.Contents))) && Seq___Equal(read($Heap, this, LazyInitArray.Contents), Seq___Update(read($Heap, this, LazyInitArray.Contents), i___19, x___20));
    assume read($Heap, this, LazyInitArray.Zero) == old(read($Heap, this, LazyInitArray.Zero));
}



procedure LazyInitArray.Set(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.LazyInitArray, i___19: int, x___20: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires LazyInitArray.Valid($Heap, this);
  free requires LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6);
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.a) != null;
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.b) != null;
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.c) != null;
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1;
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents));
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents));
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c);
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> 0 <= read($Heap, this, LazyInitArray.n);
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c));
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero)));
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1));
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents));
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents));
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int);
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d)));
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e)));
  requires (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6);
  free requires 0 <= i___19 && i___19 < Seq___Length(read($Heap, this, LazyInitArray.Contents));
  requires true ==> 0 <= i___19;
  requires true ==> i___19 < Seq___Length(read($Heap, this, LazyInitArray.Contents));
  // CEV information
  free requires ___cev_pc == 0;
  free requires ___cev_init(0);
  free requires ___cev_var_intro(0, cev_implicit, ___loc.$Heap, $Heap, 0);
  free requires ___cev_save_position(0) == ___tok$0^82.10;
  modifies $Heap, ___cev_pc;
  // user-defined postconditions
  free ensures LazyInitArray.Valid($Heap, this);
  free ensures LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6);
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.a) != null;
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.b) != null;
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.c) != null;
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1;
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents));
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents));
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c);
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> 0 <= read($Heap, this, LazyInitArray.n);
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c));
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero)));
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1));
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents));
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents));
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int);
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d)));
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e)));
  ensures (LazyInitArray.Valid($Heap, this) ==> read($Heap, this, LazyInitArray.a) != null && read($Heap, this, LazyInitArray.b) != null && read($Heap, this, LazyInitArray.c) != null && array.Length(read($Heap, this, LazyInitArray.a)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) + 1 && array.Length(read($Heap, this, LazyInitArray.b)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && array.Length(read($Heap, this, LazyInitArray.c)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && read($Heap, this, LazyInitArray.b) != read($Heap, this, LazyInitArray.c) && 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) <= array.Length(read($Heap, this, LazyInitArray.c)) && (forall i___0: int :: 0 <= i___0 && i___0 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> Seq___Index(read($Heap, this, LazyInitArray.Contents), i___0) == $ite(0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___0))): int))): int == i___0, read($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___0)), read($Heap, this, LazyInitArray.Zero))) && (forall i___1: int :: 0 <= i___1 && i___1 < Seq___Length(read($Heap, this, LazyInitArray.Contents)) ==> ((exists j___2: int :: 0 <= j___2 && j___2 < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(j___2))): int == i___1) <==> 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___1))): int))): int == i___1)) && Seq___Length(read($Heap, this, LazyInitArray.d)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && Seq___Length(read($Heap, this, LazyInitArray.e)) == Seq___Length(read($Heap, this, LazyInitArray.Contents)) && (forall i___3: int :: 0 <= i___3 && i___3 < read($Heap, this, LazyInitArray.n) ==> $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField(i___3))): int == $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___3)): int) && (forall i___4: int :: 0 <= i___4 && i___4 < Seq___Length(read($Heap, this, LazyInitArray.d)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), i___4)): int < Seq___Length(read($Heap, this, LazyInitArray.d))) && (forall i___5: int :: 0 <= i___5 && i___5 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> 0 <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int && $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___5)): int < Seq___Length(read($Heap, this, LazyInitArray.e))) && (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6)) ==> (forall i___6: int :: 0 <= i___6 && i___6 < Seq___Length(read($Heap, this, LazyInitArray.e)) ==> $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___6)): int)): int == i___6);
  free ensures Seq___Length(read($Heap, this, LazyInitArray.Contents)) == Seq___Length(old(read($Heap, this, LazyInitArray.Contents))) && Seq___Equal(read($Heap, this, LazyInitArray.Contents), Seq___Update(read($Heap, this, LazyInitArray.Contents), i___19, x___20));
  ensures true ==> Seq___Length(read($Heap, this, LazyInitArray.Contents)) == Seq___Length(old(read($Heap, this, LazyInitArray.Contents)));
  ensures true ==> Seq___Equal(read($Heap, this, LazyInitArray.Contents), Seq___Update(read($Heap, this, LazyInitArray.Contents), i___19, x___20));
  ensures read($Heap, this, LazyInitArray.Zero) == old(read($Heap, this, LazyInitArray.Zero));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this || $o == read(old($Heap), this, LazyInitArray.a) || $o == read(old($Heap), this, LazyInitArray.b) || $o == read(old($Heap), this, LazyInitArray.c));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(___cev_pc) < ___cev_pc;



const unique ___tok$0^90.5: $token;

const unique ___tok$0^90.48: $token;

const unique ___tok$0^91.12: $token;

const unique ___loc.t___21: $token;

const unique ___tok$0^95.17: $token;

const unique ___loc.k___22: $token;

const unique ___tok$0^96.17: $token;

const unique ___tok$0^97.9: $token;

const unique ___tok$0^98.9: $token;

const unique ___tok$0^99.9: $token;

const unique ___tok$0^103.14: $token;

implementation LazyInitArray.Set(this: ref, i___19: int, x___20: BoxType)
{
  var __Frame: <beta>[ref,Field beta]bool;
  var t___21: int where ___cev_var_update(___cev_pc, cev_local, ___loc.t___21, t___21);
  var k___22: int where ___cev_var_update(___cev_pc, cev_local, ___loc.k___22, k___22);

    ___cev_pc := ___cev_pc + 1;
    call CevVarIntro(___tok$0^82.10, cev_parameter, ___loc.this, this);
    call CevVarIntro(___tok$0^82.14, cev_parameter, ___loc.i___19, i___19);
    call CevVarIntro(___tok$0^82.22, cev_parameter, ___loc.x___20, x___20);
    __Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || $o == read($Heap, this, LazyInitArray.a) || $o == read($Heap, this, LazyInitArray.b) || $o == read($Heap, this, LazyInitArray.c));
    // ----- if statement ----- Test\vacid0\LazyInitArray.dfy(90,5)
    call CevEvent(___tok$0^90.5, conditional_moment);
    assert 0 <= i___19 && i___19 < array.Length(read($Heap, this, LazyInitArray.b)) && (0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___19))): int ==> 0 <= i___19 && i___19 < array.Length(read($Heap, this, LazyInitArray.b))) && (0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___19))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___19))): int < read($Heap, this, LazyInitArray.n) ==> 0 <= i___19 && i___19 < array.Length(read($Heap, this, LazyInitArray.b)) && 0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___19))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___19))): int < array.Length(read($Heap, this, LazyInitArray.c)));
    if (0 <= $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___19))): int && $Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___19))): int < read($Heap, this, LazyInitArray.n) && $Unbox(read($Heap, read($Heap, this, LazyInitArray.c), IndexField($Unbox(read($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___19))): int))): int == i___19)
    {
        call CevEvent(___tok$0^90.48, took_then_branch);
    }
    else
    {
        call CevEvent(___tok$0^91.12, took_else_branch);
        // ----- assert statement ----- Test\vacid0\LazyInitArray.dfy(92,7)
        assert {:subsumption 0} 0 <= i___19 && i___19 < Seq___Length(read($Heap, this, LazyInitArray.e));
        assert read($Heap, this, LazyInitArray.n) <= $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___19)): int;
        // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(93,12)
        assert 0 <= i___19 && i___19 < array.Length(read($Heap, this, LazyInitArray.b));
        assert true;
        assert __Frame[read($Heap, this, LazyInitArray.b), IndexField(i___19)];
        $Heap := update($Heap, read($Heap, this, LazyInitArray.b), IndexField(i___19), $Box(read($Heap, this, LazyInitArray.n)));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\vacid0\LazyInitArray.dfy(93,12)"} true;
        // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(94,12)
        assert 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) < array.Length(read($Heap, this, LazyInitArray.c));
        assert true;
        assert __Frame[read($Heap, this, LazyInitArray.c), IndexField(read($Heap, this, LazyInitArray.n))];
        $Heap := update($Heap, read($Heap, this, LazyInitArray.c), IndexField(read($Heap, this, LazyInitArray.n)), $Box(i___19));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\vacid0\LazyInitArray.dfy(94,12)"} true;
        // ----- var-declaration statement ----- Test\vacid0\LazyInitArray.dfy(95,17)
        assert true;
        assert 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) < Seq___Length(read($Heap, this, LazyInitArray.d));
        t___21 := $Unbox(Seq___Index(read($Heap, this, LazyInitArray.d), read($Heap, this, LazyInitArray.n))): int;
        assume {:captureState "Test\vacid0\LazyInitArray.dfy(95,17)"} true;
        call CevVarIntro(___tok$0^95.17, cev_local, ___loc.t___21, t___21);
        // ----- var-declaration statement ----- Test\vacid0\LazyInitArray.dfy(96,17)
        assert true;
        assert 0 <= i___19 && i___19 < Seq___Length(read($Heap, this, LazyInitArray.e));
        k___22 := $Unbox(Seq___Index(read($Heap, this, LazyInitArray.e), i___19)): int;
        assume {:captureState "Test\vacid0\LazyInitArray.dfy(96,17)"} true;
        call CevVarIntro(___tok$0^96.17, cev_local, ___loc.k___22, k___22);
        // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(97,9)
        assert true;
        assert 0 <= read($Heap, this, LazyInitArray.n) && read($Heap, this, LazyInitArray.n) < Seq___Length(read($Heap, this, LazyInitArray.d)) && 0 <= k___22 && k___22 < Seq___Length(Seq___Update(read($Heap, this, LazyInitArray.d), read($Heap, this, LazyInitArray.n), $Box(i___19)));
        assert __Frame[this, LazyInitArray.d];
        $Heap := update($Heap, this, LazyInitArray.d, Seq___Update(Seq___Update(read($Heap, this, LazyInitArray.d), read($Heap, this, LazyInitArray.n), $Box(i___19)), k___22, $Box(t___21)));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\vacid0\LazyInitArray.dfy(97,9)"} true;
        call CevUpdateHeap(___tok$0^97.9, ___loc.$Heap, $Heap);
        // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(98,9)
        assert true;
        assert 0 <= i___19 && i___19 < Seq___Length(read($Heap, this, LazyInitArray.e)) && 0 <= t___21 && t___21 < Seq___Length(Seq___Update(read($Heap, this, LazyInitArray.e), i___19, $Box(read($Heap, this, LazyInitArray.n))));
        assert __Frame[this, LazyInitArray.e];
        $Heap := update($Heap, this, LazyInitArray.e, Seq___Update(Seq___Update(read($Heap, this, LazyInitArray.e), i___19, $Box(read($Heap, this, LazyInitArray.n))), t___21, $Box(k___22)));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\vacid0\LazyInitArray.dfy(98,9)"} true;
        call CevUpdateHeap(___tok$0^98.9, ___loc.$Heap, $Heap);
        // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(99,9)
        assert true;
        assert true;
        assert __Frame[this, LazyInitArray.n];
        $Heap := update($Heap, this, LazyInitArray.n, read($Heap, this, LazyInitArray.n) + 1);
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\vacid0\LazyInitArray.dfy(99,9)"} true;
        call CevUpdateHeap(___tok$0^99.9, ___loc.$Heap, $Heap);
    }

    // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(102,10)
    assert 0 <= i___19 && i___19 < array.Length(read($Heap, this, LazyInitArray.a));
    assert true;
    assert __Frame[read($Heap, this, LazyInitArray.a), IndexField(i___19)];
    $Heap := update($Heap, read($Heap, this, LazyInitArray.a), IndexField(i___19), x___20);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\LazyInitArray.dfy(102,10)"} true;
    // ----- assignment statement ----- Test\vacid0\LazyInitArray.dfy(103,14)
    assert true;
    assert 0 <= i___19 && i___19 < Seq___Length(read($Heap, this, LazyInitArray.Contents));
    assert __Frame[this, LazyInitArray.Contents];
    $Heap := update($Heap, this, LazyInitArray.Contents, Seq___Update(read($Heap, this, LazyInitArray.Contents), i___19, x___20));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\vacid0\LazyInitArray.dfy(103,14)"} true;
    call CevUpdateHeap(___tok$0^103.14, ___loc.$Heap, $Heap);
}



const unique class._default: ClassName;
