// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: Test\VSI-Benchmarks\b4.dfy /print:..\boogie-k-induction-benchmarks\benchmarks\VSI-b4.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class.Map: ClassName;

axiom FDim(Map.Keys) == 0 && DeclType(Map.Keys) == class.Map;

const unique Map.Keys: Field (Seq BoxType);

axiom FDim(Map.Values) == 0 && DeclType(Map.Values) == class.Map;

const unique Map.Values: Field (Seq BoxType);

axiom FDim(Map.Repr) == 0 && DeclType(Map.Repr) == class.Map;

const unique Map.Repr: Field (Set BoxType);

axiom (forall $h: HeapType, $o: ref, $t: BoxType :: { read($h, $o, Map.Repr)[$t] } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) && read($h, $o, Map.Repr)[$t] ==> $Unbox($t): ref == null || read($h, $Unbox($t): ref, alloc));

axiom FDim(Map.head) == 0 && DeclType(Map.head) == class.Map;

const unique Map.head: Field ref;

axiom (forall $h: HeapType, $o: ref :: { read($h, $o, Map.head) } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) ==> read($h, $o, Map.head) == null || (read($h, read($h, $o, Map.head), alloc) && dtype(read($h, $o, Map.head)) == class.Node));

axiom FDim(Map.nodes) == 0 && DeclType(Map.nodes) == class.Map;

const unique Map.nodes: Field (Seq BoxType);

axiom (forall $h: HeapType, $o: ref, $i: int :: { Seq#Index(read($h, $o, Map.nodes), $i) } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) && 0 <= $i && $i < Seq#Length(read($h, $o, Map.nodes)) ==> $Unbox(Seq#Index(read($h, $o, Map.nodes), $i)): ref == null || (read($h, $Unbox(Seq#Index(read($h, $o, Map.nodes), $i)): ref, alloc) && dtype($Unbox(Seq#Index(read($h, $o, Map.nodes), $i)): ref) == class.Node));

function Map.Valid($heap: HeapType, this: ref) : bool;

axiom FDim(Node.key) == 0 && DeclType(Node.key) == class.Node;

axiom FDim(Node.val) == 0 && DeclType(Node.val) == class.Node;

axiom FDim(Node.next) == 0 && DeclType(Node.next) == class.Node;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (4 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref :: { Map.Valid($Heap, this) } $IsGoodHeap($Heap) && this != null ==> Map.Valid($Heap, this) == (read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null));

// frame axiom for Map.Valid
axiom (forall $h0: HeapType, $h1: HeapType, this: ref :: { $HeapSucc($h0, $h1), Map.Valid($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Map && read($h1, this, alloc) && dtype(this) == class.Map && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && ($o == this || read($h0, this, Map.Repr)[$Box($o)]) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Map.Valid($h0, this) == Map.Valid($h1, this));

procedure CheckWellformed$$Map.Valid(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map);
  free requires 0 == $ModuleContextHeight && 4 == $FunctionContextHeight;



implementation CheckWellformed$$Map.Valid(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#27: int;

    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || read($Heap, this, Map.Repr)[$Box($o)]);
    assert $_Frame[this, Map.Repr];
    if (read($Heap, this, Map.Repr)[$Box(this)])
    {
        assert $_Frame[this, Map.Keys];
        assert $_Frame[this, Map.Values];
    }

    if (read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)))
    {
        assert $_Frame[this, Map.nodes];
        assert $_Frame[this, Map.Keys];
    }

    if (read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1)
    {
        assert $_Frame[this, Map.head];
        assert $_Frame[this, Map.nodes];
        assert 0 <= 0 && 0 < Seq#Length(read($Heap, this, Map.nodes));
    }

    if (read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref)
    {
        if (0 <= i#27)
        {
            assert $_Frame[this, Map.Keys];
        }

        if (0 <= i#27 && i#27 < Seq#Length(read($Heap, this, Map.Keys)))
        {
            assert $_Frame[this, Map.nodes];
            assert 0 <= i#27 && i#27 < Seq#Length(read($Heap, this, Map.nodes));
            if ($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref != null)
            {
                assert $_Frame[this, Map.nodes];
                assert 0 <= i#27 && i#27 < Seq#Length(read($Heap, this, Map.nodes));
                assert $_Frame[this, Map.Repr];
            }

            if ($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref)])
            {
                assert $_Frame[this, Map.nodes];
                assert 0 <= i#27 && i#27 < Seq#Length(read($Heap, this, Map.nodes));
                assert $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref != null;
                assert $_Frame[$Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref, Node.key];
                assert $_Frame[this, Map.Keys];
                assert 0 <= i#27 && i#27 < Seq#Length(read($Heap, this, Map.Keys));
            }

            if ($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#27))
            {
                assert $_Frame[this, Map.nodes];
                assert 0 <= i#27 && i#27 < Seq#Length(read($Heap, this, Map.nodes));
                assert $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref != null;
                assert $_Frame[$Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref, Node.key];
                assert $_Frame[this, Map.Keys];
                assert 0 <= i#27 + 1 && i#27 + 1 <= Seq#Length(read($Heap, this, Map.Keys));
            }

            if ($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#27) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#27 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref, Node.key)))
            {
                assert $_Frame[this, Map.nodes];
                assert 0 <= i#27 && i#27 < Seq#Length(read($Heap, this, Map.nodes));
                assert $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref != null;
                assert $_Frame[$Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref, Node.val];
                assert $_Frame[this, Map.Values];
                assert 0 <= i#27 && i#27 < Seq#Length(read($Heap, this, Map.Values));
            }

            if ($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#27) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#27 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#27))
            {
                assert $_Frame[this, Map.nodes];
                assert 0 <= i#27 && i#27 < Seq#Length(read($Heap, this, Map.nodes));
                assert $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref != null;
                assert $_Frame[$Unbox(Seq#Index(read($Heap, this, Map.nodes), i#27)): ref, Node.next];
                assert $_Frame[this, Map.nodes];
                assert 0 <= i#27 + 1 && i#27 + 1 < Seq#Length(read($Heap, this, Map.nodes));
            }
        }
    }

    if (read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref))
    {
        assert $_Frame[this, Map.nodes];
        assert $_Frame[this, Map.nodes];
        assert 0 <= Seq#Length(read($Heap, this, Map.nodes)) - 1 && Seq#Length(read($Heap, this, Map.nodes)) - 1 < Seq#Length(read($Heap, this, Map.nodes));
    }
}



const unique xxxxxfile: $token;

axiom $file_name_is(0, xxxxxfile);

const unique #tok$0^40.10: $token;

procedure CheckWellformed$$Map.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^40.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.this: $token;

implementation CheckWellformed$$Map.Init(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^40.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (Map.Valid($Heap, this))
    {
    }

    assume Map.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, Map.Repr)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc));
    assume Seq#Length(read($Heap, this, Map.Keys)) == 0;
}



procedure Map.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^40.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures Map.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, Map.Repr)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc));
  free ensures Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null;
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> read($Heap, this, Map.Repr)[$Box(this)];
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values));
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1;
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref;
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref);
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null;
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> (forall $o: ref :: $o != null && read($Heap, this, Map.Repr)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc));
  ensures Seq#Length(read($Heap, this, Map.Keys)) == 0;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^45.10: $token;

const unique #tok$0^46.12: $token;

const unique #tok$0^47.10: $token;

const unique #tok$0^48.10: $token;

const unique #tok$0^49.11: $token;

implementation Map.Init(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^40.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(45,10)
    assert true;
    assert true;
    assert $_Frame[this, Map.Keys];
    $Heap := update($Heap, this, Map.Keys, Seq#Empty(): Seq BoxType);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b4.dfy(45,10)"} true;
    call CevUpdateHeap(#tok$0^45.10, #loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(46,12)
    assert true;
    assert true;
    assert $_Frame[this, Map.Values];
    $Heap := update($Heap, this, Map.Values, Seq#Empty(): Seq BoxType);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b4.dfy(46,12)"} true;
    call CevUpdateHeap(#tok$0^46.12, #loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(47,10)
    assert true;
    assert true;
    assert $_Frame[this, Map.Repr];
    $Heap := update($Heap, this, Map.Repr, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b4.dfy(47,10)"} true;
    call CevUpdateHeap(#tok$0^47.10, #loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(48,10)
    assert true;
    assert true;
    assert $_Frame[this, Map.head];
    $Heap := update($Heap, this, Map.head, null);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b4.dfy(48,10)"} true;
    call CevUpdateHeap(#tok$0^48.10, #loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(49,11)
    assert true;
    assert true;
    assert $_Frame[this, Map.nodes];
    $Heap := update($Heap, this, Map.nodes, Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box(null), 1));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b4.dfy(49,11)"} true;
    call CevUpdateHeap(#tok$0^49.11, #loc.$Heap, $Heap);
}



const unique #tok$0^52.10: $token;

procedure CheckWellformed$$Map.Find(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map, key#1: BoxType) returns (present#2: bool, val#3: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^52.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^52.15: $token;

const unique #loc.key#1: $token;

const unique #tok$0^52.34: $token;

const unique #loc.present#2: $token;

const unique #tok$0^52.49: $token;

const unique #loc.val#3: $token;

implementation CheckWellformed$$Map.Find(this: ref, key#1: BoxType) returns (present#2: bool, val#3: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#28: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^52.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^52.15, cev_parameter, #loc.key#1, key#1);
    call CevVarIntro(#tok$0^52.34, cev_local, #loc.present#2, present#2);
    call CevVarIntro(#tok$0^52.49, cev_local, #loc.val#3, val#3);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume Map.Valid($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc present#2, val#3;
    if (!present#2)
    {
    }

    assume !present#2 ==> !Seq#Contains(read($Heap, this, Map.Keys), key#1);
    if (present#2)
    {
        if (0 <= i#28)
        {
        }

        if (0 <= i#28 && i#28 < Seq#Length(read($Heap, this, Map.Keys)))
        {
            assert 0 <= i#28 && i#28 < Seq#Length(read($Heap, this, Map.Keys));
        }

        if (0 <= i#28 && i#28 < Seq#Length(read($Heap, this, Map.Keys)) && Seq#Index(read($Heap, this, Map.Keys), i#28) == key#1)
        {
            assert 0 <= i#28 && i#28 < Seq#Length(read($Heap, this, Map.Values));
        }
    }

    assume present#2 ==> (exists i#4: int :: 0 <= i#4 && i#4 < Seq#Length(read($Heap, this, Map.Keys)) && Seq#Index(read($Heap, this, Map.Keys), i#4) == key#1 && Seq#Index(read($Heap, this, Map.Values), i#4) == val#3);
}



procedure Map.Find(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map, key#1: BoxType) returns (present#2: bool, val#3: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires Map.Valid($Heap, this);
  free requires Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null;
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> read($Heap, this, Map.Repr)[$Box(this)];
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values));
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1;
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref;
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref);
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^52.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures !present#2 ==> !Seq#Contains(read($Heap, this, Map.Keys), key#1);
  ensures present#2 ==> (exists i#4: int :: 0 <= i#4 && i#4 < Seq#Length(read($Heap, this, Map.Keys)) && Seq#Index(read($Heap, this, Map.Keys), i#4) == key#1 && Seq#Index(read($Heap, this, Map.Values), i#4) == val#3);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.p#5: $token;

const unique #tok$0^57.10: $token;

const unique #loc.n#6: $token;

const unique #tok$0^57.13: $token;

const unique #loc.prev#7: $token;

const unique #tok$0^57.16: $token;

const unique #loc.p: $token;

const unique #loc.n: $token;

const unique #loc.prev: $token;

const unique #tok$0^57.5: $token;

const unique #tok$0^58.5: $token;

const unique #tok$0^58.20: $token;

const unique #tok$0^59.15: $token;

const unique #tok$0^60.12: $token;

const unique #tok$0^61.11: $token;

const unique #tok$0^62.15: $token;

implementation Map.Find(this: ref, key#1: BoxType) returns (present#2: bool, val#3: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var p#5: ref where (p#5 == null || (read($Heap, p#5, alloc) && dtype(p#5) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.p#5, p#5);
  var n#6: int where #cev_var_update(#cev_pc, cev_local, #loc.n#6, n#6);
  var prev#7: ref where (prev#7 == null || (read($Heap, prev#7, alloc) && dtype(prev#7) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.prev#7, prev#7);
  var key#29: BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^52.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^52.15, cev_parameter, #loc.key#1, key#1);
    call CevVarIntro(#tok$0^52.34, cev_local, #loc.present#2, present#2);
    call CevVarIntro(#tok$0^52.49, cev_local, #loc.val#3, val#3);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b4.dfy(57,10)
    call CevVarIntro(#tok$0^57.10, cev_local, #loc.p#5, p#5);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b4.dfy(57,13)
    call CevVarIntro(#tok$0^57.13, cev_local, #loc.n#6, n#6);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b4.dfy(57,16)
    call CevVarIntro(#tok$0^57.16, cev_local, #loc.prev#7, prev#7);
    // ----- call statement ----- Test\VSI-Benchmarks\b4.dfy(57,5)
    assert true;
    key#29 := key#1;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call p#5, n#6, prev#7 := Map.FindIndex(this, key#29);
    call CevUpdateHere(#loc.p, p#5);
    call CevUpdateHere(#loc.n, n#6);
    call CevUpdateHere(#loc.prev, prev#7);
    call CevStep(#tok$0^57.5);
    assume {:captureState "Test\VSI-Benchmarks\b4.dfy(57,5)"} true;
    // ----- if statement ----- Test\VSI-Benchmarks\b4.dfy(58,5)
    call CevEvent(#tok$0^58.5, conditional_moment);
    assert true;
    if (p#5 == null)
    {
        call CevEvent(#tok$0^58.20, took_then_branch);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(59,15)
        assert true;
        assert true;
        present#2 := false;
        assume {:captureState "Test\VSI-Benchmarks\b4.dfy(59,15)"} true;
        call CevUpdate(#tok$0^59.15, #loc.present#2, present#2);
    }
    else
    {
        call CevEvent(#tok$0^60.12, took_else_branch);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(61,11)
        assert true;
        assert p#5 != null;
        val#3 := read($Heap, p#5, Node.val);
        assume {:captureState "Test\VSI-Benchmarks\b4.dfy(61,11)"} true;
        call CevUpdate(#tok$0^61.11, #loc.val#3, val#3);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(62,15)
        assert true;
        assert true;
        present#2 := true;
        assume {:captureState "Test\VSI-Benchmarks\b4.dfy(62,15)"} true;
        call CevUpdate(#tok$0^62.15, #loc.present#2, present#2);
    }
}



const unique #tok$0^66.10: $token;

procedure CheckWellformed$$Map.Add(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map, key#8: BoxType, val#9: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^66.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^66.14: $token;

const unique #loc.key#8: $token;

const unique #tok$0^66.24: $token;

const unique #loc.val#9: $token;

implementation CheckWellformed$$Map.Add(this: ref, key#8: BoxType, val#9: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#30: int;
  var j#31: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^66.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^66.14, cev_parameter, #loc.key#8, key#8);
    call CevVarIntro(#tok$0^66.24, cev_parameter, #loc.val#9, val#9);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, Map.Repr)[$Box($o)]);
    assume Map.Valid($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (Map.Valid($Heap, this))
    {
    }

    assume Map.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, Map.Repr)[$Box($o)] && !old(read($Heap, this, Map.Repr))[$Box($o)] ==> !read(old($Heap), $o, alloc));
    if (0 <= i#30)
    {
    }

    if (0 <= i#30 && i#30 < Seq#Length(old(read($Heap, this, Map.Keys))))
    {
        assert 0 <= i#30 && i#30 < Seq#Length(old(read($Heap, this, Map.Keys)));
    }

    if (0 <= i#30 && i#30 < Seq#Length(old(read($Heap, this, Map.Keys))) && Seq#Index(old(read($Heap, this, Map.Keys)), i#30) == key#8)
    {
        if (Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(old(read($Heap, this, Map.Keys))))
        {
            assert 0 <= i#30 && i#30 < Seq#Length(read($Heap, this, Map.Keys));
        }

        if (Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(old(read($Heap, this, Map.Keys))) && Seq#Index(read($Heap, this, Map.Keys), i#30) == key#8)
        {
            assert 0 <= i#30 && i#30 < Seq#Length(read($Heap, this, Map.Values));
        }

        if (Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(old(read($Heap, this, Map.Keys))) && Seq#Index(read($Heap, this, Map.Keys), i#30) == key#8 && Seq#Index(read($Heap, this, Map.Values), i#30) == val#9)
        {
            if (0 <= j#31)
            {
            }

            if (0 <= j#31 && j#31 < Seq#Length(read($Heap, this, Map.Values)))
            {
            }

            if (0 <= j#31 && j#31 < Seq#Length(read($Heap, this, Map.Values)) && i#30 != j#31)
            {
                assert 0 <= j#31 && j#31 < Seq#Length(read($Heap, this, Map.Keys));
                assert 0 <= j#31 && j#31 < Seq#Length(old(read($Heap, this, Map.Keys)));
                if (Seq#Index(read($Heap, this, Map.Keys), j#31) == Seq#Index(old(read($Heap, this, Map.Keys)), j#31))
                {
                    assert 0 <= j#31 && j#31 < Seq#Length(read($Heap, this, Map.Values));
                    assert 0 <= j#31 && j#31 < Seq#Length(old(read($Heap, this, Map.Values)));
                }
            }
        }
    }

    assume (forall i#10: int :: 0 <= i#10 && i#10 < Seq#Length(old(read($Heap, this, Map.Keys))) && Seq#Index(old(read($Heap, this, Map.Keys)), i#10) == key#8 ==> Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(old(read($Heap, this, Map.Keys))) && Seq#Index(read($Heap, this, Map.Keys), i#10) == key#8 && Seq#Index(read($Heap, this, Map.Values), i#10) == val#9 && (forall j#11: int :: 0 <= j#11 && j#11 < Seq#Length(read($Heap, this, Map.Values)) && i#10 != j#11 ==> Seq#Index(read($Heap, this, Map.Keys), j#11) == Seq#Index(old(read($Heap, this, Map.Keys)), j#11) && Seq#Index(read($Heap, this, Map.Values), j#11) == Seq#Index(old(read($Heap, this, Map.Values)), j#11)));
    if (!Seq#Contains(old(read($Heap, this, Map.Keys)), key#8))
    {
        if (Seq#Equal(read($Heap, this, Map.Keys), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, key#8, 1), old(read($Heap, this, Map.Keys)))))
        {
        }
    }

    assume !Seq#Contains(old(read($Heap, this, Map.Keys)), key#8) ==> Seq#Equal(read($Heap, this, Map.Keys), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, key#8, 1), old(read($Heap, this, Map.Keys)))) && Seq#Equal(read($Heap, this, Map.Values), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, val#9, 1), old(read($Heap, this, Map.Values))));
}



procedure Map.Add(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map, key#8: BoxType, val#9: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires Map.Valid($Heap, this);
  free requires Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null;
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> read($Heap, this, Map.Repr)[$Box(this)];
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values));
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1;
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref;
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref);
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^66.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures Map.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, Map.Repr)[$Box($o)] && !old(read($Heap, this, Map.Repr))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  free ensures Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null;
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> read($Heap, this, Map.Repr)[$Box(this)];
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values));
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1;
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref;
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref);
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null;
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> (forall $o: ref :: $o != null && read($Heap, this, Map.Repr)[$Box($o)] && !old(read($Heap, this, Map.Repr))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  ensures (forall i#10: int :: 0 <= i#10 && i#10 < Seq#Length(old(read($Heap, this, Map.Keys))) && Seq#Index(old(read($Heap, this, Map.Keys)), i#10) == key#8 ==> Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(old(read($Heap, this, Map.Keys))) && Seq#Index(read($Heap, this, Map.Keys), i#10) == key#8 && Seq#Index(read($Heap, this, Map.Values), i#10) == val#9 && (forall j#11: int :: 0 <= j#11 && j#11 < Seq#Length(read($Heap, this, Map.Values)) && i#10 != j#11 ==> Seq#Index(read($Heap, this, Map.Keys), j#11) == Seq#Index(old(read($Heap, this, Map.Keys)), j#11) && Seq#Index(read($Heap, this, Map.Values), j#11) == Seq#Index(old(read($Heap, this, Map.Values)), j#11)));
  free ensures !Seq#Contains(old(read($Heap, this, Map.Keys)), key#8) ==> Seq#Equal(read($Heap, this, Map.Keys), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, key#8, 1), old(read($Heap, this, Map.Keys)))) && Seq#Equal(read($Heap, this, Map.Values), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, val#9, 1), old(read($Heap, this, Map.Values))));
  ensures true ==> !Seq#Contains(old(read($Heap, this, Map.Keys)), key#8) ==> Seq#Equal(read($Heap, this, Map.Keys), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, key#8, 1), old(read($Heap, this, Map.Keys))));
  ensures true ==> !Seq#Contains(old(read($Heap, this, Map.Keys)), key#8) ==> Seq#Equal(read($Heap, this, Map.Values), Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, val#9, 1), old(read($Heap, this, Map.Values))));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || read(old($Heap), this, Map.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.p#12: $token;

const unique #tok$0^77.10: $token;

const unique #loc.n#13: $token;

const unique #tok$0^77.13: $token;

const unique #loc.prev#14: $token;

const unique #tok$0^77.16: $token;

const unique #tok$0^77.5: $token;

const unique #tok$0^78.5: $token;

const unique #tok$0^78.20: $token;

const unique #loc.h#15: $token;

const unique #tok$0^79.11: $token;

const unique #tok$0^80.13: $token;

const unique #tok$0^80.28: $token;

const unique #tok$0^80.44: $token;

const unique #tok$0^81.12: $token;

const unique #tok$0^82.12: $token;

const unique #tok$0^82.37: $token;

const unique #tok$0^83.13: $token;

const unique #tok$0^84.12: $token;

const unique #tok$0^85.12: $token;

const unique #tok$0^86.13: $token;

const unique #tok$0^87.14: $token;

implementation Map.Add(this: ref, key#8: BoxType, val#9: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var p#12: ref where (p#12 == null || (read($Heap, p#12, alloc) && dtype(p#12) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.p#12, p#12);
  var n#13: int where #cev_var_update(#cev_pc, cev_local, #loc.n#13, n#13);
  var prev#14: ref where (prev#14 == null || (read($Heap, prev#14, alloc) && dtype(prev#14) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.prev#14, prev#14);
  var key#32: BoxType;
  var h#15: ref where (h#15 == null || (read($Heap, h#15, alloc) && dtype(h#15) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.h#15, h#15);
  var $nw: ref;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^66.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^66.14, cev_parameter, #loc.key#8, key#8);
    call CevVarIntro(#tok$0^66.24, cev_parameter, #loc.val#9, val#9);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, Map.Repr)[$Box($o)]);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b4.dfy(77,10)
    call CevVarIntro(#tok$0^77.10, cev_local, #loc.p#12, p#12);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b4.dfy(77,13)
    call CevVarIntro(#tok$0^77.13, cev_local, #loc.n#13, n#13);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b4.dfy(77,16)
    call CevVarIntro(#tok$0^77.16, cev_local, #loc.prev#14, prev#14);
    // ----- call statement ----- Test\VSI-Benchmarks\b4.dfy(77,5)
    assert true;
    key#32 := key#8;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call p#12, n#13, prev#14 := Map.FindIndex(this, key#32);
    call CevUpdateHere(#loc.p, p#12);
    call CevUpdateHere(#loc.n, n#13);
    call CevUpdateHere(#loc.prev, prev#14);
    call CevStep(#tok$0^77.5);
    assume {:captureState "Test\VSI-Benchmarks\b4.dfy(77,5)"} true;
    // ----- if statement ----- Test\VSI-Benchmarks\b4.dfy(78,5)
    call CevEvent(#tok$0^78.5, conditional_moment);
    assert true;
    if (p#12 == null)
    {
        call CevEvent(#tok$0^78.20, took_then_branch);
        // ----- var-declaration statement ----- Test\VSI-Benchmarks\b4.dfy(79,11)
        havoc $nw;
        assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.Node;
        $Heap := update($Heap, $nw, alloc, true);
        h#15 := $nw;
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSI-Benchmarks\b4.dfy(79,11)"} true;
        call CevVarIntro(#tok$0^79.11, cev_local, #loc.h#15, h#15);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(80,13)
        assert h#15 != null;
        assert true;
        assert $_Frame[h#15, Node.key];
        $Heap := update($Heap, h#15, Node.key, key#8);
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSI-Benchmarks\b4.dfy(80,13)"} true;
        call CevUpdateHeap(#tok$0^80.13, #loc.$Heap, $Heap);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(80,28)
        assert h#15 != null;
        assert true;
        assert $_Frame[h#15, Node.val];
        $Heap := update($Heap, h#15, Node.val, val#9);
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSI-Benchmarks\b4.dfy(80,28)"} true;
        call CevUpdateHeap(#tok$0^80.28, #loc.$Heap, $Heap);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(80,44)
        assert h#15 != null;
        assert true;
        assert $_Frame[h#15, Node.next];
        $Heap := update($Heap, h#15, Node.next, read($Heap, this, Map.head));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSI-Benchmarks\b4.dfy(80,44)"} true;
        call CevUpdateHeap(#tok$0^80.44, #loc.$Heap, $Heap);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(81,12)
        assert true;
        assert true;
        assert $_Frame[this, Map.head];
        $Heap := update($Heap, this, Map.head, h#15);
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSI-Benchmarks\b4.dfy(81,12)"} true;
        call CevUpdateHeap(#tok$0^81.12, #loc.$Heap, $Heap);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(82,12)
        assert true;
        assert true;
        assert $_Frame[this, Map.Keys];
        $Heap := update($Heap, this, Map.Keys, Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, key#8, 1), read($Heap, this, Map.Keys)));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSI-Benchmarks\b4.dfy(82,12)"} true;
        call CevUpdateHeap(#tok$0^82.12, #loc.$Heap, $Heap);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(82,37)
        assert true;
        assert true;
        assert $_Frame[this, Map.Values];
        $Heap := update($Heap, this, Map.Values, Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, val#9, 1), read($Heap, this, Map.Values)));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSI-Benchmarks\b4.dfy(82,37)"} true;
        call CevUpdateHeap(#tok$0^82.37, #loc.$Heap, $Heap);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(83,13)
        assert true;
        assert true;
        assert $_Frame[this, Map.nodes];
        $Heap := update($Heap, this, Map.nodes, Seq#Append(Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box(h#15), 1), read($Heap, this, Map.nodes)));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSI-Benchmarks\b4.dfy(83,13)"} true;
        call CevUpdateHeap(#tok$0^83.13, #loc.$Heap, $Heap);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(84,12)
        assert true;
        assert true;
        assert $_Frame[this, Map.Repr];
        $Heap := update($Heap, this, Map.Repr, Set#Union(read($Heap, this, Map.Repr), Set#UnionOne(Set#Empty(): Set BoxType, $Box(h#15))));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSI-Benchmarks\b4.dfy(84,12)"} true;
        call CevUpdateHeap(#tok$0^84.12, #loc.$Heap, $Heap);
    }
    else
    {
        call CevEvent(#tok$0^85.12, took_else_branch);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(86,13)
        assert p#12 != null;
        assert true;
        assert $_Frame[p#12, Node.val];
        $Heap := update($Heap, p#12, Node.val, val#9);
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSI-Benchmarks\b4.dfy(86,13)"} true;
        call CevUpdateHeap(#tok$0^86.13, #loc.$Heap, $Heap);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(87,14)
        assert true;
        assert 0 <= n#13 && n#13 < Seq#Length(read($Heap, this, Map.Values));
        assert $_Frame[this, Map.Values];
        $Heap := update($Heap, this, Map.Values, Seq#Update(read($Heap, this, Map.Values), n#13, val#9));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSI-Benchmarks\b4.dfy(87,14)"} true;
        call CevUpdateHeap(#tok$0^87.14, #loc.$Heap, $Heap);
    }
}



const unique #tok$0^91.10: $token;

procedure CheckWellformed$$Map.Remove(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map, key#16: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^91.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^91.17: $token;

const unique #loc.key#16: $token;

implementation CheckWellformed$$Map.Remove(this: ref, key#16: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var k#33: BoxType;
  var k#34: BoxType;
  var h#35: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^91.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^91.17, cev_parameter, #loc.key#16, key#16);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, Map.Repr)[$Box($o)]);
    assume Map.Valid($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (Map.Valid($Heap, this))
    {
    }

    assume Map.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, Map.Repr)[$Box($o)] && !old(read($Heap, this, Map.Repr))[$Box($o)] ==> !read(old($Heap), $o, alloc));
    if (Seq#Contains(read($Heap, this, Map.Keys), k#33))
    {
    }

    assume (forall k#17: BoxType :: Seq#Contains(read($Heap, this, Map.Keys), k#17) ==> Seq#Contains(old(read($Heap, this, Map.Keys)), k#17));
    if (Seq#Contains(old(read($Heap, this, Map.Keys)), k#34))
    {
        if (!Seq#Contains(read($Heap, this, Map.Keys), k#34))
        {
        }
    }

    assume (forall k#18: BoxType :: Seq#Contains(old(read($Heap, this, Map.Keys)), k#18) ==> Seq#Contains(read($Heap, this, Map.Keys), k#18) || k#18 == key#16);
    if (!Seq#Contains(old(read($Heap, this, Map.Keys)), key#16))
    {
        if (Seq#Equal(read($Heap, this, Map.Keys), old(read($Heap, this, Map.Keys))))
        {
        }
    }

    assume !Seq#Contains(old(read($Heap, this, Map.Keys)), key#16) ==> Seq#Equal(read($Heap, this, Map.Keys), old(read($Heap, this, Map.Keys))) && Seq#Equal(read($Heap, this, Map.Values), old(read($Heap, this, Map.Values)));
    if (Seq#Contains(old(read($Heap, this, Map.Keys)), key#16))
    {
        if (Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(old(read($Heap, this, Map.Keys))) - 1)
        {
        }

        if (Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(old(read($Heap, this, Map.Keys))) - 1 && !Seq#Contains(read($Heap, this, Map.Keys), key#16))
        {
            if (0 <= h#35)
            {
            }

            if (0 <= h#35 && h#35 < Seq#Length(old(read($Heap, this, Map.Keys))))
            {
                assert 0 <= h#35 && h#35 <= Seq#Length(read($Heap, this, Map.Keys));
                assert 0 <= h#35 && h#35 <= Seq#Length(old(read($Heap, this, Map.Keys)));
            }

            if (0 <= h#35 && h#35 < Seq#Length(old(read($Heap, this, Map.Keys))) && Seq#Equal(Seq#Take(read($Heap, this, Map.Keys), h#35), Seq#Take(old(read($Heap, this, Map.Keys)), h#35)))
            {
                assert 0 <= h#35 && h#35 <= Seq#Length(read($Heap, this, Map.Values));
                assert 0 <= h#35 && h#35 <= Seq#Length(old(read($Heap, this, Map.Values)));
            }

            if (0 <= h#35 && h#35 < Seq#Length(old(read($Heap, this, Map.Keys))) && Seq#Equal(Seq#Take(read($Heap, this, Map.Keys), h#35), Seq#Take(old(read($Heap, this, Map.Keys)), h#35)) && Seq#Equal(Seq#Take(read($Heap, this, Map.Values), h#35), Seq#Take(old(read($Heap, this, Map.Values)), h#35)))
            {
                assert 0 <= h#35 && h#35 <= Seq#Length(read($Heap, this, Map.Keys));
                assert 0 <= h#35 + 1 && h#35 + 1 <= Seq#Length(old(read($Heap, this, Map.Keys)));
            }

            if (0 <= h#35 && h#35 < Seq#Length(old(read($Heap, this, Map.Keys))) && Seq#Equal(Seq#Take(read($Heap, this, Map.Keys), h#35), Seq#Take(old(read($Heap, this, Map.Keys)), h#35)) && Seq#Equal(Seq#Take(read($Heap, this, Map.Values), h#35), Seq#Take(old(read($Heap, this, Map.Values)), h#35)) && Seq#Equal(Seq#Drop(read($Heap, this, Map.Keys), h#35), Seq#Drop(old(read($Heap, this, Map.Keys)), h#35 + 1)))
            {
                assert 0 <= h#35 && h#35 <= Seq#Length(read($Heap, this, Map.Values));
                assert 0 <= h#35 + 1 && h#35 + 1 <= Seq#Length(old(read($Heap, this, Map.Values)));
            }
        }
    }

    assume Seq#Contains(old(read($Heap, this, Map.Keys)), key#16) ==> Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(old(read($Heap, this, Map.Keys))) - 1 && !Seq#Contains(read($Heap, this, Map.Keys), key#16) && (exists h#19: int :: 0 <= h#19 && h#19 < Seq#Length(old(read($Heap, this, Map.Keys))) && Seq#Equal(Seq#Take(read($Heap, this, Map.Keys), h#19), Seq#Take(old(read($Heap, this, Map.Keys)), h#19)) && Seq#Equal(Seq#Take(read($Heap, this, Map.Values), h#19), Seq#Take(old(read($Heap, this, Map.Values)), h#19)) && Seq#Equal(Seq#Drop(read($Heap, this, Map.Keys), h#19), Seq#Drop(old(read($Heap, this, Map.Keys)), h#19 + 1)) && Seq#Equal(Seq#Drop(read($Heap, this, Map.Values), h#19), Seq#Drop(old(read($Heap, this, Map.Values)), h#19 + 1)));
}



procedure Map.Remove(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map, key#16: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires Map.Valid($Heap, this);
  free requires Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null;
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> read($Heap, this, Map.Repr)[$Box(this)];
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values));
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1;
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref;
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref);
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^91.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures Map.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, Map.Repr)[$Box($o)] && !old(read($Heap, this, Map.Repr))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  free ensures Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null;
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> read($Heap, this, Map.Repr)[$Box(this)];
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values));
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1;
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref;
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref);
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null;
  ensures (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> (forall $o: ref :: $o != null && read($Heap, this, Map.Repr)[$Box($o)] && !old(read($Heap, this, Map.Repr))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  ensures (forall k#17: BoxType :: Seq#Contains(read($Heap, this, Map.Keys), k#17) ==> Seq#Contains(old(read($Heap, this, Map.Keys)), k#17));
  ensures (forall k#18: BoxType :: Seq#Contains(old(read($Heap, this, Map.Keys)), k#18) ==> Seq#Contains(read($Heap, this, Map.Keys), k#18) || k#18 == key#16);
  free ensures !Seq#Contains(old(read($Heap, this, Map.Keys)), key#16) ==> Seq#Equal(read($Heap, this, Map.Keys), old(read($Heap, this, Map.Keys))) && Seq#Equal(read($Heap, this, Map.Values), old(read($Heap, this, Map.Values)));
  ensures true ==> !Seq#Contains(old(read($Heap, this, Map.Keys)), key#16) ==> Seq#Equal(read($Heap, this, Map.Keys), old(read($Heap, this, Map.Keys)));
  ensures true ==> !Seq#Contains(old(read($Heap, this, Map.Keys)), key#16) ==> Seq#Equal(read($Heap, this, Map.Values), old(read($Heap, this, Map.Values)));
  free ensures Seq#Contains(old(read($Heap, this, Map.Keys)), key#16) ==> Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(old(read($Heap, this, Map.Keys))) - 1 && !Seq#Contains(read($Heap, this, Map.Keys), key#16) && (exists h#19: int :: 0 <= h#19 && h#19 < Seq#Length(old(read($Heap, this, Map.Keys))) && Seq#Equal(Seq#Take(read($Heap, this, Map.Keys), h#19), Seq#Take(old(read($Heap, this, Map.Keys)), h#19)) && Seq#Equal(Seq#Take(read($Heap, this, Map.Values), h#19), Seq#Take(old(read($Heap, this, Map.Values)), h#19)) && Seq#Equal(Seq#Drop(read($Heap, this, Map.Keys), h#19), Seq#Drop(old(read($Heap, this, Map.Keys)), h#19 + 1)) && Seq#Equal(Seq#Drop(read($Heap, this, Map.Values), h#19), Seq#Drop(old(read($Heap, this, Map.Values)), h#19 + 1)));
  ensures true ==> Seq#Contains(old(read($Heap, this, Map.Keys)), key#16) ==> Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(old(read($Heap, this, Map.Keys))) - 1;
  ensures true ==> Seq#Contains(old(read($Heap, this, Map.Keys)), key#16) ==> !Seq#Contains(read($Heap, this, Map.Keys), key#16);
  ensures true ==> Seq#Contains(old(read($Heap, this, Map.Keys)), key#16) ==> (exists h#19: int :: 0 <= h#19 && h#19 < Seq#Length(old(read($Heap, this, Map.Keys))) && Seq#Equal(Seq#Take(read($Heap, this, Map.Keys), h#19), Seq#Take(old(read($Heap, this, Map.Keys)), h#19)) && Seq#Equal(Seq#Take(read($Heap, this, Map.Values), h#19), Seq#Take(old(read($Heap, this, Map.Values)), h#19)) && Seq#Equal(Seq#Drop(read($Heap, this, Map.Keys), h#19), Seq#Drop(old(read($Heap, this, Map.Keys)), h#19 + 1)) && Seq#Equal(Seq#Drop(read($Heap, this, Map.Values), h#19), Seq#Drop(old(read($Heap, this, Map.Values)), h#19 + 1)));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || read(old($Heap), this, Map.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.p#20: $token;

const unique #tok$0^110.10: $token;

const unique #loc.n#21: $token;

const unique #tok$0^110.13: $token;

const unique #loc.prev#22: $token;

const unique #tok$0^110.16: $token;

const unique #tok$0^110.5: $token;

const unique #tok$0^111.5: $token;

const unique #tok$0^111.20: $token;

const unique #tok$0^112.12: $token;

const unique #tok$0^113.14: $token;

const unique #tok$0^114.13: $token;

const unique #tok$0^115.7: $token;

const unique #tok$0^115.25: $token;

const unique #tok$0^116.14: $token;

const unique #tok$0^117.14: $token;

const unique #tok$0^118.19: $token;

implementation Map.Remove(this: ref, key#16: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var p#20: ref where (p#20 == null || (read($Heap, p#20, alloc) && dtype(p#20) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.p#20, p#20);
  var n#21: int where #cev_var_update(#cev_pc, cev_local, #loc.n#21, n#21);
  var prev#22: ref where (prev#22 == null || (read($Heap, prev#22, alloc) && dtype(prev#22) == class.Node)) && #cev_var_update(#cev_pc, cev_local, #loc.prev#22, prev#22);
  var key#36: BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^91.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^91.17, cev_parameter, #loc.key#16, key#16);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, Map.Repr)[$Box($o)]);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b4.dfy(110,10)
    call CevVarIntro(#tok$0^110.10, cev_local, #loc.p#20, p#20);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b4.dfy(110,13)
    call CevVarIntro(#tok$0^110.13, cev_local, #loc.n#21, n#21);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b4.dfy(110,16)
    call CevVarIntro(#tok$0^110.16, cev_local, #loc.prev#22, prev#22);
    // ----- call statement ----- Test\VSI-Benchmarks\b4.dfy(110,5)
    assert true;
    key#36 := key#16;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call p#20, n#21, prev#22 := Map.FindIndex(this, key#36);
    call CevUpdateHere(#loc.p, p#20);
    call CevUpdateHere(#loc.n, n#21);
    call CevUpdateHere(#loc.prev, prev#22);
    call CevStep(#tok$0^110.5);
    assume {:captureState "Test\VSI-Benchmarks\b4.dfy(110,5)"} true;
    // ----- if statement ----- Test\VSI-Benchmarks\b4.dfy(111,5)
    call CevEvent(#tok$0^111.5, conditional_moment);
    assert true;
    if (p#20 != null)
    {
        call CevEvent(#tok$0^111.20, took_then_branch);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(112,12)
        assert true;
        assert 0 <= n#21 && n#21 <= Seq#Length(read($Heap, this, Map.Keys)) && 0 <= n#21 + 1 && n#21 + 1 <= Seq#Length(read($Heap, this, Map.Keys));
        assert $_Frame[this, Map.Keys];
        $Heap := update($Heap, this, Map.Keys, Seq#Append(Seq#Take(read($Heap, this, Map.Keys), n#21), Seq#Drop(read($Heap, this, Map.Keys), n#21 + 1)));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSI-Benchmarks\b4.dfy(112,12)"} true;
        call CevUpdateHeap(#tok$0^112.12, #loc.$Heap, $Heap);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(113,14)
        assert true;
        assert 0 <= n#21 && n#21 <= Seq#Length(read($Heap, this, Map.Values)) && 0 <= n#21 + 1 && n#21 + 1 <= Seq#Length(read($Heap, this, Map.Values));
        assert $_Frame[this, Map.Values];
        $Heap := update($Heap, this, Map.Values, Seq#Append(Seq#Take(read($Heap, this, Map.Values), n#21), Seq#Drop(read($Heap, this, Map.Values), n#21 + 1)));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSI-Benchmarks\b4.dfy(113,14)"} true;
        call CevUpdateHeap(#tok$0^113.14, #loc.$Heap, $Heap);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(114,13)
        assert true;
        assert 0 <= n#21 && n#21 <= Seq#Length(read($Heap, this, Map.nodes)) && 0 <= n#21 + 1 && n#21 + 1 <= Seq#Length(read($Heap, this, Map.nodes));
        assert $_Frame[this, Map.nodes];
        $Heap := update($Heap, this, Map.nodes, Seq#Append(Seq#Take(read($Heap, this, Map.nodes), n#21), Seq#Drop(read($Heap, this, Map.nodes), n#21 + 1)));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSI-Benchmarks\b4.dfy(114,13)"} true;
        call CevUpdateHeap(#tok$0^114.13, #loc.$Heap, $Heap);
        // ----- if statement ----- Test\VSI-Benchmarks\b4.dfy(115,7)
        call CevEvent(#tok$0^115.7, conditional_moment);
        assert true;
        if (prev#22 == null)
        {
            call CevEvent(#tok$0^115.25, took_then_branch);
            // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(116,14)
            assert true;
            assert read($Heap, this, Map.head) != null;
            assert $_Frame[this, Map.head];
            $Heap := update($Heap, this, Map.head, read($Heap, read($Heap, this, Map.head), Node.next));
            assume $IsGoodHeap($Heap);
            assume {:captureState "Test\VSI-Benchmarks\b4.dfy(116,14)"} true;
            call CevUpdateHeap(#tok$0^116.14, #loc.$Heap, $Heap);
        }
        else
        {
            call CevEvent(#tok$0^117.14, took_else_branch);
            // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(118,19)
            assert prev#22 != null;
            assert p#20 != null;
            assert $_Frame[prev#22, Node.next];
            $Heap := update($Heap, prev#22, Node.next, read($Heap, p#20, Node.next));
            assume $IsGoodHeap($Heap);
            assume {:captureState "Test\VSI-Benchmarks\b4.dfy(118,19)"} true;
            call CevUpdateHeap(#tok$0^118.19, #loc.$Heap, $Heap);
        }
    }
    else
    {
        call CevEvent(#tok$0^111.5, took_else_branch);
    }
}



const unique #tok$0^123.22: $token;

procedure CheckWellformed$$Map.FindIndex(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map, key#23: BoxType) returns (p#24: ref where p#24 == null || (read($Heap, p#24, alloc) && dtype(p#24) == class.Node), n#25: int, prev#26: ref where prev#26 == null || (read($Heap, prev#26, alloc) && dtype(prev#26) == class.Node));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^123.22;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^123.32: $token;

const unique #loc.key#23: $token;

const unique #tok$0^123.51: $token;

const unique #loc.p#24: $token;

const unique #tok$0^123.77: $token;

const unique #loc.n#25: $token;

const unique #tok$0^123.85: $token;

const unique #loc.prev#26: $token;

implementation CheckWellformed$$Map.FindIndex(this: ref, key#23: BoxType) returns (p#24: ref, n#25: int, prev#26: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^123.22, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^123.32, cev_parameter, #loc.key#23, key#23);
    call CevVarIntro(#tok$0^123.51, cev_local, #loc.p#24, p#24);
    call CevVarIntro(#tok$0^123.77, cev_local, #loc.n#25, n#25);
    call CevVarIntro(#tok$0^123.85, cev_local, #loc.prev#26, prev#26);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume Map.Valid($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc p#24, n#25, prev#26;
    if (p#24 == null)
    {
    }

    assume p#24 == null ==> !Seq#Contains(read($Heap, this, Map.Keys), key#23);
    if (p#24 != null)
    {
        if (0 <= n#25)
        {
        }

        if (0 <= n#25 && n#25 < Seq#Length(read($Heap, this, Map.Keys)))
        {
            assert 0 <= n#25 && n#25 < Seq#Length(read($Heap, this, Map.Keys));
        }

        if (0 <= n#25 && n#25 < Seq#Length(read($Heap, this, Map.Keys)) && Seq#Index(read($Heap, this, Map.Keys), n#25) == key#23)
        {
            assert 0 <= n#25 && n#25 <= Seq#Length(read($Heap, this, Map.Keys));
        }

        if (0 <= n#25 && n#25 < Seq#Length(read($Heap, this, Map.Keys)) && Seq#Index(read($Heap, this, Map.Keys), n#25) == key#23 && !Seq#Contains(Seq#Take(read($Heap, this, Map.Keys), n#25), key#23))
        {
            assert 0 <= n#25 + 1 && n#25 + 1 <= Seq#Length(read($Heap, this, Map.Keys));
        }

        if (0 <= n#25 && n#25 < Seq#Length(read($Heap, this, Map.Keys)) && Seq#Index(read($Heap, this, Map.Keys), n#25) == key#23 && !Seq#Contains(Seq#Take(read($Heap, this, Map.Keys), n#25), key#23) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), n#25 + 1), key#23))
        {
            assert 0 <= n#25 && n#25 < Seq#Length(read($Heap, this, Map.nodes));
        }

        if (0 <= n#25 && n#25 < Seq#Length(read($Heap, this, Map.Keys)) && Seq#Index(read($Heap, this, Map.Keys), n#25) == key#23 && !Seq#Contains(Seq#Take(read($Heap, this, Map.Keys), n#25), key#23) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), n#25 + 1), key#23) && p#24 == $Unbox(Seq#Index(read($Heap, this, Map.nodes), n#25)): ref)
        {
            if (n#25 == 0)
            {
            }

            if (!(n#25 == 0 && prev#26 == null))
            {
                if (0 < n#25)
                {
                    assert 0 <= n#25 - 1 && n#25 - 1 < Seq#Length(read($Heap, this, Map.nodes));
                }
            }
        }
    }

    assume p#24 != null ==> 0 <= n#25 && n#25 < Seq#Length(read($Heap, this, Map.Keys)) && Seq#Index(read($Heap, this, Map.Keys), n#25) == key#23 && !Seq#Contains(Seq#Take(read($Heap, this, Map.Keys), n#25), key#23) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), n#25 + 1), key#23) && p#24 == $Unbox(Seq#Index(read($Heap, this, Map.nodes), n#25)): ref && ((n#25 == 0 && prev#26 == null) || (0 < n#25 && prev#26 == $Unbox(Seq#Index(read($Heap, this, Map.nodes), n#25 - 1)): ref));
}



procedure Map.FindIndex(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map, key#23: BoxType) returns (p#24: ref where p#24 == null || (read($Heap, p#24, alloc) && dtype(p#24) == class.Node), n#25: int, prev#26: ref where prev#26 == null || (read($Heap, prev#26, alloc) && dtype(prev#26) == class.Node));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires Map.Valid($Heap, this);
  free requires Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null;
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> read($Heap, this, Map.Repr)[$Box(this)];
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values));
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1;
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref;
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref);
  requires (Map.Valid($Heap, this) ==> read($Heap, this, Map.Repr)[$Box(this)] && Seq#Length(read($Heap, this, Map.Keys)) == Seq#Length(read($Heap, this, Map.Values)) && Seq#Length(read($Heap, this, Map.nodes)) == Seq#Length(read($Heap, this, Map.Keys)) + 1 && read($Heap, this, Map.head) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), 0)): ref && (forall i#0: int :: 0 <= i#0 && i#0 < Seq#Length(read($Heap, this, Map.Keys)) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref != null && read($Heap, this, Map.Repr)[$Box($Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref)] && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key) == Seq#Index(read($Heap, this, Map.Keys), i#0) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), i#0 + 1), read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.key)) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.val) == Seq#Index(read($Heap, this, Map.Values), i#0) && read($Heap, $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0)): ref, Node.next) == $Unbox(Seq#Index(read($Heap, this, Map.nodes), i#0 + 1)): ref) && $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null) ==> $Unbox(Seq#Index(read($Heap, this, Map.nodes), Seq#Length(read($Heap, this, Map.nodes)) - 1)): ref == null;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^123.22;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures p#24 == null ==> !Seq#Contains(read($Heap, this, Map.Keys), key#23);
  free ensures p#24 != null ==> 0 <= n#25 && n#25 < Seq#Length(read($Heap, this, Map.Keys)) && Seq#Index(read($Heap, this, Map.Keys), n#25) == key#23 && !Seq#Contains(Seq#Take(read($Heap, this, Map.Keys), n#25), key#23) && !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), n#25 + 1), key#23) && p#24 == $Unbox(Seq#Index(read($Heap, this, Map.nodes), n#25)): ref && ((n#25 == 0 && prev#26 == null) || (0 < n#25 && prev#26 == $Unbox(Seq#Index(read($Heap, this, Map.nodes), n#25 - 1)): ref));
  ensures true ==> p#24 != null ==> 0 <= n#25;
  ensures true ==> p#24 != null ==> n#25 < Seq#Length(read($Heap, this, Map.Keys));
  ensures true ==> p#24 != null ==> Seq#Index(read($Heap, this, Map.Keys), n#25) == key#23;
  ensures true ==> p#24 != null ==> !Seq#Contains(Seq#Take(read($Heap, this, Map.Keys), n#25), key#23);
  ensures true ==> p#24 != null ==> !Seq#Contains(Seq#Drop(read($Heap, this, Map.Keys), n#25 + 1), key#23);
  ensures true ==> p#24 != null ==> p#24 == $Unbox(Seq#Index(read($Heap, this, Map.nodes), n#25)): ref;
  ensures true ==> p#24 != null ==> (n#25 == 0 && prev#26 == null) || (0 < n#25 && prev#26 == $Unbox(Seq#Index(read($Heap, this, Map.nodes), n#25 - 1)): ref);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^132.7: $token;

const unique #tok$0^133.10: $token;

const unique #tok$0^134.7: $token;

const unique #tok$0^135.5: $token;

const unique #tok$0^141.7: $token;

const unique #tok$0^141.25: $token;

const unique #tok$0^143.14: $token;

const unique #tok$0^144.11: $token;

const unique #tok$0^145.14: $token;

const unique #tok$0^146.11: $token;

implementation Map.FindIndex(this: ref, key#23: BoxType) returns (p#24: ref, n#25: int, prev#26: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^123.22, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^123.32, cev_parameter, #loc.key#23, key#23);
    call CevVarIntro(#tok$0^123.51, cev_local, #loc.p#24, p#24);
    call CevVarIntro(#tok$0^123.77, cev_local, #loc.n#25, n#25);
    call CevVarIntro(#tok$0^123.85, cev_local, #loc.prev#26, prev#26);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(132,7)
    assert true;
    assert true;
    n#25 := 0;
    assume {:captureState "Test\VSI-Benchmarks\b4.dfy(132,7)"} true;
    call CevUpdate(#tok$0^132.7, #loc.n#25, n#25);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(133,10)
    assert true;
    assert true;
    prev#26 := null;
    assume {:captureState "Test\VSI-Benchmarks\b4.dfy(133,10)"} true;
    call CevUpdate(#tok$0^133.10, #loc.prev#26, prev#26);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(134,7)
    assert true;
    assert true;
    p#24 := read($Heap, this, Map.head);
    assume {:captureState "Test\VSI-Benchmarks\b4.dfy(134,7)"} true;
    call CevUpdate(#tok$0^134.7, #loc.p#24, p#24);
    // ----- while statement ----- Test\VSI-Benchmarks\b4.dfy(135,5)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := Seq#Length(read($Heap, this, Map.Keys)) - n#25;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^135.5);
    while (true)
      invariant $w0 ==> n#25 <= Seq#Length(read($Heap, this, Map.Keys));
      invariant $w0 ==> p#24 == $Unbox(Seq#Index(read($Heap, this, Map.nodes), n#25)): ref;
//      free invariant $w0 ==> n#25 <= Seq#Length(read($Heap, this, Map.Keys)) && p#24 == $Unbox(Seq#Index(read($Heap, this, Map.nodes), n#25)): ref;
      invariant $w0 ==> !Seq#Contains(Seq#Take(read($Heap, this, Map.Keys), n#25), key#23);
      invariant $w0 ==> (n#25 == 0 && prev#26 == null) || (0 < n#25 && prev#26 == $Unbox(Seq#Index(read($Heap, this, Map.nodes), n#25 - 1)): ref);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant Seq#Length(read($Heap, this, Map.Keys)) - n#25 <= $decr0$init$0 && (Seq#Length(read($Heap, this, Map.Keys)) - n#25 == $decr0$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^135.5;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.p#24, p#24);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.n#25, n#25);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.prev#26, prev#26);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} n#25 <= Seq#Length(read($Heap, this, Map.Keys)) ==> 0 <= n#25 && n#25 < Seq#Length(read($Heap, this, Map.nodes));
            assume n#25 <= Seq#Length(read($Heap, this, Map.Keys)) && p#24 == $Unbox(Seq#Index(read($Heap, this, Map.nodes), n#25)): ref;
            assert {:subsumption 0} 0 <= n#25 && n#25 <= Seq#Length(read($Heap, this, Map.Keys));
            assume !Seq#Contains(Seq#Take(read($Heap, this, Map.Keys), n#25), key#23);
            assert {:subsumption 0} (n#25 == 0 ==> true) && (!(n#25 == 0 && prev#26 == null) ==> 0 < n#25 ==> 0 <= n#25 - 1 && n#25 - 1 < Seq#Length(read($Heap, this, Map.nodes)));
            assume (n#25 == 0 && prev#26 == null) || (0 < n#25 && prev#26 == $Unbox(Seq#Index(read($Heap, this, Map.nodes), n#25 - 1)): ref);
            assert true;
            assume false;
        }

        assert true;
        if (p#24 == null)
        {
            break;
        }

        call CevStepEvent(#tok$0^135.5, loop_entered);
        assume {:captureState "Test\VSI-Benchmarks\b4.dfy(135,5): loop entered"} true;
        $decr0$0 := Seq#Length(read($Heap, this, Map.Keys)) - n#25;
        // ----- if statement ----- Test\VSI-Benchmarks\b4.dfy(141,7)
        call CevEvent(#tok$0^141.7, conditional_moment);
        assert p#24 != null;
        if (read($Heap, p#24, Node.key) == key#23)
        {
            call CevEvent(#tok$0^141.25, took_then_branch);
            // ----- return statement ----- Test\VSI-Benchmarks\b4.dfy(142,9)
            return;
        }
        else
        {
            call CevEvent(#tok$0^143.14, took_else_branch);
            // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(144,11)
            assert true;
            assert true;
            n#25 := n#25 + 1;
            assume {:captureState "Test\VSI-Benchmarks\b4.dfy(144,11)"} true;
            call CevUpdate(#tok$0^144.11, #loc.n#25, n#25);
            // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(145,14)
            assert true;
            assert true;
            prev#26 := p#24;
            assume {:captureState "Test\VSI-Benchmarks\b4.dfy(145,14)"} true;
            call CevUpdate(#tok$0^145.14, #loc.prev#26, prev#26);
            // ----- assignment statement ----- Test\VSI-Benchmarks\b4.dfy(146,11)
            assert true;
            assert p#24 != null;
            p#24 := read($Heap, p#24, Node.next);
            assume {:captureState "Test\VSI-Benchmarks\b4.dfy(146,11)"} true;
            call CevUpdate(#tok$0^146.11, #loc.p#24, p#24);
        }

        assert 0 <= $decr0$0 || Seq#Length(read($Heap, this, Map.Keys)) - n#25 == $decr0$0;
        assert Seq#Length(read($Heap, this, Map.Keys)) - n#25 < $decr0$0;
    }

    call CevStepEvent(#tok$0^135.5, loop_exited);
    assume {:captureState "Test\VSI-Benchmarks\b4.dfy(135,5): loop exit"} true;
}



const unique class.Node: ClassName;

const unique Node.key: Field BoxType;

const unique Node.val: Field BoxType;

const unique Node.next: Field ref;

axiom (forall $h: HeapType, $o: ref :: { read($h, $o, Node.next) } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) ==> read($h, $o, Node.next) == null || (read($h, read($h, $o, Node.next), alloc) && dtype(read($h, $o, Node.next)) == class.Node));

const unique class._default: ClassName;
