// Dafny program verifier version 2.0.0.0, Copyright (c) 2003-2010, Microsoft.
// Command Line Options: Test\VSI-Benchmarks\b8.dfy /print:..\boogie-k-induction-benchmarks\benchmarks\VSI-b8.bpl

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type ref;

const null: ref;

type Set T = [T]bool;

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, index: int, val: T, newLength: int) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T, len: int :: { Seq#Length(Seq#Build(s, i, v, len)) } 0 <= len ==> Seq#Length(Seq#Build(s, i, v, len)) == len);

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, n: int :: { Seq#Index(Seq#Build(s, i, v, len), n) } 0 <= n && n < len ==> (i == n ==> Seq#Index(Seq#Build(s, i, v, len), n) == v) && (i != n ==> Seq#Index(Seq#Build(s, i, v, len), n) == Seq#Index(s, n)));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: ref :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, i: int, v: T, len: int, x: T :: { Seq#Contains(Seq#Build(s, i, v, len), x) } Seq#Contains(Seq#Build(s, i, v, len), x) <==> (0 <= i && i < len && x == v) || (exists j: int :: { Seq#Index(s, j) } 0 <= j && j < Seq#Length(s) && j < len && j != i && Seq#Index(s, j) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Take(s, n)) == Seq#Length(s)));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n ==> (n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n) && (Seq#Length(s) < n ==> Seq#Length(Seq#Drop(s, n)) == 0));

axiom (forall<T> s: Seq T, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, t: Seq T :: { Seq#Append(s, t) } Seq#Take(Seq#Append(s, t), Seq#Length(s)) == s && Seq#Drop(Seq#Append(s, t), Seq#Length(s)) == t);

function $ite<T>(bool, T, T) : T;

axiom (forall<T> g: bool, a: T, b: T :: { $ite(g, a, b) } (g ==> $ite(g, a, b) == a) && (!g ==> $ite(g, a, b) == b));

type BoxType;

function $Box<T>(T) : BoxType;

function $Unbox<T>(BoxType) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall b: BoxType :: { $Unbox(b): int } $Box($Unbox(b): int) == b);

axiom (forall b: BoxType :: { $Unbox(b): ref } $Box($Unbox(b): ref) == b);

axiom (forall b: BoxType :: { $Unbox(b): Set BoxType } $Box($Unbox(b): Set BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): Seq BoxType } $Box($Unbox(b): Seq BoxType) == b);

axiom (forall b: BoxType :: { $Unbox(b): DatatypeType } $Box($Unbox(b): DatatypeType) == b);

type ClassName;

const unique class.int: ClassName;

const unique class.bool: ClassName;

const unique class.set: ClassName;

const unique class.seq: ClassName;

function dtype(ref) : ClassName;

function TypeParams(ref, int) : ClassName;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

const $InMethodContext: bool;

type Field _;

function FDim<T>(Field T) : int;

const unique alloc: Field bool;

axiom FDim(alloc) == 0;

function IndexField(int) : Field BoxType;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field BoxType, int) : Field BoxType;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field BoxType, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

procedure UpdateArrayRange(arr: ref, low: int, high: int, rhs: BoxType);
  modifies $Heap;
  ensures $HeapSucc(old($Heap), $Heap);
  ensures (forall i: int :: { read($Heap, arr, IndexField(i)) } low <= i && i < high ==> read($Heap, arr, IndexField(i)) == rhs);
  ensures (forall<alpha> o: ref, f: Field alpha :: { read($Heap, o, f) } read($Heap, o, f) == read(old($Heap), o, f) || (o == arr && FDim(f) == 1 && low <= IndexField_Inverse(f) && IndexField_Inverse(f) < high));



type HeapType = <alpha>[ref,Field alpha]alpha;

function {:inline true} read<alpha>(H: HeapType, r: ref, f: Field alpha) : alpha
{
  H[r, f]
}

function {:inline true} update<alpha>(H: HeapType, r: ref, f: Field alpha, v: alpha) : HeapType
{
  H[r, f := v]
}

function $IsGoodHeap(HeapType) : bool;

var $Heap: HeapType where $IsGoodHeap($Heap) && #cev_var_update(#cev_pc, cev_implicit, #loc.$Heap, $Heap);

const unique #loc.$Heap: $token;

function $HeapSucc(HeapType, HeapType) : bool;

axiom (forall<alpha> h: HeapType, r: ref, f: Field alpha, x: alpha :: { update(h, r, f, x) } $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: HeapType, b: HeapType, c: HeapType :: { $HeapSucc(a, b), $HeapSucc(b, c) } $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: HeapType, k: HeapType :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

axiom (forall x: int, y: int :: { x % y } { x / y } x % y == x - x / y * y);

axiom (forall x: int, y: int :: { x % y } 0 < y ==> 0 <= x % y && x % y < y);

axiom (forall x: int, y: int :: { x % y } y < 0 ==> y < x % y && x % y <= 0);

axiom (forall a: int, b: int, d: int :: { a % d, b % d } 2 <= d && a % d == b % d && a < b ==> a + d <= b);

type $token;

function $file_name_is(id: int, tok: $token) : bool;

type cf_event;

type var_locglob;

const unique conditional_moment: cf_event;

const unique took_then_branch: cf_event;

const unique took_else_branch: cf_event;

const unique loop_register: cf_event;

const unique loop_entered: cf_event;

const unique loop_exited: cf_event;

const unique cev_local: var_locglob;

const unique cev_global: var_locglob;

const unique cev_parameter: var_locglob;

const unique cev_implicit: var_locglob;

function #cev_init(n: int) : bool;

function #cev_save_position(n: int) : $token;

function #cev_var_intro<T,U>(n: int, locorglob: var_locglob, name: $token, val: T, typ: U) : bool;

function #cev_var_update<T>(n: int, locorglob: var_locglob, name: $token, val: T) : bool;

function #cev_control_flow_event(n: int, tag: cf_event) : bool;

function #cev_function_call(n: int) : bool;

var #cev_pc: int;

procedure CevVarIntro<T>(pos: $token, locorglob: var_locglob, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_intro(old(#cev_pc), locorglob, name, val, 0);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHere<T>(name: $token, val: T);
  ensures #cev_var_update(#cev_pc, cev_local, name, val);



procedure CevStep(pos: $token);
  modifies #cev_pc;
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdate<T>(pos: $token, name: $token, val: T);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_local, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevUpdateHeap(pos: $token, name: $token, val: HeapType);
  modifies #cev_pc;
  ensures #cev_var_update(old(#cev_pc), cev_implicit, name, val);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), tag);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures #cev_pc == old(#cev_pc) + 1;



procedure CevStepEvent(pos: $token, tag: cf_event);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc) + 1, tag);
  ensures #cev_save_position(old(#cev_pc) + 1) == pos;
  ensures #cev_pc == old(#cev_pc) + 2;



procedure CevPreLoop(pos: $token) returns (oldPC: int);
  modifies #cev_pc;
  ensures #cev_control_flow_event(old(#cev_pc), conditional_moment);
  ensures #cev_save_position(old(#cev_pc)) == pos;
  ensures oldPC == old(#cev_pc) && #cev_pc == old(#cev_pc) + 1;



const unique class.object: ClassName;

const unique class.array: ClassName;

axiom (forall o: ref :: 0 <= array.Length(o));

function array.Length(this: ref) : int;

const unique class.Queue: ClassName;

axiom FDim(Queue.contents) == 0 && DeclType(Queue.contents) == class.Queue;

const unique Queue.contents: Field (Seq BoxType);

const unique xxxxxfile: $token;

axiom $file_name_is(0, xxxxxfile);

const unique #tok$0^9.10: $token;

procedure CheckWellformed$$Queue.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Queue);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^9.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.this: $token;

implementation CheckWellformed$$Queue.Init(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^9.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    assume Seq#Length(read($Heap, this, Queue.contents)) == 0;
}



procedure Queue.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Queue);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^9.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures Seq#Length(read($Heap, this, Queue.contents)) == 0;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^12.10: $token;

procedure CheckWellformed$$Queue.Enqueue(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Queue, x#0: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^12.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^12.18: $token;

const unique #loc.x#0: $token;

implementation CheckWellformed$$Queue.Enqueue(this: ref, x#0: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^12.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^12.18, cev_parameter, #loc.x#0, x#0);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    assume Seq#Equal(read($Heap, this, Queue.contents), Seq#Append(old(read($Heap, this, Queue.contents)), Seq#Build(Seq#Empty(): Seq BoxType, 0, x#0, 1)));
}



procedure Queue.Enqueue(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Queue, x#0: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^12.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures Seq#Equal(read($Heap, this, Queue.contents), Seq#Append(old(read($Heap, this, Queue.contents)), Seq#Build(Seq#Empty(): Seq BoxType, 0, x#0, 1)));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^15.10: $token;

procedure CheckWellformed$$Queue.Dequeue(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Queue) returns (x#1: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^15.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^15.29: $token;

const unique #loc.x#1: $token;

implementation CheckWellformed$$Queue.Dequeue(this: ref) returns (x#1: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^15.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^15.29, cev_local, #loc.x#1, x#1);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    assume 0 < Seq#Length(read($Heap, this, Queue.contents));
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc x#1;
    assert 0 <= 1 && 1 <= Seq#Length(old(read($Heap, this, Queue.contents)));
    if (Seq#Equal(read($Heap, this, Queue.contents), Seq#Drop(old(read($Heap, this, Queue.contents)), 1)))
    {
        assert 0 <= 0 && 0 < Seq#Length(old(read($Heap, this, Queue.contents)));
    }

    assume Seq#Equal(read($Heap, this, Queue.contents), Seq#Drop(old(read($Heap, this, Queue.contents)), 1)) && x#1 == Seq#Index(old(read($Heap, this, Queue.contents)), 0);
}



procedure Queue.Dequeue(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Queue) returns (x#1: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires 0 < Seq#Length(read($Heap, this, Queue.contents));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^15.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures Seq#Equal(read($Heap, this, Queue.contents), Seq#Drop(old(read($Heap, this, Queue.contents)), 1)) && x#1 == Seq#Index(old(read($Heap, this, Queue.contents)), 0);
  ensures true ==> Seq#Equal(read($Heap, this, Queue.contents), Seq#Drop(old(read($Heap, this, Queue.contents)), 1));
  ensures true ==> x#1 == Seq#Index(old(read($Heap, this, Queue.contents)), 0);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



function Queue.Head($heap: HeapType, this: ref) : BoxType;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (19 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref :: { Queue.Head($Heap, this) } $IsGoodHeap($Heap) && this != null && 0 < Seq#Length(read($Heap, this, Queue.contents)) ==> Queue.Head($Heap, this) == Seq#Index(read($Heap, this, Queue.contents), 0));

// frame axiom for Queue.Head
axiom (forall $h0: HeapType, $h1: HeapType, this: ref :: { $HeapSucc($h0, $h1), Queue.Head($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Queue && read($h1, this, alloc) && dtype(this) == class.Queue && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Queue.Head($h0, this) == Queue.Head($h1, this));

procedure CheckWellformed$$Queue.Head(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Queue);
  free requires 0 == $ModuleContextHeight && 19 == $FunctionContextHeight;



implementation CheckWellformed$$Queue.Head(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    assume 0 < Seq#Length(read($Heap, this, Queue.contents));
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    assert $_Frame[this, Queue.contents];
    assert 0 <= 0 && 0 < Seq#Length(read($Heap, this, Queue.contents));
}



function Queue.Get($heap: HeapType, this: ref, i#2: int) : BoxType;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (20 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref, i#2: int :: { Queue.Get($Heap, this, i#2) } $IsGoodHeap($Heap) && this != null && 0 <= i#2 && i#2 < Seq#Length(read($Heap, this, Queue.contents)) ==> Queue.Get($Heap, this, i#2) == Seq#Index(read($Heap, this, Queue.contents), i#2));

// frame axiom for Queue.Get
axiom (forall $h0: HeapType, $h1: HeapType, this: ref, i#2: int :: { $HeapSucc($h0, $h1), Queue.Get($h1, this, i#2) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Queue && read($h1, this, alloc) && dtype(this) == class.Queue && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Queue.Get($h0, this, i#2) == Queue.Get($h1, this, i#2));

procedure CheckWellformed$$Queue.Get(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Queue, i#2: int);
  free requires 0 == $ModuleContextHeight && 20 == $FunctionContextHeight;



implementation CheckWellformed$$Queue.Get(this: ref, i#2: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    if (0 <= i#2)
    {
    }

    assume 0 <= i#2 && i#2 < Seq#Length(read($Heap, this, Queue.contents));
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    assert $_Frame[this, Queue.contents];
    assert 0 <= i#2 && i#2 < Seq#Length(read($Heap, this, Queue.contents));
}



const unique class.Glossary: ClassName;

const unique #tok$0^31.10: $token;

procedure CheckWellformed$$Glossary.Sort(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Glossary, q#3: ref where q#3 == null || (read($Heap, q#3, alloc) && dtype(q#3) == class.Queue && TypeParams(q#3, 0) == class.Word)) returns (r#4: ref where r#4 == null || (read($Heap, r#4, alloc) && dtype(r#4) == class.Queue && TypeParams(r#4, 0) == class.Word), perm#5: Seq BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^31.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^31.15: $token;

const unique #loc.q#3: $token;

const unique #tok$0^31.40: $token;

const unique #loc.r#4: $token;

const unique #tok$0^31.56: $token;

const unique #loc.perm#5: $token;

implementation CheckWellformed$$Glossary.Sort(this: ref, q#3: ref) returns (r#4: ref, perm#5: Seq BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#65: int;
  var j#66: int;
  var i#67: int;
  var i#68: int;
  var i#69: int;
  var w#70: ref;
  var i#71: int;
  var i#72: int;
  var j#73: int;
  var i#74: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^31.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^31.15, cev_parameter, #loc.q#3, q#3);
    call CevVarIntro(#tok$0^31.40, cev_local, #loc.r#4, r#4);
    call CevVarIntro(#tok$0^31.56, cev_local, #loc.perm#5, perm#5);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == q#3);
    assume q#3 != null;
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc r#4, perm#5;
    if (r#4 != null)
    {
    }

    assume r#4 != null && (r#4 == null || !read(old($Heap), r#4, alloc));
    assert r#4 != null;
    assert q#3 != null;
    assume Seq#Length(read($Heap, r#4, Queue.contents)) == Seq#Length(old(read($Heap, q#3, Queue.contents)));
    if (0 <= i#65)
    {
    }

    if (0 <= i#65 && i#65 < j#66)
    {
        assert r#4 != null;
    }

    if (0 <= i#65 && i#65 < j#66 && j#66 < Seq#Length(read($Heap, r#4, Queue.contents)))
    {
        assert r#4 != null;
        i#67 := i#65;
        assert 0 <= i#67 && i#67 < Seq#Length(read($Heap, r#4, Queue.contents));
        if ($Unbox(Queue.Get($Heap, r#4, i#65)): ref != null)
        {
            assert r#4 != null;
            i#68 := i#65;
            assert 0 <= i#68 && i#68 < Seq#Length(read($Heap, r#4, Queue.contents));
            assert $Unbox(Queue.Get($Heap, r#4, i#65)): ref != null;
            assert r#4 != null;
            i#69 := j#66;
            assert 0 <= i#69 && i#69 < Seq#Length(read($Heap, r#4, Queue.contents));
            w#70 := $Unbox(Queue.Get($Heap, r#4, j#66)): ref;
        }
    }

    assume (forall i#6: int, j#7: int :: 0 <= i#6 && i#6 < j#7 && j#7 < Seq#Length(read($Heap, r#4, Queue.contents)) ==> $Unbox(Queue.Get($Heap, r#4, i#6)): ref != null && Word.AtMost($Heap, $Unbox(Queue.Get($Heap, r#4, i#6)): ref, $Unbox(Queue.Get($Heap, r#4, j#7)): ref));
    assert r#4 != null;
    assume Seq#Length(perm#5) == Seq#Length(read($Heap, r#4, Queue.contents));
    if (0 <= i#71)
    {
    }

    if (0 <= i#71 && i#71 < Seq#Length(perm#5))
    {
        assert 0 <= i#71 && i#71 < Seq#Length(perm#5);
        if (0 <= $Unbox(Seq#Index(perm#5, i#71)): int)
        {
            assert 0 <= i#71 && i#71 < Seq#Length(perm#5);
        }
    }

    assume (forall i#8: int :: 0 <= i#8 && i#8 < Seq#Length(perm#5) ==> 0 <= $Unbox(Seq#Index(perm#5, i#8)): int && $Unbox(Seq#Index(perm#5, i#8)): int < Seq#Length(perm#5));
    if (0 <= i#72)
    {
    }

    if (0 <= i#72 && i#72 < j#73)
    {
    }

    if (0 <= i#72 && i#72 < j#73 && j#73 < Seq#Length(perm#5))
    {
        assert 0 <= i#72 && i#72 < Seq#Length(perm#5);
        assert 0 <= j#73 && j#73 < Seq#Length(perm#5);
    }

    assume (forall i#9: int, j#10: int :: 0 <= i#9 && i#9 < j#10 && j#10 < Seq#Length(perm#5) ==> $Unbox(Seq#Index(perm#5, i#9)): int != $Unbox(Seq#Index(perm#5, j#10)): int);
    if (0 <= i#74)
    {
    }

    if (0 <= i#74 && i#74 < Seq#Length(perm#5))
    {
        assert r#4 != null;
        assert 0 <= i#74 && i#74 < Seq#Length(read($Heap, r#4, Queue.contents));
        assert q#3 != null;
        assert 0 <= i#74 && i#74 < Seq#Length(perm#5);
        assert 0 <= $Unbox(Seq#Index(perm#5, i#74)): int && $Unbox(Seq#Index(perm#5, i#74)): int < Seq#Length(old(read($Heap, q#3, Queue.contents)));
    }

    assume (forall i#11: int :: 0 <= i#11 && i#11 < Seq#Length(perm#5) ==> $Unbox(Seq#Index(read($Heap, r#4, Queue.contents), i#11)): ref == $Unbox(Seq#Index(old(read($Heap, q#3, Queue.contents)), $Unbox(Seq#Index(perm#5, i#11)): int)): ref);
}



procedure Glossary.Sort(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Glossary, q#3: ref where q#3 == null || (read($Heap, q#3, alloc) && dtype(q#3) == class.Queue && TypeParams(q#3, 0) == class.Word)) returns (r#4: ref where r#4 == null || (read($Heap, r#4, alloc) && dtype(r#4) == class.Queue && TypeParams(r#4, 0) == class.Word), perm#5: Seq BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  requires q#3 != null;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^31.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures r#4 != null && (r#4 == null || !read(old($Heap), r#4, alloc));
  ensures true ==> r#4 != null;
  ensures true ==> r#4 == null || !read(old($Heap), r#4, alloc);
  ensures Seq#Length(read($Heap, r#4, Queue.contents)) == Seq#Length(old(read($Heap, q#3, Queue.contents)));
  ensures (forall i#6: int, j#7: int :: 0 <= i#6 && i#6 < j#7 && j#7 < Seq#Length(read($Heap, r#4, Queue.contents)) ==> $Unbox(Queue.Get($Heap, r#4, i#6)): ref != null && Word.AtMost($Heap, $Unbox(Queue.Get($Heap, r#4, i#6)): ref, $Unbox(Queue.Get($Heap, r#4, j#7)): ref));
  ensures Seq#Length(perm#5) == Seq#Length(read($Heap, r#4, Queue.contents));
  ensures (forall i#8: int :: 0 <= i#8 && i#8 < Seq#Length(perm#5) ==> 0 <= $Unbox(Seq#Index(perm#5, i#8)): int && $Unbox(Seq#Index(perm#5, i#8)): int < Seq#Length(perm#5));
  ensures (forall i#9: int, j#10: int :: 0 <= i#9 && i#9 < j#10 && j#10 < Seq#Length(perm#5) ==> $Unbox(Seq#Index(perm#5, i#9)): int != $Unbox(Seq#Index(perm#5, j#10)): int);
  ensures (forall i#11: int :: 0 <= i#11 && i#11 < Seq#Length(perm#5) ==> $Unbox(Seq#Index(read($Heap, r#4, Queue.contents), i#11)): ref == $Unbox(Seq#Index(old(read($Heap, q#3, Queue.contents)), $Unbox(Seq#Index(perm#5, i#11)): int)): ref);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == q#3);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^46.10: $token;

procedure CheckWellformed$$Glossary.Main(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Glossary);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^46.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



implementation CheckWellformed$$Glossary.Main(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^46.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
}



procedure Glossary.Main(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Glossary);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^46.10;
  modifies $Heap, #cev_pc;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.rs#12: $token;

const unique #tok$0^48.9: $token;

const unique #tok$0^49.5: $token;

const unique #loc.glossary#13: $token;

const unique #tok$0^50.9: $token;

const unique #tok$0^51.5: $token;

const unique #loc.q#14: $token;

const unique #tok$0^52.9: $token;

const unique #tok$0^53.5: $token;

const unique #tok$0^55.5: $token;

axiom FDim(ReaderStream.footprint) == 0 && DeclType(ReaderStream.footprint) == class.ReaderStream;

axiom FDim(ReaderStream.isOpen) == 0 && DeclType(ReaderStream.isOpen) == class.ReaderStream;

axiom FDim(Map.keys) == 0 && DeclType(Map.keys) == class.Map;

axiom FDim(Map.values) == 0 && DeclType(Map.values) == class.Map;

const unique #loc.term#16: $token;

const unique #tok$0^65.12: $token;

const unique #loc.definition#17: $token;

const unique #tok$0^65.17: $token;

const unique #loc.term: $token;

const unique #loc.definition: $token;

const unique #tok$0^65.7: $token;

const unique #tok$0^66.7: $token;

const unique #tok$0^66.25: $token;

const unique #loc.present#18: $token;

const unique #tok$0^69.12: $token;

const unique #loc.d#19: $token;

const unique #tok$0^69.21: $token;

const unique #loc.present: $token;

const unique #loc.d: $token;

const unique #tok$0^69.7: $token;

const unique #tok$0^70.7: $token;

const unique #tok$0^70.21: $token;

const unique #tok$0^71.9: $token;

const unique #tok$0^72.9: $token;

const unique #tok$0^76.5: $token;

const unique #loc.p#20: $token;

const unique #tok$0^77.12: $token;

const unique #loc.q: $token;

const unique #loc.p: $token;

const unique #tok$0^77.5: $token;

const unique #loc.wr#21: $token;

const unique #tok$0^78.9: $token;

const unique #tok$0^79.5: $token;

const unique #tok$0^81.5: $token;

axiom FDim(WriterStream.footprint) == 0 && DeclType(WriterStream.footprint) == class.WriterStream;

axiom FDim(WriterStream.isOpen) == 0 && DeclType(WriterStream.isOpen) == class.WriterStream;

const unique #loc.term#24: $token;

const unique #tok$0^89.12: $token;

const unique #tok$0^89.7: $token;

const unique #loc.present#25: $token;

const unique #tok$0^90.12: $token;

const unique #loc.definition#26: $token;

const unique #tok$0^90.20: $token;

const unique #tok$0^90.7: $token;

const unique #tok$0^94.7: $token;

const unique #loc.i#27: $token;

const unique #tok$0^95.11: $token;

const unique #loc.qcon#28: $token;

const unique #tok$0^97.11: $token;

const unique #tok$0^98.7: $token;

const unique #loc.w#31: $token;

const unique #tok$0^107.13: $token;

const unique #loc.d#32: $token;

const unique #tok$0^108.23: $token;

const unique #tok$0^108.9: $token;

const unique #tok$0^109.9: $token;

const unique #tok$0^110.9: $token;

const unique #tok$0^111.11: $token;

const unique #tok$0^114.9: $token;

const unique #tok$0^115.11: $token;

const unique #tok$0^117.10: $token;

const unique #tok$0^120.5: $token;

implementation Glossary.Main(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var rs#12: ref where (rs#12 == null || (read($Heap, rs#12, alloc) && dtype(rs#12) == class.ReaderStream)) && #cev_var_update(#cev_pc, cev_local, #loc.rs#12, rs#12);
  var $nw: ref;
  var glossary#13: ref where (glossary#13 == null || (read($Heap, glossary#13, alloc) && dtype(glossary#13) == class.Map && TypeParams(glossary#13, 0) == class.Word && TypeParams(glossary#13, 1) == TypeTuple(class.seq, class.Word))) && #cev_var_update(#cev_pc, cev_local, #loc.glossary#13, glossary#13);
  var q#14: ref where (q#14 == null || (read($Heap, q#14, alloc) && dtype(q#14) == class.Queue && TypeParams(q#14, 0) == class.Word)) && #cev_var_update(#cev_pc, cev_local, #loc.q#14, q#14);
  var $PreLoopHeap0: HeapType;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var term#16: ref where (term#16 == null || (read($Heap, term#16, alloc) && dtype(term#16) == class.Word)) && #cev_var_update(#cev_pc, cev_local, #loc.term#16, term#16);
  var definition#17: Seq BoxType where (forall $i: int :: { Seq#Index(definition#17, $i) } 0 <= $i && $i < Seq#Length(definition#17) ==> $Unbox(Seq#Index(definition#17, $i)): ref == null || (read($Heap, $Unbox(Seq#Index(definition#17, $i)): ref, alloc) && dtype($Unbox(Seq#Index(definition#17, $i)): ref) == class.Word)) && #cev_var_update(#cev_pc, cev_local, #loc.definition#17, definition#17);
  var rs#75: ref;
  var present#18: bool where #cev_var_update(#cev_pc, cev_local, #loc.present#18, present#18);
  var d#19: Seq BoxType where (forall $i: int :: { Seq#Index(d#19, $i) } 0 <= $i && $i < Seq#Length(d#19) ==> $Unbox(Seq#Index(d#19, $i)): ref == null || (read($Heap, $Unbox(Seq#Index(d#19, $i)): ref, alloc) && dtype($Unbox(Seq#Index(d#19, $i)): ref) == class.Word)) && #cev_var_update(#cev_pc, cev_local, #loc.d#19, d#19);
  var key#76: BoxType;
  var $tmp#0: BoxType;
  var key#77: BoxType;
  var val#78: BoxType;
  var x#79: BoxType;
  var p#20: Seq BoxType where #cev_var_update(#cev_pc, cev_local, #loc.p#20, p#20);
  var q#80: ref;
  var wr#21: ref where (wr#21 == null || (read($Heap, wr#21, alloc) && dtype(wr#21) == class.WriterStream)) && #cev_var_update(#cev_pc, cev_local, #loc.wr#21, wr#21);
  var $PreLoopHeap1: HeapType;
  var $decr1$init$0: int;
  var $w1: bool;
  var $PreLoopCevPC1: int;
  var $decr1$0: int;
  var term#24: ref where (term#24 == null || (read($Heap, term#24, alloc) && dtype(term#24) == class.Word)) && #cev_var_update(#cev_pc, cev_local, #loc.term#24, term#24);
  var $tmp#1: BoxType;
  var present#25: bool where #cev_var_update(#cev_pc, cev_local, #loc.present#25, present#25);
  var definition#26: Seq BoxType where (forall $i: int :: { Seq#Index(definition#26, $i) } 0 <= $i && $i < Seq#Length(definition#26) ==> $Unbox(Seq#Index(definition#26, $i)): ref == null || (read($Heap, $Unbox(Seq#Index(definition#26, $i)): ref, alloc) && dtype($Unbox(Seq#Index(definition#26, $i)): ref) == class.Word)) && #cev_var_update(#cev_pc, cev_local, #loc.definition#26, definition#26);
  var key#81: BoxType;
  var $tmp#2: BoxType;
  var tag#82: ref;
  var w#83: ref;
  var i#27: int where #cev_var_update(#cev_pc, cev_local, #loc.i#27, i#27);
  var qcon#28: Seq BoxType where (forall $i: int :: { Seq#Index(qcon#28, $i) } 0 <= $i && $i < Seq#Length(qcon#28) ==> $Unbox(Seq#Index(qcon#28, $i)): ref == null || (read($Heap, $Unbox(Seq#Index(qcon#28, $i)): ref, alloc) && dtype($Unbox(Seq#Index(qcon#28, $i)): ref) == class.Word)) && #cev_var_update(#cev_pc, cev_local, #loc.qcon#28, qcon#28);
  var $PreLoopHeap2: HeapType;
  var $decr2$init$0: int;
  var $w2: bool;
  var $PreLoopCevPC2: int;
  var $decr2$0: int;
  var w#31: ref where (w#31 == null || (read($Heap, w#31, alloc) && dtype(w#31) == class.Word)) && #cev_var_update(#cev_pc, cev_local, #loc.w#31, w#31);
  var d#32: Seq BoxType where (forall $i: int :: { Seq#Index(d#32, $i) } 0 <= $i && $i < Seq#Length(d#32) ==> $Unbox(Seq#Index(d#32, $i)): ref == null || (read($Heap, $Unbox(Seq#Index(d#32, $i)): ref, alloc) && dtype($Unbox(Seq#Index(d#32, $i)): ref) == class.Word)) && #cev_var_update(#cev_pc, cev_local, #loc.d#32, d#32);
  var key#84: BoxType;
  var $tmp#3: BoxType;
  var tag#85: ref;
  var w#86: ref;
  var w#87: ref;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^46.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(48,9)
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.ReaderStream;
    $Heap := update($Heap, $nw, alloc, true);
    rs#12 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(48,9)"} true;
    call CevVarIntro(#tok$0^48.9, cev_local, #loc.rs#12, rs#12);
    // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(49,5)
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == rs#12 ==> $_Frame[$o, $f]);
    call ReaderStream.Open(rs#12);
    call CevStep(#tok$0^49.5);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(49,5)"} true;
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(50,9)
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.Map && TypeParams($nw, 0) == class.Word && TypeParams($nw, 1) == TypeTuple(class.seq, class.Word);
    $Heap := update($Heap, $nw, alloc, true);
    glossary#13 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(50,9)"} true;
    call CevVarIntro(#tok$0^50.9, cev_local, #loc.glossary#13, glossary#13);
    // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(51,5)
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == glossary#13 ==> $_Frame[$o, $f]);
    call Map.Init(glossary#13);
    call CevStep(#tok$0^51.5);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(51,5)"} true;
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(52,9)
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.Queue && TypeParams($nw, 0) == class.Word;
    $Heap := update($Heap, $nw, alloc, true);
    q#14 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(52,9)"} true;
    call CevVarIntro(#tok$0^52.9, cev_local, #loc.q#14, q#14);
    // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(53,5)
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == q#14 ==> $_Frame[$o, $f]);
    call Queue.Init(q#14);
    call CevStep(#tok$0^53.5);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(53,5)"} true;
    // ----- while statement ----- Test\VSI-Benchmarks\b8.dfy(55,5)
    $PreLoopHeap0 := $Heap;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^55.5);
    while (true)
      free invariant ReaderStream.Valid($Heap, rs#12) ==> !read($Heap, rs#12, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#12, ReaderStream.footprint)[$Box(rs#12)] && read($Heap, rs#12, ReaderStream.isOpen);
      invariant $w0 && (ReaderStream.Valid($Heap, rs#12) ==> !read($Heap, rs#12, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#12, ReaderStream.footprint)[$Box(rs#12)] && read($Heap, rs#12, ReaderStream.isOpen)) ==> !read($Heap, rs#12, ReaderStream.footprint)[$Box(null)];
      invariant $w0 && (ReaderStream.Valid($Heap, rs#12) ==> !read($Heap, rs#12, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#12, ReaderStream.footprint)[$Box(rs#12)] && read($Heap, rs#12, ReaderStream.isOpen)) ==> read($Heap, rs#12, ReaderStream.footprint)[$Box(rs#12)];
      invariant $w0 && (ReaderStream.Valid($Heap, rs#12) ==> !read($Heap, rs#12, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#12, ReaderStream.footprint)[$Box(rs#12)] && read($Heap, rs#12, ReaderStream.isOpen)) ==> read($Heap, rs#12, ReaderStream.isOpen);
      invariant $w0 && (ReaderStream.Valid($Heap, rs#12) ==> !read($Heap, rs#12, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#12, ReaderStream.footprint)[$Box(rs#12)] && read($Heap, rs#12, ReaderStream.isOpen)) ==> (forall $o: ref :: $o != null && read($Heap, rs#12, ReaderStream.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc));
      free invariant $w0 ==> ReaderStream.Valid($Heap, rs#12) && (forall $o: ref :: $o != null && read($Heap, rs#12, ReaderStream.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc));
      free invariant Map.Valid($Heap, glossary#13) ==> Seq#Length(read($Heap, glossary#13, Map.keys)) == Seq#Length(read($Heap, glossary#13, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, glossary#13, Map.keys)) ==> Seq#Index(read($Heap, glossary#13, Map.keys), i#45) != Seq#Index(read($Heap, glossary#13, Map.keys), j#46));
      invariant $w0 && (Map.Valid($Heap, glossary#13) ==> Seq#Length(read($Heap, glossary#13, Map.keys)) == Seq#Length(read($Heap, glossary#13, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, glossary#13, Map.keys)) ==> Seq#Index(read($Heap, glossary#13, Map.keys), i#45) != Seq#Index(read($Heap, glossary#13, Map.keys), j#46))) ==> Seq#Length(read($Heap, glossary#13, Map.keys)) == Seq#Length(read($Heap, glossary#13, Map.values));
      invariant $w0 && (Map.Valid($Heap, glossary#13) ==> Seq#Length(read($Heap, glossary#13, Map.keys)) == Seq#Length(read($Heap, glossary#13, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, glossary#13, Map.keys)) ==> Seq#Index(read($Heap, glossary#13, Map.keys), i#45) != Seq#Index(read($Heap, glossary#13, Map.keys), j#46))) ==> (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, glossary#13, Map.keys)) ==> Seq#Index(read($Heap, glossary#13, Map.keys), i#45) != Seq#Index(read($Heap, glossary#13, Map.keys), j#46));
      free invariant $w0 ==> Map.Valid($Heap, glossary#13);
      invariant $w0 ==> !read($Heap, rs#12, ReaderStream.footprint)[$Box(glossary#13)];
      invariant $w0 ==> !Seq#Contains(read($Heap, glossary#13, Map.keys), $Box(null));
      invariant $w0 ==> (forall d#15: Seq BoxType :: Seq#Contains(read($Heap, glossary#13, Map.values), $Box(d#15)) ==> !Seq#Contains(d#15, $Box(null)));
      invariant $w0 ==> !read($Heap, rs#12, ReaderStream.footprint)[$Box(q#14)];
      invariant $w0 ==> Seq#Equal(read($Heap, q#14, Queue.contents), read($Heap, glossary#13, Map.keys));
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant #cev_save_position(#cev_pc) == #tok$0^55.5;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} rs#12 != null && (ReaderStream.Valid($Heap, rs#12) ==> rs#12 != null);
            assume ReaderStream.Valid($Heap, rs#12) && (forall $o: ref :: $o != null && read($Heap, rs#12, ReaderStream.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc));
            assert {:subsumption 0} glossary#13 != null;
            assume Map.Valid($Heap, glossary#13);
            assert {:subsumption 0} rs#12 != null;
            assume !read($Heap, rs#12, ReaderStream.footprint)[$Box(glossary#13)];
            assert {:subsumption 0} glossary#13 != null;
            assume !Seq#Contains(read($Heap, glossary#13, Map.keys), $Box(null));
            assert {:subsumption 0} (forall d#15: Seq BoxType :: glossary#13 != null && (Seq#Contains(read($Heap, glossary#13, Map.values), $Box(d#15)) ==> true));
            assume (forall d#15: Seq BoxType :: Seq#Contains(read($Heap, glossary#13, Map.values), $Box(d#15)) ==> !Seq#Contains(d#15, $Box(null)));
            assert {:subsumption 0} rs#12 != null;
            assume !read($Heap, rs#12, ReaderStream.footprint)[$Box(q#14)];
            assert {:subsumption 0} q#14 != null && glossary#13 != null;
            assume Seq#Equal(read($Heap, q#14, Queue.contents), read($Heap, glossary#13, Map.keys));
            assert true;
            assume false;
        }

        assert true;
        if (!true)
        {
            break;
        }

        call CevStepEvent(#tok$0^55.5, loop_entered);
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(55,5): loop entered"} true;
        // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(65,12)
        call CevVarIntro(#tok$0^65.12, cev_local, #loc.term#16, term#16);
        // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(65,17)
        call CevVarIntro(#tok$0^65.17, cev_local, #loc.definition#17, definition#17);
        // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(65,7)
        assert true;
        rs#75 := rs#12;
        assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && rs#75 != null && read($Heap, rs#75, ReaderStream.footprint)[$Box($o)] ==> $_Frame[$o, $f]);
        call term#16, definition#17 := Glossary.readDefinition(this, rs#75);
        call CevUpdateHere(#loc.term, term#16);
        call CevUpdateHere(#loc.definition, definition#17);
        call CevStep(#tok$0^65.7);
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(65,7)"} true;
        // ----- if statement ----- Test\VSI-Benchmarks\b8.dfy(66,7)
        call CevEvent(#tok$0^66.7, conditional_moment);
        assert true;
        if (term#16 == null)
        {
            call CevEvent(#tok$0^66.25, took_then_branch);
            // ----- break statement ----- Test\VSI-Benchmarks\b8.dfy(67,9)
            break;
        }
        else
        {
            call CevEvent(#tok$0^66.7, took_else_branch);
        }

        // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(69,12)
        call CevVarIntro(#tok$0^69.12, cev_local, #loc.present#18, present#18);
        // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(69,21)
        call CevVarIntro(#tok$0^69.21, cev_local, #loc.d#19, d#19);
        // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(69,7)
        assert true;
        key#76 := $Box(term#16);
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        call present#18, $tmp#0 := Map.Find(glossary#13, key#76);
        call CevUpdateHere(#loc.present, present#18);
        d#19 := $Unbox($tmp#0): Seq BoxType;
        call CevUpdateHere(#loc.d, d#19);
        call CevStep(#tok$0^69.7);
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(69,7)"} true;
        // ----- if statement ----- Test\VSI-Benchmarks\b8.dfy(70,7)
        call CevEvent(#tok$0^70.7, conditional_moment);
        assert true;
        if (!present#18)
        {
            call CevEvent(#tok$0^70.21, took_then_branch);
            // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(71,9)
            assert true;
            key#77 := $Box(term#16);
            assert true;
            val#78 := $Box(definition#17);
            assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == glossary#13 ==> $_Frame[$o, $f]);
            call Map.Add(glossary#13, key#77, val#78);
            call CevStep(#tok$0^71.9);
            assume {:captureState "Test\VSI-Benchmarks\b8.dfy(71,9)"} true;
            // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(72,9)
            assert true;
            x#79 := $Box(term#16);
            assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == q#14 ==> $_Frame[$o, $f]);
            call Queue.Enqueue(q#14, x#79);
            call CevStep(#tok$0^72.9);
            assume {:captureState "Test\VSI-Benchmarks\b8.dfy(72,9)"} true;
        }
        else
        {
            call CevEvent(#tok$0^70.7, took_else_branch);
        }
    }

    call CevStepEvent(#tok$0^55.5, loop_exited);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(55,5): loop exit"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(76,5)
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && rs#12 != null && read($Heap, rs#12, ReaderStream.footprint)[$Box($o)] ==> $_Frame[$o, $f]);
    call ReaderStream.Close(rs#12);
    call CevStep(#tok$0^76.5);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(76,5)"} true;
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(77,12)
    call CevVarIntro(#tok$0^77.12, cev_local, #loc.p#20, p#20);
    // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(77,5)
    assert true;
    q#80 := q#14;
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == q#80 ==> $_Frame[$o, $f]);
    call q#14, p#20 := Glossary.Sort(this, q#80);
    call CevUpdateHere(#loc.q, q#14);
    call CevUpdateHere(#loc.p, p#20);
    call CevStep(#tok$0^77.5);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(77,5)"} true;
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(78,9)
    havoc $nw;
    assume $nw != null && !read($Heap, $nw, alloc) && dtype($nw) == class.WriterStream;
    $Heap := update($Heap, $nw, alloc, true);
    wr#21 := $nw;
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(78,9)"} true;
    call CevVarIntro(#tok$0^78.9, cev_local, #loc.wr#21, wr#21);
    // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(79,5)
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == wr#21 ==> $_Frame[$o, $f]);
    call WriterStream.Create(wr#21);
    call CevStep(#tok$0^79.5);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(79,5)"} true;
    // ----- while statement ----- Test\VSI-Benchmarks\b8.dfy(81,5)
    $PreLoopHeap1 := $Heap;
    $decr1$init$0 := Seq#Length(read($Heap, q#14, Queue.contents)) - 0;
    havoc $w1;
    call $PreLoopCevPC1 := CevPreLoop(#tok$0^81.5);
    while (true)
      free invariant WriterStream.Valid($Heap, wr#21) ==> !read($Heap, wr#21, WriterStream.footprint)[$Box(null)] && read($Heap, wr#21, WriterStream.footprint)[$Box(wr#21)] && read($Heap, wr#21, WriterStream.isOpen);
      invariant $w1 && (WriterStream.Valid($Heap, wr#21) ==> !read($Heap, wr#21, WriterStream.footprint)[$Box(null)] && read($Heap, wr#21, WriterStream.footprint)[$Box(wr#21)] && read($Heap, wr#21, WriterStream.isOpen)) ==> !read($Heap, wr#21, WriterStream.footprint)[$Box(null)];
      invariant $w1 && (WriterStream.Valid($Heap, wr#21) ==> !read($Heap, wr#21, WriterStream.footprint)[$Box(null)] && read($Heap, wr#21, WriterStream.footprint)[$Box(wr#21)] && read($Heap, wr#21, WriterStream.isOpen)) ==> read($Heap, wr#21, WriterStream.footprint)[$Box(wr#21)];
      invariant $w1 && (WriterStream.Valid($Heap, wr#21) ==> !read($Heap, wr#21, WriterStream.footprint)[$Box(null)] && read($Heap, wr#21, WriterStream.footprint)[$Box(wr#21)] && read($Heap, wr#21, WriterStream.isOpen)) ==> read($Heap, wr#21, WriterStream.isOpen);
      invariant $w1 && (WriterStream.Valid($Heap, wr#21) ==> !read($Heap, wr#21, WriterStream.footprint)[$Box(null)] && read($Heap, wr#21, WriterStream.footprint)[$Box(wr#21)] && read($Heap, wr#21, WriterStream.isOpen)) ==> (forall $o: ref :: $o != null && read($Heap, wr#21, WriterStream.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc));
      free invariant $w1 ==> WriterStream.Valid($Heap, wr#21) && (forall $o: ref :: $o != null && read($Heap, wr#21, WriterStream.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc));
      free invariant Map.Valid($Heap, glossary#13) ==> Seq#Length(read($Heap, glossary#13, Map.keys)) == Seq#Length(read($Heap, glossary#13, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, glossary#13, Map.keys)) ==> Seq#Index(read($Heap, glossary#13, Map.keys), i#45) != Seq#Index(read($Heap, glossary#13, Map.keys), j#46));
      invariant $w1 && (Map.Valid($Heap, glossary#13) ==> Seq#Length(read($Heap, glossary#13, Map.keys)) == Seq#Length(read($Heap, glossary#13, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, glossary#13, Map.keys)) ==> Seq#Index(read($Heap, glossary#13, Map.keys), i#45) != Seq#Index(read($Heap, glossary#13, Map.keys), j#46))) ==> Seq#Length(read($Heap, glossary#13, Map.keys)) == Seq#Length(read($Heap, glossary#13, Map.values));
      invariant $w1 && (Map.Valid($Heap, glossary#13) ==> Seq#Length(read($Heap, glossary#13, Map.keys)) == Seq#Length(read($Heap, glossary#13, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, glossary#13, Map.keys)) ==> Seq#Index(read($Heap, glossary#13, Map.keys), i#45) != Seq#Index(read($Heap, glossary#13, Map.keys), j#46))) ==> (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, glossary#13, Map.keys)) ==> Seq#Index(read($Heap, glossary#13, Map.keys), i#45) != Seq#Index(read($Heap, glossary#13, Map.keys), j#46));
      free invariant $w1 ==> Map.Valid($Heap, glossary#13);
      invariant $w1 ==> !read($Heap, wr#21, WriterStream.footprint)[$Box(glossary#13)];
      invariant $w1 ==> !Seq#Contains(read($Heap, glossary#13, Map.keys), $Box(null));
//      free invariant $w1 ==> !read($Heap, wr#21, WriterStream.footprint)[$Box(glossary#13)] && !Seq#Contains(read($Heap, glossary#13, Map.keys), $Box(null));
      invariant $w1 ==> (forall d#22: Seq BoxType :: Seq#Contains(read($Heap, glossary#13, Map.values), $Box(d#22)) ==> !Seq#Contains(d#22, $Box(null)));
      invariant $w1 ==> !read($Heap, wr#21, WriterStream.footprint)[$Box(q#14)];
      invariant $w1 ==> (forall k#23: ref :: Seq#Contains(read($Heap, q#14, Queue.contents), $Box(k#23)) ==> Seq#Contains(read($Heap, glossary#13, Map.keys), $Box(k#23)));
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap1, $o, $f));
      free invariant $HeapSucc($PreLoopHeap1, $Heap);
      free invariant Seq#Length(read($Heap, q#14, Queue.contents)) - 0 <= $decr1$init$0 && (Seq#Length(read($Heap, q#14, Queue.contents)) - 0 == $decr1$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^81.5;
      free invariant $PreLoopCevPC1 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);	
      kUnwind 1;
    {
        if (!$w1)
        {
            assert {:subsumption 0} wr#21 != null && (WriterStream.Valid($Heap, wr#21) ==> wr#21 != null);
            assume WriterStream.Valid($Heap, wr#21) && (forall $o: ref :: $o != null && read($Heap, wr#21, WriterStream.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc));
            assert {:subsumption 0} glossary#13 != null;
            assume Map.Valid($Heap, glossary#13);
            assert {:subsumption 0} wr#21 != null && (!read($Heap, wr#21, WriterStream.footprint)[$Box(glossary#13)] ==> glossary#13 != null);
            assume !read($Heap, wr#21, WriterStream.footprint)[$Box(glossary#13)] && !Seq#Contains(read($Heap, glossary#13, Map.keys), $Box(null));
            assert {:subsumption 0} (forall d#22: Seq BoxType :: glossary#13 != null && (Seq#Contains(read($Heap, glossary#13, Map.values), $Box(d#22)) ==> true));
            assume (forall d#22: Seq BoxType :: Seq#Contains(read($Heap, glossary#13, Map.values), $Box(d#22)) ==> !Seq#Contains(d#22, $Box(null)));
            assert {:subsumption 0} wr#21 != null;
            assume !read($Heap, wr#21, WriterStream.footprint)[$Box(q#14)];
            assert {:subsumption 0} (forall k#23: ref :: q#14 != null && (Seq#Contains(read($Heap, q#14, Queue.contents), $Box(k#23)) ==> glossary#13 != null));
            assume (forall k#23: ref :: Seq#Contains(read($Heap, q#14, Queue.contents), $Box(k#23)) ==> Seq#Contains(read($Heap, glossary#13, Map.keys), $Box(k#23)));
            assert q#14 != null;
            assume false;
        }

        assert q#14 != null;
        if (0 >= Seq#Length(read($Heap, q#14, Queue.contents)))
        {
            break;
        }

        call CevStepEvent(#tok$0^81.5, loop_entered);
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(81,5): loop entered"} true;
        $decr1$0 := Seq#Length(read($Heap, q#14, Queue.contents)) - 0;
        // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(89,12)
        call CevVarIntro(#tok$0^89.12, cev_local, #loc.term#24, term#24);
        // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(89,7)
        assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && $o == q#14 ==> $_Frame[$o, $f]);
        call $tmp#1 := Queue.Dequeue(q#14);
        term#24 := $Unbox($tmp#1): ref;
        call CevUpdateHere(#loc.term, term#24);
        call CevStep(#tok$0^89.7);
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(89,7)"} true;
        // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(90,12)
        call CevVarIntro(#tok$0^90.12, cev_local, #loc.present#25, present#25);
        // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(90,20)
        call CevVarIntro(#tok$0^90.20, cev_local, #loc.definition#26, definition#26);
        // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(90,7)
        assert true;
        key#81 := $Box(term#24);
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        call present#25, $tmp#2 := Map.Find(glossary#13, key#81);
        call CevUpdateHere(#loc.present, present#25);
        definition#26 := $Unbox($tmp#2): Seq BoxType;
        call CevUpdateHere(#loc.definition, definition#26);
        call CevStep(#tok$0^90.7);
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(90,7)"} true;
        // ----- assert statement ----- Test\VSI-Benchmarks\b8.dfy(91,7)
        assert {:subsumption 0} true;
        assert present#25;
        // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(94,7)
        assert true;
        tag#82 := term#24;
        assert true;
        w#83 := term#24;
        assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && wr#21 != null && read($Heap, wr#21, WriterStream.footprint)[$Box($o)] ==> $_Frame[$o, $f]);
        call WriterStream.PutWordInsideTag(wr#21, tag#82, w#83);
        call CevStep(#tok$0^94.7);
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(94,7)"} true;
        // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(95,11)
        assert true;
        assert true;
        i#27 := 0;
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(95,11)"} true;
        call CevVarIntro(#tok$0^95.11, cev_local, #loc.i#27, i#27);
        // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(97,11)
        assert true;
        assert q#14 != null;
        qcon#28 := read($Heap, q#14, Queue.contents);
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(97,11)"} true;
        call CevVarIntro(#tok$0^97.11, cev_local, #loc.qcon#28, qcon#28);
        // ----- while statement ----- Test\VSI-Benchmarks\b8.dfy(98,7)
        $PreLoopHeap2 := $Heap;
        $decr2$init$0 := Seq#Length(definition#26) - i#27;
        havoc $w2;
        call $PreLoopCevPC2 := CevPreLoop(#tok$0^98.7);
        while (true)
          free invariant WriterStream.Valid($Heap, wr#21) ==> !read($Heap, wr#21, WriterStream.footprint)[$Box(null)] && read($Heap, wr#21, WriterStream.footprint)[$Box(wr#21)] && read($Heap, wr#21, WriterStream.isOpen);
          invariant $w2 && (WriterStream.Valid($Heap, wr#21) ==> !read($Heap, wr#21, WriterStream.footprint)[$Box(null)] && read($Heap, wr#21, WriterStream.footprint)[$Box(wr#21)] && read($Heap, wr#21, WriterStream.isOpen)) ==> !read($Heap, wr#21, WriterStream.footprint)[$Box(null)];
          invariant $w2 && (WriterStream.Valid($Heap, wr#21) ==> !read($Heap, wr#21, WriterStream.footprint)[$Box(null)] && read($Heap, wr#21, WriterStream.footprint)[$Box(wr#21)] && read($Heap, wr#21, WriterStream.isOpen)) ==> read($Heap, wr#21, WriterStream.footprint)[$Box(wr#21)];
          invariant $w2 && (WriterStream.Valid($Heap, wr#21) ==> !read($Heap, wr#21, WriterStream.footprint)[$Box(null)] && read($Heap, wr#21, WriterStream.footprint)[$Box(wr#21)] && read($Heap, wr#21, WriterStream.isOpen)) ==> read($Heap, wr#21, WriterStream.isOpen);
          invariant $w2 && (WriterStream.Valid($Heap, wr#21) ==> !read($Heap, wr#21, WriterStream.footprint)[$Box(null)] && read($Heap, wr#21, WriterStream.footprint)[$Box(wr#21)] && read($Heap, wr#21, WriterStream.isOpen)) ==> (forall $o: ref :: $o != null && read($Heap, wr#21, WriterStream.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc));
          free invariant $w2 ==> WriterStream.Valid($Heap, wr#21) && (forall $o: ref :: $o != null && read($Heap, wr#21, WriterStream.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc));
          free invariant Map.Valid($Heap, glossary#13) ==> Seq#Length(read($Heap, glossary#13, Map.keys)) == Seq#Length(read($Heap, glossary#13, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, glossary#13, Map.keys)) ==> Seq#Index(read($Heap, glossary#13, Map.keys), i#45) != Seq#Index(read($Heap, glossary#13, Map.keys), j#46));
          invariant $w2 && (Map.Valid($Heap, glossary#13) ==> Seq#Length(read($Heap, glossary#13, Map.keys)) == Seq#Length(read($Heap, glossary#13, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, glossary#13, Map.keys)) ==> Seq#Index(read($Heap, glossary#13, Map.keys), i#45) != Seq#Index(read($Heap, glossary#13, Map.keys), j#46))) ==> Seq#Length(read($Heap, glossary#13, Map.keys)) == Seq#Length(read($Heap, glossary#13, Map.values));
          invariant $w2 && (Map.Valid($Heap, glossary#13) ==> Seq#Length(read($Heap, glossary#13, Map.keys)) == Seq#Length(read($Heap, glossary#13, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, glossary#13, Map.keys)) ==> Seq#Index(read($Heap, glossary#13, Map.keys), i#45) != Seq#Index(read($Heap, glossary#13, Map.keys), j#46))) ==> (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, glossary#13, Map.keys)) ==> Seq#Index(read($Heap, glossary#13, Map.keys), i#45) != Seq#Index(read($Heap, glossary#13, Map.keys), j#46));
          free invariant $w2 ==> Map.Valid($Heap, glossary#13);
          invariant $w2 ==> !read($Heap, wr#21, WriterStream.footprint)[$Box(glossary#13)];
          invariant $w2 ==> !Seq#Contains(read($Heap, glossary#13, Map.keys), $Box(null));
//          free invariant $w2 ==> !read($Heap, wr#21, WriterStream.footprint)[$Box(glossary#13)] && !Seq#Contains(read($Heap, glossary#13, Map.keys), $Box(null));
          invariant $w2 ==> (forall d#29: Seq BoxType :: Seq#Contains(read($Heap, glossary#13, Map.values), $Box(d#29)) ==> !Seq#Contains(d#29, $Box(null)));
          invariant $w2 ==> !read($Heap, wr#21, WriterStream.footprint)[$Box(q#14)];
          invariant $w2 ==> Seq#Equal(qcon#28, read($Heap, q#14, Queue.contents));
          invariant $w2 ==> (forall k#30: ref :: Seq#Contains(read($Heap, q#14, Queue.contents), $Box(k#30)) ==> Seq#Contains(read($Heap, glossary#13, Map.keys), $Box(k#30)));
          free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap2, $o, $f));
          free invariant $HeapSucc($PreLoopHeap2, $Heap);
          free invariant Seq#Length(definition#26) - i#27 <= $decr2$init$0 && (Seq#Length(definition#26) - i#27 == $decr2$init$0 ==> true);
          free invariant #cev_save_position(#cev_pc) == #tok$0^98.7;
          free invariant $PreLoopCevPC2 < #cev_pc;
          free invariant #cev_control_flow_event(#cev_pc, loop_register);
	  kUnwind 1;
        {
            if (!$w2)
            {
                assert {:subsumption 0} wr#21 != null && (WriterStream.Valid($Heap, wr#21) ==> wr#21 != null);
                assume WriterStream.Valid($Heap, wr#21) && (forall $o: ref :: $o != null && read($Heap, wr#21, WriterStream.footprint)[$Box($o)] ==> !read(old($Heap), $o, alloc));
                assert {:subsumption 0} glossary#13 != null;
                assume Map.Valid($Heap, glossary#13);
                assert {:subsumption 0} wr#21 != null && (!read($Heap, wr#21, WriterStream.footprint)[$Box(glossary#13)] ==> glossary#13 != null);
                assume !read($Heap, wr#21, WriterStream.footprint)[$Box(glossary#13)] && !Seq#Contains(read($Heap, glossary#13, Map.keys), $Box(null));
                assert {:subsumption 0} (forall d#29: Seq BoxType :: glossary#13 != null && (Seq#Contains(read($Heap, glossary#13, Map.values), $Box(d#29)) ==> true));
                assume (forall d#29: Seq BoxType :: Seq#Contains(read($Heap, glossary#13, Map.values), $Box(d#29)) ==> !Seq#Contains(d#29, $Box(null)));
                assert {:subsumption 0} wr#21 != null;
                assume !read($Heap, wr#21, WriterStream.footprint)[$Box(q#14)];
                assert {:subsumption 0} q#14 != null;
                assume Seq#Equal(qcon#28, read($Heap, q#14, Queue.contents));
                assert {:subsumption 0} (forall k#30: ref :: q#14 != null && (Seq#Contains(read($Heap, q#14, Queue.contents), $Box(k#30)) ==> glossary#13 != null));
                assume (forall k#30: ref :: Seq#Contains(read($Heap, q#14, Queue.contents), $Box(k#30)) ==> Seq#Contains(read($Heap, glossary#13, Map.keys), $Box(k#30)));
                assert true;
                assume false;
            }

            assert true;
            if (i#27 >= Seq#Length(definition#26))
            {
                break;
            }

            call CevStepEvent(#tok$0^98.7, loop_entered);
            assume {:captureState "Test\VSI-Benchmarks\b8.dfy(98,7): loop entered"} true;
            $decr2$0 := Seq#Length(definition#26) - i#27;
            // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(107,13)
            assert true;
            assert 0 <= i#27 && i#27 < Seq#Length(definition#26);
            w#31 := $Unbox(Seq#Index(definition#26, i#27)): ref;
            assume {:captureState "Test\VSI-Benchmarks\b8.dfy(107,13)"} true;
            call CevVarIntro(#tok$0^107.13, cev_local, #loc.w#31, w#31);
            // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(108,23)
            call CevVarIntro(#tok$0^108.23, cev_local, #loc.d#32, d#32);
            // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(108,9)
            assert true;
            key#84 := $Box(w#31);
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            call present#25, $tmp#3 := Map.Find(glossary#13, key#84);
            call CevUpdateHere(#loc.present, present#25);
            d#32 := $Unbox($tmp#3): Seq BoxType;
            call CevUpdateHere(#loc.d, d#32);
            call CevStep(#tok$0^108.9);
            assume {:captureState "Test\VSI-Benchmarks\b8.dfy(108,9)"} true;
            // ----- if statement ----- Test\VSI-Benchmarks\b8.dfy(109,9)
            call CevEvent(#tok$0^109.9, conditional_moment);
            assert true;
            if (present#25)
            {
                call CevEvent(#tok$0^110.9, took_then_branch);
                // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(111,11)
                assert true;
                tag#85 := w#31;
                assert true;
                w#86 := w#31;
                assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && wr#21 != null && read($Heap, wr#21, WriterStream.footprint)[$Box($o)] ==> $_Frame[$o, $f]);
                call WriterStream.PutWordInsideHyperlink(wr#21, tag#85, w#86);
                call CevStep(#tok$0^111.11);
                assume {:captureState "Test\VSI-Benchmarks\b8.dfy(111,11)"} true;
            }
            else
            {
                call CevEvent(#tok$0^114.9, took_else_branch);
                // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(115,11)
                assert true;
                w#87 := w#31;
                assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && wr#21 != null && read($Heap, wr#21, WriterStream.footprint)[$Box($o)] ==> $_Frame[$o, $f]);
                call WriterStream.PutWord(wr#21, w#87);
                call CevStep(#tok$0^115.11);
                assume {:captureState "Test\VSI-Benchmarks\b8.dfy(115,11)"} true;
            }

            // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(117,10)
            assert true;
            assert true;
            i#27 := i#27 + 1;
            assume {:captureState "Test\VSI-Benchmarks\b8.dfy(117,10)"} true;
            call CevUpdate(#tok$0^117.10, #loc.i#27, i#27);
            assert 0 <= $decr2$0 || Seq#Length(definition#26) - i#27 == $decr2$0;
            assert Seq#Length(definition#26) - i#27 < $decr2$0;
        }

        call CevStepEvent(#tok$0^98.7, loop_exited);
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(98,7): loop exit"} true;
        assert 0 <= $decr1$0 || Seq#Length(read($Heap, q#14, Queue.contents)) - 0 == $decr1$0;
        assert Seq#Length(read($Heap, q#14, Queue.contents)) - 0 < $decr1$0;
    }

    call CevStepEvent(#tok$0^81.5, loop_exited);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(81,5): loop exit"} true;
    // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(120,5)
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && wr#21 != null && read($Heap, wr#21, WriterStream.footprint)[$Box($o)] ==> $_Frame[$o, $f]);
    call WriterStream.Close(wr#21);
    call CevStep(#tok$0^120.5);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(120,5)"} true;
}



const unique #tok$0^124.10: $token;

procedure CheckWellformed$$Glossary.readDefinition(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Glossary, rs#33: ref where rs#33 == null || (read($Heap, rs#33, alloc) && dtype(rs#33) == class.ReaderStream)) returns (term#34: ref where term#34 == null || (read($Heap, term#34, alloc) && dtype(term#34) == class.Word), definition#35: Seq BoxType where (forall $i: int :: { Seq#Index(definition#35, $i) } 0 <= $i && $i < Seq#Length(definition#35) ==> $Unbox(Seq#Index(definition#35, $i)): ref == null || (read($Heap, $Unbox(Seq#Index(definition#35, $i)): ref, alloc) && dtype($Unbox(Seq#Index(definition#35, $i)): ref) == class.Word)));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^124.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^124.25: $token;

const unique #loc.rs#33: $token;

const unique #tok$0^124.51: $token;

const unique #loc.term#34: $token;

const unique #tok$0^124.62: $token;

const unique #loc.definition#35: $token;

implementation CheckWellformed$$Glossary.readDefinition(this: ref, rs#33: ref) returns (term#34: ref, definition#35: Seq BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^124.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^124.25, cev_parameter, #loc.rs#33, rs#33);
    call CevVarIntro(#tok$0^124.51, cev_local, #loc.term#34, term#34);
    call CevVarIntro(#tok$0^124.62, cev_local, #loc.definition#35, definition#35);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> rs#33 != null && read($Heap, rs#33, ReaderStream.footprint)[$Box($o)]);
    if (rs#33 != null)
    {
        assert rs#33 != null;
    }

    assume rs#33 != null && ReaderStream.Valid($Heap, rs#33);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc term#34, definition#35;
    assert rs#33 != null;
    if (ReaderStream.Valid($Heap, rs#33))
    {
        assert rs#33 != null;
        assert rs#33 != null;
    }

    assume ReaderStream.Valid($Heap, rs#33) && (forall $o: ref :: $o != null && read($Heap, rs#33, ReaderStream.footprint)[$Box($o)] && !old(read($Heap, rs#33, ReaderStream.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
    if (term#34 != null)
    {
    }

    assume term#34 != null ==> !Seq#Contains(definition#35, $Box(null));
}



procedure Glossary.readDefinition(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Glossary, rs#33: ref where rs#33 == null || (read($Heap, rs#33, alloc) && dtype(rs#33) == class.ReaderStream)) returns (term#34: ref where term#34 == null || (read($Heap, term#34, alloc) && dtype(term#34) == class.Word), definition#35: Seq BoxType where (forall $i: int :: { Seq#Index(definition#35, $i) } 0 <= $i && $i < Seq#Length(definition#35) ==> $Unbox(Seq#Index(definition#35, $i)): ref == null || (read($Heap, $Unbox(Seq#Index(definition#35, $i)): ref, alloc) && dtype($Unbox(Seq#Index(definition#35, $i)): ref) == class.Word)));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires rs#33 != null && ReaderStream.Valid($Heap, rs#33);
  free requires ReaderStream.Valid($Heap, rs#33) ==> !read($Heap, rs#33, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#33, ReaderStream.footprint)[$Box(rs#33)] && read($Heap, rs#33, ReaderStream.isOpen);
  requires (ReaderStream.Valid($Heap, rs#33) ==> !read($Heap, rs#33, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#33, ReaderStream.footprint)[$Box(rs#33)] && read($Heap, rs#33, ReaderStream.isOpen)) ==> rs#33 != null;
  requires (ReaderStream.Valid($Heap, rs#33) ==> !read($Heap, rs#33, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#33, ReaderStream.footprint)[$Box(rs#33)] && read($Heap, rs#33, ReaderStream.isOpen)) ==> !read($Heap, rs#33, ReaderStream.footprint)[$Box(null)];
  requires (ReaderStream.Valid($Heap, rs#33) ==> !read($Heap, rs#33, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#33, ReaderStream.footprint)[$Box(rs#33)] && read($Heap, rs#33, ReaderStream.isOpen)) ==> read($Heap, rs#33, ReaderStream.footprint)[$Box(rs#33)];
  requires (ReaderStream.Valid($Heap, rs#33) ==> !read($Heap, rs#33, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#33, ReaderStream.footprint)[$Box(rs#33)] && read($Heap, rs#33, ReaderStream.isOpen)) ==> read($Heap, rs#33, ReaderStream.isOpen);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^124.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures ReaderStream.Valid($Heap, rs#33) && (forall $o: ref :: $o != null && read($Heap, rs#33, ReaderStream.footprint)[$Box($o)] && !old(read($Heap, rs#33, ReaderStream.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  free ensures ReaderStream.Valid($Heap, rs#33) ==> !read($Heap, rs#33, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#33, ReaderStream.footprint)[$Box(rs#33)] && read($Heap, rs#33, ReaderStream.isOpen);
  ensures (ReaderStream.Valid($Heap, rs#33) ==> !read($Heap, rs#33, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#33, ReaderStream.footprint)[$Box(rs#33)] && read($Heap, rs#33, ReaderStream.isOpen)) ==> !read($Heap, rs#33, ReaderStream.footprint)[$Box(null)];
  ensures (ReaderStream.Valid($Heap, rs#33) ==> !read($Heap, rs#33, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#33, ReaderStream.footprint)[$Box(rs#33)] && read($Heap, rs#33, ReaderStream.isOpen)) ==> read($Heap, rs#33, ReaderStream.footprint)[$Box(rs#33)];
  ensures (ReaderStream.Valid($Heap, rs#33) ==> !read($Heap, rs#33, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#33, ReaderStream.footprint)[$Box(rs#33)] && read($Heap, rs#33, ReaderStream.isOpen)) ==> read($Heap, rs#33, ReaderStream.isOpen);
  ensures (ReaderStream.Valid($Heap, rs#33) ==> !read($Heap, rs#33, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#33, ReaderStream.footprint)[$Box(rs#33)] && read($Heap, rs#33, ReaderStream.isOpen)) ==> (forall $o: ref :: $o != null && read($Heap, rs#33, ReaderStream.footprint)[$Box($o)] && !old(read($Heap, rs#33, ReaderStream.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  ensures term#34 != null ==> !Seq#Contains(definition#35, $Box(null));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (rs#33 != null && read(old($Heap), rs#33, ReaderStream.footprint)[$Box($o)]));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^130.5: $token;

const unique #tok$0^131.5: $token;

const unique #tok$0^132.5: $token;

const unique #tok$0^133.18: $token;

const unique #tok$0^134.7: $token;

const unique #loc.w#36: $token;

const unique #tok$0^139.14: $token;

const unique #loc.w: $token;

const unique #tok$0^139.9: $token;

const unique #tok$0^140.9: $token;

const unique #tok$0^141.9: $token;

const unique #tok$0^144.20: $token;

implementation Glossary.readDefinition(this: ref, rs#33: ref) returns (term#34: ref, definition#35: Seq BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $PreLoopHeap0: HeapType;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var w#36: ref where (w#36 == null || (read($Heap, w#36, alloc) && dtype(w#36) == class.Word)) && #cev_var_update(#cev_pc, cev_local, #loc.w#36, w#36);

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^124.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^124.25, cev_parameter, #loc.rs#33, rs#33);
    call CevVarIntro(#tok$0^124.51, cev_local, #loc.term#34, term#34);
    call CevVarIntro(#tok$0^124.62, cev_local, #loc.definition#35, definition#35);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> rs#33 != null && read($Heap, rs#33, ReaderStream.footprint)[$Box($o)]);
    // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(130,5)
    assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && rs#33 != null && read($Heap, rs#33, ReaderStream.footprint)[$Box($o)] ==> $_Frame[$o, $f]);
    call term#34 := ReaderStream.GetWord(rs#33);
    call CevUpdateHere(#loc.term, term#34);
    call CevStep(#tok$0^130.5);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(130,5)"} true;
    // ----- if statement ----- Test\VSI-Benchmarks\b8.dfy(131,5)
    call CevEvent(#tok$0^131.5, conditional_moment);
    assert true;
    if (term#34 != null)
    {
        call CevEvent(#tok$0^132.5, took_then_branch);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(133,18)
        assert true;
        assert true;
        definition#35 := Seq#Empty(): Seq BoxType;
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(133,18)"} true;
        call CevUpdate(#tok$0^133.18, #loc.definition#35, definition#35);
        // ----- while statement ----- Test\VSI-Benchmarks\b8.dfy(134,7)
        $PreLoopHeap0 := $Heap;
        havoc $w0;
        call $PreLoopCevPC0 := CevPreLoop(#tok$0^134.7);
        while (true)
          free invariant ReaderStream.Valid($Heap, rs#33) ==> !read($Heap, rs#33, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#33, ReaderStream.footprint)[$Box(rs#33)] && read($Heap, rs#33, ReaderStream.isOpen);
          invariant $w0 && (ReaderStream.Valid($Heap, rs#33) ==> !read($Heap, rs#33, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#33, ReaderStream.footprint)[$Box(rs#33)] && read($Heap, rs#33, ReaderStream.isOpen)) ==> !read($Heap, rs#33, ReaderStream.footprint)[$Box(null)];
          invariant $w0 && (ReaderStream.Valid($Heap, rs#33) ==> !read($Heap, rs#33, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#33, ReaderStream.footprint)[$Box(rs#33)] && read($Heap, rs#33, ReaderStream.isOpen)) ==> read($Heap, rs#33, ReaderStream.footprint)[$Box(rs#33)];
          invariant $w0 && (ReaderStream.Valid($Heap, rs#33) ==> !read($Heap, rs#33, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#33, ReaderStream.footprint)[$Box(rs#33)] && read($Heap, rs#33, ReaderStream.isOpen)) ==> read($Heap, rs#33, ReaderStream.isOpen);
          invariant $w0 && (ReaderStream.Valid($Heap, rs#33) ==> !read($Heap, rs#33, ReaderStream.footprint)[$Box(null)] && read($Heap, rs#33, ReaderStream.footprint)[$Box(rs#33)] && read($Heap, rs#33, ReaderStream.isOpen)) ==> (forall $o: ref :: $o != null && read($Heap, rs#33, ReaderStream.footprint)[$Box($o)] && !old(read($Heap, rs#33, ReaderStream.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
          free invariant $w0 ==> ReaderStream.Valid($Heap, rs#33) && (forall $o: ref :: $o != null && read($Heap, rs#33, ReaderStream.footprint)[$Box($o)] && !old(read($Heap, rs#33, ReaderStream.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
          invariant $w0 ==> !Seq#Contains(definition#35, $Box(null));
          free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f) || (rs#33 != null && read(old($Heap), rs#33, ReaderStream.footprint)[$Box($o)]));
          free invariant $HeapSucc($PreLoopHeap0, $Heap);
          free invariant #cev_save_position(#cev_pc) == #tok$0^134.7;
          free invariant $PreLoopCevPC0 < #cev_pc;
          free invariant #cev_control_flow_event(#cev_pc, loop_register);
          free invariant #cev_var_update(#cev_pc, cev_local, #loc.term#34, term#34);
          free invariant #cev_var_update(#cev_pc, cev_local, #loc.definition#35, definition#35);
	  kUnwind 1;
        {
            if (!$w0)
            {
                assert {:subsumption 0} rs#33 != null && (ReaderStream.Valid($Heap, rs#33) ==> rs#33 != null && old(rs#33 != null));
                assume ReaderStream.Valid($Heap, rs#33) && (forall $o: ref :: $o != null && read($Heap, rs#33, ReaderStream.footprint)[$Box($o)] && !old(read($Heap, rs#33, ReaderStream.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
                assert {:subsumption 0} true;
                assume !Seq#Contains(definition#35, $Box(null));
                assert true;
                assume false;
            }

            assert true;
            if (!true)
            {
                break;
            }

            call CevStepEvent(#tok$0^134.7, loop_entered);
            assume {:captureState "Test\VSI-Benchmarks\b8.dfy(134,7): loop entered"} true;
            // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(139,14)
            call CevVarIntro(#tok$0^139.14, cev_local, #loc.w#36, w#36);
            // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(139,9)
            assert (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) && rs#33 != null && read($Heap, rs#33, ReaderStream.footprint)[$Box($o)] ==> $_Frame[$o, $f]);
            call w#36 := ReaderStream.GetWord(rs#33);
            call CevUpdateHere(#loc.w, w#36);
            call CevStep(#tok$0^139.9);
            assume {:captureState "Test\VSI-Benchmarks\b8.dfy(139,9)"} true;
            // ----- if statement ----- Test\VSI-Benchmarks\b8.dfy(140,9)
            call CevEvent(#tok$0^140.9, conditional_moment);
            assert true;
            if (w#36 == null)
            {
                call CevEvent(#tok$0^141.9, took_then_branch);
                // ----- break statement ----- Test\VSI-Benchmarks\b8.dfy(142,11)
                break;
            }
            else
            {
                call CevEvent(#tok$0^140.9, took_else_branch);
            }

            // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(144,20)
            assert true;
            assert true;
            definition#35 := Seq#Append(definition#35, Seq#Build(Seq#Empty(): Seq BoxType, 0, $Box(w#36), 1));
            assume {:captureState "Test\VSI-Benchmarks\b8.dfy(144,20)"} true;
            call CevUpdate(#tok$0^144.20, #loc.definition#35, definition#35);
        }

        call CevStepEvent(#tok$0^134.7, loop_exited);
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(134,7): loop exit"} true;
    }
    else
    {
        call CevEvent(#tok$0^131.5, took_else_branch);
    }
}



const unique class.Word: ClassName;

function Word.AtMost($heap: HeapType, this: ref, w#37: ref) : bool;

// frame axiom for Word.AtMost
axiom (forall $h0: HeapType, $h1: HeapType, this: ref, w#37: ref :: { $HeapSucc($h0, $h1), Word.AtMost($h1, this, w#37) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Word && read($h1, this, alloc) && dtype(this) == class.Word && (w#37 == null || (read($h0, w#37, alloc) && dtype(w#37) == class.Word)) && (w#37 == null || (read($h1, w#37, alloc) && dtype(w#37) == class.Word)) && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: false ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Word.AtMost($h0, this, w#37) == Word.AtMost($h1, this, w#37));

procedure CheckWellformed$$Word.AtMost(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Word, w#37: ref where w#37 == null || (read($Heap, w#37, alloc) && dtype(w#37) == class.Word));
  free requires 0 == $ModuleContextHeight && 21 == $FunctionContextHeight;



implementation CheckWellformed$$Word.AtMost(this: ref, w#37: ref)
{
}



const unique class.ReaderStream: ClassName;

const unique ReaderStream.footprint: Field (Set BoxType);

axiom (forall $h: HeapType, $o: ref, $t: BoxType :: { read($h, $o, ReaderStream.footprint)[$t] } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) && read($h, $o, ReaderStream.footprint)[$t] ==> $Unbox($t): ref == null || read($h, $Unbox($t): ref, alloc));

const unique ReaderStream.isOpen: Field bool;

function ReaderStream.Valid($heap: HeapType, this: ref) : bool;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (22 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref :: { ReaderStream.Valid($Heap, this) } $IsGoodHeap($Heap) && this != null ==> ReaderStream.Valid($Heap, this) == (!read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)] && read($Heap, this, ReaderStream.isOpen)));

// frame axiom for ReaderStream.Valid
axiom (forall $h0: HeapType, $h1: HeapType, this: ref :: { $HeapSucc($h0, $h1), ReaderStream.Valid($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.ReaderStream && read($h1, this, alloc) && dtype(this) == class.ReaderStream && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && ($o == this || read($h0, this, ReaderStream.footprint)[$Box($o)]) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> ReaderStream.Valid($h0, this) == ReaderStream.Valid($h1, this));

procedure CheckWellformed$$ReaderStream.Valid(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.ReaderStream);
  free requires 0 == $ModuleContextHeight && 22 == $FunctionContextHeight;



implementation CheckWellformed$$ReaderStream.Valid(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || read($Heap, this, ReaderStream.footprint)[$Box($o)]);
    assert $_Frame[this, ReaderStream.footprint];
    if (!read($Heap, this, ReaderStream.footprint)[$Box(null)])
    {
        assert $_Frame[this, ReaderStream.footprint];
    }

    if (!read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)])
    {
        assert $_Frame[this, ReaderStream.isOpen];
    }
}



const unique #tok$0^165.10: $token;

procedure CheckWellformed$$ReaderStream.Open(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.ReaderStream);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^165.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



implementation CheckWellformed$$ReaderStream.Open(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^165.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (ReaderStream.Valid($Heap, this))
    {
    }

    assume ReaderStream.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, ReaderStream.footprint)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc));
}



procedure ReaderStream.Open(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.ReaderStream);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^165.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures ReaderStream.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, ReaderStream.footprint)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc));
  free ensures ReaderStream.Valid($Heap, this) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)] && read($Heap, this, ReaderStream.isOpen);
  ensures (ReaderStream.Valid($Heap, this) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)] && read($Heap, this, ReaderStream.isOpen)) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)];
  ensures (ReaderStream.Valid($Heap, this) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)] && read($Heap, this, ReaderStream.isOpen)) ==> read($Heap, this, ReaderStream.footprint)[$Box(this)];
  ensures (ReaderStream.Valid($Heap, this) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)] && read($Heap, this, ReaderStream.isOpen)) ==> read($Heap, this, ReaderStream.isOpen);
  ensures (ReaderStream.Valid($Heap, this) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)] && read($Heap, this, ReaderStream.isOpen)) ==> (forall $o: ref :: $o != null && read($Heap, this, ReaderStream.footprint)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^169.15: $token;

const unique #tok$0^170.12: $token;

implementation ReaderStream.Open(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^165.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(169,15)
    assert true;
    assert true;
    assert $_Frame[this, ReaderStream.footprint];
    $Heap := update($Heap, this, ReaderStream.footprint, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(169,15)"} true;
    call CevUpdateHeap(#tok$0^169.15, #loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(170,12)
    assert true;
    assert true;
    assert $_Frame[this, ReaderStream.isOpen];
    $Heap := update($Heap, this, ReaderStream.isOpen, true);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(170,12)"} true;
    call CevUpdateHeap(#tok$0^170.12, #loc.$Heap, $Heap);
}



const unique #tok$0^173.10: $token;

procedure CheckWellformed$$ReaderStream.GetWord(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.ReaderStream) returns (x#38: ref where x#38 == null || (read($Heap, x#38, alloc) && dtype(x#38) == class.Word));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^173.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^173.27: $token;

const unique #loc.x#38: $token;

implementation CheckWellformed$$ReaderStream.GetWord(this: ref) returns (x#38: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^173.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^173.27, cev_local, #loc.x#38, x#38);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, ReaderStream.footprint)[$Box($o)]);
    assume ReaderStream.Valid($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc x#38;
    if (ReaderStream.Valid($Heap, this))
    {
    }

    assume ReaderStream.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, ReaderStream.footprint)[$Box($o)] && !old(read($Heap, this, ReaderStream.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
}



procedure ReaderStream.GetWord(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.ReaderStream) returns (x#38: ref where x#38 == null || (read($Heap, x#38, alloc) && dtype(x#38) == class.Word));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires ReaderStream.Valid($Heap, this);
  free requires ReaderStream.Valid($Heap, this) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)] && read($Heap, this, ReaderStream.isOpen);
  requires (ReaderStream.Valid($Heap, this) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)] && read($Heap, this, ReaderStream.isOpen)) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)];
  requires (ReaderStream.Valid($Heap, this) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)] && read($Heap, this, ReaderStream.isOpen)) ==> read($Heap, this, ReaderStream.footprint)[$Box(this)];
  requires (ReaderStream.Valid($Heap, this) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)] && read($Heap, this, ReaderStream.isOpen)) ==> read($Heap, this, ReaderStream.isOpen);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^173.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures ReaderStream.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, ReaderStream.footprint)[$Box($o)] && !old(read($Heap, this, ReaderStream.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  free ensures ReaderStream.Valid($Heap, this) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)] && read($Heap, this, ReaderStream.isOpen);
  ensures (ReaderStream.Valid($Heap, this) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)] && read($Heap, this, ReaderStream.isOpen)) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)];
  ensures (ReaderStream.Valid($Heap, this) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)] && read($Heap, this, ReaderStream.isOpen)) ==> read($Heap, this, ReaderStream.footprint)[$Box(this)];
  ensures (ReaderStream.Valid($Heap, this) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)] && read($Heap, this, ReaderStream.isOpen)) ==> read($Heap, this, ReaderStream.isOpen);
  ensures (ReaderStream.Valid($Heap, this) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)] && read($Heap, this, ReaderStream.isOpen)) ==> (forall $o: ref :: $o != null && read($Heap, this, ReaderStream.footprint)[$Box($o)] && !old(read($Heap, this, ReaderStream.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || read(old($Heap), this, ReaderStream.footprint)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



implementation ReaderStream.GetWord(this: ref) returns (x#38: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^173.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^173.27, cev_local, #loc.x#38, x#38);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, ReaderStream.footprint)[$Box($o)]);
}



const unique #tok$0^180.10: $token;

procedure CheckWellformed$$ReaderStream.Close(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.ReaderStream);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^180.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



implementation CheckWellformed$$ReaderStream.Close(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^180.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, ReaderStream.footprint)[$Box($o)]);
    assume ReaderStream.Valid($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
}



procedure ReaderStream.Close(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.ReaderStream);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires ReaderStream.Valid($Heap, this);
  free requires ReaderStream.Valid($Heap, this) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)] && read($Heap, this, ReaderStream.isOpen);
  requires (ReaderStream.Valid($Heap, this) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)] && read($Heap, this, ReaderStream.isOpen)) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)];
  requires (ReaderStream.Valid($Heap, this) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)] && read($Heap, this, ReaderStream.isOpen)) ==> read($Heap, this, ReaderStream.footprint)[$Box(this)];
  requires (ReaderStream.Valid($Heap, this) ==> !read($Heap, this, ReaderStream.footprint)[$Box(null)] && read($Heap, this, ReaderStream.footprint)[$Box(this)] && read($Heap, this, ReaderStream.isOpen)) ==> read($Heap, this, ReaderStream.isOpen);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^180.10;
  modifies $Heap, #cev_pc;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || read(old($Heap), this, ReaderStream.footprint)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^184.12: $token;

implementation ReaderStream.Close(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^180.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, ReaderStream.footprint)[$Box($o)]);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(184,12)
    assert true;
    assert true;
    assert $_Frame[this, ReaderStream.isOpen];
    $Heap := update($Heap, this, ReaderStream.isOpen, false);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(184,12)"} true;
    call CevUpdateHeap(#tok$0^184.12, #loc.$Heap, $Heap);
}



const unique class.WriterStream: ClassName;

const unique WriterStream.footprint: Field (Set BoxType);

axiom (forall $h: HeapType, $o: ref, $t: BoxType :: { read($h, $o, WriterStream.footprint)[$t] } $IsGoodHeap($h) && $o != null && read($h, $o, alloc) && read($h, $o, WriterStream.footprint)[$t] ==> $Unbox($t): ref == null || read($h, $Unbox($t): ref, alloc));

axiom FDim(WriterStream.stream) == 0 && DeclType(WriterStream.stream) == class.WriterStream;

const unique WriterStream.stream: Field (Seq BoxType);

const unique WriterStream.isOpen: Field bool;

function WriterStream.Valid($heap: HeapType, this: ref) : bool;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (23 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref :: { WriterStream.Valid($Heap, this) } $IsGoodHeap($Heap) && this != null ==> WriterStream.Valid($Heap, this) == (!read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)));

// frame axiom for WriterStream.Valid
axiom (forall $h0: HeapType, $h1: HeapType, this: ref :: { $HeapSucc($h0, $h1), WriterStream.Valid($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.WriterStream && read($h1, this, alloc) && dtype(this) == class.WriterStream && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && ($o == this || read($h0, this, WriterStream.footprint)[$Box($o)]) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> WriterStream.Valid($h0, this) == WriterStream.Valid($h1, this));

procedure CheckWellformed$$WriterStream.Valid(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.WriterStream);
  free requires 0 == $ModuleContextHeight && 23 == $FunctionContextHeight;



implementation CheckWellformed$$WriterStream.Valid(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this || read($Heap, this, WriterStream.footprint)[$Box($o)]);
    assert $_Frame[this, WriterStream.footprint];
    if (!read($Heap, this, WriterStream.footprint)[$Box(null)])
    {
        assert $_Frame[this, WriterStream.footprint];
    }

    if (!read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)])
    {
        assert $_Frame[this, WriterStream.isOpen];
    }
}



const unique #tok$0^199.10: $token;

procedure CheckWellformed$$WriterStream.Create(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.WriterStream);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^199.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



implementation CheckWellformed$$WriterStream.Create(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^199.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (WriterStream.Valid($Heap, this))
    {
    }

    assume WriterStream.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, WriterStream.footprint)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc));
    assume Seq#Equal(read($Heap, this, WriterStream.stream), Seq#Empty(): Seq BoxType);
}



procedure WriterStream.Create(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.WriterStream);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^199.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures WriterStream.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, WriterStream.footprint)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc));
  free ensures WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen);
  ensures (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)];
  ensures (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> read($Heap, this, WriterStream.footprint)[$Box(this)];
  ensures (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> read($Heap, this, WriterStream.isOpen);
  ensures (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> (forall $o: ref :: $o != null && read($Heap, this, WriterStream.footprint)[$Box($o)] && $o != this ==> !read(old($Heap), $o, alloc));
  ensures Seq#Equal(read($Heap, this, WriterStream.stream), Seq#Empty(): Seq BoxType);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^204.12: $token;

const unique #tok$0^205.15: $token;

const unique #tok$0^206.11: $token;

implementation WriterStream.Create(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^199.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(204,12)
    assert true;
    assert true;
    assert $_Frame[this, WriterStream.stream];
    $Heap := update($Heap, this, WriterStream.stream, Seq#Empty(): Seq BoxType);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(204,12)"} true;
    call CevUpdateHeap(#tok$0^204.12, #loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(205,15)
    assert true;
    assert true;
    assert $_Frame[this, WriterStream.footprint];
    $Heap := update($Heap, this, WriterStream.footprint, Set#UnionOne(Set#Empty(): Set BoxType, $Box(this)));
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(205,15)"} true;
    call CevUpdateHeap(#tok$0^205.15, #loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(206,11)
    assert true;
    assert true;
    assert $_Frame[this, WriterStream.isOpen];
    $Heap := update($Heap, this, WriterStream.isOpen, true);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(206,11)"} true;
    call CevUpdateHeap(#tok$0^206.11, #loc.$Heap, $Heap);
}



const unique #tok$0^208.10: $token;

procedure CheckWellformed$$WriterStream.GetCount(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.WriterStream) returns (c#39: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^208.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^208.30: $token;

const unique #loc.c#39: $token;

implementation CheckWellformed$$WriterStream.GetCount(this: ref) returns (c#39: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^208.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^208.30, cev_local, #loc.c#39, c#39);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume WriterStream.Valid($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc c#39;
    assume 0 <= c#39;
}



procedure WriterStream.GetCount(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.WriterStream) returns (c#39: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires WriterStream.Valid($Heap, this);
  free requires WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen);
  requires (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)];
  requires (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> read($Heap, this, WriterStream.footprint)[$Box(this)];
  requires (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> read($Heap, this, WriterStream.isOpen);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^208.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures 0 <= c#39;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^212.6: $token;

implementation WriterStream.GetCount(this: ref) returns (c#39: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^208.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^208.30, cev_local, #loc.c#39, c#39);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(212,6)
    assert true;
    assert true;
    c#39 := Seq#Length(read($Heap, this, WriterStream.stream));
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(212,6)"} true;
    call CevUpdate(#tok$0^212.6, #loc.c#39, c#39);
}



const unique #tok$0^215.10: $token;

procedure CheckWellformed$$WriterStream.PutWord(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.WriterStream, w#40: ref where w#40 == null || (read($Heap, w#40, alloc) && dtype(w#40) == class.Word));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^215.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^215.18: $token;

const unique #loc.w#40: $token;

implementation CheckWellformed$$WriterStream.PutWord(this: ref, w#40: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^215.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^215.18, cev_parameter, #loc.w#40, w#40);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, WriterStream.footprint)[$Box($o)]);
    assume WriterStream.Valid($Heap, this);
    assume w#40 != null;
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (WriterStream.Valid($Heap, this))
    {
    }

    assume WriterStream.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, WriterStream.footprint)[$Box($o)] && !old(read($Heap, this, WriterStream.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
    assume Seq#Length(old(read($Heap, this, WriterStream.stream))) <= Seq#Length(read($Heap, this, WriterStream.stream)) && Seq#SameUntil(old(read($Heap, this, WriterStream.stream)), read($Heap, this, WriterStream.stream), Seq#Length(old(read($Heap, this, WriterStream.stream))));
}



procedure WriterStream.PutWord(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.WriterStream, w#40: ref where w#40 == null || (read($Heap, w#40, alloc) && dtype(w#40) == class.Word));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires WriterStream.Valid($Heap, this);
  free requires WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen);
  requires (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)];
  requires (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> read($Heap, this, WriterStream.footprint)[$Box(this)];
  requires (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> read($Heap, this, WriterStream.isOpen);
  requires w#40 != null;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^215.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures WriterStream.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, WriterStream.footprint)[$Box($o)] && !old(read($Heap, this, WriterStream.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  free ensures WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen);
  ensures (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)];
  ensures (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> read($Heap, this, WriterStream.footprint)[$Box(this)];
  ensures (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> read($Heap, this, WriterStream.isOpen);
  ensures (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> (forall $o: ref :: $o != null && read($Heap, this, WriterStream.footprint)[$Box($o)] && !old(read($Heap, this, WriterStream.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  ensures Seq#Length(old(read($Heap, this, WriterStream.stream))) <= Seq#Length(read($Heap, this, WriterStream.stream)) && Seq#SameUntil(old(read($Heap, this, WriterStream.stream)), read($Heap, this, WriterStream.stream), Seq#Length(old(read($Heap, this, WriterStream.stream))));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || read(old($Heap), this, WriterStream.footprint)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



implementation WriterStream.PutWord(this: ref, w#40: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^215.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^215.18, cev_parameter, #loc.w#40, w#40);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, WriterStream.footprint)[$Box($o)]);
}



const unique #tok$0^224.10: $token;

procedure CheckWellformed$$WriterStream.PutWordInsideTag(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.WriterStream, tag#41: ref where tag#41 == null || (read($Heap, tag#41, alloc) && dtype(tag#41) == class.Word), w#42: ref where w#42 == null || (read($Heap, w#42, alloc) && dtype(w#42) == class.Word));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^224.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^224.27: $token;

const unique #loc.tag#41: $token;

const unique #tok$0^224.36: $token;

const unique #loc.w#42: $token;

implementation CheckWellformed$$WriterStream.PutWordInsideTag(this: ref, tag#41: ref, w#42: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^224.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^224.27, cev_parameter, #loc.tag#41, tag#41);
    call CevVarIntro(#tok$0^224.36, cev_parameter, #loc.w#42, w#42);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, WriterStream.footprint)[$Box($o)]);
    assume WriterStream.Valid($Heap, this);
    if (tag#41 != null)
    {
    }

    assume tag#41 != null && w#42 != null;
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (WriterStream.Valid($Heap, this))
    {
    }

    assume WriterStream.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, WriterStream.footprint)[$Box($o)] && !old(read($Heap, this, WriterStream.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
    assume Seq#Length(old(read($Heap, this, WriterStream.stream))) <= Seq#Length(read($Heap, this, WriterStream.stream)) && Seq#SameUntil(old(read($Heap, this, WriterStream.stream)), read($Heap, this, WriterStream.stream), Seq#Length(old(read($Heap, this, WriterStream.stream))));
}



procedure WriterStream.PutWordInsideTag(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.WriterStream, tag#41: ref where tag#41 == null || (read($Heap, tag#41, alloc) && dtype(tag#41) == class.Word), w#42: ref where w#42 == null || (read($Heap, w#42, alloc) && dtype(w#42) == class.Word));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires WriterStream.Valid($Heap, this);
  free requires WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen);
  requires (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)];
  requires (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> read($Heap, this, WriterStream.footprint)[$Box(this)];
  requires (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> read($Heap, this, WriterStream.isOpen);
  free requires tag#41 != null && w#42 != null;
  requires true ==> tag#41 != null;
  requires true ==> w#42 != null;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^224.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures WriterStream.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, WriterStream.footprint)[$Box($o)] && !old(read($Heap, this, WriterStream.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  free ensures WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen);
  ensures (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)];
  ensures (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> read($Heap, this, WriterStream.footprint)[$Box(this)];
  ensures (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> read($Heap, this, WriterStream.isOpen);
  ensures (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> (forall $o: ref :: $o != null && read($Heap, this, WriterStream.footprint)[$Box($o)] && !old(read($Heap, this, WriterStream.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  ensures Seq#Length(old(read($Heap, this, WriterStream.stream))) <= Seq#Length(read($Heap, this, WriterStream.stream)) && Seq#SameUntil(old(read($Heap, this, WriterStream.stream)), read($Heap, this, WriterStream.stream), Seq#Length(old(read($Heap, this, WriterStream.stream))));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || read(old($Heap), this, WriterStream.footprint)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



implementation WriterStream.PutWordInsideTag(this: ref, tag#41: ref, w#42: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^224.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^224.27, cev_parameter, #loc.tag#41, tag#41);
    call CevVarIntro(#tok$0^224.36, cev_parameter, #loc.w#42, w#42);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, WriterStream.footprint)[$Box($o)]);
}



const unique #tok$0^233.10: $token;

procedure CheckWellformed$$WriterStream.PutWordInsideHyperlink(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.WriterStream, tag#43: ref where tag#43 == null || (read($Heap, tag#43, alloc) && dtype(tag#43) == class.Word), w#44: ref where w#44 == null || (read($Heap, w#44, alloc) && dtype(w#44) == class.Word));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^233.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^233.33: $token;

const unique #loc.tag#43: $token;

const unique #tok$0^233.42: $token;

const unique #loc.w#44: $token;

implementation CheckWellformed$$WriterStream.PutWordInsideHyperlink(this: ref, tag#43: ref, w#44: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^233.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^233.33, cev_parameter, #loc.tag#43, tag#43);
    call CevVarIntro(#tok$0^233.42, cev_parameter, #loc.w#44, w#44);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, WriterStream.footprint)[$Box($o)]);
    assume WriterStream.Valid($Heap, this);
    if (tag#43 != null)
    {
    }

    assume tag#43 != null && w#44 != null;
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (WriterStream.Valid($Heap, this))
    {
    }

    assume WriterStream.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, WriterStream.footprint)[$Box($o)] && !old(read($Heap, this, WriterStream.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
    assume Seq#Length(old(read($Heap, this, WriterStream.stream))) <= Seq#Length(read($Heap, this, WriterStream.stream)) && Seq#SameUntil(old(read($Heap, this, WriterStream.stream)), read($Heap, this, WriterStream.stream), Seq#Length(old(read($Heap, this, WriterStream.stream))));
}



procedure WriterStream.PutWordInsideHyperlink(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.WriterStream, tag#43: ref where tag#43 == null || (read($Heap, tag#43, alloc) && dtype(tag#43) == class.Word), w#44: ref where w#44 == null || (read($Heap, w#44, alloc) && dtype(w#44) == class.Word));
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires WriterStream.Valid($Heap, this);
  free requires WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen);
  requires (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)];
  requires (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> read($Heap, this, WriterStream.footprint)[$Box(this)];
  requires (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> read($Heap, this, WriterStream.isOpen);
  free requires tag#43 != null && w#44 != null;
  requires true ==> tag#43 != null;
  requires true ==> w#44 != null;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^233.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures WriterStream.Valid($Heap, this) && (forall $o: ref :: $o != null && read($Heap, this, WriterStream.footprint)[$Box($o)] && !old(read($Heap, this, WriterStream.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  free ensures WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen);
  ensures (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)];
  ensures (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> read($Heap, this, WriterStream.footprint)[$Box(this)];
  ensures (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> read($Heap, this, WriterStream.isOpen);
  ensures (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> (forall $o: ref :: $o != null && read($Heap, this, WriterStream.footprint)[$Box($o)] && !old(read($Heap, this, WriterStream.footprint))[$Box($o)] ==> !read(old($Heap), $o, alloc));
  ensures Seq#Length(old(read($Heap, this, WriterStream.stream))) <= Seq#Length(read($Heap, this, WriterStream.stream)) && Seq#SameUntil(old(read($Heap, this, WriterStream.stream)), read($Heap, this, WriterStream.stream), Seq#Length(old(read($Heap, this, WriterStream.stream))));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || read(old($Heap), this, WriterStream.footprint)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



implementation WriterStream.PutWordInsideHyperlink(this: ref, tag#43: ref, w#44: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^233.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^233.33, cev_parameter, #loc.tag#43, tag#43);
    call CevVarIntro(#tok$0^233.42, cev_parameter, #loc.w#44, w#44);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, WriterStream.footprint)[$Box($o)]);
}



const unique #tok$0^242.10: $token;

procedure CheckWellformed$$WriterStream.Close(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.WriterStream);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^242.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



implementation CheckWellformed$$WriterStream.Close(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^242.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, WriterStream.footprint)[$Box($o)]);
    assume WriterStream.Valid($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
}



procedure WriterStream.Close(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.WriterStream);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires WriterStream.Valid($Heap, this);
  free requires WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen);
  requires (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)];
  requires (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> read($Heap, this, WriterStream.footprint)[$Box(this)];
  requires (WriterStream.Valid($Heap, this) ==> !read($Heap, this, WriterStream.footprint)[$Box(null)] && read($Heap, this, WriterStream.footprint)[$Box(this)] && read($Heap, this, WriterStream.isOpen)) ==> read($Heap, this, WriterStream.isOpen);
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^242.10;
  modifies $Heap, #cev_pc;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || read(old($Heap), this, WriterStream.footprint)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^246.12: $token;

implementation WriterStream.Close(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^242.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> read($Heap, this, WriterStream.footprint)[$Box($o)]);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(246,12)
    assert true;
    assert true;
    assert $_Frame[this, WriterStream.isOpen];
    $Heap := update($Heap, this, WriterStream.isOpen, false);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(246,12)"} true;
    call CevUpdateHeap(#tok$0^246.12, #loc.$Heap, $Heap);
}



const unique class.Map: ClassName;

const unique Map.keys: Field (Seq BoxType);

const unique Map.values: Field (Seq BoxType);

function Map.Valid($heap: HeapType, this: ref) : bool;

axiom 0 < $ModuleContextHeight || (0 == $ModuleContextHeight && (24 < $FunctionContextHeight || $InMethodContext)) ==> (forall $Heap: HeapType, this: ref :: { Map.Valid($Heap, this) } $IsGoodHeap($Heap) && this != null ==> Map.Valid($Heap, this) == (Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46))));

// frame axiom for Map.Valid
axiom (forall $h0: HeapType, $h1: HeapType, this: ref :: { $HeapSucc($h0, $h1), Map.Valid($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && read($h0, this, alloc) && dtype(this) == class.Map && read($h1, this, alloc) && dtype(this) == class.Map && $HeapSucc($h0, $h1) ==> (forall<alpha> $o: ref, $f: Field alpha :: $o != null && read($h0, $o, alloc) && read($h1, $o, alloc) && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Map.Valid($h0, this) == Map.Valid($h1, this));

procedure CheckWellformed$$Map.Valid(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map);
  free requires 0 == $ModuleContextHeight && 24 == $FunctionContextHeight;



implementation CheckWellformed$$Map.Valid(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#88: int;
  var j#89: int;

    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    assert $_Frame[this, Map.keys];
    assert $_Frame[this, Map.values];
    if (Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)))
    {
        if (0 <= i#88)
        {
        }

        if (0 <= i#88 && i#88 < j#89)
        {
            assert $_Frame[this, Map.keys];
        }

        if (0 <= i#88 && i#88 < j#89 && j#89 < Seq#Length(read($Heap, this, Map.keys)))
        {
            assert $_Frame[this, Map.keys];
            assert 0 <= i#88 && i#88 < Seq#Length(read($Heap, this, Map.keys));
            assert $_Frame[this, Map.keys];
            assert 0 <= j#89 && j#89 < Seq#Length(read($Heap, this, Map.keys));
        }
    }
}



const unique #tok$0^264.10: $token;

procedure CheckWellformed$$Map.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^264.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



implementation CheckWellformed$$Map.Init(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^264.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    if (Map.Valid($Heap, this))
    {
    }

    assume Map.Valid($Heap, this) && Seq#Length(read($Heap, this, Map.keys)) == 0;
}



procedure Map.Init(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^264.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures Map.Valid($Heap, this) && Seq#Length(read($Heap, this, Map.keys)) == 0;
  free ensures Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46));
  ensures (Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46))) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values));
  ensures (Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46))) ==> (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46));
  ensures (Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46))) ==> Seq#Length(read($Heap, this, Map.keys)) == 0;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^268.10: $token;

const unique #tok$0^269.12: $token;

implementation Map.Init(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^264.10, cev_parameter, #loc.this, this);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(268,10)
    assert true;
    assert true;
    assert $_Frame[this, Map.keys];
    $Heap := update($Heap, this, Map.keys, Seq#Empty(): Seq BoxType);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(268,10)"} true;
    call CevUpdateHeap(#tok$0^268.10, #loc.$Heap, $Heap);
    // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(269,12)
    assert true;
    assert true;
    assert $_Frame[this, Map.values];
    $Heap := update($Heap, this, Map.values, Seq#Empty(): Seq BoxType);
    assume $IsGoodHeap($Heap);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(269,12)"} true;
    call CevUpdateHeap(#tok$0^269.12, #loc.$Heap, $Heap);
}



const unique #tok$0^272.10: $token;

procedure CheckWellformed$$Map.Find(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map, key#47: BoxType) returns (present#48: bool, val#49: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^272.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^272.15: $token;

const unique #loc.key#47: $token;

const unique #tok$0^272.34: $token;

const unique #loc.present#48: $token;

const unique #tok$0^272.49: $token;

const unique #loc.val#49: $token;

implementation CheckWellformed$$Map.Find(this: ref, key#47: BoxType) returns (present#48: bool, val#49: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#90: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^272.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^272.15, cev_parameter, #loc.key#47, key#47);
    call CevVarIntro(#tok$0^272.34, cev_local, #loc.present#48, present#48);
    call CevVarIntro(#tok$0^272.49, cev_local, #loc.val#49, val#49);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume Map.Valid($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc present#48, val#49;
    if (!present#48)
    {
    }

    assume !present#48 ==> !Seq#Contains(read($Heap, this, Map.keys), key#47);
    if (present#48)
    {
        if (0 <= i#90)
        {
        }

        if (0 <= i#90 && i#90 < Seq#Length(read($Heap, this, Map.keys)))
        {
            assert 0 <= i#90 && i#90 < Seq#Length(read($Heap, this, Map.keys));
        }

        if (0 <= i#90 && i#90 < Seq#Length(read($Heap, this, Map.keys)) && Seq#Index(read($Heap, this, Map.keys), i#90) == key#47)
        {
            assert 0 <= i#90 && i#90 < Seq#Length(read($Heap, this, Map.values));
        }
    }

    assume present#48 ==> (exists i#50: int :: 0 <= i#50 && i#50 < Seq#Length(read($Heap, this, Map.keys)) && Seq#Index(read($Heap, this, Map.keys), i#50) == key#47 && Seq#Index(read($Heap, this, Map.values), i#50) == val#49);
}



procedure Map.Find(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map, key#47: BoxType) returns (present#48: bool, val#49: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires Map.Valid($Heap, this);
  free requires Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46));
  requires (Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46))) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values));
  requires (Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46))) ==> (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^272.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  ensures !present#48 ==> !Seq#Contains(read($Heap, this, Map.keys), key#47);
  ensures present#48 ==> (exists i#50: int :: 0 <= i#50 && i#50 < Seq#Length(read($Heap, this, Map.keys)) && Seq#Index(read($Heap, this, Map.keys), i#50) == key#47 && Seq#Index(read($Heap, this, Map.values), i#50) == val#49);
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.j#51: $token;

const unique #tok$0^278.10: $token;

const unique #loc.j: $token;

const unique #tok$0^278.5: $token;

const unique #tok$0^279.5: $token;

const unique #tok$0^279.18: $token;

const unique #tok$0^280.15: $token;

const unique #tok$0^281.12: $token;

const unique #tok$0^282.15: $token;

const unique #tok$0^283.11: $token;

implementation Map.Find(this: ref, key#47: BoxType) returns (present#48: bool, val#49: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var j#51: int where #cev_var_update(#cev_pc, cev_local, #loc.j#51, j#51);
  var key#91: BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^272.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^272.15, cev_parameter, #loc.key#47, key#47);
    call CevVarIntro(#tok$0^272.34, cev_local, #loc.present#48, present#48);
    call CevVarIntro(#tok$0^272.49, cev_local, #loc.val#49, val#49);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(278,10)
    call CevVarIntro(#tok$0^278.10, cev_local, #loc.j#51, j#51);
    // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(278,5)
    assert true;
    key#91 := key#47;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call j#51 := Map.FindIndex(this, key#91);
    call CevUpdateHere(#loc.j, j#51);
    call CevStep(#tok$0^278.5);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(278,5)"} true;
    // ----- if statement ----- Test\VSI-Benchmarks\b8.dfy(279,5)
    call CevEvent(#tok$0^279.5, conditional_moment);
    assert true;
    if (j#51 == 0 - 1)
    {
        call CevEvent(#tok$0^279.18, took_then_branch);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(280,15)
        assert true;
        assert true;
        present#48 := false;
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(280,15)"} true;
        call CevUpdate(#tok$0^280.15, #loc.present#48, present#48);
    }
    else
    {
        call CevEvent(#tok$0^281.12, took_else_branch);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(282,15)
        assert true;
        assert true;
        present#48 := true;
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(282,15)"} true;
        call CevUpdate(#tok$0^282.15, #loc.present#48, present#48);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(283,11)
        assert true;
        assert 0 <= j#51 && j#51 < Seq#Length(read($Heap, this, Map.values));
        val#49 := Seq#Index(read($Heap, this, Map.values), j#51);
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(283,11)"} true;
        call CevUpdate(#tok$0^283.11, #loc.val#49, val#49);
    }
}



const unique #tok$0^287.10: $token;

procedure CheckWellformed$$Map.Add(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map, key#52: BoxType, val#53: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^287.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^287.14: $token;

const unique #loc.key#52: $token;

const unique #tok$0^287.24: $token;

const unique #loc.val#53: $token;

implementation CheckWellformed$$Map.Add(this: ref, key#52: BoxType, val#53: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#92: int;
  var j#93: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^287.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^287.14, cev_parameter, #loc.key#52, key#52);
    call CevVarIntro(#tok$0^287.24, cev_parameter, #loc.val#53, val#53);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    assume Map.Valid($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    assume Map.Valid($Heap, this);
    if (0 <= i#92)
    {
    }

    if (0 <= i#92 && i#92 < Seq#Length(old(read($Heap, this, Map.keys))))
    {
        assert 0 <= i#92 && i#92 < Seq#Length(old(read($Heap, this, Map.keys)));
    }

    if (0 <= i#92 && i#92 < Seq#Length(old(read($Heap, this, Map.keys))) && Seq#Index(old(read($Heap, this, Map.keys)), i#92) == key#52)
    {
        if (Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(old(read($Heap, this, Map.keys))))
        {
            assert 0 <= i#92 && i#92 < Seq#Length(read($Heap, this, Map.keys));
        }

        if (Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(old(read($Heap, this, Map.keys))) && Seq#Index(read($Heap, this, Map.keys), i#92) == key#52)
        {
            assert 0 <= i#92 && i#92 < Seq#Length(read($Heap, this, Map.values));
        }

        if (Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(old(read($Heap, this, Map.keys))) && Seq#Index(read($Heap, this, Map.keys), i#92) == key#52 && Seq#Index(read($Heap, this, Map.values), i#92) == val#53)
        {
            if (0 <= j#93)
            {
            }

            if (0 <= j#93 && j#93 < Seq#Length(read($Heap, this, Map.values)))
            {
            }

            if (0 <= j#93 && j#93 < Seq#Length(read($Heap, this, Map.values)) && i#92 != j#93)
            {
                assert 0 <= j#93 && j#93 < Seq#Length(read($Heap, this, Map.keys));
                assert 0 <= j#93 && j#93 < Seq#Length(old(read($Heap, this, Map.keys)));
                if (Seq#Index(read($Heap, this, Map.keys), j#93) == Seq#Index(old(read($Heap, this, Map.keys)), j#93))
                {
                    assert 0 <= j#93 && j#93 < Seq#Length(read($Heap, this, Map.values));
                    assert 0 <= j#93 && j#93 < Seq#Length(old(read($Heap, this, Map.values)));
                }
            }
        }
    }

    assume (forall i#54: int :: 0 <= i#54 && i#54 < Seq#Length(old(read($Heap, this, Map.keys))) && Seq#Index(old(read($Heap, this, Map.keys)), i#54) == key#52 ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(old(read($Heap, this, Map.keys))) && Seq#Index(read($Heap, this, Map.keys), i#54) == key#52 && Seq#Index(read($Heap, this, Map.values), i#54) == val#53 && (forall j#55: int :: 0 <= j#55 && j#55 < Seq#Length(read($Heap, this, Map.values)) && i#54 != j#55 ==> Seq#Index(read($Heap, this, Map.keys), j#55) == Seq#Index(old(read($Heap, this, Map.keys)), j#55) && Seq#Index(read($Heap, this, Map.values), j#55) == Seq#Index(old(read($Heap, this, Map.values)), j#55)));
    if (!Seq#Contains(old(read($Heap, this, Map.keys)), key#52))
    {
        if (Seq#Equal(read($Heap, this, Map.keys), Seq#Append(old(read($Heap, this, Map.keys)), Seq#Build(Seq#Empty(): Seq BoxType, 0, key#52, 1))))
        {
        }
    }

    assume !Seq#Contains(old(read($Heap, this, Map.keys)), key#52) ==> Seq#Equal(read($Heap, this, Map.keys), Seq#Append(old(read($Heap, this, Map.keys)), Seq#Build(Seq#Empty(): Seq BoxType, 0, key#52, 1))) && Seq#Equal(read($Heap, this, Map.values), Seq#Append(old(read($Heap, this, Map.values)), Seq#Build(Seq#Empty(): Seq BoxType, 0, val#53, 1)));
}



procedure Map.Add(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map, key#52: BoxType, val#53: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires Map.Valid($Heap, this);
  free requires Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46));
  requires (Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46))) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values));
  requires (Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46))) ==> (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^287.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures Map.Valid($Heap, this);
  free ensures Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46));
  ensures (Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46))) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values));
  ensures (Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46))) ==> (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46));
  ensures (forall i#54: int :: 0 <= i#54 && i#54 < Seq#Length(old(read($Heap, this, Map.keys))) && Seq#Index(old(read($Heap, this, Map.keys)), i#54) == key#52 ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(old(read($Heap, this, Map.keys))) && Seq#Index(read($Heap, this, Map.keys), i#54) == key#52 && Seq#Index(read($Heap, this, Map.values), i#54) == val#53 && (forall j#55: int :: 0 <= j#55 && j#55 < Seq#Length(read($Heap, this, Map.values)) && i#54 != j#55 ==> Seq#Index(read($Heap, this, Map.keys), j#55) == Seq#Index(old(read($Heap, this, Map.keys)), j#55) && Seq#Index(read($Heap, this, Map.values), j#55) == Seq#Index(old(read($Heap, this, Map.values)), j#55)));
  free ensures !Seq#Contains(old(read($Heap, this, Map.keys)), key#52) ==> Seq#Equal(read($Heap, this, Map.keys), Seq#Append(old(read($Heap, this, Map.keys)), Seq#Build(Seq#Empty(): Seq BoxType, 0, key#52, 1))) && Seq#Equal(read($Heap, this, Map.values), Seq#Append(old(read($Heap, this, Map.values)), Seq#Build(Seq#Empty(): Seq BoxType, 0, val#53, 1)));
  ensures true ==> !Seq#Contains(old(read($Heap, this, Map.keys)), key#52) ==> Seq#Equal(read($Heap, this, Map.keys), Seq#Append(old(read($Heap, this, Map.keys)), Seq#Build(Seq#Empty(): Seq BoxType, 0, key#52, 1)));
  ensures true ==> !Seq#Contains(old(read($Heap, this, Map.keys)), key#52) ==> Seq#Equal(read($Heap, this, Map.values), Seq#Append(old(read($Heap, this, Map.values)), Seq#Build(Seq#Empty(): Seq BoxType, 0, val#53, 1)));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.j#56: $token;

const unique #tok$0^297.10: $token;

const unique #tok$0^297.5: $token;

const unique #tok$0^298.5: $token;

const unique #tok$0^298.18: $token;

const unique #tok$0^299.12: $token;

const unique #tok$0^300.14: $token;

const unique #tok$0^301.12: $token;

const unique #tok$0^302.14: $token;

implementation Map.Add(this: ref, key#52: BoxType, val#53: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var j#56: int where #cev_var_update(#cev_pc, cev_local, #loc.j#56, j#56);
  var key#94: BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^287.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^287.14, cev_parameter, #loc.key#52, key#52);
    call CevVarIntro(#tok$0^287.24, cev_parameter, #loc.val#53, val#53);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(297,10)
    call CevVarIntro(#tok$0^297.10, cev_local, #loc.j#56, j#56);
    // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(297,5)
    assert true;
    key#94 := key#52;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call j#56 := Map.FindIndex(this, key#94);
    call CevUpdateHere(#loc.j, j#56);
    call CevStep(#tok$0^297.5);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(297,5)"} true;
    // ----- if statement ----- Test\VSI-Benchmarks\b8.dfy(298,5)
    call CevEvent(#tok$0^298.5, conditional_moment);
    assert true;
    if (j#56 == 0 - 1)
    {
        call CevEvent(#tok$0^298.18, took_then_branch);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(299,12)
        assert true;
        assert true;
        assert $_Frame[this, Map.keys];
        $Heap := update($Heap, this, Map.keys, Seq#Append(read($Heap, this, Map.keys), Seq#Build(Seq#Empty(): Seq BoxType, 0, key#52, 1)));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(299,12)"} true;
        call CevUpdateHeap(#tok$0^299.12, #loc.$Heap, $Heap);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(300,14)
        assert true;
        assert true;
        assert $_Frame[this, Map.values];
        $Heap := update($Heap, this, Map.values, Seq#Append(read($Heap, this, Map.values), Seq#Build(Seq#Empty(): Seq BoxType, 0, val#53, 1)));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(300,14)"} true;
        call CevUpdateHeap(#tok$0^300.14, #loc.$Heap, $Heap);
    }
    else
    {
        call CevEvent(#tok$0^301.12, took_else_branch);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(302,14)
        assert true;
        assert 0 <= j#56 && j#56 < Seq#Length(read($Heap, this, Map.values));
        assert $_Frame[this, Map.values];
        $Heap := update($Heap, this, Map.values, Seq#Update(read($Heap, this, Map.values), j#56, val#53));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(302,14)"} true;
        call CevUpdateHeap(#tok$0^302.14, #loc.$Heap, $Heap);
    }
}



const unique #tok$0^306.10: $token;

procedure CheckWellformed$$Map.Remove(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map, key#57: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^306.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^306.17: $token;

const unique #loc.key#57: $token;

implementation CheckWellformed$$Map.Remove(this: ref, key#57: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var k#95: BoxType;
  var k#96: BoxType;
  var h#97: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^306.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^306.17, cev_parameter, #loc.key#57, key#57);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    assume Map.Valid($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    assume Map.Valid($Heap, this);
    if (Seq#Contains(read($Heap, this, Map.keys), k#95))
    {
    }

    assume (forall k#58: BoxType :: Seq#Contains(read($Heap, this, Map.keys), k#58) ==> Seq#Contains(old(read($Heap, this, Map.keys)), k#58));
    if (Seq#Contains(old(read($Heap, this, Map.keys)), k#96))
    {
        if (!Seq#Contains(read($Heap, this, Map.keys), k#96))
        {
        }
    }

    assume (forall k#59: BoxType :: Seq#Contains(old(read($Heap, this, Map.keys)), k#59) ==> Seq#Contains(read($Heap, this, Map.keys), k#59) || k#59 == key#57);
    if (!Seq#Contains(old(read($Heap, this, Map.keys)), key#57))
    {
        if (Seq#Equal(read($Heap, this, Map.keys), old(read($Heap, this, Map.keys))))
        {
        }
    }

    assume !Seq#Contains(old(read($Heap, this, Map.keys)), key#57) ==> Seq#Equal(read($Heap, this, Map.keys), old(read($Heap, this, Map.keys))) && Seq#Equal(read($Heap, this, Map.values), old(read($Heap, this, Map.values)));
    if (Seq#Contains(old(read($Heap, this, Map.keys)), key#57))
    {
        if (Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(old(read($Heap, this, Map.keys))) - 1)
        {
        }

        if (Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(old(read($Heap, this, Map.keys))) - 1 && !Seq#Contains(read($Heap, this, Map.keys), key#57))
        {
            if (0 <= h#97)
            {
            }

            if (0 <= h#97 && h#97 <= Seq#Length(read($Heap, this, Map.keys)))
            {
                assert 0 <= h#97 && h#97 <= Seq#Length(read($Heap, this, Map.keys));
                assert 0 <= h#97 && h#97 <= Seq#Length(old(read($Heap, this, Map.keys)));
            }

            if (0 <= h#97 && h#97 <= Seq#Length(read($Heap, this, Map.keys)) && Seq#Equal(Seq#Take(read($Heap, this, Map.keys), h#97), Seq#Take(old(read($Heap, this, Map.keys)), h#97)))
            {
                assert 0 <= h#97 && h#97 <= Seq#Length(read($Heap, this, Map.values));
                assert 0 <= h#97 && h#97 <= Seq#Length(old(read($Heap, this, Map.values)));
            }

            if (0 <= h#97 && h#97 <= Seq#Length(read($Heap, this, Map.keys)) && Seq#Equal(Seq#Take(read($Heap, this, Map.keys), h#97), Seq#Take(old(read($Heap, this, Map.keys)), h#97)) && Seq#Equal(Seq#Take(read($Heap, this, Map.values), h#97), Seq#Take(old(read($Heap, this, Map.values)), h#97)))
            {
                assert 0 <= h#97 && h#97 <= Seq#Length(read($Heap, this, Map.keys));
                assert 0 <= h#97 + 1 && h#97 + 1 <= Seq#Length(old(read($Heap, this, Map.keys)));
            }

            if (0 <= h#97 && h#97 <= Seq#Length(read($Heap, this, Map.keys)) && Seq#Equal(Seq#Take(read($Heap, this, Map.keys), h#97), Seq#Take(old(read($Heap, this, Map.keys)), h#97)) && Seq#Equal(Seq#Take(read($Heap, this, Map.values), h#97), Seq#Take(old(read($Heap, this, Map.values)), h#97)) && Seq#Equal(Seq#Drop(read($Heap, this, Map.keys), h#97), Seq#Drop(old(read($Heap, this, Map.keys)), h#97 + 1)))
            {
                assert 0 <= h#97 && h#97 <= Seq#Length(read($Heap, this, Map.values));
                assert 0 <= h#97 + 1 && h#97 + 1 <= Seq#Length(old(read($Heap, this, Map.values)));
            }
        }
    }

    assume Seq#Contains(old(read($Heap, this, Map.keys)), key#57) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(old(read($Heap, this, Map.keys))) - 1 && !Seq#Contains(read($Heap, this, Map.keys), key#57) && (exists h#60: int :: 0 <= h#60 && h#60 <= Seq#Length(read($Heap, this, Map.keys)) && Seq#Equal(Seq#Take(read($Heap, this, Map.keys), h#60), Seq#Take(old(read($Heap, this, Map.keys)), h#60)) && Seq#Equal(Seq#Take(read($Heap, this, Map.values), h#60), Seq#Take(old(read($Heap, this, Map.values)), h#60)) && Seq#Equal(Seq#Drop(read($Heap, this, Map.keys), h#60), Seq#Drop(old(read($Heap, this, Map.keys)), h#60 + 1)) && Seq#Equal(Seq#Drop(read($Heap, this, Map.values), h#60), Seq#Drop(old(read($Heap, this, Map.values)), h#60 + 1)));
}



procedure Map.Remove(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map, key#57: BoxType);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires Map.Valid($Heap, this);
  free requires Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46));
  requires (Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46))) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values));
  requires (Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46))) ==> (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^306.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures Map.Valid($Heap, this);
  free ensures Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46));
  ensures (Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46))) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values));
  ensures (Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46))) ==> (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46));
  ensures (forall k#58: BoxType :: Seq#Contains(read($Heap, this, Map.keys), k#58) ==> Seq#Contains(old(read($Heap, this, Map.keys)), k#58));
  ensures (forall k#59: BoxType :: Seq#Contains(old(read($Heap, this, Map.keys)), k#59) ==> Seq#Contains(read($Heap, this, Map.keys), k#59) || k#59 == key#57);
  free ensures !Seq#Contains(old(read($Heap, this, Map.keys)), key#57) ==> Seq#Equal(read($Heap, this, Map.keys), old(read($Heap, this, Map.keys))) && Seq#Equal(read($Heap, this, Map.values), old(read($Heap, this, Map.values)));
  ensures true ==> !Seq#Contains(old(read($Heap, this, Map.keys)), key#57) ==> Seq#Equal(read($Heap, this, Map.keys), old(read($Heap, this, Map.keys)));
  ensures true ==> !Seq#Contains(old(read($Heap, this, Map.keys)), key#57) ==> Seq#Equal(read($Heap, this, Map.values), old(read($Heap, this, Map.values)));
  free ensures Seq#Contains(old(read($Heap, this, Map.keys)), key#57) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(old(read($Heap, this, Map.keys))) - 1 && !Seq#Contains(read($Heap, this, Map.keys), key#57) && (exists h#60: int :: 0 <= h#60 && h#60 <= Seq#Length(read($Heap, this, Map.keys)) && Seq#Equal(Seq#Take(read($Heap, this, Map.keys), h#60), Seq#Take(old(read($Heap, this, Map.keys)), h#60)) && Seq#Equal(Seq#Take(read($Heap, this, Map.values), h#60), Seq#Take(old(read($Heap, this, Map.values)), h#60)) && Seq#Equal(Seq#Drop(read($Heap, this, Map.keys), h#60), Seq#Drop(old(read($Heap, this, Map.keys)), h#60 + 1)) && Seq#Equal(Seq#Drop(read($Heap, this, Map.values), h#60), Seq#Drop(old(read($Heap, this, Map.values)), h#60 + 1)));
  ensures true ==> Seq#Contains(old(read($Heap, this, Map.keys)), key#57) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(old(read($Heap, this, Map.keys))) - 1;
  ensures true ==> Seq#Contains(old(read($Heap, this, Map.keys)), key#57) ==> !Seq#Contains(read($Heap, this, Map.keys), key#57);
  ensures true ==> Seq#Contains(old(read($Heap, this, Map.keys)), key#57) ==> (exists h#60: int :: 0 <= h#60 && h#60 <= Seq#Length(read($Heap, this, Map.keys)) && Seq#Equal(Seq#Take(read($Heap, this, Map.keys), h#60), Seq#Take(old(read($Heap, this, Map.keys)), h#60)) && Seq#Equal(Seq#Take(read($Heap, this, Map.values), h#60), Seq#Take(old(read($Heap, this, Map.values)), h#60)) && Seq#Equal(Seq#Drop(read($Heap, this, Map.keys), h#60), Seq#Drop(old(read($Heap, this, Map.keys)), h#60 + 1)) && Seq#Equal(Seq#Drop(read($Heap, this, Map.values), h#60), Seq#Drop(old(read($Heap, this, Map.values)), h#60 + 1)));
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.j#61: $token;

const unique #tok$0^326.10: $token;

const unique #tok$0^326.5: $token;

const unique #tok$0^327.5: $token;

const unique #tok$0^327.17: $token;

const unique #tok$0^328.12: $token;

const unique #tok$0^329.14: $token;

implementation Map.Remove(this: ref, key#57: BoxType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var j#61: int where #cev_var_update(#cev_pc, cev_local, #loc.j#61, j#61);
  var key#98: BoxType;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^306.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^306.17, cev_parameter, #loc.key#57, key#57);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> $o == this);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(326,10)
    call CevVarIntro(#tok$0^326.10, cev_local, #loc.j#61, j#61);
    // ----- call statement ----- Test\VSI-Benchmarks\b8.dfy(326,5)
    assert true;
    key#98 := key#57;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    call j#61 := Map.FindIndex(this, key#98);
    call CevUpdateHere(#loc.j, j#61);
    call CevStep(#tok$0^326.5);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(326,5)"} true;
    // ----- if statement ----- Test\VSI-Benchmarks\b8.dfy(327,5)
    call CevEvent(#tok$0^327.5, conditional_moment);
    assert true;
    if (0 <= j#61)
    {
        call CevEvent(#tok$0^327.17, took_then_branch);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(328,12)
        assert true;
        assert 0 <= j#61 && j#61 <= Seq#Length(read($Heap, this, Map.keys)) && 0 <= j#61 + 1 && j#61 + 1 <= Seq#Length(read($Heap, this, Map.keys));
        assert $_Frame[this, Map.keys];
        $Heap := update($Heap, this, Map.keys, Seq#Append(Seq#Take(read($Heap, this, Map.keys), j#61), Seq#Drop(read($Heap, this, Map.keys), j#61 + 1)));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(328,12)"} true;
        call CevUpdateHeap(#tok$0^328.12, #loc.$Heap, $Heap);
        // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(329,14)
        assert true;
        assert 0 <= j#61 && j#61 <= Seq#Length(read($Heap, this, Map.values)) && 0 <= j#61 + 1 && j#61 + 1 <= Seq#Length(read($Heap, this, Map.values));
        assert $_Frame[this, Map.values];
        $Heap := update($Heap, this, Map.values, Seq#Append(Seq#Take(read($Heap, this, Map.values), j#61), Seq#Drop(read($Heap, this, Map.values), j#61 + 1)));
        assume $IsGoodHeap($Heap);
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(329,14)"} true;
        call CevUpdateHeap(#tok$0^329.14, #loc.$Heap, $Heap);
    }
    else
    {
        call CevEvent(#tok$0^327.5, took_else_branch);
    }
}



const unique #tok$0^333.10: $token;

procedure CheckWellformed$$Map.FindIndex(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map, key#62: BoxType) returns (idx#63: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^333.10;
  modifies $Heap, #cev_pc;
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #tok$0^333.20: $token;

const unique #loc.key#62: $token;

const unique #tok$0^333.39: $token;

const unique #loc.idx#63: $token;

implementation CheckWellformed$$Map.FindIndex(this: ref, key#62: BoxType) returns (idx#63: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^333.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^333.20, cev_parameter, #loc.key#62, key#62);
    call CevVarIntro(#tok$0^333.39, cev_local, #loc.idx#63, idx#63);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    assume Map.Valid($Heap, this);
    havoc $Heap;
    assume (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $_Frame[$o, $f] || read($Heap, $o, $f) == read(old($Heap), $o, $f));
    havoc idx#63;
    if (0 - 1 <= idx#63)
    {
    }

    assume 0 - 1 <= idx#63 && idx#63 < Seq#Length(read($Heap, this, Map.keys));
    if (idx#63 == 0 - 1)
    {
    }

    assume idx#63 == 0 - 1 ==> !Seq#Contains(read($Heap, this, Map.keys), key#62);
    if (0 <= idx#63)
    {
        assert 0 <= idx#63 && idx#63 < Seq#Length(read($Heap, this, Map.keys));
    }

    assume 0 <= idx#63 ==> Seq#Index(read($Heap, this, Map.keys), idx#63) == key#62;
}



procedure Map.FindIndex(this: ref where this != null && read($Heap, this, alloc) && dtype(this) == class.Map, key#62: BoxType) returns (idx#63: int);
  free requires 0 == $ModuleContextHeight && $InMethodContext;
  // user-defined preconditions
  free requires Map.Valid($Heap, this);
  free requires Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46));
  requires (Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46))) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values));
  requires (Map.Valid($Heap, this) ==> Seq#Length(read($Heap, this, Map.keys)) == Seq#Length(read($Heap, this, Map.values)) && (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46))) ==> (forall i#45: int, j#46: int :: 0 <= i#45 && i#45 < j#46 && j#46 < Seq#Length(read($Heap, this, Map.keys)) ==> Seq#Index(read($Heap, this, Map.keys), i#45) != Seq#Index(read($Heap, this, Map.keys), j#46));
  // CEV information
  free requires #cev_pc == 0;
  free requires #cev_init(0);
  free requires #cev_var_intro(0, cev_implicit, #loc.$Heap, $Heap, 0);
  free requires #cev_save_position(0) == #tok$0^333.10;
  modifies $Heap, #cev_pc;
  // user-defined postconditions
  free ensures 0 - 1 <= idx#63 && idx#63 < Seq#Length(read($Heap, this, Map.keys));
  ensures true ==> 0 - 1 <= idx#63;
  ensures true ==> idx#63 < Seq#Length(read($Heap, this, Map.keys));
  ensures idx#63 == 0 - 1 ==> !Seq#Contains(read($Heap, this, Map.keys), key#62);
  ensures 0 <= idx#63 ==> Seq#Index(read($Heap, this, Map.keys), idx#63) == key#62;
  // frame condition
  free ensures (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);
  // CEV information
  free ensures old(#cev_pc) < #cev_pc;



const unique #loc.j#64: $token;

const unique #tok$0^339.9: $token;

const unique #tok$0^340.5: $token;

const unique #tok$0^344.7: $token;

const unique #tok$0^344.27: $token;

const unique #tok$0^345.13: $token;

const unique #tok$0^348.9: $token;

const unique #tok$0^350.9: $token;

implementation Map.FindIndex(this: ref, key#62: BoxType) returns (idx#63: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var j#64: int where #cev_var_update(#cev_pc, cev_local, #loc.j#64, j#64);
  var $PreLoopHeap0: HeapType;
  var $decr0$init$0: int;
  var $w0: bool;
  var $PreLoopCevPC0: int;
  var $decr0$0: int;

    #cev_pc := #cev_pc + 1;
    call CevVarIntro(#tok$0^333.10, cev_parameter, #loc.this, this);
    call CevVarIntro(#tok$0^333.20, cev_parameter, #loc.key#62, key#62);
    call CevVarIntro(#tok$0^333.39, cev_local, #loc.idx#63, idx#63);
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: $o != null && read($Heap, $o, alloc) ==> false);
    // ----- var-declaration statement ----- Test\VSI-Benchmarks\b8.dfy(339,9)
    assert true;
    assert true;
    j#64 := 0;
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(339,9)"} true;
    call CevVarIntro(#tok$0^339.9, cev_local, #loc.j#64, j#64);
    // ----- while statement ----- Test\VSI-Benchmarks\b8.dfy(340,5)
    $PreLoopHeap0 := $Heap;
    $decr0$init$0 := Seq#Length(read($Heap, this, Map.keys)) - j#64;
    havoc $w0;
    call $PreLoopCevPC0 := CevPreLoop(#tok$0^340.5);
    while (true)
      invariant $w0 ==> j#64 <= Seq#Length(read($Heap, this, Map.keys));
      invariant $w0 ==> !Seq#Contains(Seq#Take(read($Heap, this, Map.keys), j#64), key#62);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: { read($Heap, $o, $f) } $o != null && read(old($Heap), $o, alloc) ==> read($Heap, $o, $f) == read($PreLoopHeap0, $o, $f));
      free invariant $HeapSucc($PreLoopHeap0, $Heap);
      free invariant Seq#Length(read($Heap, this, Map.keys)) - j#64 <= $decr0$init$0 && (Seq#Length(read($Heap, this, Map.keys)) - j#64 == $decr0$init$0 ==> true);
      free invariant #cev_save_position(#cev_pc) == #tok$0^340.5;
      free invariant $PreLoopCevPC0 < #cev_pc;
      free invariant #cev_control_flow_event(#cev_pc, loop_register);
      free invariant #cev_var_update(#cev_pc, cev_local, #loc.idx#63, idx#63);
      kUnwind 1;
    {
        if (!$w0)
        {
            assert {:subsumption 0} true;
            assume j#64 <= Seq#Length(read($Heap, this, Map.keys));
            assert {:subsumption 0} 0 <= j#64 && j#64 <= Seq#Length(read($Heap, this, Map.keys));
            assume !Seq#Contains(Seq#Take(read($Heap, this, Map.keys), j#64), key#62);
            assert true;
            assume false;
        }

        assert true;
        if (j#64 >= Seq#Length(read($Heap, this, Map.keys)))
        {
            break;
        }

        call CevStepEvent(#tok$0^340.5, loop_entered);
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(340,5): loop entered"} true;
        $decr0$0 := Seq#Length(read($Heap, this, Map.keys)) - j#64;
        // ----- if statement ----- Test\VSI-Benchmarks\b8.dfy(344,7)
        call CevEvent(#tok$0^344.7, conditional_moment);
        assert 0 <= j#64 && j#64 < Seq#Length(read($Heap, this, Map.keys));
        if (Seq#Index(read($Heap, this, Map.keys), j#64) == key#62)
        {
            call CevEvent(#tok$0^344.27, took_then_branch);
            // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(345,13)
            assert true;
            assert true;
            idx#63 := j#64;
            assume {:captureState "Test\VSI-Benchmarks\b8.dfy(345,13)"} true;
            call CevUpdate(#tok$0^345.13, #loc.idx#63, idx#63);
            // ----- return statement ----- Test\VSI-Benchmarks\b8.dfy(346,9)
            return;
        }
        else
        {
            call CevEvent(#tok$0^344.7, took_else_branch);
        }

        // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(348,9)
        assert true;
        assert true;
        j#64 := j#64 + 1;
        assume {:captureState "Test\VSI-Benchmarks\b8.dfy(348,9)"} true;
        call CevUpdate(#tok$0^348.9, #loc.j#64, j#64);
        assert 0 <= $decr0$0 || Seq#Length(read($Heap, this, Map.keys)) - j#64 == $decr0$0;
        assert Seq#Length(read($Heap, this, Map.keys)) - j#64 < $decr0$0;
    }

    call CevStepEvent(#tok$0^340.5, loop_exited);
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(340,5): loop exit"} true;
    // ----- assignment statement ----- Test\VSI-Benchmarks\b8.dfy(350,9)
    assert true;
    assert true;
    idx#63 := 0 - 1;
    assume {:captureState "Test\VSI-Benchmarks\b8.dfy(350,9)"} true;
    call CevUpdate(#tok$0^350.9, #loc.idx#63, idx#63);
}



const unique class._default: ClassName;
